package AccessReport;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
######################################################################
# ܥݡȥ⥸塼
# AccessReport.pm ver1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# 
# 	$$data[0]	֡hhmmss
# 	$$data[1]	IPREMOTE_HOST
# 	$$data[2]	ե
# 	$$data[3]	饤ȴĶHTTP_USER_AGENT
# 	$$data[4]	饤ȼHTTP_ACCEPT_LANGUAGE
# 	$$data[5]	󥯸HTTP_REFERER
# 	$$data[6]	ɥ¦
# 	$$data[7]	ɥ¦ι⤵
# 	$$data[8]	Ѳǽʥ꡼
# 	$$data[9]	Ѳǽʥ꡼⤵
sub log_stat ($$$) {
my($this,$date,$data) = @_;

# Ȥ˽פ
if (defined $setting::stat{'access'}{'mon'} && $setting::stat{'access'}{'mon'}) {
	$date = substr($date,0,6);
} else {
	$date = substr($date,0,8);
}
#return 0 if $date !~ /^\d{6,8}$/; 
$this->{'access_fluctuation'}->{$date}++;
return 1;
}

######################################################################
# ϴĶɲá
sub print_sub_stat_env ($) {
my $this = shift;
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('ɽ');
print $this->{'infoTable'}->td(
	'<select name="setting:access_reverse">'
	. '<option value=""></option>'
	. '<option value="1"' . (($setting::stat{'access'}{'reverse'}) ? ' selected="selected"' : '') . '>ߢ</option>'
	. '</select> '
	. ' <select name="setting:access_mon">'
	. '<option value="">ñ</option>'
	. '<option value="1"' . (($setting::stat{'access'}{'mon'}) ? ' selected="selected"' : '') . '>ñ</option>'
	. '</select>'
	. $this->submit_button($env::image_dir . '/stat/access.gif',20,20,'ο','','m','AccessReport','k','access')
);
print $this->{'infoTable'}->_tr;
}

######################################################################
# Ĵ
sub stat_key ($$;$) {
my($this,$key) = @_;
return '<strong>' . $this->date($key,$setting::page{'stat'}{'datelimit'},$setting::page{'stat'}{'datetype'}) . '</strong>';
}

######################################################################
# ϥȥ
sub stat_title ($) {
my $this = shift;
return 'ο';
}

######################################################################
# Ϸɽ
sub print_report ($) {
my $this = shift;
return if defined $this->{'noLog'} && $this->{'noLog'};

my(@date);
@date = (!@{$this->{'access_log'}}) ? () : $this->date_span($this->{'access_log'}->[0],$this->{'access_log'}->[$#{$this->{'access_log'}}]);
@date = reverse @date if defined $setting::stat{'access'}{'reverse'} && $setting::stat{'access'}{'reverse'};
$this->print_stat_report(
	(($setting::stat{'access'}{'mon'}) ? '̥' : '̥'),
	\@date,
	$this->{'access_fluctuation'},
	'',
	'',
	$this->{'access_fluctuation'}->{$this->maximum($this->{'access_fluctuation'})},
	'access',
	0,
	(($setting::stat{'access'}{'mon'}) ? '' : ''),
	'center',
	180,
	'',
	100,
	''
);

}

# 
sub date_span ($$$) {
my($this,$from,$to) = @_;

# Ȥξ
if (defined $setting::stat{'access'}{'mon'} && $setting::stat{'access'}{'mon'}) {
	my(@date,$year,$mon,$mday,$y,$m,$d);
	($y,$m) = ($1,$2) if $from =~ /^([0-9]{4})([0-9]{2})/;
	($year,$mon) = ($1,$2) if $to =~ /^([0-9]{4})([0-9]{2})/;

	while ($y < $year) {
		foreach ($m..12) {
			push(@date,sprintf("%.4d", $y) . sprintf("%.2d", $_));
		}
		$m = 1;
		$y++;
	}
	while ($m <= $mon) {
		push(@date,sprintf("%.4d", $y) . sprintf("%.2d", $m));
		$m++;
	}
	return @date;
}

# Ȥξ
my(@date,$year,$mon,$mday,$y,$m,$d,@month);
($y,$m,$d) = ($1,$2,$3) if $from =~ /^([0-9]{4})([0-9]{2})([0-9]{2})/;
($year,$mon,$mday) = ($1,$2,$3) if $to =~ /^([0-9]{4})([0-9]{2})([0-9]{2})/;

while ($y < $year) {
	my($month);
	@month = (0,31,(($this->is_leap_year($y)) ? 29 : 28),31,30,31,30,31,31,30,31,30,31);
	foreach $month ($m..12) {
		foreach ($d..$month[$month]) {
			push(@date,sprintf("%.4d", $y) . sprintf("%.2d", $month) . sprintf("%.2d", $_));
		}
		$d = 1;
	}
	$m = 1;
	$y++;
}
@month = (0,31,(($this->is_leap_year($y)) ? 29 : 28),31,30,31,30,31,31,30,31,30,31);
while ($m < $mon) {
	foreach ($d..$month[$m]) {
		push(@date,sprintf("%.4d", $y) . sprintf("%.2d", $m) . sprintf("%.2d", $_));
	}
	$d = 1;
	$m++;
}
while ($d <= $mday) {
	push(@date,sprintf("%.4d", $y) . sprintf("%.2d", $m) . sprintf("%.2d", $d));
	$d++;
}

return @date;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#ǥեȥ
	$main::k = 'access' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('access','AccessReport');

}


1;

