package AgentReport;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
######################################################################
# ˬԤαĶ⥸塼
# AgentReport.pm ver1.0.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# 
# 	$$data[0]	֡hhmmss
# 	$$data[1]	IPREMOTE_HOST
# 	$$data[2]	ե
# 	$$data[3]	饤ȴĶHTTP_USER_AGENT
# 	$$data[4]	饤ȼHTTP_ACCEPT_LANGUAGE
# 	$$data[5]	󥯸HTTP_REFERER
# 	$$data[6]	ɥ¦
# 	$$data[7]	ɥ¦ι⤵
# 	$$data[8]	Ѳǽʥ꡼
# 	$$data[9]	Ѳǽʥ꡼⤵
sub log_stat ($$$) {
my($this,$date,$data) = @_;
return 0 if $$data[3] eq '' || $$data[3] =~ /[<>\@]/ || $$data[3] !~ /\//;
my $key = (($$data[1] =~ /proxy\w+\.docomo\.ne\.jp/) ? '' : $$data[1]) . $$data[3];
if (!$this->{'is_counted'}{$key}) {
	my($platform,$platform_ver,$browser,$browser_ver,$limitsize,$device) = $cgi::UserAgent->get_user_agent_info($$data[3]);

	# ץåȥեླྀ
	if (defined $platform && $platform) {
		$this->{'user_platform'}->{$platform}++;
		$this->{'user_platform_ver'}->{$platform}->{$platform_ver}++ if defined $platform_ver && $platform_ver;
	} else {
		return 0;
	}

	# ֥饦
	if ($browser) {
		$this->{'user_browser'}->{$platform}->{$browser}++;
		$this->{'user_browser_ver'}->{$platform}->{$browser}->{$browser_ver}++ if defined $browser_ver && $browser_ver;
	}

	# ｸ
	$this->{'user_device'}->{$platform_ver}->{$device}++ if $platform eq '' && $device;
	$this->{'is_counted'}{$key} = 1;
	$this->{'user_count'}++;
}
return 1;
}

######################################################################
# ϥȥ
sub stat_title ($) {
my $this = shift;
return 'ˬԤαĶ';
}

######################################################################
# Ϸɽ
sub print_report ($) {
my $this = shift;
undef %{$this->{'is_counted'}};
delete $this->{'is_counted'};
return if defined $this->{'noLog'} && $this->{'noLog'};

# ץåȥե󥭥
if (ref $this->{'user_platform'}) {
	my @ranking = sort {$this->sort_by(\$this->{'user_platform'}->{$a},\$this->{'user_platform'}->{$b},'descend') || $a cmp $b} keys %{$this->{'user_platform'}};
	$this->print_stat_report(
		'ץåȥե󥭥',
		\@ranking,
		$this->{'user_platform'},
		$this->{'user_platform_ver'},
		'',
		$this->{'user_count'},
		'',
		1,
		'ץåȥե',
		'center',
		200,
		'桼',
		100,
		'%'
	) if @ranking;
}

# ֥饦󥭥󥰡Windows
if (ref $this->{'user_browser'} && ref $this->{'user_browser'}->{'Windows'}) {
	my @ranking = sort {$this->sort_by(\$this->{'user_browser'}->{'Windows'}->{$a},\$this->{'user_browser'}->{'Windows'}->{$b},'descend') || $a cmp $b} keys %{$this->{'user_browser'}->{'Windows'}};
	$this->print_stat_report(
		'֥饦󥭥󥰡Windows',
		\@ranking,
		$this->{'user_browser'}->{'Windows'},
		$this->{'user_browser_ver'}->{'Windows'},
		'',
		$this->{'user_count'},
		'',
		1,
		'֥饦',
		'center',
		200,
		'桼',
		100,
		'%'
	) if @ranking;
}

# ֥饦󥭥󥰡Macintosh
if (ref $this->{'user_browser'} && ref $this->{'user_browser'}->{'Macintosh'}) {
	my @ranking = sort {$this->sort_by(\$this->{'user_browser'}->{'Macintosh'}->{$a},\$this->{'user_browser'}->{'Macintosh'}->{$b},'descend') || $a cmp $b} keys %{$this->{'user_browser'}->{'Macintosh'}};
	$this->print_stat_report(
		'֥饦󥭥󥰡Macintosh',
		\@ranking,
		$this->{'user_browser'}->{'Macintosh'},
		$this->{'user_browser_ver'}->{'Macintosh'},
		'',
		$this->{'user_count'},
		'',
		1,
		'֥饦',
		'center',
		200,
		'桼',
		100,
		'%'
	) if @ranking;
}

# ֥饦󥭥󥰡UNIX
if (ref $this->{'user_browser'} && ref $this->{'user_browser'}->{'UNIX'}) {
	my @ranking = sort {$this->sort_by(\$this->{'user_browser'}->{'UNIX'}->{$a},\$this->{'user_browser'}->{'UNIX'}->{$b},'descend') || $a cmp $b} keys %{$this->{'user_browser'}->{'UNIX'}};
	$this->print_stat_report(
		'֥饦󥭥󥰡UNIX',
		\@ranking,
		$this->{'user_browser'}->{'UNIX'},
		$this->{'user_browser_ver'}->{'UNIX'},
		'',
		$this->{'user_count'},
		'',
		1,
		'֥饦',
		'center',
		200,
		'桼',
		100,
		'%'
	) if @ranking;
}

# ӵ󥭥
if (ref $this->{'user_platform_ver'} && ref $this->{'user_platform_ver'}->{''}) {
	my @ranking = sort {$this->sort_by(\$this->{'user_platform_ver'}->{''}->{$a},\$this->{'user_platform_ver'}->{''}->{$b},'descend') || $a cmp $b} keys %{$this->{'user_platform_ver'}->{''}};
	$this->print_stat_report(
		' 󥭥',
		\@ranking,
		$this->{'user_platform_ver'}->{''},
		$this->{'user_device'},
		'',
		$this->{'user_count'},
		'',
		1,
		'',
		'center',
		200,
		'桼',
		100,
		'%'
	) if @ranking;
}

# ӥ֥饦󥭥
if (ref $this->{'user_browser'} && ref $this->{'user_browser'}->{''}) {
	my @ranking = sort {$this->sort_by(\$this->{'user_browser'}->{''}->{$a},\$this->{'user_browser'}->{''}->{$b},'descend') || $a cmp $b} keys %{$this->{'user_browser'}->{''}};
	$this->print_stat_report(
		'֥饦󥭥󥰡ʷá',
		\@ranking,
		$this->{'user_browser'}->{''},
		$this->{'user_browser_ver'}->{''},
		'',
		$this->{'user_count'},
		'',
		1,
		'֥饦',
		'center',
		200,
		'桼',
		100,
		'%'
	) if @ranking;
}

# ¾ǥХ֥饦󥭥
if (ref $this->{'user_browser'} && ref $this->{'user_browser'}->{'¾'}) {
	my @ranking = sort {$this->sort_by(\$this->{'user_browser'}->{'¾'}->{$a},\$this->{'user_browser'}->{'¾'}->{$b},'descend') || $a cmp $b} keys %{$this->{'user_browser'}->{'¾'}};
	$this->print_stat_report(
		'֥饦󥭥󥰡ʤ¾',
		\@ranking,
		$this->{'user_browser'}->{'¾'},
		$this->{'user_browser_ver'}->{'¾'},
		'',
		$this->{'user_count'},
		'',
		1,
		'֥饦',
		'center',
		200,
		'桼',
		100,
		'%'
	) if @ranking;
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#ǥեȥ
	$main::k = 'agent' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('agent','AgentReport');

	unless (ref $cgi::UserAgent) {
		require CMONOS::CGI_Lib::UserAgent;
		$cgi::UserAgent = UserAgent->new;
	}
}


1;

