package ClientReport;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
######################################################################
# 󥭥󥰥⥸塼
# ClientReport.pm ver1.0.5
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-09-29
######################################################################
# 
# 	$$data[0]	֡hhmmss
# 	$$data[1]	IPREMOTE_HOST
# 	$$data[2]	ե
# 	$$data[3]	饤ȴĶHTTP_USER_AGENT
# 	$$data[4]	饤ȼHTTP_ACCEPT_LANGUAGE
# 	$$data[5]	󥯸HTTP_REFERER
# 	$$data[6]	ɥ¦
# 	$$data[7]	ɥ¦ι⤵
# 	$$data[8]	Ѳǽʥ꡼
# 	$$data[9]	Ѳǽʥ꡼⤵
sub log_stat ($$$) {
my($this,$date,$data) = @_;
my $host = (defined $$data[1]) ? $$data[1] : '';

# ۥȸ
return 0 if @setting::target_client && !grep(eval {$host =~ /$_/},@setting::target_client);

# ɥᥤ̾ǽ
if (defined $setting::stat{'client'}{'option'} && $setting::stat{'client'}{'option'}) {
	if ($host =~ /[^0-9\.]/) {
		$host = $this->host_to_domain($host);
	} else {
		$host = 'ɥᥤ̾';
	}
}

if (@setting::target_client_referer && $$data[5] && !$this->{'referer_is_target'}->{$host} && (!$setting::stat{'client'}{'refererLanding'} || !$this->{'remote_host'}->{$host})) {
	my $referer = $this->url_filter($$data[5]);
	$this->{'referer_is_target'}->{$host} = 1 if grep((eval {$$data[5] =~ /$_/} || eval {$referer =~ /$_/}),@setting::target_client_referer);
}

$this->{'remote_host'}->{$host}++;
$this->{'client_in'}->{$host} = $$data[0] if !defined $this->{'client_in'}->{$host};
$this->{'client_out'}->{$host} = $$data[0];
return 1;
}

######################################################################
# ϴĶɲá
sub print_sub_stat_env ($) {
my $this = shift;
my $client_target = $setting::stat{'client'}{'target'};
$client_target =~ s/\\(?!\\)//g if !defined $setting::stat{'client'}{'regexp'} || !$setting::stat{'client'}{'regexp'};
my $client_referer = $setting::stat{'client'}{'referer'};
$client_referer =~ s/\\(?!\\)//g if !defined $setting::stat{'client'}{'refererRegexp'} || !$setting::stat{'client'}{'refererRegexp'};

print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('ˡ');
print $this->{'infoTable'}->td(
	'<div id="hostsearch"><label for="setting:client_target" class="datatitle">ۥ̾</label>'
	. '<input type="text" name="setting:client_target" size="30" value="' . $this->escape($client_target) . '">'
	. '<select name="setting:client_regexp">'
	. '<option value="">ʬ</option>'
	. '<option value="2"' . (($setting::stat{'client'}{'regexp'} && $setting::stat{'client'}{'regexp'} == 2) ? ' selected="selected"' : '') . '></option>'
	. '<option value="1"' . (($setting::stat{'client'}{'regexp'} && $setting::stat{'client'}{'regexp'} == 1) ? ' selected="selected"' : '') . '>ɽ</option>'
	. '</select>'
	. '<select name="setting:client_option">'
	. '<option value="">ۥ̾ǽפ</option>'
	. '<option value="1"' . (($setting::stat{'client'}{'option'}) ? ' selected="selected"' : '') . '>ɥᥤ̾ǽפ</option>'
	. '</select></div>'

	. '<div id="referersearch"><label for="setting:client_referer" class="datatitle">󥯸</label>'
	. '<input type="text" name="setting:client_referer" size="30" value="' . $this->escape($client_referer) . '">'
	. '<select name="setting:client_refererRegexp">'
	. '<option value="">ʬ</option>'
	. '<option value="2"' . (($setting::stat{'client'}{'refererRegexp'} && $setting::stat{'client'}{'refererRegexp'} == 2) ? ' selected="selected"' : '') . '></option>'
	. '<option value="1"' . (($setting::stat{'client'}{'refererRegexp'} && $setting::stat{'client'}{'refererRegexp'} == 1) ? ' selected="selected"' : '') . '>ɽ</option>'
	. '</select>'
	. '<select name="setting:client_refererLanding">'
	. '<option value="">ˬΥ󥯸ޤ</option>'
	. '<option value="1"' . (($setting::stat{'client'}{'refererLanding'}) ? ' selected="selected"' : '') . '>Υ󥯸Τ</option>'
	. '</select> ' . $this->submit_button($env::image_dir . '/stat/client.gif',20,20,'󥭥','','m','ClientReport','k','client') . '</div>'
);
print $this->{'infoTable'}->_tr;
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('ꥻå');
print $this->{'infoTable'}->td('<input type="button" value="Ͼꥻå" onclick="cmonos.form.item(this.form).resetAll()" />');
print $this->{'infoTable'}->_tr;
}

######################################################################
# Ĵ
sub stat_key ($$;$) {
my($this,$key) = @_;
return '<strong>' . $this->domain_info($key) . '</strong>';
}

######################################################################
# ɲù
sub stat_option ($$$) {
my($this,$key,$value) = @_;
return $this->hhmmss_to_time($this->{'client_in'}->{$key}) . '-' . $this->hhmmss_to_time($this->{'client_out'}->{$key}) . ' ' . $this->submit_button($env::image_dir . '/stat/dog.gif',14,14,'­פƸޤ','','m','TracerReport','k','tracer','setting:tracer_target',$key);
}

sub hhmmss_to_time ($$) {
my($this,$time) = @_;
return ($time =~ /^(\d{2})(\d{2})/) ? $1 . ':' . $2 : $time;
}

######################################################################
# ϥȥ
sub stat_title ($) {
my $this = shift;
return '' . (($setting::stat{'referer'}{'option'}) ? 'ɥᥤ' : 'ۥ') . '󥭥';
}

######################################################################
# Ϸɽ
sub print_report ($) {
my $this = shift;
return if defined $this->{'noLog'} && $this->{'noLog'};

my(@ranking);
$setting::stat{'client'}{'sort'} = 'descend' if !defined $setting::stat{'client'}{'sort'} ||  $setting::stat{'client'}{'sort'} eq '';
@ranking = keys %{$this->{'remote_host'}};
@ranking = grep($this->{'referer_is_target'}->{$_},@ranking) if @setting::target_client_referer;
@ranking = sort {$this->sort_by(\$this->{'remote_host'}->{$a},\$this->{'remote_host'}->{$b},$setting::stat{'client'}{'sort'}) || $this->sort_by(\$this->{'client_out'}->{$a},\$this->{'client_out'}->{$b},'ascend') || $a cmp $b} @ranking;
$this->print_stat_report(
	'',
	\@ranking,
	$this->{'remote_host'},
	'',
	'',
	((!@ranking) ? '' : ($setting::stat{'client'}{'sort'} eq 'ascend') ? $this->{'remote_host'}->{$ranking[$#ranking]} : $this->{'remote_host'}->{$ranking[0]}),
	'client',
	1,
	'' . (($setting::stat{'client'}{'option'}) ? 'ɥᥤ' : 'ۥ'),
	'left',
	250,
	'',
	100,
	'',
	(($setting::stat{'client'}{'option'}) ? '' : 'ں߻/'),
	(($setting::stat{'client'}{'option'}) ? '' : 120)
);

}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#ǥեȥ
	$main::k = 'client' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('client','ClientReport');

}


1;

