package RequestReport;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
######################################################################
# ե̥󥭥󥰥⥸塼
# RequestReport.pm ver1.0.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-08-07
######################################################################
# 
# 	$$data[0]	֡hhmmss
# 	$$data[1]	IPREMOTE_HOST
# 	$$data[2]	ե
# 	$$data[3]	饤ȴĶHTTP_USER_AGENT
# 	$$data[4]	饤ȼHTTP_ACCEPT_LANGUAGE
# 	$$data[5]	󥯸HTTP_REFERER
# 	$$data[6]	ɥ¦
# 	$$data[7]	ɥ¦ι⤵
# 	$$data[8]	Ѳǽʥ꡼
# 	$$data[9]	Ѳǽʥ꡼⤵
sub log_stat ($$$) {
my($this,$date,$data) = @_;
my($request);
$request = $$data[2];

# к
if ($request && ($request =~ /\?(.+)$/ || $request =~ /^.+(http.*?)$/)) {
	my $query = $1;
	$query =~ s/\+/ /g;
	$query =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/(($1 eq '26' || uc $1 eq '3D') ? '%' . $1 : pack("C",hex($1)))/ge;
	foreach (@default::target) {
		if ($query =~ s/^.*\Q$_\E/$_/) {
			$query =~ s/[\&\^].*$//;
			$query =~ s/%26/\&/gi;
			$query =~ s/%3D/=/gi;
			$request = $query;
			$request = 'http://' . $request if $request !~ /^https?:\/\//i;
			last;
		}
	}
}

# ѥɤޤ줿URLΤᡢѥʬ
#$request =~ s!^(http[s]?://)\w+:\w+\@!$1!si;

# CGIξʬ̵
$request =~ s/\?.*$//s if defined $setting::stat{'request'}{'option'} && $setting::stat{'request'}{'option'};

# 󥫡̵
if ($setting::stat{'request'}{'option2'}) {
	$request =~ s/\#.*$//s;
	$request =~ s/(\.[s]?htm[l]?)(?=\W).*?$/$1/s;
}
$request = $this->url_filter($request,1);
if ($setting::stat{'request'}{'option3'}) {
	$this->{'access_file'}->{$request}++ if !$this->{'access_ip'}->{$request}->{$$data[1]};
	$this->{'access_ip'}->{$request}->{$$data[1]}++;
} else {
	$this->{'access_file'}->{$request}++;
}
return 1;
}

######################################################################
# Ĵ
sub stat_key ($$;$) {
my($this,$key) = @_;
return $this->url_to_title($key);
}

######################################################################
# ɲù
sub stat_option ($$$) {
my($this,$key,$value) = @_;
return $this->submit_button($env::image_dir . '/stat/node.gif',14,14,'Υե뤫Υ󥯤ΥåΨ󥭥󥰤ޤ','','m','ClickRatioReport','k','click','setting:click_target',$key);
}

######################################################################
# ϥȥ
sub stat_title ($) {
my $this = shift;
return 'ե̥󥭥';
}

######################################################################
# ϴĶɲá
sub print_sub_stat_env ($) {
my $this = shift;
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('ˡ');
print $this->{'infoTable'}->td(
	'<select name="setting:request_option">'
	. '<option value="">CGIξʬޤ</option>'
	. '<option value="1"' . (($setting::stat{'request'}{'option'}) ? ' selected="selected"' : '') . '>CGIξʬ̵뤹</option>'
	. '</select>'
	. ' <select name="setting:request_option2">'
	. '<option value="">󥫡ޤ</option>'
	. '<option value="1"' . (($setting::stat{'request'}{'option2'}) ? ' selected="selected"' : '') . '>󥫡̵뤹</option>'
	. '</select> '
	. ' <select name="setting:request_option3">'
	. '<option value="">ƱIPκƥ򥫥Ȥ</option>'
	. '<option value="1"' . (($setting::stat{'request'}{'option3'}) ? ' selected="selected"' : '') . '>ƱIPκƥ򥫥Ȥʤ</option>'
	. '</select> '
	. $this->submit_button($env::image_dir . '/stat/request.gif',20,20,'ե̥󥭥','','m','RequestReport','k','request')
);
print $this->{'infoTable'}->_tr;
}

######################################################################
# Ϸɽ
sub print_report ($) {
my $this = shift;
return if defined $this->{'noLog'} && $this->{'noLog'};
$this->tie_title_db;

my(@ranking);
$setting::stat{'request'}{'sort'} = 'descend' if !defined $setting::stat{'request'}{'sort'} ||  $setting::stat{'request'}{'sort'} eq '';
@ranking = sort {$this->sort_by(\$this->{'access_file'}->{$a},\$this->{'access_file'}->{$b},$setting::stat{'request'}{'sort'}) || $a cmp $b} keys %{$this->{'access_file'}};

$this->print_stat_report(
	'',
	\@ranking,
	$this->{'access_file'},
	'',
	'',
	((!@ranking) ? '' : ($setting::stat{'request'}{'sort'} eq 'ascend') ? $this->{'access_file'}->{$ranking[$#ranking]} : $this->{'access_file'}->{$ranking[0]}),
	'request',
	1,
	'URL',
	'left',
	300,
	'',
	100,
	'',
	'åΨ',
	60
);
$this->untie_title_db;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#ǥեȥ
	$main::k = 'request' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('request','RequestReport');

}


1;

