package Stat;
require CMONOS::CGI_Lib::UrlDecode;
@ISA = qw(UrlDecode);
use strict;
######################################################################
# Ͽ⥸塼
# Stat.pm ver1.0.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-01-18
######################################################################
# ֥Ȥ롣
sub new ($) {
my $pkg = shift;
my $this = {};
bless $this;
$this;
}

######################################################################
# ᥤ
sub run ($) {
my $this = shift;
my($location,$date,$time,$access_log);

# ꤬
if (defined $main::location && $main::location ne '') {
	$location = $main::location;
	$main::referer = ($ENV{'HTTP_REFERER'}) ? $ENV{'HTTP_REFERER'} : '';
} elsif (defined $main::url && $main::url ne '') {
	$location = $main::url;

# ¾
} elsif (defined $ENV{'HTTP_REFERER'} && $ENV{'HTTP_REFERER'} !~ /\/stat\.cgi/) {
	$location = $ENV{'HTTP_REFERER'};
} else {
	$location = '';
}
$main::referer = '' if !$main::referer || $main::referer =~ m!^file://!i;

# ѥɤޤ줿URLΤᡢѥʬ
$location =~ s!^(https?://)[\w:]+\@!$1!si;
$main::referer =~ s!^(https?://)[\w:]+\@!$1!si;

$location =~ s!/index\.s?htm[l]?$!/!si;
$main::referer =~ s!/index\.s?htm[l]?$!/!si;

$location =~ s/%7e/~/sgi;
$main::referer =~ s/%7e/~/sgi;
$location =~ s/ /\+/g;
$main::referer =~ s/ /\+/g;

# ɥᥤʸ
$location =~ s!^(https?://[^/]+)!lc($1)!ie;
$main::referer =~ s!^(https?://[^/]+)!lc($1)!ie;

# å䴰
$location .= '/' if $location =~ m!^https?://[^/]+$!;
$main::referer .= '/' if $main::referer =~ m!^https?://[^/]+$!;

# ۥ̾Ѵ
$location =~ s!^(https?://)([\d+\.]+)/!$1 . $this->to_host($2) . '/'!e;
$main::referer =~ s!^(https?://)([\d+\.]+)/!$1 . $this->to_host($2) . '/'!e;

# åȥȰʳξ/Ͽоݳ
if (!@default::target) {
	my $home_location = $this->home_location;
	if (defined $env::doublename && $env::doublename) {
		$home_location =~ s!^https?://www\.!!si;
		$location =~ s!^(https?://)www\.$home_location!$1$home_location!si if defined $env::doublename && $env::doublename;
	}
	push(@default::target,$home_location);
}
(defined $main::location && $main::location ne '') ? $this->location($main::location) : $this->invisible_gif if grep(eval {$location =~ /\Q$_\E/},@default::target) == 0 || $this->read_cookie_direct('NOCHECK' . $default::id) eq $default::nocheck_pswd;

# 
($date,$time) = $this->date_id;

# եؤ
$access_log = $default::access_log . '/' . $date . '.csv';
$this->log_sweeper unless -f $access_log;

# 񤭹
#if (open (LOG, ">>$access_log")) {
if ($this->filelock($access_log,2) && open (LOG, ">>$access_log")) {
	use Fcntl qw(:flock);
	binmode LOG;
	flock(LOG, LOCK_EX);

	print LOG $this->csv(1,
		$time,
		$this->to_host($ENV{'REMOTE_ADDR'}),
		$location,
		$ENV{'HTTP_USER_AGENT'},
		$ENV{'HTTP_ACCEPT_LANGUAGE'},
		$main::referer,
		$main::innerWidth,
		$main::innerHeight,
		$main::screenWidth,
		$main::screenHeight
	);
	print LOG "\x0D\x0A";

	close (LOG);
	$this->filelock($access_log,8);
}

# ƩGIF/
(defined $main::location && $main::location ne '') ? $this->location($main::location) : $this->invisible_gif;
}

#եå
sub filelock ($$$) {
my($this,$file,$code) = @_;
my($lockdir,$i,$lock);
$lockdir = $file . '.lock';

$SIG{'TERM'} = $SIG{'PIPE'} = $SIG{'HUP'} = \&unlock;

if ($code == 2) {
	for ($i = 0; $i <= 10; $i++) {
		if (mkdir($lockdir, $env::dir_mode)) {
			$locked::file{$lockdir} = 1;
			return 1;
		} else {
			my @stat = stat($lockdir);
			if ($stat[9] && time - $stat[9] > 5) {
				rmdir($lockdir);
				delete $locked::file{$lockdir};
				next;
			}
			sleep(1);
		}
	}
	return 0;

} elsif ($code == 8) {
	delete $locked::file{$lockdir};
	return rmdir($lockdir);
}
}

sub unlock {
my($lockdir);
while (($lockdir) = each %locked::file) {
	rmdir($lockdir);
}
}

######################################################################
# 
sub log_sweeper ($) {
my $this = shift;
my(@logfiles,$size,%setting,$cginame,$mastername,$master,$owners,$mailto,$limit,$oldest);

# ǥ쥯ȥΥ
opendir(LOG, $default::access_log);
@logfiles = grep($_ =~ /\d{8}\.csv$/ && ($size += -s $default::access_log . '/' . $_),readdir(LOG));
closedir(LOG);

#ե뤬¸ߤʤȤϲ⤷ʤ
return if !@logfiles;

# ɤ߹
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
tie(%setting, $env::dbm_file, $default::preference_dir . '/general', O_RDONLY, $env::dbm_mode);
$cginame = $setting{'cginame'};
$mastername = $setting{'mastername'};
$master = $setting{'master'};
$owners = $setting{'owners'};
$mailto = $setting{'mailto'};
$limit = $setting{'limit'};
untie %setting;

$limit = $default::limit if !defined $limit ||  !$limit;
$limit = 100000 if !defined $limit ||  !$limit;

# ̤̰λϲ⤷ʤ
$size += $size / @logfiles;
return if $size < $limit;

# ָŤ
@logfiles = sort @logfiles;
$oldest = $default::access_log . '/' . $logfiles[0];
# 褬ꤵƤȤϥ᡼
if (defined $mailto && $mailto ne '') {
	my($msg);
	$msg = '' . $cginame . "\x0A";
	$msg .= "\x0A";
	$msg .= '̤ͤ˶ŤƤΤǡ' . "\x0A";
	$msg .= 'Ťޤ' . "\x0A";

	$msg .= "\x0A";
	$msg .= 'źեեϺ줿Ǥ' . "\x0A";
	$msg .= 'ե̾աyyyymmdd' . "\x0A";
	$msg .= 'csvʥ޶ڤƥȡ' . "\x0A";
	$msg .= "\x0A";
	$msg .= '֡hhmmss,' . "\x0A";
	$msg .= 'IPREMOTE_HOST,' . "\x0A";
	$msg .= 'ե,' . "\x0A";
	$msg .= '饤ȴĶHTTP_USER_AGENT,' . "\x0A";
	$msg .= '饤ȼHTTP_ACCEPT_LANGUAGE,' . "\x0A";
	$msg .= '󥯸HTTP_REFERER,' . "\x0A";
	$msg .= 'ɥ¦,' . "\x0A";
	$msg .= 'ɥ¦ι⤵,' . "\x0A";
	$msg .= '꡼,' . "\x0A";
	$msg .= '꡼⤵' . "\x0A";
	$msg .= "\x0A";

	unless (ref $cgi::SendMail) {
		require CMONOS::CGI_Lib::SendMail;
		$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
	}

	$cgi::SendMail->send_mail(
		'Bcc'		=>  $mailto,
		'From'		=>  (($mastername) ? $mastername . ' <' . $master . '>' : $master),
		'Subject'	=>  'Ťޤ',
		'message'	=>  $msg,
		'file'		=>  $oldest,
		'info'		=>  0
	);
}

unlink $oldest;
}


1;
