package CartController;
require CMONOS::CGI_Lib::Base;
@ISA = qw(Base);
use strict;
use Fcntl qw(:flock);
######################################################################
# ⥸塼
# CartController.pm 1.0.5
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-05-06
######################################################################
# 
# 
# Υ֥롼󽸤λȤ
# ---------------------------------------------------------------------------------------
#	(0) ֥Ȥ롣
#		require CMONOS::CGI_Lib::CartController;
#		obj = CartController->new;
# 
# ---------------------------------------------------------------------------------------
#	(1) obj->add(\%new_item,\%item_data,\@item_order);
#		ƥɲá
#			new_item		ƥΥϥåΥե
#			item_data		ȥǡɤ߹ϥåΥե
#			item_order		Ǽɤ߹Υե
# 
# ---------------------------------------------------------------------------------------
#	(2) obj->change(\%quantity,\%item_data,\@item_order);
#		ƥѹ
#			quantity		ƥΥϥåΥե
# 
# ---------------------------------------------------------------------------------------
#	(3) obj->cancel(\%canceled_item,\%item_data,\@item_order);
#		ƥѹ
#			canceled_item	󥻥뤹륢ƥΥե󥹡ʥ顼󡦥ϥå
# 
# ---------------------------------------------------------------------------------------
#	(4) obj->cancel_all;
#		Ȥˤ
# 
# ---------------------------------------------------------------------------------------
#	(5) obj->check(\%cart,\%item_data,\@item_order,strictly);
#		ƥ¸ߤȺ߸ˤå
#			cart			ȥǡϥåΥե󥹡ʶξ祻å󤫤ɤ߹ߤޤ
#			strictly		1=ǡ١Υեå
# 
######################################################################
#֥Ⱥ
sub new ($) {
my $pkg = shift;
my $this = {};
bless $this;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
$this->use_session;
if (!$session::id && !$session::is_deleted) {
	$session::id = $this->read_cookie_direct($this->login_cookie_name);
	if (!$cgi::Session->is_available($session::id)) {
		$session::is_deleted = 1;
		undef $session::id;
	}
}
$this;
}

######################################################################
#ƥɲ
sub add ($$;$$) {
my($this,$new_item,$item_data,$item_order) = @_;
my $new_item_id = '';
my %cart = ();
$new_item->{'quantity'} = 1 if $new_item->{'digitalcontent'};
if (!$new_item->{'caller'}) {
	push(@{$cgi::action->{'dialog'}},'ƤӤǤ') if ref $cgi::action;
} elsif (!$new_item->{'quantity'} || $this->is_nan($new_item->{'quantity'})) {
	push(@{$cgi::action->{'dialog'}},'ĿǤϤޤ') if ref $cgi::action;
} elsif ($new_item->{'quantity'} < 1) {
} elsif ($new_item->{'m'}) {
	if (!$this->_get_field_info($new_item)) {
		push(@{$cgi::action->{'dialog'}},'ȸƤӽФե꤬ǤޤǤ') if ref $cgi::action;
	} elsif ($new_item->{'digitalContentRequired'} && !$new_item->{'digitalcontent'}) {
		push(@{$cgi::action->{'dialog'}},'ǥ륳ƥĤ¸ߤޤ') if ref $cgi::action;
	} else {
		$new_item->{'path'} = '../' . $new_item->{'caller'} . '/start.cgi?pickup=1' . (($new_item->{'m'}) ? '&m=' . $new_item->{'m'} : '') . ((defined $new_item->{'c'} && $new_item->{'c'} ne '') ? '&c=' . $new_item->{'c'} : '') . ((defined $new_item->{'n'} && $new_item->{'n'} ne '') ? '&n=' . $new_item->{'n'} : '');
		$new_item_id = $new_item->{'caller'} . ((defined $new_item->{'c'} && $new_item->{'c'} ne '') ? '_' . $new_item->{'c'} : '') . ((defined $new_item->{'n'} && $new_item->{'n'} ne '') ? '_' . $new_item->{'n'} : '') . (($new_item->{'option'}) ? '_' . ((ref $new_item->{'option'}) ? join('_',sort @{$new_item->{'option'}}) : $new_item->{'option'}) : '');
	}
} elsif ($new_item->{'cartfield'}) {
	$new_item->{'path'} = ($ENV{'HTTP_REFERER'}) ? $this->path_change($ENV{'HTTP_REFERER'}) : '../../' . $new_item->{'caller'} . ((defined $new_item->{'c'} && $new_item->{'c'} ne '') ? '/' . $new_item->{'c'} : '') . ((defined $new_item->{'n'} && $new_item->{'n'} ne '') ? '/' . $new_item->{'n'} : '') . '/' . (($new_item->{'p'}) ? ($new_item->{'p'} eq 'i') ? '1' : $new_item->{'p'} : 'index') . '.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html');
	$new_item->{'path'} .= 'index.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html') if $new_item->{'path'} =~ m!/$!;
	if (!$new_item->{'path'} || !-f $new_item->{'path'} || !-f '../' . $new_item->{'caller'} . '/start.cgi') {
		push(@{$cgi::action->{'dialog'}},'ȸƤӽФڡǤޤǤ') if ref $cgi::action;
	} else {
		$new_item_id = $new_item->{'caller'} . ((defined $new_item->{'c'} && $new_item->{'c'} ne '') ? '_' . $new_item->{'c'} : '') . ((defined $new_item->{'n'} && $new_item->{'n'} ne '') ? '_' . $new_item->{'n'} : '') . (($new_item->{'p'}) ? '_' . $new_item->{'p'} : '') . (($new_item->{'chapterid'}) ? '_' . $new_item->{'chapterid'} : '') . (($new_item->{'sectionid'}) ? '_' . $new_item->{'sectionid'} : '') . (($new_item->{'option'}) ? '_' . ((ref $new_item->{'option'}) ? join('_',sort @{$new_item->{'option'}}) : $new_item->{'option'}) : '');
	}
} else {
	push(@{$cgi::action->{'dialog'}},'ȸƤӽФǡ­ޤ') if ref $cgi::action;
}
$session::is_changed = 1 if !$session::id;
$cgi::Session->read_by_uri($session::id,$env::home_dir_id . 'cart',\%cart,0,$item_order);
if ($new_item_id) {
	my $old_quantity = (ref $cart{$new_item_id}) ? $cart{$new_item_id}{'quantity'} : 0;
	$cart{$new_item_id} = $new_item;
	if ($cart{$new_item_id}{'digitalcontent'}) {
		$cart{$new_item_id}{'quantity'} = 1;
	} elsif ($old_quantity) {
		$cart{$new_item_id}{'quantity'} += $old_quantity;
	}
}
$this->check(\%cart,$item_data,$item_order);
push(@$item_order,$new_item_id) if $new_item_id && ref $cart{$new_item_id} && !grep($_ eq $new_item_id,@$item_order);
$cgi::Session->save_by_uri($session::id,$env::home_dir_id . 'cart',\%cart);
return ($new_item_id && ref $cart{$new_item_id}) ? 1 : 0;
}

sub _get_field_info ($$) {
my($this,$item) = @_;
my($setting,$subdivided,$db,$field_pref_dir,$preference_dir,$is_success,$caller_path);
$is_success = 0;
$caller_path = '../' . $item->{'caller'} . '/start.cgi';
$setting = $this->read_file('../' . $item->{'caller'} . '/default.pl');
$db = ($setting =~ /\$db\s*=\s*["'](.*?)["']/) ? $this->un_base_change($1,$caller_path,'rel',1) : '';
$subdivided = 1 if $setting =~ /\$subdivided\s*=\s*1/;
$preference_dir = $this->un_base_change($1,$caller_path,'rel',1) if $setting =~ /\$preference_dir\s*=\s*["'](.*?)["']/;
$field_pref_dir = $this->un_base_change($1,$caller_path,'rel',1) if $setting =~ /\$field_pref_dir\s*=\s*["'](.*?)["']/;
if ($db && $field_pref_dir) {
	my(%field_setting);
	$field_pref_dir .= '/' . $item->{'c'} unless !$subdivided || $field_pref_dir =~ s!^$preference_dir/!$preference_dir/$item->{'c'}/!;
	$db .= '/' . $item->{'c'} if defined $item->{'c'} && $item->{'c'} ne '';
	$item->{'db'} = $db;
	tie(%field_setting, $env::dbm_file, $field_pref_dir . '/inputfield', O_RDONLY, $env::dbm_mode);
	if (ref tied %field_setting) {
		$item->{'keyfield'} = ($field_setting{'for_key'}) ? $field_setting{'for_key'} : '';
		$item->{'namefield'} = ($field_setting{'for_title'}) ? $field_setting{'for_title'} : ($field_setting{'for_name'}) ? $field_setting{'for_name'} : $item->{'keyfield'};
		if ($item->{'cartfield'} && $field_setting{$item->{'cartfield'} . '_pkg'} && $field_setting{$item->{'cartfield'} . '_pkg'} eq 'ShoppingCart') {
			if ($field_setting{$item->{'cartfield'} . '_stockview'} && $field_setting{$item->{'cartfield'} . '_stockview'} eq 'sync') {
				$item->{'outOfStockBounds'} = $field_setting{$item->{'cartfield'} . '_outOfStockBounds'} if defined $field_setting{$item->{'cartfield'} . '_outOfStockBounds'};
				$item->{'outOfStockName'} = $field_setting{$item->{'cartfield'} . '_outOfStockName'} if defined $field_setting{$item->{'cartfield'} . '_outOfStockName'};
				$item->{'digitalContentRequired'} = 1 if $field_setting{$item->{'cartfield'} . '_digitalContentRequired'};
			} else {
				delete $item->{'outOfStockBounds'};
				delete $item->{'outOfStockName'};
			}
			$is_success = 1;
		}
	}
	untie(%field_setting);
}
if ($item->{'digitalcontent'}) {
	if ($item->{'digitalcontent'} && $item->{'digitalcontent'} eq '1' && $db && -d $db) {
		$item->{'digitalcontentpath'} = $db . '/digital-content';
	} elsif ($item->{'digitalcontent'} && $item->{'digitalcontent'} eq '2' && $setting =~ /\$file\s*=\s*["'](.*?)["']/) {
		my $files = $this->un_base_change($1,$caller_path,'rel',1);
		$item->{'digitalcontentpath'} = $files . ((defined $item->{'c'} && $item->{'c'} ne '') ? '/' . $item->{'c'} : '') . ((defined $item->{'n'} && $item->{'n'} ne '') ? '/' . $item->{'n'} : '') if $files && -d $files;
	}
}
return $is_success;
}

sub read_file ($$) {
my($this,$path) = @_;
my($data);
local(*FILE);
if (open(FILE, $path)) {
	binmode FILE;
	flock(FILE, LOCK_SH);
	$data = join('',<FILE>);
	close(FILE);
}
return (defined $data) ? $data : '';
}

######################################################################
#ƥѹ
sub change ($$;$$) {
my($this,$quantity,$item_data,$item_order) = @_;
return 0 if !$session::id;
my %cart = ();
my($id,$q);
$cgi::Session->read_by_uri($session::id,$env::home_dir_id . 'cart',\%cart,0,$item_order);
while (($id,$q) = each %{$quantity}) {
	if (ref $cart{$id}) {
		if (!$q) {
			$cart{$id}{'quantity'} = 0;
		} elsif ($q && !$this->is_nan($q)) {
			$cart{$id}{'quantity'} = $q;
		}
	}
}
$this->check(\%cart,$item_data,$item_order);
$cgi::Session->save_by_uri($session::id,$env::home_dir_id . 'cart',\%cart);
return 1;
}

######################################################################
#ƥΥ󥻥
sub cancel ($$;$$) {
my($this,$canceled_item,$item_data,$item_order) = @_;
return 0 if !$session::id;
my %quantity = ();
if ($canceled_item && !ref $canceled_item) {
	$quantity{$canceled_item} = 0;
} elsif (ref $canceled_item eq 'ARRAY') {
	foreach my $id (@$canceled_item) {
		$quantity{$id} = 0;
	}
} elsif (ref $canceled_item eq 'HASH') {
	%quantity = %$canceled_item;
}
return $this->change(\%quantity,$item_data,$item_order);
}

######################################################################
#ƥΥ󥻥
sub cancel_all ($) {
my $this = shift;
return 0 if !$session::id;
return $cgi::Session->reset_by_uri($session::id,$env::home_dir_id . 'cart',$env::home_dir_id . 'checkout');
}

sub get_url_of_last_item ($) {
my $this = shift;
return '' if !$session::id;
my(%cart,@order);
$cgi::Session->read_by_uri($session::id,$env::home_dir_id . 'cart',\%cart,0,\@order);
return (%cart && @order && ref $cart{$order[$#order]} && $cart{$order[$#order]}{'path'}) ? $cart{$order[$#order]}{'path'} : '';
}

######################################################################
#ƥΥå
sub check ($;$$$$$) {
my($this,$cart,$item_data,$item_order,$strictly,$digital_content_array) = @_;
my %temp = ();
my($id,$item,@delete,@deleted_item);
if (!ref $cart) {
	$cart = \%temp;
	$cgi::Session->read_by_uri($session::id,$env::home_dir_id . 'cart',$cart,0,$item_order);
}
require CMONOS::CGI_Lib::Template;
while (($id,$item) = each %$cart) {
	if (!$item->{'quantity'}) {
		push(@delete,$id);
		next;
	} elsif ($item->{'m'}) {
		if ($item->{'db'}) {
			my(%db,%temp_data,$data,$pending);
			tie(%db, $env::dbm_file, $item->{'db'} . '/pending', O_RDONLY, $env::dbm_mode);
			$pending = $db{$item->{'n'}} if ref tied %db && $db{$item->{'n'}};
			untie(%db);
			if ($pending) {
				my($is_pending,$start,$end) = split(/\-/,$pending);
				my $time = time;
				if (($is_pending && !$start && !$end) || ($start && $time < $start) || ($end && $end < $time)) {
					push(@delete,$id);
					next;
				}
 			}
			tie(%db, $env::dbm_file, $item->{'db'} . '/showcase', O_RDONLY, $env::dbm_mode);
			$data = $db{$item->{'n'}} if ref tied %db;
			untie(%db);
			if (($strictly && !$this->_get_field_info($item)) || !$this->_is_available($data,$item,((ref $item_data) ? \%{$item_data->{$id}} : \%temp_data)) || !$this->_has_available_item(((ref $item_data) ? \%{$item_data->{$id}} : \%temp_data),$item,$digital_content_array)) {
				push(@delete,$id);
				next;
			}
			undef $data;
			if (ref $item_data) {
				if ($item->{'keyfield'}) {
					tie(%db, $env::dbm_file, $item->{'db'} . '/' . $item->{'keyfield'}, O_RDONLY, $env::dbm_mode);
					$item_data->{$id}->{'key'} = $db{$item->{'n'}} if ref tied %db;
					untie(%db);
					$item_data->{$id}->{'key'} =~ s/<>([#0-9a-zA-z]{3,10})\Z//s if $item_data->{$id}->{'key'};
				}
				if ($item->{'namefield'}) {
					if ($item->{'keyfield'} && $item->{'keyfield'} eq $item->{'namefield'}) {
						$item_data->{$id}->{'name'} = $item_data->{$id}->{'key'};
					} else {
						tie(%db, $env::dbm_file, $item->{'db'} . '/' . $item->{'namefield'}, O_RDONLY, $env::dbm_mode);
						$item_data->{$id}->{'name'} = $db{$item->{'n'}} if ref tied %db;
						untie(%db);
						$item_data->{$id}->{'name'} =~ s/<>([#0-9a-zA-z]{3,10})\Z//s if $item_data->{$id}->{'name'};
					}
				}
				$item_data->{$id}->{'db'} = $item->{'db'};
				$item_data->{$id}->{'n'} = $item->{'n'};
				$item_data->{$id}->{'path'} = $item->{'path'};
				$item_data->{$id}->{'quantity'} = $item->{'quantity'};
				$item_data->{$id}->{'digitalcontentpath'} = $item->{'digitalcontentpath'};
			}
		}
	} else {
		my %data = ();
		my $this_template = Template->new('','','');
		if ($item->{'p'} && $item->{'p'} eq 'i') {
			$this_template->set(
				'chapter' => '',	
				'section' => '',
				'field_tag_name' => 'info'
			);
		} else {
			$this_template->set(
				'chapter' => 'chapter',	
				'section' => 'section',
				'field_tag_name' => 'field'
			);
		}
		my $article = $this->read_file($item->{'path'});
		my $chap_id = ((defined $item->{'chapterid'}) ? $item->{'chapterid'} : '');
		my $sect_id = ((defined $item->{'sectionid'}) ? $item->{'sectionid'} : '');
		$this_template->scan(\$article,\$chap_id,\$sect_id,\%data);

		#¸ߤΥå/߸ˤΥåFALSE%cart & item_dataɤ߹ޤʤ
		$item->{'digitalcontentpath'} = $this->un_base_change($data{$item->{'cartfield'}}{'folder'},$item->{'path'}) if $data{$item->{'cartfield'}}{'folder'};
		if (defined $data{$item->{'cartfield'}}{'price'} && !$data{$item->{'cartfield'}}{'unavailable'} && $this->_has_available_item($data{$item->{'cartfield'}},$item,$digital_content_array)) {
			if (ref $item_data) {
				$item_data->{$id}->{'key'} = ($item->{'keyfield'} && defined $data{$item->{'keyfield'}}{'str'}) ? $data{$item->{'keyfield'}}{'str'} : '';
				$item_data->{$id}->{'name'} = ($item->{'namefield'} && defined $data{$item->{'namefield'}}{'str'}) ? $data{$item->{'namefield'}}{'str'} : '';
				$item_data->{$id}->{'anchor'} = ($item->{'p'} && $item->{'p'} eq 'i') ? '' : '#a' . ((defined $item->{'p'} && $item->{'p'} ne '') ? sprintf("%.2d", $item->{'p'}) : ($item->{'path'} =~ m!/1\.s?html?$!i) ? '01' : '') . sprintf("%.2d", $item->{'chapterid'}) . sprintf("%.2d", $item->{'sectionid'});
				$item_data->{$id}->{'path'} = $item->{'path'};
				$item_data->{$id}->{'quantity'} = $item->{'quantity'};
				$item_data->{$id}->{'digitalcontentpath'} = $item->{'digitalcontentpath'};
				my($k,$v);
				while (($k,$v) = each %{$data{$item->{'cartfield'}}}) {
					$item_data->{$id}->{$k} = $v if $k ne 'option' && $k ne 'multiple';
				}
				($item_data->{$id}->{'option'},$item_data->{$id}->{'optionprice'}) = $this->_option($item->{'option'},$data{$item->{'cartfield'}}{'option'},$data{$item->{'cartfield'}}{'multiple'}) if $item->{'option'} && $data{$item->{'cartfield'}}{'option'};
			}
		} else {
			push(@delete,$id);
		}
	}
}
if (@delete) {
	foreach $id (@delete) {
		undef %{$cart->{$id}};
		$cart->{$id} = "\x7F";
		@$item_order = grep($_ ne $id,@$item_order) if ref $item_order eq 'ARRAY'
	}
	push(@{$cgi::action->{'dialog'}},'갷ߤ줿߸ڤΤ' . scalar(@delete) . 'Τʸޤ') if ref $cgi::action;
	$cgi::Session->save_by_uri($session::id,$env::home_dir_id . 'cart',\%temp) if %temp;
	return 0;
} else {
	return 1;
}
}

sub _has_available_item ($$$;$) {
my($this,$data,$item,$digital_content_array) = @_;
return ($item->{'digitalContentRequired'} || $data->{'digitalContentRequired'}) ? 0 : 1 if !$item->{'digitalcontent'};
$item->{'quantity'} = 1;
if ($data->{'digitalcontent'} && $data->{'foldertype'} && $data->{'foldertype'} eq $item->{'digitalcontent'} && $item->{'digitalcontentpath'} && !$data->{'withdrawn'}) {
	my $dc = $item->{'digitalcontentpath'} . '/' . (($data->{'foldertype'} eq '2') ? $item->{'cartfield'} . '.' . $data->{'digitalcontent'} . '.dat' : $data->{'digitalcontent'});
	if (-f $dc) {
		push(@$digital_content_array,$dc) if ref $digital_content_array eq 'ARRAY';
		return 1;
	}
}
push(@{$cgi::action->{'dialog'}},'ǥ륳ƥĤ¸ߤޤ') if ref $cgi::action;
return 0;
}

sub _is_available ($$$$) {
#no warnings qw(numeric);
my($this,$str,$item,$item_data) = @_;
my(%data,$option,$multiple);
return 0 if !defined $str;
$data{'price'} = $data{'condition'} = $data{'availability'} = $data{'stock'} = $data{'multiple'} = $data{'option'} = $data{'withdrawn'} = '';
$data{'price'} = $1 if $str =~ s/^(\d*)\x0A//;
while ($str =~ /^(\w+)\:(.*)$/gm) {
	my($k,$v) = ($1,$2);
	chomp $v;
	$v =~ s/&#10;/\x0A/sg;
	if ($k eq 'option') {
		$option = $v;
	} elsif ($k eq 'multiple') {
		$multiple = $v;
	} else {
		$data{$k} = $v;
	}
}
if (defined $data{'stock'} && $data{'stock'} ne '') {
	$item->{'outOfStockBounds'} = 0 if !$item->{'outOfStockBounds'};
	if ($data{'stock'} <= $item->{'outOfStockBounds'}) {
		return 0;
	} elsif ($data{'stock'} < ($item->{'quantity'} + $item->{'outOfStockBounds'})) {
		$item->{'quantity'} = $data{'stock'} - $item->{'outOfStockBounds'};
		push(@{$cgi::action->{'dialog'}},'߸ڤΤ¤Ƥޤ') if ref $cgi::action;
	}
} elsif (!defined $item->{'outOfStockBounds'} && $data{'unavailable'}) {
	return 0;
}
if (ref $item_data) {
	($data{'option'},$data{'optionprice'}) = $this->_option($item->{'option'},$option,$multiple) if $option && defined $item->{'option'};
	%$item_data = %data;
}
return 1;
}

sub _option ($$$;$) {
my($this,$selected_option,$option,$multiple) = @_;
my($option_name,$option_price,$id);
while ($option =~ /^(.*)$/mg) {
	$id++;
	if ((!ref $selected_option && $selected_option && $selected_option == $id) || ($multiple && ref $selected_option && grep($_ == $id,@$selected_option))) {
		my $name = $1;
		my $price = ($name =~ s/:([\+\-]?\d+)$//) ? $1 : '';
		next if $name !~ /\S/;
		$option_price += $price if $price;
		my $mark = ($price =~ s/^([\+\-])//) ? $1 : '+';
		$option_name .= (($option_name) ? ' ' : '') . $name . (($price) ? '(' . $mark . $this->digit($price) . ')' : '');
		last if !$multiple || !ref $selected_option;
	}
}
return($option_name,$option_price);
}

sub purchase ($;$$$$) {
my($this,$item_data,$item_order,$strictly,$already_read) = @_;
my %temp_data = ();
my @temp_order = ();
$item_data = \%temp_data if !ref $item_data;
$item_order = \@temp_order if !ref $item_order;
return 0 if !$already_read && !$this->check('',$item_data,$item_order,$strictly);
my $id;
foreach $id (@$item_order) {
	if ($item_data->{$id}->{'db'}) {
		my(%db);
		tie(%db, $env::dbm_file, $item_data->{$id}->{'db'} . '/showcase', O_RDWR, $env::dbm_mode);
		$db{$item_data->{$id}->{'n'}} =~ s/^stock\:(\d+)$/'stock:' . ($1 - $item_data->{$id}->{'quantity'})/me if ref tied %db && $db{$item_data->{$id}->{'n'}};
		untie(%db);
		tie(%db, $env::dbm_file, $item_data->{$id}->{'db'} . '/sales', O_RDWR, $env::dbm_mode);
		$db{$item_data->{$id}->{'n'}} = $this->set_sales_data($db{$item_data->{$id}->{'n'}},$item_data->{$id}->{'quantity'}) if ref tied %db && $db{$item_data->{$id}->{'n'}};
		untie(%db);
	}
}
return 1;
}

sub set_sales_data ($$$) {
my($this,$data,$quantity) = @_;
return $data if !$quantity;
my($point,$daily,$total,$ctime,$recommend);
($point,$daily,$total,$ctime) = split(/\t/,$data,4);
$point = 0 if !$point;
$daily = 0 if !$daily;
$daily = $total = 0 if !$total;
$ctime = time if !$ctime;
$recommend = ($point == 999999) ? 1 : 0;
$total += $quantity;
$daily = ($total) ? int((($total / int(((time - $ctime) / 86400) + 1)) * 1000000) + 0.5) / 1000000 : 0;
return (($recommend) ? 999999 : $daily) . "\x09" . $daily . "\x09" . $total . "\x09" . $ctime;
}

sub restore ($;$$) {
my($this,$order_info,$dl_dir) = @_;
my($id,$item);
my %temp = ();
my $cart = \%temp;
if ($order_info) {
	if ($order_info =~ s/^(.*?)\x0A//) {
		#($total,$tax,$fee,$carriage,$carriage_total,$download_key,$ptime)
		my @info = split(/\x09/,$1);
		if ($dl_dir && $info[5] && -d $dl_dir . '/' . $info[5]) {
			use File::Path;
			rmtree $dl_dir . '/' . $info[5];
		}
	}
	my $id = 1;
	while ($order_info =~ /^(.*)$/mg) {
		$cgi::Session->read_data(\%{$cart->{$id++}},$1) if $1;
	}
	undef $order_info;
} else {
	$cgi::Session->read_by_uri($session::id,$env::home_dir_id . 'cart',$cart);
}
while (($id,$item) = each %$cart) {
	if ($item->{'db'}) {
		my(%db);
		tie(%db, $env::dbm_file, $item->{'db'} . '/showcase', O_RDWR, $env::dbm_mode);
		$db{$item->{'n'}} =~ s/^stock\:(\d+)$/'stock:' . ($1 + $item->{'quantity'})/me if ref tied %db && $db{$item->{'n'}};
		untie(%db);
		tie(%db, $env::dbm_file, $item->{'db'} . '/sales', O_RDWR, $env::dbm_mode);
		$db{$item->{'n'}} = $this->set_sales_data($db{$item->{'n'}},(0 - $item->{'quantity'})) if ref tied %db && $db{$item->{'n'}};
		untie(%db);
	}
}
return $this->cancel_all;
}

1;