package RSS2_0;
require CMONOS::CGI_Lib::Common;
@ISA = qw(Common);
use strict;
use Fcntl qw(:flock);
######################################################################
# RSS2.0
# CMONOS::CGI_Lib::Feed::RSS2_0.pm ver1.0.6
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-01-27
######################################################################
# Ȥ
# require CMONOS::CGI_Lib::Feed::RSS2_0;
# $rss = RSS2_0->new(
#	'path'					=>	RSSΥѥ../index.xml etc,
#	'maxitem'				=>	絭,
#	'description_maxlength'	=>	ʸκʸȾѴ,
#	'delete_only'			=>	ʤ=1,
#	'rss_marker'			=>	link  URL  RSS Υ򼨤ղä=1,
#	'utm_medium'			=>	link  URL  RSS Υ򼨤ղä RSS μ
#	'channel_element'		=>	{
# 									ͥ̾ 	=>	,
# 									ͥ̾ 	=>	,
#								},
#	'xmlns'					=>	{
# 									'content' 			=>	'http://purl.org/rss/1.0/modules/content/',
# 									'itunes' 			=>	'http://www.itunes.com/DTDs/Podcast-1.0.dtd',
# 									'dc' 				=>	'http://purl.org/dc/elements/1.1/',
#								},
# );
#
# ͥǰ
# http://blogs.law.harvard.edu/tech/rss
# http://wiki.koshigoe.jp/doku.php?id=koshigoewiki:feed:rss2.0%E4%BB%95%E6%A7%98ܸ
#	title			ͥΥȥ
#	link			ͥɽ륳ƥĤURI
#	description		ͥγ; 񡢽ʥƥȤΤߤǵҤ졢Ԥ̣ޤ
#	language		쥳; Netscape륳ɤѲǽǤɻͤW3CƤޤen-us,ja 
#	copyright		ͥ
#	managingEditor	ƥǤԤEmailɥ쥹
#	webMaster		ƥǤԤEmailɥ쥹
#	pubDate			ͥ뤬ۤ줿; RFC822˽ޤ
#	lastBuildDate	ͥκǽ; pubDateƱ§
#	category		ͥ뤬°ƥ; ǥ٥ǤʣǽǤ
#	generator		ͥץμ̾
#	docs			RSS2.0ΥɥȤɽURI; §http://blogs.law.harvard.edu/tech/rss
#	cloud			XML-RPCʤɤѤΤʤɤΥӥ; HTTP-POST/XML-RPC/SOAPѲǽǤ
#	ttl				åݻ(ʬ); ͤΤѤǤޤ
#	image			ͥɽURI
#	rating			PICSΥ졼
#	textInput		ϲǽʥƥȥܥå; ɥե
#	skipHours		ꥲФͿ̵
#	skipDays		ꥲФͿ̵
#
# ƥɲ
# $rss->update({
# 	ƥ̾ 	=>	,
# 	ƥ̾ 	=>	,
# },keep_pubDate);
# 
# ƥǰ
#	title			ƥΥȥ
#	link			ƥɽ륳ƥĤURI
#	description		ƥγ
#	author			ƥ
#	category		ƥब°륫ƥ
#	comments		ƥ˴Ϣ륳ȥƥĤURI
#	enclosure		ǥƥĤURI	<enclosure url="http://www.scripting.com/mp3s/weatherReportSuite.mp3" length="12216320" type="audio/mpeg" />
#	guid			ƥͭʸ	<guid isPermaLink="true">http://inessential.com/2002/09/01.php#a2</guid>
#	pubDate			ƥबȯԤ줿	Sun, 19 May 2002 15:21:36 GMT
#	source			ƥΥ	<source url="http://www.tomalak.org/links2.xml">Tomalak's Realm</source>
# 
# ƥ
# $rss->update({
# 	'delete' 			=>	[뵭linkꥹ],
# 	'delete_prefix' 	=>	[뵭linkꥹ()],
# });
# 
# ץ
#	keep_pubDate	1=󹹿ݻ
# 
######################################################################
# ֥Ȥ롣
if (!ref $cgi::Jcode) {
	use Jcode;
	$cgi::Jcode = Jcode->new;
	$Jcode::FALLBACK = &Jcode::FB_XMLCREF if defined $Jcode::FALLBACK;
}

sub new ($;@) {
my $pkg = shift;
my $this = {@_};
bless $this, $pkg;
$this->{'maxitem'} = 15 if !$this->{'maxitem'};
$this->{'description_maxlength'} = 128 if !$this->{'decription_maxlength'};
$this->{'rss_marker'} = 1 if !defined $this->{'rss_marker'} && $env::rss_marker;
$env::file_mode = 0644 if !$env::file_mode;

#߻
$this->{'channel_element'}{'pubDate'} = $this->{'gmt'} = $this->current_gmt;

#ͥǤΥå
$this->{'channel_element'} = {} if !ref $this->{'channel_element'};
$this->{'channel_element'}{'link'} = $this->home_location if !defined $this->{'channel_element'}{'link'} || $this->{'channel_element'}{'link'} eq '';
$this->{'channel_element'}{'link'} =~ s/[\?\&]$//;
$this->{'channel_element'}{'title'} = (defined $env::title && $env::title ne '') ? $env::title : $this->{'channel_element'}{'link'} if !defined $this->{'channel_element'}{'title'} || $this->{'channel_element'}{'title'} eq '';
$this->{'channel_element'}{'description'} = (defined $env::description && $env::description ne '') ? $env::description : $this->{'channel_element'}{'title'} if !defined $this->{'channel_element'}{'description'} || $this->{'channel_element'}{'description'} eq '';
$this->{'channel_element'}{'language'} = 'ja-JP' if !defined $this->{'channel_element'}{'language'} || $this->{'channel_element'}{'language'} eq '';
$this->{'channel_element'}{'copyright'} = 'Copyright ' . ((localtime())[5] + 1900) . (($this->{'channel_element'}{'copyright'}) ? ', ' . $this->{'channel_element'}{'copyright'} : '') if !defined $this->{'channel_element'}{'copyright'} || $this->{'channel_element'}{'copyright'} eq '' || $this->{'channel_element'}{'copyright'} !~ /Copyright \d{4}/i;
$this->{'channel_element'}{'lastBuildDate'} = $this->{'channel_element'}{'pubDate'} if !$this->{'delete_only'} && (!defined $this->{'channel_element'}{'lastBuildDate'} || $this->{'channel_element'}{'lastBuildDate'} eq '');
$this->{'channel_element'}{'generator'} = 'http://cmonos.jp/' if !defined $this->{'channel_element'}{'generator'} || $this->{'channel_element'}{'generator'} eq '';
$this->{'channel_element'}{'docs'} = 'http://blogs.law.harvard.edu/tech/rss' if !defined $this->{'channel_element'}{'docs'} || $this->{'channel_element'}{'docs'} eq '';
$this->{'channel_element'}{'description'} = $this->cut_string($this->{'channel_element'}{'description'},$this->{'description_maxlength'},'no');
$this->_image_init($this->{'channel_element'});
$this->_init();
return $this;
}

sub current_gmt ($;$) {
my($this,$time) = @_;
$time = time if !$time;
my $gmt = gmtime($time);
$gmt =~ s/^([a-zA-Z]+)\s+([a-zA-Z]+)\s+([0-9]{1,2})\s+([0-9]{2}:[0-9]{2}:[0-9]{2})\s+([0-9]{4})/$1, $3 $2 $5 $4/;
return $gmt . ' GMT';
}

sub _init ($) {
my $this = shift;
}

sub _image_init ($) {
my($this,$item) = @_;
if (ref $item->{'image'}) {
	if ($item->{'image'}{'url'} && !ref $item->{'image'}{'value'} && !defined $item->{'image'}{'value'}{'url'}) {
		$item->{'image'}{'value'}{'url'} = $item->{'image'}{'url'};
	}
	if (!ref $item->{'image'}{'value'} || !defined $item->{'image'}{'value'}{'url'}) {
		undef $item->{'image'};
	} else {
		$item->{'image'}{'value'}{'link'} = $item->{'link'} if !defined $item->{'image'}{'value'}{'link'} || $item->{'image'}{'value'}{'link'} eq '';
		$item->{'image'}{'value'}{'title'} = $item->{'title'} if !defined $item->{'image'}{'value'}{'title'} || $item->{'image'}{'value'}{'title'} eq '';	
	}
}
}

sub push_rss_marker ($$$;$) {
my($this,$link,$rss_marker,$is_escaped) = @_;
$link = $this->unescape($link) if $is_escaped;
$link =~ s/[\?\&]utm_source=RSS\&utm_medium=[^\&#=]+//;
if ($rss_marker) {
	$rss_marker = (($link =~ /\?/) ? '&' : '?') . $rss_marker;
	$link .= $rss_marker unless $link =~ s/#/$rss_marker#/;
}
$link = $this->escape($link) if $is_escaped;
return $link;
}

sub update ($$;$) {
my($this,$item_ref,$keep_pubdate) = @_;
return 0 if !$this->{'path'};
my $item = {%$item_ref};

#ƥǤΥå
return 0 if !$item->{'link'} && !ref $item->{'delete'} && !ref $item->{'delete_prefix'};
my $rss_marker = ($this->{'rss_marker'}) ? 'utm_source=RSS&utm_medium=' . $this->url_encode(($this->{'utm_medium'}) ? $this->{'utm_medium'} : $cgi::Jcode->set($this->{'channel_element'}{'title'})->utf8) : '';
if ($item->{'link'}) {
	$item->{'description'} = $item->{'content:encoded'} if (!defined $item->{'description'} || $item->{'description'} eq '') && defined $item->{'content:encoded'} && $item->{'content:encoded'} ne '';
	if (!defined $item->{'title'} || $item->{'title'} eq '') {
		if ($item->{'description'}) {
			$item->{'title'} = $this->cut_string($this->detag_lite($item->{'description'}),32);
		} else {
			$item->{'title'} = $item->{'link'};
		}
	}
	$item->{'description'} = $item->{'title'} if !defined $item->{'description'} || $item->{'description'} eq '';
	if ($item->{'pubDate'} && $item->{'pubDate'} eq 'KEEP') {
		$keep_pubdate = 1;
		$item->{'pubDate'} = $this->{'gmt'};
	} elsif (!$item->{'pubDate'}) {
		$item->{'pubDate'} = $this->{'gmt'};
	}
	if (!defined $item->{'guid'} || $item->{'guid'} eq '' || (ref $item->{'guid'} && !$item->{'guid'}{'value'})) {
		$item->{'guid'} = {
			'isPermaLink'	=>	'true',
			'value'			=>	$item->{'link'},
		};
	} elsif (defined $item->{'guid'} && !ref $item->{'guid'} && $item->{'guid'} ne '') {
		$item->{'guid'} = {'value' => $item->{'guid'}};
	}
	if ($item->{'content:encoded'}) {
		$this->{'xmlns'}{'content'} = 'http://purl.org/rss/1.0/modules/content/' if !$this->{'xmlns'}{'content'};
		my $path = $item->{'guid'}{'value'};
		$path =~ s!^https?://[^/]+!!ig;
		$item->{'content:encoded'} =~ s/(<[^<>]*\s+(?:href|src|background|action)=["']?)(?!\w+:)([^"\s]+)([^<>]*>)/$1 . $this->full_path($this->path_change($2,$path,'abs')) . $3/seig;
		$item->{'content:encoded'} =~ s/(<param\s+name=["']?(?:src|movie)["']?\s+value=["']?)(?!\w+:)([^"\s]+)([^<>]*>)/$1 . $this->full_path($this->path_change($2,$path,'abs')) . $3/seig;
		$item->{'content:encoded'} =~ s/(<video(?!\w)[^<>]*\s+preview=["']?)(?!\w+:)([^"\s]+)([^<>]*>)/$1 . $this->full_path($this->path_change($2,$path,'abs')) . $3/seig;
	}
	if (defined $item->{'g:price'}) {
		$this->{'xmlns'}{'g'} = 'http://base.google.com/ns/1.0' if !$this->{'xmlns'}{'g'};
	}
	$item->{'description'} = $this->cut_string($this->detag_lite($item->{'description'}),$this->{'description_maxlength'});
	$item->{'link'} = $this->push_rss_marker($item->{'link'},$rss_marker) if $rss_marker;
	$this->_image_init($item);
	$this->_item_init($item);
} elsif (!-f $this->{'path'}) {
	return 0;
}

my @delete_prefix = (ref $item->{'delete_prefix'}) ? map(quotemeta($_),@{$item->{'delete_prefix'}}) : ();
my $temp_path = $this->{'path'} . '.tmp';
my $is_updated = 0;
local(*RSS,*TEMP);
if (open (TEMP, ">>$temp_path")) {
	binmode TEMP;
	flock(TEMP, LOCK_EX);
	truncate(TEMP, 0);
	seek(TEMP, 0, 0);
	print TEMP '<?xml version="1.0" encoding="UTF-8"?>',"\x0A";
	print TEMP '<rss version="2.0"';
	foreach my $xmlns (sort keys %{$this->{'xmlns'}}) {
		print TEMP ' xmlns:' . $xmlns . '="' . $this->{'xmlns'}{$xmlns} . '"';
	}
	print TEMP '>',"\x0A";
	print TEMP '<channel>',"\x0A";
	my %done = ();
	my $is_channel_element = 1;
	my $item_elements = '';
	my $item_counter = 0;
	print TEMP $this->_hash_to_xml($this->{'channel_element'},\%done,1);
	if (!-f $this->{'path'}) {
		print TEMP '<item>',"\x0A";
		print TEMP $this->_hash_to_xml($item);
		print TEMP '</item>',"\x0A";
		$is_updated = 1;
	} elsif (open(RSS, $this->{'path'})) {
		my $done = 0;
		binmode RSS;
		flock(RSS, LOCK_SH);
		ITEM:
		while (<RSS>) {
			my $line = $_;
			if ($item_counter >= $this->{'maxitem'}) {
				last ITEM;
			} elsif ($line =~ /<item>/ || $line =~ /<\/channel>/) {
				$done = 1 if !$keep_pubdate;
				if ($is_channel_element) {
					$is_channel_element = 0;
					if ($item->{'link'} && !$keep_pubdate && (!ref $item->{'delete'} || !grep($_ eq $item->{'guid'}{'value'},@{$item->{'delete'}})) && (!@delete_prefix || !grep($item->{'guid'}{'value'} =~ /^$_/,@delete_prefix))) {
						print TEMP '<item>',"\x0A";
						print TEMP $this->_hash_to_xml($item);
						print TEMP '</item>',"\x0A";
						$item_counter++;
						last ITEM if $line =~ /<\/channel>/;
					}
				}
				$item_elements = $line;
			} elsif ($line =~ m!</item>!) {
				$item_elements .= $line;
				if ($item_elements =~ /<guid(?!\w)[^>]*>(.*?)<\/guid>/) {
					my $guid = $this->unescape($1);
					if (defined $item->{'guid'} && ref $item->{'guid'} && defined $item->{'guid'}{'value'} && $item->{'guid'}{'value'} eq $guid) {
						if (!$done && $keep_pubdate && $item->{'link'}) {
							$item->{'pubDate'} = $this->unescape($1) if $item_elements =~ /<pubDate(?!\w)[^>]*>(.*?)<\/pubDate>/;
							print TEMP '<item>',"\x0A";
							print TEMP $this->_hash_to_xml($item);
							print TEMP '</item>',"\x0A";
							$item_counter++;
							$done = 1;
						}
					} elsif ((!ref $item->{'delete'} || !grep($_ eq $guid,@{$item->{'delete'}})) && (!@delete_prefix || !grep($guid =~ /^$_/,@delete_prefix))) {
						$item_elements =~ s/(<link(?!\w)[^>]*>)(.*?)(<\/link>)/$1 . $this->push_rss_marker($2,$rss_marker,1) . $3/ges;
						print TEMP $item_elements;
						$item_counter++;
					}
				}
				$item_elements = '';
			} elsif ($is_channel_element) {
				print TEMP $line if $line =~ /<([\w:]+)(?!\w)[^>]*>/ && !$done{$1} && $1 ne 'rss' && $1 ne 'channel';
			} elsif ($item_elements) {
				$item_elements .= $line;
			}
		}
		close(RSS);
		if (!$done && !$keep_pubdate) {
			print TEMP '<item>',"\x0A";
			print TEMP $this->_hash_to_xml($item);
			print TEMP '</item>',"\x0A";
		}
		$is_updated = 1;
	}
	print TEMP '</channel>',"\x0A";
	print TEMP '</rss>';
	close(TEMP);
	if ($is_updated) {
		rename($temp_path,$this->{'path'});
		chmod($env::file_mode, $this->{'path'});
	}
}
return $is_updated;
}

sub _hash_to_xml ($$;$$) {
my($this,$hash,$done,$oneline) = @_;
my $xml = '';
ELEMENT:
foreach my $key (sort keys %{$hash}) {
	next ELEMENT if $key eq 'delete';
	my $value = '';
	my $attribute = '';
	if (ref $hash->{$key}) {
		if (ref $hash->{$key} eq 'HASH' && %{$hash->{$key}}) {
			ATTRIBUTE:
			foreach my $k (sort keys %{$hash->{$key}}) {
				next ATTRIBUTE if !defined $hash->{$key}{$k} || $hash->{$key}{$k} eq '';
				if ($k eq 'value') {
					if (ref $hash->{$key}{$k} eq 'HASH') {
						$value = "\x0A" . $this->_hash_to_xml($hash->{$key}{$k});
						$value = $this->oneline($value) if $oneline;
					} else {
						$value = $cgi::Jcode->set(($key eq 'content:encoded') ? '<![CDATA[' . $this->oneline($hash->{$key}{$k}) . ']]>' : $this->detag($hash->{$key}{$k}))->utf8;
					}
				} else {
					$attribute .= ' ' . $k . '="' . $cgi::Jcode->set($this->detag($hash->{$key}{$k}))->utf8 . '"';
				}
			}
			$xml .= '<' . $key . $attribute . (($attribute && $value eq '') ? ' />' : '>' . $value . '</' . $key . '>') . "\x0A" if $attribute || $value ne '';
		}
	} else {
		$value = $hash->{$key} if defined $hash->{$key};
		$xml .= '<' . $key .  '>' . $cgi::Jcode->set(($key eq 'content:encoded') ? '<![CDATA[' . $this->oneline($value) . ']]>' : $this->detag($value))->utf8 . '</' . $key . '>' . "\x0A" if $value ne '';
	}
	$done->{$key} = 1 if ref $done;
}
return $xml;
}

sub _item_init ($$) {
my $this = shift;
}

sub detag ($$) {
my($this,$str) = @_;
$str =~ s/<(.*?)>/(($1 =~ m! alt="(.*?)"!i) ? $1 : '')/egs;
$str =~ s/&/&amp;/gs;
$str =~ s/"/&quot;/g;
$str =~ s/</&lt;/g;
$str =~ s/>/&gt;/g;
$str =~ s/[\x0D\x0A]+/ /gs;
return $str;
}

sub detag_lite ($$) {
my($this,$str) = @_;
$str =~ s/<(.*?)>/(($1 =~ m! alt="(.*?)"!i) ? $1 : '')/egs;
$str =~ s/[\x0D\x0A]+/ /gs;
return $str;
}

sub oneline ($$) {
my($this,$str) = @_;
$str =~ s/[\x0D\x0A]+/ /gs;
$str =~ s/<!--.*?-->//gs;
return $str;
}

sub escape ($$) {
my($this,$str) = @_;
$str =~ s/&/&amp;/gs;
$str =~ s/"/&quot;/g;
$str =~ s/</&lt;/g;
$str =~ s/>/&gt;/g;
return $str;
}

sub unescape ($$) {
my($this,$str) = @_;
$str =~ s/\&quot;/"/g;
$str =~ s/\&lt;/</g;
$str =~ s/\&gt;/>/g;
$str =~ s/\&amp;/&/gs;
return $str;
}


1;
