package Email;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# ե⥸塼ʥ᡼륢ɥ쥹
# Email.pm 1.1.4
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
#support@cmonos.jp
#http://cmonos.jp/
# ǽ2009-11-20
######################################################################
sub _set ($$) {
my($this,$setting) = @_;
unless (ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
$this->{'e-mail'} = 1;
$this->{'field_for'}{'mail_address'} = [] if !ref $this->{'field_for'}{'mail_address'};
push(@{$this->{'field_for'}{'mail_address'}},$this->{'id'});
return;
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
my($modifier,$p);
return 1 if !defined $main::search{$this->{'id'}}{'str'} || $main::search{$this->{'id'}}{'str'} eq '';
if (!ref $this->{'pattern'}) {
	$main::search{$this->{'id'}}{'str'} = $this->z_to_h($main::search{$this->{'id'}}{'str'});
	$this->mk_pattern;
}
$modifier = (defined $main::search{$this->{'id'}}{'i'} && $main::search{$this->{'id'}}{'i'}) ? '(?i)' : '';
foreach $p (@{$this->{'pattern'}}) {
	next if !defined $p || $p eq '';
	if (eval {$$str =~ /$modifier$p/}) {
		return 1 if !defined $main::search{$this->{'id'}}{'mode'} || $main::search{$this->{'id'}}{'mode'} ne 'and'
	} elsif (defined $main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'and') {
		return 0;
	}
}
if (defined $main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'and') {
	return 1;
} else {
	return 0;
}
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status) = @_;
my($name,$form,$event);

#̾˥ǡID
$name = 'data:' . $this->{'id'} . ':str';

#եɥ͡+إå
$form = $this->field_header($this->{'cols'},$name);

#å
$event .= ' onchange="cmonos.validate.field(this).asEMailAddress()"';
$event .= ' class="invalid-field"' if $this->{'is_invalid_field'}{'str'};

#ǥեȺ
if ((!defined $status || $status eq '') && (!defined $main::data{$this->{'id'}}{'str'} || $main::data{$this->{'id'}}{'str'} eq '')) {
	$main::data{$this->{'id'}}{'str'} = $this->{'default'};

	#­
	$main::data{$this->{'id'}}{'str'} = $main::email if defined $main::email && $main::email ne '' && $this->is_invalid_email_address_header($main::data{$this->{'id'}}{'str'});
}
$this->{'cols'} = 40 if !defined $this->{'cols'} || !$this->{'cols'};

#⤵1ʲξ
if (!defined $this->{'rows'} || $this->{'rows'} eq '' || $this->{'rows'} <= 1) {
	$main::data{$this->{'id'}}{'str'} =~ s/\x0A//gs if defined $main::data{$this->{'id'}}{'str'} && $main::data{$this->{'id'}}{'str'} ne '';
	$form .= '<input type="text" name="' . $name . '" id="' . $name . '" size="' . $this->{'cols'} . '"';
	$form .= ' value="' . $main::data{$this->{'id'}}{'str'} . '"' if defined $main::data{$this->{'id'}}{'str'} && $main::data{$this->{'id'}}{'str'} ne '';
	$form .= $event . ' />';

#⤵2ʾξ
} else {
	$form .= '<textarea name="' . $name . '" id="' . $name . '" cols="' . $this->{'cols'} . '" rows="' . $this->{'rows'} . '"' . $event . ' wrap="off">';
	$form .= $main::data{$this->{'id'}}{'str'} if defined $main::data{$this->{'id'}}{'str'} && $main::data{$this->{'id'}}{'str'} ne '';
	$form .= '</textarea>';
}

$form .= $this->field_footer;
return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my $this = shift;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
my($is_valid);
$this->escape_data_tag('str');

#ȾѴ
$main::data{$this->{'id'}}{'str'} = $this->z_to_h($main::data{$this->{'id'}}{'str'});

#ɬܹ/ʸå
$is_valid = $this->is_not_empty('str') && $this->is_not_too_long('str');

#񼰥å
if ($main::data{$this->{'id'}}{'str'} ne '' && $this->is_invalid_email_address_header($main::data{$this->{'id'}}{'str'})) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : '') . 'ǧƤ') if ref $cgi::action;
	$is_valid = 0;
}

if ($is_valid) {
	$cookie::data{'data:' . $this->{'id'} . ':str'} = $main::data{$this->{'id'}}{'str'} if $this->{'cookie'} && $main::set_cookie;
} else {
	$this->{'is_invalid_field'}{'str'} = 1;
}
return $is_valid;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return $this->field_tag('') if !defined $str || $str eq '';

if ($this->{'button'}) {
	$this->use_deco($cgi::output);
	my(@email,$email,$email_title);
	@email = $this->get_address($str);
	$email = join(',',@email);
	$email_title = ($this->{'addressProtector'}) ? (($default::english) ? 'E-Mail' : '᡼륽եȤ򳫤ޤ') : $this->address_camouflage($str);
	$email = $this->address_protector($email,$this->{'addressProtector'});
	return $this->field_tag(
		$this->data_tag_from_hash('str',$this->address_camouflage($str,$this->{'addressProtector'})) . 
		$cgi::Deco->button(
			'email',
			$this->{'button'},
			$email,
			$email_title
		)
	);

} else {
	$str =~ s/\x20+/ /g;
	$this->escape(\$str);
	$str =~ s/[\x0A\x0D]+/<br \/>/g;
	$this->autolink(\$str,0,$this->{'addressProtector'});
	return $this->field_tag($this->style($this->data_tag('str',$str),$this->{'style'},$this->{'fontsize'},$this->{'fontcolor'},$this->{'fontface'}));
}
}

sub format_for_mail {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return '' if !defined $str ||  $str eq '';
$str =~ s/,\s*/,\x0A/g if length $str > 70;
$str = '[' . $this->name . "]\x0A" . $str;
$str =~ s/[\x0A]*\Z/\x0A\x0A/s;
return $str;
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$) {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return '' if !defined $str || $str eq '';
$str =~ s/\x0A//g;
return $str;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled) = @_;

#̾
my $name = 'data:' . $this->{'id'};

$this->print_field_info_form($name);

print '<fieldset>';
print '<legend></legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_cols"></label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_cols" id="' . $name . '_cols" value="' . $this->escape($this->{'cols'}) . '" size="3" title="βꤷޤ" /> <span class="unit">ʸȾѡ</span></td>';
print '<td class="field-name"><label for="' . $name . '_rows">⤵</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_rows" id="' . $name . '_rows" value="' . $this->escape($this->{'rows'}) . '" size="3" title="ι⤵ꤷޤ" /> <span class="unit">ʸ</span></td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_default">ǥե</label></td>';
print '<td class="field" colspan="3"><textarea name="' . $name . '_default" id="' . $name . '_default" cols="56" rows="6" wrap="off" title="ΥǥեȤͤꤷޤ">' . $this->escape($this->{'default'}) . '</textarea></td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

if (!defined $html_disabled || !$html_disabled) {
	print '<fieldset><legend>᡼륢ɥ쥹ɽ</legend>';
	print '<fieldset><legend>ܥ</legend>';

	#ܥ˥塼
	print $cgi::Deco->button_menu(
		$name . '_button',
		'email',
		120,
		$this->{'button'}
	);
	print '<div class="note">꤬ʤ硢E-Mailɥ쥹ɽޤ</div></fieldset>';
	print '<fieldset><legend>᡼륢ɥ쥹ݸ</legend><label><input type="checkbox" name="' . $name . '_addressProtector" value="1"' . ((defined $this->{'addressProtector'} && $this->{'addressProtector'}) ? ' checked="checked"' : '') . ' /> ᡼륢ɥ쥹 JavaScript + CSS + HTML ƥƥݸ롣</label></fieldset>';
	print '</fieldset>';
	$this->print_font_setting_form($name);
}

$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;

#ʸå
my $is_valid = $this->is_valid_font_setting;

if ($main::data{$this->{'id'} . '_cols'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_cols'})) {
	push(@{$cgi::action->{'dialog'}},'򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_cols'};
	$is_valid = 0;
}
if ($main::data{$this->{'id'} . '_rows'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_rows'})) {
	push(@{$cgi::action->{'dialog'}},'⤵򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_rows'};
	$is_valid = 0;
}

$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
$main::data{$this->{'id'} . '_addressProtector'} = '' if !defined $main::data{$this->{'id'} . '_addressProtector'} || !$main::data{$this->{'id'} . '_addressProtector'};
return $is_valid;
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('text_email','Email','᡼륢ɥ쥹');
	$setting::deco_dir{'email'} = 'E᡼ܥ';
	$setting::deco_type{'email'} = 'button';
}

1;
