package SCPrice;
require CMONOS::CGI_Lib::Field::ShoppingCartBase;
@ISA = qw(ShoppingCartBase);
use strict;
######################################################################
# ե⥸塼ʲʡ
# SCPrice.pm 1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-06-14
######################################################################
sub _set ($$) {
my $this = shift;
return;
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
return (!$this->is_nan($main::search{$this->{'id'}}{'f'}) || !$this->is_nan($main::search{$this->{'id'}}{'t'})) ? 1 : 0;
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
return 1 if !$this->showcase_object_enabled;
return $this->{'showcase'}->price_is_matched($this,$str);
}

######################################################################
#	(2) obj->form;
sub input_enabled ($) {
my $this = shift;
return 0;
}

sub form {
my($this,$status,$original,$path) = @_;
return '';
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
my $this = shift;
return 1;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=ɽǡ/path=ե¸ǥ쥯ȥ
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
my(%data);
return $this->field_tag('') if !$this->showcase_object_enabled;
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
if (!$cgi::on_refreshing && %main::data && !defined $data{'price'}) {
	$data{'price'} = $main::data{$this->{'field_for'}->{'showcase'}}{'price'};
}
return $this->field_tag('') if !defined $data{'price'} || $data{'price'} eq '';
return $this->field_tag(
	$this->data_tag_from_hash('price',$data{'price'}) . 
	$this->style(
		$this->{'showcase'}->sc_price_tag($data{'price'},$this->{'showcase'}->{'monetaryunit'}),
		$this->{'style'},
		$this->{'fontsize'},
		$this->{'fontcolor'},
		$this->{'fontface'}
	)
);
}

sub has_content {
my($this,$str) = @_;
return 0 if !$this->showcase_object_enabled;
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
if (!$cgi::on_refreshing && %main::data && !defined $data{'price'}) {
	$data{'price'} = $main::data{$this->{'field_for'}->{'showcase'}}{'price'};
}
return (defined $data{'price'} && $data{'price'} ne '') ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
my($this,$str) = @_;
my(%data);
return '' if !$this->showcase_object_enabled;
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
$data{'price'} = $main::data{$this->{'field_for'}->{'showcase'}}{'price'} if !$cgi::on_refreshing && !defined $data{'price'};
return '' if !defined $data{'price'} ||  $data{'price'} eq '';
$str = $this->get_showcase_info(\%data);
$str = '[' . $this->name . "]\x0A" . $str;
$str =~ s/[\x0A]*\Z/\x0A\x0A/s;
return $str;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
my($this,$str) = @_;
my(%data);
return '' if !$this->showcase_object_enabled;
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
$data{'price'} = $main::data{$this->{'field_for'}->{'showcase'}}{'price'} if !$cgi::on_refreshing && !defined $data{'price'};
return '' if !defined $data{'price'} ||  $data{'price'} eq '';
return $this->get_showcase_info(\%data);
}

sub get_showcase_info($$) {
my($this,$data) = @_;
my $out;
$out .= $this->{'showcase'}->{'monetaryunit'} if $this->{'showcase'}->{'monetaryunit'} !~ /[\x80-\xff]/;
$out .= $this->digit($this->add_tax($data->{'price'}));
$out .= $this->{'showcase'}->{'monetaryunit'} if $this->{'showcase'}->{'monetaryunit'} =~ /[\x80-\xff]/;
$out .= $this->raw_price_info($data->{'price'},$this->{'showcase'}->{'monetaryunit'});
return $out;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my $this = shift;
my($name,$showcase_name);

#̾
$name = 'data:' . $this->{'id'};

if ($this->showcase_object_enabled) {
	$showcase_name = $this->{'showcase'}->name . '˽सޤ';
} else {
	$showcase_name = '֥åԥ󥰥ȡץեɤߤĤʤΤǤΥեɤϵǽޤ';
}

$this->print_field_info_form($name,1,$showcase_name);
$this->print_font_setting_form($name);
$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
return $this->is_valid_font_setting;
}

######################################################################
sub search_form_enabled ($) {
my $this = shift;
return $this->showcase_object_enabled;
}

#	(6) obj->search_form;
sub search_form ($) {
my $this = shift;
return '' if !$this->showcase_object_enabled;
my($form);
$form = '<tr><td class="field-name"><span class="datatitle">' . $this->{'name'} . '</span></td><td class="field">';
$form .= $this->{'showcase'}->search_form_for_price($this);
$form .= '</td></tr>';
return $form;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
my $this = shift;
return 1;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#sub import {
BEGIN {
if ($env::checkout && -e $env::checkout && !$setting::field_for_mail && (!defined $default::type || $default::type eq '')) {
	Field::class_register('ysc_price','SCPrice','');
}
}

1;
