package Tategaki;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# ե⥸塼ʽĽ񤭡
# Tategaki.pm 1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-04-27
######################################################################
sub __set ($$) {
my($this,$setting) = @_;
return;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return $this->field_tag($str) if !defined $str || $str eq '';

my($tate,$fontcolor,$id);
$id = ($this->{'toggle'}) ? 'tategaki' . $this->_mk_user_generated_field_id($c,$n) : '';
$fontcolor = $this->text_color(\$str);
$this->text_conv(\$str);
$this->text_fix(\$str,$this->{'csv'},((!$this->{'rows'} || $this->{'rows'} <= 1) ? 1 : 0)) if defined $str && $str;

require CMONOS::CGI_Lib::Taketori;
$tate = Taketori->new({
	'id'				=> $id,	
	'class'				=> 'tategaki',	
	'height'			=> $this->{'height'},						# ʹ⤵
	'fontsize'			=> $this->{'basesize'},						# եȥ
	'width'				=> $this->{'width'},						# ʲ
	'margin'			=> $this->{'margin'},						# Դֳ
	'colmargin'			=> $this->{'colmargin'},					# ʴֳ
	'blockenabled'		=> $this->{'blockenabled'},					# 뤹
	'rotatedisabled'	=> $this->{'rotatedisabled'},				# Ĺ򲣽Ĺβžɽ֡áפѤ
	'clear'				=> (($this->{'toggle'} || $this->{'clear'}) ? 1 : 0),						# ʸǲ߲
	'ltrnum'			=> $this->{'ltrnum'},						# ϲ񤭤ˤ
})->tategaki($str);

if ($this->{'toggle'}) {
	$tate .= $this->javascript('document.write(\'<ul class="panel tools"><li id="' . $id . '-tate"><a href="javascript:void(0)" onclick="cmonos.element.item(\\\'' . $id . '\\\',\\\'' . $id . '-tate\\\',\\\'' . $id . '-ltr\\\',\\\'' . $id . '-yoko\\\').toggle();">񤭤ɽ</a></li><li id="' . $id . '-yoko"><a href="javascript:void(0)" onclick="cmonos.element.item(\\\'' . $id . '\\\',\\\'' . $id . '-tate\\\',\\\'' . $id . '-ltr\\\',\\\'' . $id . '-yoko\\\').toggle();">Ľ񤭤ɽ</a></li></ul>\');');
	$tate .= $this->javascript('cmonos.element.item(\'' . $id . '-ltr\',\'' . $id . '-yoko\').disappear(true);');
}

return $this->field_tag(
	(($fontcolor) ? $this->data_tag_from_hash('fontcolor',$fontcolor) : '') . 
	$this->style(
		(($this->{'toggle'}) ? '<div id="' . $id . '-ltr" style="display: none">' . $this->data_tag('str',$str) . '</div>' : $this->data_tag_from_hash('str',$str)) . $tate,
		$this->{'style'},
		$this->{'fontsize'},
		(($fontcolor) ? $fontcolor : $this->{'fontcolor'}),
		$this->{'fontface'},
	)
);
}

######################################################################
#	(5) obj->print_setting_form;
sub print_sub_setting_form ($$) {
my($this,$name) = @_;

print '<fieldset>';
print '<legend>Ľ</legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_height">ʹ⤵</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_height" id="' . $name . '_height" value="' . $this->escape($this->{'height'}) . '" size="3" /> <span class="unit">px</span></td>';
print '<td class="field-name"><label for="' . $name . '_basesize">ʸ礭</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_basesize" id="' . $name . '_basesize" value="' . $this->escape($this->{'basesize'}) . '" size="3" /> <span class="unit">px</span></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_margin">Դֳ</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_margin" id="' . $name . '_margin" value="' . $this->escape($this->{'margin'}) . '" size="3" /> <span class="unit">px</span></td>';
print '<td class="field-name"><label for="' . $name . '_colmargin">ʴֳ</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_colmargin" id="' . $name . '_colmargin" value="' . $this->escape($this->{'colmargin'}) . '" size="3" /> <span class="unit">px</span></td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_width">ʲ</label></td>';
print '<td class="field" colspan="3"><input type="text" name="' . $name . '_width" id="' . $name . '_width" value="' . $this->escape($this->{'width'}) . '" size="3" /> <span class="unit">px</span></td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">Ľ񤭥ץ</span></td>';
print '<td class="field" colspan="3">';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_rotatedisabled" value="1" ' . ((defined $this->{'rotatedisabled'} && $this->{'rotatedisabled'}) ? ' checked="checked"' : '') . ' /> Ĺ򲣽Ĺβžɽ֡áפѤ</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_ltrnum" value="1" ' . ((defined $this->{'ltrnum'} && $this->{'ltrnum'}) ? ' checked="checked"' : '') . ' /> ϲ񤭤ˤ</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_clear" value="1" ' . ((defined $this->{'clear'} && $this->{'clear'}) ? ' checked="checked"' : '') . ' /> ʸǲߤ</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_toggle" value="1" ' . ((defined $this->{'toggle'} && $this->{'toggle'}) ? ' checked="checked"' : '') . ' /> ɽڤؤǽˤ</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_blockenabled" value="1" ' . ((defined $this->{'blockenabled'} && $this->{'blockenabled'}) ? ' checked="checked"' : '') . ' /> ٤ƤΥ֥åǤݻ(֥åǤȤ˲ʤޤ)</label></li>';
print '</ol>';
print '</td>';
print '</tr>';
print '</tbody>';
print '</table>';
print '</fieldset>';
}

sub html_editor_panel_type ($) {
my $this = shift;
return ($this->{'nostyle'}) ? 'nostylemini' : 'mini';
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_sub_setting ($) {
my $this = shift;
my $is_valid = 1;

#åܥå
$main::data{$this->{'id'} . '_ltrnum'} = '' if !defined $main::data{$this->{'id'} . '_ltrnum'} || !$main::data{$this->{'id'} . '_ltrnum'};
$main::data{$this->{'id'} . '_clear'} = '' if !defined $main::data{$this->{'id'} . '_clear'} || !$main::data{$this->{'id'} . '_clear'};
$main::data{$this->{'id'} . '_toggle'} = '' if !defined $main::data{$this->{'id'} . '_toggle'} || !$main::data{$this->{'id'} . '_toggle'};
$main::data{$this->{'id'} . '_rotatedisabled'} = '' if !defined $main::data{$this->{'id'} . '_rotatedisabled'} || !$main::data{$this->{'id'} . '_rotatedisabled'};
$main::data{$this->{'id'} . '_blockenabled'} = '' if !defined $main::data{$this->{'id'} . '_blockenabled'} || !$main::data{$this->{'id'} . '_blockenabled'};

#
if (defined $main::data{$this->{'id'} . '_basesize'} && $main::data{$this->{'id'} . '_basesize'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_basesize'})) {
	push(@{$cgi::action->{'dialog'}},'ʸ礭򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_basesize'};
	$is_valid = 0;
}
if (defined $main::data{$this->{'id'} . '_margin'} && $main::data{$this->{'id'} . '_margin'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_margin'})) {
	push(@{$cgi::action->{'dialog'}},'Դֳ֤򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_margin'};
	$is_valid = 0;
}
if (defined $main::data{$this->{'id'} . '_height'} && $main::data{$this->{'id'} . '_height'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_height'})) {
	push(@{$cgi::action->{'dialog'}},'ʹ⤵򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_height'};
	$is_valid = 0;
}
if (defined $main::data{$this->{'id'} . '_colmargin'} && $main::data{$this->{'id'} . '_colmargin'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_colmargin'})) {
	push(@{$cgi::action->{'dialog'}},'ʴֳ֤򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_colmargin'};
	$is_valid = 0;
}
if (defined $main::data{$this->{'id'} . '_width'} && $main::data{$this->{'id'} . '_width'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_width'})) {
	push(@{$cgi::action->{'dialog'}},'򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_width'};
	$is_valid = 0;
}

return $is_valid;
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('text_0_tategaki','Tategaki','Ľ') if !$setting::field_for_mail;
}

1;
