package Url;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# ե⥸塼URL
# Url.pm 1.1.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-03-24
######################################################################
sub _set ($$) {
my($this,$setting) = @_;
unless (ref $cgi::Image) {
	require CMONOS::CGI_Lib::Image;
	$cgi::Image = Image->new;
}
unless (ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
return;
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
my($modifier,$p);
return 1 if !defined $main::search{$this->{'id'}}{'str'} || $main::search{$this->{'id'}}{'str'} eq '';
if (!ref $this->{'pattern'}) {
	$main::search{$this->{'id'}}{'str'} = $this->z_to_h($main::search{$this->{'id'}}{'str'});
	$this->mk_pattern;
}
$modifier = (defined $main::search{$this->{'id'}}{'i'} && $main::search{$this->{'id'}}{'i'}) ? '(?i)' : '';
foreach $p (@{$this->{'pattern'}}) {
	next if $p eq '';
	if (eval{$$str =~ /$modifier$p/}) {
		return 1 if !defined $main::search{$this->{'id'}}{'mode'} || $main::search{$this->{'id'}}{'mode'} ne 'and'
	} elsif (defined $main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'and') {
		return 0;
	}
}
if (defined $main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'and') {
	return 1;
} else {
	return 0;
}
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status) = @_;
my($name,$form);

#̾˥ǡID
$name = 'data:' . $this->{'id'} . ':str';

#եɥ͡+إå
$form = $this->field_header('50',$name);

#ǥեȺ
$main::data{$this->{'id'}}{'str'} = $this->{'default'} if (!defined $status || $status eq '') && (!defined $main::data{$this->{'id'}}{'str'} || $main::data{$this->{'id'}}{'str'} eq '');

$form .= '<input type="text" id="' . $name . '" name="' . $name . '" size="40"';
$form .= ' value="' . $this->escape($main::data{$this->{'id'}}{'str'}) . '"' if defined $main::data{$this->{'id'}}{'str'} && $main::data{$this->{'id'}}{'str'};
$form .= ' class="invalid-field"' if $this->{'is_invalid_field'}{'str'};
$form .= ' onchange="cmonos.validate.field(this).asUrl();" />';

$form .= $this->field_footer;
return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my $this = shift;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
my($is_valid);

$this->escape_data_tag('str');

#ȾѴ
$main::data{$this->{'id'}}{'str'} = $this->z_to_h($main::data{$this->{'id'}}{'str'});
$main::data{$this->{'id'}}{'str'} =~ s/\x0A//gs;

#ɬܹ/ʸå
$is_valid = 1;
$is_valid = 0 unless $this->is_not_empty('str') && $this->is_not_too_long('str');

#񼰥å
if ($main::data{$this->{'id'}}{'str'} ne '' && $this->is_invalid_url($main::data{$this->{'id'}}{'str'})) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : '') . 'ǧƤURLǤϤޤ') if ref $cgi::action;
	$is_valid = 0;
}

#ե륿Υå
if ($this->{'extfilter'} && defined $main::data{$this->{'id'}}{'str'} && $main::data{$this->{'id'}}{'str'} ne '') {
	my @ext_filter = split(/,/,$this->{'extfilter'});
	@ext_filter = grep($_ ne '',@ext_filter);
	my $ext;
	my $matched = 0;
	foreach $ext (@ext_filter) {
		if ($main::data{$this->{'id'}}{'str'} =~ /\.$ext$/i) {
			if (!$this->{'extmatched'}) {
				push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'}) ? $this->{'name'} : '') . 'ǧƤػߤ줿եǤ') if ref $cgi::action;
				$is_valid = 0;
				last;
			}
			$matched = 1;
		}
	}
	if (!$matched && $this->{'extmatched'}) {
		push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'}) ? $this->{'name'} : '') . 'ǧƤػߤ줿եǤ') if ref $cgi::action;
		$is_valid = 0;
	}
}

if ($is_valid) {
	$cookie::data{'data:' . $this->{'id'} . ':str'} = $main::data{$this->{'id'}}{'str'} if $this->{'cookie'} && $main::set_cookie;
} else {
	$this->{'is_invalid_field'}{'str'} = 1;
}
return $is_valid;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return $this->field_tag($str) if !defined $str || $str eq '';
my $title = $str;
my $fetched = 0;
if ($this->{'getTitle'}) {
	require CMONOS::CGI_Lib::HTTP_Client;
	my $res = HTTP_Client->new->request('GET' => $str,{},'','',4096);
	if ($res->is_success) {
		my $content = $res->content('euc');
		if ($content && ($content =~ m/<title(?!\w)[^>]*>(.*?)<\/title(?!\w)[^>]*>/si || $content =~ m/<h[1-6](?!\w)[^>]*>(.*?)<\/h[1-6]>/si)) {
			$title = $this->unescape($1);
			$fetched = 1;
		}
	}
}
if ($this->{'apiurl'}) {
	my $thumnail = $this->get_website_thumnail_url($this->{'apiurl'},$str);
	if ($thumnail) {
		return $this->field_tag(
			$this->data_tag_from_hash('str',$str) . 
			'<a href="' . $str . '" target="_blank"' .
			' title="' . $this->escape_without_html_entity($title) . '"' .
		 	(($this->{'nofollow'}) ? ' rel="nofollow"' : '') .
			'>' . $cgi::Image->image_tag(
				$thumnail,
				$this->{'previewwidth'},
				$this->{'previewheight'},
				0
			) . '</a>'
		);
	}
}
if ($this->{'button'}) {
	$this->use_deco($cgi::output);
	return $this->field_tag(
		$this->data_tag_from_hash('str',$str) . 
		$cgi::Deco->button(
			'jump',
			$this->{'button'},
			$str,
			$title,
			'_blank',
			(($this->{'nofollow'}) ? {'rel' => 'nofollow'} : '')
		)
	);

} else {
	return $this->field_tag(
		(($fetched) ? $this->data_tag_from_hash('str',$str) : '') . 
		$this->style(
			'<a href="' . $this->escape_without_html_entity($str) . '" title="' . $this->escape_without_html_entity($title) . '" target="_blank"' . (($this->{'nofollow'}) ? ' rel="nofollow"' : '') . '>' . ((!$fetched) ? $this->data_tag('str',$str) : $this->escape_without_html_entity($title)) . '</a>',
			$this->{'style'},
			$this->{'fontsize'},
			$this->{'fontcolor'},
			$this->{'fontface'}
		)
	);
}
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$) {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return '' if !defined $str || $str eq '';
$str =~ s/\x0A//g;
return $str;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled) = @_;

#̾
my $name = 'data:' . $this->{'id'};

$this->{'default'} =~ s/\x0A//sg if $this->{'default'};
$this->print_field_info_form($name);

print '<fieldset>';
print '<legend><label for="' . $name . '_default">ǥե</label></legend>';
print '<input type="text" name="' . $name . '_default" id="' . $name . '_default" value="' . $this->escape($this->{'default'}) . '" size="50" title="ΥǥեȤͤꤷޤ" />';
print '</fieldset>';
print '<fieldset>';
print '<legend><label for="' . $name . '_extfilter">ĥҥե륿</label></legend>';
print '<input type="text" name="' . $name . '_extfilter" id="' . $name . '_extfilter" value="' . ((defined $this->{'extfilter'}) ? $this->escape($this->{'extfilter'}) : 'exe,app,scr,pif,bat,com,cmd') . '" size="50" title="ĥҤǥե륿󥰤ޤ" />';
print ' <span class="note">(ĥҤȤ˥ޤǶڤޤ)</note>';
print '<fieldset>';
print '<legend></legend>';
print '<ol class="checkbox">';
print '<li><label><input type="radio" name="' . $name . '_extmatched" value="1"' . (($this->{'extmatched'}) ? ' checked="checked"' : '') . ' /> ĥҤפȤϿĤ롣</label></li>';
print '<li><label><input type="radio" name="' . $name . '_extmatched" value="0"' . ((!$this->{'extmatched'}) ? ' checked="checked"' : '') . ' /> ĥҤפʤȤϿĤ롣</label></li>';
print '</ol>';
print '</fieldset>';
print '</fieldset>';
if (!defined $html_disabled || !$html_disabled) {

	print '<fieldset>';
	print '<legend></legend>';
	print '<ol class="checkbox">';
	print '<li><label><input type="checkbox" name="' . $name . '_nofollow" id="' . $name . '_nofollow" value="1"' . ((defined $this->{'nofollow'} && $this->{'nofollow'}) ? ' checked="checked"' : '') . ' /> 򸡺󥸥̵뤵</label></li>';
	print '<li><label><input type="checkbox" name="' . $name . '_getTitle" value="1"' . ((defined $this->{'getTitle'} && $this->{'getTitle'}) ? ' checked="checked"' : '') . ' /> ڡȥ' . (($default::static) ? '' : '侩') . '</label></li>';
	print '</ol>';
	print '</fieldset>';

	#ܥ˥塼
	print '<fieldset><legend title="꤬ʤ硢URLɽޤ">ܥ</legend>';
	print $cgi::Deco->button_menu(
		$name . '_button',
		'jump',
		120,
		$this->{'button'}
	);
	print '</fieldset>';

	print '<fieldset>';
	print '<legend>֥ڡͥ벽ӥ API</legend>';
	print '<fieldset>';
	print '<legend><label for="' . $name . '_apiurl">API URL</label></legend>';
	print '<input type="text" name="' . $name . '_apiurl" id="' . $name . '_apiurl" value="' . $this->escape($this->{'apiurl'}) . '" size="72" />';
	print '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'', $name, '_apiurl\').textByMenu(this)">';
	print '<option value="">ʥӥ</option>';
	print '<option value="http://img.simpleapi.net/small/%u">SimpleAPI</option>';
	print '<option value="http://mozshot.nemui.org/shot?%u">Mozshot</option>';
	print '<option value="http://thumbs.bookmacro.com/u/%u">ͥAPI</option>';
	print '<option value="http://capture.heartrails.com/medium?%u">HeartRails Capture</option>';
	print '<option value="http://x-row.cc/igwebcap/jpeg.php?width=160&amp;height=120&amp;wait=5&amp;url=%u">IgWebCap</option>';
	print '<option value="http://images.websnapr.com/?url=%u&amp;size=s">WebSnapr</option>';
	print '</select><div class="note">URL  %u Ȥޤ</div>';
	print '</fieldset>';
	print '<fieldset>';
	print '<legend>ͥ륵</legend>';
	print '<label> <input type="text" name="' . $name . '_previewwidth" id="' . $name . '_previewwidth" value="' . $this->escape($this->{'previewwidth'}) . '" size="4" /> <span class="unit">ԥ</span></label> &times <label>⤵ <input type="text" name="' . $name . '_previewheight" id="' . $name . '_previewheight" value="' . $this->escape($this->{'previewheight'}) . '" size="4" /> <span class="unit">ԥ</span></label>';
	print '</fieldset>';
	print '</fieldset>';

	#ʸ
	$this->print_font_setting_form($name);
}
$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my $is_valid = 1;

#ν
if (defined $main::data{$this->{'id'} . '_default'} && $main::data{$this->{'id'} . '_default'}) {
	$main::data{$this->{'id'} . '_default'} =~ s/[\x0A\x0D]//sg;
	$this->detag(\$main::data{$this->{'id'} . '_default'});
}

$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
if ($main::data{$this->{'id'} . '_extfilter'}) {
	$main::data{$this->{'id'} . '_extfilter'} = $this->z_to_h($main::data{$this->{'id'} . '_extfilter'});
	$main::data{$this->{'id'} . '_extfilter'} =~ s/[^a-zA-Z0-9,]/,/g;
	$main::data{$this->{'id'} . '_extfilter'} =~ s/,+/,/g;
	$main::data{$this->{'id'} . '_extfilter'} =~ s/^,//;
	$main::data{$this->{'id'} . '_extfilter'} =~ s/,$//;
}
$main::data{$this->{'id'} . '_nofollow'} = '' if !defined $main::data{$this->{'id'} . '_nofollow'} || !$main::data{$this->{'id'} . '_nofollow'};
$main::data{$this->{'id'} . '_getTitle'} = '' if !defined $main::data{$this->{'id'} . '_getTitle'} || $main::data{$this->{'id'} . '_getTitle'} eq '';
if (defined $main::data{$this->{'id'} . '_apiurl'} && $main::data{$this->{'id'} . '_apiurl'} ne '' && $this->is_invalid_url($main::data{$this->{'id'} . '_apiurl'})) {
	push(@{$cgi::action->{'dialog'}},'ͥ벽 API URLǧƤ') if ref $cgi::action;
	$is_valid = 0;
	delete $main::data{$this->{'id'} . '_apiurl'};
}
if (defined $main::data{$this->{'id'} . '_previewwidth'} && $main::data{$this->{'id'} . '_previewwidth'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_previewwidth'})) {
	push(@{$cgi::action->{'dialog'}},'ͥ벣򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_previewwidth'};
	$is_valid = 0;
}
if (defined $main::data{$this->{'id'} . '_previewheight'} && $main::data{$this->{'id'} . '_previewheight'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_previewheight'})) {
	push(@{$cgi::action->{'dialog'}},'ͥ⤵򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_previewheight'};
	$is_valid = 0;
}
if ($main::data{$this->{'id'} . '_apiurl'} && !$main::data{$this->{'id'} . '_previewwidth'}) {
	my $thumnail = $this->get_website_thumnail_url($main::data{$this->{'id'} . '_apiurl'},'http://www.google.com/');
	if ($thumnail) {
		require CMONOS::CGI_Lib::HTTP_Client;
		my $res = HTTP_Client->new->request('GET' => $thumnail);
		if ($res->is_success) {
			my $content = $res->content;
			($main::data{$this->{'id'} . '_previewwidth'},$main::data{$this->{'id'} . '_previewheight'}) = $cgi::Image->info(\$content);
		}
	}
}
$is_valid = 0 if !$this->is_valid_font_setting;
return $is_valid;
}

sub get_website_thumnail_url ($$$) {
my($this,$api,$url) = @_;
$url = $this->url_encode($url) if $url && $api =~ /\?/ && $api =~ /=/;
return ($url && $api =~ s/\%u/$url/g) ? $api : '';
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('text_url','Url','URL');
	$setting::deco_dir{'jump'} = 'ץܥ';
	$setting::deco_type{'jump'} = 'button';
}

1;
