package Trackback;
use strict;
######################################################################
# Trackback ⥸塼
# CMONOS::CGI_Lib::Ping::Trackback.pm ver1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-06-08
######################################################################
# Ȥ
# require CMONOS::CGI_Lib::Ping::Trackback;
# $trackback = Trackback->new(
#	'ping_url'				=>	Trackback  URL,
#	'title'					=>	Υȥ,
#	'excerpt'				=>	,
#	'url'					=>	URL,
#	'trackback'				=>	 Trackback Ping URL,
#	'blog_name'				=>	֥ȥ,
# );
#
# RDF
# $trackback->rdf;
# 
######################################################################
# ֥Ȥ롣
sub new ($;@) {
my $pkg = shift;
my $this = {@_};
bless $this;
return $this;
}

sub set ($;@) {
my $this = shift;
$this = {@_};
return $this;
}

sub ping_url ($) {
my $this = shift;
return ($this->{'ping_url'}) ? $this->unescape($this->{'ping_url'}) : '';
}

sub url ($) {
my $this = shift;
return ($this->{'url'}) ? $this->unescape($this->{'url'}) : '';
}

sub excerpt ($) {
my $this = shift;
return ($this->{'excerpt'}) ? $this->unescape($this->{'excerpt'}) : '';
}

sub blog_name ($) {
my $this = shift;
return ($this->{'blog_name'}) ? $this->unescape($this->{'blog_name'}) : '';
}

sub title ($) {
my $this = shift;
return ($this->{'title'}) ? $this->unescape($this->{'title'}) : '';
}

sub trackback ($) {
my $this = shift;
return ($this->{'trackback'}) ? $this->unescape($this->{'trackback'}) : '';
}

sub error ($) {
my $this = shift;
return ($this->{'error'}) ? $this->{'error'} : 0;
}

sub message ($) {
my $this = shift;
return ($this->{'message'}) ? $this->unescape($this->{'message'}) : '';
}

sub ptime ($) {
my $this = shift;
return ($this->{'ptime'}) ? $this->{'ptime'} : '';
}

sub sender ($) {
my $this = shift;
return ($this->{'sender'}) ? $this->{'sender'} : $this;
}

sub hash ($;$) {
my($this,$sender_result) = @_;
my $result = ($sender_result && ref $this->{'sender'}) ? $this->{'sender'} : $this;
return (
	'title'		=>	$this->title,
	'excerpt'	=>	$this->excerpt,
	'url'		=>	$this->url,
	'trackback'	=>	$this->trackback,
	'blog_name'	=>	$this->blog_name,

	'ping_url'	=>	$result->ping_url,
	'error'		=>	$result->error,
	'message'	=>	$result->message,
	'ptime'		=>	$result->ptime,
);
}

sub hash_ref ($;$) {
my($this,$sender_result) = @_;
return {$this->hash($sender_result)};
}

sub rdf ($) {
my $this = shift;
return '' if !$this->{'url'};
my $rdf = '<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"' . "\x0A";
$rdf .= '         xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/"' . "\x0A" if $this->{'trackback'};
$rdf .= '         xmlns:dc="http://purl.org/dc/elements/1.1/">' . "\x0A";
$rdf .= '<rdf:Description' . "\x0A";
$rdf .= '    rdf:about="' . $this->escape($this->url) . '"' . "\x0A";
$rdf .= '    trackback:ping="' . $this->escape($this->trackback) . '"' . "\x0A" if $this->{'trackback'};
$rdf .= '    dc:title="' . $this->escape($this->title) . '"' . "\x0A" if defined $this->{'title'} && $this->{'title'} ne '';
$rdf .= '    dc:identifier="' . $this->escape($this->url) . '"' . "\x0A";
$rdf .= '    dc:description="' . $this->escape($this->excerpt) . '"' . "\x0A" if defined $this->{'excerpt'} && $this->{'excerpt'} ne '';
$rdf .= '/>' . "\x0A";
$rdf .= '</rdf:RDF>' . "\x0A";
return $rdf;
}

# url ؤΥ󥯤뤫ɤĴ٤
sub linked ($;$$) {
my($this,$url,$loosely) = @_;
return 0 if !$this->{'url'};
$url =~ s/[\?#].*?$// if $loosely;
require CMONOS::CGI_Lib::HTTP_Client;
my $res = HTTP_Client->new->request('GET' => $this->url,{'Accept' => 'text/html'});
return ($res->is_success && $res->content_type eq 'text/html' && ${$res->content_ref} =~ /\Q$url\E/) ? 1 : 0;
}

# ping url ̤ξ硢url  RDF  ping url 
sub get ($) {
my $this = shift;
if ($this->{'url'} && !$this->{'trackback'}) {
	if (!ref $cgi::Jcode) {
		use Jcode;
		$Jcode::FALLBACK = &Jcode::FB_XMLCREF if defined $Jcode::FALLBACK;
		$cgi::Jcode = Jcode->new;
	}
	require CMONOS::CGI_Lib::HTTP_Client;
	my $res = HTTP_Client->new->request('GET' => $this->url,{'Accept' => 'text/html'});
	if ($res->is_success && $res->content_type eq 'text/html') {
		my $content_ref = $res->content_ref;
		while ($$content_ref =~ /<rdf:Description(?!\w)([^>]*?)\/>/g) {
			my($data,$url);
			$data = $cgi::Jcode->set($1)->euc;
			$url = $1 if $data =~ /\s+rdf:about="(.*?)"/is || $data =~ /\s+dc:identifier="(.*?)"/is;
			if ($url eq $this->{'url'}) {
				$this->{'trackback'} = $this->unescape($1) if $data =~ /\s+trackback:ping="(.*?)"/is;
				$this->{'title'} = $this->unescape($1) if $data =~ /\s+dc:title="(.*?)"/is;
				$this->{'excerpt'} = $this->unescape($1) if $data =~ /\s+dc:description="(.*?)"/is;
				last;
			}
		}
	}
}
return $this;
}

# ping 
sub ping ($) {
my $this = shift;
if (!$this->{'ping_url'}) {
	$this->{'message'} = 'ȥåХå URL ߤĤޤǤ';
	return $this
}
require CMONOS::CGI_Lib::HTTP_Client;
my $res = HTTP_Client->new->request(
	'POST' => $this->ping_url,
	{
		'Accept'	=> '*/*',
	},
	{
		'title'		=>	$this->title,
		'excerpt'	=>	$this->excerpt,
		'url'		=>	$this->url,
		'blog_name'	=>	$this->blog_name,
	},
	'utf8'
);
if ($res->is_success) {
	my $hash = $res->hash('euc');
	if (defined $hash->{'response'}->{'error'}) {
		$this->{'error'} = $hash->{'response'}->{'error'};
		$this->{'message'} = $hash->{'response'}->{'message'} if defined $hash->{'response'}->{'message'};
		$this->{'ptime'} = time;
		return $this;
	} else {
		$this->{'error'} = 1;
		$this->{'message'} = '';
	}
} else {
	$this->{'error'} = 1;
	$this->{'message'} = $res->message;
}
if (!ref $this->{'sender'} && !ref $this->{'receiver'}) {
	$this->{'receiver'} = Trackback->new('sender' => $this,'url' => $this->ping_url)->get;
	if ($this->{'receiver'}->trackback) {
		$this->{'ping_url'} = $this->{'receiver'}->trackback;
		$this->ping;
	} else {
		$this->{'message'} = 'ȥåХå URL ޤ';
		delete $this->{'receiver'};
	}
}
return $this;
}

sub receiver ($) {
my $this = shift;
return (ref $this->{'receiver'}) ? $this->{'receiver'} : Trackback->new('sender' => $this,'trackback' => $this->ping_url);
}

sub escape ($$) {
my($this,$str) = @_;
$str =~ s/\&(?!(?:#\d{2,6}|#x[a-fA-F0-9]+|[a-zA-Z0-9]{2,10});)/\&amp;/g;
$str =~ s/"/\&quot;/g;
$str =~ s/</\&lt;/g;
$str =~ s/>/\&gt;/g;
$str =~ s/\s+/ /sg;
return $str;
}

sub unescape ($$) {
my($this,$str) = @_;
$str =~ s/\&quot;/"/g;
$str =~ s/\&lt;/</g;
$str =~ s/\&gt;/>/g;
$str =~ s/\&amp;/&/g;
$str =~ s/\s+/ /sg;
return $str;
}

1;
