package UserAgent;
use strict;
######################################################################
# 桼ĶϤ⥸塼
# UserAgent.pm ver1.1.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-05-23
######################################################################
# Ȥ
# use UserAgent;
# obj = UserAgent->new
# (platform,platform_ver,browser,browser_ver,limitsize,device,language)
#	= obj->get_user_agent_info($ENV{'HTTP_USER_AGENT'});
#
#	platform			ץåȥե
#	platform_ver		OSС
#	browser				֥饦
#	browser_ver			֥饦С
#	limitsize			¾
#	device				ӵ̾
#	language			
######################################################################
# ֥Ȥ롣
sub new ($) {
my $pkg = shift;
my $this = {};
bless $this;
$this;
}

# 桼Ķ
sub get_user_agent_info ($;$) {
my($this,$user_agent) = @_;
my($ua,$platform,$platform_ver,$browser,$browser_ver,$limitsize,$device,$lang);
$user_agent = $ENV{'HTTP_USER_AGENT'} if !defined $user_agent || $user_agent eq '';
$ua = $user_agent;

# 
$lang = $1 if $user_agent =~ s/\[(.*?)\]/ /s;

# Google Wireless Transcoder
if ($user_agent =~ /Google Wireless Transcoder/) {
	$browser = 'Google Wireless Transcoder';
	$browser_ver = $1 if $user_agent =~ /Version\/([0-9\.abr]+)/;
	$platform = '';
	$platform_ver = $device = 'Google Х븡';

# Google Web Preview
} elsif ($user_agent =~ /Google Web Preview/) {
	$platform = 'ܥå';
	$platform_ver = 'Google Web Preview';

# ܥå
} elsif ($user_agent =~ s!\s*\(([^\(\)]*?https?://[^\(\)]*?)\)!!i) {
	my(@info,$url);

	# ץåȥե
	@info = split(/;\s*\+?/,$1);
	foreach my $data (@info) {
		if ($data =~ m!https?://!) {
			$url = $data;
		} elsif (!$platform_ver) {
			if ($data =~ m!^([^\/]+)/[0-9\.abr]+!) {
				$platform_ver = $1;
			} elsif ($data =~ m!/!) {
				$platform_ver = $data;
			}
		}
	}
	$platform = 'ܥå';
	$platform_ver = $1 if !$platform_ver && $user_agent =~ s/^([^\/]+)\/([0-9\.abr]+[N]?)\s*//;

# PC
} elsif ($user_agent =~ s/\s*\((.*?)\)//) {
	my(@info,$engine,$engine_ver,$option);

	# ץåȥե
	@info = split(/;\s*/,$1);

	# Mozilla
	($engine,$engine_ver) = ($user_agent =~ s/^([^\/]+)\/([0-9\.abr]+[N]?)\s*//) ? ($1,$2) : ('','');

	# Mozillaߴ
	if ($engine eq 'Mozilla') {

		# MSIE
		if (defined $info[0] && $info[0] eq 'compatible') {
			($browser,$browser_ver) = (defined $info[1] && $info[1] =~ s/^([^\/\s]+)([\s\/]|\s*Ver\s*)([0-9\.abr]+)\s*//i) ? ($1,$3) : ('','');
			$browser = 'InternetExplorer' if $browser eq 'MSIE';

			$platform_ver = (defined $info[2]) ? $info[2] : '';
			$platform_ver = 'Windows Me' if defined $info[3] && $platform_ver eq 'Windows 98' && $info[3] =~ /Win 9x/;
			
			if ($platform_ver =~ /^Win/i) {
				$platform = 'Windows';
			} elsif ($platform_ver =~ /^X\d+$/i || $platform_ver eq 'FreeBSD') {
				$platform = 'UNIX';
			} elsif ($browser =~ /DreamPassport/i) {
				$platform = 'Dreamcast';
			} elsif (grep($_ =~ /Mac\s*OS\s*X/i,@info)){
				$platform = 'Macintosh';
				$platform_ver = 'MacOS X';
			}

			# Opera
			if ($user_agent =~ s/\s*Opera\s*([0-9\.abr]+)//) {
				$browser_ver = $1;
				$browser_ver = $1 if $user_agent =~ s/\s*Version\/([0-9\.abr]+)//;
				$browser = 'Opera';
				($platform,$platform_ver,$device) = ($1,$2,$2.'/'.$3) if defined $info[2] && $info[2] =~ m!^([^/]+)/([^/]+)/([0-9\.abr]+)!;
			}

		# Mozilla
		} elsif (grep($_ =~ /^[NIU]$/,@info) || $user_agent =~ /\s*Gecko\/?[0-9\.abr]*/) {
			if ($user_agent =~ s/\s*AppleWebKit\/([0-9\.abr]+)//) {
				$browser = 'AppleWebKit';
				$browser_ver = $1;
				$user_agent =~ s/\s*Mobile\/\S+//;
				if ($user_agent =~ s/\s*([a-zA-Z]+)[0-9\.abr]*\/([0-9\.abr]+)//) {
					$browser = $1;
					$browser_ver = $2;
					if ($browser eq 'Version' && $user_agent =~ s/\s*([a-zA-Z]+)[0-9\.abr]*\/[0-9\.abr]+//) {
						$browser = $1;
						if ($user_agent =~ s/\s*([a-zA-Z]+)[0-9\.abr]*\/([0-9\.abr]+)//) {
							$browser = $1;
							$browser_ver = $2;
						}
					}
					$browser = 'Shiira' if $browser eq 'Safari' && $user_agent =~ /Shiira/;
				}
			} elsif ($user_agent =~ s/\s*Gecko\/?[0-9\.abr]*//) {
				$browser = 'Firefox';
				if ($user_agent =~ s/\s*Firefox\/([0-9\.abr]+)//) {
					$browser_ver = $1;
					if ($user_agent =~ s/\s*([a-zA-Z]+)[0-9\.abr]*\/([0-9\.abr]+)//) {
						$browser = $1;
						$browser_ver = $2;
					}
				} elsif ($user_agent =~ s/\s*([a-zA-Z]+)[0-9\.abr]*\/([0-9\.abr]+)//) {
					$browser = $1;
					$browser_ver = $2;
				} else {
					$browser = 'Gecko';
					$browser_ver = (defined $info[4] && $info[4] =~ /^rv:([\d\.]+)/) ? $1 : (defined $info[1] && $info[1] =~ /^rv:([\d\.]+)/) ? $1 : '';
				}
			}
			$browser_ver = $engine_ver if !defined $browser_ver || !$browser_ver;

			$platform = (defined $info[0]) ? $info[0] : '';
			$platform_ver = (defined $info[1] && $info[1] =~ /^[NIU]$/) ? (defined $info[2]) ? $info[2] : '' : (defined $info[1]) ? $info[1] : '';

			if ((defined $platform && $platform =~ /^Win/i) || !$platform_ver) {
				$platform_ver = $platform if !defined $platform_ver || $platform_ver eq '' || $platform =~ /\d/;
				if ($platform_ver =~ /Win 9x/i) {
					$platform_ver = 'Windows Me';
				} else {
					$platform_ver =~ s/^Win(?!d)([a-zA-Z]*)\s*([0-9\.abr]*)$/'Windows' . (($1) ? ' ' . $1 : '') . (($2) ? ' ' . $2 : '')/ie;
				}
				if ($platform_ver =~ /^Win/i) {
					$platform = 'Windows';
				} else {
					$platform = (defined $platform && $platform =~ /^([^\s]+)/) ? $1 : '';
				}
			} elsif (defined $platform && $platform =~ /^X\d+$/i) {
				$platform = 'UNIX';
				$platform_ver =~ s/^X\d+\s+//i;
				$platform_ver = (defined $platform_ver && $platform_ver =~ /^([\w\-]+)/) ? $1 : '';
			}

		# DreamPassport
		} elsif (defined $info[0] && $info[0] =~ /^DreamPassport\/([0-9\.abr]+)/) {
			$browser = 'DreamPassport';
			$browser_ver = $1;
			$platform = '¾';
			$platform_ver = 'Dreamcast';

		# PSP
		} elsif (defined $info[0] && $info[0] =~ /^PSP/) {
			$browser = 'PSP';
			$browser_ver = ($user_agent =~ /([\d\.]+)/) ? $1 : '';
			$platform = '¾';
			$platform_ver = 'PSP';

		# PlayStation
		} elsif (defined $info[0] && $info[0] =~ /^(?:PLAYSTATION\s*|PS)(\d*)/i) {
			$browser = 'PlayStation ' . $1;
			$browser_ver = $info[1];
			$platform = '¾';
			$platform_ver = $browser;

		# jig browser
		} elsif (defined $info[0] && $info[0] =~ /^jig browser[\s\/]([0-9\.abr]+)/i) {
			$browser = $platform_ver = 'jig browser';
			$browser_ver = $1;
			$platform = '';
			$device = $info[1];

		} elsif (defined $info[0] && $info[0] =~ /^jig browser/i) {
			$browser = $platform_ver = $info[0];
			$browser_ver = $info[1];
			$platform = '';
			$device = $info[2];

		# NetFront
		} elsif ($user_agent =~ s/^\s*NetFront\/([0-9\.abr]+)\s*//) {
			$browser = 'NetFront';
			$browser_ver = $1;
			if ($info[1] eq 'SoftBank') {
				$platform = '';
				$platform_ver = $info[1];
				$device = $info[0];
			} else {
				$platform = (defined $info[0]) ? $info[0] : '';
				my @platform_info = ($info[1]) ? split("/",$info[1]) : ('','','','');
				$platform_ver = $platform_info[0];
				$device = 'CLIE' if $platform_info[0] eq 'PalmOS' && $platform_info[1] eq 'sony';
				$device .= $platform_info[2] . '/' . $platform_info[3] if $platform_info[2] =~ s/^model\s+//;
			}

		# Opera
		} elsif ($user_agent =~ s/\s*Opera\s*([0-9\.abr]+)//) {
			$browser_ver = $1;
			$browser_ver = $1 if $user_agent =~ s/\s*Version\/([0-9\.abr]+)//;
			$browser = 'Opera';
			($platform,$platform_ver,$device) = (defined $info[1] && $info[1] =~ m!^([^/]+)/([^/]+)/([0-9\.abr]+)!) ? ($1,$2,$2.'/'.$3) : ('','','');

		# AppleWebKit
		} elsif ($user_agent =~ s/\s*AppleWebKit\/([0-9\.abr]+)//) {
			$browser_ver = $1;
			$platform = 'Macintosh';
			$platform_ver = 'MacOS X';
			if ($user_agent =~ s/([^\/\s]+)\/([0-9\.abr]+)//) {
				$browser = $1;
				$browser_ver = $2;
			} else {
				$browser = 'AppleWebKit';
			}

		# Handycam
		} elsif ($user_agent =~ s/\s*NF([0-9\.abr]+) \(NQ\)//) {
			$browser_ver = $1;
			$browser = 'NetFront';
			$platform = '¾';
			$platform_ver = $device = 'Handycam';
		}

	# Mozillaߴ
	} else {
		if (grep($_ =~ /^[NIU]$/,@info)) {
			$platform = (defined $info[0]) ? $info[0] : '';
			$platform_ver = (defined $info[1] && $info[1] =~ /^[NIU]$/) ? (defined $info[0]) ? $info[0] : '' : (defined $info[1]) ? $info[1] : '';
			$lang = (defined $info[1] && $info[1] =~ /^[NIU]$/ && defined $info[2]) ? $info[2] : (defined $info[3]) ? $info[3] : '';
		} elsif (defined $info[0] && $info[0] =~ s/^(Windows NT\s[0-9\.abr]+)\s*//i) {
			($platform,$platform_ver) = ('Windows',$1);
		} elsif (defined $info[0] && $info[0] =~ s/^([^\/\s]+)([\s\/]|\s*Ver\s*)([0-9\.abr]+)\s*//i) {
			($platform,$platform_ver) = ($1,$3);
		}
		if ($engine eq 'sharp pda browser') {

			# DoCoMo BrowserBoard
			if ($platform eq 'BrowserBoard') {
				$platform_ver = 'DoCoMo BrowserBoard';
		
			# ZAURUS
			} else {
				$platform_ver = 'ZAURUS/' . $platform_ver;
			}
			$platform = '¾';

		} elsif ($engine =~ /DoCoMo/i) {
			$platform = '';
			$platform_ver = 'DoCoMo/' . $engine_ver;
			$device = ($user_agent =~ /([\w\-\.\,]+)/) ? $1 : $platform_ver;

		} elsif ($engine =~ /(KDDI-?(\S*)|UP\.Browser)/i) {
			$platform = '';
			$platform_ver = 'au';
			$device = $2 || 'au';

		} else {
			($browser,$browser_ver) = ($engine,$engine_ver);
			$browser_ver = $1 if $user_agent =~ s/\s*Version\/([0-9\.abr]+)//;
			$platform = $info[0] if !defined $platform;
			$platform_ver = $info[1] || $info[0] if !defined $platform_ver;
			if ($browser eq 'Xiino' || $browser eq 'Palmscape') {
				$platform = '¾';
				$platform_ver = 'PalmOS';
			} elsif ($platform_ver !~ /$platform/) {
				$platform_ver = $platform . ' ' . $platform_ver;
			}
		}
	}

	# ץåȥե䴰
	$platform = '' if !defined $platform;
	$platform_ver = '' if !defined $platform_ver;
	$platform = 'Windows' if $platform =~ /^Win/;
	if ($platform =~ /^Mac/i || $platform_ver =~ /^Mac/i) {
		$platform = 'Macintosh';
		if ($platform_ver =~ /X/i || $browser =~ /OmniWeb/i) {
			$platform_ver = 'MacOS X';
		} elsif ($platform_ver =~ /(PPC|PowerPC)/i || $platform_ver =~ /^Macintosh$/) {
			$platform_ver = 'Macintosh(PPC)';
		} elsif ($platform_ver =~ /(68K|68000)/i) {
			$platform_ver = 'Macintosh(68K)';
		}
	} elsif ($platform_ver eq 'Windows NT 5.0' || ($platform =~ /^Win/i && $platform_ver =~ /2000/)) {
		$platform_ver = 'Windows 2000';
	} elsif ($platform_ver eq 'Windows NT 5.1') {
		$platform_ver = 'Windows XP';
	} elsif ($platform_ver eq 'Windows NT 5.2') {
		$platform_ver = 'Windows Server 2003';
	} elsif ($platform_ver eq 'Windows NT 6.0') {
		$platform_ver = 'Windows Vista';
	} elsif ($platform_ver eq 'Windows NT 6.1') {
		$platform_ver = 'Windows 7';
	} elsif ($platform_ver eq 'Windows ME') {
		$platform_ver = 'Windows Me';
	} elsif (defined $platform && $platform =~ /^X\d+$/i) {
		$platform = 'UNIX';
		$platform_ver =~ s/^X\d+\s+//i;
		$platform_ver = (defined $platform_ver && $platform_ver =~ /^([\w\-]+)/) ? $1 : '';
	}

	# üʥץåȥե
	if (!$platform && $user_agent =~ s/^\s*([^\/]+)\/([0-9\.abr]+)\s*//) {
		($platform,$platform_ver) = ($1,$1 . ' ' . $2);

		#AVE-Front
		if ($platform eq 'AVE-Front') {
			($browser,$browser_ver) = ($platform,$platform_ver);
			$platform = '¾';

			if (defined $info[0] && $info[0] =~ s/^BrowserInfo\s+//i) {
				foreach (@info) {
					if ($_ =~ /^Product=(.*)$/i) {
						$platform_ver = $1;
						last;
					}
				}
			} else {
				$platform_ver = 'ץ';
			}
		}
	}
	if (!$platform || ($platform ne 'Windows' && $platform ne 'Macintosh' && $platform ne 'UNIX' && $platform ne '' && $platform ne '¾')) {
		if ($platform_ver =~ /like Mac OS X/i) {
			$platform_ver = $platform;
		} elsif ($platform_ver =~ /Android/i) {
			$platform_ver = 'Android';
		} elsif ($platform && $platform ne $platform_ver) {
			$platform_ver = $platform . '(' . $platform_ver . ')';
		}
		$platform = '¾';
	}
	$platform_ver = 'ǥƥ' if $platform_ver eq 'DTV';

# 
} else {

	# 
	$platform = '';

	# ץåȥե
	my @info = split(/\//,$user_agent);

	# ץåȥե
	# KDDI
	if (defined $info[0] && $info[0] eq 'UP.Browser') {
		$platform_ver = 'au';
		
	# ¾
	} else {
		$info[0] = 'SoftBank' if $info[0] eq 'J-PHONE' || $info[0] eq 'Vodafone';
		$platform_ver = $info[0] . '/' . $info[1];
		$device = $info[2];
		$limitsize = $1 if $info[3] =~ /^c(\d+)$/;
	}
}

$platform = '¾' if !$platform;
$platform_ver = $ua if !$platform_ver;
$browser = '' if !defined $browser;
$browser_ver = '' if !defined $browser_ver;
$browser_ver = $1 if $browser_ver =~ /^(\d+\.\d+)/;
$limitsize = '' if !defined $limitsize;
$device = '' if !defined $device;
$lang = '' if !defined $lang;
return ($platform,$platform_ver,$browser,$browser_ver,$limitsize,$device,$lang);
}



1;
