package GeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
#no warnings qw(once);
######################################################################
# ⥸塼
# GeneralSetting.pm ver1.0.46
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-12-09
######################################################################
# åܼ
sub get_sub_setting_items ($) {
my $this = shift;
$check::num{'rewindable'} = '¸';

#åܥå
push(@check::checkbox,'rebuildenabled','skip','feedArticleRSS','feedSectionRSS','sectionRSStitleRequired','addressProtector','siteRSSEnabled','RSSEnabled','rssChecked','pendingChecked','keepMtimeEnabled','keepMtimeChecked','autoPublishingEnabled');
push(@check::checkbox,'masterRSSEnabled') if $default::subdivided;
push(@check::checkbox,'externalIndexDisabled') if $default::external_index && -f $default::external_index;
push(@check::checkbox,'externalNaviDisabled') if $default::external_navi && -f $default::external_navi;
push(@check::checkbox,'externalNavi2Disabled') if $default::external_navi2 && -f $default::external_navi2;

#
push(@check::tagfix,'description');

if (defined $default::date && $default::date) {

	#å
	$check::num{'yearStart'} = 'ǯ˥塼' if !defined $check::num{'yearStart'};
	$check::num{'yearEnd'} = 'ǯ˥塼' if !defined $check::num{'yearEnd'};
}

#
if (!defined $default::subdivided || !$default::subdivided) {
	$check::imagefile{'icon'} = '' if !defined $check::imagefile{'icon'};								#̾
	
} elsif (defined $master::general{'subicon'} && $master::general{'subicon'}) {
	$check::imagefile{'icon'} = '' if !defined $check::imagefile{'icon'};								#̾
	$check::maxsize{'icon'} = ($master::general{'iconMaxSize'}) ? $master::general{'iconMaxSize'} : 30000 if !defined $check::maxsize{'icon'};	#ե륵
	$check::widthlimit{'icon'} = $master::general{'iconWidthLimit'} if !defined $check::widthlimit{'icon'};		#ե벣
	$check::heightlimit{'icon'} = $master::general{'iconHeightLimit'} if !defined $check::heightlimit{'icon'};		#ե⤵
}
return;
}

######################################################################
# Ķ2
sub sub_set_preferences ($) {
my $this = shift;

# ƥ꡼ʤ
if (!defined $default::subdivided || !$default::subdivided) {
	$cgi::enctype_multipart = 1;
	$default::home = '.' if !defined $default::home || $default::home eq '';
	$preference::filedir{'icon'} = $default::home;				#¸ǥ쥯ȥ

# ƥ꡼
} elsif ($default::subdivided && defined $main::c && $main::c ne '') {
	$default::home = '.' if !defined $default::home || $default::home eq '';
	$master::home = $default::home;
	$default::home .= '/' . $main::c;
	if (defined $master::general{'subicon'} && $master::general{'subicon'}) {
		$cgi::enctype_multipart = 1;
		$preference::filedir{'icon'} = $default::home;				#¸ǥ쥯ȥ
	}
}
}

######################################################################
# ѥͥ
sub print_sub_preference_panel ($$) {
my($this,$master) = @_;

# ƥ꡼
if (!$default::subdivided || $master::general{'subicon'}) {
	print '<fieldset><legend><label for="data:icon"></label></legend>';
	$this->print_image_upload_form('icon','icon',\%main::data);
	print '</fieldset>';
}

print '<fieldset><legend><label for="data:description"></label></legend>';
print '<div class="hints">ǥåɽڡꤷޤڡޤѹɽȿǤޤ</div>';
print '<textarea name="data:description" id="data:description" cols="70" rows="6" wrap="soft" title="ǥåɽڡꤷޤ">' . ((defined $main::data{'description'}) ? $main::data{'description'} : '') . '</textarea>';
print '<div class="extra-field"><label><input type="checkbox" name="data:addressProtector" value="1"' . ((defined $main::data{'addressProtector'} && $main::data{'addressProtector'}) ? ' checked="checked"' : '') . ' /> ᡼륢ɥ쥹 JavaScript + CSS + HTML ƥƥݸ</label></div>';
print '<div class="extra-field"><label><input type="checkbox" name="rebuild" value="1" /> Ϣڡ򤹤٤ƽ񤭴(λޤǻ֤礬ޤ)</label></div>';
print '</fieldset>';

print '<fieldset><legend>ڡ</legend>';
print '<label><input type="checkbox" name="data:skip" id="data:skip" value="1"' . ((defined $main::data{'skip'} && $main::data{'skip'}) ? ' checked="checked"' : '') . ' /> ڡϤ򥹥åפ</label>';
print '</fieldset>';

print '<fieldset><legend>ƹ</legend>';
print '<label><input type="checkbox" name="data:rebuildenabled" id="data:rebuildenabled" value="1"' . ((defined $main::data{'rebuildenabled'} && $main::data{'rebuildenabled'}) ? ' checked="checked"' : '') . ' /> ٤ƤεǿΥƥץ졼ȤȤäƽ񤭴ǽˤ</label>';
print ' (<label title="ƹۤ˼Ԥϰ٤˽񤭴뵭ο򸺤餷ޤ"><input type="text" size="3" name="data:rebuildinterval" id="data:rebuildinterval" value="' . $this->escape($main::data{'rebuildinterval'}) . '" /> 鷺Ľ񤭴</label>)';
print '</fieldset>';

print '<fieldset><legend></legend>';
print '<table class="field-table"><tbody><tr><td class="field-name"><label for="data:datetype">ɸս</label></td>';
print '<td class="field">';
$this->print_date_type_menu('data:',$main::data{'datetype'},'դɸ񼰤ꤷޤ');
print '</td></tr>';

if (defined $default::date && $default::date) {
	print '<tr><td class="field-name"><span class="datatitle">ǯ˥塼</span></td>';
	print '<td class="field">';
	print '<label><input type="text" name="data:yearStart" id="data:yearStart" size="4" maxlength="4" value="' . ((defined $main::data{'yearStart'}) ? $main::data{'yearStart'} : '') . '" title="ǯ˥塼εꤷޤ" />ǯ</label>';
	print '<label><input type="text" name="data:yearEnd" size="4" maxlength="4" value="' . ((defined $main::data{'yearEnd'}) ? $main::data{'yearEnd'} : '') . '" title="ǯ˥塼νꤷޤ" />ǯ</label>';
	print '</td></tr>';

	print '<tr><td class="field-name"><label for="data:historyType"></label></td>';
	print '<td class="field">';
	print $this->mk_select_menu(
		'data:historyType','ڡڡεϰϤꤷޤ','',$main::data{'historyType'},
		'm'		=>		'ȤˤޤȤ',
		'y'		=>		'ǯȤˤޤȤ',
		'd'		=>		'ޤȤ'
	);
	print '<div class="note">ϸߤ/ǯ/ȿǤޤ</div>';
	print '</td></tr>';
}
print '</tbody></table></fieldset>';

print '<fieldset><legend>Խ̤¾Υڡ˰ưȤǽɽ chapter</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="radio" name="data:getNewChapter" value="1"' . (($main::data{'getNewChapter'}) ? ' checked="checked"' : '') . ' />  chapter ǽɽ</label></li>';
print '<li><label><input type="radio" name="data:getNewChapter" value="0"' . ((!$main::data{'getNewChapter'}) ? ' checked="checked"' : '') . ' /> Ǹ chapter ǽɽ</label></li>';
print '</ol>';
print '</fieldset>';
print '<fieldset><legend>Խ̤¾Υڡ˰ưȤǽɽ section</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="radio" name="data:getNewSection" value="1"' . (($main::data{'getNewSection'}) ? ' checked="checked"' : '') . ' />  section ǽɽ</label></li>';
print '<li><label><input type="radio" name="data:getNewSection" value="0"' . ((!$main::data{'getNewSection'}) ? ' checked="checked"' : '') . ' /> Ǹ section ǽɽ</label></li>';
print '</ol>';
print '</fieldset>';

print '<fieldset><legend>¸</legend>';
print '<label>ι<input type="text" size="3" maxlength="3" name="data:rewindable" value="' . $this->escape($main::data{'rewindable'}) . '" /> ޤǼư¸롣</label>';
print '</fieldset>';

#ǥå
if (($default::external_navi && -f $default::external_navi) || ($default::external_navi2 && -f $default::external_navi2) || ($default::external_index && -f $default::external_index)) {
	print '<fieldset><legend>ǥåι</legend>';
	print '<ol class="checkbox">';
	print '<li><label><input type="checkbox" name="data:externalIndexDisabled" value="1"' . (($main::data{'externalIndexDisabled'}) ? ' checked="checked"' : '') . ' /> ' . $this->path_change($default::external_index,$ENV{'SCRIPT_NAME'},'abs') . ' 򹹿<strong>ʤ</strong></label></li>' if $default::external_index && -f $default::external_index;
	print '<li><label><input type="checkbox" name="data:externalNaviDisabled" value="1"' . (($main::data{'externalNaviDisabled'}) ? ' checked="checked"' : '') . ' /> ' . $this->path_change($default::external_navi,$ENV{'SCRIPT_NAME'},'abs') . ' 򹹿<strong>ʤ</strong></label></li>' if $default::external_navi && -f $default::external_navi;
	print '<li><label><input type="checkbox" name="data:externalNavi2Disabled" value="1"' . (($main::data{'externalNavi2Disabled'}) ? ' checked="checked"' : '') . ' /> ' . $this->path_change($default::external_navi2,$ENV{'SCRIPT_NAME'},'abs') . ' 򹹿<strong>ʤ</strong></label></li>' if $default::external_navi2 && -f $default::external_navi2;
	print '</ol>';
	print '</fieldset>';
}

#RSS
print '<fieldset><legend>RSS</legend>';
print '<fieldset><legend>Υߥ</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="data:feedArticleRSS" value="1"' . (($main::data{'feedArticleRSS'}) ? ' checked="checked"' : '') . ' /> ֥ڡ׽񤭹߻RSS򹹿(ϵκǽΥڡ)</label></li>';
print '<li><label><input type="checkbox" name="data:feedSectionRSS" value="1"' . (($main::data{'feedSectionRSS'}) ? ' checked="checked"' : '') . ' /> section 񤭹߻ˤRSS򹹿(Ϲ줿 section)</label>';
print ' (<label><input type="checkbox" name="data:sectionRSStitleRequired" value="1"' . (($main::data{'sectionRSStitleRequired'}) ? ' checked="checked"' : '') . ' /> ȥեɤλϹʤ</label>)</li>';
print '</ol>';
print '</fieldset>';
print '<fieldset><legend>RSS</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="data:siteRSSEnabled" value="1"' . (($main::data{'siteRSSEnabled'}) ? ' checked="checked"' : '') . ' /> ' . ((-f '../../index.xml') ? '<a href="../../index.xml" target="_blank">Το(RSS)</a>' : 'Το(RSS)') . '򹹿</label></li>';
print '<li><label><input type="checkbox" name="data:masterRSSEnabled" value="1"' . (($main::data{'masterRSSEnabled'}) ? ' checked="checked"' : '') . ' /> ' . (($master::home && -f $master::home . '/index.xml') ? '<a href="' . $master::home . '/index.xml' . '" target="_blank">ڡΤο(RSS)</a>' : 'ڡΤο(RSS)') . '򹹿</label></li>' if $default::subdivided;
print '<li><label><input type="checkbox" name="data:RSSEnabled" value="1"' . (($main::data{'RSSEnabled'}) ? ' checked="checked"' : '') . ' /> ' . (($default::home && -f $default::home . '/index.xml') ? '<a href="' . $default::home . '/index.xml' . '" target="_blank">Υڡο(RSS)</a>' : 'Υڡο(RSS)') . '򹹿</label></li>';
print '</ol>';
print '</fieldset>';
print '<fieldset><legend>ǥեȤξ</legend>';
print '<label><input type="checkbox" name="data:rssChecked" value="1"' . (($main::data{'rssChecked'}) ? ' checked="checked"' : '') . ' /> ǥեȤ RSS 򹹿(RSS åܥååѤ)</label>';
print '</fieldset>';
print '</fieldset>';

print '<fieldset><legend></legend>';
print '<fieldset><legend><label><input type="checkbox" name="data:autoPublishingEnabled" value="1"' . (($main::data{'autoPublishingEnabled'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'trrigers\').disappear(!this.checked)" />ͽ</label></legend>';
print '<p class="warning">ͽǽϡRSS꡼ˤŪʹåưΥȥꥬȤѤޤȤ ƩGIF ޤ ԤΤߤJavaScript Ȥ CGI ƤӽФȤǡˬԤΥưΥȥꥬȤ뤳ȤǤޤ</p>';
print '<div id="trrigers">';
print '<fieldset><legend>å</legend>';
print '<label><select name="data:autoPublishingStartTime" id="data:autoPublishingStartTime">';
foreach my $h (0..23) {
	print '<option value="' . $h . '"';
	print ' selected="selected"' if $main::data{'autoPublishingStartTime'} && $h == $main::data{'autoPublishingStartTime'};
	print '>' . $h . '</option>';
}
print '</select> ʹ</label>';
print '';
print '</fieldset>';
my $trriger_url = $this->my_url . '?m=Publish' . (($default::subdivided) ? '&c=' . $main::c : '');
print '<fieldset><legend>RSS꡼Ͽ</legend>';
print '<textarea cols="90" rows="1">' . $trriger_url . '</textarea>';
print '<div class="note"><a href="http://www.google.co.jp/reader/view/?hl=ja" target="_blank">Google꡼</a>  <a href="http://reader.livedoor.com/" target="_blank">livedoor RSS꡼</a><a href="http://my.yahoo.co.jp/st/rss/" target="_blank">My Yahoo! RSS꡼</a> ʤɡ֥ӥ RSS ꡼˾嵭URLϿƤȡ11ɬưǽưޤ</div></fieldset>';
print '<fieldset><legend>ƩGIFȤƥڡ(ƥץ졼)</legend>';
print '<textarea cols="90" rows="1">&lt;img src=&quot;' . $this->escape($trriger_url . '&res=img') . '&quot; width=&quot;1&quot; height=&quot;1&quot; alt=&quot;&quot; /&gt;</textarea>';
print '</fieldset>';
print '<fieldset><legend>JavaScriptȤƥڡ(ƥץ졼)</legend>';
print '<textarea cols="90" rows="1">&lt;script type="text/javascript" src=&quot;' . $this->escape($trriger_url . '&res=js') . '&quot;&gt;&lt;/script&gt;</textarea>';
print '</fieldset>';
print '</div>';
print $this->javascript('cmonos.element.item(\'trrigers\').disappear(true)') if !$main::data{'autoPublishingEnabled'};
print '</fieldset>';
print '<label><input type="checkbox" name="data:pendingChecked" value="1"' . (($main::data{'pendingChecked'}) ? ' checked="checked"' : '') . ' /> ǥեȤǡץåܥååѤߤˤ</label>';
print '</fieldset>';

print '<fieldset><legend>󹹿ݻ</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="data:keepMtimeEnabled" value="1"' . (($main::data{'keepMtimeEnabled'}) ? ' checked="checked"' : '') . ' /> 󹹿ݻפĤ</label></li>';
print '<li><label><input type="checkbox" name="data:keepMtimeChecked" value="1"' . (($main::data{'keepMtimeChecked'}) ? ' checked="checked"' : '') . ' /> ǥեȤǡ󹹿ݻץåܥååѤߤˤ</label></li>';
print '</ol>';
print '</fieldset>';
}

######################################################################
# å
sub _is_valid_setting ($) {
my $this = shift;
$main::data{'autoPublishingStartTime'} = 0 if !$main::data{'autoPublishingStartTime'} || $this->is_nan($main::data{'autoPublishingStartTime'});
my(@rss,@exindex) = ((),());
push(@rss,'../../index.xml') if $setting::general{'siteRSSEnabled'} && !$main::data{'siteRSSEnabled'};
push(@rss,$master::home . '/index.xml') if $default::subdivided && $setting::general{'masterRSSEnabled'} && !$main::data{'masterRSSEnabled'};
unlink $default::home . '/index.xml' if $setting::general{'RSSEnabled'} && !$main::data{'RSSEnabled'};

push(@exindex,$default::external_index) if !$setting::general{'externalIndexDisabled'} && $main::data{'externalIndexDisabled'} && -f $default::external_index;
push(@exindex,$default::external_navi) if !$setting::general{'externalNaviDisabled'} && $main::data{'externalNaviDisabled'} && -f $default::external_navi;
push(@exindex,$default::external_navi2) if !$setting::general{'externalNavi2Disabled'} && $main::data{'externalNavi2Disabled'} && -f $default::external_navi2;

if (@rss || @exindex) {
	require CMONOS::CGI_Lib::IndexSweeper;
	IndexSweeper->new(
		'index_files'	=>	\@exindex,
		'rss_files'		=>	\@rss,
	)->sweep(
		[$this->full_path($default::home)],
		{$default::id => (($default::subdivided && defined $main::c && $main::c ne '') ? [$main::c] : [])}
	);
}
if ($main::rebuild) {
	require CMONOS::CGI_Lib::ProgressBar;
	$cgi::ProgressBar = ProgressBar->new;
	$this->set_css($cgi::ProgressBar->css);
	$this->set_javascript($cgi::ProgressBar->javascript);
}
return;
}

######################################################################
# եå
sub print_progress_bar ($) {
my $this = shift;
$cgi::ProgressBar->print_progress_bar('ե') if $main::rebuild;
return;
}

sub site_update ($) {
my $this = shift;
$this->refresh_icon_and_description if $main::rebuild;
return;
}

sub refresh_icon_and_description ($$) {
my $this = shift;
return 1 if !defined $main::data{'description'};
my @categories = ();
my @indexes = ();
push(@indexes,$default::external_index) if $default::external_index && -f $default::external_index;
push(@indexes,$default::external_navi) if $default::external_navi && -f $default::external_navi;
push(@indexes,$default::external_navi2) if $default::external_navi2 && -f $default::external_navi2;
my @articles = ();
my $icon_attribute = '';
my $description = '';
my $index_id = (defined $default::id && $default::id ne '') ? $default::id : 'homepage';
my $c = ($default::subdivided) ? $main::c : 'main';
my $metaindex_target = '';
if ($default::id) {
	my $prefix = $default::id;
	$prefix =~ s/^_+//;
	$prefix =~ s/_/-/g;
	$metaindex_target = $prefix . ((defined $main::c && $main::c ne '') ? '-' . $main::c : '');
}
if ($default::subdivided) {
	my $master_home = $default::home;
	$master_home =~ s!/\w+$!!;
	if (opendir(DIR,$master_home)) {
		while (my $file = readdir(DIR)) {
			push(@indexes,$master_home . '/' . $file) if $file !~ /^\./ && -f $master_home . '/' . $file && $file =~ /\.(s?html?|ssi)$/i;
		}
	}
	closedir(DIR);
}
if (opendir(DIR,$default::home)) {
	my @article_folders = ();
	my $history_dir = $default::home . '/history';
	while (my $file = readdir(DIR)) {
		next if $file =~ /^\./ && $file ne 'calendar';
		if (-d $default::home . '/' . $file) {
			push(@article_folders,$default::home . '/' . $file);
		} elsif (-f $default::home . '/' . $file && $file =~ /\.(s?html?|ssi)$/i) {
			push(@indexes,$default::home . '/' . $file);
		}
	}
	closedir(DIR);
	if (@article_folders) {
		foreach my $d (@article_folders) {
			if (opendir(DIR,$d)) {
				if ($default::date && $d eq $history_dir) {
					push(@indexes,map($d . '/' . $_,grep($_ =~ /^(\d+|index)\.s?html?$/i && -f $d . '/' . $_,readdir(DIR))));
				} else {
					push(@articles,map($d . '/' . $_,grep($_ =~ /^(\d+|index)\.s?html?$/i && -f $d . '/' . $_,readdir(DIR))));
				}
				closedir(DIR);
			}
		}
	}
}
if ($main::data{'icon'}) {
	$icon_attribute = ' width="' . $main::data{'iconwidth'} . '" height="' . $main::data{'iconheight'} . '" alt="' . $main::data{'cginame'} . '" border="0"';
} elsif ($setting::general{'icon'} && -f $default::home . '/' . $setting::general{'icon'}) { 
	$icon_attribute = ' width="' . $setting::general{'iconwidth'} . '" height="' . $setting::general{'iconheight'} . '" alt="' . $setting::general{'cginame'} . '" border="0"';
}
$description = $this->autolink($this->tag_fix($this->autolist($main::data{'description'}),2),0,$main::data{'addressProtector'}) if $main::data{'description'};
my $total = @indexes + @articles;
my $count = 0;
if (@indexes) {
	foreach my $path (@indexes) {
		my($data,$icon,$done);
		$done = 0;
		$count++;
		$icon = '<img src="' . $this->base_change($default::home . '/' . $main::data{'icon'},$path,(($path =~ /\.ssi$/) ? 'abs' : '')) . '"' . $icon_attribute . ' />' if $icon_attribute;
		$data = $this->read_file($path,1,1);
		$data =~ s/(<!--index(?!\w)[^>]*id="$index_id"[^>]*-->)(.*?)(<!--\/index-->)/"\x03" . $1 . $this->_index_replace($2,$c,$icon,$description,\$done) . $3 . "\x02"/sge if $c ne '';
		$data =~ s/(<!--metaindex(?!\w)[^>]*-->)(.*?)(<!--\/metaindex-->)/"\x03" . $1 . $this->_metaindex_replace($2,$metaindex_target,$icon,$description,\$done) . $3 . "\x02"/sge if $metaindex_target;
		$data =~ s/(?:^|\x02)(.*?)(?:\x03|$)/$this->_replace_icon_and_description($1,$icon,$description,\$done)/sge if !$default::subdivided || $path =~ /^\Q$default::home\E/;
		$data =~ s/[\x02\x03]//sg;
		if ($done) {
			$this->write_file($path,\$data,1,$env::file_mode,1);
			$cgi::ProgressBar->update($count,$total,20);
		}
	}
}
if (@articles) {
	foreach my $path (@articles) {
		my($data,$icon,$done);
		$done = 0;
		$count++;
		$icon = '<img src="' . $this->base_change($default::home . '/' . $main::data{'icon'},$path,(($path =~ /\.ssi$/) ? 'abs' : '')) . '"' . $icon_attribute . ' />' if $icon_attribute;
		$data = $this->read_file($path,1,1);
		$data = $this->_replace_icon_and_description($data,$icon,$description,\$done);
		if ($done) {
			$this->write_file($path,\$data,1,$env::file_mode,1);
			$cgi::ProgressBar->update($count,$total,20);
		}
	}
}
$cgi::ProgressBar->update($total,$total);
$cgi::ProgressBar->remove;
}

sub _index_replace ($$$$$$) {
my($this,$data,$c,$icon,$description,$done_ref) = @_;
$data =~ s/(<!--subindex(?!\w)[^>]*id="$c"[^>]*-->)(.*?)(<!--\/subindex-->)/$1 . $this->_subindex_replace($2,$icon,$description,$done_ref) . $3/sge;
return $data;
}

sub _subindex_replace ($$$$$) {
my($this,$data,$icon,$description,$done_ref) = @_;
my $article = ($data =~ s/(<!--article(?!\w)[^>]*-->.*<!--\/article-->)/<!--article--><!--\/article-->/sg) ? $this->_replace_icon_and_description($1,$icon,$description,$done_ref,'main') : '';
$data = $this->_replace_icon_and_description($data,$icon,$description,$done_ref);
$data =~ s/<!--article--><!--\/article-->/$article/sg;
return $data;
}

sub _metaindex_replace ($$$$$$) {
my($this,$data,$target,$icon,$description,$done_ref) = @_;
$data =~ s/(<!--article(?!\w)[^>]*id="$target-[^"]+"[^>]*-->.*?<!--\/article-->)/$this->_replace_icon_and_description($1,$icon,$description,$done_ref,'main')/sge;
return $data;
}

sub _replace_icon_and_description ($$$$;$) {
my($this,$data,$icon,$description,$done_ref,$prefix) = @_;
$prefix = '' if !defined $prefix;
$$done_ref = 1 if $data =~ s/<\!--(${prefix}icon(?!\w))([^>]*)-->(.*?)<\!--\/\1(?!\w)[^>]*-->/$this->item_tag_replace($1,$2,$3,$icon,1)/gies;
$$done_ref = 1 if $data =~ s/<\!--(${prefix}description(?!\w))([^>]*)-->(.*?)<\!--\/\1(?!\w)[^>]*-->/$this->item_tag_replace($1,$2,$3,$description,1)/gies;
return $data;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
unless ($default::subdivided && (!defined $main::c || $main::c eq '')) {
	#饹Ͽ
	Common::class_register('0000','GeneralSetting');

	#ġϿ
	$setting::jump_menu{'0000'} = '' if !defined $setting::jump_menu{'0000'};
}
}

1;
