package HmPreferenceShare;
require CMONOS::CGI_Lib::Tools::PreferenceShare;
@ISA = qw(PreferenceShare);
use strict;
######################################################################
# HomePageMaker ζͭ⥸塼
# HmPreferenceShare.pm ver1.1.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
sub get_shareable_db_info ($$) {
my($this,$shareable_db) = @_;
my $default_path = ($env::user_default_dir || $env::default_dir) . '/homepagemaker';
$default_path .= '_date' if defined $default::date && $default::date;
if ($default::subdivided && (!defined $main::c || $main::c eq '')) {
	$default_path .= '/masterdefault';
	$this->set_dir($default_path);
	%$shareable_db = (
		'general'		=>	{
								'pref_path'		=>	$default::preference_dir . '/general',
								'bak_path'		=>	$default_path . '/general',
								'pref_type'		=>	'',
								'pref_id'		=>	'0000'
							},
		'security'		=>	{
								'pref_path'		=>	$default::preference_dir . '/security',
								'bak_path'		=>	$default_path . '/security',
								'pref_type'		=>	'',
								'pref_id'		=>	'0001'
							},
		'installmsg'	=>	{
								'pref_path'		=>	$default::preference_dir . '/installmsg',
								'bak_path'		=>	$default_path . '/installmsg',
								'pref_type'		=>	'ƥ꡼',
								'pref_id'		=>	'00H1'
							},
		'page'			=>	{
								'pref_path'		=>	$default::preference_dir . '/page',
								'bak_path'		=>	$default_path . '/page',
								'pref_type'		=>	'ڡ쥤',
								'pref_id'		=>	'H010'
							}
	);
} else {
	$default_path .= '/default';
	$this->set_dir($default_path . '/field');
	%$shareable_db = (
		'general'		=>	{
								'pref_path'		=>	$default::preference_dir . '/general',
								'bak_path'		=>	$default_path . '/general',
								'pref_type'		=>	'',
								'pref_id'		=>	'0000'
							},
		'security'		=>	{
								'pref_path'		=>	$default::preference_dir . '/security',
								'bak_path'		=>	$default_path . '/security',
								'pref_type'		=>	'',
								'pref_id'		=>	'0001'
							},
		'inputfield'	=>	{
								'pref_path'		=>	$default::field_pref_dir . '/inputfield',
								'bak_path'		=>	$default_path . '/field/inputfield',
								'pref_type'		=>	'ϥե',
								'pref_id'		=>	'H100'
							},
		'infofield'	=>		{
								'pref_path'		=>	$default::field_pref_dir . '/infofield',
								'bak_path'		=>	$default_path . '/field/infofield',
								'pref_type'		=>	'ڡե',
								'pref_id'		=>	'H101'
							},
		'page'			=>	{
								'pref_path'		=>	$default::preference_dir . '/page',
								'bak_path'		=>	$default_path . '/page',
								'pref_type'		=>	'ڡ쥤',
								'pref_id'		=>	'H010'
							}
	);
}
return;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
if ($env::default_dir) {
	#饹Ͽ
	Common::class_register('xxbs','HmPreferenceShare');

	#˥塼Ͽ
	$setting::jump_menu{'xxbs'} = 'ζͭ';
	$setting::sub_jump_menu{'share'}{'xxbs'} = 'ζͭ';
	$setting::selected_jump_menu{'xxbs'} = 'xxbs';
}
}


1;
