package Editor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# Խ⥸塼
# Editor.pm ver1.1.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-03-29
######################################################################
# ᥤ
sub run ($) {
my $this = shift;
my $tool_master = $this->is_secure('tools');

#---------------------------------------------------------------------
#ǧԤܷٹ
$this->set_pending_item_alert if !defined $main::w && !defined $main::chap && !defined $main::sect && $this->is_secure('edit');

#---------------------------------------------------------------------
#ɬפʥ⥸塼ɤ߹ߡĴ
use Fcntl qw(:DEFAULT :flock);
eval 'use ' . $env::dbm_file . ';';
use File::Path;
require CMONOS::CGI_Lib::Template;
require CMONOS::CGI_Lib::Taketori;
$env::ssi = 0 if $default::home !~ /\.$env::ssi_ext$/;
if (!defined $default::file || $default::file eq '') {
	($default::file = $default::home) =~ s/[^\/]+$/files/;
	$this->set_dir($default::file);
}

$setting::page{'edit'}{'infoLabel'} = 'ڡ' if !$setting::page{'edit'}{'infoLabel'};

#---------------------------------------------------------------------
#ХåĴ
my $archives_dir = $default::file . '/archives.pending';
if ($main::rewind) {
	$main::rewind =~ s/\D//g;
	undef $main::rewind if $main::w || !$main::rewind || !-d "$archives_dir/$main::rewind" || !$this->is_secure('rewind');
}

#---------------------------------------------------------------------
#
my $is_draft;
if ($main::delete && $main::delete eq 'rmdraft') {
	if (-d $default::file . '/draft.pending') {
		rmtree $default::file . '/draft.pending';
		push(@{$this->{'dialog'}},'񤭤ޤ');
		undef $main::delete;
	}
} elsif (-d $default::file . '/draft.pending') {
	if (!$main::w || $main::pending) {
		$is_draft = 1;
	} else {
		$this->file_directory_clear($default::file); #Ǥźեեä
		$this->file_directory_copy($default::file . '/draft.pending/files',$default::file); #źեե˰ư
		$this->home_file_copy($default::file . '/draft.pending/' . (($default::home =~ /([^\/]+)$/) ? $1 : 'index.html'),$default::home,$default::file . '/draft.pending/files',$default::file);
		rmtree $default::file . '/draft.pending';
	}
} elsif ($main::pending) {
	push(@{$this->{'dialog'}},'񤭤Ȥ¸ޤ');
	$is_draft = 1;
	$this->file_directory_copy($default::file,$default::file . '/draft.pending/files');
	$this->home_file_copy($default::home,$default::file . '/draft.pending/' . (($default::home =~ /([^\/]+)$/) ? $1 : 'index.html'),$default::file,$default::file . '/draft.pending/files');
}
if ($is_draft) {
	$this->template_fix(\$setting::page{'article'}{'template'},$default::home,$default::file . '/draft.pending/' . (($default::home =~ /([^\/]+)$/) ? $1 : 'index.html'),$default::file,$default::file . '/draft.pending/files') if $setting::page{'article'}{'template'};
	$this->write_file(
		$default::file . '/draft.pending/.htaccess',
		"order deny,allow\x0Adeny from all\x0A" . (($ENV{'REMOTE_ADDR'}) ? "allow from " . $ENV{'REMOTE_ADDR'} . "\x0A" : ''),
		1
	);
	$default::home = $default::file . '/draft.pending/' . (($default::home =~ /([^\/]+)$/) ? $1 : 'index.html');
	$default::file = $default::file . '/draft.pending/files';
}

#---------------------------------------------------------------------
#Хå
if ($main::rewind) {
	my $current_dir = $archives_dir . '/' . $main::rewind;
	$this->file_directory_copy($current_dir . '/files',$default::file,1);
	$this->home_file_copy($current_dir . '/' . (($default::home =~ /([^\/]+)$/) ? $1 : 'index.html'),$default::home,$current_dir . '/files',$default::file);
	$this->save_this_version($archives_dir);
}

#---------------------------------------------------------------------

my $get_last_chapter = (!$main::i && !$main::w && !$setting::general{'getNewChapter'}) ? 1 : 0;
my $get_last_section = (!$main::i && !$main::w && !$setting::general{'getNewSection'}) ? 1 : 0;
if (!$main::i) {
	if ($main::chap && $main::chap eq 'new') {
		$main::chap = '';
		$get_last_chapter = 0;
	}
	if ($main::sect && $main::sect eq 'new') {
		$main::sect = '';
		$get_last_section = 0;
	}
	$main::chap = '' if !defined $main::chap || !$main::chap || $main::chap =~ /\D/;
	$main::sect = '' if !defined $main::sect || !$main::sect || $main::sect =~ /\D/;
	if ($main::chap && $main::chap > 99) {
		$main::chap = 99;
		push(@{$this->{'dialog'}},'Ǥ chapter  99 ޤǤǤ');
	}
	if ($main::sect && $main::sect > 99) {
		$main::sect = 99;
		push(@{$this->{'dialog'}},'Ǥ section  99 ޤǤǤ');
	}
}

#-----------------------------------------------------------------------------
#եɤ߹
my($article);
local(*FILE);
if ($setting::page{'article'}{'template'} && $main::delete && $main::delete eq 'refresh') {
	$this->file_directory_clear($default::file);
	$this->write_html_file();
	$article = '';
	$this->index_sweeper;
} else {
	$article = $this->read_html_file;
}
undef %main::data if !$main::w && $article && ($main::i || ($main::chap && $main::sect));
$article = '' if $article !~ /\S/s || $article =~ /<!--article_body--><!--\/article_body-->/s;
my $info_enabled = 0;
if (($article && $article =~ /<!--info(?!\w)[^>]*-->.*?<!--\/info(?!\w)[^>]*-->/s) || (!$article && $setting::page{'article'}{'template'} && $setting::page{'article'}{'template'} =~ /<!--info(?!\w)[^>]*-->.*?<!--\/info(?!\w)[^>]*-->/s)) {
	$info_enabled = 1;
} elsif ($main::i) {
	undef %main::data;
	undef $main::w;
	undef $main::i;
}


#-----------------------------------------------------------------------------
#ƥץ졼ȥ֥Ⱥ
my($field,$field_for,$template);
if ($main::i) {
	$this->use_field('info',$default::field_pref_dir . '/infofield',2,0,$setting::field_tag_enabled,'info') if !%info::obj;
	$template = $this->mk_info_template_obj;
	$field = \%info::obj;
	$field_for = \%info::for;
} else {
	$template = $this->mk_article_template_obj;
	$field = \%field::obj;
	$field_for = \%field::for;
}

#-----------------------------------------------------------------------------
#chapter/sectionư
if ($article) {
	if (!$main::i && $main::moveto && $main::chap && ($main::target eq 'chapter' || $main::sect)) {
		$template->subdivision_move_to(
			\$article,
			$main::target,
			$main::chap,
			$main::sect,
			$main::moveto,
		);
		$this->write_html_file($article);
		$this->save_this_version($archives_dir);
	}
	$article =~ s/^.*?<!--article_body-->//s;
	$article =~ s/<!--\/article_body-->.*?$//s;
}

#ƥץ졼ȤޤϵѥեɤФ
$cgi::output = $default::home;
$template->scan(\$article,\$main::chap,\$main::sect,'main','data',$get_last_chapter,$get_last_section);


#-----------------------------------------------------------------------------
#åץɥե¸
my $filedir = ($main::i) ? $default::file . '/i' : $default::file . '/' . $main::chap . '/' . $main::sect;


#-----------------------------------------------------------------------------
#ǡ˥åȺ
if (!$main::i && defined $main::delete && (
	($main::delete eq 'rmchapter' && ref $template->{'stat'}{'chapter_order'} && @{$template->{'stat'}{'chapter_order'}} > 1) || 
	($main::delete eq 'rmsection' && $main::sect && ref $template->{'stat'}{'section_order'} && @{$template->{'stat'}{'section_order'}} > 1)
	) && $main::chap) {

	#źեեǥ쥯ȥ
	if ($main::delete eq 'rmsection') {
		rmtree "$default::file/$main::chap/$main::sect";
	} else {
		rmtree "$default::file/$main::chap";
	}

	$article = $template->replace($main::chap,$main::sect,$this->tag_replace($article),\%main::data,$main::delete,$filedir,$main::c,$main::n);
	$this->write_html_file($article);

	if ($main::delete eq 'rmsection') {
		$this->index_sweeper($main::chap,$main::sect);
		$main::sect = '';
	} else {
		$this->index_sweeper($main::chap);
		$main::chap = $main::sect = '';
	}
	undef %main::data;
	$template->scan(\$article,\$main::chap,\$main::sect);
	$this->save_this_version($archives_dir);

} elsif (defined $main::delete && ($main::delete eq 'rmsection' || $main::delete eq 'rmchapter')) {
	push(@{$this->{'dialog'}},'˼ԤޤǧƤ');
	undef $main::delete;


#-----------------------------------------------------------------------------
#ϤΥå
} elsif (defined $main::w && $main::w) {
	my $input_is_valid = 1;
	if (@{$template->{'stat'}{'field'}}) {
		#no warnings qw(numeric);
		foreach my $fid (sort {$field->{$a}->{'ORDER'} <=> $field->{$b}->{'ORDER'}} @{$template->{'stat'}{'field'}}) {
			$input_is_valid = 0 if !$field->{$fid}->is_valid_data($filedir);
		}
	}


	#-----------------------------------------------------------------------------
	#񤭹
	if ($input_is_valid) {
	
		#ե¸
		$cgi::input->fix_all_files($filedir);
	
		if (ref $cgi::input->{'dialog'} && @{$cgi::input->{'dialog'}} > 0) {
			push(@{$this->{'dialog'}},@{$cgi::input->{'dialog'}});
		}
	
		#
		if (@{$template->{'stat'}{'field'}}) {
			#no warnings qw(numeric);
			foreach my $fid (sort {$field->{$a}->{'ORDER'} <=> $field->{$b}->{'ORDER'}} @{$template->{'stat'}{'field'}}) {
				$field->{$fid}->settle_up($filedir) if ref $field->{$fid};
			}
		}

		#ڡι
		if ($main::i) {
			if ($tool_master && $main::refresh && $setting::page{'article'}{'template'}) {
				my($new_template);
				if ($setting::page{'article'}{'template'} =~ /<!--field(?!\w)[^>]*-->.*?<!--\/field(?!\w)[^>]*-->/s) {
					my $article_template = $this->mk_article_template_obj;
					$new_template = $article_template->refresh(\$article,'',$default::file,'detail');
				}
				$article = $template->refresh(\$article,\$new_template,$default::file . '/i','detail');
				$template->scan(\$article);
			}
			$this->write_html_file($template->replace($this->tag_replace($article),\%main::data,'detail',$filedir));
		} else {
			if ($tool_master && $main::refresh && $setting::page{'article'}{'template'}) {
				my($new_template);
				if ($setting::page{'article'}{'template'} =~ /<!--info(?!\w)[^>]*-->.*?<!--\/info(?!\w)[^>]*-->/s) {
					local(%info::obj);
					$this->use_field('info',$default::field_pref_dir . '/infofield',2,0,$setting::field_tag_enabled,'info');
					my $info_template = $this->mk_info_template_obj;
					$new_template = $info_template->refresh(\$article,'',$default::file . '/i','detail');
					undef %info::obj;
				}
				$article = $template->refresh(\$article,\$new_template,$default::file,'detail');
				$template->scan(\$article,\$main::chap,\$main::sect);
			}
			$this->write_html_file($template->replace($main::chap,$main::sect,$this->tag_replace($article),\%main::data,'detail',$filedir));
		}
		undef $main::refresh;
		
		push(@{$template->{'stat'}{'chapter_order'}},$main::chap) unless grep($_ eq $main::chap,@{$template->{'stat'}{'chapter_order'}});
		push(@{$template->{'stat'}{'section_order'}},$main::sect) unless grep($_ eq $main::sect,@{$template->{'stat'}{'section_order'}});
		$template->{'stat'}{'new_chapter'} = $template->{'stat'}{'new_section'} = 0;

		#RSS
		if (!$is_draft && $main::feed_rss && $setting::general{'siteRSSEnabled'}) {
			my $url = $this->full_path($default::home) . (($main::i) ? '' : '#a' . sprintf("%.2d", $main::chap) . sprintf("%.2d", $main::sect));
			$this->feed_rss(
				{
					'title'				=>	(($field_for->{'title'} && ref $field->{$field_for->{'title'}} && $main::data{$field_for->{'title'}}{'str'}) ? $field->{$field_for->{'title'}}->restore->format_for_text($main::data{$field_for->{'title'}}{'str'},$filedir,$main::c,$main::n) : ''),
					'link'				=>	$url,
					'content:encoded'	=>	(($field_for->{'description'} && ref $field->{$field_for->{'description'}} && $main::data{$field_for->{'description'}}{'str'}) ? $field->{$field_for->{'description'}}->restore->format_for_detail($main::data{$field_for->{'description'}}{'str'},$filedir,$main::c,$main::n) : ''),
					'enclosure'			=>	(($field_for->{'media'} && ref $field->{$field_for->{'media'}} && $main::data{$field_for->{'media'}}{'str'}) ? {$field->{$field_for->{'media'}}->get_enclosure_attributes($main::data{$field_for->{'media'}}{'str'},$filedir,$main::c,$main::n)} : ''),
					(($env::checkout && $field_for->{'showcase'} && ref $field->{$field_for->{'showcase'}}) ? 
						$field->{$field_for->{'showcase'}}->get_gdata($url,$main::data{$field_for->{'showcase'}})
					: ()),
				}
			);
		}
		$this->save_this_version($archives_dir);

	} else {
		push(@{$this->{'dialog'}},'񤭹ߤ˼Ԥޤ');
	}
}
undef $cgi::output;
undef $cgi::output_option;

#-----------------------------------------------------------------------------
#ϲ


#ڡإå
$this->print_page_header('edit');

#/ꥸʥڡ
print '<div id="target-selector">';
print '<ul>';
print '<li><a href="' . $default::home . '" target="_blank">ºݤΥڡ</a></li>';
if ($info_enabled) {
	print '<li>';
	print $this->form_start(
		'key'	=>	'edit',
		'name'	=>	'fieldtype',
		'required'	=>	\@setting::form
	);
	if ($main::i) {
		print '<input type="submit" name="" value="&rsaquo; ' . (($setting::page{'edit'}{'mainLabel'}) ? $setting::page{'edit'}{'mainLabel'} : 'ʸ') . '" />';
	} else {
		print '<input type="submit" name="i=1" value="&lsaquo; ' . $setting::page{'edit'}{'infoLabel'} . '" />';
	}
	print '</form></li>';
}
print '</ul>';

#ܥǥ/
if ($main::i) {
	push(@setting::form,'i');
} else {
	if ($template->{'chapter_limit'} eq '' || $template->{'chapter_limit'} > 1) {
		my $chap_dir = ($template->{'chapter_dir'} eq 'above') ? '[]' : '[]';

		print '<ul>';
		if ($template->{'stat'}{'prev_chapter'} && $template->{'stat'}{'prev_chapter'} ne '<new>') {
			print '<li>';
			print $this->form_start(
				'key'	=>	'edit',
				'name'	=>	'prevchapter',
				'required'	=>	\@setting::form
			);
			print '<input type="submit" name="chap=' . $template->{'stat'}{'prev_chapter'} . '" value=" chapter" /></form></li>';
		} elsif ($template->{'chapter_dir'} eq 'above' && !$template->{'stat'}{'new_chapter'} && (!defined $template->{'chapter_limit'} || $template->{'chapter_limit'} eq '' || @{$template->{'stat'}{'chapter_order'}} < $template->{'chapter_limit'})) {
			print '<li>';
			print $this->form_start(
				'key'	=>	'edit',
				'name'	=>	'nextchapter',
				'required'	=>	\@setting::form
			);
			print '<input type="submit" name="chap=new" value=" chapter ' . $chap_dir . '" /></form></li>';
		}

		if ($template->{'stat'}{'next_chapter'} && $template->{'stat'}{'next_chapter'} ne '<new>') {
			print '<li>';
			print $this->form_start(
				'key'	=>	'edit',
				'name'	=>	'nextchapter',
				'required'	=>	\@setting::form
			);
			print '<input type="submit" name="chap=' . $template->{'stat'}{'next_chapter'} . '" value=" chapter" /></form></li>';
		} elsif ($template->{'chapter_dir'} ne 'above' && !$template->{'stat'}{'new_chapter'} && (!defined $template->{'chapter_limit'} || $template->{'chapter_limit'} eq '' || @{$template->{'stat'}{'chapter_order'}} < $template->{'chapter_limit'})) {
			print '<li>';
			print $this->form_start(
				'key'	=>	'edit',
				'name'	=>	'nextchapter',
				'required'	=>	\@setting::form
			);
			print '<input type="submit" name="chap=new" value=" chapter ' . $chap_dir . '" /></form></li>';
		}

		print '<li>';
		print $this->form_start(
			'key'	=>	'edit',
			'name'	=>	'chapterselector',
			'required'	=>	\@setting::form
		);
		print '<select name="chap" onchange="submit()">';
		print '<option value="new"> chapter ' . $chap_dir . '</option>' if $template->{'chapter_dir'} eq 'above' && !$template->{'stat'}{'new_chapter'} && (!defined $template->{'chapter_limit'} || $template->{'chapter_limit'} eq '' || @{$template->{'stat'}{'chapter_order'}} < $template->{'chapter_limit'});
		foreach (@{$template->{'stat'}{'chapter_order'}}) {
			next if $_ eq '';
			print '<option value="' . $_ . '"' . (($main::chap eq $_) ? ' selected="selected"' : '') . '>' . $this->jfold($template->{'stat'}{'chapter_title'}{$_},24,'I',1) . '</option>';
		}
		print '<option value="new"> chapter ' . $chap_dir . '</option>' if $template->{'chapter_dir'} ne 'above' && !$template->{'stat'}{'new_chapter'} && (!defined $template->{'chapter_limit'} || $template->{'chapter_limit'} eq '' || @{$template->{'stat'}{'chapter_order'}} < $template->{'chapter_limit'});
		print '</select><input type="submit" value="" /></form></li>';
		print '</ul>';

	}
	push(@setting::form,'chap');

	#˥å/
	if ($template->{'section_limit'} eq '' || $template->{'section_limit'} > 1) {
		my $sect_dir = ($template->{'section_dir'} eq 'above') ? '[]' : '[]';

		print '<ul>';
		if ($template->{'stat'}{'prev_section'} && $template->{'stat'}{'prev_section'} ne '<new>') {
			print '<li>';
			print $this->form_start(
				'key'	=>	'edit',
				'name'	=>	'prevsection',
				'required'	=>	\@setting::form
			);
			print '<input type="submit" name="sect=' . $template->{'stat'}{'prev_section'} . '" value=" section" /></form></li>';
		} elsif ($template->{'section_dir'} eq 'above' && !$template->{'stat'}{'new_section'} && (!defined $template->{'section_limit'} || $template->{'section_limit'} eq '' || @{$template->{'stat'}{'section_order'}} < $template->{'section_limit'})) {
			print '<li>';
			print $this->form_start(
				'key'	=>	'edit',
				'name'	=>	'nextsection',
				'required'	=>	\@setting::form
			);
			print '<input type="submit" name="sect=new" value=" section ' . $sect_dir . '" /></form></li>';
		}

		if ($template->{'stat'}{'next_section'} && $template->{'stat'}{'next_section'} ne '<new>') {
			print '<li>';
			print $this->form_start(
				'key'	=>	'edit',
				'name'	=>	'nextsection',
				'required'	=>	\@setting::form
			);
			print '<input type="submit" name="sect=' . $template->{'stat'}{'next_section'} . '" value=" section" /></form></li>';
		} elsif ($template->{'section_dir'} ne 'above' && !$template->{'stat'}{'new_section'} && (!defined $template->{'section_limit'} || $template->{'section_limit'} eq '' || @{$template->{'stat'}{'section_order'}} < $template->{'section_limit'})) {
			print '<li>';
			print $this->form_start(
				'key'	=>	'edit',
				'name'	=>	'nextsection',
				'required'	=>	\@setting::form
			);
			print '<input type="submit" name="sect=new" value=" section ' . $sect_dir . '" /></form></li>';
		}

		print '<li>';
		print $this->form_start(
			'key'	=>	'edit',
			'name'	=>	'sectionselector',
			'required'	=>	\@setting::form
		);
		print '<select name="sect" onchange="submit()">';
		print '<option value="new"> section ' . $sect_dir . '</option>' if $template->{'section_dir'} eq 'above' && !$template->{'stat'}{'new_section'} && (!defined $template->{'section_limit'} || $template->{'section_limit'} eq '' || @{$template->{'stat'}{'section_order'}} < $template->{'section_limit'});
		foreach (@{$template->{'stat'}{'section_order'}}) {
			next if !defined $_ ||  $_ eq '';
			print '<option value="' . $_ . '"' . (($main::sect eq $_) ? ' selected="selected"' : '') . '>' . $this->jfold($template->{'stat'}{'section_title'}{$_},24,'I',1) . '</option>';
		}
		print '<option value="new"> section ' . $sect_dir . '</option>' if $template->{'section_dir'} ne 'above' && !$template->{'stat'}{'new_section'} && (!defined $template->{'section_limit'} || $template->{'section_limit'} eq '' || @{$template->{'stat'}{'section_order'}} < $template->{'section_limit'});
		print '</select><input type="submit" value="" /></form></li>';
		print '</ul>';
	}
	push(@setting::form,'sect');
}
print '</div>';

#ưե
if (!$main::i && (!$template->{'stat'}{'new_chapter'} || !$template->{'stat'}{'new_section'})) {
	$template->print_subdivision_arrangement_form(
		$this->form_start(
			'key'	=>	'edit',
			'name'	=>	'subdivision-arrangement-form',
			'method'	=> 'post',
			'onsubmit'	=> 'return cmonos.form.item(this).isNotSubmitted()',
			'required'	=>	\@setting::form
		)
	);
}

#ȥ
print '<h1 id="editor-article-title">';
print ((defined $setting::page{'article'}{'title'} && $setting::page{'article'}{'title'} ne '') ? $setting::page{'article'}{'title'} : $setting::general{'cginame'});
if ($main::i) {
	print ' - ' . $setting::page{'edit'}{'infoLabel'};
} elsif ($setting::page{'edit'}{'mainLabel'}) {
	print ' - ' . $setting::page{'edit'}{'mainLabel'};
}
print ' <span style="color: #FFF; background-color: #f66" title=""></span> ' if $is_draft;
print '</h1>';

#ե
print $this->form_start(
	'key'	=>	'edit',
	'name'	=>	'input',
	'multi'	=> (defined $cgi::enctype_multipart) ? $cgi::enctype_multipart : '',
	'method'	=> 'post',
	'onsubmit'	=> 'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="w" value="1" />';

print '<table class="field-table"><tbody>';
if (defined $template->{'stat'}{'chapter_title_enabled'} && $template->{'stat'}{'chapter_title_enabled'}) {
	print '<tr class="tbody-end"><td class="field-name"><label for="data:title">chapter ȥ</label></td>';
	print '<td class="field"><input type="text" size="50" name="data:title" id="data:title" value="' . $this->escape($main::data{'title'}) . '" />';
	print '</td></tr></tbody><tbody>';
}
if (@{$template->{'stat'}{'field'}}) {
	#no warnings qw(numeric);
	foreach my $fid (sort {$field->{$a}->{'ORDER'} <=> $field->{$b}->{'ORDER'} || $a <=> $b} @{$template->{'stat'}{'field'}}) {
		next unless ref $field->{$fid};
		print $field->{$fid}->form((($template->{'stat'}{'new_section'}) ? '' : 1),'',$filedir);
	}
}
print '</tbody><tbody>';
print '<tr class="tbody-start"><td class="submit-box" colspan="2">';

print '<label title="ƱƤϤ뤳Ȥ¿Ĥιܤ򵭲ޤ"><input type="checkbox" name="set_cookie" value="1"' . (($cookie::read{$cookie::name} || $main::set_cookie) ? ' checked="checked"' : '') . ' />򵭲</label> ' if defined $cookie::enabled && $cookie::enabled;
print '<label title="񤭤Ȥ¸ޤ"><input type="checkbox" name="pending" value="1"' . (($is_draft) ? ' checked="checked"' : '') . ' /></label> ';
print '<label><input type="checkbox" name="refresh" value="1"' . (($main::refresh) ? ' checked="checked"' : '') . ' onclick="cmonos.form.field(this).checkboxConfirm(\'ǿΥƥץ졼Ȥȵƥץ졼Ȥδ֤˸ߴʤ硢ǡ줿ɽ뤳Ȥޤ\\nǤǿΥƥץ졼ȤȤޤ\')" />ǿΥƥץ졼ȤȤ</label> ' if $tool_master && $setting::page{'article'}{'template'};
print '<label title="RSS򹹿ޤ"><input type="checkbox" name="feed_rss" value="1"' . (($setting::general{'rssChecked'}) ? ' checked="checked"' : '') . ' />RSS</label> ' if $setting::general{'siteRSSEnabled'};
print '<input type="submit" value="¸" class="save" /></td></tr></tbody></table></form>';

if (!$setting::general{'rewindable'}) {
	if (-d $archives_dir) {
		use File::Path;
		rmtree $archives_dir;
	}
} elsif ($this->is_secure('rewind')) {
	if (opendir(DIR, $archives_dir)) {
		my @dir = sort {$this->sort_by(\$a,\$b,'descend')} grep($_ !~ /\D/ && -d $archives_dir . '/' . $_,readdir(DIR));
		shift @dir;
		my $ip = $this->to_host($ENV{'REMOTE_ADDR'});
		$this->write_file(
			$archives_dir . '/.htaccess',
			'Satisfy all' . "\x0A"
				. 'order deny,allow' . "\x0A"
				. 'deny from all' . "\x0A"
				. 'allow from ' . $ip . "\x0A",
			1
		);
		if (@dir) {
			print $this->form_start(
				'key'		=>	'edit',
				'id'		=>	'rewind-form',
				'name'		=>	'rewind-form',
				'method'	=> 'post',
				'onsubmit'	=> 'return cmonos.tool.isRewindable()',
				'required'	=>	\@setting::form
			);
			print '<fieldset class="risky">';
			print '<select name="rewind" id="rewind" onchange="cmonos.tool.openPreviewWindow()">';
			print '<option value="">ε' . (($main::email || $this->is_secure('tools')) ? '[Խ]' : '') . '</option>';
			foreach my $d (@dir) {
				my $user = '';
				if ($main::email || $this->is_secure('tools')) {
					my($ip,$ua,$email) = split(/\x0A/,$this->read_file($archives_dir . '/' . $d . '/data/author',1));
					if (($email && $main::email && $email eq $main::email) || $this->is_secure('tools')) {
						if ($email) {
							$user = $cgi::Register->email_to_name($main::pswd,$email,$this->is_secure('tools'));
							$user = $email if !$user;
						}
						$user .= '&lt;<a href="mailto:' . $email . '" title="' . $email . '">' . $email . '</a>&gt;' if $email;
					}
				}
				print '<option value="' . $d . '">' . $this->date($d,3,$setting::general{'datetype'}) . (($user) ? '[' . $user . ']' : '') . '</option>';
			}
			print '</select>';
			print '<input type="submit" value="᤹" />';
			print ' <label><input type="checkbox" id="preview-enabled" onclick="cmonos.tool.openPreviewWindow()" />ץӥ塼</label>';
			print '</fieldset>';
			print '</form>';
			my $file_name = ($default::home =~ /([^\/]+)$/) ? $1 : 'index.html';
my $js = <<JAVASCRIPT;
cmonos.tool.openPreviewWindow = function () {
	var preview_enabled = document.getElementById('preview-enabled');
	if (preview_enabled && preview_enabled.checked) {
		var d = cmonos.form.field('rewind').getValue();
		if (d != '') window.open('$archives_dir/'+d+'/$file_name');
	}
};
cmonos.tool.isRewindable = function () {
	if (cmonos.form.field('rewind').getValue() != "") {
		return confirm('ϼäޤ˰ξ֤ᤷޤ') && cmonos.form.item(this).isNotSubmitted();
	} else {
		alert('ε򤷤Ƥ');
		return false;
	}
};
JAVASCRIPT
			print $this->javascript($js);
		}
	}
}
if ((!defined $main::delete || $main::delete ne 'refresh') && ($is_draft || (ref $template->{'stat'}{'section_order'} && @{$template->{'stat'}{'section_order'}} > 1 && !$template->{'stat'}{'new_section'}) || (ref $template->{'stat'}{'chapter_order'} && @{$template->{'stat'}{'chapter_order'}} > 1 && !$template->{'stat'}{'new_chapter'}) || $setting::page{'article'}{'template'})) {
	print $this->form_start(
		'key'	=>	'edit',
		'name'	=>	'delete',
		'method'	=>	'post',
		'onsubmit'	=> 'return confirm(\'ϼäޤ˺ޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
		'required'	=>	\@setting::form
	);
	print '<fieldset id="delete-menu" class="risky">';
	print '<select name="delete"';
	print ' title="Τȡƥץ졼Ȥɤ߹ޤޤ"' if $setting::page{'article'}{'template'};
	print '>';
	print '<option value=""></option>';
	if (!$main::i) {
		print '<option value="rmsection"> section </option>' if ref $template->{'stat'}{'section_order'} && @{$template->{'stat'}{'section_order'}} > 1 && !$template->{'stat'}{'new_section'};
		print '<option value="rmchapter"> chapter </option>' if ref $template->{'stat'}{'chapter_order'} && @{$template->{'stat'}{'chapter_order'}} > 1 && !$template->{'stat'}{'new_chapter'};
	}
	print '<option value=""></option>';
	if ($is_draft) {
		print '<option value="rmdraft">β񤭤</option>';
	} elsif ($setting::page{'article'}{'template'}) {
		print '<option value="refresh">Τ</option>';
	}
	print '</select><input type="submit" value="" /></fieldset></form>';
}

#ڡեå
$this->print_page_footer('edit');
}

sub mk_info_template_obj ($) {
my $this = shift;
my $template = Template->new(\%info::obj,\%info::for,$frame::obj{'frame'});
$template->set(
	'field_style_disabled' => 0,								# 1=ե̵뤹/2=̵뤹
	'field_tag_enabled' => $setting::field_tag_enabled,				# tag=Τ/all=յ/no=Ĥʤ
	'field_tag_name' => 'info',							# եɥ ǥեȤ<!--field-->
	'default' => \$setting::page{'article'}{'template'},
	'link_id' => 'i',
	'tategaki_disabled' => 1,
);
return $template;
}

sub mk_article_template_obj ($) {
my $this = shift;
my $template = Template->new(\%field::obj,\%field::for,$frame::obj{'frame'});
$template->set(
	'field_style_disabled' => 0,								# 1=ե̵뤹/2=̵뤹
	'field_tag_enabled' => $setting::field_tag_enabled,				# tag=Τ/all=յ/no=Ĥʤ
	'field_tag_name' => 'field',							# եɥ ǥեȤ<!--field-->
	'chapter' => 'chapter',							# chapter 
	'section' => 'section',							# section 
	'default' => \$setting::page{'article'}{'template'},
	'chapter_limit' => $setting::page{'article'}{'ChapterLimit'},
	'section_limit' => $setting::page{'article'}{'SectionLimit'},
	'chapter_dir' => $setting::page{'article'}{'ChapterDir'},
	'section_dir' => $setting::page{'article'}{'SectionDir'},
	'link_id' => 'a',
	'tategaki_disabled' => 1,
);
return $template;
}

sub save_this_version ($$) {
my($this,$archives_dir) = @_;
if ($setting::general{'rewindable'}) {
	if ($this->set_dir($archives_dir)) {
		my $ver = $this->time_id;
		my $current_dir = $archives_dir . '/' . $ver;
		$this->write_file(
			$archives_dir . '/.htaccess',
			'Satisfy all' . "\x0A"
				. 'order deny,allow' . "\x0A"
				. 'deny from all' . "\x0A",
			1
		);
		rmtree $current_dir if -d $current_dir;
		if ($this->set_dir($current_dir)) {
			$this->file_directory_copy($default::file,$current_dir . '/files',1);
			$this->home_file_copy($default::home,$current_dir . '/' . (($default::home =~ /([^\/]+)$/) ? $1 : 'index.html'),$default::file,$current_dir . '/files',$ver);
			if ($this->set_dir($current_dir . '/data')) {
				$this->write_file(
					$current_dir . '/data/.htaccess',
					'Satisfy all' . "\x0A"
						. 'order deny,allow' . "\x0A"
						. 'deny from all' . "\x0A",
					1
				);
				$this->write_file(
					$current_dir . '/data/author',
					$this->to_host($ENV{'REMOTE_ADDR'}) . "\x0A" . $ENV{'HTTP_USER_AGENT'} . "\x0A" . (($main::email) ? $main::email : ''),
					1
				);
			}
		}
		if (opendir(DIR, $archives_dir)) {
			my @dir = sort {$this->sort_by(\$a,\$b,'descend')} grep($_ !~ /^\./ && -d $archives_dir . '/' . $_,readdir(DIR));
			closedir(DIR);
			if (($setting::general{'rewindable'} + 1) < @dir) {
				foreach my $n (($setting::general{'rewindable'} + 1)..(@dir - 1)) {
					rmtree $archives_dir . '/' . $dir[$n];
				}
			}
		}
	}
}
}

######################################################################
# ǥ쥯ȥ򥳥ԡ
sub file_directory_copy ($$$;$) {
my($this,$dir,$clone,$skip) = @_;
my(@files,@directories);
local(*DIR);
return unless $this->set_dir($clone) && opendir(DIR,$dir);
while (my $entry = readdir(DIR)) {
	my $path = $dir . '/' . $entry;
	next if $entry =~ /^\./ || $entry eq 'draft.pending' || $entry eq 'archives.pending' || $entry eq 'author' || $entry eq 'data';
	if (-f $path) {
		push(@files,$entry);
	} elsif (-d $path) {
		push(@directories,$entry);
	}
}
closedir(DIR);
foreach my $f (@files) {
	if (!$skip || $f !~ /\.(?:ssi|js|dat)$/ || $f =~ /^\d+\.\w+\.\w+\.dat$/ || !-f $clone . '/' . $f) {
		$this->file_copy($dir . '/' . $f,$clone . '/' . $f);
	}
}
if (@directories) {
	my @clone_directories;
	if (opendir(DIR,$clone)) {
		@clone_directories = grep($_ !~ /^\./ && $_ ne 'draft.pending' && $_ ne 'archives.pending' && $_ ne 'author' && $_ ne 'data' && -d $clone . '/' . $_,readdir(DIR));
		closedir(DIR);
	}
	foreach my $d (@directories) {
		$this->file_directory_copy($dir . '/' . $d,$clone . '/' . $d,$skip);
		@clone_directories = grep($_ ne $d,@clone_directories);
	}
	if (@clone_directories) {
		foreach my $d (@clone_directories) {
			rmtree $clone . '/' . $d;
		}
	}
}
}

sub file_directory_clear ($$) {
my($this,$dir) = @_;
my @delete = $this->fileglob($dir,'^(\d+|i)$','d');
foreach my $d (@delete) {
	rmtree $d;
}
}

sub home_file_copy ($$$$$;$) {
my($this,$source,$copy,$source_file,$copy_file,$info) = @_;
my $data = $this->read_file($source,1);
$this->template_fix(\$data,$source,$copy,$source_file,$copy_file,$info);
return $this->write_file($copy,\$data,1);
}

sub template_fix ($$$$$$;$) {
my($this,$template_ref,$source,$copy,$source_file,$copy_file,$info) = @_;
$$template_ref = Taketori->new->tategaki_to_text($$template_ref) if $$template_ref;

my $here = $ENV{'SCRIPT_NAME'};
my $source_path = $this->path_change($source,$here,'abs');
my $copy_path = $this->path_change($copy,$here,'abs');
my $source_file_path = $this->path_change($source_file,$here,'abs');
my $copy_file_path = $this->path_change($copy_file,$here,'abs');
my $source_file_rel = $this->base_change($source_file,$source);
my $copy_file_rel = $this->base_change($copy_file,$copy);
$$template_ref =~ s/(<[^<>]*\s+(?:href|src|background|action)=["']?)(?!\w+:)([^"\s]+)([^<>]*>)/$1 . $this->path_base_change($2,$source_path,$copy_path,$source_file_path,$copy_file_path,$source_file_rel,$copy_file_rel) . $3/seig;
$$template_ref =~ s/(<param\s+name=["']?(?:src|movie)["']?\s+value=["']?)(?!\w+:)([^"\s]+)([^<>]*>)/$1 . $this->path_base_change($2,$source_path,$copy_path,$source_file_path,$copy_file_path,$source_file_rel,$copy_file_rel) . $3/seig;
$$template_ref =~ s/(<video(?!\w)[^<>]*\s+preview=["']?)(?!\w+:)([^"\s]+)([^<>]*>)/$1 . $this->path_base_change($2,$source_path,$copy_path,$source_file_path,$copy_file_path,$source_file_rel,$copy_file_rel) . $3/seig;
$$template_ref =~ s/<!--#include virtual="\Q$source_file_path\E([^">]*)"-->/<!--#include virtual="$copy_file_path$1"-->/sg;

my $source_url = $this->full_path($source_path);
my $copy_url = $this->full_path($copy_path);
my $source_url_encoded = $this->url_encode($source_url);
my $copy_url_encoded = $this->url_encode($copy_url);
$$template_ref =~ s/\Q$source_url\E/$copy_url/g;
$$template_ref =~ s/\Q$source_url_encoded\E/$copy_url_encoded/g;

my $source_file_url = $this->full_path($source_file_path);
my $copy_file_url = $this->full_path($copy_file_path);
my $source_file_url_encoded = $this->url_encode($source_file_url);
my $copy_file_url_encoded = $this->url_encode($copy_file_url);
my $source_fla_encoded = $this->url_encode($this->base_change($source_file,$env::javascript . '/player'));
my $copy_fla_encoded = $this->url_encode($this->base_change($copy_file,$env::javascript . '/player'));
$$template_ref =~ s/\Q$source_file_url\E/$copy_file_url/g;
$$template_ref =~ s/\Q$source_file_url_encoded\E/$copy_file_url_encoded/g;
$$template_ref =~ s/\Q$source_fla_encoded\E/$copy_fla_encoded/g;

if ($source_file_rel ne $copy_file_rel) {
	my $source_file_rel_encoded = $this->url_encode($source_file_rel);
	my $copy_file_rel_encoded = $this->url_encode($copy_file_rel);
	$$template_ref =~ s/\Q$source_file_rel_encoded\E/$copy_file_rel_encoded/g;
}

if ($info) {
	$info = '<div id="cms-rollback-infomation"><strong>' . $this->date($info,3,$setting::general{'datetype'}) . 'ǡ</strong></div>';
	$$template_ref =~ s/(<body(?!\w)[^>]*>)/$1$info/si;
} else {
	$$template_ref =~ s/<div id="cms-rollback-infomation">.*?<\/div>//si;
}

$$template_ref = Taketori->new->text_to_tategaki($$template_ref,1) if $$template_ref;
}

sub path_base_change ($$$$$$$$) {
my($this,$url,$source,$copy,$source_file,$copy_file,$source_rel,$copy_rel) = @_;
return $url if $url eq '' || $url =~ s/^\Q$source_rel\E/$copy_rel/ || $url =~ s/^\Q$source_file\E/$copy_file/ || $url =~ m!^/! || $url =~ /:/ || $url =~ /\&#58;/ || $url =~ /^#/;
return $this->path_change(
	$this->path_change($url,$source,'abs'),
	$copy,
	'rel'
);
}

######################################################################
# ܾ󹹿
sub tag_replace ($$) {
my($this,$article) = @_;
my $mtime = $this->time_id;

#ȥ빹
if ($setting::page{'article'}{'template'}) {
	my $articletitle = (defined $env::title && $env::title ne '') ? $env::title : '';
	$articletitle .= (($articletitle ne '') ? ':' : '') . $setting::general{'cginame'} if defined $setting::general{'cginame'} && $setting::general{'cginame'} ne '';
	$articletitle .= (($articletitle ne '') ? ':' : '') . $setting::page{'article'}{'title'} if defined $setting::page{'article'}{'title'} && $setting::page{'article'}{'title'} ne '';
	$this->escape(\$articletitle);
	$article =~ s/(<title(?!\w)[^>]*>).*?(<\/title(?!\w)[^>]*>)/$1$articletitle$2/sgi;
}
#$article =~ s/<\!--title(?!\w)([^>]*)-->(.*?)<\!--\/title(?!\w)[^>]*-->/$this->item_tag_replace('title',$1,$2,$setting::general{'cginame'},1)/ges;
$article =~ s/(<\!--index(?!\w)[^>]*-->.*?<\!--\/index(?!\w)[^>]*-->|<\!--title(?!\w)([^>]*)-->(.*?)<\!--\/title(?!\w)[^>]*-->)/(($2 || $3) ? $this->item_tag_replace('title',$2,$3,$setting::general{'cginame'},1) : $1)/ges;
$article = $this->page_item_replace($article,1,$default::home,(($setting::page{'article'}{'title'} ne '') ? $setting::page{'article'}{'title'} : $setting::general{'cginame'}));

#
#$article =~ s/<\!--(mtime)(?!\w)([^>]*)-->.*?<\!--\/mtime-->/$this->date_replace($1,$2,$mtime)/sge;
$article =~ s/(<\!--index(?!\w)[^>]*-->.*?<\!--\/index(?!\w)[^>]*-->|<\!--(mtime)(?!\w)([^>]*)-->(.*?)<\!--\/mtime-->)/(($2) ? $this->date_replace($2,$3,$4,$mtime) : $1)/sge;

#չ
#$article =~ s/<\!--(date)(?!\w)([^>]*)-->.*?<\!--\/date-->/$this->date_replace($1,$2,substr($mtime,0,8))/sge;
$article =~ s/(<\!--index(?!\w)[^>]*-->.*?<\!--\/index(?!\w)[^>]*-->|<\!--(date)(?!\w)([^>]*)-->(.*?)<\!--\/date-->)/(($2) ? $this->date_replace($2,$3,$4,substr($mtime,0,8)) : $1)/sge;

#ġ륢
$article =~ s/<\!--(edit|tool)(?!\w)([^>]*)-->(.*?)<\!--\/\1-->/$this->tools_replace($1,$2,$3)/iges;	

#դ
$article =~ s/<\!--link(?!\w)([^>]*)-->.*?<\!--\/link-->/$this->image_replace($1)/sge;

#ǿ
$article =~ s/<\!--(masternavi)(?!\w)([^>]*)-->(.*?)<\!--\/masternavi-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($env::externalfiles . '\/metaindex.ssi',1,$default::home),1)/iges;
$article =~ s/<\!--(masterrecentcomments)(?!\w)([^>]*)-->(.*?)<\!--\/masterrecentcomments-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($env::externalfiles . '\/recentcomments.ssi',1,$default::home),1)/iges;
$article =~ s/<\!--(masterrecenttrackbacks)(?!\w)([^>]*)-->(.*?)<\!--\/masterrecenttrackbacks-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($env::externalfiles . '\/recenttrackbacks.ssi',1,$default::home),1)/iges;

return $article;
}

sub tools_replace ($$$$) {
my($this,$tag,$setting,$content) = @_;
my($header,$footer) = $this->get_header_and_footer($setting,$content);
$setting =~ s/\s+head="([^"]+)"//sg;
$setting =~ s/\s+foot="([^"]+)"//sg;
$setting = '' if $setting eq '' || $setting !~ /\S/;
my $alt = ($setting =~ / title="([^"]+)"/i) ? $this->unescape($1) : ($tag eq 'edit') ? 'Խ' : 'Ķ';
my($image_type,$image_id) = ($tag eq 'edit') ? ('edit',$setting::page{'editButton'}) : ('tools',$setting::page{'toolButton'});
my $url = $ENV{'SCRIPT_NAME'} . (($tag eq 'tool') ? '?m=Tools' : '');
if ($setting =~ / text="([^"]+)"/i) {
	my $text = $1;
	$content = '<a href="' . $url . '"' . (($setting =~ / class="([^"]+)"/i) ? ' class="' . $this->escape_without_html_entity($1) . '"' : '') . ' title="' . $this->escape_without_html_entity($alt) . '">' . $this->escape_without_html_entity($text) . '</a>';
} else {
	$this->use_deco($default::home);
	$content = $cgi::Deco->button(
		$image_type,
		(($setting =~ / image="(\d+)"/i) ? $1 : $image_id),
		$url,
		$alt,
		'_blank',
	);
}
return '<!--' . $tag . $setting . '-->' . (($header ne '') ? '<!--head-->' . $header . '<!--/head-->' : '') . '<!--data-->' . $content . '<!--/data-->' . (($footer ne '') ? '<!--foot-->' . $footer . '<!--/foot-->' : '') . '<!--/' . $tag . '-->';
}

sub image_replace ($$) {
my($this,$setting) = @_;
my($link_setting,$type,$image,$alt,$location,$target);
$setting = '' if $setting eq '' || $setting !~ /\S/;
$link_setting = $setting;
$this->use_deco($default::home);
$alt = $this->unescape($1) if $setting =~ s/ title="([^"]+)"//gi;
$image = $1 if $setting =~ s/ image="([^"]+)"//gi;
if ($image eq 'indexButton') {
	$type = 'index';
} elsif ($image eq 'returnButton') {
	$type = 'return';
} elsif ($image eq 'topButton') {
	$type = 'index';
	$target = '_top';
}
$location = $this->path_change($1,$this->path_change($default::home,$ENV{'SCRIPT_NAME'},'abs'),'abs') if $setting =~ s/ location\s*=\s*"([^"]+)"//gi;
$target = $1 if $setting =~ s/ target\s*=\s*"([^"]+)"//gi;
return '<!--link' . $link_setting . '-->'
	. $cgi::Deco->button(
		$type,
		$setting::page{$image},
		$location,
		$alt,
		$target,
		$setting
	)
	. '<!--/link-->';
}

sub date_replace ($$;$$$$) {
my($this,$tag,$attributes,$content,$time,$old_mtime) = @_;
my($type,$format,$date_only);
if ($content =~ s/\s*<\!--format(?!\w)[^>]*-->(.*?)<\!--\/format(?!\w)[^>]*-->//si) {
	$format = $1;
	$attributes .= ' format="' . $this->lf_to_entity($this->escape($format)) . '"' unless $attributes =~ s/(\s+format\s*=\s*")[^"]*(")/$1 . $this->lf_to_entity($this->escape($format)) . $2/gesi;
} elsif ($attributes =~ /\s+format\s*=\s*"([^"]+)"/si) {
	$format = $this->unescape($this->entity_to_lf($1));
}
my($header,$footer) = $this->get_header_and_footer($attributes,$content);
$attributes =~ s/\s+head="([^"]+)"//sg;
$attributes =~ s/\s+foot="([^"]+)"//sg;
$attributes = '' if $attributes eq '' || $attributes !~ /\S/;
$date_only = $1 if $attributes && $attributes =~ /\s+dateonly="([12])"/s;
$time = $1 if $old_mtime && $attributes && $attributes =~ /\s+value="([^"]+)"/s;
$time = $this->time_id if !defined $time || !$time; 
$type = ($attributes && $attributes =~ /\s+type="([^"]+)"/s) ? $1 : $setting::general{'datetype'};
$attributes .= ' value="' . $time . '"' unless $attributes =~ s/\s+value="([^"]+)"/ value="$time"/gs;
$type .= ($date_only == 2) ? '>dnw' : '>d' if $date_only;
return '<!--' . $tag . $attributes . '-->' . (($header ne '') ? '<!--head-->' . $header . '<!--/head-->' : '') . $this->date($time,0,$type,$format) . (($footer ne '') ? '<!--foot-->' . $footer . '<!--/foot-->' : '') . '<!--/' . $tag . '-->';
}

######################################################################
# RSSݽ
sub index_sweeper ($;$$) {
my($this,$chap,$sect) = @_;
my($target_url,$target_id);
$target_url = $this->full_path($default::home);
if ($chap) {
	$target_url .= '#a' . sprintf("%.2d", $chap);
	$target_id = $chap;
	if ($sect) {
		$target_url .= sprintf("%.2d", $sect);
		$target_id .= '-' . $sect;
	}
}
require CMONOS::CGI_Lib::IndexSweeper;
IndexSweeper->new(
	'index_files'	=>	[
							$env::externalfiles . '/recentcomments.ssi',
							$env::externalfiles . '/recenttrackbacks.ssi',
						],
	'rss_files'		=>	[
							'../../index.xml',
							'../../comment.xml',
							'../../trackback.xml',
							'../../podcast.xml',
						],
)->sweep([$target_url],{$default::id => ((!$target_id) ? [] : [$target_id])});
}

######################################################################
# 
sub read_html_file ($$;$) {
my $this = shift;
my $data = '';
if (open(FILE, $default::home)) {
	binmode FILE;
	flock(FILE, LOCK_EX);
	$data = join('',<FILE>);
	close(FILE);
	if (!$setting::page{'data'}{'template'}) {
		my $charset = $this->get_charset_from_html(\$data);
		$data = $cgi::Jcode->set(\$data)->euc if $charset && $charset ne 'euc';	
	}
	$data = Taketori->new->tategaki_to_text($data) if $data;
}
return $data;
}

# meta 󤫤ʸɼ
sub get_charset_from_html ($$) {
my($this,$html_ref) = @_;
if ($$html_ref =~ /<head(?!\w)[^>]*>(.*?)<\/head>/is) {
	my $header = $1;
	while ($header =~ /<meta(?!\w)([^>]*)http-equiv="Content-Type"(?!\w)([^>]*)>/sgi) {
		my $contenttype = $1 . $2;
		if ($contenttype =~ / content="(.*?)"/si) {
			$contenttype = $1;
			if ($contenttype =~ /charset=([\w\-]+)/is) {
				return $this->ename_to_jname($1);
			}
		}
	}
}
return '';
}

# 񤭹
sub write_html_file ($$) {
my($this,$data) = @_;
my($key);
local(*OUT);
$data = '' if !defined $data;
$data = Taketori->new->text_to_tategaki($data,1) if $data;
if ($data =~ /<body(?!\w)[^>]*>/is && $data =~ /<html(?!\w)[^>]*>/is) {
	if (!$setting::page{'article'}{'template'}) {
		my $charset = $this->get_charset_from_html(\$data);
		$this->jcode_convert(\$data,$charset,'euc') if $charset && $charset ne 'euc';
	}
} else {
	$key = 'article';
}
if (open(OUT, ">>$default::home")) {
	flock(OUT, LOCK_EX);
	truncate(OUT, 0);
	seek(OUT, 0, 0);
	if ($key) {
		$this->set_canonical($this->full_path($default::home));
		$this->print_page_header($key,\*OUT,$default::home);
		print OUT '<!--article_body-->';
	}
	print OUT $data;
	if ($key) {
		print OUT '<!--/article_body-->';
		$this->print_page_footer($key,\*OUT,$default::home);
	}
	close(OUT);
	return 1;
}
push(@{$this->{'dialog'}},'եν񤭹ߤ˼Ԥޤ');
return 0;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;					#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 1;					#ơ֥ɤ߹
	$setting::page = 1;						#ڡɤ߹

	$setting::field_db_name = 'inputfield';		#եDB
	$setting::field = 2;					#եɤ߹ߡ2=ꥸʥɤ߹
	$setting::field_style_disabled = 0;				#2=եꥹ̵/1=եΤ̵
	$setting::field_tag_enabled = 'tag';				#tag=Τ/all=Ƥ/no=Ĥʤ

	#省
	$setting::security_key = 'edit';			#ǥեȥƥ

	#å
	$cookie::id_enabled = 1;						#ID󥯥åɤ߹
	$cookie::default_enabled = 1;					#桼󥯥åɤ߹
	$cookie::name = 'EDITOR';
	$cookie::path = $ENV{'SCRIPT_NAME'};

	#ǥեȥ
	$main::k = 'edit' if !defined $main::k || !$main::k;

	#ɬܥե
	@setting::form = ('m','k');
	if ($ENV{'QUERY_STRING'} || ($ENV{'REQUEST_METHOD'} eq 'POST' && !$cgi::input->referer_is_me)) {
		undef $main::w;
		undef $main::moveto;
		undef $main::delete;
	}

	#饹Ͽ
	Common::class_register('edit','Editor');

	$setting::page{'edit'}{'title'} = 'Խ';
}

1;
