package HMLUserGeneratedField;
use strict;
######################################################################
# ե⥸塼HomePageMakerLite 桼եɡ
# HMLUserGeneratedField.pm 1.0.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-02-28
######################################################################
sub get_query_for_user_generated_field_editor ($;$$$) {
my($this,$for_post) = @_;
if ($for_post) {
	return $this->add_query('post',
		{
			'm'		=>	'UserGeneratedFieldEditor',
			'k'		=>	'ugfieldeditor',
			'id'	=>	$this->{'id'},
			'chap'	=>	$main::chap,
			'sect'	=>	$main::sect
		}
	);
} else {
	return '?m=UserGeneratedFieldEditor&k=ugfieldeditor&id=' . $this->{'id'} . '&chap=' . $main::chap . '&sect=' . $main::sect;
}
}

sub _mk_user_generated_field_id ($;$$) {
my $this = shift;
return '-' . $main::chap . '-' . $main::sect . '-' . $this->{'id'};
}

sub get_query_keys ($) {
my $this = shift;
return [];
}

sub add_query_for_form ($;$$) {
my($this,$c,$n) = @_;
return $this->add_query(
	'post',
	{
		'm' => 'UserGeneratedFieldUpdater',
		'chap'	=>	$main::chap,
		'sect'	=>	$main::sect
	}
);
}

sub get_output_path ($) {
my $this = shift;
return $default::home;
}

sub is_short_parameters ($) {
return (!$default::home || !$default::file || !defined $main::chap || $main::chap eq '' || !defined $main::sect || $main::sect eq '') ? 1 : 0;
}

sub get_field_data ($) {
my $this = shift;
return $this->get_field_hash_by_id($main::id);
}

sub get_field_hash_by_id ($$) {
my($this,$id) = @_;
return ((ref $this->{'record_hash'}->{$main::chap}->{$main::sect}->{$id}) ? $this->{'record_hash'}->{$main::chap}->{$main::sect}->{$id} : '') if ref $this->{'record_hash'} && ref $this->{'record_hash'}->{$main::chap} && ref $this->{'record_hash'}->{$main::chap}->{$main::sect};
my($template,$article);
$article = $this->read_file($default::home,1);
require CMONOS::CGI_Lib::Template;
$template = Template->new(\%field::obj,\%field::for);
$template->set(
	'field_tag_name' => 'field',
	'chapter' => 'chapter',
	'section' => 'section'
);
$this->{'record_hash'}->{$main::chap}->{$main::sect} = {};
$template->scan(\$article,\$main::chap,\$main::sect,$this->{'record_hash'}->{$main::chap}->{$main::sect});
return ((ref $this->{'record_hash'}->{$main::chap}->{$main::sect}->{$id}) ? $this->{'record_hash'}->{$main::chap}->{$main::sect}->{$id} : '');
}

sub get_file_directory ($) {
my $this = shift;
return ($main::i) ? $default::file . '/i' : $default::file . '/' . $main::chap . '/' . $main::sect;
}

sub get_mail_field_data ($$) {
my($this,$mailto) = @_;
return '' if !ref $field::obj{$mailto} || $field::obj{$mailto}->{'class'} !~ /email/;
my $data = $this->get_field_hash_by_id($mailto);
my($k,$v,@addr);
while (($k,$v) = each %$data) {
	push(@addr,$v);
}
return (@addr) ? join(',',$this->get_address(@addr)) : '';
}

sub get_title_field_data ($$) {
my $this = shift;
return '' if !$field::for{'title'} || !ref $field::obj{$field::for{'title'}};
my $data = $this->get_field_hash_by_id($field::for{'title'});
return ($data->{'str'}) ? $data->{'str'} : '';
}

sub get_viewer_url ($;$$) {
my $this = shift;
return $this->full_path($default::home) . '#a' . sprintf("%.2d", $main::chap) . sprintf("%.2d", $main::sect);
}

sub post_update ($) {
my $this = shift;
if (-d $default::file . '/draft.pending') {
	my $file_name = $this->get_file_directory . '/' . $this->{'id'};
	my $draft_file_name = $default::file . '/draft.pending/files/' . (($main::i) ? 'i' : $main::chap . '/' . $main::sect) . '/' . $this->{'id'};
	$this->file_copy($file_name . '.dat',$draft_file_name . '.dat');
	$this->file_copy($file_name . '.ssi',$draft_file_name . '.ssi');
	$this->file_copy($file_name . '.js',$draft_file_name . '.js');
}
return 1;
}

sub is_secure_user_for_edit ($) {
my $this = shift;
my $is_secure = $this->is_secure_user_for_update;
$this->read_security_settings;
if ($this->is_short_parameters) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Prameters is short.' : 'ɬפǤޤǤ')) if ref $cgi::action;
	$is_secure = 0;
}
$is_secure = 0 if !$this->is_secure('edit',1);
return $is_secure;
}

sub get_rss_path ($) {
my $this = shift;
return ();
}


1;
