package CGIInstaller;
require CMONOS::SetupAssistant::Tools::CGIRegister;
@ISA = qw(CGIRegister);
use strict;
use Fcntl qw(:DEFAULT :flock);
######################################################################
# CGI󥹥ȡ⥸塼
# CGIInstaller.pm ver1.0.7
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-09-25
######################################################################
# ¹
sub run ($) {
my $this = shift;
my($error_flag,$template_name,$date_mode_flag,$multi_mode_flag,$no_file_flag,$no_data_flag,$cart_flag);
$this->get_setup_env;
$this->get_perl_path;
$main::type = '' if !defined $main::type;
$main::name = '' if !defined $main::name;

if (defined $main::a && $main::a) {

	#ϥå
	if ($main::type eq 'tm') {
		$template_name = 'tablemaker';
	} elsif ($main::type eq 'hp_date') {
		$template_name = 'homepagemaker';
		$date_mode_flag = 1;
	} elsif ($main::type eq 'hp_date_multi') {
		$template_name = 'homepagemaker';
		$date_mode_flag = 1;
		$multi_mode_flag = 1;
	} elsif ($main::type eq 'hp') {
		$template_name = 'homepagemaker';
	} elsif ($main::type eq 'hp_multi') {
		$template_name = 'homepagemaker';
		$multi_mode_flag = 1;
	} elsif ($main::type eq 'hp_lite') {
		$template_name = 'homepagemakerlite';
	} elsif ($main::type eq 'bb') {
		$template_name = 'baobab';
	} elsif ($main::type eq 'bb_multi') {
		$template_name = 'baobab';
		$multi_mode_flag = 1;
	} elsif ($main::type eq 'cal') {
		$template_name = 'calendar';
	} elsif ($main::type eq 'cal_multi') {
		$template_name = 'calendar';
		$multi_mode_flag = 1;
	} elsif ($main::type eq 'questionnaire') {
		$template_name = 'questionnaire';
		$no_file_flag = 1;
	#} elsif ($main::type eq 'order' || $main::type eq 'account') {
	} elsif ($main::type eq 'order') {
		if (!$env::session_enabled) {
			push(@{$this->{'dialog'}},'桼󤬥åˤäƵʤˤʤäƤ뤿 å ϥ󥹥ȡǤޤ󡣥˥塼Ρִѹפǥ桼εˡѹƤ');
			$error_flag = 1;
		} else {
			#if ($main::type eq 'order' || -d "../order") {
				$template_name = 'tablemaker';
				$cart_flag = 1;
				push(@{$this->{'dialog'}},'ե̾ ' . $main::type . ' ˸ꤵƤޤ') if $main::name ne $main::type;
				$main::name = $main::type;
			#} else {
			#	push(@{$this->{'dialog'}},'å CGI 󥹥ȡ뤵ƤʤΤ ܵҴǡ١ ϥ󥹥ȡǤޤ');
			#	$error_flag = 1;
			#}
		}
	} else {
		$template_name = $main::type;
		$no_file_flag = 1;
		$no_data_flag = 1;
	}
	if (!defined $template_name || $template_name eq '') {
		push(@{$this->{'dialog'}},'CGI򤷤Ƥ');
		$error_flag = 1;
	}
	$main::name = $this->z_to_h($main::name,'euc') if defined $main::name && $main::name;
	if ($cart_flag) {
		if (-d "../$main::name") {
			push(@{$this->{'dialog'}},$main::name . ' ϴ˥󥹥ȡ뤵Ƥޤ');
			$error_flag = 1;
		}
	} elsif (!defined $main::name || $main::name !~ /^[a-zA-Z][a-zA-Z0-9]{0,20}$/) {
		push(@{$this->{'dialog'}},'ե̾ȾѱѻǻϤޤ20ʸȾѱѿˤƤ');
		$error_flag = 1;
	} elsif ($this->name_is_unavailable($main::name)) {
		push(@{$this->{'dialog'}},'Ϥ줿ե̾ϴ˻ѤƤޤ');
		$error_flag = 1;
	}

	#󥹥ȡ
	if (!defined $error_flag || !$error_flag) {
		my($dir,$clone,$preference_path,$pref_id,$field_id,$default_pref,$default_field,$custom_pref,$custom_field,$confirmation,$default_id);
		$dir = $env::template_dir . '/cgi/' . $template_name;
		$clone = '../' . $main::name;
		$this->set_dir($clone);
		($default_id = $default::http_home_dir . '/' . $main::name) =~ tr!/!_!;
		local(*DIR);
		if (opendir(DIR,$dir)) {
			my(@files,@directories,$entry,$file);
			while ($entry = readdir(DIR)) {
				next if $entry =~ /^\./;
				my $path = $dir . '/' . $entry;
				if (-f $path) {
					push(@files,$entry);
				} elsif (-d $path) {
					push(@directories,$entry);
				}
			}
			closedir(DIR);
			foreach $file (@files) {
				local(*FILE,*COPY);
				my($data);
				if (open(FILE, "$dir/$file")) {
					binmode FILE;
					flock(FILE, LOCK_SH);
					$data = join('',<FILE>);
					close (FILE);
				}
				if ($file =~ /\.cgi$/) {
					$data =~ s/\A#!.*?$/$default::perl_path/m if $default::perl_path;
					$data =~ s/<shared-cgi-data-root>/$default::shared_cgi_data_root/g;
					$data =~ s/<cgi-data-root>/$default::cgi_data_root/g;
					$data =~ s/<cgi-data-path>/$default::cgi_data/g;
				} elsif ($file eq 'default.pl') {
					$data =~ s/<shared-cgi-data-root>/$default::shared_cgi_data_root/g;
					$data =~ s/<cgi-data-root>/$default::cgi_data_root/g;
					$data =~ s/<cgi-data-path>/$default::cgi_data/g;
					$data =~ s/<home-dir>/$default::home_dir/g;
					$data =~ s/<default-id>/$default_id/g;
					$data =~ s/<cgi-name>/$main::name/g;
					if ($date_mode_flag) {
						$data =~ s/\$date = 0/\$date = 1/g;
					#} elsif ($template_name eq 'homepagemaker') {
					#	$data =~ s/^[\x20\x09]*\$external_navi[\x20\x09]*=[^;]*;/\$external_navi = '';/gm;
					} elsif ($cart_flag && $template_name eq 'tablemaker') {
						$data =~ s/^[\x20\x09]*\$type[\x20\x09]*=[^;]*;/\$type = '$main::name';/gm;
						if ($main::name eq 'order') {
							$data =~ s/^[\x20\x09]*\$m[\x20\x09]*=[^;]*;/\$m = 'CartViewer';/gm;
							$data =~ s/^[\x20\x09]*\$k[\x20\x09]*=[^;]*;/\$k = 'cartviewer';/gm;
						} elsif ($main::name eq 'account') {
							$data =~ s/^[\x20\x09]*\$m[\x20\x09]*=[^;]*;/\$m = 'Gate';/gm;
							$data =~ s/^[\x20\x09]*\$k[\x20\x09]*=[^;]*;/\$k = 'gate';/gm;
						}
					}
					$data =~ s/\$subdivided = 0/\$subdivided = 1/g if defined $multi_mode_flag && $multi_mode_flag;
				}
				if (open (COPY, ">>$clone/$file")) {
					binmode COPY;
					flock(COPY, LOCK_EX);
					truncate(COPY, 0);
					seek(COPY, 0, 0);
					print COPY $data;
					close (COPY);
					if ($file =~ /\.(cgi|pl)$/) {
						chmod($env::cgi_file_mode, "$clone/$file");
					} else {
						chmod($env::file_mode, "$clone/$file");
					}
				}
			}
			chmod($env::dir_mode, $clone);
			if (@directories) {
				my $directory;
				foreach $directory (@directories) {
					$this->directory_copy($dir . '/' . $directory,$clone . '/' . $directory,1);
				}
			}
		}
		$this->set_dir('../' . $main::name);
		if ($template_name =~ /^homepagemaker/) {
			$this->set_dir('../../' . $main::name);
			$this->set_dir('../../' . $main::name . '/files') if $template_name eq 'homepagemakerlite';
			if ($template_name eq 'homepagemakerlite') {
				local(*INDEX);
				if (open(INDEX,">> ../../$main::name/index.$env::ssi_ext")) {
					print INDEX "\x0A";
					close(INDEX);
				}
			}
		} else {
			$this->set_dir('../' . $main::name . '/files') if !$no_file_flag;
			$this->set_dir($default::cgi_data . '/data/' . $main::name) if !$no_data_flag;
		}
		$pref_id = $main::pref{$main::type} || '';
		$field_id = $main::field{$main::type} || '';
		$preference_path = $default::cgi_data . '/preferences/' . $main::name;
		$default_pref = $env::default_dir . '/' . (($cart_flag) ? $main::name : $template_name) . (($date_mode_flag) ? '_date' : '');
		$default_field = $env::default_dir . '/' . (($cart_flag) ? $main::name : $template_name) . (($date_mode_flag) ? '_date' : '');
		$custom_pref = (($env::user_default_dir && $pref_id && $pref_id =~ s/^~//) ? $env::user_default_dir : $env::default_dir) . '/' . (($cart_flag) ? $main::name : $template_name) . (($date_mode_flag) ? '_date' : '');
		$custom_field = (($env::user_default_dir && $field_id && $field_id =~ s/^~//) ? $env::user_default_dir : $env::default_dir) . '/' . (($cart_flag) ? $main::name : $template_name) . (($date_mode_flag) ? '_date' : '');
		if ($multi_mode_flag) {
			$default_pref .= '/masterdefault';
			$default_field .= '/masterdefault';
			$custom_pref .= '/masterdefault';
			$custom_field .= '/masterdefault';
		} else {
			$default_pref .= '/default' if -d $default_pref . '/default';
			$default_field .= '/default' if -d $default_field . '/default';
			$custom_pref .= '/default' if -d $custom_pref . '/default';
			$custom_field .= '/default' if -d $custom_field . '/default';
			if ($pref_id && $template_name eq 'calendar') {
				my $ext = $pref_id;
				$ext =~ s/\.default$//;
				my $css = '../' . $main::name . '/files/event-category.css';
				my $default_css = $default_pref . '/css/event-category.' . $ext . '.css';
				my $custom_css = $default_pref . '/css/event-category.' . $ext . '.css';
				$this->file_copy(((-f $custom_css) ? $custom_css : $default_css),$css);
			}
		}
		$default_field .= '/field';
		$custom_field .= '/field';
		my $home_dir_id = $this->get_home_dir_id;
		my $user_directory = $this->home_directory(1);
		my $home_url = $this->full_path('../../',1);
		$this->restore_default_settings($default_pref,$preference_path,0,$home_dir_id,$user_directory,$home_url);
		$this->restore_default_settings($default_field,$preference_path . '/field',0,$home_dir_id,$user_directory,$home_url);
		$this->restore_custom_settings($custom_pref,$preference_path,$pref_id,$home_dir_id,$user_directory,$home_url) if $pref_id;
		$this->restore_custom_settings($custom_field,$preference_path . '/field',$field_id,$home_dir_id,$user_directory,$home_url) if $field_id;
		$this->site_scan;
		$this->checkout_enabled if $cart_flag;
$confirmation = <<SCRIPT;
cmonos.tool.jumpConfirmation = function() {
	if (confirm('$main::nameڡ˰ưޤ')) {
		location.href = '../$main::name/start.cgi?m=Tools';
	}
}
SCRIPT
		$this->set_javascript($confirmation);
		$this->set_onload('cmonos.tool.jumpConfirmation();');
		$main::type = '';
		$main::name = '';
	}
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>CGI 󥹥ȡ顼</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=>	'return confirm(\'ϼäޤ˥󥹥ȡ뤷ޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="1" />';
print '<fieldset><legend>CGI </legend>';

#ơ֥
require CMONOS::CGI_Lib::Table;
my $table = Table->new;
$table->set(
	'tableclass' => 'tooltable',
	'trclass' => 'odd,even',
	'class0' => 'odd,even',
	'style0' => 'text-align: center;,text-align: center;,,,,',
	'thenabled' => 'true',
	'classF' => 'name'					# @bgcolor1ʷ֤
);

my $is_vicuna = (-d $env::css . '/vicuna') ? 1 : 0;

#ɽ
print $table->table;

#إå
print $table->tr;
print $table->td('');
print $table->td('');
print $table->td('CGI');
print $table->td('⡼');
print $table->td('/ե');
print $table->_tr;

#TableMaker
print $table->tr;
print $table->td('<input type="radio" name="type" value="tm"' . (($main::type eq 'tm') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/tablemaker_pen.gif" width="32" height="32" alt="ơ֥᡼" />');
print $table->td('ơ֥᡼<div class="note">ǡ١</div>');
print $table->td('');
print $table->td($this->shared_preference_menu('tm',$main::pref{'tm'},$is_vicuna) . '<br />' . $this->shared_preference_menu('tm',$main::field{'tm'},$is_vicuna,1));
print $table->_tr;

#HPMaker
print $table->tr;
print $table->td('<input type="radio" name="type" value="hp_date"' . (($main::type eq 'hp_date') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/homepagemaker_pen.gif" width="32" height="32" alt="ۡڡ᡼" />');
print $table->td('ۡڡ᡼<div class="note">HTML񤭽Фմ()</div>');
print $table->td('ƥ꡼ʤ');
print $table->td($this->shared_preference_menu('hp_date',$main::pref{'hp_date'},$is_vicuna) . '<br />' . $this->shared_preference_menu('hp_date',$main::field{'hp_date'},$is_vicuna,1));
print $table->_tr;

#HPMaker
print $table->tr;
print $table->td('<input type="radio" name="type" value="hp_date_multi"' . (($main::type eq 'hp_date_multi') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/homepagemaker_pen.gif" width="32" height="32" alt="ۡڡ᡼" />');
print $table->td('ۡڡ᡼<div class="note">HTML񤭽Фմ()</div>');
print $table->td('ƥ꡼');
print $table->td($this->shared_preference_menu('hp_date_multi',$main::pref{'hp_date_multi'},$is_vicuna) . '<br />' . $this->shared_preference_menu('hp_date_multi',$main::field{'hp_date_multi'},$is_vicuna,1));
print $table->_tr;

#HPMaker
print $table->tr;
print $table->td('<input type="radio" name="type" value="hp"' . (($main::type eq 'hp') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/homepagemaker_pen.gif" width="32" height="32" alt="ۡڡ᡼" />');
print $table->td('ۡڡ᡼<div class="note">HTML񤭽Фڥե()</div>');
print $table->td('ƥ꡼ʤ');
print $table->td($this->shared_preference_menu('hp',$main::pref{'hp'},$is_vicuna) . '<br />' . $this->shared_preference_menu('hp',$main::field{'hp'},$is_vicuna,1));
print $table->_tr;

#HPMaker
print $table->tr;
print $table->td('<input type="radio" name="type" value="hp_multi"' . (($main::type eq 'hp_multi') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/homepagemaker_pen.gif" width="32" height="32" alt="ۡڡ᡼" />');
print $table->td('ۡڡ᡼<div class="note">HTML񤭽Фڥե()</div>');
print $table->td('ƥ꡼');
print $table->td($this->shared_preference_menu('hp_multi',$main::pref{'hp_multi'},$is_vicuna) . '<br />' . $this->shared_preference_menu('hp_multi',$main::field{'hp_multi'},$is_vicuna,1));
print $table->_tr;

#HPMaker
print $table->tr;
print $table->td('<input type="radio" name="type" value="hp_lite"' . (($main::type eq 'hp_lite') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/homepagemakerlite_pen.gif" width="32" height="32" alt="ۡڡ᡼Lite" />');
print $table->td('ۡڡ᡼Lite<div class="note">HTML񤭽Фñڡ</div>');
print $table->td('');
print $table->td($this->shared_preference_menu('hp_lite',$main::pref{'hp_lite'},$is_vicuna) . '<br />' . $this->shared_preference_menu('hp_lite',$main::field{'hp_lite'},$is_vicuna,1));
print $table->_tr;

#ХХ
print $table->tr;
print $table->td('<input type="radio" name="type" value="bb"' . (($main::type eq 'bb') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/baobab_pen.gif" width="32" height="32" alt="ХХ" />');
print $table->td('ХХ<div class="note">ĥ꡼Ǽ</div>');
print $table->td('ƥ꡼ʤ');
print $table->td($this->shared_preference_menu('bb',$main::pref{'bb'},$is_vicuna) . '<br />' . $this->shared_preference_menu('bb',$main::field{'bb'},$is_vicuna,1));
print $table->_tr;

#ХХ
print $table->tr;
print $table->td('<input type="radio" name="type" value="bb_multi"' . (($main::type eq 'bb_multi') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/baobab_pen.gif" width="32" height="32" alt="ХХ" />');
print $table->td('ХХ<div class="note">ĥ꡼Ǽ</div>');
print $table->td('ƥ꡼');
print $table->td($this->shared_preference_menu('bb_multi',$main::pref{'bb_multi'},$is_vicuna) . '<br />' . $this->shared_preference_menu('bb_multi',$main::field{'bb_multi'},$is_vicuna,1));
print $table->_tr;

#
print $table->tr;
print $table->td('<input type="radio" name="type" value="cal"' . (($main::type eq 'cal') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/calendar_pen.gif" width="32" height="32" alt="" />');
print $table->td('<div class="note">塼顼</div>');
print $table->td('ƥ꡼ʤ');
print $table->td($this->shared_preference_menu('cal',$main::pref{'cal'},$is_vicuna) . '<br />' . $this->shared_preference_menu('cal',$main::field{'cal'},$is_vicuna,1));
print $table->_tr;

#
print $table->tr;
print $table->td('<input type="radio" name="type" value="cal_multi"' . (($main::type eq 'cal_multi') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/calendar_pen.gif" width="32" height="32" alt="" />');
print $table->td('<div class="note">塼顼</div>');
print $table->td('ƥ꡼');
print $table->td($this->shared_preference_menu('cal_multi',$main::pref{'cal_multi'},$is_vicuna) . '<br />' . $this->shared_preference_menu('cal_multi',$main::field{'cal_multi'},$is_vicuna,1));
print $table->_tr;

#󥿡
print $table->tr;
print $table->td('<input type="radio" name="type" value="daycounter"' . (($main::type eq 'daycounter') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/daycounter.gif" width="32" height="32" alt="󥿡" />');
print $table->td('󥿡<div class="note"></div>');
print $table->td('');
print $table->td($this->shared_preference_menu('daycounter',$main::pref{'daycounter'},$is_vicuna));
print $table->_tr;

#󥱡
print $table->tr;
print $table->td('<input type="radio" name="type" value="questionnaire"' . (($main::type eq 'questionnaire') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/questionnaire.gif" width="32" height="32" alt="󥱡" />');
print $table->td('󥱡<div class="note">ե᡼</div>');
print $table->td('');
print $table->td($this->shared_preference_menu('questionnaire',$main::pref{'questionnaire'},$is_vicuna) . '<br />' . $this->shared_preference_menu('questionnaire',$main::field{'questionnaire'},$is_vicuna,1));
print $table->_tr;

#եɥߥ
print $table->tr;
print $table->td('<input type="radio" name="type" value="feedmixer"' . (($main::type eq 'feedmixer') ? ' checked="checked"' : '') . ' />');
print $table->td('<img src="../../image/station/feedmixer.gif" width="32" height="32" alt="եɥߥ" />');
print $table->td('եɥߥ<div class="note">RSSեɽ</div>');
print $table->td('');
print $table->td($this->shared_preference_menu('feedmixer',$main::pref{'feedmixer'},$is_vicuna));
print $table->_tr;

#ȴϢ
if (!-d "../order") {
	print $table->tr;
	print $table->td('<input type="radio" name="type" value="order"' . (($main::type eq 'order') ? ' checked="checked"' : '') . ' />');
	print $table->td('<img src="../../image/station/checkout_pen.gif" width="32" height="32" alt="å" />');
	print $table->td('å<div class="note">Ȥ</div>');
	print $table->td('ե̾<br />(order)');
	print $table->td($this->shared_preference_menu('order',$main::pref{'order'},$is_vicuna) . '<br />' . $this->shared_preference_menu('order',$main::field{'order'},$is_vicuna,1));
	print $table->_tr;
	
#} elsif (!-d "../account") {
#	print $table->tr;
#	print $table->td('<input type="radio" name="type" value="account"' . (($main::type eq 'account') ? ' checked="checked"' : '') . ' />');
#	print $table->td('<img src="../../image/station/tablemaker_pen.gif" width="32" height="32" alt="ơ֥᡼" />');
#	print $table->td('ܵҴǡ١');
#	print $table->td('ե̾(account)');
#	print $table->td('');
#	print $table->_tr;
}

print $table->_table;
print '</fieldset><fieldset class="submit">';
print '<label for="name" class="datatitle">ե̾</label><input type="text" name="name" size="20" maxlength="20" value="' . $this->escape($main::name) . '" title="ȾѱѻǻϤޤȾѱѿˤޤ" />';
print ' <input type="submit" value="󥹥ȡ" />';
print '</fieldset></form>';

#ڡեå
$this->print_page_footer('tools');
}

#ե̾ʣå
sub name_is_unavailable ($$) {
my($this,$name) = @_;
return ($name eq 'order' || $name eq 'account' || -e '../' . $name || -e '../../' . $name || -e $default::cgi_data . '/preferences/' . $name || -e $default::cgi_data . '/data/' . $name) ? 1 : 0;
}

sub checkout_enabled ($) {
my $this = shift;
my($data,$env_path,$cmonos_js_path);
$env_path = $default::cgi_data . '/lib/env.pl';
$data = $this->read_file($env_path,1);
$this->write_file($env_path,\$data,1) if $data && $data =~ s!^[\x20\x09]*\$checkout[\x20\x09]*=[^;]*;!\$checkout = '../order/start.cgi';!m;

$cmonos_js_path = $env::javascript . '/cmonos.js';
$data = $this->read_file($cmonos_js_path,1);
$this->write_file($cmonos_js_path,\$data,1) if $data && $data =~ s!^//(cmonos\.init\.loadCartJs\(\));!$1!m;
}

sub shared_preference_menu ($$$;$$) {
my($this,$type,$selected,$is_vicuna,$is_field) = @_;
my $template_name = $type;
my $default_path = $template_name;
my $db = '\w+';
if ($type eq 'tm') {
	$template_name = 'tablemaker';
	$default_path = 'tablemaker';
	$db = 'inputfield' if $is_field;
	$selected = 'vicunaPopup.default' if !defined $selected && !$is_field && $is_vicuna;
} elsif ($type eq 'hp_date') {
	$template_name = 'homepagemaker_date';
	$default_path = 'homepagemaker_date/default';
	$selected = 'vicunaBlog.default' if !defined $selected && $is_vicuna;
} elsif ($type eq 'hp_date_multi') {
	$template_name = 'homepagemaker_date';
	$default_path = 'homepagemaker_date/masterdefault';
	$selected = 'vicuna.default' if !defined $selected && $is_vicuna;
} elsif ($type eq 'hp') {
	$template_name = 'homepagemaker';
	$default_path = 'homepagemaker/default';
	$selected = 'vicunaBasic.default' if !defined $selected && !$is_field && $is_vicuna;
} elsif ($type eq 'hp_multi') {
	$template_name = 'homepagemaker';
	$default_path = 'homepagemaker/masterdefault';
	$selected = 'vicuna.default' if !defined $selected && $is_vicuna;
} elsif ($type eq 'hp_lite') {
	$template_name = 'homepagemakerlite';
	$default_path = 'homepagemakerlite';
	$selected = 'vicunaBasic.default' if !defined $selected && $is_vicuna;
} elsif ($type eq 'bb') {
	$template_name = 'baobab';
	$default_path = 'baobab/default';
	$selected = '_vicunize.default' if !defined $selected && !$is_field && $is_vicuna;
} elsif ($type eq 'bb_multi') {
	$template_name = 'baobab';
	$default_path = 'baobab/masterdefault';
	$selected = 'vicuna.default' if !defined $selected && $is_vicuna;
} elsif ($type eq 'cal') {
	$template_name = 'calendar';
	$default_path = 'calendar/default';
	$selected = 'vicunaBasic.default' if !defined $selected && !$is_field && $is_vicuna;
} elsif ($type eq 'cal_multi') {
	$template_name = 'calendar';
	$default_path = 'calendar/masterdefault';
	$selected = 'vicuna.default' if !defined $selected && $is_vicuna;
} elsif ($type eq 'order') {
	$db = 'inputfield' if $is_field;
	$selected = 'vicunaBasic.default' if !defined $selected && !$is_field && $is_vicuna;
} elsif (!defined $selected && $is_vicuna) {
	$selected = 
		($type eq 'daycounter')			?	'vicunaBasic.default'	:
		($type eq 'feedmixer')			?	'_vicunize.default'		:
		($type eq 'questionnaire')		?	($is_field)	?	''		:	'vicunaBasic.default'	:
		'';
}
$default_path .= '/field' if $is_field;

my(%bak);
$this->get_backup_list_hash($default_path,\%bak);
return '' if !%bak;

my $menu_name = (($is_field) ? 'field' : 'pref') . ':' . $type;
my $menu = '<select name="' . $menu_name . '" id="' . $menu_name . '" title="' . (($is_field) ? 'ե򤷤ޤ' : '򤷤ޤ') . '">';
$menu .= '<option value="">ǥեȤ</option>';
foreach my $k (sort keys %bak) {
	next if $k eq 'bak';
	$menu .= '<option value="' . $k . '"' . (($selected && $k eq $selected) ? ' selected="selected"' : '') . '>' . $bak{$k} . '</option>';
}
$menu .= '</select>';
return $menu;
}

sub get_backup_list_hash ($$$) {
my($this,$dir,$bak) = @_;
$this->_get_backup_list_hash($env::default_dir . '/' . $dir,$bak) if $env::default_dir;
$this->_get_backup_list_hash($env::user_default_dir . '/' . $dir,$bak,1) if $env::user_default_dir;
}

sub _get_backup_list_hash ($$$;$) {
my($this,$path,$bak,$user_dir) = @_;
my($db,@files);
if (-d $path) {
	$db = '.*?';
} else {
	($path,$db) = ($1,$2) if $path =~ m!^(.*)/([^/]+)$!;
	$db =~ s/\.([^\/\.]+)$//;
}
$path =~ s!/$!!;
if (opendir(DIR,$path)) {
	@files = grep(-f "$path/$_" && $_ !~ /^\./,readdir(DIR));
	closedir(DIR);
	foreach my $file_name (@files) {
		if ($file_name =~ /^$db\.bak$/) {
			next if defined $$bak{'bak'} && $$bak{'bak'} ne '';
			$$bak{'bak'} = 'ɸ';
		} elsif ($file_name =~ /^$db\.(\w+\.default)$/) {
			my $ext = (($user_dir) ? '~' : '') . $1;
			next if defined $$bak{$ext} && $$bak{$ext} ne '';
			if (open(FILE, "$path/$file_name")) {
				binmode FILE;
				$$bak{$ext} = <FILE>;
				close(FILE);
				chomp $$bak{$ext};
				$$bak{$ext} .= '&lt;ͭ&gt;' if $env::user_default_dir && !$user_dir;
			}
		}
	}
}
}

######################################################################
# ǥ쥯ȥDB
sub restore_custom_settings ($$$$;$$$) {
my($this,$backup_path,$target_path,$ext,$home_dir_id,$user_directory,$home_url) = @_;
my(@restore,$ext_ref);
return if !$ext;
$ext_ref = quotemeta($ext);
local(*DIR);
return unless opendir(DIR,$backup_path);
@restore = grep($_ !~ /^\./ && -f $backup_path . '/' . $_ && $_ =~ /\.$ext_ref$/,readdir(DIR));
closedir(DIR);
return unless $this->set_dir($target_path);
my $error = 0;
my $home_url_encoded = $this->url_encode($home_url);
foreach my $name (@restore) {
	my(%db,$db_path,$bak_path);
	$bak_path = $backup_path . '/' . $name;	
	$db_path = $target_path . '/' . $name;
	$db_path =~ s/\.$ext_ref$//;
	my $data = $this->read_file($bak_path);
	if ($data) {
		tie(%db, $env::dbm_file, $db_path, O_RDWR | O_CREAT, $env::dbm_mode);
		if (ref tied %db) {
			%db = () if $db_path =~ /field$/ && $ext !~ /^_/;	#ꥢ
			while ($data =~ /([^\x09\x0A\x0D]+)\x09([^\x0A\x0D]*)[\x0A\x0D]*/sg) {
				my($k,$v) = ($1,$2);
				$k =~ s/\&#09;/\x09/gs;
				$k =~ s/\x0B/\x0A/gs;
				$v =~ s/\&#09;/\x09/gs;
				$v =~ s/\x0B/\x0A/gs;
				$v =~ s!<home-dir-id>!$home_dir_id!gs;
				$v =~ s/<home-url>/$home_url/gs;
				$v =~ s/<home-url-encoded>/$home_url_encoded/gs;
				$v =~ s!<user-directory>!$user_directory!gs;
				eval '$db{$k} = $v;';
				$error++ if defined $@ && $@;
			}
		}
		untie %db;
	}
}
push(@{$this->{'dialog'}},'̤礭᤮' . $error . '˼Ԥޤ') if $error;
return 1;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('s400','CGIInstaller');

	#˥塼Ͽ
	$setting::jump_menu{'s400'} = 'CGI󥹥ȡ顼';

}



1;
