package SessionSweeper;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# å⥸塼
# SessionSweeper.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ¹
sub run ($) {
my $this = shift;
local(*STORE);
my $session_count = 0;
my $delete_count = 0;
my $expired_time = 0;
my $stat = (defined $main::stat && $main::stat eq 'mtime') ? 9 : 8;
if (!defined $main::sleepdays || $main::sleepdays eq '' || ($main::sleepdays && $this->is_nan($main::sleepdays))) {
	$main::sleepdays = '';
} else {
	$expired_time = time - 86400 * $main::sleepdays;
}

if (opendir(STORE, $env::session_store)) {
	while (my $id = readdir(STORE)) {
		if ($id !~ /^\./) {
			my $session = $env::session_store . '/' . $id;
			if ($expired_time && -f $session && (stat($session))[$stat] <= $expired_time) {
				unlink $session;
				$delete_count++;
			} else {
				$session_count++;
			}
		}
	}
	closedir(STORE);
}
push(@{$this->{'dialog'}},$delete_count . 'Υåޤ') if $expired_time;

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>å</h1>';

if ($session_count) {
	print '<p>ߡ' . $session_count . 'Υå¸Ƥޤ</p>';
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'method'	=>	'post',
		'required'	=>	\@setting::form,
		'onsubmit'	=>	'return confirm(\'ϼäޤ˺ޤ\');',
	);
	print '<fieldset class="delete">';
	print '<input type="text" size="5" name="sleepdays" value="' . $this->escape($main::sleepdays || $env::cookie_lifetime || 30) . '" title="0 ꤹȤ٤ƤΥåޤ" />';
	print 'Ĺ';
	print '<select name="stat" id="stat">';
	print '<option value="atime"' . ((defined $main::stat && $main::stat eq 'atime') ? ' selected="selected"' : '') . '></option>';
	print '<option value="mtime"' . ((defined $main::stat && $main::stat eq 'mtime') ? ' selected="selected"' : '') . '></option>';
	print '</select>';
	print 'Ƥʤå<input type="submit" value="" /></td></tr>';
	print '</fieldset></form>';
} elsif (!$env::session_enabled) {
	print '<p>å̵ǤִѹפѹǤޤ</p>';
} else {
	print '<p>å󤬸Ĥޤ</p>';
}

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);

	#饹Ͽ
	Common::class_register('s305','SessionSweeper');

	#˥塼Ͽ
	$setting::jump_menu{'s305'} = 'å' if !defined $setting::jump_menu{'s305'};

}



1;
