package DetailButton;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# ե⥸塼ʥͥ+ܺ٤򸫤ܥ
# DetailButton.pm 1.1.7
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-12-21
######################################################################
sub _set ($$) {
#no warnings qw(once);
my($this,$setting) = @_;
unless (ref $cgi::Image) {
	require CMONOS::CGI_Lib::Image;
	$cgi::Image = Image->new;
}
unless (ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
$this->{'border'} = '0' if !defined $this->{'border'} || $this->{'border'} eq '';
$this->{'alwaysCopy'} = 1 if !defined $this->{'alwaysCopy'};

#ʣǤϿ
$this->{'elements'} = 1;

#ե륢åץ
if (!$this->{'noThumbnail'}) {
	$cgi::enctype_multipart = 1;
}
return;
}

#	(0)-8 obj->align;
sub align ($) {
my $this = shift;
return 'center';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
return 1;
}

######################################################################
#	(2) obj->form;
sub input_enabled ($) {
my $this = shift;
return ($this->{'noThumbnail'}) ? 0 : 1;
}

sub form {
my($this,$status,$original,$path) = @_;
return '' if $this->{'noThumbnail'} || $this->{'userThumbnailDisabled'};
my($name,$form);

#̾˥ǡID
$name = 'data:' . $this->{'id'};

#եɥ͡+إå
$form = $this->field_header('',$name . ':file');

#ե¸ߤå
($main::data{$this->{'id'}}{'type'},$main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'}) = () unless defined $main::data{$this->{'id'}}{'type'} && -f ((!$cgi::input->{'clipboard_expired'} && $this->{'is_posted_file'}) ? $cgi::input->get_public_clipboard : $path) . '/' . $this->{'id'} . '.' . $main::data{$this->{'id'}}{'type'};

#åץɥե
$form .= '<input type="file" name="' . $name . ':file" id="' . $name . ':file" value="' . $this->escape($main::data{$this->{'id'}}{'file'}) . '"' . (($this->{'is_invalid_field'}{'file'}) ? $this->set_invalid_class : '') . ' />';
$form .= '<div class="note">(&lt; ' . $this->escape($this->{'maxsize'}) . ' byte) </div>' if defined $this->{'maxsize'} && $this->{'maxsize'} > 0;
$form .= '<div class="note">(&lt; ' . (($this->{'widthlimit'}) ? $this->{'widthlimit'} : '&infin;') . '  ' . (($this->{'heightlimit'}) ? $this->{'heightlimit'} : '&infin;') . ' <span class="unit">ԥ</span>) </div>' if $this->{'widthlimit'} || $this->{'heightlimit'};
$form .= '<input type="hidden" name="' . $name . ':width" value="' . $this->escape($main::data{$this->{'id'}}{'width'}) . '" />';
$form .= '<input type="hidden" name="' . $name . ':height" value="' . $this->escape($main::data{$this->{'id'}}{'height'}) . '" />';

#¸եɽ
if ((defined $status && $status ne '' || (!$cgi::input->{'clipboard_expired'} && $this->{'is_posted_file'})) && defined $main::data{$this->{'id'}}{'type'} && $main::data{$this->{'id'}}{'type'} ne '') {
	$form .= '<div class="sample-image">';
	$form .= $cgi::Image->image_tag(
		((!$cgi::input->{'clipboard_expired'} && $this->{'is_posted_file'}) ? $cgi::input->get_public_clipboard : $path) . "/$this->{'id'}.$main::data{$this->{'id'}}{'type'}",
		$main::data{$this->{'id'}}{'width'},
		$main::data{$this->{'id'}}{'height'},
		$this->{'border'},
		$this->{'name'},
		'',
		300,
		300,
	);
	if (!$cgi::input->{'clipboard_expired'} && $this->{'is_posted_file'}) {
		$form .= '<div class="extra-field"><label><input type="checkbox" name="option:' . $this->{'id'} . ':cancel" value="1" /> <strong>̤</strong>ե</label></div>' if !defined $this->{'required'} ||  !$this->{'required'};
	} else {
		$form .= '<div class="extra-field"><label><input type="checkbox" name="' . $name . ':delete" value="1"' . ((!$cgi::input->{'clipboard_expired'} && $main::data{$this->{'id'}}{'delete'}) ? ' checked="checked"' : '') . ' /> Υե</label></div>' if !defined $this->{'required'} ||  !$this->{'required'};
	}
	$form .= '<input type="hidden" name="' . $name . ':type" value="' . $main::data{$this->{'id'}}{'type'} . '" /></div>';
}

$form .= $this->field_footer;
return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my($this,$path) = @_;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
return 1 if defined $this->{'noThumbnail'} && $this->{'noThumbnail'};

my($is_valid,@stat,$name,$width,$height,$type);
$is_valid = 1;

#ܥå͡
$name = 'data:' . $this->{'id'} . ':file';

#¸եξ
if ($path && -d $path) {
	($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'},$main::data{$this->{'id'}}{'type'}) = $this->get_field_file_info(
		$path,
		$main::data{$this->{'id'}}{'width'},
		$main::data{$this->{'id'}}{'height'},
		$main::data{$this->{'id'}}{'type'},
		'',
		'',
		1
	);
} else {
	delete $main::data{$this->{'id'}}{'width'};
	delete $main::data{$this->{'id'}}{'height'};
	delete $main::data{$this->{'id'}}{'type'};
	undef $path;
}

#ե륢åץɥեɤ饳ԡ
if ($main::clipboard_id && !$main::data{$this->{'id'}}{'file'} && !$main::option{$this->{'id'}}{'cancel'}) {
	$cgi::input->inherit_posted_file_properties($name);
}
my %properties = $cgi::input->get_posted_file_properties_from_param($name);
if ($properties{'delete'}) {
	delete $properties{'delete'};
	$cgi::input->set_posted_file_properties_from_param($name,0,\%properties);
}
if ($this->{'copyfrom'} && $env::clipboard && $cgi::Image->image_magick_enabled && ((!$properties{'filename'} && (!$main::data{$this->{'id'}}{'type'} || $main::data{$this->{'id'}}{'delete'} || $this->{'alwaysCopy'})) || $this->{'userThumbnailDisabled'}) && ref $this->{'field_obj'}{$this->{'copyfrom'}} && ($this->{'field_obj'}{$this->{'copyfrom'}}->{'class'} eq 'file' || $this->{'field_obj'}{$this->{'copyfrom'}}->{'class'} eq 'file_shipainter')) {
	if ($cgi::input->get_posted_file_size_from_param('data:' . $this->{'copyfrom'} . ':file') > 0) {
		my @info = $cgi::Image->input_info($cgi::input,'data:' . $this->{'copyfrom'} . ':file',0);
		%properties = $cgi::input->clone_posted_file('data:' . $this->{'copyfrom'} . ':file',$name) if $info[2];
	} elsif ($this->{'field_obj'}{$this->{'copyfrom'}}->{'class'} eq 'file_shipainter' && $main::data{$this->{'copyfrom'}}{'key'} && $main::data{$this->{'copyfrom'}}{'key'} !~ /[^\w\@\-]/s) {
		use Fcntl qw(:flock);
		my $is_valid_header = 1;
		local(*SPD);
		if (open(SPD, $env::clipboard . '/' . $main::data{$this->{'copyfrom'}}{'key'})) {
			binmode SPD;
			flock(SPD, LOCK_EX);
			my $pos = 9;
			my $buf = int($this->{'field_obj'}{$this->{'copyfrom'}}->read_image(\*SPD,1,8));
			if ($buf) {
				my %header = $this->url_decode($this->{'field_obj'}{$this->{'copyfrom'}}->read_image(\*SPD,9,$buf));
				$pos += $buf;
				if ($header{'pch'} && (!$path || $header{'pch'} ne $path . '/' . $this->{'copyfrom'} . '.spch')) {
					$is_valid_header = 0;
				}
			}
			if ($is_valid_header) {
				$buf = int($this->{'field_obj'}{$this->{'copyfrom'}}->read_image(\*SPD,$pos,8));
				$pos += 10; #8Х+CRLF
				if ($buf) {
					my $image = $this->{'field_obj'}{$this->{'copyfrom'}}->read_image(\*SPD,$pos,$buf);
					my($width,$height,$ext,$type) = $cgi::Image->info(\$image);
					$properties{'filename'} = $main::data{$this->{'id'}}{'file'} = 'image.' . $ext;
					$properties{'name'} = $name;
					$properties{'type'} = $type;
					$cgi::input->post_clipboard($name,0,$image,\%properties);
				}
			}
			close(SPD);
		}
	}
}

if ($properties{'filename'}) {

	#źեե뤬ե뤫ɤå
	@stat = $cgi::Image->input_info($cgi::input,$name,0,$this->{'widthlimit'},$this->{'heightlimit'},1,\%properties);
	($width,$height,$type) = @stat if @stat > 2;
	
	#MIME-TYPEå
	if (!defined $type || $type eq '') {
		push(@{$cgi::action->{'dialog'}}, (($this->{'name'}) ? $this->{'name'} : 'ͥ') . 'Υե륿פǧƤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'file'} = 1;
		$is_valid = 0;
	}
	
	#ե륵å
	if (defined $this->{'maxsize'} && $this->{'maxsize'} > 0 && $cgi::input->get_posted_file_size_from_param($name) > $this->{'maxsize'}) {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'ͥ') . 'Υե륵ǧƤ' . $this->{'maxsize'} . 'ХȰˤƤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'file'} = 1;
		$is_valid = 0;
	}

#եͽ
} elsif (!$this->{'required'} && $main::data{$this->{'id'}}{'delete'}) {
	$properties{'delete'} = $this->{'id'};
	$cgi::input->set_posted_file_properties_from_param($name,0,\%properties);
	$cgi::input->parameters_trash(\$main::data{$this->{'id'}}{'width'},\$main::data{$this->{'id'}}{'height'},\$main::data{$this->{'id'}}{'type'});
	delete $main::data{$this->{'id'}}{'file'};
	$this->data('file','delete','width','height','type');
	return 1;

} else {
	($width,$height,$type) = ($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'},$main::data{$this->{'id'}}{'type'});
}
delete $main::data{$this->{'id'}}{'file'};

#å
if ($this->{'widthlimit'} && $width && $width > $this->{'widthlimit'}) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'ͥ') . 'βǧƤ' . $this->{'widthlimit'} . 'ԥˤƤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'file'} = 1;
	$is_valid = 0;
}
if ($this->{'heightlimit'} && $height && $height > $this->{'heightlimit'}) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'ͥ') . 'ι⤵ǧƤ' . $this->{'heightlimit'} . 'ԥˤƤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'file'} = 1;
	$is_valid = 0;
}
return 0 if !$is_valid;

#ǡ
my($w,$h,$t);
($w,$h,$t) = ($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'},$main::data{$this->{'id'}}{'type'});
($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'},$main::data{$this->{'id'}}{'type'}) = ($width,$height,$type);
$this->data('delete');

#ϤΥå
if (!$this->is_not_empty('type')) {
	($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'},$main::data{$this->{'id'}}{'type'}) = ($w,$h,$t);
	$this->{'is_invalid_field'}{'file'} = 1;
	return 0;
}

#¸ͽ
if ($properties{'filename'}) {
	$mail::file .= '<' . $name . '>,' if defined $this->{'mail'} && $this->{'mail'};		#᡼źͽ
	$cgi::input->save_file($name,'!' . $this->{'id'} . '.' . $main::data{$this->{'id'}}{'type'});
	$this->{'is_posted_file'} = 1;
}

return 1;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=ɽǡ/path=ե¸ǥ쥯ȥ/category=ƥ꡼/no=쥳No
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
my(%data,$image,$href,$option,$target,$ct);
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
if (!defined $cgi::path || $cgi::path eq '') {
	$cgi::path = $ENV{'SCRIPT_NAME'};
	$cgi::path = $env::cgi_server . $cgi::path if defined $env::cgi_server && $env::cgi_server;
}
if (@main::c && @main::c > 1) {
	foreach (@main::c) {
		$ct .= '&ct=' . $_;
	}
}
$href = $cgi::path . '?m=DetailViewer&k=detail' . (($this->{'dn'}) ? '&dn=' . $this->{'dn'} : '') . ((defined $c) ? '&c=' . $c : '') . ((defined $n) ? '&n=' . $n : '') . (($ct) ? $ct : '') . $this->set_query('url+',['mod','s','w','f','u','uni','and','search','q','fv']);
if (!defined $this->{'sameWindow'} || !$this->{'sameWindow'}) {
	$option = 'onclick="if(typeof cmonos == \'object\'){cmonos.window.open(\'detailViewer\',' . (($this->{'windowWidth'}) ? $this->{'windowWidth'} : '640') . ',' . (($this->{'windowHeight'}) ? $this->{'windowHeight'} : '480') . ')}else{window.open(\'\',\'detailViewer\',\'width=' . (($this->{'windowWidth'}) ? $this->{'windowWidth'} : '640') . ',height=' . (($this->{'windowHeight'}) ? $this->{'windowHeight'} : '480') . ',scrollbars=yes,resizable=yes\')} return true"';
	$target = 'detailViewer';
}

#
if (!$this->{'noThumbnail'} && defined $data{'type'} && $data{'type'} ne '') {
	$href = '<a href="' . $this->escape($href) . '"' . (($target) ? ' target="detailViewer"' : '') . ' title="' . $this->escape($this->name(1)) . '" ' . (($option) ? $option : '');
	$href .= '>' . $cgi::Image->image_tag(
		"$path/$this->{'id'}.$data{'type'}",
		$data{'width'},
		$data{'height'},
		$this->{'border'},
		$this->name(1),
		'',
		'',
		'',
		$cgi::output,
		$cgi::output_option,
	) . '</a>';

} elsif ($this->{'button'} && $main::m ne 'KMLViewer') {
	$href = $cgi::Deco->button(
		'detail',
		$this->{'button'},
		$href,
		$this->name(1),
		$target,
		$option,
		$cgi::output_option
	);

} else {
	$href = '<a href="' . $this->escape($href) . '"' . (($target) ? ' target="detailViewer"' : '') . ((defined $option) ? ' ' . $option : '');
	$href .= '>' . $this->escape($this->name(1)) . '</a>';
}
return $this->field_tag($this->data_tag_from_ref(\%data) . $href);
}

sub has_content {
my($this,$str,$type) = @_;
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return (!$type || $type ne 'detail' || (!$this->{'noThumbnail'} && defined $data{'type'} && $data{'type'} ne '')) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
my $this = shift;
return 0;
}

sub format_for_mail {
my($this,$str) = @_;
return '';
}

#---------------------------------------------------------------------
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail_enabled ($) {
my $this = shift;
return ($this->{'noThumbnail'} || $this->{'hideThumbnail'}) ? 0 : 1;
}

sub format_for_detail {
my($this,$str,$path,$c,$n) = @_;
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
if (!$this->{'noThumbnail'} && defined $data{'type'} && $data{'type'} ne '') {
	return $cgi::Image->image_tag(
		"$path/$this->{'id'}.$data{'type'}",
		$data{'width'},
		$data{'height'},
		$this->{'border'},
		$this->name(1),
		'',
		'',
		'',
		$cgi::output,
		$cgi::output_option
	);
} else {
	return '';
}
}

#	(4)-4 obj->format_for_text(str);
sub format_for_text_enabled ($) {
my $this = shift;
return 0;
}

sub format_for_text {
my($this,$str) = @_;
return '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$;$) {
my($this,$str,$path) = @_;
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
my $out = '';
if (defined $data{'type'} && $data{'type'} ne '') {
	$out .= $cgi::Image->image_tag(
		((!$cgi::input->{'clipboard_expired'} && $this->{'is_posted_file'}) ? $cgi::input->get_public_clipboard : $path) . "/$this->{'id'}.$data{'type'}",
		$data{'width'},
		$data{'height'},
		$this->{'border'},
		$this->{'name'},
		'',
		300,
		300,
	);
	if ($main::data{$this->{'id'}}{'delete'} && !$this->{'required'} && !$this->{'is_posted_file'}) {
		$out .= '<div class="note">Υե</div>';
	}
}
return $out;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my $this = shift;

#̾
my $name = 'data:' . $this->{'id'};

$this->{'maxsize'} = '30000' if !defined $this->{'maxsize'} || !$this->{'maxsize'};
$this->print_field_info_form($name);

print '<fieldset>';
if ($default::detail_variation >= 2) {
	print '<legend><label for="' . $name . '_dn">ܺɽɥڡ쥤</label></legend>';
	print '<select name="' . $name . '_dn" id="' . $name . '_dn">';
	print '<option value="">ܺɽڡ</option>';
	foreach (2..$default::detail_variation) {
		print '<option value="' . $_ . '"' . ((defined $this->{'dn'} && $this->{'dn'} eq $_) ? ' selected="selected"' : '') . '>ܺɽڡ' . $_ . '</option>';
	}
	print '</select>';
} else {
	print '<legend>ܺɽɥ</legend>';
}
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_sameWindow" id="' . $name . '_sameWindow" value="1"' . ((defined $this->{'sameWindow'} && $this->{'sameWindow'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'windowsize\').disappear(this.checked)" /> ̥ɥ򳫤Ʊɥɽ</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_hideThumbnail" id="' . $name . '_hideThumbnail" value="1"' . ((defined $this->{'hideThumbnail'} && $this->{'hideThumbnail'}) ? ' checked="checked"' : '') . ' /> ܺٲ̤Ǥϥͥɽʤ</label></li>';
print '</ol>';
print '<fieldset id="windowsize">';
print '<legend>ɥ(Ʊɥɽ̵)</legend>';
print '<label> <input type="text" name="' . $name . '_windowWidth" id="' . $name . '_windowWidth" value="' . $this->escape($this->{'windowWidth'}) . '" size="7" maxlength="7" /> <span class="unit">ԥ</span></label> ';
print '&times; <label>⤵ <input type="text" name="' . $name . '_windowHeight" id="' . $name . '_windowHeight" value="' . $this->escape($this->{'windowHeight'}) . '" size="7" maxlength="7" /> <span class="unit">ԥ</span></label> ';
print '</fieldset>';
print $this->javascript('cmonos.element.item(\'windowsize\').disappear(true)') if $this->{'sameWindow'};
print '</fieldset>';
print '<fieldset>';
print '<legend>ܺɽܥ</legend>';

print '<div class="hints">ͤĶ硢źդ䤷ޤ</div>';
print '<table class="field-table">';
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_noThumbnail">ͥɽ</label></td>';
print '<td class="field" colspan="3"><input type="checkbox" name="' . $name . '_noThumbnail" id="' . $name . '_noThumbnail" value="1" ' . ((defined $this->{'noThumbnail'} && $this->{'noThumbnail'}) ? ' checked="checked"' : '') . ' />';
print '<span class="hints">åȥ̵꤬ͥˤʤޤ</span>';
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_maxsize">ե륵</label></td>';
print '<td class="field" colspan="3"><input type="text" name="' . $name . '_maxsize" id="' . $name . '_maxsize" value="' . $this->escape($this->{'maxsize'}) . '" size="16" /> <span class="unit">byte</span>';
print '<div class="hints">̵꤬硢30,000byte30kBˤꤵޤ</div>';
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '"></label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_widthlimit" id="' . $name . '_widthlimit" value="' . $this->escape($this->{'widthlimit'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
print '<td class="field-name"><label for="' . $name . '">⤵</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_heightlimit" id="' . $name . '_heightlimit" value="' . $this->escape($this->{'heightlimit'}) . '" size="4" /> <span class="unit">ԥ</span>';
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">Υ᡼</span></td>';
print '<td class="field" colspan="3"><label><input type="checkbox" name="' . $name . '_mail" id="' . $name . '_mail" value="1" ' . ((defined $this->{'mail'} && $this->{'mail'}) ? ' checked="checked"' : '') . ' /> Υ᡼˥ͥեźդ</label></td>';
print '</tr>';
print '</tbody></table>';
if ($cgi::Image->image_magick_enabled) {
	print '<fieldset>';
	print '<legend><label for="' . $name . '_copyfrom">ͥʤȤΥեɤ饵ͥ</label></legend>';
	print '<select name="' . $name . '_copyfrom" id="' . $name . '_copyfrom">';
	print '<option value=""></option>';
	my $is_following = 0;
	foreach my $id (sort {$this->{'field_obj'}->{$a}->{'ORDER'} <=> $this->{'field_obj'}->{$b}->{'ORDER'} || $a <=> $b} keys %{$this->{'field_obj'}}) {
		if (ref $this->{'field_obj'}{$id} && ($this->{'field_obj'}{$id}->{'class'} eq 'file' || $this->{'field_obj'}{$id}->{'class'} eq 'file_shipainter')) {
			print '<option value="' . $id . '"' . ((defined $this->{'copyfrom'} && $this->{'copyfrom'} eq $id) ? ' selected="selected"' : '') . '>' . $this->jfold($this->{'field_obj'}{$id}->name,32,'I',1) . '</option>';
		}
	}
	print '</select>';
	print '<div class="extra-field"><label><input type="checkbox" name="' . $name . '_alwaysCopy" value="1"' . (($this->{'alwaysCopy'}) ? ' checked="checked"' : '') . ' /> ǽʤоˤΥեɤβǸߤΥͥ񤭤롣</label></div>';
	print '<div class="extra-field"><label><input type="checkbox" name="' . $name . '_userThumbnailDisabled" value="1"' . (($this->{'userThumbnailDisabled'}) ? ' checked="checked"' : '') . ' /> ˤΥեɤ򥵥ͥˤ롣</label></div>';
	print '</fieldset>';
}

print '<fieldset>';
print '<legend><label for="' . $name . '_button">ǥեȥܥ</label></legend>';

#ܥ˥塼
print $cgi::Deco->button_menu(
	$name . '_button',
	'detail',
	120,
	$this->{'button'}
);
print '</fieldset></fieldset>';
$this->print_setting_save_button;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my $is_valid = $this->is_valid_file_setting;
if (defined $main::data{$this->{'id'} . '_windowWidth'} && $main::data{$this->{'id'} . '_windowWidth'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_windowWidth'})) {
	push(@{$cgi::action->{'dialog'}},'ܺɽɥ򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_windowWidth'};
	$is_valid = 0;
}
if (defined $main::data{$this->{'id'} . '_windowHeight'} && $main::data{$this->{'id'} . '_windowHeight'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_windowHeight'})) {
	push(@{$cgi::action->{'dialog'}},'ܺɽɥ⤵򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_windowHeight'};
	$is_valid = 0;
}

#åܥå
$main::data{$this->{'id'} . '_noThumbnail'} = '' if !defined $main::data{$this->{'id'} . '_noThumbnail'} ||  $main::data{$this->{'id'} . '_noThumbnail'} eq '';
$main::data{$this->{'id'} . '_sameWindow'} = '' if !defined $main::data{$this->{'id'} . '_sameWindow'} ||  $main::data{$this->{'id'} . '_sameWindow'} eq '';
$main::data{$this->{'id'} . '_hideThumbnail'} = '' if !defined $main::data{$this->{'id'} . '_hideThumbnail'} ||  $main::data{$this->{'id'} . '_hideThumbnail'} eq '';
$main::data{$this->{'id'} . '_userThumbnailDisabled'} = '' if !defined $main::data{$this->{'id'} . '_userThumbnailDisabled'} || !$main::data{$this->{'id'} . '_userThumbnailDisabled'};
$main::data{$this->{'id'} . '_alwaysCopy'} = '0' if !$main::data{$this->{'id'} . '_alwaysCopy'};
$cgi::enctype_multipart = 1 if !defined $this->{'noThumbnail'} || !$this->{'noThumbnail'};

$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
return $is_valid;
}

######################################################################
#	(6) obj->search_form;
sub search_form_enabled ($) {
my $this = shift;
return 0;
}

sub search_form ($) {
my $this = shift;
return;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#sub import {
BEGIN {
if (!$setting::field_for_mail) {
	#no warnings qw(once);
	Field::class_register('xtm_detail','DetailButton','ܺ/ͥ');
	$setting::deco_dir{'detail'} = 'ܺ٥ܥ';
	$setting::deco_type{'detail'} = 'button';
}
}

1;
