package Input;
require CMONOS::TableMaker::InputBase;
@ISA = qw(InputBase);
use strict;
######################################################################
# ǡϥ⥸塼
# Input.pm ver1.1.12
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-08-12
######################################################################
sub update ($) {
my $this = shift;
my($input_is_valid,$input_only_user);
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

#쥳ֹǧ
if (defined $main::n && $main::n =~ /^\d+$/) {
	my(%mtime);
	tie(%mtime, $env::dbm_file, "$default::db/$main::c/mtime", O_RDONLY, $env::dbm_mode);
	$main::n = '' unless ref tied %mtime && $mtime{$main::n};
	untie(%mtime);
} else {
	$main::n = '';
}

#ǡϥѥɥå
if ($setting::security_key eq 'revise' && $main::n eq '') {
	$setting::security_key = 'input';
	$this->unauthorized_alert if !$this->is_secure($setting::security_key,1);
}

#󥯸
if (!defined $cgi::path || $cgi::path eq '') {
	$cgi::path = $ENV{'SCRIPT_NAME'};
	$cgi::path = $env::cgi_server . $cgi::path if defined $env::cgi_server && $env::cgi_server;
}
if (!defined $main::mod || $main::mod ne 'KMLViewer') {
	$this->{'referer_url'} = $cgi::path . '?m=' . ((defined $main::mod) ? $main::mod : 'Gate');
	if (@main::ct && grep($_ =~ /(^|,)$main::c(,|$)/,@main::ct)) {
		$this->{'referer_url'} .= '&c=' . $_ foreach @main::ct;
	} elsif (defined $main::ct && $main::ct ne '' && $main::ct =~ /(^|,)$main::c(,|$)/) {
		$this->{'referer_url'} .= '&c=' . $main::ct;
	} else {
		$this->{'referer_url'} .= '&c=' . $main::c;
	}
	$this->{'referer_url'} .= ((defined $main::n) ? '&n=' . $main::n : '') . $this->set_query('url+',['s','w','f','u','uni','and','search','q','fv']);
} else {
	$this->{'referer_url'} = '';
}

#ƥ꡼ư
if (defined $main::n && $main::n ne '' && (!$default::type || $default::type ne 'order') && $this->is_secure('input') && ($main::copy || (defined $main::moveto && $main::moveto ne '' && $main::c ne $main::moveto && ref $setting::category{$main::moveto}))) {
	$main::moveto = $main::c if !defined $main::moveto || $main::moveto eq '' || !ref $setting::category{$main::moveto};
	($main::c,$main::n) = $this->record_move_to($main::moveto,$main::c,$main::n,$main::copy);
}

#ɤ߹
$main::a = '' if $main::delete || !%main::data;
$this->dbm if !$main::a && $main::n ne '';
if ($field::NAMECHECK && $field::for{'name'} && !defined $main::data{$field::for{'name'}}{'str'} && $this->use_register) {
	$main::data{$field::for{'name'}}{'str'} = $cgi::Register->email_to_name($main::pswd,$main::email,$security::registered);
}

#ǡѥɥå
$input_only_user = $this->is_input_only_user;


#ǡ
if ($main::delete && $main::n ne '' && !$input_only_user && $this->is_secure('delete',0,'revise') && (!$default::type || $default::type ne 'order' || $this->is_secure('tools'))) {

#	#EMailǡ١
#	if ($default::type eq 'account') {
#		my(%email_to_id);
#		tie(%email_to_id, $env::dbm_file, $default::db . '/email_to_id', O_RDWR | O_CREAT, $env::dbm_mode);
#		if (ref tied %email_to_id) {
#			delete $email_to_id{$main::data{$field::for{'mail'}}{'str'}};
#		}
#		untie %email_to_id;
#	}

	my(%category,%pending,$nocount);
	tie(%pending, $env::dbm_file, "$default::db/$main::c/pending", O_RDONLY, $env::dbm_mode);
	if (ref tied %pending) {
		$nocount = 1 if ref tied %pending && $pending{$main::n} && $pending{$main::n} =~ /^1/;
	}
	untie %pending;

	#ǡ
	$this->delete_all_data("$default::db/$main::c",$main::n);

	#쥳ɿ
	tie(%category, $env::dbm_file, $default::preference_dir . '/category', O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %category) {
		$category{$main::c . '_count'}-- if !$nocount && $category{$main::c . '_count'};
		$category{$main::c . '_total'}-- if $category{$main::c . '_total'};
		$setting::category{$main::c}{'total'} = $category{$main::c . '_total'} || 0;
		$setting::category{$main::c}{'count'} = $category{$main::c . '_count'} || 0;
	}
	untie %category;
	$this->write_category_list;

	#źեե
	use File::Path;
	rmtree "$default::file/$main::c/$main::n";

	#ǥå
	$this->index_sweeper($main::c,$main::n);

	if ($main::ajax) {
		$this->print_response({'status' => 'success'});
		exit;
	}
	
	#ڡإå
	$this->set_onload('cmonos.window.refreshOpener(\'' . $this->escape($this->{'referer_url'}) . '\',false)');
	$this->print_page_header('input');
	print '<p>ޤ</p>';
	$this->print_contents_footer;
	$this->print_page_footer('input');
	exit;
	
} elsif (defined $main::delete && $main::delete) {
	if ($input_only_user || !$this->is_secure('delete',0,'revise') || ($default::type && $default::type eq 'order' && !$this->is_secure('tools'))) {
		push(@{$this->{'dialog'}},'˼Ԥޤ¤ޤ');
	} elsif (!$input_only_user) {
		push(@{$this->{'dialog'}},'˼Ԥޤоݥ쥳ɤꤵƤޤ');
	}
	if ($main::ajax) {
		$this->print_response({'status' => 'error','message' => join('',@{$this->{'dialog'}})});
		exit;
	}


#ϤΥå
} elsif ($main::a eq 'w') {
	$input_is_valid = $this->input_is_valid;

	#EMAILå
	if ((!defined $main::n || $main::n eq '') && (!defined $setting::security{'revise'}{'passwordCheck'} || $setting::security{'revise'}{'passwordCheck'} ne 'nocheck') && $this->is_secure('revise') && $this->is_registered_email && !$this->is_secure_email && $this->email_field_enabled) {
		push(@{$this->{'dialog'}},'Ͽ᡼륢ɥ쥹ߤĤޤ');
		$main::data{$field::for{'mail'}}{'str'} = $main::email if $field::for{'mail'} && defined $main::data{$field::for{'mail'}}{'str'} && $main::data{$field::for{'mail'}}{'str'} ne '';
		$input_is_valid = 0;
	}

#	#ܵҾDB
#	if ($default::type && $default::type eq 'account') {
#
#		#EMailեɥå
#		if ($field::for{'mail'} && defined $main::data{$field::for{'mail'}}{'str'} && $main::data{$field::for{'mail'}}{'str'} ne '') {
#			if ($this->is_invalid_email_address($main::data{$field::for{'mail'}}{'str'})) {
#				push(@{$this->{'dialog'}},$field::obj{$field::for{'mail'}}->name . 'ϡ᡼륢ɥ쥹ĤꤷƤ');
#				$input_is_valid = 0;
#			}
#		} elsif (defined $field::for{'mail'} && $field::for{'mail'}) {
#			push(@{$this->{'dialog'}},$field::obj{$field::for{'mail'}}->name . 'ϡ᡼륢ɥ쥹ꤷƤ');
#			$input_is_valid = 0;
#		} else {
#			push(@{$this->{'dialog'}},'ɽ᡼륢ɥ쥹եɤޤ');
#			$input_is_valid = 0;
#		}
#
#		#EMailǡ١񤭴
#		if ($this->{'old_pswd'} && $this->{'old_email'}) {
#			if ($input_is_valid) {
#				if ($cgi::Register->remove($this->{'old_pswd'},$this->{'old_email'})) {
#					push(@{$this->{'dialog'}},'ޤϿƤ᡼륢ɥ쥹' . $this->{'old_email'} . 'ˤäޤ');
#					$cgi::Register->success_dialog;
#				}
#				undef $main::shift_flag;
#				my(%email_to_id);
#				tie(%email_to_id, $env::dbm_file, $default::db . '/email_to_id', O_RDWR | O_CREAT, $env::dbm_mode);
#				if (ref tied %email_to_id) {
#					delete $email_to_id{$this->{'old_email'}} if $cgi::Register->is_registered($this->{'old_pswd'},$this->{'old_email'});
#					$email_to_id{$main::data{$field::for{'mail'}}{'str'}} = $main::n;
#				}
#				untie %email_to_id;
#			} else {
#				push(@setting::form,'old_pswd','old_email');
#			}
#		}
#	}

	#̾å
	if ($field::NAMECHECK && $field::for{'name'} && defined $main::data{$field::for{'name'}}{'str'} && $main::data{$field::for{'name'}}{'str'} ne '' && $this->use_register) {
		if ($main::shift_flag && $this->{'old_pswd'} && $this->{'old_email'}) {
			if ($input_is_valid) {
				if ($cgi::Register->remove($this->{'old_pswd'},$this->{'old_email'})) {
					push(@{$this->{'dialog'}},'ޤϿƤ᡼륢ɥ쥹' . $this->{'old_email'} . 'ˤäޤ');
					$cgi::Register->success_dialog;
				}
			} else {
				push(@setting::form,'shift_flag','old_pswd','old_email');
			}
		}
		if ($input_is_valid) {
			my($name,$fontcolor);
			$name = $main::data{$field::for{'name'}}{'str'};
			$fontcolor = $1 if $name =~ s/<>([#0-9a-zA-z]{3,10})\Z//s;
			if (defined $name && $name ne '' && !$this->is_same_name_and_email($main::n,$name)) {
				if ((!defined $main::n || $main::n eq '' || $this->is_secure_email) && $cgi::Register->is_available_name($main::pswd,$main::email,$name,$security::registered)) {
					push(@{$this->{'dialog'}},$cgi::Register->success_dialog);
				} else {
					my @msg = $cgi::Register->error_dialog;
					push(@{$this->{'dialog'}},((@msg) ? @msg : 'ǧڤɬפʥ᡼륢ɥ쥹ѹޤ'));
					$main::data{$field::for{'name'}}{'str'} = $name . ((defined $fontcolor && $fontcolor ne '') ? '<>' . $fontcolor : '');
					if ($this->{'old_email'}) {
						push(@{$this->{'dialog'}},'ϤϳꤷƤޤ');
					} else {
						$input_is_valid = 0;
					}
				}
			}
		}
	}

	#ϥ顼 or 󥻥
	if (!$input_is_valid || $main::cancel) {

	#ǧ
	} elsif ($main::n eq '') {
		if (!$setting::general{'skipConfirmation'} && $input_only_user && !$cgi::confirmation_disabled && !$cgi::ssl_required && !$main::ok) {
			$this->print_page_header('input');		
			print '<p id="form-confirmation">' . (($default::english) ? 'Confirmation.' : 'Ƥ꤬ʤС¸ץܥ򲡤Ƥ') . '</p>';
			$this->print_confirmation_table(1);
			$this->print_contents_footer;
			$this->print_page_footer('input');
			exit;

		#Ͽ
		} else {
			$main::n = $this->new_record_number(1);
			$this->{'new_data'} = 1;
		}
	}

#
} elsif ($main::n eq '') {
	$this->new_record_number;

}

#񤭹/Ϥι
if ($input_is_valid && (!$input_only_user || $this->{'new_data'})) {
	$this->dbm;
	$this->notice_mail_for_master('ǡϤޤ','ǡϤޤ',\%field::obj,(($setting::general{'data'}) ? \%main::data : '')) if $this->{'new_record'};
	$this->write_category_list;
	$this->{'is_written'} = 1;
} elsif (!$input_only_user) {
	$this->dbm(1);
}

#ǡѥɥå
if ($main::n ne '' && $input_only_user) {

	#
	if (defined $this->{'new_data'} && $this->{'new_data'}) {
		$this->set_onload('cmonos.window.refreshOpener(\'' . $this->escape($this->{'referer_url'}) . '\',false)');
		$this->thanks;

	#üʥ
	} elsif ($input_only_user ne '1') {
		$this->print_dialog($setting::key,$input_only_user);


	#ѥɥå
	} elsif ($main::a && $main::a eq 'w') {
		$this->print_password_check_form(
			'input',
			(($this->{'user_address'}) ? $this->{'user_address'} : 'none'),
			(($this->{'need_new_pswd'}) ? $this->{'need_new_pswd'} : 0)
		);
		return;
	} else {
		$this->print_password_check_form('input');
		return;
	}
}

#ڡإå
$this->import_db($default::preference_dir . '/category',\%setting::category,1) if !%setting::category;
$this->push_window_title($setting::category{$main::c}{'name'}) if keys %{$setting::category{'ORDER'}} > 1 && defined $setting::category{$main::c}{'name'} && $setting::category{$main::c}{'name'} ne '';
$this->set_onload('cmonos.window.refreshOpener(\'' . $this->escape($this->{'referer_url'}) . '\',false)') if $input_is_valid && !$main::cancel;
}

sub print_submit_button_in_table ($) {
my $this = shift;
print '<tbody><tr class="tbody-start">';
print '<td class="submit-box" colspan="2">';
if (defined $main::n && $main::n ne '') {
	print '<div id="submit-button">';
	print '<label title="Υ쥳ɤ̤Υ쥳ɤȤ¸ޤ"><input type="checkbox" name="copy" value="1" />ԡ</label> ' if (!$default::type || $default::type ne 'order') && $this->is_secure('input');
}
print '<label title="ƱƤϤ뤳Ȥ¿Ĥιܤ򵭲ޤ"><input type="checkbox" name="set_cookie" value="1"' . (($cookie::read{$cookie::name} || $main::set_cookie) ? ' checked="checked"' : '') . ' />򵭲</label> ' if defined $cookie::enabled && $cookie::enabled;
print '<input type="submit" name="submit_button" value="¸" class="save" />';
print '</div>' if defined $main::n && $main::n ne '';
print '<div id="delete-button"><input type="submit" name="delete=1" value="" onclick="return confirm(\'ϼäޤ˺ޤ\')" /></div>' if defined $main::n && $main::n ne '' && $this->is_secure('delete',0,'revise') && (!$default::type || $default::type ne 'order' || $this->is_secure('tools'));
print '</td></tr></tbody>';
}

sub print_submit_button ($) {
my $this = shift;
if (defined $main::n && $main::n ne '' && (!$default::type || $default::type ne 'order') && $this->is_secure('input') && keys %{$setting::category{'ORDER'}} > 1) {
	my $menu = '';
	foreach my $o (sort {$a <=> $b} keys %{$setting::category{'ORDER'}}) {
		my $c = $setting::category{'ORDER'}{$o};
		if ($c ne $main::c && ref $setting::category{$c} && (!$setting::category{$c}{'total'} || $setting::category{$c}{'total'} < $setting::category{'LIMIT'})) {
			$menu .= '<option value="' . $c . '">' . $setting::category{$c}{'name'} . ' (' . ($setting::category{$c}{'count'} || 0) . ')</option>';
		}
	}
	if ($menu) {
		print '<fieldset id="renamer" class="risky">Υ쥳ɤ';
		print '<select name="moveto" id="moveto">';
		print '<option value=""></option>';
		print $menu;
		print '</select><input type="submit" value="ư" />';
		print '</fieldset>';
	}
}
my $archives_dir = "$default::file/$main::c/$main::n/archives.pending";
if (!$setting::general{'rewindable'}) {
	if (-d $archives_dir) {
		use File::Path;
		rmtree $archives_dir;
	}
} elsif ($this->is_secure('rewind')) {
	if (opendir(DIR, $archives_dir)) {
		my @dir = sort {$this->sort_by(\$a,\$b,'descend')} grep($_ !~ /\D/ && -d $archives_dir . '/' . $_,readdir(DIR));
		shift @dir;
		if (@dir) {
			print '</form>';
			print $this->form_start(
				'key'		=>	$setting::key,
				'id'		=>	'rewind-form',
				'name'		=>	'rewind-form',
				'method'	=> 'post',
				'onsubmit'	=> 'return cmonos.tool.isRewindable()',
				'required'	=>	\@setting::form
			);
			print '<fieldset class="risky">';
			print '<select name="rewind" id="rewind" onchange="cmonos.tool.openPreviewWindow()">';
			print '<option value="">Υǡ' . (($main::email || $this->is_secure('tools')) ? '[Խ]' : '') . '</option>';
			foreach my $d (@dir) {
				my $user = '';
				if ($main::email || $this->is_secure('tools')) {
					my($ip,$ua,$email,$name) = split(/\x0A/,$this->read_file($archives_dir . '/' . $d . '/data/author',1));
					if (($email && $main::email && $email eq $main::email) || $this->is_secure('tools')) {
						if ($email) {
							$user = $cgi::Register->email_to_name($main::pswd,$email,$this->is_secure('tools'));
							$user = $email if !$user;
						}
						$user = $name if !$user && $name;
					}
				}
				print '<option value="' . $d . '">' . $this->date($d,3,'c24') . (($user) ? '[' . $user . ']' : '') . '</option>';
			}
			print '</select>';
			print '<input type="submit" value="᤹" />';
			print ' <label><input type="checkbox" id="preview-enabled" onclick="cmonos.tool.openPreviewWindow()" />ץӥ塼</label>';
			print '</fieldset>';
			my($window_width,$window_height) = (640,480);
			my $same_window;
			foreach my $o (sort {$a <=> $b} keys %field::ORDER) {
				my $id = $field::ORDER{$o};
				if (ref $field::obj{$id} && $field::obj{$id}{'class'} eq 'xtm_detail') {
					$window_width = $field::obj{$id}{'windowWidth'} if $field::obj{$id}{'windowWidth'};
					$window_height = $field::obj{$id}{'windowHeight'} if $field::obj{$id}{'windowHeight'};
					$same_window = $field::obj{$id}{'sameWindow'} if $field::obj{$id}{'sameWindow'};
					last;
				}
			}
			my $url = $this->full_path($cgi::path) . '?m=DetailViewer&c=' . $main::c . '&n=' . $main::n . '&ver=';
			my $open_window = ($same_window) ? "window.open('$url'+d)" : "cmonos.window.open('previewViewer',$window_width,$window_height,'$url'+d)";
my $js = <<JAVASCRIPT;
cmonos.tool.openPreviewWindow = function () {
	var preview_enabled = document.getElementById('preview-enabled');
	if (preview_enabled && preview_enabled.checked) {
		var d = cmonos.form.field('rewind').getValue();
		if (d != '') $open_window;
	}
};
cmonos.tool.isRewindable = function () {
	if (cmonos.form.field('rewind').getValue() != "") {
		return confirm('ϼäޤ˰ξ֤ᤷޤ') && cmonos.form.item(this).isNotSubmitted();
	} else {
		alert('Υǡ򤷤Ƥ');
		return false;
	}
};
JAVASCRIPT
			print $this->javascript($js);
		}
	}
}
}

sub is_same_name_and_email ($$$) {
my($this,$n,$name) = @_;
return 0 if !defined $n || $n eq '' || !$this->{'is_admin'};
my(@check_fields,%db,$is_not_same);
@check_fields = @{$field::for{'mail_address'}} if ref $field::for{'mail_address'};
return 0 if !@check_fields;
push(@check_fields,$field::for{'name'});
foreach my $id (@check_fields) {
	if (ref $field::obj{$id}) {
		tie(%db, $env::dbm_file, $default::db . '/' . $main::c . '/' . $field::obj{$id}->db, O_RDONLY, $env::dbm_mode);
		$is_not_same = 1 if !ref tied %db || (defined $db{$n} && $db{$n} ne $main::data{$id}{'str'});
		untie(%db);
		return 0 if $is_not_same;
	}
}
$this->{'keep_original_user_info'} = 1;
return 1;
}

sub get_order_info ($) {
my $this = shift;
if (defined $main::c && $main::c ne '' && defined $main::n && $main::n ne '' && !$this->{'order_received'}) {
	my(%order,$info);
	$this->{'order'} = {};
	tie(%order, $env::dbm_file, $default::db . '/' . $main::c . '/order', O_RDONLY, $env::dbm_mode);
	if (ref tied %order && $order{$main::n} && $order{$main::n} =~ /^(.*?)$/m) {
		$info = $1;
	}
	untie %order;
	if ($info) {
		chomp $info;
		my($total,$tax,$fee,$carriage,$carriage_total,$download_key,$ptime,$transaction_id,$status,$dc_only) = split(/\x09/,$info);
		$this->{'order_carriage_total'} = $carriage_total;
		$this->{'order_paid'} = $ptime;
		$this->{'order_status'} = $status;
		$this->{'order_received'} = 1;
		$this->{'estimated_sum'} = $total;
		$this->{'digital_content_only'} = $dc_only;
	}
}
}

sub is_skip_field ($$) {
my($this,$field) = @_;
return ($default::type && $default::type eq 'order' && $this->{'digital_content_only'} && $this->is_skippable_field($field)) ? 1 : 0;
}

sub is_reserved_field ($$) {
my($this,$field) = @_;
if ($this->{'order_received'}) {
	if ($field->{'class'} =~ /^addr_/) {
		$this->import_db($default::preference_dir . '/terms',\%setting::payment,1) if !%setting::payment;
		if (!$setting::payment{'carriage'} || $setting::payment{'carriage'} eq 'nation' || $setting::payment{'carriage'} eq 'weight') {
			return 0;
		} elsif ($setting::payment{'specialcarriage'}{'requirements'}) {
			if ($this->{'order_carriage_total'} && $this->{'order_carriage_total'} >= $setting::payment{'specialcarriage'}{'requirements'}) {
				return 0;
			} else {
				return 1;
			}
		} else {
			return 1;
		}
	} elsif ($field->{'class'} eq 'yorder_payment') {
		$this->import_db($default::preference_dir . '/terms',\%setting::payment,1) if !%setting::payment;
		if ($setting::payment{'paypalenabled'} || $setting::payment{'codenabled'} || $setting::payment{'otherenabled'}) {
			return 1;
		} elsif ($this->{'order_paid'} || $this->{'order_status'}) {
			return 1;
		} else {
			return 0;
		}
	}
}
return 0;
}

######################################################################
# ƥ꡼˥塼
sub allocate_category ($$) {
my($this,$option) = @_;
my(%c);

#ڡإå
$this->print_page_header('input');

#ե
print $this->form_start(
	'key'	=>	'input',
	'name'	=>	'category',
	'required'	=>	['m','k','mod','s','w','f','u','uni','and','search','q','fv']
);

if (@main::c || (defined $main::c && $main::c =~ /,/)) {
	push(@main::c,$main::c) if !@main::c && defined $main::c && $main::c ne '';
	foreach (@main::c) {
		print '<input type="hidden" name="ct" value="' . $this->escape($_) . '" />' if !@main::ct;
		$c{$_}++ foreach (split(/,/,$_));
	}
}
if (@main::ct || (defined $main::ct && $main::ct =~ /,/)) {
	push(@main::ct,$main::ct) if defined $main::ct;
	foreach (@main::ct) {
		print '<input type="hidden" name="ct" value="' . $this->escape($_) . '" />';
	}
}

print '<select name="c">';
my @categories = sort {$setting::category{$a}{'ORDER'} <=> $setting::category{$b}{'ORDER'} || $a <=> $b} grep(defined $_ && $_ !~ /\D/,keys %setting::category);
if (%c) {
	my $c;
	foreach $c (@categories) {
		next if !$c{$c} || ($setting::category{$c}{'total'} && $setting::category{$c}{'total'} > $setting::category{'LIMIT'});
		print '<option value="' . $c . '">' . $setting::category{$c}{'name'} . (($setting::category{$c}{'count'}) ? ' (' . $setting::category{$c}{'count'} . ')' : '') . '</option>';
	}
} else {
	print $this->mk_category_selector(\%setting::category,\@categories);
}
print '</select>';
print '<input type="submit" value="" />';
print '</form>';
print '<div id="close-button">' . $this->close_button($this->{'referer_url'},$setting::page{'closeButton'},$setting::page{'backButton'}) . '</div>';

#ڡեå
$this->print_page_footer('input');
exit;
}

sub mk_category_selector ($$$;$$$$$) {
my($this,$category,$list,$selected,$size,$key,$indent,$done) = @_;
return '' if !ref $list;
$key = '' if !defined $key;
$indent = '' if !defined $indent;
my($sub_key,@sub_list,$selector,$c);
$done = {} if !ref $done;
$sub_key = $selector = '';
foreach $c (@$list) {
	next if !defined $c;
	$sub_key = $1 if $sub_key eq '' && $category->{$c}->{'name'} && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
	if ($sub_key ne '' && $sub_key ne $key && $category->{$c}->{'name'} =~ /^$sub_key/ && ($sub_key =~ m!/$! || $category->{$c}->{'name'} eq $sub_key)) {
		push(@sub_list,$c);
	} else {
		if ($sub_key ne '' && $sub_key ne $key) {
			my $my_indent = $indent;
			my $indent2 = '';
			if ($key ne '') {
				$my_indent .= '';
				$indent2 = '';
			}
			$selector .= $this->_mk_category_selector($category,\@sub_list,$selected,$size,$sub_key,$my_indent,$done);
			$selector .= $this->mk_category_selector($category,\@sub_list,$selected,$size,$sub_key,$indent . $indent2,$done) if @sub_list && $key ne $sub_key;
		}
		$sub_key = $1 if $category->{$c}->{'name'} && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
		undef @sub_list;
		push(@sub_list,$c);
	}
}
if ($sub_key ne '' && $sub_key ne $key) {
	my $my_indent = $indent;
	my $indent2 = '';
	if ($key ne '') {
		$my_indent .= '';
		$indent2 = '';
	}
	$selector .= $this->_mk_category_selector($category,\@sub_list,$selected,$size,$sub_key,$my_indent,$done);
	$selector .= $this->mk_category_selector($category,\@sub_list,$selected,$size,$sub_key,$indent . $indent2,$done) if @sub_list && $key ne $sub_key;
}
return $selector;
}

sub _mk_category_selector ($$$$$$$$) {
my($this,$category,$sub_list,$selected,$size,$sub_key,$my_indent,$done) = @_;
my $record_count = 0;
foreach (@$sub_list) {
	$record_count += $category->{$_}->{'count'} if ref $category->{$_} && $category->{$_}->{'count'};
}
my $value = join(',',@$sub_list);
my $selector .= '<option value="' . $value . '"' . ((!$done->{$value}++ && grep($_ eq $value,@$selected)) ? ' selected="selected"' : '') . '>';
$selector .= $my_indent;
$selector .= $1 if $sub_key =~ m!([^/]+)/?$!;
$selector .= ' (' . $record_count . ')</option>';
$$size++ if ref $size;
return $selector;
}

######################################################################
# ϤΤߤΥ桼ɤ
sub is_input_only_user ($) {
my $this = shift;
if (!defined $main::n || $main::n eq '') {
	return ((!defined $setting::security{'revise'}{'passwordCheck'} || $setting::security{'revise'}{'passwordCheck'} ne 'nocheck') && (!$this->is_secure('revise') || (!$this->is_one_of_owners && !$this->email_field_enabled))) ? 1 : 0;
} else {
	my($suspend_flag);
	if ($field::for{'checker'} && ref $field::obj{$field::for{'checker'}}) {
		my $field = $field::obj{$field::for{'checker'}};
		my($level,%db);
		$level = 0;
		tie(%db, $env::dbm_file, $default::db . '/' . $main::c . '/' . $field->db, O_RDONLY, $env::dbm_mode);
		if (ref tied %db) {
			$level = $1 if $db{$main::n} =~ /^.*?\x0A(\d+):/s;
		}
		untie(%db);
		$suspend_flag = 1 if $level && (($level == 999 && $field->{'cancelSuspend'}) || $field->{'phase'}{$level}{'suspend'});
	}
	if (defined $setting::security{'revise'}{'passwordCheck'} && $setting::security{'revise'}{'passwordCheck'} eq 'nocheck') {
		$this->{'is_admin'} = 1 if $this->is_secure('revise') && $this->is_one_of_owners;
		$this->is_authorized_email if !$suspend_flag;
	} else {
		$this->{'is_admin'} = 1 if !$this->is_authorized_email && $this->is_secure('revise') && $this->is_one_of_owners;
	}
	if ($suspend_flag) {
		if ($this->is_secure('revise') && $this->is_secure('tools')) {
			return 0;
		} else {
			return 'Υ쥳ɤϽǤޤ';
		}
	}
	return ((!defined $setting::security{'revise'}{'passwordCheck'} || $setting::security{'revise'}{'passwordCheck'} ne 'nocheck') && (!$this->is_secure_email || !$this->is_secure('revise'))) ? (($this->{'email_field_enabled'}) ? 1 : '᡼륢ɥ쥹եɤ¸ߤޤ') : 0;
}
}

sub is_secure_email ($) {
my $this = shift;
if (defined $this->{'is_secure_email'}) {
	return $this->{'is_secure_email'};
} elsif ($this->is_master || $this->is_owner || $this->is_one_of_owners) {
	$main::set_cookie_id = 1 if !$env::session_enabled && $cookie::read{$this->login_cookie_name};
	$this->{'is_secure_email'} = 1;
} elsif ($this->is_authorized_email) {
	$this->{'is_secure_email'} = 1;
} else {
	$this->{'is_secure_email'} = 0;
}
return $this->{'is_secure_email'};
}

sub email_field_enabled ($) {
my $this = shift;
$this->is_authorized_email if !defined $this->{'email_field_enabled'};
return $this->{'email_field_enabled'};
}

sub is_authorized_email ($) {
my $this = shift;
if (defined $this->{'is_authorized_email'}) {
	return $this->{'is_authorized_email'};
} else {
	$this->{'is_authorized_email'} = 0;
	$this->{'email_field_enabled'} = 0;
	$this->{'user_address'} = '';
	if (ref $field::for{'mail_address'} && @{$field::for{'mail_address'}}) {
		my(@user_address,@new_user_address);
		$this->{'email_field_enabled'} = 1;
		foreach my $id (@{$field::for{'mail_address'}}) {
			push(@new_user_address,$main::data{$id}{'str'}) if $main::data{$id}{'str'};
			if (defined $main::n && $main::n ne '') {
				if (ref $field::obj{$id}) {
					my(%db);
					tie(%db, $env::dbm_file, $default::db . '/' . $main::c . '/' . $field::obj{$id}->db, O_RDONLY, $env::dbm_mode);
					if (ref tied %db) {
						push(@user_address,$db{$main::n}) if $db{$main::n};
					}
					untie(%db);
				}
			} elsif ($main::data{$id}{'str'}) {
				push(@user_address,$main::data{$id}{'str'});
			}
		}
		@user_address = $this->get_address(@user_address);
		@new_user_address = $this->get_address(@new_user_address);
		if (@user_address && @new_user_address) {
			my $user_address_count = grep(defined $_ && defined $main::email && $_ eq $main::email,@user_address);
			my $new_user_address_count = grep(defined $_ && defined $main::email && $_ eq $main::email,@new_user_address);

			#ǡ١ˤ⿷ǡˤϿ줿E-Mail
			if ($main::email
					&& $user_address_count
					&& $new_user_address_count
					&& ($security::registered || ($this->use_register && $cgi::Register->is_registered($main::pswd,$main::email)))
				) {
				$security::registered = 1;
				$main::set_cookie_id = 1 if !$env::session_enabled && $cookie::read{$this->login_cookie_name};
				$this->{'is_authorized_email'} = 1;
				$this->{'user_address'} = $main::email;

			#ǡ١ˤϿ줿E-Mail뤬ǡˤʤ
			} elsif ($user_address_count && !$new_user_address_count && $this->use_register && $cgi::Register->is_registered($main::pswd,$main::email)) {
				$this->{'need_new_pswd'} = 1;
				if ($main::new_email && $main::new_pswd && grep(defined $_ && $_ eq $main::new_email,@new_user_address) && $cgi::Register->is_registered($main::new_pswd,$main::new_email)) {
					$this->{'is_authorized_email'} = 1;
					$this->{'old_email'} = $main::email;
					$this->{'old_pswd'} = $main::pswd;
					$this->{'user_address'} = $main::email = $main::new_email;
					$main::pswd = $main::new_pswd;
					undef $main::new_email;
					undef $main::new_pswd;
					if ($env::session_enabled) {
						if ($this->use_session) {
							$session::id = $cgi::Session->set_user_info($main::email,$main::pswd,$session::id);
							$session::is_changed = 1;
						}
					} elsif ($cookie::read{$this->login_cookie_name}) {
						$main::set_cookie_id = 1;
					}
				} else {
					if ($main::new_email && !grep(defined $_ && $_ eq $main::new_email,@new_user_address)) {
						push(@{$this->{'dialog'}},'Ϥ줿ܤ˿᡼륢ɥ쥹ߤĤޤ');
					} elsif ($main::new_pswd) {
						push(@{$this->{'dialog'}},'ѥɤǧƤ');
					} elsif ($setting::security{'revise'}{'passwordCheck'} eq 'nocheck') {
						$main::pswd = $main::email = '';
						$this->{'is_authorized_email'} = 1;
					}
					$this->{'user_address'} = (@new_user_address) ? $new_user_address[0] : $user_address[0];
				}

			#¾
			} else {
				if ($setting::security{'revise'}{'passwordCheck'} eq 'nocheck') {
					$main::pswd = $main::email = '' if !$new_user_address_count;
					$this->{'is_authorized_email'} = 1;
				}
				$this->{'user_address'} = (@new_user_address) ? $new_user_address[0] : $user_address[0];
			}
		} elsif ($setting::security{'revise'}{'passwordCheck'} eq 'nocheck') {
			$main::pswd = $main::email = '';
			$this->{'is_authorized_email'} = 1;
		}
	} elsif ($setting::security{'revise'}{'passwordCheck'} eq 'nocheck') {
		$main::pswd = $main::email = '';
		$this->{'is_authorized_email'} = 1;
	}
}
return $this->{'is_authorized_email'};
}

######################################################################
# ƥ꡼ư
sub record_move_to ($$$$;$) {
my($this,$moveto,$c,$n,$copy) = @_;
return($c,$n) if $moveto eq $c && !$copy;

#ư
my(%mtime,$count,$num);
$count = 0;
tie(%mtime, $env::dbm_file, "$default::db/$moveto/mtime", O_RDONLY, $env::dbm_mode);
if (ref tied %mtime) {
	while (my($k) = each %mtime) {
		$count++;
	}
}
$num = $this->new_number(\%mtime) if $count < $setting::category{'LIMIT'};
untie %mtime;
if (!defined $num) {
	push(@{$this->{'dialog'}},'ưΥƥ꡼' . $setting::category{$moveto}{'name'} . 'פˤϽ񤭹ޤ󡣥쥳ɿ ' . $setting::category{'LIMIT'} . ' ¤Ƥޤ');
	return($c,$n);
}

#ǡԡ
local(*DIR);
if (opendir(DIR, "$default::db/$c")) {
	my @files = readdir(DIR);
	closedir(DIR);
	my(%database,%category,$nocount);
	foreach my $db (@files) {
		next if $db =~ /^\./ || $db =~ /\.htm[l]?$/i || !-f "$default::db/$c/$db";
		$db =~ s/\.[^\/\.]+$//;
		$database{$db} = 1;
	}
	eval 'use ' . $env::dbm_file . ';';
	while (my($db) = each %database) {
		my($original,$new);
		tie(%{$original}, $env::dbm_file, "$default::db/$c/$db", O_RDWR, $env::dbm_mode);
		if (ref tied %{$original}) {
			if ($moveto ne $c) {
				tie(%{$new}, $env::dbm_file, "$default::db/$moveto/$db", O_RDWR | O_CREAT, $env::dbm_mode);
			} else {
				$new = $original;
			}
			$nocount = 1 if $db eq 'pending' && $original->{$n} && $original->{$n} =~ /^1/;
			$new->{$num} = $original->{$n} if ref tied %{$new};
			delete $original->{$n} if !$copy;
			untie %{$new} if $moveto ne $c;
		}
		untie %{$original};
	}
	tie(%category, $env::dbm_file, $default::preference_dir . '/category', O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %category) {
		if (!$copy) {
			$category{$c . '_count'} = $setting::category{$c}{'count'} = $category{$c . '_count'} - 1 if !$nocount && $category{$c . '_count'};
			$category{$c . '_total'} = $setting::category{$c}{'total'} = $category{$c . '_total'} - 1  if $category{$c . '_total'};
		}
		$category{$moveto . '_count'} = $setting::category{$moveto}{'count'} = ($category{$moveto . '_count'} || 0) + 1 if !$nocount;
		$category{$moveto . '_total'} = $setting::category{$moveto}{'total'} = ($category{$moveto . '_total'} || 0) + 1;
	}
	untie %category;
	$this->directory_copy("$default::file/$c/$n","$default::file/$moveto/$num",1,['\\.(?:js|ssi)$']);
	if (!$copy) {
		use File::Path;
		rmtree "$default::file/$c/$n";
		$this->index_sweeper($c,$n);
	}
}
return($moveto,$num);
}

######################################################################
# 
sub new_record_number ($;$) {
#no warnings qw(untie);
my($this,$count_flag) = @_;
my(%mtime,%pending,$count,$n,$num,$nocount);
$this->gc;

#쥳ɿ
$count = $nocount = 0;
tie(%mtime, $env::dbm_file, "$default::db/$main::c/mtime", O_RDONLY, $env::dbm_mode);
if (ref tied %mtime) {
	tie(%pending, $env::dbm_file, "$default::db/$main::c/pending", O_RDONLY, $env::dbm_mode);
	if ($default::type && $default::type eq 'order') {
		$num = ($setting::category{$main::c}{'latestnumber'}) ? ($setting::category{$main::c}{'latestnumber'} < 1000000) ? $setting::category{$main::c}{'latestnumber'} : ($setting::category{$main::c}{'latestnumber'} % 1000000) : 0;
		while (my($n) = each %mtime) {
			$num = $n if $n > $num;
			$count++;
			$nocount++ if ref tied %pending && $pending{$n} && $pending{$n} =~ /^1/;
		}
		$num++;
		$num = $this->new_number(\%mtime) if $num > 1000000;
	} else {
		while (my($n) = each %mtime) {
			$count++;
			$nocount++ if ref tied %pending && $pending{$n} && $pending{$n} =~ /^1/;
		}
	}
	untie %pending;
}

#쥳ɿ¥С
if ($count >= $setting::category{'LIMIT'}) {

	#üDB
	#if (defined $default::type && ($default::type eq 'order' || $default::type eq 'account')) {
	if (defined $default::type && $default::type eq 'order') {
		untie %mtime;
		my(@category_id,$name,$d);
		@category_id = sort {$a <=> $b || $a cmp $b} grep(defined $_ && $_ !~ /\D/,keys %setting::category);
		$name = $setting::category{$category_id[$#category_id]}{'name'};
		$main::c = $category_id[$#category_id] + 1;
		undef @category_id;
		$d = $1 if $name =~ s/(\d+)$//;
		$d = 1 if $d == 0;
		$this->mk_category($main::c,$name . $d);
		$n = 0;

	#ǤŤ쥳ɤõƿ쥳ɤɲä
	} elsif ($setting::category{'ADD'} eq 'add') {
		$n = $this->minimum(\%mtime); 
		untie %mtime;

		#ǡ
		$this->delete_all_data("$default::db/$main::c",$n);

		#쥳ɿ
		$count--;
	
		#źեե
		use File::Path;
		rmtree "$default::file/$main::c/$n";
		#push(@{$this->{'dialog'}},'쥳ɿ ' . $setting::category{'LIMIT'} . ' ĶᡢǽǤŤ쥳ɤޤ');

	#ƥ꡼ƿ쥳ɤɲä
	} elsif ($setting::category{'ADD'} eq 'newcategory') {
		untie %mtime;

		my($oname,$name,$d,$new_name,$c,$new_c,@categories);
		$name = $oname = $setting::category{$main::c}{'name'};
		$d = $1 if $name =~ s/(\d+)$//;
		$d = 1 if !$d;
		@categories = grep(defined $_ && $_ !~ /\D/,keys %setting::category);
		COUNT:
		while ($count >= $setting::category{'LIMIT'}) {
			$count = $nocount = 0;	
			$d++;
			$new_name = $name . $d;
			$new_c = '';
			foreach $c (@categories) {
				if (ref $setting::category{$c} && defined $setting::category{$c}{'name'} && $setting::category{$c}{'name'} eq $new_name) {
					my(%mtime);
					tie(%mtime, $env::dbm_file, "$default::db/$c/mtime", O_RDONLY, $env::dbm_mode);
					if (ref tied %mtime) {
						tie(%pending, $env::dbm_file, "$default::db/$c/pending", O_RDONLY, $env::dbm_mode);
						while (my($n) = each %mtime) {
							$count++;
							$nocount++ if ref tied %pending && $pending{$n} && $pending{$n} =~ /^1/;
						}
						untie %pending;
						if ($count < $setting::category{'LIMIT'}) {
							$new_c = $c;
							$n = $this->new_number(\%mtime);
							untie %mtime;
							last COUNT;
						}
						untie %mtime;
						$main::c = $c;
						next COUNT;
					} else {
						untie %mtime;
						$new_c = $c;
						$n = 0;
						last COUNT;
					}
				}
			}
		}
		if (defined $new_c && $new_c) {
			$main::c = $new_c;
		} else {
			my $order = $setting::category{$main::c}{'ORDER'} + 1;
			$main::c = $this->new_number(\%setting::category,1);
			$this->mk_category($main::c,$new_name,$order);
			$count = $n = 0;
		}
		push(@{$this->{'dialog'}},'쥳ɿ ' . $setting::category{'LIMIT'} . ' ¤Ƥ뤿ᡢ' . $oname . ' ˤϽ񤭹ޤ' . $new_name . ' ˽񤭹ߤޤ');

	#쥳ɤν񤭹ߤ䤹
	} else {
		untie %mtime;
		push(@{$this->{'dialog'}},'Υƥ꡼ˤϽ񤭹ޤ󡣥쥳ɿ ' . $setting::category{'LIMIT'} . ' ¤Ƥޤ');
		$this->allocate_category;

	}

#üDB
#} elsif (defined $default::type && ($default::type eq 'order' || $default::type eq 'account')) {
} elsif (defined $default::type && $default::type eq 'order') {
	untie %mtime;
	$n = $num;

} else {
	$n = $this->new_number(\%mtime);
	untie %mtime;
}

#ȵϿ
if (defined $count_flag && $count_flag) {
	my(%category);
	$count++;
	tie(%category, $env::dbm_file, $default::preference_dir . '/category', O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %category) {
		$category{$main::c . '_total'} = $count;
		$category{$main::c . '_count'} = $count - $nocount;
		$setting::category{$main::c}{'total'} = $category{$main::c . '_total'} || 0;
		$setting::category{$main::c}{'count'} = $category{$main::c . '_count'} || 0;
	}
	untie %category;
	$this->write_category_list;
}
return $n;
}

######################################################################
sub set_rss_link ($;$) {
my($this,$output) = @_;
$this->import_db($default::preference_dir . '/category',\%setting::category,1) if !%setting::category;
$this->_set_rss_link($default::file . '/' . $main::c,((ref $setting::category{$main::c} && defined $setting::category{$main::c}{'name'} && $setting::category{$main::c}{'name'} ne '') ? $setting::category{$main::c}{'name'} : '')) if defined $main::c && $main::c ne '';
$this->_set_rss_link($default::file,((defined $setting::general{'cginame'} && $setting::general{'cginame'} ne '') ? $setting::general{'cginame'} : ''),$output);
}

sub url_encoded_query ($$) {
my($this,$hash) = @_;
my($query,$key,$value);
while (($key,$value) = each %$hash) {
	$query .= $this->make_query('url',$cgi::Jcode->set(\$key)->utf8,$cgi::Jcode->set(\$value)->utf8);
}
if (defined $query) {
	$query =~ s/^&//;
	return $query;
} else {
	return '';
}
}

sub print_response ($$) {
my($this,$data) = @_;
$this->print_http_header('application/x-www-form-urlencoded; charset=utf-8');
print ((!defined $data) ? '' : (!ref $data) ? $data : (ref $data eq 'HASH') ? $this->url_encoded_query($data) : $$data);
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#省
	$setting::security_key = (defined $main::n && $main::n ne '') ? 'revise' : 'input';				#ǥեȥƥ
	$setting::key = 'input';						#ڡꥭ

	#ǥեȥ
	$main::k = 'input' if !defined $main::k || !$main::k;

	#ɬܥե
	@setting::form = ('m','k','c','ct','n','mod','s','w','f','u','uni','and','search','q','fv');

	#饹Ͽ
	Common::class_register('input','Input');

	$setting::page{'input'}{'title'} = 'ǡ';

}

1;
