package TableViewer;
require CMONOS::TableMaker::Viewer;
@ISA = qw(Viewer);
use strict;
######################################################################
# ơ֥ӥ塼⥸塼
# TableViewer.pm ver1.1.6
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-12-07
######################################################################
sub set_delete_this_js ($) {
my $this = shift;
my $js = <<'JAVASCRIPT';
cmonos.form.deleteRecord = function (record_id) {
	this_form = this.currentForm;
	this_field = this.currentField;
	this_field.className = this_field.className.replace(/-(visited|active)$/,'') + '-active';
	record_id = 'n' + record_id;
	var hash = new Array();
	for (var i=0; i < this_form.elements.length; i++) {
		if (typeof this_form.elements[i].name != "undefined" && this_form.elements[i].name != "" && (typeof this_form.elements[i].value == "string" || typeof this_form.elements[i].value == "number") && typeof this_form.elements[i].type != "undefined" && this_form.elements[i].type != null && this_form.elements[i].type == 'hidden') {
			hash[this_form.elements[i].name] = this.setHashValue(hash[this_form.elements[i].name],this_form.elements[i].value);
		}
	}
	cmonos.form.item(this_form).enabled(false);
	hash["delete"] = "1";
	hash["ajax"] = "1";
	cmonos.xml.request(
		this_form.action, 
		{
			method: 'post',
			parameters: cmonos.value.urlEncode(hash), 
			onFailure: function(){
				alert("error!");
				cmonos.form.item(this_form).enabled(true);
				this_field.className = this_field.className.replace(/-active$/,"");
			},
			onSuccess: function(transport){
				var response_hash = cmonos.value.urlDecode(transport.responseText);
				cmonos.form.item(this_form).enabled(true);
				this_field.className = this_field.className.replace(/-active$/,"");
				if (response_hash["status"] == "success") {
					cmonos.element.item(record_id).addClassName('deleted');
				} else if (response_hash["status"] == "error") {
					alert((response_hash["message"] != null) ? response_hash["message"] : 'error!');
				}
			}
		}
	);
	return false;
}
JAVASCRIPT
$this->set_javascript($js);
}

######################################################################
# ƥĥإå
sub print_contents_header ($) {
my $this = shift;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

#ġܥå
$this->print_toolbox_top;

#ڡؤΥ
$this->print_page_jump_form;

$this->{'Table'} = Table->new;
if (defined $setting::page{$setting::key}{'table'}) {
	if (ref $table::obj{$setting::page{$setting::key}{'table'}}) {
		%{$this->{'Table'}} = %{$table::obj{$setting::page{$setting::key}{'table'}}};
	} elsif (defined $setting::table{$setting::page{$setting::key}{'table'}}{'setting'} && $setting::table{$setting::page{$setting::key}{'table'}}{'setting'}) {
		$this->{'Table'}->set($setting::table{$setting::page{$setting::key}{'table'}}{'setting'});
		$this->{'Table'}->{'name'} = $setting::table{$setting::page{$setting::key}{'table'}}{'name'};
	}
}

#ܥ
if (defined $this->{'revForm'} && $this->{'revForm'}) {
	$this->{'cellWidth'} .= ',' if defined $this->{'cellWidth'};
	$this->{'cellWidth'} .= '100';
	$this->{'cellAlign'} .= ',' if defined $this->{'cellAlign'};
	$this->{'cellAlign'} .= 'center';
	$this->{'cellValign'} .= ',' if defined $this->{'cellValign'};
	$this->{'cellValign'} .= 'middle';
}

$this->{'Table'}->set(
	'width' => $this->{'cellWidth'},
	'align0' => $this->{'cellAlign'},
	'alignH' => 'center',
	'valign0' => $this->{'cellValign'},
	'valignH' => 'middle',
	'tableid' => 'table-viewer'
);
$this->{'cellspace'} = 0;
$this->{'cellspace'} += $this->{'Table'}->{'cellpadding'} * 2 if defined $this->{'Table'}->{'cellpadding'} && $this->{'Table'}->{'cellpadding'} !~ /\D/ && $this->{'Table'}->{'cellpadding'} > 0;
$this->{'cellspace'} += $this->{'Table'}->{'cellspacing'} * 2 if defined $this->{'Table'}->{'cellspacing'} && $this->{'Table'}->{'cellspacing'} !~ /\D/ && $this->{'Table'}->{'cellspacing'} > 0;
$this->{'cellspace'} += $this->{'Table'}->{'border'} if defined $this->{'Table'}->{'border'} && $this->{'Table'}->{'border'} !~ /\D/ && $this->{'Table'}->{'border'} > 0;

#ơ֥볫
my $handle = $this->{'filehandle'};
print $handle ('<div id="table-viewer-box">');
print $handle ($this->{'Table'}->table);

#ե̾
print $handle ($this->{'Table'}->tr);
my $url = $cgi::path . $this->set_query('url',[grep($_ ne 'w' && $_ ne 's',@setting::form)]);
foreach my $id (@{$this->{'selectedField'}}) {
	next if !defined $id || !ref $field::obj{$id} || !$field::obj{$id}->usual_format_enabled;
	my $name = $field::obj{$id}->name;
	if (!$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret')) && $field::obj{$id}->sort_enabled && $field::obj{$id}->{'sortEnabled'}) {
		$name = '<a href="' . $this->escape($url . $this->add_query('url',{'s' => $id, 'w' => (($main::s eq $id) ? ($main::w eq 'descend') ? 'ascend' : 'descend' : $main::w)})) . '" title="' . (($default::english) ? 'sort this column in ' . (($main::s eq $id) ? ($main::w eq 'descend') ? 'ascending' : 'descending' : ($main::w eq 'descend') ? 'descending' : 'ascending') . ' order.' : 'ιܤ' . (($main::s eq $id) ? ($main::w eq 'descend') ? '碥' : '߽碧' : ($main::w eq 'descend') ? '߽碧' : '碥') . '˥Ȥ') . '">' . $name . '</a>' . (($default::english) ? ($main::s eq $id) ? ($main::w eq 'descend') ? ' <span class="sort-mark">&uarr;</span>' : ' <span class="sort-mark">&darr;</span>' : '' : ($main::s eq $id) ? ($main::w eq 'descend') ? ' <span class="sort-mark"></span>' : ' <span class="sort-mark"></span>' : '');
		print $handle ($this->{'Table'}->th($name,(($main::s eq $id) ? {'class' => 'sorted'} : {})));
	} else {
		print $handle ($this->{'Table'}->th($name));
	}
}

#ܥ
print $handle ($this->{'Table'}->td('')) if $this->{'revForm'};

print $handle ($this->{'Table'}->_tr);
}

######################################################################
# ƥĥեå
sub print_contents_footer ($) {
my $this = shift;

#ơ֥뽪λ
my $handle = $this->{'filehandle'};
print $handle ($this->{'Table'}->_table);
print $handle ('</div>');

#ڡؤΥ
$this->print_page_jump_form;

$this->print_toolbox_bottom;
$this->print_download_form;
$this->print_page_return_form;

}

######################################################################
# 쥳
sub print_record ($$$) {
my($this,$c,$n) = @_;
my $path = "$default::file/$c/$n";
my $rid = $c * 1000000 + $n;
my $handle = $this->{'filehandle'};
print $handle ($this->{'Table'}->tr({'id' => 'n' . $rid}));
foreach my $id (@{$this->{'selectedField'}}) {
	if (defined $id && ref $field::obj{$id} && $field::obj{$id}->usual_format_enabled) {
		my $db = $field::obj{$id}->db;
		unless (!$db || ref tied %{$this->{'DB'}{$c}{$db}}) {
			tie(%{$this->{'DB'}{$c}{$db}}, $env::dbm_file, "$default::db/$c/$db", O_RDONLY, $env::dbm_mode);
		}
		$field::obj{$id}->{'maxwidth'} = $field::obj{$id}->{'cellWidth'} - ($this->{'cellspace'} * 2);
		print $handle ($this->{'Table'}->td($field::obj{$id}->usual_format((($db) ? $this->{'DB'}{$c}{$db}{$n} : ''),$path,$c,$n)));
	}
}

#ܥ
print $handle ($this->{'Table'}->td($this->get_rev_buttons($c,$n,$rid,'tmedit','tmdelete'))) if $this->{'revForm'};

print $handle ($this->{'Table'}->_tr);
}

######################################################################
# ե
sub set_field_setting ($$) {
my($this,$id) = @_;
$this->{'cellWidth'} .= ',' if defined $this->{'cellWidth'};
$this->{'cellWidth'} .= $field::obj{$id}->{'cellWidth'};
$this->{'cellAlign'} .= ',' if defined $this->{'cellAlign'};
$this->{'cellAlign'} .= $field::obj{$id}->{'cellAlign'};
$this->{'cellValign'} .= ',' if defined $this->{'cellValign'};
$this->{'cellValign'} .= $field::obj{$id}->{'cellValign'};
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	$setting::field_style_disabled = 2;			#2=եꥹ̵/1=եΤ̵
	$setting::field_tag_enabled = 'no';			#tag=Τ/all=Ƥ/no=Ĥʤ

	#省
	$setting::key = 'viewer' if !defined $setting::key || !$setting::key;	#ڡꥭ

	#ǥեȥ
	$main::k = 'viewer' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('viewer','TableViewer');
}

1;
