package TeaserVariation;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use Fcntl qw(:flock);
######################################################################
# ѥꥹȥХꥨѹ⥸塼
# TeaserVariation.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-09-04
######################################################################
# ¹
sub run ($) {
my $this = shift;
my($valid_flag,$error_flag);
$default::teaser_variation = 0 if !$default::teaser_variation;

#ϥå
if (defined $main::variation) {
	if ($this->is_nan($main::variation)) {
		push(@{$this->{'dialog'}},'ϤǤ');
		$error_flag = 1;
	} elsif ($main::variation != $default::teaser_variation) {
		$valid_flag = 1;
	}
}

#teaser.pl񤭴
if ($valid_flag && !$error_flag) {
	local(*FILE);
	my($data,$default_path);
	$default_path = './default.pl';
	$data = $this->read_file($default_path);
	unless ($data =~ s/^[\x20\x09]*\$teaser_variation[\x20\x09]*=[^;]*;/\$teaser_variation = $main::variation;/gm || !$main::variation) {
		$data =~ s/^1;/# ѥꥹȤΥХꥨ\x0A\$teaser_variation = $main::variation;\x0A\x0A1;/m;
	}
	if ($default::teaser_variation > $main::variation) {
		for (my $i = $main::variation + 1; $i <= $default::teaser_variation; $i++) {
			my $teaser_path = $default::file . '/teaser' . (($i > 1) ? $i : '');
			unlink $teaser_path . '.ssi';
			unlink $teaser_path . '.js';
		}
	}
	if (open (FILE, ">>$default_path")) {
		binmode FILE;
		flock(FILE, LOCK_EX);
		truncate(FILE, 0);
		seek(FILE, 0, 0);
		print FILE $data;
		close(FILE);
		push(@{$this->{'dialog'}},'ѥꥹȥХꥨ򹹿ޤ');
		$default::teaser_variation = $main::variation;
		undef $main::variation;
	} else {
		push(@{$this->{'dialog'}},'ѥꥹȥХꥨι˼Ԥޤ');
	}
} elsif (defined $error_flag && $error_flag) {
	push(@{$this->{'dialog'}},'ѥꥹȥХꥨι˼Ԥޤ');
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>ѥꥹȥХꥨѹ</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=>	'return confirm(\'ϼäޤѹޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
	'required'	=>	\@setting::form
);
print '<fieldset class="submit"><select name="variation">';
foreach my $n (0..10) {
	print '<option value="' . $n . '"' . (($default::teaser_variation == $n) ? ' selected="selected"' : '') . '>' . $n . '</option>';
}
print '</select>';
print '<input type="submit" value="ѹ" />';
print '</fieldset></form>';

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
if (!$default::type || $default::type ne 'order') {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('00t2','TeaserVariation');

	#˥塼Ͽ
	$setting::jump_menu{'00t2'} = 'ѥꥹȥХꥨ';

}
}



1;
