package Viewer;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
######################################################################
# ӥ塼⥸塼
# Viewer.pm ver1.1.7
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-09-04
######################################################################
# ᥤ
sub run ($) {
my $this = shift;
$this->gc_download_directory if $default::type && $default::type eq 'order';
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

#---------------------------------------------------------------------
#ǧԤܷٹ
$this->set_pending_item_alert if !defined $main::c && $this->is_secure('tools');


#---------------------------------------------------------------------
#üեɽ
if (defined $main::c && $main::c ne '' && defined $main::n && $main::n ne '' && -d $default::db . '/' . $main::c && defined $main::id && $main::id ne '' && ref $field::obj{$main::id} && $field::obj{$main::id}->update_enabled && $field::obj{$main::id}->is_secure_user_for_update) {
	$field::obj{$main::id}->update;
	@main::c = (@main::ct) ? @main::ct : ($main::c);#üեѤξ狼鸵ξ
	undef $main::c;
}


#---------------------------------------------------------------------
#Ĵ
push(@main::f,$main::f) if !@main::f && defined $main::f && $main::f;
push(@main::c,$main::c) if !@main::c && defined $main::c && $main::c;
undef $main::f;
undef $main::c;

#̤
$this->set_viewer;
$this->open_filehandle;

#ƥ꡼ɤ߹
$this->import_db($default::preference_dir . '/category',\%setting::category,1) if !%setting::category;

#ƥ꡼꤬ʤ硢ǸΥƥ꡼
if (!@main::c) {
	if ($setting::category{'DEFAULT'}) {
		push(@main::c,((ref $setting::category{'DEFAULT'}) ? @{$setting::category{'DEFAULT'}} : $setting::category{'DEFAULT'}));
	} else {
		my @g_order = sort {$a <=> $b} keys %{$setting::category{'ORDER'}};
		my $c = (@g_order) ? $setting::category{'ORDER'}{$g_order[$#g_order]} : 1;
		push(@main::c,(($c) ? $c : 1));
	}
}

$main::p = $main::pnum - 1 if $main::pnum && !$this->is_nan($main::pnum);
$main::p = 0 if !defined $main::p || $this->is_nan($main::p) || $main::p < 0;

#---------------------------------------------------------------------
#
$this->sort_and_search;


#---------------------------------------------------------------------
#񤭽Ф
#ɽĴ
if ($setting::page{'uStatic'} || $this->is_nan($main::u)) {
	$main::u = $setting::page{'u'};
} elsif ($setting::page{'uLimit'} && $main::u && $main::u > $setting::page{'uLimit'}) {
	$main::u = $setting::page{'uLimit'};
}
$main::u = 20 if !$main::u;
$main::w = ($field::SORTORDER) ? $field::SORTORDER : 'ascend' if !defined $main::w || $main::w eq '';

#ե
$this->get_selected_fields;

#ڡإå
$this->print_viewer_header;

#ƥĥإå
$this->print_contents_header;

#no warnings qw(numeric);
my($no,$count,$from,$to);
$from = $main::p * $main::u;
$to = $from + $main::u;
$count = 0;
foreach $no (
	sort {
		$this->sort_by(\$this->{'match'}{$b},\$this->{'match'}{$a}) || 
		$this->sort_by(\$this->{'sort'}{$a},\$this->{'sort'}{$b},$main::w) || 
		$a <=> $b || $a cmp $b
	} keys %{$this->{'sort'}}
) {
	next if $main::u && $count < $from;
	last if $main::u && $count >= $to;

	my($c,$n);
	$c = int($no / 1000000);
	$n = $no - ($c * 1000000);

	$this->print_record($c,$n);

} continue {
	$count++;
}

#DBM³
$this->untie_all_dbm;

#ƥĥեå
$this->print_contents_footer;

#ڡեå
$this->print_viewer_footer;

$this->close_filehandle;
}

sub set_viewer ($) {
my $this = shift;
return;
}

sub open_filehandle ($) {
my $this = shift;
$this->{'filehandle'} = \*STDOUT;
return;
}

sub close_filehandle ($) {
my $this = shift;
return;
}

######################################################################
# ɽեɼ
sub get_selected_fields ($) {
my $this = shift;
return if ref $this->{'selectedField'} eq 'ARRAY';
$this->{'selectedField'} = [];
my($id);
$this->{'revForm'} = 1 if (!@main::f || grep($_ eq 'r',@main::f) || $main::rev_mode) && $this->is_secure('revise');
@main::f = grep(ref $field::obj{$_},@main::f);
if (@main::f && !$main::all_fields) {
	foreach $id (sort {$field::obj{$a}->{'ORDER'} <=> $field::obj{$b}->{'ORDER'}} @main::f) {
		next unless !$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret'));
		next if grep($_ eq $id,@{$this->{'selectedField'}});
		push(@{$this->{'selectedField'}},$id);
		$this->set_field_setting($id);
	}
} else {
	foreach (sort {$a <=> $b} keys %field::ORDER) {
		$id = $field::ORDER{$_};
		next unless ref $field::obj{$id} && !$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Default'} || $main::all_fields) && ($field::obj{$id}->{'Open'} || $this->is_secure('secret'));
		next if grep($_ eq $id,@{$this->{'selectedField'}});
		push(@{$this->{'selectedField'}},$id);
		$this->set_field_setting($id);
	}
}
@main::f = @{$this->{'selectedField'}};
push(@main::f,'r') if defined $this->{'revForm'} && $this->{'revForm'};
}

######################################################################
# ե
sub set_field_setting ($$) {
my($this,$id) = @_;
}

######################################################################
# ƥĥإå
sub print_contents_header ($) {
my $this = shift;
}

######################################################################
# ƥĥեå
sub print_contents_footer ($) {
my $this = shift;
}

######################################################################
# ڡؤΥ
sub print_page_jump_form ($) {
my $this = shift;
if (defined $this->{'PageJumpForm'} && $this->{'PageJumpForm'}) {
	print $this->{'PageJumpForm'};
	return;
}

my($prev,$next,$to,$form_flag);
$prev = $main::p - 1;
$next = $main::p + 1;

if ($setting::general{'postMethod'}) {
	$this->{'PageJumpForm'} = $this->form_start(
		'key'	=>	$setting::security_key,
		'name'	=>	'jump',
		'required'	=>	\@setting::form
	);
	$form_flag = 1;
} else {
	$form_flag = 0;
}

$this->{'PageJumpForm'} .= '<ul class="pager">';

if ($prev >= 0) {
	$this->{'PageJumpForm'} .= '<li class="prev">';
	if ($form_flag) {
		$this->{'PageJumpForm'} .= $cgi::Deco->submit_button('prev',$setting::page{'prevButton'},(($default::english) ? 'Prev' : 'Υڡ'),'',{'p'=>$prev});
	} else {
		$this->{'PageJumpForm'} .= $cgi::Deco->button(
			'prev',
			$setting::page{'prevButton'},
			$cgi::path . $this->set_query('url',\@setting::form) . $this->add_query('url',{'p'=>$prev}),
			(($default::english) ? 'Prev' : 'Υڡ')
		);
	}
	$this->{'PageJumpForm'} .= '</li>';
}

$this->{'mcount'} = 0 if !$this->{'mcount'};
$to = $main::u * $next;
$to = $this->{'mcount'} if $to > $this->{'mcount'};

if ($form_flag || $setting::page{'pageinfo'} || $this->{'mcount'} < $main::u) {
	my $from = $main::u * $main::p;
	$from += 1 if $this->{'mcount'};
	$this->{'PageJumpForm'} .= '<li class="info">' . $from . ' - ' . $to . ' / ' . $this->{'mcount'} . '</li>';
} else {
	my $p = $main::p + 1;
	my $max = ($setting::page{'pagelistmax'}) ? $setting::page{'pagelistmax'} : 12;
	my $margin = ($setting::page{'pagelistmargin'}) ? $setting::page{'pagelistmargin'} : 2;
	my $total = int($this->{'mcount'} / $main::u + 0.9999);
	$max = 7 if $max && $max < 7;
	$margin = int(($max - 5) / 2) if $max - $margin * 2 - 5 < 0;
	$margin = 1 if $margin < 1;
	my $start_page = ($p - $margin <= $total - $max + 3) ? ($p - $margin > 3) ? $p - $margin : 3 : $total - $max + 3;
	my $end_page = $start_page + $max - 5;
	my $omission = 0;
	foreach my $page (1..$total) {
		if (($max && $max < $total && $page > 1 && $page < $total) &&
			(($p > $margin + 3 && $page < $start_page) ||
			($end_page < $page && $end_page < $total - 2))) {
			$omission = 1;
			next;
		}
		if ($omission) {
			$this->{'PageJumpForm'} .= '<li class="omission">...</li>';
			$omission = 0;
		}
		if ($page == $p) {
			$this->{'PageJumpForm'} .= '<li class="here">' . $page . '</li>';
		} else {
			$this->{'PageJumpForm'} .= '<li><a href="./start.cgi' . $this->set_query('url',\@setting::form) . $this->add_query('url',{'p'=>($page-1)}) . '">' . $page . '</a></li>';
		}
	}
	$this->{'PageJumpForm'} .= '<li class="manual">' . $this->form_start(
		'key'	=>	$setting::security_key,
		'name'	=>	'jump',
		'required'	=>	\@setting::form
	);
	$this->{'PageJumpForm'} .= '<input type="text" size="2" name="pnum" title="' . (($default::english) ? 'Type return key' : 'ڡֹϤ꥿󥭡ǰưޤ') . '" />';
	$this->{'PageJumpForm'} .= '</form></li>';
}

unless (!$this->{'mcount'} || $this->{'mcount'} <= $to) {
	$this->{'PageJumpForm'} .= '<li class="next">';
	if ($form_flag) {
		$this->{'PageJumpForm'} .= $cgi::Deco->submit_button('next',$setting::page{'nextButton'},(($default::english) ? 'Next' : 'Υڡ'),'',{'p'=>$next});
	} else {
		$this->{'PageJumpForm'} .= $cgi::Deco->button(
			'next',
			$setting::page{'nextButton'},
			$cgi::path . $this->set_query('url',\@setting::form) . $this->add_query('url',{'p'=>$next}),
			(($default::english) ? 'Next' : 'Υڡ')
		);
	}
	$this->{'PageJumpForm'} .= '</li>';
}

$this->{'PageJumpForm'} .= '</ul>';
$this->{'PageJumpForm'} .= '</form>' if $form_flag;
print $this->{'PageJumpForm'};
}

######################################################################
# ɥե
sub print_download_form ($) {
my $this = shift;
return if !$setting::page{'download'};
return if !$this->{'mcount'};
my $filename = $default::id || 'exported';
$filename =~ s/^_//;
$filename .= '_data';
my @form = grep($_ ne 'k' && $_ ne 'm',@setting::form);
print $this->form_start(
	'key'	=>	$setting::security_key,
	'name'	=>	'tm-download-form',
	'id'	=>	'tm-download-form',
	'class'	=>	'panel',
	'path'	=>	'/.dl/' . $filename . '.csv',
	'required'	=>	\@form
);
print '<select name="m" id="m" onchange="cmonos.form.item(this.form).field(this).appendDownloadPathByValue({\'CsvViewer\':\'' . $filename . '.csv\',\'TsvViewer\':\'' . $filename . '.tsv\',\'VCardViewer\':\'' . $filename . '.vcf\',\'VCard2Viewer\':\'' . $filename . '.vcf\'})">';
print '<option value="CsvViewer"' . ((defined $main::m && $main::m eq 'CsvViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Comma-Separated-Values (csv)' : '޶ڤƥ(csv)') . '</option>';
print '<option value="TsvViewer"' . ((defined $main::m && $main::m eq 'TsvViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Tab-Separated-Values' : 'ֶڤƥ') . '</option>';
if (defined $setting::page{'vcard'} && $setting::page{'vcard'}) {
	print '<option value="VCardViewer"' . ((defined $main::m && $main::m eq 'VCardViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'vCard (vcf)' : 'vCard (vcf)') . '</option>';
	print '<option value="VCard2Viewer"' . ((defined $main::m && $main::m eq 'VCard2Viewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'vCard2.1 (vcf)' : 'vCard2.1 (vcf)') . '</option>';
}
print '</select><input type="submit" name="download" value="' . (($default::english) ? 'Download' : '') . '" />';
print ' <label><input type="checkbox" name="all_fields" value="1" checked="checked" />' . (($default::english) ? 'All fields.' : '') . '</label></form>';
}

######################################################################
sub set_rss_link ($;$) {
my($this,$output) = @_;
$this->_set_rss_link($default::file . '/' . $main::c[0],((ref $setting::category{$main::c[0]} && defined $setting::category{$main::c[0]}{'name'} && $setting::category{$main::c[0]}{'name'} ne '') ? $setting::category{$main::c[0]}{'name'} : '')) if @main::c == 1;
$this->_set_rss_link($default::file,((defined $setting::general{'cginame'} && $setting::general{'cginame'} ne '') ? $setting::general{'cginame'} : ''));
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;					#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 1;					#ơ֥ɤ߹
	$setting::page = 1;						#ڡɤ߹

	$setting::field_db_name = 'inputfield';		#եDB
	$setting::field = 2;					#եɤ߹ߡ2=ꥸʥɤ߹

	$setting::pending_check = 1;			#쥳ɥå

	#省
	$setting::security_key = 'browse' if !defined $setting::security_key ||  !$setting::security_key;	#ǥեȥƥ

	#å
	$cookie::id_enabled = 1;						#ID󥯥åɤ߹

	#ɬܥե
	@setting::form = ('k','m','c','f','u','uni','s','w','mod','and','search','q','fv') if !@setting::form;
	$main::mod = $main::m;

	#᡼CSS
	$setting::image_css = 'tablemaker-image.css';
}

1;
