package AccessRanking;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# 󥭥󥰥⥸塼
# AccessRanking.pm ver1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-07-24
######################################################################
# ᥤ
sub run ($) {
my $this = shift;

#󥭥
$this->use_deco;
$this->ranking_setting;

#إå
$this->print_page_header('ranking');
$this->contents_header;

#
$this->count;

#
$this->print_report;

#եå
$this->print_tool_icon if $this->is_secure('tools');
$this->print_page_footer('ranking');

}

######################################################################
# 
sub count ($) {
my $this = shift;
my(@localtime,$month,$date,$date2);

@localtime = localtime(time);
$month = ($localtime[5] + 1900) . sprintf("%.2d", ++$localtime[4]);
$date = $month . sprintf("%.2d", $localtime[3]);

@localtime = localtime(time - 86400);
$date2 = ($localtime[5] + 1900) . sprintf("%.2d", ++$localtime[4]) . sprintf("%.2d", $localtime[3]);

# Ⱦɤ߽
my(%counter);
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
tie(%counter, $env::dbm_file, $default::access_counter . '/access_counter', O_RDONLY, $env::dbm_mode);
if (ref tied %counter) {
	my($location,$data);
	while (($location,$data) = each %counter) {

		#оݥեå
		next if @setting::target && grep(eval {$location =~ /$_/},@setting::target) == 0;

		my(@data);
		@data = split(/\x09/,$counter{$location});
		$this->{'access_count'}->{$location} = $this->access_count(\@data,$month,$date,$date2);
	}
}
untie %counter;
}

sub access_count ($$$$$) {
my($this,$data,$month,$date,$date2) = @_;
if (defined $setting::ranking{'span'} && $setting::ranking{'span'} eq 'thismonth') {
	if (defined $$data[1] && defined $month && $$data[1] eq $month) {
		return $$data[2];
	} else {
		return 0;
	}
} elsif (defined $setting::ranking{'span'} && $setting::ranking{'span'} eq 'today') {
	if (defined $$data[3] && defined $date && $$data[3] eq $date) {
		return $$data[4];
	} else {
		return 0;
	}
} elsif (defined $setting::ranking{'span'} && $setting::ranking{'span'} eq 'yesterday') {
	if (defined $$data[5] && defined $date2 && $$data[5] eq $date2) {
		return $$data[6];
	} elsif (defined $$data[3] && defined $date2 && $$data[3] eq $date2) {
		return $$data[4];
	} else {
		return 0;
	}
} else {
	return $$data[0];
}
}

######################################################################
# ɽ
sub print_report ($) {
my $this = shift;
#my(@ranking,$tablewidth,$grafwidth,$lastpage,$max);
my(@ranking,$lastpage,$max);

#
$setting::ranking{'sort'} = 'descend' if !defined $setting::ranking{'sort'} || $setting::ranking{'sort'} ne 'ascend';
@ranking = sort {$this->sort_by(\$this->{'access_count'}->{$a},\$this->{'access_count'}->{$b},$setting::ranking{'sort'}) || $a cmp $b} keys %{$this->{'access_count'}};

#
$max = (ref $this->{'access_count'} && @ranking) ? ($setting::ranking{'sort'} eq 'ascend') ? $this->{'access_count'}->{$ranking[$#ranking]} : $this->{'access_count'}->{$ranking[0]} : 0;

#
#$grafwidth = ($this->{'Table'}->{'cellpadding'} * 2) + ($this->{'Table'}->{'cellspacing'} * 2) + $this->{'Table'}->{'border'} + $this->{'BarGraph'}->{'barWidth'};
#$tablewidth = 430 + $grafwidth;

$this->{'Table'}->set(
#	'tablewidth' => $tablewidth,
	'styleH' => 'text-align: center; width: 30px, text-align: center; width: 300px, text-align: center; width: 100px, text-align: center; width: ' . $this->{'BarGraph'}->{'barWidth'} . 'px',
	'style0' => 'text-align: center,text-align: center,text-align: right,text-align: left'
);

#ڡ
$setting::ranking{'u'} = 40 if $this->is_nan($setting::ranking{'u'});
$lastpage = ($setting::ranking{'u'}) ? ((@ranking % $setting::ranking{'u'}) ? int(@ranking / $setting::ranking{'u'}) + 1 : @ranking / $setting::ranking{'u'}) : 1;
if (!$main::p || $main::p < 1) {
	$main::p = 1;
} elsif ($main::p > $lastpage) {
	$main::p = $lastpage;
}
print '<div id="ranking-report">';
print ' (' . $main::p . '/'. $lastpage . 'ڡ)' if $lastpage > 1;
print $this->{'Table'}->table;
print $this->{'Table'}->tr;
print $this->{'Table'}->td('No.');
print $this->{'Table'}->td('URL');
print $this->{'Table'}->td('');
print $this->{'Table'}->td(' ()');
print $this->{'Table'}->_tr;

#Ϸ
my($count,$ranking,$location,$prev,$pageoption);
foreach $location (@ranking) {
	$count++;

	#ڡ
	if ($setting::ranking{'u'} > 0) {
		if ($setting::ranking{'u'} * ($main::p - 1) >= $count) {
			$pageoption = 1;
			next;
		} elsif ($setting::ranking{'u'} * $main::p < $count) {
			$pageoption = 1;
			last;
		}
	}

	#󥭥
	$ranking = $count if (defined $this->{'access_count'}->{$location} && defined $prev && $this->{'access_count'}->{$location} != $prev) || !$ranking;

	print $this->{'Table'}->tr;
	print $this->{'Table'}->td($ranking);
	print $this->{'Table'}->td($this->ranking_key($location));
	print $this->{'Table'}->td(($this->{'access_count'}->{$location}) ? $this->{'access_count'}->{$location} : 0);
	print $this->{'Table'}->td($this->{'BarGraph'}->bargraph($this->{'access_count'}->{$location},$max,''));
	print $this->{'Table'}->_tr;
	$prev = $this->{'access_count'}->{$location};
}
print $this->{'Table'}->_table;

if (defined $pageoption && $pageoption) {
	my $form_flag = 0;
	if ($setting::general{'postMethod'}) {
		print $this->form_start(
			'key'	=>	'ranking',
			'name'	=>	'input',
			'required'	=>	\@setting::form
		);
		$form_flag = 1;
	} else {
		$this->use_deco;
	}
		
	print '<ul class="tools">';
	if ($main::p > 1) {
		print '<li>';
		if ($form_flag) {
			print $cgi::Deco->submit_button('prev',$setting::page{'ranking'}{'prevButton'},'Υڡ','',{'p'=>($main::p - 1)});
		} else {
			print $cgi::Deco->button(
				'prev',
				$setting::page{'ranking'}{'prevButton'},
				'./start.cgi' . $this->set_query('url',\@setting::form) . $this->add_query('url',{'p'=>$main::p - 1}),
				'Υڡ'
			);
		}
		print '</li>';
	}
	if ($main::p < $lastpage) {
		print '<li>';
		if ($form_flag) {
			print $cgi::Deco->submit_button('next',$setting::page{'ranking'}{'nextButton'},'Υڡ','',{'p'=>($main::p + 1)});
		} else {
			print $cgi::Deco->button(
				'next',
				$setting::page{'stat'}{'nextButton'},
				'./start.cgi' . $this->set_query('url',\@setting::form) . $this->add_query('url',{'p'=>$main::p + 1}),
				'Υڡ',
			);
		}
		print '</li>';
	}
	print '</ul>';
	print '</form>' if $form_flag;
}
print '</div>';
}

######################################################################
# Ĵ
sub ranking_key ($$) {
my($this,$key) = @_;
return '<a href="' . $key . '" target="_blank">' . $this->jfold($this->query_decode($key),40,'r') . '</a>';
}

sub query_decode ($$) {
my($this,$query) = @_;
$query =~ s/\+/ /g;
$query =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
return $cgi::Jcode->set(\$query)->euc;
}

######################################################################
# ƥĥإå
sub contents_header ($) {
my $this = shift;

#Ͼơ֥
$this->{'infoTable'} = Table->new;
if (defined $setting::page{'ranking'}{'infoTable'} && ref $table::obj{$setting::page{'ranking'}{'infoTable'}}) {
	%{$this->{'infoTable'}} = %{$table::obj{$setting::page{'ranking'}{'infoTable'}}};
	$this->{'infoTable'}->{'fixed'} = 0;
} else {
	$this->{'infoTable'}->set(
		'fixed' => 0,
		'tableclass' => 'datatable',
		'trclass' => 'odd,even',
		'class0' => 'odd,even',
	);
}

#Ϸ̥ơ֥
$this->{'Table'} = Table->new;
if (defined $setting::page{'ranking'}{'table'} && ref $table::obj{$setting::page{'ranking'}{'table'}}) {
	%{$this->{'Table'}} = %{$table::obj{$setting::page{'ranking'}{'table'}}};
	$this->{'Table'}->{'fixed'} = 0;
} else {
	$this->{'Table'}->set(
		'fixed' => 0,
		'tableclass' => 'datatable',
		'trclass' => 'odd,even',
		'class0' => 'odd,even',
		'thenabled' => 'true'
	);
}

#ե⥸塼ɤ߹
require CMONOS::CGI_Lib::BarGraph;
$this->{'BarGraph'} = BarGraph->new(
	\%setting::deco,
	$setting::page{'ranking'}{'barColor'},
	$setting::page{'ranking'}{'bgColor'},
	$setting::page{'ranking'}{'barImage'},
	$setting::page{'ranking'}{'bgImage'},
	$setting::page{'ranking'}{'barWidth'}
);

#Ͼ
$this->print_ranking_env;

#ȥ
print '<h1>' . $this->ranking_title . '</h1>';
}

sub ranking_title ($) {
my $this = shift;
if (!defined $setting::ranking{'span'}) {
	return '󥭥';
} elsif ($setting::ranking{'span'} eq 'thismonth') {
	return 'Υ󥭥';
} elsif ($setting::ranking{'span'} eq 'today') {
	return 'Υ󥭥';
} elsif ($setting::ranking{'span'} eq 'yesterday') {
	return 'Υ󥭥';
} else {
	return '󥭥';
}
}

######################################################################
# Ͼ
sub print_ranking_env ($) {
my $this = shift;

#ե೫
print $this->form_start(
	'key'	=>	'ranking',
	'name'	=>	'input',
	'required'	=>	\@setting::form
);

print $this->{'infoTable'}->table('id','accesscounter-env');

#󥭥о
my $target = (defined $setting::ranking{'target'}) ? $setting::ranking{'target'} : '';
$target =~ s/\\(?!\\)//g if !defined $setting::ranking{'regexp'} || !$setting::ranking{'regexp'};
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('<label for="setting:target">󥭥оݥե</label>');
print $this->{'infoTable'}->td(
	'<textarea name="setting:target" id="setting:target" wrap="off"'
	. ' title="ѥΰꤵ줿ʸޤեΤߥ󥭥󥰤ޤ" cols="60" rows="4">'
	. $this->escape($target)
	. '</textarea>'

	. '<div class="external-field"><label for="setting:regexp" class="datatitle">ɽ</label>'
	. '<select name="setting:regexp" id="setting:regexp">'
	. '<option value="">Ի</option>'
	. '<option value="1"' . (($setting::ranking{'regexp'}) ? ' selected="selected"' : '') . '></option>'
	. '</select></div>'

);
print $this->{'infoTable'}->_tr;

#󥭥
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('󥭥');
print $this->{'infoTable'}->td(
	'<label for="setting:u" class="datatitle">ɽ</label><input type="text" name="setting:u" id="setting:u" value="' . $this->escape($setting::ranking{'u'}) . '" size="3" maxlength="3" />'
	. '<select name="setting:sort">'
	. '<option value="descend"' . ((defined $setting::ranking{'sort'} && $setting::ranking{'sort'} eq 'descend') ? ' selected="selected"' : '') . '>߽</option>'
	. '<option value="ascend"' . ((defined $setting::ranking{'sort'} && $setting::ranking{'sort'} eq 'ascend') ? ' selected="selected"' : '') . '></option>'
	. '</select>'
);
print $this->{'infoTable'}->_tr;

#󥭥оݴ
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('<label for="setting:span">󥭥оݴ</label>');
print $this->{'infoTable'}->td(
	'<select name="setting:span" id="setting:span">'
	. '<option value=""></option>'
	. '<option value="thismonth"' . ((defined $setting::ranking{'span'} && $setting::ranking{'span'} eq 'thismonth') ? ' selected="selected"' : '') . '></option>'
	. '<option value="today"' . ((defined $setting::ranking{'span'} && $setting::ranking{'span'} eq 'today') ? ' selected="selected"' : '') . '></option>'
	. '<option value="yesterday"' . ((defined $setting::ranking{'span'} && $setting::ranking{'span'} eq 'yesterday') ? ' selected="selected"' : '') . '></option>'
	. '</select>'
	. ' <input type="submit" value="ɽ" />'
);
print $this->{'infoTable'}->_tr;

print $this->{'infoTable'}->_table;
print '</form>';

}

######################################################################
# 񤭹/ɤ߹
sub ranking_setting ($) {
my $this = shift;

#񤭹/ɤ߹
if (%main::setting) {
	$main::setting{'u'} = '' if $this->is_nan($main::setting{'u'});
	$main::setting{'target'} =~ s/[<>"]//gs if defined $main::setting{'target'} && $main::setting{'target'};
	$this->write_db($default::preference_dir . '/ranking',\%main::setting,'','',\%setting::ranking,1);

#ɤ߹ߤΤ
} else {
	$this->import_db($default::preference_dir . '/ranking',\%setting::ranking,1);
}

if (defined $setting::ranking{'target'} && $setting::ranking{'target'}) {
	@setting::target = grep($_ ne '',split(/\s+/,$setting::ranking{'target'}));
	map($_ = quotemeta $_,@setting::target) if !defined $setting::ranking{'regexp'} || !$setting::ranking{'regexp'};
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;					#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 1;					#ơ֥ɤ߹
	$setting::page = 1;						#ڡɤ߹

	#省
	$setting::security_key = 'ranking';			#ǥեȥƥ
	$setting::key = 'ranking';					#ڡꥭ

	#å
	$cookie::id_enabled = 1;						#ID󥯥åɤ߹

	#ɬܥե
	@setting::form = ('k','m');

	#ǥեȥ
	$main::k = 'ranking' if !defined $main::k || !$main::k;

	#饹Ͽ
	Common::class_register('ranking','AccessRanking');

}


1;

