package ClickRatioReport;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
######################################################################
# 󥯸󥭥󥰥⥸塼
# ClickRatioReport.pm ver1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-02-11
######################################################################
# 
# 	$$data[0]	֡hhmmss
# 	$$data[1]	IPREMOTE_HOST
# 	$$data[2]	ե
# 	$$data[3]	饤ȴĶHTTP_USER_AGENT
# 	$$data[4]	饤ȼHTTP_ACCEPT_LANGUAGE
# 	$$data[5]	󥯸HTTP_REFERER
# 	$$data[6]	ɥ¦
# 	$$data[7]	ɥ¦ι⤵
# 	$$data[8]	Ѳǽʥ꡼
# 	$$data[9]	Ѳǽʥ꡼⤵
sub log_stat ($$$) {
my($this,$date,$data) = @_;
my $uri = $$data[2];
my $referer = $$data[5];
if ($setting::stat{'click'}{'option'} eq 'ignore' || $setting::stat{'click'}{'option'} eq 'noquery') {
	$uri =~ s/\?.*$//;
	$referer =~ s/\?.*$//;
} else {
	$uri = $this->url_filter($uri,1);
	$referer = $this->url_filter($referer,1);
}
if ($setting::stat{'click'}{'option'} eq 'ignore' || $setting::stat{'click'}{'option'} eq 'noanchor') {
	$uri =~ s/\#.*$//;
	$referer =~ s/\#.*$//;
}
$this->{'total_click'}++ if $uri eq $setting::stat{'click'}{'target'};
if ($referer eq $setting::stat{'click'}{'target'}) {
	$this->{'click_count'}->{$uri}++;
	$this->{'checked_click'}++;
	return 1;
} else {
	return 0;
}
}

sub _stat_setting ($) {
my $this = shift;
$main::setting{'click_target'} = $main::clicktarget if defined $main::clicktarget && $main::clicktarget;
return;
}

######################################################################
# ϴĶɲá
sub print_sub_stat_env ($) {
my $this = shift;
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('оݥڡ');
print $this->{'infoTable'}->td(
	'<input type="text" name="setting:click_target" size="30" value="' . $this->escape($setting::stat{'click'}{'target'}) . '" />'
	. ' <select name="setting:click_option">'
	. '<option value="">URLñ̤ǽפ</option>'
	. '<option value="noquery"' . (($setting::stat{'click'}{'option'} eq 'noquery') ? ' selected="selected"' : '') . '>CGIξʬ̵뤹</option>'
	. '<option value="noanchor"' . (($setting::stat{'click'}{'option'} eq 'noanchor') ? ' selected="selected"' : '') . '>󥫡̵뤹</option>'
	. '<option value="ignore"' . (($setting::stat{'click'}{'option'} eq 'ignore') ? ' selected="selected"' : '') . '>CGIξʬȥ󥫡̵뤹</option>'
	. '</select>'
	. $this->submit_button($env::image_dir . '/stat/node.gif',14,14,'Υե뤫Υ󥯤ΥåΨ󥭥󥰤ޤ','','m','ClickRatioReport','k','click')
);
print $this->{'infoTable'}->_tr;
}

######################################################################
# Ĵ
sub stat_key ($$) {
my($this,$key) = @_;
return $this->url_to_title($key);
}

######################################################################
# ɲù
sub stat_option ($$$) {
my($this,$key,$value) = @_;
if ($key =~ m!^http://!i) {
	return $this->submit_button($env::image_dir . '/stat/node.gif',14,14,'Υե뤫Υ󥯤ΥåΨ󥭥󥰤ޤ','','m','ClickRatioReport','k','click','clicktarget',$key);
} else {
	return '&nbsp;';
}
}

######################################################################
# ϥȥ
sub stat_title ($) {
my $this = shift;
return 'ڡ̥åΨ󥭥';
}

######################################################################
# Ϸɽ
sub print_report ($) {
my $this = shift;
return if defined $this->{'noLog'} && $this->{'noLog'};
$this->tie_title_db;
my(@ranking);
$this->{'total_click'} = 0 if !defined $this->{'total_click'};
$this->{'checked_click'} = 0 if !defined$this->{'checked_click'} ;
$setting::stat{'click'}{'sort'} = 'descend' if !defined $setting::stat{'click'}{'sort'} ||  $setting::stat{'click'}{'sort'} eq '';
$this->{'total_click'} = $this->{'checked_click'} if $this->{'total_click'} && $this->{'checked_click'} && $this->{'total_click'} < $this->{'checked_click'};
$this->{'click_count'}->{(($default::english) ? 'Missing' : '')} = $this->{'total_click'} - $this->{'checked_click'} if $this->{'total_click'} - $this->{'checked_click'} > 0;
@ranking = sort {
	$this->sort_by(\$this->{'click_count'}->{$a},\$this->{'click_count'}->{$b},$setting::stat{'click'}{'sort'}) || 
	$a cmp $b
} keys %{$this->{'click_count'}};
$this->print_stat_report(
	'',
	\@ranking,
	$this->{'click_count'},
	'',
	'',
	$this->{'total_click'},
	'click',
	1,
	'',
	'left',
	300,
	'',
	100,
	'%',
	'åΨ',
	60,
	'/' . $this->{'total_click'} . '[]'
);
$this->untie_title_db;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#ǥեȥ
	$main::k = 'click' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('click','ClickRatioReport');

}


1;

