package GeneralReport;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
######################################################################
# ץݡȥ⥸塼
# GeneralReport.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# 
# 	$$data[0]	֡hhmmss
# 	$$data[1]	IPREMOTE_HOST
# 	$$data[2]	ե
# 	$$data[3]	饤ȴĶHTTP_USER_AGENT
# 	$$data[4]	饤ȼHTTP_ACCEPT_LANGUAGE
# 	$$data[5]	󥯸HTTP_REFERER
# 	$$data[6]	ɥ¦
# 	$$data[7]	ɥ¦ι⤵
# 	$$data[8]	Ѳǽʥ꡼
# 	$$data[9]	Ѳǽʥ꡼⤵
sub log_stat ($$$) {
my($this,$date,$data) = @_;
my($wday,$hour);

#̽
$hour = $1 + 0 if $$data[0] =~ /^([0-9]{2})/;
if (defined $hour && $hour ne '') {
	$this->{'access_hour'}->{$hour}++;
	$this->{'count_hour'}++ if !defined $this->{'date'} || $this->{'date'} ne $date;
}

#̽
@{$this->{'week'}} = ('', '', '', '', '', '', '');
$wday = $this->{'week'}->[$this->get_wday($1,$2,$3)] if $date =~ /^([0-9]{4})([0-9]{2})([0-9]{2})/;;
if (defined $wday && $wday ne '') {
	$this->{'access_wday'}->{$wday}++;
	$this->{'count_wday'}->{$wday}++ if !defined $this->{'date'} || $this->{'date'} ne $date;
}

$this->{'date'} = $date;
return ($hour eq '' && $wday eq '') ? 0 : 1;
}

######################################################################
# ϥȥ
sub stat_title ($) {
my $this = shift;
return 'γ';
}

######################################################################
# Ϸɽ
sub print_report ($) {
my $this = shift;
return if defined $this->{'noLog'} && $this->{'noLog'};
my($k,$v);

#̽

#ʿͲ
while (($k,$v) = each %{$this->{'access_hour'}}) {
	$this->{'access_hour'}->{$k} = ($this->{'count_hour'}) ? int((($v / $this->{'count_hour'}) * 100) + 0.5) / 100 : 0;
}

my(@hour);
@hour = (0..23);
$this->print_stat_report(
	'̽',
	\@hour,
	$this->{'access_hour'},
	'',
	'',
	((%{$this->{'access_hour'}}) ? $this->{'access_hour'}->{$this->maximum($this->{'access_hour'})} : ''),
	'',
	0,
	'',
	'center',
	50,
	'ʿѥ',
	100,
	''
);

#̽

#ʿͲ
while (($k,$v) = each %{$this->{'access_wday'}}) {
	$this->{'access_wday'}->{$k} = ($this->{'count_wday'}->{$k}) ? int((($v / $this->{'count_wday'}->{$k}) * 100) + 0.5) / 100 : 0;
}

$this->print_stat_report(
	'̽',
	$this->{'week'},
	$this->{'access_wday'},
	'',
	'',
	((%{$this->{'access_wday'}}) ? $this->{'access_wday'}->{$this->maximum($this->{'access_wday'})} : ''),
	'',
	0,
	'',
	'center',
	50,
	'ʿѥ',
	100,
	''
);

}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#ǥեȥ
	$main::k = 'general' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('general','GeneralReport');

}


1;

