package KeywordReport;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
######################################################################
# ɥ󥭥󥰥⥸塼
# KeywordReport.pm ver1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-08-07
######################################################################
# 
# 	$$data[0]	֡hhmmss
# 	$$data[1]	IPREMOTE_HOST
# 	$$data[2]	ե
# 	$$data[3]	饤ȴĶHTTP_USER_AGENT
# 	$$data[4]	饤ȼHTTP_ACCEPT_LANGUAGE
# 	$$data[5]	󥯸HTTP_REFERER
# 	$$data[6]	ɥ¦
# 	$$data[7]	ɥ¦ι⤵
# 	$$data[8]	Ѳǽʥ꡼
# 	$$data[9]	Ѳǽʥ꡼⤵
sub log_stat ($$$) {
my($this,$date,$data) = @_;
my($query,@name,@name2,@keywords);

if (defined $$data[5] && $$data[5] =~ /\?(.*)$/) {
	@keywords = $this->query_to_keywords($1,$setting::stat{'keyword'}{'option'});
} else {
	return 0;
}
return 0 if !@keywords;

if (!$this->{'is_counted'}{$$data[1] . $$data[3]}) {
	if ($setting::stat{'keyword'}{'option'}) {
		return 0 if !@keywords;
		$this->{'search_keyword'}->{$keywords[0]}++ if defined $keywords[0] && $keywords[0] ne '' && $keywords[0] =~ /\S/;
	} else {
		foreach my $k (@keywords) {
			$this->{'search_keyword'}->{$k}++ if defined $k && $k ne '' && $k =~ /\S/;
		}
	}
	$this->{'is_counted'}{$$data[1] . $$data[3]} = 1;
}
return 1;
}

######################################################################
# ϴĶɲá
sub print_sub_stat_env ($) {
my $this = shift;
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('ˡ');
print $this->{'infoTable'}->td(
	'<select name="setting:keyword_option">'
	. '<option value="">ñ줴Ȥ˽פ</option>'
	. '<option value="1"' . (($setting::stat{'keyword'}{'option'}) ? ' selected="selected"' : '') . '>ǽפ</option>'
	. '</select> '
	. $this->submit_button($env::image_dir . '/stat/keyword.gif',20,20,'ɥ󥭥','','m','KeywordReport','k','keyword')
);
print $this->{'infoTable'}->_tr;
}

######################################################################
# Ĵ
sub stat_key ($$;$) {
my($this,$key) = @_;
my $limit = ($setting::stat{'keyword'}{'option'}) ? 40 : 24;
return '<strong>' . ((length $key < $limit) ? $this->escape_without_html_entity($key) : $this->jfold($this->escape_without_html_entity($key),$limit,'r',0,'<wbr />')) . '</strong>';
}

######################################################################
# ϥȥ
sub stat_title ($) {
my $this = shift;
return 'ɥ󥭥';
}

######################################################################
# Ϸɽ
sub print_report ($) {
my $this = shift;
undef %{$this->{'is_counted'}};
delete $this->{'is_counted'};
return if defined $this->{'noLog'} && $this->{'noLog'};

my(@ranking);
$setting::stat{'keyword'}{'sort'} = 'descend' if !defined $setting::stat{'keyword'}{'sort'} ||  $setting::stat{'keyword'}{'sort'} eq '';
@ranking = sort {$this->sort_by(\$this->{'search_keyword'}->{$a},\$this->{'search_keyword'}->{$b},$setting::stat{'keyword'}{'sort'}) || $a cmp $b} keys %{$this->{'search_keyword'}};

$this->print_stat_report(
	'',
	\@ranking,
	$this->{'search_keyword'},
	'',
	'',
	((!ref $this->{'search_keyword'} || !%{$this->{'search_keyword'}}) ? 0 : ($setting::stat{'keyword'}{'sort'} && $setting::stat{'keyword'}{'sort'} eq 'ascend') ? $this->{'search_keyword'}->{$ranking[$#ranking]} : $this->{'search_keyword'}->{$ranking[0]}),
	'keyword',
	1,
	'',
	'left',
	(($setting::stat{'keyword'}{'option'}) ? 300 : 180),
	'',
	100,
	''
);

}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#ǥեȥ
	$main::k = 'keyword' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('keyword','KeywordReport');

}


1;

