package BbCommon;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ХХ֥åȥåץ⥸塼
# BbCommon.pm ver1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2008-12-02
######################################################################
sub amp_escape ($$) {
my($this,$url) = @_;
return '' if !defined $url;
$url =~ s/\&/\&amp;/g;
return $url;
}

######################################################################
# ǡ١³
sub tie_db_by_field_setting ($$$) {
my($this,$database,$key) = @_;
my($id,$field);
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
while (($id,$field) = each %field::obj) {
	next unless ref $field;
	my $db = $field->db;
	if ($db && $field->{$key} && !ref tied %{$database->{$db}}) {
		tie(%{$database->{$db}}, $env::dbm_file, "$default::db/$db", O_RDONLY, $env::dbm_mode);
	}
}
}

sub tie_db ($$@) {
my($this,$database,@field) = @_;
return if !@field;
my($id);
foreach $id (@field) {
	my $db = $field::obj{$id}->db;
	next if !defined $db ||  $db eq '';
	unless (ref tied %{$database->{$db}}) {
		tie(%{$database->{$db}}, $env::dbm_file, "$default::db/$db", O_RDONLY, $env::dbm_mode);
	}
}
}

sub untie_db ($$) {
my($this,$database) = @_;
my($k,$db);
while (($k,$db) = each %$database) {
	untie(%$db);
	undef %$db;
}
undef %$database;
}

######################################################################
# 쥹Ĥ뤫ɤ
sub tree_enabled ($) {
my $this = shift;
return $this->{'tree_enabled'} if defined $this->{'tree_enabled'} && $this->{'tree_enabled'} ne '';
my($field);
foreach $field (values %field::obj) {
	if ($field->{'class'} eq 'xbb_viewselector' && (
			$field->{'treeres'} || $field->{'listres'} || $field->{'articlelistres'} || $field->{'articleres'}
			 || $field->{'treeres'} eq '' || $field->{'listres'} eq '' || $field->{'articlelistres'} eq '' || $field->{'articleres'} eq ''
		)) {
		$this->{'tree_enabled'} = 1;
		return 1;
	}
}
$this->{'tree_enabled'} = 0;
return 0;
}

######################################################################
# 롼ȵֹ
sub get_top ($$) {
my($this,$n,$info) = @_;
return (defined $info && $info =~ /^[^,]+,(\d+)/) ? $1 : $n; 
}

######################################################################
# ɽڤؤܥ
sub view_switch_button ($$;$$$$$$$) {
my($this,$view,$title,$url,$query,$li_class,$onclick,$target,$is_selected) = @_;
my $button;
$button = '<li' . ((defined $li_class && $li_class ne '') ? ' class="' . $li_class . '"' : '') . '>';
if (defined $url && $url ne '') {
	$url .= $this->amp_escape($this->add_query('url',$query)) if ref $query;
	$button .= $cgi::icon->button(
		$view,
		$setting::page{$view} . (($is_selected) ? '-selected' : ''),
		$url,
		$title,
		$target,
		(($onclick) ? {'onclick' => $onclick} : '')
	);
} else {
	if ($target) {
		if ($onclick =~ /^return/) {
			$onclick =~ s/;$/ \&\& /;
			$onclick .= '(this.form.target=\'' . $target . '\');';
		} else {
			$onclick .= ';' if $onclick;
			$onclick .= 'this.form.target=\'' . $target . '\';';
		}
	}		
	$button .= $cgi::icon->submit_button(
		$view,
		$setting::page{$view} . (($is_selected) ? '-selected' : ''),
		$title,
		(($onclick) ? {'onclick' => $onclick} : ''),
		$query
	);
}
$button .= '</li>';
return $button;
}

######################################################################
# åȥå
#sub import {
BEGIN {
if (!$default::subdivided || ($default::subdivided && defined $main::c && $main::c ne '')) {

	#DBɤ߹
	$setting::general = 1;				#ɤ߹
	$setting::deco = 1;					#ƥɤ߹
	$setting::security = 1;				#ɤ߹
	$setting::table = 1;				#ơ֥ɤ߹
	$setting::page = 1;					#ڡɤ߹

	#å
	$cookie::id_enabled = 1;					#ID󥯥åɤ߹

	#եɤ߹
	$setting::field_db_name = 'inputfield';		#եDB
	$setting::field = 2;					#եɤ߹ߡ2=ꥸʥɤ߹
	$setting::field_style_disabled = 0;			#2=եꥹ̵/1=եΤ̵
	$setting::field_tag_enabled = 'no';			#tag=Τ/all=Ƥ/no=Ĥʤ

	#ɬפʥ⥸塼
	use Fcntl qw(:DEFAULT);
	eval 'use ' . $env::dbm_file . ';';

	#ɬܥե
	@setting::form = ('k','m','s','w','tc','st','and','search','q') if !@setting::form;
	@setting::form0 = ('k','m');
	@setting::form1 = ('s','w','tc','st','and','search','q');

	#ǥեȲ̤Ĵ
	if ($default::subdivided && defined $main::c && $main::c ne '') {
		unshift(@setting::form,'c');
		unshift(@setting::form0,'c');
		unshift(@setting::form1,'c');
	}

	#᡼CSS
	$setting::image_css = 'baobab-image.css';

} else {
	$main::m = $default::m = 'Index';
	$main::k = $default::k = 'index';
	require CMONOS::Baobab::Index;
}
}

1;
