package ThreadStatus;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# եɥ⥸塼ʥåɾ
# ThreadStatus.pm 1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-06-14
######################################################################
sub set_my_type($;$) {
my($v,$k) = @_;
$ThreadStatus::is_tree = ((defined $v && $v =~ /tree/) || (defined $k && $k =~ /tree/)) ? 1 : 0;
}

sub _set ($$) {
my($this,$setting) = @_;
set_my_type($main::v,$main::k);
$this->{'field_for'}{'status'} = $this->{'id'};
return;
}

sub thread_status_name ($;$) {
my($this,$status) = @_;
return (
	($status eq '') ? (($setting::page{'statusnew'} && ref $setting::icon{'statusnew'}{$setting::page{'statusnew'}} && $setting::icon{'statusnew'}{$setting::page{'statusnew'}}{'alt'}) ? $setting::icon{'statusnew'}{$setting::page{'statusnew'}}{'alt'} : ($default::english) ? 'New' : '') :
	($status eq 'new') ? (($setting::page{'statusnew'} && ref $setting::icon{'statusnew'}{$setting::page{'statusnew'}} && $setting::icon{'statusnew'}{$setting::page{'statusnew'}}{'alt'}) ? $setting::icon{'statusnew'}{$setting::page{'statusnew'}}{'alt'} : ($default::english) ? 'New' : '') :
	($status eq 'operational') ? (($setting::page{'statusoperational'} && ref $setting::icon{'statusoperational'}{$setting::page{'statusoperational'}} && $setting::icon{'statusoperational'}{$setting::page{'statusoperational'}}{'alt'}) ? $setting::icon{'statusoperational'}{$setting::page{'statusoperational'}}{'alt'} : ($default::english) ? 'In Operation' : 'ʹ') :
	($status eq 'solved') ? (($setting::page{'statussolved'} && ref $setting::icon{'statussolved'}{$setting::page{'statussolved'}} && $setting::icon{'statussolved'}{$setting::page{'statussolved'}}{'alt'}) ? $setting::icon{'statussolved'}{$setting::page{'statussolved'}}{'alt'} : ($default::english) ? 'Solved' : '') : ($default::english) ? 'Unknown' : ''
);
}

######################################################################
#	(0)-3 եDB
sub db ($) {
my $this = shift;
return 'thread_status';
}

# --------------------------------------------------------------------
#	(0)-8 obj->align;
sub align ($) {
my $this = shift;
return 'center';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
$this->scalar_to_array(\$main::search{$this->{'id'}}{'str'});
return 1 if @{$main::search{$this->{'id'}}{'str'}};
return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
return 1 if !ref $main::search{$this->{'id'}}{'str'} || !@{$main::search{$this->{'id'}}{'str'}};
foreach (@{$main::search{$this->{'id'}}{'str'}}) {
	next if !defined $_ ||  $_ eq '';
	return 1 if (defined $$str && $$str eq $_) || ((!defined $$str || $$str eq '') && $_ eq 'new');
}
return 0;
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
my $this = shift;
return (!$main::parent || ($main::data{$field::for{'name'}}{'str'} ne '' && $main::data{$field::for{'name'}}{'str'} ne $thread::root)) ? 0 : 1;
}

sub form {
my($this,$status,$original) = @_;
if (!$main::parent || (defined $field::for{'name'} && defined $main::data{$field::for{'name'}}{'str'} && $main::data{$field::for{'name'}}{'str'} ne '' && $main::data{$field::for{'name'}}{'str'} ne $thread::root)) {
	return '';
} else {
	my $form = $this->field_header;
	if ($thread::status && $thread::status eq 'solved') {
		if (defined $setting::page{'statussolved'} && $setting::page{'statussolved'} && $setting::icon{'statussolved'}{$setting::page{'statussolved'}}{'name'}) {
			$this->use_icon('baobab','bb_icon') if !ref $cgi::icon;
			$form .= $cgi::Image->image_tag(
				$cgi::icon->{'image_dir'} . '/statussolved/' . $setting::icon{'statussolved'}{$setting::page{'statussolved'}}{'name'},
				$setting::icon{'statussolved'}{$setting::page{'statussolved'}}{'width'},
				$setting::icon{'statussolved'}{$setting::page{'statussolved'}}{'height'},
				0,
				$this->thread_status_name('solved')
			);
		} else {
			$form .= '(' . $this->escape($this->thread_status_name('solved')) . ')';
		}
	} else {
		$form .= '<label><input type="checkbox" name="status" value="solved"' . (($main::status && $main::status eq 'solved') ? ' checked="checked"' : '') . ' /> ' . $this->thread_status_name('solved') . '</label>';
	}
	$form .= $this->field_footer;
	return $form;
}
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
my $this = shift;
delete $main::data{$this->{'id'}}{'str'};
if (!defined $main::parent || !$main::parent) {
	undef $main::status;
	undef @main::status;
} elsif ($thread::root ne '' && $main::data{$field::for{'name'}}{'str'} ne $thread::root) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'åɾ') . 'ѹǤޤ󡣥åɺԤǤϤޤ') if ref $cgi::action && ($main::status || @main::status);
	undef $main::status;
	undef @main::status;
} elsif (@main::status) {
	undef @main::status;
	$main::status = 'solved';
} elsif (defined $main::status && $main::status) {
	$main::status = 'solved';
}
return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
my($this,$str,$path,$c,$n,$db) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
my $status = (defined $str && $str ne '') ? $str : $this->get_thread_status_id($n,$db);
return '' if !defined $status || !$status;
my $icon_name = 'status' . $status;
if ((!$ThreadStatus::is_tree || $this->{'icon'}) && $setting::page{$icon_name} && ref $setting::icon{$icon_name}{$setting::page{$icon_name}} && $setting::icon{$icon_name}{$setting::page{$icon_name}}{'name'}) {
	$this->use_icon('baobab','bb_icon') if !ref $cgi::icon;
	return $this->field_tag(
		$cgi::Image->image_tag(
			(($cgi::output || $cgi::output_option) ? $this->base_change($cgi::icon->{'image_dir'},$cgi::output,$cgi::output_option) : $cgi::icon->{'image_dir'}) . '/' . $icon_name . '/' . $setting::icon{$icon_name}{$setting::page{$icon_name}}{'name'},
			$setting::icon{$icon_name}{$setting::page{$icon_name}}{'width'},
			$setting::icon{$icon_name}{$setting::page{$icon_name}}{'height'},
			0,
			$this->thread_status_name($status)
		)
	);
} else {
	return $this->field_tag(
		$this->style(
			'(' . $this->escape($this->thread_status_name($status)) . ')',
			$this->{'style'},
			$this->{'fontsize'},
			$this->{'fontcolor'},
			$this->{'fontface'}
		)
	);
}
}

sub has_content {
my($this,$str,$type,$path,$c,$n,$db) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
my $status = (defined $str && $str ne '') ? $str : $this->get_thread_status_id($n,$db);
return ($status) ? 1 : 0;
}

sub get_thread_status_id ($$$) {
my($this,$n,$db) = @_;
my $status = $db->{'thread_status'}->{$cgi::action->get_top($n,$db->{'tree'}->{$n})};
return ($status) ? $status : ($main::parent) ? 'operational' : 'new';
}

sub format_for_mail {
my($this,$str,$path,$c,$n,$db) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return '' if (!defined $str || $str eq '') && !ref $db;
my $status = (defined $str && $str ne '') ? $str : $this->get_thread_status_id($n,$db);
return '[' . $this->{'name'} . "]\x0A" . $this->thread_status_name($status) . "\x0A\x0A";
}

sub format_for_text {
my($this,$str,$path,$c,$n,$db) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return '' if (!defined $str || $str eq '') && !ref $db;
my $status = (defined $str && $str ne '') ? $str : $this->get_thread_status_id($n,$db);
return $this->thread_status_name($status);
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$) {
my($this,$str) = @_;
return '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled) = @_;
my($name);

#̾
$name = 'data:' . $this->{'id'};
$this->print_field_info_form($name);

print '<fieldset>';
print '<legend>ɽ</legend>';
print '<label for="' . $name . '_icon"><input type="checkbox" id="' . $name . '_icon" name="' . $name . '_icon" value="1"' . (($this->{'icon'}) ? ' checked="checked"' : '') . ' /> ĥ꡼ɽ(ʸ)ǤϤʤɽ</label>';
print '</fieldset>';

$this->print_font_setting_form($name);
$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
return $this->is_valid_font_setting;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
my $this = shift;
$this->scalar_to_array(\$main::search{$this->{'id'}}{'str'});
my $form = '<tr><td class="field-name"><span class="datatitle">' . $this->{'name'} . '</span></td><td class="field">';
$form .= '<input type="checkbox" name="search:' . $this->{'id'} . ':str" value="new"' . ((grep($_ eq 'new',@{$main::search{$this->{'id'}}{'str'}})) ? ' checked="checked"' : '') . ' /> ' . $this->thread_status_name('new');
$form .= ' <input type="checkbox" name="search:' . $this->{'id'} . ':str" value="operational"' . ((grep($_ eq 'operational',@{$main::search{$this->{'id'}}{'str'}})) ? ' checked="checked"' : '') . ' /> ' . $this->thread_status_name('operational');
$form .= ' <input type="checkbox" name="search:' . $this->{'id'} . ':str" value="solved"' . ((grep($_ eq 'solved',@{$main::search{$this->{'id'}}{'str'}})) ? ' checked="checked"' : '') . ' /> ' . $this->thread_status_name('solved');
$form .= '</td></tr>';
return $form;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('xbb_status','ThreadStatus','åɾ');
}

1;
