package InputField;
require CMONOS::CGI_Lib::Tools::FieldEditor;
@ISA = qw(FieldEditor);
use strict;
######################################################################
# ϥեԽ⥸塼
# InputField.pm ver1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-12-07
######################################################################
# եɤ߹
sub set_field ($) {
my $this = shift;
$setting::field_db_name = 'inputfield';
$setting::field = 2;
push(@check::checkbox,'protected','Hidden','tree','info','nametag','searchEnabled','sortEnabled');
$this->{'foldable'} = 1;
}

######################################################################
# եDB
sub mk_field ($$) {
my($this,$id) = @_;
return if $field::obj{$id}->db ne $id;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

#ǡ١
if (defined $default::db && $this->set_dir($default::db)) {
	my(%new,%mtime);
	tie(%new, $env::dbm_file, $default::db . '/' . $id, O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %new) {
		tie(%mtime, $env::dbm_file, $default::db . '/mtime', O_RDONLY, $env::dbm_mode);
		if (ref tied %mtime) {
			my($n);
			while (($n) = each %mtime) {
				$new{$n} = '' if !defined $new{$n} ||  $new{$n} eq '';
			}
		}
		untie(%mtime);
	}
	untie(%new);
}
}

######################################################################
# ̾
sub print_setting_item_name ($$) {
my($this,$table) = @_;
print $table->td('ݸ');
print $table->td('');
print $table->td('');
print $table->td('ơ֥ɽ<br />');
print $table->td('ĥ꡼ɽ');
print $table->td('ɽ<br />');
print $table->td('ɽ<br />̾չ');
print $table->td('о');
print $table->td('о');
}

sub field_setting_check ($$) {
my($this,$k) = @_;
if (defined $main::data{$k . '_Hidden'} && $main::data{$k . '_Hidden'}) {
	$main::data{$k . '_cellWidth'} = '';
	$main::data{$k . '_tree'} = '';
}
return;
}

sub note ($) {
my $this = shift;
return '<div class="warning">åץɤ줿եϥǽʰ֤¸ޤפޤϡֱפꤷƤľܥ뤳ȤϲǽǤ</div>';
}

######################################################################
# 
sub print_setting_items  ($$$$;$) {
my($this,$table,$field,$name,$id) = @_;
$field->{'Open'} = '1' if !defined $field->{'Open'} ||  $field->{'Open'} eq '';

if ($field->{'class'} !~ /^(?:xbb|user)_/) {
	print $table->td('<input type="checkbox" name="' . $name . 'protected" value="1"' . (($field->{'protected'}) ? ' checked="checked"' : '') . ' />') ;
} else {
	print $table->td('');
}

print $table->td(
	$this->mk_select_menu(
		$name . 'Open','','',$field->{'Open'},
		'1'		=>		'̸',
		'0'		=>		''
	)
);

print $table->td(
	'<input type="checkbox" name="' . $name . 'Hidden" value="1"' . (($field->{'Hidden'}) ? ' checked="checked"' : '')
	. ' onclick="cmonos.form.item(this.form).checkboxSync(this.checked,true,\'' . $name . 'tree\',false); cmonos.form.item(this.form).menuSync(this.checked,true,\'' . $name . 'cellWidth\',\'\');" />'
);

print $table->td(
	$this->mk_select_menu(
		$name . 'cellWidth','',' onchange="cmonos.form.item(this.form).checkboxSync(this.options[0].selected,false,\'' . $name . 'Hidden\',false)"',$field->{'cellWidth'},
		''			=>		'ɽ',
		'50'		=>		'50',
		'100'		=>		'100',
		'150'		=>		'150',
		'200'		=>		'200',
		'250'		=>		'250',
		'300'		=>		'300',
		'350'		=>		'350',
		'400'		=>		'400'
	)
);

if ($field->format_for_text_enabled || $field->{'class'} =~ /^xbb_/) {
	print $table->td('<input type="checkbox" name="' . $name . 'tree" value="1"' . (($field->{'tree'}) ? ' checked="checked"' : '') . ' onclick="cmonos.form.item(this.form).checkboxSync(this.checked,true,\'' . $name . 'Hidden\',false)" />');
} else {
	print $table->td('');
}

print $table->td('<input type="checkbox" name="' . $name . 'info" value="1"' . (($field->{'info'}) ? ' checked="checked"' : '') . ' />');
print $table->td('<input type="checkbox" name="' . $name . 'nametag" value="1"' . (($field->{'nametag'}) ? ' checked="checked"' : '') . ' />');

if ($field->search_form_enabled) {
	print $table->td('<input type="checkbox" name="' . $name . 'searchEnabled" value="1"' . (($field->{'searchEnabled'}) ? ' checked="checked"' : '') . ' />') ;
} else {
	print $table->td('');
}
if ($field->sort_enabled) {
	print $table->td('<input type="checkbox" name="' . $name . 'sortEnabled" value="1"' . (($field->{'sortEnabled'}) ? ' checked="checked"' : '') . ' />');
} else {
	print $table->td('');
}
}

######################################################################
#
sub print_sub_setting_items ($) {
my $this = shift;
return if !%field::obj;

print '<fieldset><legend>üե</legend><table class="field-table"><tbody>';

print '<tr><td class="field-name"><label for="data:for_title">ȥե</label></td>';
print '<td class="field"><select name="data:for_title" id="data:for_title">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->{'Open'} && !$field::obj{$field::ORDER{$_}}->{'Hidden'} && $field::obj{$field::ORDER{$_}}->sort_enabled && $field::obj{$field::ORDER{$_}}->{'class'} =~ /^text/;
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'title'} && $field::for{'title'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_content">ʸե</label></td>';
print '<td class="field"><select name="data:for_content" id="data:for_content">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->{'Open'} && !$field::obj{$field::ORDER{$_}}->{'Hidden'} && $field::obj{$field::ORDER{$_}}->{'class'} =~ /^text/;
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'content'} && $field::for{'content'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_name">Ƽ̾ե</label></td>';
print '<td class="field"><select name="data:for_name" id="data:for_name">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->{'class'} =~ /^text/ && $field::obj{$field::ORDER{$_}}->{'Open'} && !$field::obj{$field::ORDER{$_}}->{'Hidden'} && $field::obj{$field::ORDER{$_}}->sort_enabled;
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'name'} && $field::for{'name'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select><ol class="checkbox">';
print '<li><label><input type="checkbox" name="data:NAMECHECK" value="1"' . (($field::NAMECHECK) ? ' checked="checked"' : '') . ' />';
print ' ̾ʣåǡ١ϿϿѤߤ̾ȽʣƤʤå</label></li>';
print '<li><label><input type="checkbox" name="data:NAMEREGISTER" value="1"' . (($field::NAMEREGISTER) ? ' checked="checked"' : '') . ' />';
print ' ̾桼̾ǡ١Ͽ¾ CGI ѡ</label></li>';
print '</ol></td></tr>';

print '<tr><td class="field-name"><label for="data:for_mail">ɽ᡼ե</label></td>';
print '<td class="field"><select name="data:for_mail" id="data:for_mail">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->{'e-mail'} && $field::obj{$field::ORDER{$_}}->{'class'} =~ /email/;
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'mail'} && $field::for{'mail'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_media">ǥե</label></td>';
print '<td class="field"><select name="data:for_media" id="data:for_media">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && ($field::obj{$field::ORDER{$_}}->{'class'} eq 'file' || $field::obj{$field::ORDER{$_}}->{'class'} eq 'file_media' || $field::obj{$field::ORDER{$_}}->{'class'} eq 'file_shipainter');
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'media'} && $field::for{'media'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_sort">ȹܤΥǥե</label></td>';
print '<td class="field"><select name="data:for_sort" id="data:for_sort">';
print '<option value="thread_mtime"' . ((defined $field::for{'sort'} && $field::for{'sort'} eq 'thread_mtime') ? ' selected="selected"' : '') . '>åɹ</option>';
print '<option value="thread_ctime"' . ((defined $field::for{'sort'} && $field::for{'sort'} eq 'thread_ctime') ? ' selected="selected"' : '') . '>åɺ</option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->sort_enabled && $field::obj{$field::ORDER{$_}}->{'sortEnabled'} && $field::obj{$field::ORDER{$_}}->{'class'} ne 'xbb_threadxtime';
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'sort'} && $field::for{'sort'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';
print '<tr class="tbody-end"><td class="field-name"><label for="data:SORTORDER">ˡΥǥե</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	'data:SORTORDER','','',$field::SORTORDER,
	'ascend'		=>		'',
	'descend'		=>		'߽'
);
print '</td></tr>';
print '</tbody></table>';
print '</fieldset>';

print '<fieldset class="submit"><input type="submit" value="¸" class="save" /></fieldset>';
}

sub field_general_setting_check ($) {
my $this = shift;
$main::data{'NAMECHECK'} = '' if !defined $main::data{'NAMECHECK'} || !$main::data{'NAMECHECK'};
$main::data{'NAMEREGISTER'} = '' if !defined $main::data{'NAMEREGISTER'} || !$main::data{'NAMEREGISTER'};
return;
}

######################################################################
# ǡ١
sub delete_field ($@) {
my($this,@delete) = @_;
my($dir,$file,$delete_all);
local(*NO,*DIR);

#եɤ줿
$delete_all = 1 if keys %main::order == 0;

#ǡ١
opendir(DIR,$default::db);
foreach $file (readdir(DIR)) {
	next unless $file !~ /^\./ && -f "$default::db/$file";
	if ($delete_all || grep($file =~ /^$_(\.|_|$)/,@delete) > 0) {
		unlink "$default::db/$file";
	}
}
closedir(DIR);

#źեե
opendir(DIR,$default::file);
foreach $dir (readdir(DIR)) {
	next unless $dir !~ /^\./ && -d "$default::file/$dir";
	opendir(NO,"$default::file/$dir");
	foreach $file (readdir(NO)) {
		next unless $file !~ /^\./ && -f "$default::file/$dir/$file";
		if (grep($file =~ /^$_(\.|$)/,@delete) > 0) {
			unlink "$default::file/$dir/$file";
		}
	}
	closedir(NO);
}
closedir(DIR);
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
if (!$default::subdivided || ($default::subdivided && defined $main::c && $main::c ne '')) {

	#饹Ͽ
	Common::class_register('b100','InputField');

	#ġϿ
	$setting::jump_menu{'b100'} = 'ϥե' if !defined $setting::jump_menu{'b100'};
}
}

1;
