package Viewer;
require CMONOS::Baobab::BbCommon;
@ISA = qw(BbCommon);
use strict;
######################################################################
# ХХֵɽ⥸塼
# Viewer.pm ver1.1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-08-23
######################################################################
# ¹
sub run ($;$) {
my($this,$output) = @_;
my($v,%db,%match,%sort,$sort_db);

#ǥեɽ
$this->import_db($default::preference_dir . '/page',\%setting::page,1,'article') if !ref $setting::page{'article'};
if (!defined $main::v || $main::v eq '') {
	$main::v = $setting::page{'article'}{'defaultView'};
	eval 'ViewSelector::set_my_type($main::v,$main::n)';
	eval 'ThreadCategory::set_my_type($main::v,$main::k)';
	eval 'ThreadStatus::set_my_type($main::v,$main::k)';
	eval 'BbGrader::set_my_type($main::v,$main::k)';
}
if ($output) {
	$this->set_canonical($this->my_url . ((defined $main::c && $main::c ne '') ? '?c=' . $main::c : ''));
	$v = $setting::page{'article'}{'defaultView'};
} else {
	$v = $main::v;
	if (defined $main::n && $main::n ne '' && (!$default::subdivided || (defined $main::c && $main::c ne '')) && $v eq 'listarticle') {
		my $url;
		if ($default::subdivided && defined $main::c && $main::c ne '') {
			$url = $this->my_url . '?c=' . $main::c . '&n=' . $main::n . '&v=listarticle';
		} else {
			$url = $this->my_url . '?n=' . $main::n . '&v=listarticle';
		}
		$this->set_canonical($url);		
	}
}

#ڡ
if ($v eq 'listsearch') {
	$this->print_article_list($output,\%db,$this->view_object($v));
	return;
}

use Fcntl qw(:DEFAULT :flock);
eval 'use ' . $env::dbm_file . ';';
tie(%{$db{'thread_category'}}, $env::dbm_file, "$default::db/thread_category", O_RDONLY, $env::dbm_mode) if $field::for{'category'};
tie(%{$db{'thread_status'}}, $env::dbm_file, "$default::db/thread_status", O_RDONLY, $env::dbm_mode) if $field::for{'status'};
tie(%{$db{'tree'}}, $env::dbm_file, "$default::db/tree", O_RDONLY, $env::dbm_mode);


if ($output) {
	eval 'ViewSelector::set_my_type($v)';
	eval 'ThreadCategory::set_my_type($v)';
	eval 'ThreadStatus::set_my_type($v)';
	eval 'BbGrader::set_my_type($v)';
	$this->{'original_k'} = $main::k;
	$this->{'original_m'} = $main::m;
	$this->{'original_v'} = $main::v;
	$this->{'original_s'} = $main::s;
	$this->{'original_w'} = $main::w;
	$this->{'original_p'} = $main::p;
	$this->{'original_key'} = $setting::key;
	$main::k = 'viewer';
	$main::m = 'Viewer';
	$main::v = $v;
	undef $main::s;
	undef $main::w;
	undef $main::p;
	$setting::key = 'article';
}

#
$main::s = ($field::for{'sort'}) ? $field::for{'sort'} : 'thread_mtime' if !defined $main::s || $main::s eq '';
if ($main::s =~ /\D/) {
	$sort_db = $main::s;
} elsif (ref $field::obj{$main::s} && $field::obj{$main::s}->sort_enabled && $field::obj{$main::s}->{'sortEnabled'} && ($field::obj{$main::s}->{'Open'} || $this->is_secure('secret'))) {
	$sort_db = $field::obj{$main::s}->db;
	$sort_db = 'thread_mtime' if !defined $sort_db || !$sort_db;
} else {
	$sort_db = 'thread_mtime';
}
unless (ref tied %{$db{$sort_db}}) {
	tie(%{$db{$sort_db}}, $env::dbm_file, "$default::db/$sort_db", O_RDONLY, $env::dbm_mode);
}

if (!$output) {

#---------------------------------------------------------------------
#ǧԤܷٹ
	$this->set_pending_item_alert if !defined $main::s && $this->is_secure('tools');

#---------------------------------------------------------------------
#üեɽ
	$field::obj{$main::id}->update if defined $main::id && $main::id ne '' && defined $main::n && $main::n ne '' && ref $field::obj{$main::id} && $field::obj{$main::id}->update_enabled && $field::obj{$main::id}->is_secure_user_for_update;


#---------------------------------------------------------------------
#åȤꤷƤ
	if ($main::n || $main::t) {
		my($top,$is_secure);
		if (defined $main::n && $main::n ne '') {
			$top = $this->get_top($main::n,$db{'tree'}->{$main::n});
		} else {
			$top = $main::t;
		}

		#åɥƥ꡼å
		if ($field::for{'category'} && %{$thread::category{'ORDER'}}) {
			my $category = $db{'thread_category'}->{$top};
			$is_secure = 1 if !defined $category || !ref $thread::category{$category} || !$thread::category{$category}{'closed'} || $this->is_secure('closed');
		} else {
			$is_secure = 1;
		}

		if (defined $is_secure && $is_secure) {
			my(@list);
			if ($main::n && $v eq 'listarticle') {
				@list = ($main::n) ? ($main::n) : ();
				$this->set_page_title(\%db,$main::n);
				$this->print_article_list('',\%db,$this->view_object($v),\@list,$main::t,$main::n,$v);
				return;
			} elsif (defined $main::t && $main::t) {
				$v = 'listthread' if $v eq 'listarticle';
				$main::t = $top;
				@list = ($main::t) ? ($main::t) : ();	
				$this->set_page_title(\%db,$top);
				$this->print_article_list('',\%db,$this->view_object($v),\@list,$main::t,$main::n,$v);
				return;
			} elsif ($v eq 'list') {
				$main::t = $top;
			}
		}
	}


#---------------------------------------------------------------------
#
	my @q = (defined $main::q && $main::q ne '') ? grep($_ ne '',split(/\s+|\xa1\xa1/,$main::q)) : ();
	my @fields = keys %field::obj;
	foreach my $id (@fields) {
		if (ref $field::obj{$id} && ($field::obj{$id}->match_enabled || (@q && $field::obj{$id}->{'class'} =~ /^(?:text|num|addr_|select_(?!image)|ysc_)/)) && ($field::obj{$id}->{'Open'} || $this->is_secure('secret'))) {
			$this->{'is_searched'} = 1;
			last;
		}
	}
	if ($this->{'is_searched'}) {
		THREAD:
		while (my($no,$info) = each %{$db{'tree'}}) {
			my $top = $this->get_top($no,$info);

			#åɥƥ꡼å
			if ($field::for{'category'} && %{$thread::category{'ORDER'}}) {
				my $category = $db{'thread_category'}->{$top};
				next THREAD if defined $category && ref $thread::category{$category} && $thread::category{$category}{'closed'} && !$this->is_secure('closed');
				next THREAD if $main::tc && defined $category && ref $thread::category{$category} && $thread::category{$category}{'ORDER'} && $main::tc ne $category;
			}

			#åɾ֥å
			next THREAD if $field::for{'status'} && $main::st && $db{'thread_status'}->{$top} ne $main::st;

			my $matched = 0;
			my $q_matched = 0;
			my $text = '';

			SEARCH:
			foreach my $id (@fields) {
				next SEARCH if !$field::obj{$id}->match_enabled && (!@q || $field::obj{$id}->{'class'} !~ /^(?:text|num|addr_|select_(?!image)|ysc_)/);
				my($db,$thread_flag);
				$db = $field::obj{$id}->db;
				next SEARCH if !defined $db || !$db;

				#¹ԥե饰/åɴϢեɥե饰
				$thread_flag = 1 if $db =~ /^thread/;

				unless (ref tied %{$db{$db}}) {
					tie(%{$db{$db}}, $env::dbm_file, "$default::db/$db", O_RDONLY, $env::dbm_mode);
				}
				my $dat = ($thread_flag) ? $db{$db}->{$top} : $db{$db}->{$no};
				$dat = '' if !defined $dat;
				if ($field::obj{$id}->match_enabled) {
					$this->{'is_searched_full'} = 1;
					if ($field::obj{$id}->match(\$dat)) {
						$matched++;
					} elsif ($main::and) {
						$matched = $q_matched = 0;
						last SEARCH;
					}
				}
				if (@q && $field::obj{$id}->{'class'} =~ /^(?:text|num|addr_|select_(?!image)|ysc_)/) {
					$text .= (($text) ? "\x0A" : '') . $dat;
				}
			}
			if ($text) {
				my $euc = (length $text < 200) ? 1 : 0;
				foreach my $pat (@q) {
					if ($this->jmatch(\$text,$pat,'i',1,$euc)) {
						$q_matched++;
					} else {
						$q_matched = 0;
						last;
					}
				}
			}
			if ((!$this->{'is_searched_full'} || $matched) && (!@q || $q_matched)) {
				if ($v eq 'listarticle') {
					$match{$no} += $matched + $q_matched;
					$sort{$no} = $db{$sort_db}->{$no};
				} elsif ($top) {
					if ($no ne $top) {
						$match{$top} += $matched + $q_matched;
						delete $match{$no};
					}
					$sort{$top} = $db{$sort_db}->{$top};
				}
			}
		}
	}
}


#---------------------------------------------------------------------
#
if ($this->{'is_searched'}) {
	$this->push_window_title(($default::english) ? 'Search Results' : '');

#̵
} else {
	my $thread_flag = 1 if $sort_db =~ /^thread/;
	while (my($no,$info) = each %{$db{'tree'}}) {
		my($top);
		$top = $this->get_top($no,$info);
		next if $v ne 'listarticle' && $top ne $no;

		#åɥƥ꡼å
		if ($field::for{'category'} && %{$thread::category{'ORDER'}}) {
			my $category = $db{'thread_category'}->{$top};
			next if defined $category && ref $thread::category{$category} && $thread::category{$category}{'closed'} && !$this->is_secure('closed');
			next if $main::tc && defined $category && ref $thread::category{$category} && $thread::category{$category}{'ORDER'} && $main::tc ne $category;
		}

		#åɾ֥å
		next if $field::for{'status'} && $main::st && $db{'thread_status'}->{$top} ne $main::st;

		$sort{$no} = ($thread_flag) ? $db{$sort_db}->{$top} : $db{$sort_db}->{$no};
	}
}

#ɽĴ
if (!defined $main::w || $main::w eq '') {
	$main::w = ($field::SORTORDER) ? $field::SORTORDER : 'descend';
}

#ɽꥹ
my @list = sort {
	$this->sort_by(\$match{$b},\$match{$a}) || 
	$this->sort_by(\$sort{$a},\$sort{$b},$main::w) || 
	$this->sort_by(\$a,\$b,$main::w)
} keys %sort;

#---------------------------------------------------------------------
#񤭽Ф
$this->print_article_list($output,\%db,$this->view_object($v),\@list,$main::t,$main::n,$v);

if (defined $output && $output) {
	undef $cgi::output;
	undef $cgi::output_option;
	$this->use_icon('baobab','bb_icon');
	$this->use_deco();
	$setting::key = $this->{'original_key'};
	$main::k = $this->{'original_k'};
	$main::m = $this->{'original_m'};
	$main::v = $this->{'original_v'};
	$main::s = $this->{'original_s'};
	$main::w = $this->{'original_w'};
	$main::p = $this->{'original_p'};
	eval 'ViewSelector::set_my_type($main::v,$main::n)';
	eval 'ThreadCategory::set_my_type($main::v,$main::k)';
	eval 'ThreadStatus::set_my_type($main::v,$main::k)';
	eval 'BbGrader::set_my_type($main::v,$main::k)';
	delete $this->{'is_searched'};
	delete $this->{'original_k'};
	delete $this->{'original_m'};
	delete $this->{'original_v'};
	delete $this->{'original_s'};
	delete $this->{'original_w'};
	delete $this->{'original_key'};
}
}

sub set_page_title ($$$) {
my($this,$database,$n) = @_;
my($db,$title);
return if $field::for{'title'} eq '' || !ref $field::obj{$field::for{'title'}};
$db = $field::obj{$field::for{'title'}}->db;
unless (ref tied %{$database->{$db}}) {
	tie(%{$database->{$db}}, $env::dbm_file, "$default::db/$db", O_RDONLY, $env::dbm_mode);
}
$title = $database->{$db}->{$n};
$title = '' if !defined $title;
$title =~ s/<>([#0-9a-zA-z]{3,10})\Z//s if defined $field::obj{$field::for{'title'}}->{'color'} && $field::obj{$field::for{'title'}}->{'color'};
$this->push_window_title($title);
}

sub view_object ($$) {
my($this,$v) = @_;
my($this_view);
$v = $setting::page{'article'}{'defaultView'} if !defined $v || !$v;
if (defined $v && $v eq 'listtree') {
	require CMONOS::Baobab::BbTree;
	$this_view = BbTree->new;
} elsif (defined $v && $v eq 'listarticle') {
	require CMONOS::Baobab::BbArticle;
	$this_view = BbArticle->new;
} elsif (defined $v && $v eq 'listthread') {
	require CMONOS::Baobab::BbThread;
	$this_view = BbThread->new;
} elsif (defined $v && $v eq 'listsearch') {
	require CMONOS::Baobab::BbSearch;
	$this_view = BbSearch->new;
} else {
	require CMONOS::Baobab::BbList;
	$this_view = BbList->new;
}
return $this_view;
}

######################################################################
# ϤҤʷ
sub print_article_list ($;$$$$$) {
my($this,$output,$database,$this_view,$list,$t,$n,$v) = @_;
my($opened,$p);
local(*OUT);
if (defined $output && $output) {
	undef $n;
	undef $t;
	if (open(OUT, ">>$output")) {
		flock(OUT, LOCK_EX);
		truncate(OUT, 0);
		seek(OUT, 0, 0);
		$opened = 1;
		$cgi::output = $output;

	} else {
		push(@{$cgi::action->{'dialog'}},'եν񤭹ߤ˼Ԥޤ') if ref $cgi::action;
		return 0;
	}
} else {
	*OUT = *STDOUT;
	$main::p = $main::pnum - 1 if $main::pnum && !$this->is_nan($main::pnum);
	$p = ($main::p && !$this->is_nan($main::p) && $main::p > 0) ? $main::p : 0;
}
$this->use_icon('baobab','bb_icon',$output);
$this->use_deco($output);

#ڡåƥ
$this->set_css($this_view->css($list));

#إå
$this->print_page_header($setting::key,\*OUT,$output);

#
$this->print_tool_button(\*OUT,$output,'top',$n) if $setting::page{$setting::key}{'headIcon'};

#ɬפDBɤ߹
$this->tie_db($database,$this_view->required_field);

#ڡȽ
$p = $this_view->list_count($output,$database,$list,$p,$t,$n);

#إå
$this_view->print_list_header(\*OUT,$output,$p);

#ꥹ
$this_view->print_articles(\*OUT,$output,$database,$list,$p);

#եå
$this_view->print_list_footer(\*OUT,$output,$p);

#ƥե
$this_view->print_input_form(\*OUT,$output,$database,$t,$n,$v) if $setting::page{$setting::key}{'formEnabled'} && !$output;

#DB³
$this->untie_db($database);

#
$this->print_tool_button(\*OUT,$output,'bottom',$n) if $setting::page{$setting::key}{'footIcon'};

#
$this->print_return_button(\*OUT,$output,$list,$t,$n,$v);

#եå
$this->print_page_footer($setting::key,\*OUT,$output);

close(OUT) if $opened;
}

######################################################################
# ɽ
sub print_tool_button ($$;$$$) {
my($this,$handle,$output,$name,$n) = @_;
my($url,$viewform_flag,$query);
if (defined $setting::page{$setting::key}{'viewSwitch'} && $setting::page{$setting::key}{'viewSwitch'}) {
	my @form = grep($_ ne 'q',@setting::form1);
	@form = grep($_ ne 's' && $_ ne 'w',@form) if defined $setting::page{$setting::key}{'sortMenu'} && $setting::page{$setting::key}{'sortMenu'};
	if ($setting::page{$setting::key}{'sortMenu'} || $setting::page{$setting::key}{'searchbox'} || (!$output && $setting::general{'postMethod'})) {
		if (defined $output && $output) {
			print $handle $this->form_start(
				'key'	=>	'browse',
				'authorization'	=>	'disabled',
				'name'	=>	'view_' . $name
			);
			print $handle '<input type="hidden" name="c" value="' . $this->escape($main::c) . '" />' if defined $main::c && $main::c ne '';
		} else {
			unshift(@form,'n') if $main::v eq 'listarticle' && $n;
			print $handle $this->form_start(
				'key'	=>	'browse',
				'name'	=>	'view_' . $name,
				'required'	=>	\@form
			);
		}
		print $handle $this->add_query('post',{'m'=>'Viewer','k'=>'viewer'});
		$viewform_flag = 1;
		
	} else {
		$url = $cgi::path . '?m=Viewer&amp;k=viewer';
		if (!defined $output ||  !$output) {
			unshift(@form,'n') if $main::v eq 'listarticle' && $n;
			$url .= $this->amp_escape($this->set_query('url+',\@form));
		}
	}
	undef @form;
	print $handle '<ul class="tools panel" id="view-selector-' . $name . '">';
	if ($setting::page{$setting::key}{'searchbox'}) {
		print $handle '<li><input type="search" placeholder="' . (($this->{'is_searched_full'}) ? 'ʤ߸' : '') . '" results="5" autosave="' . (($default::id) ? $default::id : 'baobab') . '" name="q" size="16" value="' . $this->escape($main::q) . '" title="' . (($this->{'is_searched_full'}) ? 'ɤǤ˹ʤߤޤ' : '') . '" onkeypress="if((event.keyCode || event.charCode)==13){this.name=\'m=' . $main::m . '&amp;k=' . $main::k . '&amp;v=' . $main::v . '&amp;q=\'+this.value;submit();return false}" /></li>';
	}
	
	# ƥȥ˥塼
	if (defined $setting::page{$setting::key}{'sortMenu'} && $setting::page{$setting::key}{'sortMenu'}) {
		$this->print_sort_menu($handle);
	}
	
	# ɽڤؤܥ
	
	# ơ֥ɽ
	print $handle $this->view_switch_button('list','ơ֥ɽ',$url,{'v'=>'list'},'','','',(($main::v && $main::v eq 'list') ? 1 : 0));

	if ($this->tree_enabled) {
		# ĥ꡼ɽ
		print $handle $this->view_switch_button('listtree','ĥ꡼ɽ',$url,{'v'=>'listtree'},'','','',(($main::v && $main::v eq 'listtree') ? 1 : 0));
	
		# åɽ
		print $handle $this->view_switch_button('listthread','åɽ',$url,{'v'=>'listthread'},'','','',(($main::v && $main::v eq 'listthread') ? 1 : 0));
	}	

	# ɽ
	print $handle $this->view_switch_button('listarticle','ɽ',$url,{'v'=>'listarticle'},'','','',(($main::v && $main::v eq 'listarticle') ? 1 : 0));

	# ꥻå
	if ($this->{'is_searched'}) {
		print $handle $this->view_switch_button(
			'listreset',
			'ꥻå',
			$cgi::path . $this->set_query('url',[grep($_ ne 'q' && $_ ne 'search' && $_ ne 'and',@setting::form),'v']),
			'',
			'group-start',
		);
	}

	# 
	print $handle $this->view_switch_button('listsearch','',$url,{'v'=>'listsearch'},'group-start','','',(($main::v && $main::v eq 'listsearch') ? 1 : 0));
	
} else {
	print $handle '<ul class="tools" id="view-selector-' . $name . '">';
}

# 
if ((!$output || $setting::security{'inputthread'}{'passwordCheck'} eq 'nocheck') && $this->is_secure('inputthread')) {
	my(%query,$url);
	$url = $cgi::path . '?m=Editor&amp;k=editor';
	if (defined $output && $output) {
		$url .= '&amp;c=' . $main::c if defined $main::c && $main::c ne '';
		%query = ();
	} else {
		$url .= $this->amp_escape($this->set_query('url+',\@setting::form1));
		%query = ('v'=>$main::v);
	}
	print $handle $this->view_switch_button(
		'input',
		'',
		$url,
		\%query,
		'group-start',
		"cmonos.window.open('articleEditor',640,480)",
		'articleEditor',
	);
}

# ġ
if (!$output && $this->is_secure('tools')) {
	print $handle $this->view_switch_button('tool','Ķ򳫤',$cgi::path . '?m=Tools' . ((defined $main::c) ? '&amp;c=' . $main::c : ''),'','group-start');
}

# ѥ
if (defined $setting::page{$setting::key}{'pswdIcon'} && $setting::page{$setting::key}{'pswdIcon'}) {
	print $handle $this->view_switch_button(
		'toolpassword',
		'',
		$env::register_cgi . '?k=pswd&amp;m=Password',
		'',
		'group-start',
		"cmonos.window.open('LoginWindow',450,300)",
		'LoginWindow',
	);
}

print $handle '</ul>';
print $handle '</form>' if defined $viewform_flag && $viewform_flag;
}

sub print_sort_menu ($$$) {
my($this,$handle) = @_;
my $s = (defined $main::s && $main::s ne '') ? $main::s : ($field::for{'sort'}) ? $field::for{'sort'} : 'thread_mtime';
my $w = (defined $main::w && $main::w ne '') ? $main::w : ($field::SORTORDER) ? $field::SORTORDER : 'descend';
print $handle '<li class="group-end"><select name="s" title="(¤ؤ)">';
print $handle '<option value="thread_mtime"' . (($s eq 'thread_mtime' || (ref $field::obj{$s} && $field::obj{$s}->{'timetype'} && $field::obj{$s}->{'timetype'} eq 'thread_mtime')) ? ' selected="selected"' : '') . '>' . (($this->tree_enabled) ? 'å' : '') . '</option>';
print $handle '<option value="thread_ctime"' . (($s eq 'thread_ctime' || (ref $field::obj{$s} && $field::obj{$s}->{'timetype'} && $field::obj{$s}->{'timetype'} eq 'thread_ctime')) ? ' selected="selected"' : '') . '>' . (($this->tree_enabled) ? 'å' : '') . '</option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->sort_enabled && $field::obj{$field::ORDER{$_}}->{'sortEnabled'} && $field::obj{$field::ORDER{$_}}->{'class'} ne 'xbb_threadxtime';
	print $handle '<option value="' . $field::ORDER{$_} . '"' . (($s eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $field::obj{$field::ORDER{$_}}->name . '</option>';
}
print $handle '</select>';
print $handle '<select name="w" title="(¤ؤ)ˡ">';
print $handle '<option value="descend"' . (($w eq 'descend') ? ' selected="selected"' : '') . '>߽</option>';
print $handle '<option value="ascend"' . (($w eq 'ascend') ? ' selected="selected"' : '') . '></option>';
print $handle '</select></li>';
}

######################################################################
# ܥ
sub print_return_button ($$$$$$$) {
my($this,$handle,$output,$list,$t,$n,$v) = @_;
my($url);
$n = $list->[0] if !$n && @$list == 1;
if ($n && $v && $setting::page{'article'}{'defaultView'} && (@$list == 1 || $v ne $setting::page{'article'}{'defaultView'})) {
	$url = $cgi::path . '?m=Viewer&v=' . $setting::page{'article'}{'defaultView'} . (($default::subdivided && $main::c) ? '&c=' . $main::c : '') . (($setting::page{'article'}{'defaultView'} ne 'listarticle') ? '&n=' . $n : '');
} elsif (defined $default::subdivided && $default::subdivided) {
	$url = $cgi::path . (($default::subdivided && $main::c && $v ne $setting::page{'article'}{'defaultView'}) ? '?c=' . $main::c : '');
} elsif (defined $setting::page{'returnUrl'} && $setting::page{'returnUrl'}) {
	$url = $setting::page{'returnUrl'};
} else {
	return;
}
print $handle '<div id="return-to" class="panel">';
print $handle $cgi::Deco->set_output($output)->button(
	'return',
	$setting::page{'returnButton'},
	$url,
	(($default::english) ? 'Return' : '')
);
print $handle '</div>';
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);
if (!$default::subdivided || ($default::subdivided && defined $main::c && $main::c ne '')) {

	#Ƽ省
	$setting::security_key = 'browse' if !defined $setting::security_key || $setting::security_key eq '';	#ǥեȥƥ

	#ڡꥭ
	$setting::key = 'article' if !defined $setting::key || $setting::key eq '';

	#ǥեȥ
	$main::k = 'viewer' if !defined $main::k || !$main::k;

	#饹Ͽ
	Common::class_register('viewer','Viewer');

}
}

1;
