package BarGraph;
require CMONOS::CGI_Lib::Common;
@ISA = qw(Common);
use strict;
######################################################################
# ե⥸塼
# BarGraph.pm 1.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
#support@cmonos.jp
#http://cmonos.jp/
# 
# աCGI_Lib/Deco.pm ɬפǤ
######################################################################
#֥Ⱥ
sub new ($;$$$$$$) {
my($pkg,$setting,$bar_color,$bgcolor,$bar_image,$bg_image,$bar_width) = @_;
my $this = {};
$this->{'setting'} = (ref $setting eq 'HASH') ? $setting : \%setting::deco;
$this->{'barColor'} = (defined $bar_color && $bar_color ne '') ? $bar_color : '#6699FF';
$this->{'bgColor'} = (defined $bgcolor && $bgcolor ne '') ? $bgcolor : '#eeeeee';
$this->{'barImage'} = (defined $bar_image && $bar_image ne '') ? $bar_image : '';
$this->{'bgImage'} = (defined $bg_image && $bg_image ne '') ? $bg_image : '';
$this->{'barWidth'} = (defined $bar_width && $bar_width) ? $bar_width : 150;
bless $this;
return $this;
}

sub set ($@) {
my($this,@setting) = @_;

if (@setting == 1) {
	my $setting = $setting[0];
	@setting = ();
	while ($setting =~ /\s*(\w+)\s*=\s*"([^"]*)"/sg) {
		my($k,$v) = ($1,$2);
		$v =~ s/&lt;/</sg;
		$v =~ s/&gt;/>/sg;
		$v =~ s/&quot;/"/sg;
		$v =~ s/&#10;/\x0A/sg;
		$v =~ s/&amp;/\&/sg;
		push(@setting,$k,$v);
	}
}

my($k,$v,$key,$op,@images);
while (($k,$v) = splice(@setting,0,2)) {
	next if !defined $k || $k eq '';
	$this->{$k} = $v;
}
return $this;
}

######################################################################
#
sub bargraph ($$$$;$$$$$$$) {
my($this,$point,$total,$unit,$id,$bar_color,$bgcolor,$bar_image,$bg_image,$bar_width,$alt) = @_;
my($out,$image_dir,$bar,$bar_src,$bg,$bar_id,$bg_id,$bar_height,$bg_height,$padding,$ratio,$bar_size,$rawratio,$chargraph);
$bar = $bg = '';
$bar_color = $this->{'barColor'} if !defined $bar_color || $bar_color eq '';
$bgcolor = $this->{'bgColor'} if !defined $bgcolor || $bgcolor eq '';
$bar_width = $this->{'barWidth'} if !defined $bar_width || !$bar_width;
$point = 0 if !defined $point || !$point;
$total = 0 if !defined $total || !$total;
$unit = '' if !defined $unit || !$unit;
$bar_id = (defined $bar_image) ? $bar_image : $this->{'barImage'};
$bg_id = (defined $bg_image) ? $bg_image : $this->{'bgImage'};
if (
	($bar_image && defined $this->{'setting'}{'bargraph'}{$bar_image}{'name'} && $this->{'setting'}{'bargraph'}{$bar_image}{'name'} ne '') || ($this->{'barImage'} && defined $this->{'setting'}{'bargraph'}{$this->{'barImage'}}{'name'} && $this->{'setting'}{'bargraph'}{$this->{'barImage'}}{'name'} ne '') ||
	($bg_image && defined $this->{'setting'}{'bargraphbg'}{$bg_image}{'name'} && $this->{'setting'}{'bargraphbg'}{$bg_image}{'name'} ne '') || ($this->{'bgImage'} && defined $this->{'setting'}{'bargraphbg'}{$this->{'bgImage'}}{'name'} && $this->{'setting'}{'bargraphbg'}{$this->{'bgImage'}}{'name'} ne '')
) {
	$image_dir = (($cgi::output || $cgi::output_option) ? $this->base_change($env::image_dir,$cgi::output,$cgi::output_option) : $env::image_dir);
}
if (defined $bar_image && $bar_image ne '' && $this->{'setting'}{'bargraph'}{$bar_image}{'height'}) {
	$bar_id = $bar_image;
	$bar_height = $this->{'setting'}{'bargraph'}{$bar_image}{'height'};
	if ($image_dir) {
		$bar_src = $image_dir . '/bargraph/' . $this->{'setting'}{'bargraph'}{$bar_image}{'name'};
		$bar = ' background-image: url(&quot;' . $bar_src . '&quot;);';
	}
} elsif (defined $this->{'barImage'} && $this->{'barImage'} ne '' && $this->{'setting'}{'bargraph'}{$this->{'barImage'}}{'height'}) {
	$bar_id = $this->{'barImage'};
	$bar_height = $this->{'setting'}{'bargraph'}{$this->{'barImage'}}{'height'};
	if ($image_dir) {
		$bar_src = $image_dir . '/bargraph/' . $this->{'setting'}{'bargraph'}{$this->{'barImage'}}{'name'};
		$bar = ' background-image: url(&quot;' . $bar_src . '&quot;);';
	}
}
if (defined $bg_image && $bg_image ne '' && $this->{'setting'}{'bargraphbg'}{$bg_image}{'height'}) {
	$bg_id = $bg_image;
	$bg_height = $this->{'setting'}{'bargraphbg'}{$bg_image}{'height'};
	$bg = ' background-image: url(&quot;' . $image_dir . '/bargraphbg/' . $this->{'setting'}{'bargraphbg'}{$bg_image}{'name'} . '&quot;);' if $image_dir;
} elsif (defined $this->{'bgImage'} && $this->{'bgImage'} ne '' && $this->{'setting'}{'bargraphbg'}{$this->{'bgImage'}}{'height'}) {
	$bg_id = $this->{'bgImage'};
	$bg_height = $this->{'setting'}{'bargraphbg'}{$this->{'bgImage'}}{'height'};
	$bg = ' background-image: url(&quot;' . $image_dir . '/bargraphbg/' . $this->{'setting'}{'bargraphbg'}{$this->{'bgImage'}}{'name'} . '&quot;);' if $image_dir;
}
if (defined $bar_height && defined $bg_height && $bar_height < $bg_height) {
	my $p = int(($bg_height - $bar_height) / 2);
	$padding = $p . 'px 0 ' . ((($p * 2 + $bar_height) < $bg_height) ? $p + 1 : $p) . 'px 0 ';
} else {
	$padding = '0';
}
$bar_height = 10 if !$bar_height;
($bar_size,$ratio,$rawratio) = $this->get_bar_size($point,$total,$bar_width);
$chargraph = '*' x int(20 * $ratio);
if (!defined $alt || $alt eq '') {
	if ($unit eq '%') {
		$alt = (int(($rawratio * 10000) + 0.5) / 100) . '%';
	} else {
		$alt = $point . $unit;
	}
}

#
$out = '<div' . (($id) ? ' id="' . $id . '-bargraphbg"' : '') . ' class="bargraphbg-' . $bg_id . '" style="text-align: left; margin: 0; padding: ' . $padding . '; width:' . $bar_width . 'px; height:' . $bar_height . 'px; background-color: ' . $bgcolor . '; ' . $bg . '" title="' . $alt . '">';
$alt = $chargraph . ' (' . $alt . ')';
$out .= '<div' . (($id) ? ' id="' . $id . '-bargraph"' : '') . ' class="bargraph-' . $bar_id . '" style="margin: 0; padding: 0; width:' . $bar_size . 'px; height:' . $bar_height . 'px; background-color: ' . $bar_color . '; ' . $bar . '">';
if (defined $bar_src && $bar_src) {
	$out .= '<img class="barimage" src="' . $bar_src . '" width="' . $bar_size . '" height="' . $bar_height . '" border="0" style="display: none" alt="' . $alt . '" />';
} else {
	$out .= '<span class="barimage" style="display: none">' . $alt . '</span>';
}
$out .= '</div>';
$out .= '</div>';
return $out;
}

sub get_bar_size ($$$$) {
my($this,$point,$total,$bar_width) = @_;
my($bar_size,$ratio,$rawratio);
$rawratio = $ratio = ($total > 0) ? $point / $total : 0;
if ($ratio > 1) {
	$ratio = 1;
} elsif ($ratio < 0) {
	$ratio = 0;
}
$bar_size = int($bar_width * $ratio);
return (wantarray) ? ($bar_size,$ratio,$rawratio) : $bar_size;
}

######################################################################
#å
sub get_bargraph_setting_items ($;$$$) {
my($this,$type,$namae,$nowidth) = @_;
$namae = '' if !defined $namae;
$type = '' if !defined $type;

#å
$check::num{'barWidth' . $type} = $namae . '' if !defined $nowidth || !$nowidth;

#顼񼰥å
$check::color{'barColor' . $type} = $namae . 'ؿ';
$check::color{'bgColor' . $type} = $namae . 'طؿ';

return;
}

######################################################################
#å
sub is_valid_bargraph_setting ($;$$$$) {
my($this,$name,$type,$namae,$nowidth) = @_;
my $is_valid = 1;
$name .= '_' if defined $name && $name;
$type = '' if !defined $type;
$namae = '' if !defined $namae;
if (!$nowidth && defined $main::data{$name . 'barWidth' . $type} && $main::data{$name . 'barWidth' . $type} ne '' && $this->is_nan($main::data{$name . 'barWidth'} . $type)) {
	push(@{$cgi::action->{'dialog'}},$namae . '򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$name . 'barWidth' . $type};
	$is_valid = 0;
}
if (defined $main::data{$name . 'barColor' . $type} && $main::data{$name . 'barColor' . $type} ne '' && $this->is_invalid_color($main::data{$name . 'barColor' . $type})) {
	push(@{$cgi::action->{'dialog'}},$namae . 'ؿ򹹿ǤޤǤǧƤ') if ref $cgi::action;
	delete $main::data{$name . 'barColor' . $type};
	$is_valid = 0;
}
if (defined $main::data{$name . 'bgColor' . $type} && $main::data{$name . 'bgColor' . $type} ne '' && $this->is_invalid_color($main::data{$name . 'bgColor' . $type})) {
	push(@{$cgi::action->{'dialog'}},$namae . 'طؿ򹹿ǤޤǤǧƤ') if ref $cgi::action;
	delete $main::data{$name . 'bgColor' . $type};
	$is_valid = 0;
}
return $is_valid;
}

######################################################################
#
sub print_bargraph_setting_form ($$;$$$$) {
my($this,$name,$type,$namae,$nowidth_flag,$obj) = @_;
my($bar_width,$bar_image,$bg_image,$bar_color,$bgcolor,$max);
$name .= '_' if defined $name && $name;
$type = '' if !defined $type;
$namae = '' if !defined $namae;
unless (ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}

if (ref $obj) {
	$bar_width = ($nowidth_flag) ? ($obj->{'barWidth'}) ? $obj->{'barWidth'} : '' : ($obj->{'barWidth' . $type}) ? $obj->{'barWidth' . $type} : '';
	$bar_image = ($obj->{'barImage' . $type}) ? $obj->{'barImage' . $type} : '';
	$bg_image = ($obj->{'bgImage' . $type}) ? $obj->{'bgImage' . $type} : '';
	$bar_color = ($obj->{'barColor' . $type}) ? $obj->{'barColor' . $type} : '';
	$bgcolor = ($obj->{'bgColor' . $type}) ? $obj->{'bgColor' . $type} : '';
} else {
	$bar_width = ($nowidth_flag) ? ($main::data{$name . 'barWidth'}) ? $main::data{$name . 'barWidth'} : '' : ($main::data{$name . 'barWidth' . $type}) ? $main::data{$name . 'barWidth' . $type} : '';
	$bar_image = ($main::data{$name . 'barImage' . $type}) ? $main::data{$name . 'barImage' . $type} : '';
	$bg_image = ($main::data{$name . 'bgImage' . $type}) ? $main::data{$name . 'bgImage' . $type} : '';
	$bar_color = ($main::data{$name . 'barColor' . $type}) ? $main::data{$name . 'barColor' . $type} : '';
	$bgcolor = ($main::data{$name . 'bgColor' . $type}) ? $main::data{$name . 'bgColor' . $type} : '';
}
print '<fieldset>';
print '<legend>' . $namae . '</legend>';

if (!defined $nowidth_flag || !$nowidth_flag) {
	print '<fieldset>';
	print '<legend><label for="data:' . $name . 'barWidth' . $type . '"></label></legend>';
	print '<input type="text" name="data:' . $name . 'barWidth' . $type . '" id="data:' . $name . 'barWidth' . $type . '" value="' . $bar_width . '" size="4" maxlength="4" /> <span class="unit">ԥ</span>';
	print '</fieldset>';
}

print '<fieldset>';
print '<legend><label for="data:' . $name . 'barImage' . $type . '">ղ</label></legend>';

#ե˥塼
print $cgi::Deco->image_menu(
	'data:' . $name . 'barImage' . $type,
	'bargraph',
	100,
	$bar_image
);

print '<div class="additional-field"><label for="data:' . $name . 'barColor' . $type . '">ؿ</label>';
print '<input type="text" name="data:' . $name . 'barColor' . $type . '" id="data:' . $name . 'barColor' . $type . '" value="' . $bar_color . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:' . $name . 'barColor' . $type . '\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" style="background-color: ' . $bar_color . '" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:' . $name . 'barColor' . $type . '\')" ondblclick="cmonos.tool.colorPalette.open(\'data:' . $name . 'barColor' . $type . '\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:' . $name . 'barColor' . $type . '\')" ondblclick="cmonos.tool.colorSlider.open(\'data:' . $name . 'barColor' . $type . '\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</div>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label for="data:' . $name . 'bgImage' . $type . '">طʲ</label></legend>';

#ե˥塼
print $cgi::Deco->image_menu(
	'data:' . $name . 'bgImage' . $type,
	'bargraphbg',
	100,
	$bg_image
);

print '<div class="additional-field"><label for="data:' . $name . 'bgColor' . $type . '">طؿ</label>';
print '<input type="text" name="data:' . $name . 'bgColor' . $type . '" id="data:' . $name . 'bgColor' . $type . '" value="' . $bgcolor . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:' . $name . 'bgColor' . $type . '\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" style="background-color: ' . $bgcolor . '" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:' . $name . 'bgColor' . $type . '\')" ondblclick="cmonos.tool.colorPalette.open(\'data:' . $name . 'bgColor' . $type . '\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:' . $name . 'bgColor' . $type . '\')" ondblclick="cmonos.tool.colorSlider.open(\'data:' . $name . 'bgColor' . $type . '\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</div>';
print '</fieldset>';

print '<fieldset>';
print '<legend>ߤ</legend>';

$max = (ref $obj && $obj->{'max'}) ? $obj->{'max'} : 100;
print $this->bargraph(
	int(rand($max) + 0.5),
	$max,
	((ref $obj && $obj->{'unit'}) ? $obj->{'unit'} : '%'),
	'',
	$bar_color,
	$bgcolor,
	$bar_image,
	$bg_image,
	$bar_width
);

print '</fieldset>';
print '</fieldset>';
return
}

1;
