package Menu;
require CMONOS::CGI_Lib::Field::Select;
@ISA = qw(Select);
use strict;
######################################################################
# եɥ⥸塼ʥ˥塼
# Menu.pm 1.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
#support@cmonos.jp
#http://cmonos.jp/
# 
######################################################################
sub select_menu ($$;$$$) {
my($this,$name,$multiple,$value,$is_invalid) = @_;
my($form,@menu,@values);

#̾˥ǡID
$name = 'data' if !defined $name || !$name;
$name .= ':' . $this->{'id'} . ':str';

#+ǥե
@values = (@$value) ? $this->escape(@$value) : ();

#˥塼
@menu = ($this->{'default'}) ? $this->escape(split(/\x0A/,$this->{'default'})) : ();
$this->{'rows'} = @menu if !$this->{'rows'} || $this->{'rows'} > @menu;

if ($multiple && $this->{'rows'} && $this->{'rows'} < 4) {
	$this->{'rows'} = (@menu > 4) ? 4 : @menu;
} elsif (!$multiple || !$this->{'rows'}) {
	$this->{'rows'} = 1;
}
$form .= '<select size="' . $this->{'rows'} . '" name="' . $name . '" id="' . $name . '"';
$form .= ' multiple="multiple"' if $multiple;
$form .= $this->set_invalid_class if $is_invalid;
$form .= '>';
$form .= '<option value="">' . (($this->{'required'}) ? '򤷤Ƥ' : '') . '</option>' if !$multiple;
foreach my $k (@menu) {
	$form .= '<option value="' . $k . '"' . ((@values && grep($_ eq $k,@values)) ? ' selected="selected"' : '') . '>' . $k . '</option>';
}

$form .= ' ' . $this->{'unit'} if $this->{'unit'};
$form .= '</select>';
return $form;
}

sub is_one_to_one ($) {
my $this = shift;
return 1;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled) = @_;

#̾
my $name = 'data:' . $this->{'id'};

$this->print_field_info_form($name);

print '<fieldset>';
print '<legend></legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_rows">ɽԿ</label></td>';
print '<td class="field"><input type="text" name="' . $name . '_rows" id="' . $name . '_rows" value="' . $this->escape($this->{'rows'}) . '" size="3" /> <span class="unit"></span>';
print ' <label><input type="checkbox" name="' . $name . '_multiple" value="1"' . (($this->{'multiple'}) ? ' checked="checked"' : '') . ' /> ʣ</label></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_unit">ñ</label></td>';
print '<td class="field"><input type="text" name="' . $name . '_unit" id="' . $name . '_unit" value="' . $this->escape($this->{'unit'}) . '" size="8" title="ϤƤŬñ̤ꤷޤ" /></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_default"></label></td>';
print '<td class="field"><textarea name="' . $name . '_default" id="' . $name . '_default" cols="56" rows="8" wrap="off">' . $this->escape($this->{'default'}) . '</textarea><div class="hints">ܤȤ˲Ԥޤ</div></td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';
$this->_print_setting_form($name);

#ʸ
$this->print_font_setting_form($name) if !defined $html_disabled || !$html_disabled;

$this->print_setting_save_button;
return;
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('select_menu','Menu','˥塼');
}

1;
