package Num;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# ե⥸塼ʿ
# Num.pm 1.1.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-04-28
######################################################################
sub _set ($$) {
my($this,$setting) = @_;
$this->{'cols'} = '8' if !$this->{'cols'};
return;
}

######################################################################
#	(0)-8 obj->align;
sub align ($) {
my $this = shift;
return 'right';
}

######################################################################
#	(1) obj->match(str);
sub match_enabled ($) {
my $this = shift;
return 1 if !$this->is_nan($main::search{$this->{'id'}}{'f'}) || !$this->is_nan($main::search{$this->{'id'}}{'t'}) || (defined $main::search{$this->{'id'}}{'str'} && $main::search{$this->{'id'}}{'str'} ne '');
return 0;
}

sub match ($;$) {
my($this,$str) = @_;
my($p);
return 1 if !$this->match_enabled;
if (!defined $main::search{$this->{'id'}}{'str'} || $main::search{$this->{'id'}}{'str'} eq '') {
	if ((!defined $main::search{$this->{'id'}}{'f'} || $main::search{$this->{'id'}}{'f'} eq '' || (defined $$str && $$str ne '' && $main::search{$this->{'id'}}{'f'} <= $$str)) && 
		(!defined $main::search{$this->{'id'}}{'t'} || $main::search{$this->{'id'}}{'t'} eq '' || (defined $$str && $$str ne '' && $$str <= $main::search{$this->{'id'}}{'t'}))) {
		return 1;
	} else {
		return 0;
	}
} elsif (!ref $this->{'pattern'}) {
	@{$this->{'pattern'}} = split(/\s+/,$this->z_to_h($main::search{$this->{'id'}}{'str'}));
	push(@{$this->{'pattern'}},$main::search{$this->{'id'}}{'f'} . '~' . $main::search{$this->{'id'}}{'t'}) if (defined $main::search{$this->{'id'}}{'f'} && $main::search{$this->{'id'}}{'f'} ne '') || (defined $main::search{$this->{'id'}}{'t'} && $main::search{$this->{'id'}}{'t'} ne '');
}
$main::search{$this->{'id'}}{'mode'} = 'or' if !$main::search{$this->{'id'}}{'mode'};
foreach $p (@{$this->{'pattern'}}) {
	next if !defined $p ||  $p eq '';
	if ($p =~ /^(.*?)(~|)(.*)$/) {
		my($f,$t) = ($1,$3);
		if (($f eq '' || (defined $$str && $$str ne '' && $f <= $$str)) && ($t eq '' || (defined $$str && $$str ne '' && $$str <= $t))) {
			return 1 if !defined $main::search{$this->{'id'}}{'mode'} || $main::search{$this->{'id'}}{'mode'} ne 'and';
		} elsif (defined $main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'and') {
			return 0;
		}
	} elsif (!$this->is_nan($p) && defined $$str && $$str ne '' && $p == $$str) {
		return 1 if !defined $main::search{$this->{'id'}}{'mode'} || $main::search{$this->{'id'}}{'mode'} ne 'and';
	} elsif (defined $main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'and') {
		return 0;
	}
}
if (defined $main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'and') {
	return 1;
} else {
	return 0;
}
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status) = @_;

#եɥ͡+إå
my $form = $this->field_header($this->{'cols'},'data:' . $this->{'id'} . ':str');

#ǥեȺ
$main::data{$this->{'id'}}{'str'} = $this->{'default'} if (!defined $status || $status eq '') && (!defined $main::data{$this->{'id'}}{'str'} || $main::data{$this->{'id'}}{'str'} eq '');

#­
if (defined $main::data{$this->{'id'}}{'str'}) {
	$main::data{$this->{'id'}}{'str'} =~ s/\x0A//gs;
	$main::data{$this->{'id'}}{'str'} =~ s/,//gs;
}
$form .= '<input type="text" name="data:' . $this->{'id'} . ':str" id="data:' . $this->{'id'} . ':str" size="' . $this->{'cols'} . '"';
$form .= ' maxlength="' . $this->{'maxlength'} . '"' if $this->{'maxlength'};
$form .= ' value="' . $this->escape($main::data{$this->{'id'}}{'str'}) . '"' if defined $main::data{$this->{'id'}}{'str'} && $main::data{$this->{'id'}}{'str'} ne '';
$form .= $this->set_invalid_class if $this->{'is_invalid_field'}{'str'};
$form .= ' />';

#ñ̤ղ
$form .= ' <span class="unit">' . $this->{'unit'} . '</span>' if defined $this->{'unit'} && $this->{'unit'};

$form .= $this->field_footer;
return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my $this = shift;
my($is_valid);
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};

#ɬܹ/ʸå
$is_valid = 1;
$is_valid = 0 unless $this->is_not_empty('str') && $this->is_not_too_long('str');

#å
if ($main::data{$this->{'id'}}{'str'} ne '' && $this->is_nan($main::data{$this->{'id'}}{'str'})) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : '') . 'ǤϤޤȾѿˤƤ') if ref $cgi::action;
	$main::data{$this->{'id'}}{'str'} = '';
	$this->{'is_invalid_field'}{'str'} = 1;
	$is_valid = 0;
} elsif ($this->{'int'} && $main::data{$this->{'id'}}{'str'} && $main::data{$this->{'id'}}{'str'} =~ /\./) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : '') . 'ǧƤʲͼθޤ') if ref $cgi::action;
	$main::data{$this->{'id'}}{'str'} = int($main::data{$this->{'id'}}{'str'} + 0.5);
}

$cookie::data{'data:' . $this->{'id'} . ':str'} = $main::data{$this->{'id'}}{'str'} if $is_valid && $this->{'cookie'} && $main::set_cookie;
return $is_valid;
}

######################################################################
#	(4)-1 obj->usual_format(str);
sub usual_format {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return $this->field_tag($str) if !defined $str || $str eq '';
my $txt;
if ($this->{'numtype'}) {
	$txt = $this->kansuuji($this->{'numtype'},$str);
} elsif (defined $this->{'comma'} && $this->{'comma'}) {
	$str =~ s/(\.\d{4,})/{my $d = $1;$d =~ s\/(\d{3})\/$1,\/g;$d}/ge;
	$str =~ s/(\d{4,}(?=(\D|$)))/{my $d = $1;1 while $d =~ s\/(\d)(\d{3}(?=(\D|$)))\/$1,$2\/g;$d}/ge;
}
return $this->field_tag($this->style($this->data_tag('str',$str,$txt),$this->{'style'},$this->{'fontsize'},$this->{'fontcolor'},$this->{'fontface'}));
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled) = @_;

#̾
my $name = 'data:' . $this->{'id'};

$this->{'default'} =~ s/\x0A//sg if $this->{'default'};

$this->print_field_info_form($name);

print '<fieldset>';
print '<legend></legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_cols"></label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_cols" id="' . $name . '_cols" value="' . $this->escape($this->{'cols'}) . '" size="3" title="βꤷޤ" /> <span class="unit">ʸ(Ⱦ)</span></td>';
print '<td class="field-name"><label for="' . $name . '_maxlength">ʸ</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_maxlength" id="' . $name . '_maxlength" value="' . $this->escape($this->{'maxlength'}) . '" size="3" title="ʸ¤ޤ" /> <span class="unit">ʸ(Ⱦ)</span></td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_unit">ñ</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_unit" id="' . $name . '_unit" value="' . $this->escape($this->{'unit'}) . '" size="8" title="ϤƤŬñ̤ꤷޤ" /> <label><input type="checkbox" name="' . $name . '_int" value="1"' . ((defined $this->{'int'} && $this->{'int'}) ? ' checked="checked"' : '') . ' /> </label></td>';
print '<td class="field-name"><label for="' . $name . '_numtype">ɽ</label></td>';
print '<td class="q-field">';
print '<select name="' . $name . '_numtype" onchange="document.getElementById(\'comma\').style.display = (this.selectedIndex == 0) ? \'\' : \'none\';">';
print '<option value=""' . ((!$this->{'numtype'}) ? ' selected="selected"' : '') . '>(123)</option>';
print '<option value="k"' . ((defined $this->{'numtype'} && $this->{'numtype'} eq 'k') ? ' selected="selected"' : '') . '>()</option>';
print '<option value="kJ"' . ((defined $this->{'numtype'} && $this->{'numtype'} eq 'kJ') ? ' selected="selected"' : '') . '>(ɴ󽽻)</option>';
print '<option value="K"' . ((defined $this->{'numtype'} && $this->{'numtype'} eq 'K') ? ' selected="selected"' : '') . '>(ɴ)</option>';
print '</select>';
print ' <label id="comma"><input type="checkbox" name="' . $name . '_comma" id="' . $name . '_comma" value="1"' . ((defined $this->{'comma'} && $this->{'comma'}) ? ' checked="checked"' : '') . ' />头Ȥ˰̼ꤹ</label>';
print $this->javascript('document.getElementById(\'comma\').style.display = \'none\';') if $this->{'numtype'};
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_default">ǥե</label></td>';
print '<td class="field" colspan="3"><input type="text" name="' . $name . '_default" id="' . $name . '_default" value="' . $this->escape($this->{'default'}) . '" size="' . (($this->{'cols'}) ? $this->{'cols'} : '8') . '" title="ΥǥեȤͤꤷޤ" />' . (($this->{'unit'}) ? ' <span class="unit">' . $this->{'unit'} . '</span>' : '') . '</td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

if (!defined $html_disabled || !$html_disabled) {

	#ץ
	$this->print_search_option_settings($name);

	#ʸ
	$this->print_font_setting_form($name);
}
$this->print_setting_save_button;
return;
}

sub print_search_option_settings ($$) {
my($this,$name) = @_;
if (!$default::static) {
	print '<fieldset>';
	print '<legend><label for="' . $name . '_searchOption"></label></legend>';
	print $this->mk_select_menu(
		$name . '_searchOption','','',$this->{'searchOption'},
		''			=>		'ϰϤ',
		'text'		=>		'ϰϤ+ƥȥꥢʣϰϤ',
		'selectSpan'	=>		'ϰϥ˥塼',
		'selectMin'		=>		'¥˥塼',
		'selectMax'		=>		'¥˥塼',
	);
	print '<fieldset>';
	print '<legend><label for="' . $name . '_searchMenu">ͥ˥塼</label></legend>';
	print '<textarea name="' . $name . '_searchMenu" id="' . $name . '_searchMenu" rows="8" cols="16">' . $this->escape($this->{'searchMenu'}) . '</textarea>';
	print '<div class="note">ͤȤ˲</div>';
	print '</fieldset>';
	print '</fieldset>';
}
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my $is_valid = $this->_is_valid_settings;
$is_valid = 0 if !$this->is_valid_font_setting;

#ν
$main::data{$this->{'id'} . '_default'} =~ s/[\x0A\x0D]//sg;
$this->detag(\$main::data{$this->{'id'} . '_default'}) if defined $main::data{$this->{'id'} . '_default'} && $main::data{$this->{'id'} . '_default'};
if ($main::data{$this->{'id'} . '_default'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_default'})) {
	push(@{$cgi::action->{'dialog'}},'ǥեǧƤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_default'};
	$is_valid = 0;
} elsif ($main::data{$this->{'id'} . '_int'} && $main::data{$this->{'id'} . '_default'} && $main::data{$this->{'id'} . '_default'} =~ /\./) {
	push(@{$cgi::action->{'dialog'}},'ǥեǧƤʲͼθޤ') if ref $cgi::action;
	$main::data{$this->{'id'} . '_default'} = int($main::data{$this->{'id'} . '_default'} + 0.5);
}
return $is_valid;
}

sub _is_valid_settings ($) {
my $this = shift;
$this->tag_fix(\$main::data{$this->{'id'} . '_unit'},2) if defined $main::data{$this->{'id'} . '_unit'} && $main::data{$this->{'id'} . '_unit'};
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
$main::data{$this->{'id'} . '_int'} = 0 if !$main::data{$this->{'id'} . '_int'};
$main::data{$this->{'id'} . '_searchOption'} = 0 if !$main::data{$this->{'id'} . '_searchOption'};
$main::data{$this->{'id'} . '_comma'} = 0 if !$main::data{$this->{'id'} . '_comma'};
if ($main::data{$this->{'id'} . '_searchMenu'}) {
	$main::data{$this->{'id'} . '_searchMenu'} = join("\x0A",sort {$a <=> $b} grep(!$this->is_nan($_) && $_ ne '',split(/[\r\n]+/,$main::data{$this->{'id'} . '_searchMenu'})));
}
return 1;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
my $this = shift;
my $form = '<tr><td class="field-name">';
if (defined $this->{'searchOption'} && $this->{'searchOption'}) {
	$form .= '<label for="search:' . $this->{'id'} . ':str">' . $this->{'name'} . '</label>';
} else {
	$form .= '<span class="datatitle">' . $this->{'name'} . '</span>';
}
$form .= '</td><td class="field">';
if ($this->{'searchOption'} && $this->{'searchOption'} =~ /select/ && defined $this->{'searchMenu'} && $this->{'searchMenu'} ne '') {
	#my @menu = sort {$a <=> $b} grep(!$this->is_nan($_) && $_ ne '',split(/[\r\n]+/,$this->{'searchMenu'}));
	my @menu = split(/[\r\n]+/,$this->{'searchMenu'});
	$form .= '<select name="search:' . $this->{'id'} . ':str" id="search:' . $this->{'id'} . ':str">';
	$form .= '<option value=""></option>';
	my $unit = $this->detag($this->{'unit'});
	if ($this->{'searchOption'} eq 'selectMax') {
		foreach my $num (@menu) {
			my $v = '~' . $num;
			$form .= '<option value="' . $v . '"' . (($main::search{$this->{'id'}}{'str'} && $main::search{$this->{'id'}}{'str'} eq $v) ? ' selected="selected"' : '') . '>';
			if ($default::english) {
				$form .= 'less than ' . $num . $unit;
			} else {
				$form .= $num . $unit . 'ʲ';
			}
			$form .= '</option>';
		}
	} elsif ($this->{'searchOption'} eq 'selectMin') {
		foreach my $num (@menu) {
			my $v = $num . '~';
			$form .= '<option value="' . $v . '"' . (($main::search{$this->{'id'}}{'str'} && $main::search{$this->{'id'}}{'str'} eq $v) ? ' selected="selected"' : '') . '>';
			if ($default::english) {
				$form .= 'more than ' . $num . $unit;
			} else {
				$form .= $num . $unit . 'ʾ';
			}
			$form .= '</option>';
		}
	} else {
		my $prev = '';
		foreach my $num (@menu) {
			my $v = $prev . '~' . $num;
			$form .= '<option value="' . $v . '"' . (($main::search{$this->{'id'}}{'str'} && $main::search{$this->{'id'}}{'str'} eq $v) ? ' selected="selected"' : '') . '>';
			$form .= (($prev ne '') ? $prev . $unit : '') . (($default::english) ? ' - ' : '') . $num . $unit;
			$form .= '</option>';
			$prev = $num;
		}
		$form .= '<option value="' . $prev . '~"' . (($main::search{$this->{'id'}}{'str'} && $main::search{$this->{'id'}}{'str'} eq $prev . '~') ? ' selected="selected"' : '') . '>';
		$form .= $prev . $unit . (($default::english) ? ' - ' : '');
		$form .= '</option>';
	}
	$form .= '</select>';
} else {
	$form .= '<div class="sub-field">';
	$form .= '<label>' . (($default::english) ? '<span class="unit">From</span> ' : '') . '<input type="text" size="' . $this->{'cols'} . '" name="search:' . $this->{'id'} . ':f" value="' . $this->escape($main::search{$this->{'id'}}{'f'}) . '" /><span class="unit">' . ((defined $this->{'unit'}) ? $this->{'unit'} : '')  . (($default::english) ? '' : ' ʾ') . '</span></label> ' . (($this->{'cols'} > 20) ? '</div><div class="sub-field">' : '');
	$form .= '<label>' . (($default::english) ? '<span class="unit">To</span> ' : '') . '<input type="text" size="' . $this->{'cols'} . '" name="search:' . $this->{'id'} . ':t" value="' . $this->escape($main::search{$this->{'id'}}{'t'}) . '" /><span class="unit">' . ((defined $this->{'unit'}) ? $this->{'unit'} : '') . (($default::english) ? '' : ' ʲ') . '</span></label>';
	$form .= '</div>';
	if (defined $this->{'searchOption'} && $this->{'searchOption'} && $this->{'searchOption'} !~ /select/) {
		$form .= '<div class="sub-field"><input type="text" size="30" name="search:' . $this->{'id'} . ':str" value="' . $this->escape($main::search{$this->{'id'}}{'str'}) . '" /> ';
		$form .= $this->mk_select_menu(
			'search:' . $this->{'id'} . ':mode','','',$main::search{$this->{'id'}}{'mode'},
			'and'		=>		(($default::english) ? 'Matches on all numbers' : 'Ƥξ˰'),
			'or'		=>		(($default::english) ? 'Matches on any number' : '줫ξ˰')
		);
		$form .= ($default::english) ? '</div><div class="example">ex) form -6 to 10 -&gt; -6~10</div>' : '</div><div class="hints">"~"ȤϰϤǤޤ0ʾ 5ʲ  0~5ˡ</div>';
	}
}
$form .= $this->additional_search_form;
$form .= '</td></tr>';
return $form;
}

sub additional_search_form ($) {
my $this = shift;
return '';
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('num','Num','');
}

1;
