package ShoppingCartBase;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# ե⥸塼ʥåԥ󥰥ȴܥ⥸塼
# ShoppingCartBase.pm 1.0.5
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-06-06
######################################################################
#	(0)-3 եDB
sub db ($) {
my $this = shift;
return 'showcase';
}

# --------------------------------------------------------------------
sub _set ($$) {
my($this,$setting) = @_;
unless (ref $cgi::Image) {
	require CMONOS::CGI_Lib::Image;
	$cgi::Image = Image->new;
}
unless (ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
$this->{'namefield'} = $this->{'field_for'}->{'title'} || $this->{'field_for'}->{'name'} if !$this->{'namefield'};
$this->{'keyfield'} = $this->{'field_for'}->{'key'} || $this->{'field_for'}->{'title'} if !$this->{'keyfield'};
$this->{'monetaryunit'} = '' if !$this->{'monetaryunit'};
#$this->{'pointunit'} = 'point' if !$this->{'pointunit'};
if (defined $this->{'stockmenu'} && $this->{'stockmenu'} ne '') {
	my $id = 0;
	while ($this->{'stockmenu'} =~ /^(.*)$/mg) {
		my $name = $1;
		next if $name !~ /\S/;
		$this->{'orderstop'}[$id] = 1 if $name =~ s/^\*//;
		$this->{'stockAvailability'}[$id] = $name;
		$id++;
	}
	$this->{'stockview'} = 'menu' if $default::static && $id;
	$this->{'stockview'} = 'menu' if !$this->{'stockview'};
} elsif (!defined $this->{'stockview'} || $this->{'stockview'} eq '') {
	$this->{'stockview'} = '' if !$this->{'stockview'};
	$this->{'stockhidden'} = 1;
}
$this->{'field_for'}->{'showcase'} = $this->{'id'} if !$this->{'field_for'}->{'showcase'};
#ҥեɤ $this->{'field_obj'}->{$this->{'field_for'}->{'showcase'}}->{'***'}

#ե륢åץ
if ($this->{'digitalContentUploadEnabled'} || $this->{'digitalContentMenuEnabled'}) {
	undef %{$this->{'ext_type'}};
	undef %{$this->{'type_ext'}};
	undef %{$this->{'mimename'}};
	delete $this->{'ext_type'};
	delete $this->{'type_ext'};
	delete $this->{'mimename'};
	if (ref $setting && defined $setting->{'mimetype'} && $setting->{'mimetype'} ne '') {
		my @mime = split(/\x0A|,\s*/,$setting->{'mimetype'});
		foreach my $type (@mime) {
			next if !defined $type || $type eq '';
			if ($type =~ /^([^:]+):([^:]+)[:]{0,1}([^:]*)$/) {
				$this->{'ext_type'}{$2} = $1;
				$this->{'type_ext'}{$1} = $2;
				$this->{'mimename'}{$2} = ($3 ne '') ? $3 : $2;
			}
		}
	}
	$cgi::enctype_multipart = 1 if $this->{'digitalContentUploadEnabled'};
}
$this->{'elements'} = 1;
return;
}

sub showcase_object_enabled ($) {
my $this = shift;
if (ref $this->{'showcase'}) {
	return 1;
} elsif ($this->{'field_for'}->{'showcase'} && ref $this->{'field_obj'}->{$this->{'field_for'}->{'showcase'}}) {
	$this->{'showcase'} = $this->{'field_obj'}->{$this->{'field_for'}->{'showcase'}};
	return 1;
} else {
	return 0;
}
}

# --------------------------------------------------------------------
#	(0)-5 ǡǤμ
sub elements ($$) {
my($this,$str) = @_;
my(%data);
$data{'price'} = $data{'condition'} = $data{'availability'} = $data{'stock'} = $data{'multiple'} = $data{'option'} = '';
if ($str) {
	$data{'price'} = $1 if $str =~ s/^(\d*)\x0A//;
	while ($str =~ /^(\w+)\:(.*)$/gm) {
		$data{$1} = $2;
		$data{$1} =~ s/&#10;/\x0A/sg;
	}
}
return %data;
}

# --------------------------------------------------------------------
#ǥ륳ƥĥǥ쥯ȥ
sub get_digital_content_directory_ftp_url ($) {
my $this = shift;
return (($this->{'ftpurl'} =~ m!://!) ? '' : 'ftp://') . $this->{'ftpurl'} . $this->ftp_url_fix if $this->{'ftpurl'};
my $digital_content_directory = $this->path_conv($this->get_digital_content_directory_path,'path');
my $uid = (stat($this->path_conv($ENV{'SCRIPT_NAME'},'path')))[4];
my $ftp_path = '';
while ($digital_content_directory =~ s!(/[^/]+)$!!) {
	if ($digital_content_directory) {
		my $duid = (stat($digital_content_directory))[4];
		if (!$duid || $duid ne $uid) {
			$ftp_path = $1 . $ftp_path if !$ftp_path;
			last;
		}
	}
	$ftp_path = $1 . $ftp_path;
}
return 'ftp://' . $this->to_host($ENV{'SERVER_NAME'}) . $ftp_path;
}

sub ftp_url_fix ($) {
my $this = shift;
return '';
}

sub get_digital_content_directory_path ($) {
my $this = shift;
return (($default::home) ? ($default::file) ? $default::file : $default::home : (defined $main::c && $main::c ne '' && !$default::subdivided) ? $default::db . '/' . $main::c : $default::db) . '/digital-content';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
#return 0 if $this->{'pricehidden'} && $this->{'pointhidden'} && $this->{'stockhidden'};
return 0 if $this->{'pricehidden'} && $this->{'stockhidden'};
return 1 if !$this->is_nan($main::search{$this->{'id'}}{'f'}) || !$this->is_nan($main::search{$this->{'id'}}{'t'}) || !$this->is_nan($main::search{$this->{'id'}}{'pf'}) || !$this->is_nan($main::search{$this->{'id'}}{'pt'}) || (defined $main::search{$this->{'id'}}{'stock'} && ($main::search{$this->{'id'}}{'stock'} ne '' || @{$main::search{$this->{'id'}}{'stock'}}));
return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
return (
	($this->{'pricehidden'} || $this->price_is_matched($this,$str))
	#&& ($this->{'pointhidden'} || $this->point_is_matched($this,$str))
	&& ($this->{'stockhidden'} || $this->stock_is_matched($this,$str))
) ? 1 : 0;
}

sub price_is_matched ($$;$) {
my($this,$obj,$str) = @_;
return 1 if $this->is_nan($main::search{$obj->{'id'}}{'f'}) && $this->is_nan($main::search{$obj->{'id'}}{'t'});
$obj->{'price_search_from'} = (!defined $main::search{$obj->{'id'}}{'f'} || $main::search{$obj->{'id'}}{'f'} eq '') ? '' : $this->add_tax($main::search{$obj->{'id'}}{'f'}) if !defined $obj->{'price_search_from'};
$obj->{'price_search_to'} = (!defined $main::search{$obj->{'id'}}{'t'} || $main::search{$obj->{'id'}}{'t'} eq '') ? '' : $this->add_tax($main::search{$obj->{'id'}}{'t'}) if !defined $obj->{'price_search_to'};
my %data = $this->elements($$str);
if (($obj->{'price_search_from'} eq '' || $obj->{'price_search_from'} <= $data{'price'}) && 
	($obj->{'price_search_to'} eq '' || $obj->{'price_search_to'} >= $data{'price'})) {
#if (($obj->{'price_search_from'} eq '' || $obj->{'price_search_from'} <= $$str) && 
#	($obj->{'price_search_to'} eq '' || $obj->{'price_search_to'} >= $$str)) {
	return 1;
} else {
	return 0;
}
}

#sub point_is_matched ($$;$) {
#my($this,$obj,$str) = @_;
#return 1 if $this->is_nan($main::search{$obj->{'id'}}{'pf'}) && $this->is_nan($main::search{$obj->{'id'}}{'pt'});
#my %data = $this->elements($$str);
#if ((!defined $main::search{$obj->{'id'}}{'pf'} || $main::search{$obj->{'id'}}{'pf'} eq '' || $main::search{$obj->{'id'}}{'pf'} <= $data{'point'}) && 
#	(!defined $main::search{$obj->{'id'}}{'pt'} || $main::search{$obj->{'id'}}{'pt'} eq '' || $main::search{$obj->{'id'}}{'pt'} >= $data{'point'})) {
#	return 1;
#} else {
#	return 0;
#}
#}

sub stock_is_matched ($$;$) {
my($this,$obj,$str) = @_;
return 1 if !defined $main::search{$obj->{'id'}}{'stock'} || $main::search{$obj->{'id'}}{'stock'} eq '';
$this->scalar_to_array(\$main::search{$obj->{'id'}}{'stock'});
my %data = $this->elements($$str);
if ($this->{'stockview'} eq 'sync') {
	return 1 if defined $default::static && $default::static;
	my $availability;
	foreach $availability (@{$main::search{$obj->{'id'}}{'stock'}}) {
		if (
			($availability eq 'abundant' && defined $this->{'inStockBounds'} && $data{'stock'} > $this->{'inStockBounds'}) ||
			($availability eq 'in_stock' && defined $this->{'inStockBounds'} && defined $this->{'limitedAvailabilityBounds'} && $data{'stock'} <= $this->{'inStockBounds'} && $data{'stock'} > $this->{'limitedAvailabilityBounds'}) ||
			($availability eq 'limited' && defined $this->{'limitedAvailabilityBounds'} && defined $this->{'outOfStockBounds'} && $data{'stock'} <= $this->{'limitedAvailabilityBounds'} && $data{'stock'} > $this->{'outOfStockBounds'}) ||
			($availability eq 'out_of_stock' && defined $this->{'outOfStockBounds'} && $data{'stock'} <= $this->{'outOfStockBounds'})
		) {
			return 1;
		}
	}
	return 0;
} elsif ($this->{'stockview'} eq 'menu') {
	return (grep($_ eq $data{'availability'},@{$main::search{$obj->{'id'}}{'stock'}})) ? 1 : 0;
}
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status,$original,$path) = @_;
my($form);

#եɥ͡+إå
$form = $this->field_header;

#ǥեȤκ
if ((!defined $status || $status eq '') && (!defined $main::data{$this->{'id'}}{'price'} || $main::data{$this->{'id'}}{'price'} eq '')) {
	$main::data{$this->{'id'}}{'price'} = $this->{'defaultprice'};
	$main::data{$this->{'id'}}{'stock'} = $this->{'defaultstock'};
	$main::data{$this->{'id'}}{'weight'} = $this->{'defaultweight'};
	$main::data{$this->{'id'}}{'condition'} = $this->{'defaultcondition'};
	$main::data{$this->{'id'}}{'availability'} = $this->{'defaultavailability'};
	$main::data{$this->{'id'}}{'option'} = $this->{'defaultoption'};
}

#ϥեɽ
$form .= $this->input_form('data:' . $this->{'id'} . ':','',$main::data{$this->{'id'}},1,1,$this->{'id'},$path);
$form .= $this->field_footer;
return $form;
}

sub input_form ($$$$;$$$) {
my($this,$name,$type,$data,$option,$invalid_check,$id,$path) = @_;
my($form,$form_id,$pricelimit);
$type = '' if !defined $type;
$pricelimit = (defined $this->{'pricelimit'} && $this->{'pricelimit'}) ? ',' . $this->{'pricelimit'} : '';
#$pricelimit .= (($pricelimit) ? '' : ",''") . ',' . $this->{'pointlimit'} if defined $this->{'pointlimit'} && $this->{'pointlimit'};
$form_id = ($id) ? $id : $this->{'id'};
$form .= '<table class="sub-field-table">';
if ($invalid_check && $this->{'digitalContentMenuEnabled'}) {
	my $digital_content_directory = $this->get_digital_content_directory_path;
	my $ftp_url = $this->get_digital_content_directory_ftp_url;
	$form .= '<tbody>';
	$form .= '<tr><td class="sub-field-name"><span class="datatitle" title="ǥ륳ƥĤΥåץե">FTP</span></td><td class="sub-field"><a href="' . $ftp_url . '">' . $ftp_url . '</a></td></tr>' if $this->is_secure('tools');
	$form .= (!$this->{'digitalContentUploadEnabled'}) ? '<tr>' : '<tr class="tbody-end">';
	$form .= '<td class="sub-field-name"><label for="' . $name . 'selectedDigitalContent" title="ǥ륳ƥĥ˥塼">˥塼</label></td><td class="sub-field">';
	local(*DIR);
	if ($this->set_dir($digital_content_directory) && opendir(DIR, $digital_content_directory)) {
		$this->write_file(
			$digital_content_directory . '/.htaccess',
			'Satisfy all' . "\x0A"
				. 'order deny,allow' . "\x0A"
				. 'deny from all' . "\x0A",
			1
		);
		my %digital_content = ();
		my $digital_content = $data->{$type . 'selectedDigitalContent'} || '';
		my $is_menu = 0;
		if ($data->{$type . 'foldertype'} && $data->{$type . 'foldertype'} eq '1' && -f $digital_content_directory . '/' . $data->{$type . 'digitalcontent'}) {
			$digital_content = $data->{$type . 'digitalcontent'};
			$is_menu = 1;
		}
		my $count = 0;
		my $done = 0;
		my @files = grep($_ !~ /^\./ && $_ =~ /\.\w+$/ && -f "$digital_content_directory/$_",readdir(DIR));
		closedir(DIR);
		foreach my $f (@files) {
			$digital_content{$f} = (stat("$digital_content_directory/$f"))[9] if !ref $this->{'ext_type'} || ($f =~ /\.(\w+)$/ && $this->{'ext_type'}{$1});
		}
		if (%digital_content) {
			$form .= '<select name="' . $name . 'selectedDigitalContent" id="' . $name . 'selectedDigitalContent"' . (($this->{'is_invalid_field'}{'selectedDigitalContent'}) ? $this->set_invalid_class : '') . '>';
			$form .= '<option value=""></option>';
			foreach my $f (sort {$digital_content{$b} <=> $digital_content{$a}} keys %digital_content) {
				$form .= '<option value="' . $this->escape($f) . '"' . (($f eq $digital_content && !$done++) ? ' selected="selected"' : '') . '>' . $this->escape($f) . '</option>';
				last if $this->{'maxitem'} && ++$count >= $this->{'maxitem'};
			}
			$form .= '<option value="' . $this->escape($digital_content) . '" selected="selected">' . $this->escape($digital_content) . '</option>' if $digital_content && !$done;
			$form .= '</select>';
			if ($is_menu) {
				$form .= '<input type="hidden" name="' . $name . 'foldertype" value="' . $this->escape($data->{$type . 'foldertype'}) . '" />';
				$form .= '<input type="hidden" name="' . $name . 'digitalcontent" value="' . $this->escape($data->{$type . 'digitalcontent'}) . '" />';
			} elsif ($data->{$type . 'foldertype'} && $data->{$type . 'foldertype'} eq '1') {
				delete $data->{$type . 'foldertype'};
				delete $data->{$type . 'digitalcontent'};
			}
		} else {
			$form .= 'ǥ륳ƥĤߤĤޤ';
		}
	} else {
		$form .= 'ǥ륳ƥĥե򳫤ޤǤ';
	}
	$form .= '</td></tr>';
	$form .= '</tbody>' if !$this->{'digitalContentUploadEnabled'};
}
if ($invalid_check && $this->{'digitalContentUploadEnabled'}) {
	$form .= '<tbody>' if !$this->{'digitalContentMenuEnabled'};
	$form .= '<tr class="tbody-end">';
	$form .= '<td class="sub-field-name"><label for="' . $name . 'file">ե</label></td><td class="sub-field">';
	$form .= '<input type="file" name="' . $name . 'file" id="' . $name . 'file"' . (($this->{'is_invalid_field'}{'file'}) ? $this->set_invalid_class : '') . ' />';
	if ($data->{$type . 'foldertype'} && $data->{$type . 'foldertype'} eq '2' && $data->{$type . 'digitalcontent'} && -f ((!$cgi::input->{'clipboard_expired'} && $this->{'is_posted_file'}) ? $cgi::input->get_public_clipboard : ($path) ? $path : $this->get_file_directory) . '/' . $id . '.' . $data->{$type . 'digitalcontent'} . '.dat') {
		$form .= $this->digital_content_icon($main::data{$this->{'id'}});
		if (!$cgi::input->{'clipboard_expired'} && $this->{'is_posted_file'}) {
			$form .= '<div class="extra-field"><label><input type="checkbox" name="option:' . $this->{'id'} . ':cancel" value="1" /> <strong>̤</strong>ե</label></div>';
		} elsif ($this->{'digitalContentMenuEnabled'} || !$this->{'required'} || !$this->{'digitalContentRequired'}) {
			$form .= '<div class="extra-field"><label><input type="checkbox" name="' . $name . 'delete" value="1"' . ((!$cgi::input->{'clipboard_expired'} && $main::data{$this->{'id'}}{'delete'}) ? ' checked="checked"' : '') . ' /> Υե</label></div>';
		}
		$form .= '<input type="hidden" name="' . $name . 'foldertype" value="' . $this->escape($data->{$type . 'foldertype'}) . '" />';
		$form .= '<input type="hidden" name="' . $name . 'digitalcontent" value="' . $this->escape($data->{$type . 'digitalcontent'}) . '" />';
	} elsif ($data->{$type . 'foldertype'} && $data->{$type . 'foldertype'} eq '2') {
		delete $data->{$type . 'foldertype'};
		delete $data->{$type . 'digitalcontent'};
	}
	$form .= '</td></tr>';
	$form .= '</tbody>';
}
$form .= '<tbody>';
if (!$invalid_check && ($this->{'digitalContentMenuEnabled'} || $this->{'digitalContentUploadEnabled'}) && $data->{$type . 'digitalcontent'}) {
	$form .= '<tr>';
	$form .= '<td class="sub-field-name"><span class="datatitle">ե</span></td>';
	$form .= '<td class="sub-field">';
	$form .= $this->digital_content_icon($data);
	$form .= '<input type="hidden" name="' . $name . 'foldertype" value="' . $this->escape($data->{$type . 'foldertype'}) . '" />';
	$form .= '<input type="hidden" name="' . $name . 'digitalcontent" value="' . $this->escape($data->{$type . 'digitalcontent'}) . '" />';
	$form .= '</td></tr>';
}
$form .= '<tr>';
$form .= '<td class="sub-field-name"><label for="price-form-' . $form_id . '"></label></td>';
$form .= '<td class="sub-field">';
$form .= '<span class="unit">' . $this->{'monetaryunit'} . '</span> ' if $this->{'monetaryunit'} !~ /[\x80-\xff]/;
$form .= '<input type="text" size="10" name="' . $name . 'price" value="' . $this->escape($data->{$type . 'price'}) . '" onchange="cmonos.tool.showPrice(\'' . $env::tax_frac . '\',' . $env::tax_rate . ',\'' . $form_id . '\'' . $pricelimit . ');"' . (($invalid_check && $this->{'is_invalid_field'}{'price'}) ? ' class="invalid-field"' : '') . ' id="price-form-' . $form_id . '" />';
$form .= ' <span class="unit">' . $this->{'monetaryunit'} . '</span>' if $this->{'monetaryunit'} =~ /[\x80-\xff]/;
$form .= ' <span class="note">(ǹ߲ : ';
$form .= $this->{'monetaryunit'} if $this->{'monetaryunit'} !~ /[\x80-\xff]/;
$form .= '<span id="price-' . $form_id . '">';
$form .= $this->digit($this->add_tax($data->{$type . 'price'}));
$form .= '</span>';
$form .= $this->{'monetaryunit'} if $this->{'monetaryunit'} =~ /[\x80-\xff]/;
$form .= ')</span>';
$form .= '</td></tr>';
#$form .= '<tr>';
#$form .= '<td class="sub-field-name"><label for="point-form-' . $form_id . '">ݥΨ</label></td>';
#$form .= '<td class="sub-field">';
#$form .= '<input type="text" size="10" name="' . $name . 'point" value="' . $this->escape($data->{$type . 'point'}) . '" onchange="cmonos.tool.showPrice(\'' . $env::tax_frac . '\',' . $env::tax_rate . ',\'' . $form_id . '\'' . $pricelimit . ');"' . (($invalid_check && $this->{'is_invalid_field'}{'point'}) ? ' class="invalid-field"' : '') . ' id="point-form-' . $form_id . '" />';
#$form .= ' % <span class="note">(';
#$form .= '<span id="point-' . $form_id . '">';
#$form .= $this->digit($this->get_point($data->{$type . 'point'},$data->{$type . 'price'}));
#$form .= '</span>';
#$form .= $this->{'pointunit'};
#$form .= ')</span></td></tr>';
if ($this->{'weightenabled'} && !$this->{'digitalContentRequired'} && !$data->{$type . 'digitalcontent'}) {
	$form .= '<tr>';
	$form .= '<td class="sub-field-name"><label for="' . $name . 'weight"></label></td>';
	$form .= '<td class="sub-field"><input type="text" size="10" name="' . $name . 'weight" id="' . $name . 'weight" value="' . $this->escape($data->{$type . 'weight'}) . '"' . (($invalid_check && $this->{'is_invalid_field'}{$type . 'weight'}) ? ' class="invalid-field"' : '') . ' onchange="cmonos.validate.field(this).bailOut()" /> <span class="unit">g</span></td>';
	$form .= '</tr>';
}
if (!$default::static) {
	if ($data->{$type . 'digitalcontent'}) {
		$data->{$type . 'withdrawn'} = time if $data->{$type . 'withdrawn'} && $this->is_nan($data->{$type . 'withdrawn'});
		$form .= '<tr>';
		$form .= '<td class="sub-field-name"><label for="' . $name . 'withdrawn"></label></td>';
		$form .= '<td class="sub-field"><input type="checkbox" name="' . $name . 'withdrawn" id="' . $name . 'withdrawn" value="' . ($data->{$type . 'withdrawn'} || time) . '"' . (($data->{$type . 'withdrawn'}) ? ' checked="checked"' : '') . ' /> ' . $this->escape($this->{'withdrawnLabel'} || '') . (($data->{$type . 'withdrawn'}) ? '(' . int((time - $data->{$type . 'withdrawn'})/86400) . ')' : '') . '</td>';
		$form .= '</tr>';
	} elsif (!$this->{'digitalContentRequired'}) {
		$form .= '<tr>';
		$form .= '<td class="sub-field-name"><label for="' . $name . 'stock">߸˿</label></td>';
		$form .= '<td class="sub-field"><input type="text" size="10" name="' . $name . 'stock" id="' . $name . 'stock" value="' . $this->escape($data->{$type . 'stock'}) . '"' . (($invalid_check && $this->{'is_invalid_field'}{$type . 'stock'}) ? ' class="invalid-field"' : '') . ' onchange="cmonos.validate.field(this).bailOut()" />' . ((defined $this->{'stockunit'} && $this->{'stockunit'} ne '') ? ' <span class="unit">' . $this->{'stockunit'} . '</span>' : '') . '</td>';
		$form .= '</tr>';
	}
}
if (($this->{'stockview'} eq 'menu' || ($default::static && ref $this->{'stockAvailability'} eq 'ARRAY')) && !$this->{'digitalContentRequired'} && !$data->{$type . 'digitalcontent'}) {
	$form .= '<tr>';
	$form .= '<td class="sub-field-name"><label for="' . $name . 'availability">߸˾</label></td>';
	$form .= '<td class="sub-field">';
	$form .= $this->stock_availability_menu($name . 'availability',$data->{$type . 'availability'});
	$form .= '</td>';
	$form .= '</tr>';
}
if ($type || ($invalid_check && !$this->{'defaultconditionfixed'})) {
	$form .= '<tr>';
	$form .= '<td class="sub-field-name"><label for="' . $name . 'condition"></label></td>';
	$form .= '<td class="sub-field">';
	$form .= $this->mk_select_menu(
		$name . 'condition','','',$data->{$type . 'condition'},
		'new'			=>		'',
		'used'			=>		'',
		'refurbished'	=>		''
	);
	$form .= ' <label><input type="checkbox" name="' . $name . 'conditionfixed" value="1"' . (($this->{'defaultconditionfixed'}) ? ' checked="checked"' : '') . ' />(ɽ)</label>' if $type;
	$form .= '</td>';
	$form .= '</tr>';
}
if ($option) {
	if ($this->{'optionenabled'}) {
		$form .= '<tr>';
		$form .= '<td class="sub-field-name"><label for="' . $name . 'option">ץ</label></td>';
		$form .= '<td class="sub-field">';
		$form .= '<textarea name="' . $name . 'option" id="' . $name . 'option" rows="5" cols="40"' . (($invalid_check && $this->{'is_invalid_field'}{$type . 'option'}) ? $this->set_invalid_class : '') . '>';
		$form .= $this->escape($data->{$type . 'option'});
		$form .= '</textarea>';
		$form .= '<div class="note">=̾:褻[]</div><div class="note">褻ʤˤƤ</div>';
		$form .= '<div class="extra-field"><label><input type="checkbox" name="' . $name . 'multiple" value="1"' . (($data->{$type . 'multiple'}) ? ' checked="checked"' : '') . ' /> ʣ</label></div>';
		$form .= '</td>';
		$form .= '</tr>';
	}
} else {
	$form .= '<tr>';
	$form .= '<td class="submit-box" colspan="2">';
	$form .= $cgi::Deco->submit_button('submit',$this->{'submitButton'},(($default::english) ? 'Submit' : ''),{'id' => $id . '-submit'});
	$form .= '</td>';
	$form .= '</tr>';
}
$form .= '</tbody></table>';
return $form;
}

sub digital_content_icon ($$;$) {
my($this,$data,$no_box) = @_;
my $icon = '';
$icon .= '<div class="digital-content">' if !$no_box;
my $ext = ($data->{'digitalcontent'} =~ /\.(\w+)$/) ? $1 : '';
if (!@env::icon_images && $env::icon_dir && -d $env::icon_dir) {
	opendir(DIR,$env::icon_dir);
	@env::icon_images = readdir(DIR);
	closedir(DIR);
}
if (@env::icon_images) {
	my($icon_image) = grep($_ =~ /^$ext\./,@env::icon_images);
	if (!$icon_image) {
		if (@Common::qt_plug && grep($_ eq $ext,@Common::qt_plug)) {
			$icon_image = 'mov.png' if grep($_ eq 'mov.png',@env::icon_images);
		} elsif (@Common::image_plug && grep($_ eq $ext,@Common::image_plug,'png','jpg','jpeg','gif')) {
			$icon_image = 'image.png' if grep($_ eq 'image.png',@env::icon_images);
		} elsif (@Common::sound_plug && grep($_ eq $ext,@Common::sound_plug)) {
			$icon_image = 'sound.png' if grep($_ eq 'sound.png',@env::icon_images);
		} else {
			$icon_image = 'unknown.png';
		}
	}
	$icon .= '<img src="' . (($cgi::output) ? $this->base_change($env::icon_dir . '/' . $icon_image,$cgi::output,$cgi::output_option) : $env::icon_dir . '/' . $icon_image) . '" border="0" width="32" height="32" alt="' . $this->escape($data->{'digitalcontent'}) . '" /><span class="sc-download-file-name">' . $this->escape($data->{'digitalcontent'}) . '</span>';
} else {
	$icon .= $this->escape($data->{'digitalcontent'});
}
if ($this->{'is_temporary_data'} && $main::data{$this->{'id'}}{'delete'} && !$this->{'is_posted_file'}) {
	$icon .= '<div class="note">Υե</div>';
}
$icon .= '</div>' if !$no_box;
return $icon;
}

sub stock_availability_menu ($$$;$) {
my($this,$name,$default,$multiple_flag) = @_;
my($form);
$default = '' if !defined $default;
$form .= '<select name="' . $name . '" id="' . $name . '"';
if (defined $multiple_flag && $multiple_flag) {
	if ($this->{'stockview'} eq 'sync') {
		$form .= ' size="4" multiple="multiple"';
	} else {
		$form .= ' size="' . (scalar(@{$this->{'stockAvailability'}}) - 1) . '" multiple="multiple"';
	}
}
$form .= '>';
$form .= '<option value=""></option>' if !defined $multiple_flag || !$multiple_flag;
if ($default::static || $this->{'stockview'} eq 'menu') {
	my($availability_name,$id);
	$id = 0;
	foreach $availability_name (@{$this->{'stockAvailability'}}) {
		$form .= '<option value="' . $id . '"' . (($default ne '' && $default == $id) ? ' selected="selected"' : '') . '>' . $this->get_option_name($availability_name) . ((ref $this->{'orderstop'} && $this->{'orderstop'}[$id]) ? '()' : '') . '</option>';
		$id++;
	}
} elsif ($this->{'stockview'} eq 'sync') {
	$form .= '<option value="abundant"' . (($default eq 'abundant') ? ' selected="selected"' : '') . '>' . $this->get_option_name($this->{'abundantName'}) . '</option>';
	$form .= '<option value="in_stock"' . (($default eq 'in_stock') ? ' selected="selected"' : '') . '>' . $this->get_option_name($this->{'inStockName'}) . '</option>';
	$form .= '<option value="limited"' . (($default eq 'limited') ? ' selected="selected"' : '') . '>' . $this->get_option_name($this->{'limitedAvailabilityName'}) . '</option>';
	$form .= '<option value="out_of_stock"' . (($default eq 'out_of_stock') ? ' selected="selected"' : '') . '>' . $this->get_option_name($this->{'outOfStockName'}) . '</option>';
} else {
	return '';
}
$form .= '</select>';
return $form;
}

sub get_option_name ($$) {
my($this,$option) = @_;
my($name);
$name = $1 if $option =~ /\s+alt\s*=\s*"([^"]+)"/s;
$option =~ s/<[^>]+>//sg if $option;
$name .= (defined $option && $option ne '') ? (defined $name && $name ne '') ? '(' . $option . ')' : $option : '';
return $name;
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
my $this = shift;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
my $is_valid = 1;
my $upload_name = 'data:' . $this->{'id'} . ':file';
if ($main::clipboard_id && !$main::data{$this->{'id'}}{'file'} && !$main::option{$this->{'id'}}{'cancel'}) {
	$cgi::input->inherit_posted_file_properties($upload_name);
}
my %properties = $cgi::input->get_posted_file_properties_from_param($upload_name);
if ($properties{'delete'}) {
	delete $properties{'delete'};
	$cgi::input->set_posted_file_properties_from_param($upload_name,0,\%properties);
}
my $dc_directory = $this->get_digital_content_directory_path;
if ($this->{'digitalContentUploadEnabled'}) {
	if ($main::data{$this->{'id'}}{'foldertype'} && $main::data{$this->{'id'}}{'foldertype'} eq '2' && $main::data{$this->{'id'}}{'digitalcontent'} && $main::data{$this->{'id'}}{'digitalcontent'} !~ /^\./ && -f $this->get_file_directory . '/' . $this->{'id'} . '.' . $main::data{$this->{'id'}}{'digitalcontent'} . '.dat') {
		$main::data{$this->{'id'}}{'foldertype'} = 2;
	} else {
		my $file_path = $this->fileglob($this->get_file_directory,'^' .  $this->{'id'} . '\\.\\w+\\.\\w+\\.dat$');
		if ($file_path && $file_path =~ /\/$this->{'id'}\.(\w+\.\w+)\.dat$/) {
			$main::data{$this->{'id'}}{'digitalcontent'} = $1;
			$main::data{$this->{'id'}}{'foldertype'} = 2;
		} elsif ($main::data{$this->{'id'}}{'foldertype'} && $main::data{$this->{'id'}}{'foldertype'} eq '2' && $main::data{$this->{'id'}}{'digitalcontent'}) {
			push(@{$cgi::action->{'dialog'}},'' . (($this->{'name'}) ? $this->{'name'} . '饢åץɤ줿' : '') . 'ǥ륳ƥĥե뤬ߤĤޤ') if ref $cgi::action;
			$this->{'is_invalid_field'}{'file'} = 1;
			delete $main::data{$this->{'id'}}{'foldertype'};
			delete $main::data{$this->{'id'}}{'digitalcontent'};
			delete $main::data{$this->{'id'}}{'delete'};
			$is_valid = 0;
		}
	}
}
if ($this->{'digitalContentMenuEnabled'} && $main::data{$this->{'id'}}{'foldertype'} && $main::data{$this->{'id'}}{'foldertype'} eq '1') {
	if ((defined $main::data{$this->{'id'}}{'digitalcontent'} && $main::data{$this->{'id'}}{'digitalcontent'} =~ /^\./) || !-f $dc_directory . '/' . $main::data{$this->{'id'}}{'digitalcontent'}) {
		push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '򤵤줿' : '') . 'ǥ륳ƥĤߤĤޤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'selectedDigitalContent'} = 1;
		delete $main::data{$this->{'id'}}{'foldertype'};
		delete $main::data{$this->{'id'}}{'digitalcontent'};
		$is_valid = 0;
	}
}
delete $main::data{$this->{'id'}}{'foldertype'} if defined $main::data{$this->{'id'}}{'foldertype'} && $main::data{$this->{'id'}}{'foldertype'} ne '1' && $main::data{$this->{'id'}}{'foldertype'} ne '2';
if ($this->{'digitalContentUploadEnabled'} && $properties{'filename'}) {
	if (ref $this->{'type_ext'} eq 'HASH' && %{$this->{'type_ext'}}) {

		#MIME-TYPEå
		if (!defined $this->{'type_ext'}{$properties{'type'}}) {
			my $mimename = '';
			foreach my $ext (sort keys %{$this->{'mimename'}}) {
				$mimename .= (($mimename) ? ',' : '') . $this->{'mimename'}{$ext} . (($this->{'mimename'}{$ext} ne $ext) ? '(' . $ext . ')' : '')
			}
			push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} . '饢åץɤ줿' : '') . 'ǥ륳ƥĥեΥեǧƤΤߵĤƤޤ' . $mimename) if ref $cgi::action;
			$this->{'is_invalid_field'}{'file'} = 1;
			$is_valid = 0;
		} else {
			$properties{'filename'} =~ s/\.\w+$/\.$this->{'type_ext'}{$properties{'type'}}/;
		}
	}

	#ե̾
	if ($is_valid) {
		my $file_name = $this->z_to_h($properties{'filename'},'euc');
		my $ext = ($file_name =~ s/\.(\w+)$//s) ? lc $1 : 'txt';
		$file_name =~ s/[\s\.\-\+]+/_/gs;
		$file_name = 'download' if $file_name =~ /\W/;
		$main::data{$this->{'id'}}{'foldertype'} = 2;
		$main::data{$this->{'id'}}{'digitalcontent'} = $file_name . '.' . $ext;
		delete $main::data{$this->{'id'}}{'selectedDigitalContent'};
	}

} elsif (!$main::data{$this->{'id'}}{'delete'} && $this->{'digitalContentUploadEnabled'} && $main::data{$this->{'id'}}{'foldertype'} && $main::data{$this->{'id'}}{'foldertype'} eq '2' && $main::data{$this->{'id'}}{'digitalcontent'}) {
	if ($this->{'digitalContentMenuEnabled'} && defined $main::data{$this->{'id'}}{'selectedDigitalContent'} && $main::data{$this->{'id'}}{'selectedDigitalContent'} ne '') {
		push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '򤵤줿' : '') . 'ǥ륳ƥĤꤹˤϡߥåץɤƤ' . $main::data{$this->{'id'}}{'digitalcontent'} . 'פޤ') if ref $cgi::action;
	}

} elsif ($this->{'digitalContentMenuEnabled'} && defined $main::data{$this->{'id'}}{'selectedDigitalContent'} && $main::data{$this->{'id'}}{'selectedDigitalContent'} ne '') {
	$dc_directory = $this->get_digital_content_directory_path;
	if ($main::data{$this->{'id'}}{'selectedDigitalContent'} =~ /^\./ || !-f $dc_directory . '/' . $main::data{$this->{'id'}}{'selectedDigitalContent'}) {
		push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '򤵤줿' : '') . 'ǥ륳ƥĤߤĤޤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'selectedDigitalContent'} = 1;
		delete $main::data{$this->{'id'}}{'selectedDigitalContent'};
		$is_valid = 0;
	} else {
		$main::data{$this->{'id'}}{'foldertype'} = 1;
		$main::data{$this->{'id'}}{'digitalcontent'} = $main::data{$this->{'id'}}{'selectedDigitalContent'};
	}
	$this->write_file(
		$dc_directory . '/.htaccess',
		'Satisfy all' . "\x0A"
			. 'order deny,allow' . "\x0A"
			. 'deny from all' . "\x0A",
		1
	);
}
if ($default::static && $main::data{$this->{'id'}}{'foldertype'}) {
	my $dir = ($main::data{$this->{'id'}}{'foldertype'} eq '2') ? $this->get_file_directory : $this->get_digital_content_directory_path;
	$main::data{$this->{'id'}}{'folder'} =  ($cgi::output) ? $this->base_change($dir,$cgi::output,$cgi::output_option) : $dir;
} else {
	delete $main::data{$this->{'id'}}{'folder'};
}
if ($this->is_digital_content($main::data{$this->{'id'}}) && (!$main::data{$this->{'id'}}{'delete'} || $main::data{$this->{'id'}}{'selectedDigitalContent'})) {
	delete $main::data{$this->{'id'}}{'availability'};
	delete $main::data{$this->{'id'}}{'stock'};
} elsif ($this->{'digitalContentRequired'} && $this->{'required'}) {
	push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '' : '') . 'ǥ륳ƥĤǧƤǥ륳ƥĤɬܹܤǤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'file'} = 1;
	$is_valid = 0;
}
if (defined $main::data{$this->{'id'}}{'price'} && $main::data{$this->{'id'}}{'price'} ne '' && $this->is_nan($main::data{$this->{'id'}}{'price'})) {
	push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '' : '') . 'ʤǤϤޤȾѿˤƤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'price'} = 1;
	$is_valid = 0;
} elsif ($main::data{$this->{'id'}}{'price'} && $main::data{$this->{'id'}}{'price'} =~ /\./) {
	push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '' : '') . 'ʤǧƤʲͼθޤ') if ref $cgi::action;
	$main::data{$this->{'id'}}{'price'} = int($main::data{$this->{'id'}}{'price'} + 0.5);
}
#if (defined $main::data{$this->{'id'}}{'point'} && $main::data{$this->{'id'}}{'point'} ne '' && ($this->is_nan($main::data{$this->{'id'}}{'point'}) || $main::data{$this->{'id'}}{'point'} < 0 || $main::data{$this->{'id'}}{'point'} >= 100)) {
#	push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '' : '') . 'ݥȤǧƤ0 ʾ 100 ̤ȾѿˤƤ') if ref $cgi::action;
#	$this->{'is_invalid_field'}{'point'} = 1;
#	$is_valid = 0;
#}
if (defined $main::data{$this->{'id'}}{'weight'} && $main::data{$this->{'id'}}{'weight'} ne '' && $this->is_nan($main::data{$this->{'id'}}{'weight'})) {
	push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '' : '') . '̤ǤϤޤȾѿˤƤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'weight'} = 1;
	$is_valid = 0;
}
if (defined $main::data{$this->{'id'}}{'stock'} && $main::data{$this->{'id'}}{'stock'} ne '' && $this->is_nan($main::data{$this->{'id'}}{'stock'})) {
	push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '' : '') . '߸˿ǤϤޤȾѿˤƤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'stock'} = 1;
	$is_valid = 0;
} elsif ($main::data{$this->{'id'}}{'stock'} && $main::data{$this->{'id'}}{'stock'} =~ /\./) {
	push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '' : '') . 'ʤǧƤʲڤΤƤޤ') if ref $cgi::action;
	$main::data{$this->{'id'}}{'stock'} = int($main::data{$this->{'id'}}{'stock'} + 0.5);
}
if ($this->{'required'} && (!defined $main::data{$this->{'id'}}{'price'} || $main::data{$this->{'id'}}{'price'} eq '')) {
	push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '' : '') . 'ʤϤƤޤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'price'} = 1;
	$is_valid = 0;
}
unless (($this->{'digitalContentMenuEnabled'} && $main::data{$this->{'id'}}{'foldertype'} && $main::data{$this->{'id'}}{'foldertype'} eq '1' && $main::data{$this->{'id'}}{'digitalcontent'})
 || ($this->{'digitalContentUploadEnabled'} && !$main::data{$this->{'id'}}{'delete'} && $main::data{$this->{'id'}}{'foldertype'} && $main::data{$this->{'id'}}{'foldertype'} eq '2' && $main::data{$this->{'id'}}{'digitalcontent'})) {
	delete $main::data{$this->{'id'}}{'withdrawn'};
}
if (defined $main::data{$this->{'id'}}{'option'} && $main::data{$this->{'id'}}{'option'} ne '') {
	my($id);
	while ($main::data{$this->{'id'}}{'option'} =~ /^(.*)$/mg) {
		my($name,$formula);
		$id++;
		$name = $1;
		$formula = $1 if $name =~ s/:([^:]*?)$//;
		if ($name !~ /\S/) {
			push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '' : '') . 'ץ ' . $id . 'ܤǤ') if ref $cgi::action;
			$this->{'is_invalid_field'}{'option'} = 1;
			$is_valid = 0;
		}
		if (defined $formula && $formula ne '') {
			if ($formula !~ /^[\+\-]?\d+$/) {
				push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . '' : '') . 'ץ ' . $id . 'ܤξ褻ʤ׻ǽǤ') if ref $cgi::action;
				$this->{'is_invalid_field'}{'option'} = 1;
				$is_valid = 0;
			}
		}
	}
}
if ($is_valid) {
	$main::data{$this->{'id'}}{'digitalContentRequired'} = 1 if $this->{'digitalContentRequired'};
	if (!$this->sc_stock_is_ok($main::data{$this->{'id'}})) {
		$main::data{$this->{'id'}}{'unavailable'} = 1;
	} else {
		delete $main::data{$this->{'id'}}{'unavailable'};
	}
	$main::data{$this->{'id'}}{'str'} = ((defined $main::data{$this->{'id'}}{'price'}) ? $main::data{$this->{'id'}}{'price'} : '') . "\x0A";
	my($k,$v);
	while (($k,$v) = each %{$main::data{$this->{'id'}}}) {
		next if !defined $k || !defined $v || $k eq 'str' || $k eq 'price' || $k eq 'file' || $k eq 'selectedDigitalContent' || $k eq 'delete'
			 || (!$properties{'filename'} && $this->{'digitalContentUploadEnabled'} && $main::data{$this->{'id'}}{'delete'} && !$main::data{$this->{'id'}}{'selectedDigitalContent'} && ($k eq 'digitalcontent' || $k eq 'foldertype'));
		$v =~ s/\x0A/\&#10;/sg;
		$main::data{$this->{'id'}}{'str'} .= $k . ':' . $v . "\x0A";
	}
	$cookie::data{'data:' . $this->{'id'} . ':str'} = $main::data{$this->{'id'}}{'str'} if $this->{'cookie'} && $main::set_cookie;

	#ե¸/ͽ
	if ($properties{'filename'}) {
		$cgi::input->save_file(
			$upload_name,
			'!' . $this->{'id'} . '.' . $main::data{$this->{'id'}}{'digitalcontent'} . '.dat',
			'',
			'',
			'',
			$this->{'id'} . '(\\..*|)'
		);
		$this->{'is_posted_file'} = 1;
	} elsif ($main::data{$this->{'id'}}{'delete'}) {
		$properties{'delete'} = $this->{'id'} . '(\\..*|)';
		$cgi::input->set_posted_file_properties_from_param($upload_name,0,\%properties);
		$cgi::input->parameters_trash(\$main::data{$this->{'id'}}{'foldertype'},\$main::data{$this->{'id'}}{'digitalcontent'}) if $this->{'digitalContentUploadEnabled'};
	}
}
delete $main::data{$this->{'id'}}{'file'};
return $is_valid;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=ɽǡ/path=ե¸ǥ쥯ȥ
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
my(%data,$out,$id);
$id = $this->mk_user_generated_field_id($c,$n);
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
my $is_dc = $this->is_digital_content(\%data);
return $this->field_tag($this->data_tag_from_ref(\%data),1) if ($this->{'digitalContentRequired'} || $data{'digitalContentRequired'}) && !$is_dc;
if (!$default::static && !$cgi::output && $this->{'formauthority'} && $this->is_secure($this->{'formauthority'})) {
	$out .= $this->form_start(
		'key'	=>	$this->{'formauthority'},
		'id'		=>	(($id) ? $id . '-form' : ''),
		'name'		=>	(($id) ? $id . '-form' : ''),
		'method'	=> 'post',
		'onsubmit'	=>	'return cmonos.form.item(this).submit(\'' . $id . '\');',
		'required'	=>	$this->get_query_keys
	);
	$out .= $this->add_query_for_form($c,$n);
	$out .= $this->add_query('post',{'id' => $this->{'id'}});
	$out .= $this->input_form('data:' . $this->{'id'} . ':','',\%data,0,0,$id,$path);
	$out .= '</form>';
} else {
	return $this->field_tag($this->data_tag_from_ref(\%data),1) if !defined $data{'price'} || $data{'price'} eq '';
	if ($this->sc_stock_is_ok(\%data)) {
		$out = '<form action="' . (($cgi::output || $cgi::output_option) ? $this->base_change($env::checkout,$cgi::output,$cgi::output_option) : $env::checkout) . '" method="post"';
		$out .= ' name="' . $id . '-form"';
		$out .= ' onsubmit="return cmonos.tool.shoppingcart.window.open(this)"';
		$out .= ' class="showcase-form">';
		$out .= '<input type="hidden" name="m" value="CartViewer" />';
		$out .= '<input type="hidden" name="cart:caller" value="' . (($ENV{'SCRIPT_NAME'} =~ m!([^/]+)/[^/]+$!) ? $1 : '') . '" />';
		$out .= '<input type="hidden" name="cart:c" value="' . $c . '" />' if defined $c;
		$out .= '<input type="hidden" name="cart:n" value="' . $n . '" />' if defined $n;
		$out .= '<input type="hidden" name="cart:cartfield" value="' . $this->{'id'} . '" />';
		if ($default::static) {
			$out .= '<input type="hidden" name="cart:namefield" value="' . $this->{'namefield'} . '" />' if defined $this->{'namefield'} && $this->{'namefield'};
			$out .= '<input type="hidden" name="cart:keyfield" value="' . $this->{'keyfield'} . '" />' if defined $this->{'keyfield'} && $this->{'keyfield'};	
			$out .= '<input type="hidden" name="cart:p" value="' . $main::p . '" />' if defined $main::p;
			$out .= '<input type="hidden" name="cart:chapterid" value="' . $main::chap . '" />' if defined $main::chap && $main::chap ne '';
			$out .= '<input type="hidden" name="cart:sectionid" value="' . $main::sect . '" />' if defined $main::sect && $main::sect ne '';
#			$out .= '<input type="hidden" name="cart:itemname" value="' . $main::data{$this->{'namefield'}}{'str'} . '" />' if defined $this->{'namefield'} && $this->{'namefield'};
#			$out .= '<input type="hidden" name="cart:itemid" value="' . $main::data{$this->{'keyfield'}}{'str'} . '" />' if defined $this->{'keyfield'} && $this->{'keyfield'};	
#			$out .= '<input type="hidden" name="cart:price" value="' . $data{'price'} . '" />';
#			$out .= '<input type="hidden" name="cart:availability" value="' . $data{'availability'} . '" />';
		} else {
#			$out .= '<input type="hidden" name="cart:lib" value="' . $default::lib . '" />';
			$out .= '<input type="hidden" name="cart:m" value="' . $this->escape($main::m) . '" />';
		}
		$out .= '<input type="hidden" name="cart:digitalcontent" value="' . $this->escape($data{'foldertype'}) . '" />' if $is_dc;
		delete $data{'unavailable'};
	} else {
		$data{'unavailable'} = 1;
	}
	if ($this->{'template'}) {
		my $template = $this->{'template'};
		my $icon = ($is_dc) ? $this->digital_content_icon(\%data,1) : '';
		my $price = (!$this->{'pricehidden'}) ? $this->sc_price_tag($data{'price'},$this->{'monetaryunit'},1) : '';
#		my $point = (!$this->{'pointhidden'}) ? $this->sc_point_tag($data{'point'},$data{'price'},$this->{'pointunit'},1) : '';
		my $stock = (!$this->{'stockhidden'}) ? $this->sc_stock_tag($data{'availability'},$data{'stock'},$is_dc,$data{'withdrawn'},1) : '';
		my $condition = (!$this->{'defaultconditionfixed'} && !$is_dc) ? $this->sc_condition_tag($data{'condition'},1) : '';
		$template =~ s/<\!--icon(?!\w)([^>]*)-->(.*?)<\!--\/icon(?!\w)[^>]*-->/$this->item_tag_replace('icon',$1,$2,$icon)/gies;
		$template =~ s/<\!--price(?!\w)([^>]*)-->(.*?)<\!--\/price(?!\w)[^>]*-->/$this->item_tag_replace('price',$1,$2,$price)/gies;
#		$template =~ s/<\!--point(?!\w)([^>]*)-->(.*?)<\!--\/point(?!\w)[^>]*-->/$this->item_tag_replace('point',$1,$2,$point)/gies;
		$template =~ s/<\!--stock(?!\w)([^>]*)-->(.*?)<\!--\/stock(?!\w)[^>]*-->/$this->item_tag_replace('stock',$1,$2,$stock)/gies;
		$template =~ s/<\!--condition(?!\w)([^>]*)-->(.*?)<\!--\/condition(?!\w)[^>]*-->/$this->item_tag_replace('condition',$1,$2,$condition)/gies;
		if (!$data{'unavailable'}) {
			my $quantity = $this->sc_quantity_tag($is_dc,1);
			my $option = $this->sc_option_menu(\%data,1);
			my $button = $this->sc_submit_button(1);
			$template =~ s/<\!--quantity(?!\w)([^>]*)-->(.*?)<\!--\/quantity(?!\w)[^>]*-->/(($is_dc) ? $quantity : $this->item_tag_replace('quantity',$1,$2,$quantity))/gies;
			$template =~ s/<\!--option(?!\w)([^>]*)-->(.*?)<\!--\/option(?!\w)[^>]*-->/$this->item_tag_replace('option',$1,$2,$option)/gies;
			$template =~ s/<\!--button(?!\w)([^>]*)-->(.*?)<\!--\/button(?!\w)[^>]*-->/$this->item_tag_replace('button',$1,$2,$button)/gies;
			$out .= $template . '</form>';
		} else {
			$template =~ s/<\!--quantity(?!\w)[^>]*-->.*?<\!--\/quantity(?!\w)[^>]*-->//gis;
			$template =~ s/<\!--option(?!\w)[^>]*-->.*?<\!--\/option(?!\w)[^>]*-->//gis;
			$template =~ s/<\!--button(?!\w)[^>]*-->.*?<\!--\/button(?!\w)[^>]*-->//gis;
			$out .= $template;
		}
	} else {
		$out .= $this->digital_content_icon(\%data) if $is_dc;
		$out .= $this->sc_price_tag($data{'price'},$this->{'monetaryunit'}) if !$this->{'pricehidden'};
#		$out .= $this->sc_point_tag($data{'point'},$data{'price'},$this->{'pointunit'}) if !$this->{'pointhidden'};
		$out .= $this->sc_stock_tag($data{'availability'},$data{'stock'},$is_dc,$data{'withdrawn'}) if !$this->{'stockhidden'};
		$out .= $this->sc_condition_tag($data{'condition'}) if !$this->{'defaultconditionfixed'} && !$is_dc;
		if (!$data{'unavailable'}) {
			$out .= $this->sc_quantity_tag($is_dc);
			$out .= $this->sc_option_menu(\%data);
			$out .= $this->sc_submit_button;
			$out .= '</form>';
		}
	}
}
return $this->field_tag(
	$this->data_tag_from_ref(\%data) . 
	$this->style(
		$out,
		$this->{'style'},
		$this->{'fontsize'},
		$this->{'fontcolor'},
		$this->{'fontface'}
	)
);
}

sub has_content {
my($this,$str) = @_;
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return ((!$default::static && !$cgi::output && !$this->{'digitalContentMenuEnabled'} && !$this->{'digitalContentUploadEnabled'} && $this->{'formauthority'} && $this->is_secure($this->{'formauthority'})) || (defined $data{'price'} && $data{'price'} ne '')) ? 1 : 0;
}

sub sc_stock_is_ok ($$) {
#no warnings qw(numeric);
my($this,$data) = @_;
if (($this->{'digitalContentMenuEnabled'} && $data->{'foldertype'} && $data->{'foldertype'} eq '1' && $data->{'digitalcontent'}) || ($this->{'digitalContentUploadEnabled'} && $data->{'foldertype'} && $data->{'foldertype'} eq '2' && $data->{'digitalcontent'})) {
	return (ref $data && $data->{'withdrawn'}) ? 0 : 1;
} elsif ($default::static || $this->{'stockview'} eq 'menu') {
	return (ref $data && defined $data->{'availability'} && ref $this->{'orderstop'} eq 'ARRAY' && $this->{'orderstop'}[$data->{'availability'}]) ? 0 : 1;
} elsif ($this->{'stockview'} eq 'sync') {
	return (ref $data && defined $data->{'stock'} && defined $this->{'outOfStockBounds'} && $data->{'stock'} ne '' && $data->{'stock'} <= $this->{'outOfStockBounds'}) ? 0 : 1;
}
return 1;
}

sub is_digital_content ($$) {
my($this,$data) = @_;
if (($this->{'digitalContentMenuEnabled'} && $data->{'foldertype'} && $data->{'foldertype'} eq '1' && $data->{'digitalcontent'}) || ($this->{'digitalContentUploadEnabled'} && $data->{'foldertype'} && $data->{'foldertype'} eq '2' && $data->{'digitalcontent'})) {
	return 1;
} else {
	return 0;
}
}

sub sc_price_tag ($$$;$) {
my($this,$price,$unit,$no_box) = @_;
my $out = '';
$out .= '<div class="showcase-price"' . $this->raw_price_info($price,$unit,1) . '>' if !$no_box;
$out .= '<span class="unit">' . $unit . '</span>' if $unit && $unit !~ /[\x80-\xff]/;
$out .= $this->digit($this->add_tax($price));
$out .= '<span class="unit">' . $unit . '</span>' if $unit && $unit =~ /[\x80-\xff]/;
$out .= '</div>' if !$no_box;
return $out;
}

sub sc_weight_tag ($$;$) {
my($this,$weight,$no_box) = @_;
return ((!$no_box) ? '<div class="showcase-weight">' : '') . $this->digit($weight) . '<span class="unit">g</span>' . ((!$no_box) ? '</div>' : '');
}

#sub sc_point_tag ($$$$;$) {
#my($this,$point_rate,$price,$unit,$no_box) = @_;
#my($out);
#return '' if !$point_rate || $point_rate =~ /[^\d\.]/;
#$out .= '<div class="showcase-point">' if !$no_box;
#$out .= $this->digit($this->get_point($point_rate,$price)) . (($unit) ? '<span class="unit">' . $unit . '</span>' : '');
#$out .= ' <span class="note">(' . $point_rate . '%)</span>';
#$out .= '</div>' if !$no_box;
#return $out;
#}
#
#sub get_point ($$$) {
#my($this,$point_rate,$price) = @_;
#$price = 0 if !$price || $price =~ /[^\d\.]/;
#$point_rate = 0 if !$point_rate || $point_rate =~ /[^\d\.]/;
#if ($env::tax_frac eq 'floor') {
#	return int(($price * ($point_rate / 100)) + 0.999);
#} elsif ($env::tax_frac eq 'round') {
#	return int(($price * ($point_rate / 100)) + 0.5);
#} else {
#	return int($price * ($point_rate / 100));
#}
#}

sub sc_stock_tag ($$$$;$$) {
my($this,$availability,$stock,$is_dc,$withdrawn,$no_box) = @_;
my($out);
$out .= '<div class="showcase-stock">' if !$no_box;
if ($is_dc) {
	return '' if !$withdrawn;
	$out .= $this->escape($this->{'withdrawnLabel'} || '');
} elsif ($default::static || $this->{'stockview'} eq 'menu') {
	return '' if !defined $availability || $availability eq '' || ref $this->{'stockAvailability'} ne 'ARRAY' || !defined $this->{'stockAvailability'}[$availability] || $this->{'stockAvailability'}[$availability] eq '';
	$out .= $this->{'stockAvailability'}[$availability];
} elsif ($this->{'stockview'} eq 'sync') {
	if (!defined $stock || $stock eq '') {
		return '';
	} elsif (defined $this->{'inStockBounds'} && $stock > $this->{'inStockBounds'}) {
		$out .= $this->{'abundantName'};
	} elsif (defined $this->{'inStockBounds'} && defined $this->{'limitedAvailabilityBounds'} && $stock <= $this->{'inStockBounds'} && $stock > $this->{'limitedAvailabilityBounds'}) {
		$out .= $this->{'inStockName'};
	} elsif (defined $this->{'limitedAvailabilityBounds'} && defined $this->{'outOfStockBounds'} && $stock <= $this->{'limitedAvailabilityBounds'} && $stock > $this->{'outOfStockBounds'}) {
		$out .= $this->{'limitedAvailabilityName'};
	} elsif (defined $this->{'outOfStockBounds'} && $stock <= $this->{'outOfStockBounds'}) {
		$out .= $this->{'outOfStockName'};
	} else {
		return '';
	}
} else {
	return '';
}
$out .= '</div>' if !$no_box;
return $out;
}

sub sc_quantity_tag ($$;$) {
my($this,$is_dc,$no_box) = @_;
my $out = '';
if (!$is_dc) {
	$out .= '<div class="showcase-quantity"><label>:' if !$no_box;
	$out .= '<input type="text" name="cart:quantity" size="3" value="1" />';
	$out .= '<span class="unit">' . $this->{'stockunit'} . '</span>' if $this->{'stockunit'};
	$out .= '</label></div>' if !$no_box;
} else {
	$out .= '<input type="hidden" name="cart:quantity" value="1" />';
}
return $out;
}

sub sc_option_menu ($$;$) {
my($this,$data,$no_box) = @_;
if (ref $data && defined $data->{'option'} && $data->{'option'} ne '') {
	my $id = 0;
	my $menu = '';
	while ($data->{'option'} =~ /^(.*)$/mg) {
		my $name = $1;
		my($mark,$optionprice) = ($name =~ s/:([\+\-]?)(\d+)$//) ? ($1,$2) : ('','');
		next if $name !~ /\S/;
		$id++;
		$menu .= '<option value="' . $id . '">' . $this->escape($name) . (($optionprice) ? '(' . (($mark) ? $mark : '+') . $this->digit($this->add_tax($optionprice)) . ')' : '') . '</option>';
	}
	return ($menu) ? ((!$no_box) ? '<div class="showcase-option">' : '') . '<select name="cart:option"' . (($data->{'multiple'}) ? ' size="' . (($id > 4) ? 5 : ($id+1)) . '" multiple="multiple"' : '') . '><option value="">' . (($default::english) ? '' : 'ʤ') . '</option>' . $menu . '</select>' . ((!$no_box) ? '</div>' : '') : '';
} else {
	return '';
}
}

sub sc_submit_button ($;$) {
my($this,$no_box) = @_;
my $out = '';
$out .= '<div class="showcase-submit">' if !$no_box;
$out .= $cgi::Deco->submit_button('cart',$this->{'button'},(($this->{'cartname'}) ? $this->{'cartname'} : 'Ȥ'),'','',$cgi::output_option);
$out .= '</div>' if !$no_box;
return $out;
}

sub sc_condition_tag ($$;$) {
my($this,$condition,$no_box) = @_;
$condition = $this->get_condition($condition);
return ((!$no_box) ? '<div class="showcase-condition">' : '')
	 . (($default::english) ? $condition : ($condition eq 'used') ? '' : ($condition eq 'refurbished') ? '' : '')
	 . ((!$no_box) ? '</div>' : '');
}

sub get_condition ($$) {
my($this,$condition) = @_;
$condition = $this->{'defaultcondition'} if $this->{'defaultconditionfixed'};
$condition = 'new' if !$condition || !grep($condition eq $_,'new','used','refurbished');
return $condition;
}

sub get_gdata ($$$) {
my($this,$guid,$data) = @_;
return () if !$guid || !$data || !ref $data;
$data = {$this->elements($data->{'str'})} if !defined $data->{'price'} && $data->{'str'};
return (!defined $data->{'price'}) ? () : (
	'g:id'			=>	$guid,
	'g:price'		=>	$data->{'price'},
	'g:condition'	=>	$this->get_condition($data->{'condition'}),
);
}

sub raw_price_info ($$$;$) {
my($this,$price,$unit,$title_flag) = @_;
if (!$env::tax_rate) {
	return '';
} elsif (defined $env::tax_included && $env::tax_included) {
	my($out);
	$out = ($title_flag) ? ' title="' : '(';
	$out .= ($default::english) ? '' : 'β:';
	$out .= $unit if $unit && $unit !~ /[\x80-\xff]/;
	$out .= $this->digit($price);
	$out .= $unit if $unit && $unit =~ /[\x80-\xff]/;
	$out .= ($title_flag) ? '"' : ')';
	return $out;
} else {
	return '';
}
}

sub add_tax ($$) {
my($this,$price) = @_;
if (!$env::tax_rate) {
	return $price;
} elsif (defined $env::tax_included && $env::tax_included) {
	$price = 0 if !$price || $price =~ /[^\d\.]/;
	if ($env::tax_frac eq 'floor') {
		return int($price * (1 + $env::tax_rate));
	} elsif ($env::tax_frac eq 'round') {
		return int(($price * (1 + $env::tax_rate)) + 0.5);
	} else {
		return int(($price * (1 + $env::tax_rate)) + 0.999);
	}
} else {
	return $price;
}
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
my($this,$str) = @_;
return '' if !defined $str || $str eq '' || ($this->{'pricehidden'} && $this->{'stockhidden'});
my(%data);
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
$str = $this->get_showcase_info(\%data);
return '' if !defined $str || $str eq '';
$str = '[' . $this->name . "]\x0A" . $str;
$str =~ s/[\x0A]*\Z/\x0A\x0A/s;
return $str;
}

sub get_showcase_info($$) {
my($this,$data) = @_;
my $out;
if (!defined $this->{'pricehidden'} ||  !$this->{'pricehidden'}) {
	$out .= $this->{'monetaryunit'} if $this->{'monetaryunit'} !~ /[\x80-\xff]/;
	$out .= $this->digit($$data{'price'});
	$out .= $this->{'monetaryunit'} if $this->{'monetaryunit'} =~ /[\x80-\xff]/;
}
if (!defined $this->{'stockhidden'} ||  !$this->{'stockhidden'}) {
	if (($default::static || $this->{'stockview'} eq 'menu') && defined $$data{'availability'} && $$data{'availability'} ne '' && ref $this->{'stockAvailability'} eq 'ARRAY' && defined $this->{'stockAvailability'}[$$data{'availability'}] && $this->{'stockAvailability'}[$$data{'availability'}] ne '') {
		$out .= '' if defined $out && $out ne '';
		$out .= $this->{'stockAvailability'}[$$data{'availability'}];
	}
	if (!$default::static && defined $$data{'stock'} && $$data{'stock'} ne '') {
		$out .= '' if defined $out && $out ne '';
		$out .= '߸ ';
		$out .= $this->digit($$data{'stock'});
		$out .= $this->{'stockunit'} if $this->{'stockunit'};
	}
}
return $out;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
my($this,$str) = @_;
return '' if !defined $str || $str eq '' || ($this->{'pricehidden'} && $this->{'stockhidden'});
my(%data);
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return $this->get_showcase_info(\%data);
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$;$$$) {
my($this,$str,$path,$c,$n) = @_;
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
my $is_dc = $this->is_digital_content(\%data);
my $out = '';
$out .= $this->digital_content_icon(\%data) if $is_dc;
$out .= $this->sc_price_tag($data{'price'},$this->{'monetaryunit'}) if !$this->{'pricehidden'};
#	$out .= $this->sc_point_tag($data{'point'},$data{'price'},$this->{'pointunit'}) if !$this->{'pointhidden'};
$out .= $this->sc_stock_tag($data{'availability'},$data{'stock'}) if !$this->{'stockhidden'} && !$is_dc;
$out .= $this->sc_condition_tag($data{'condition'}) if !$this->{'defaultconditionfixed'} && !$is_dc;
if (defined $data{'option'} && $data{'option'} ne '') {
	my $menu = '';
	while ($data{'option'} =~ /^(.*)$/mg) {
		my $name = $1;
		my($mark,$optionprice) = ($name =~ s/:([\+\-]?)(\d+)$//) ? ($1,$2) : ('','');
		next if $name !~ /\S/;
		$menu .= $this->escape($name) . (($optionprice) ? '(' . (($mark) ? $mark : '+') . $this->digit($this->add_tax($optionprice)) . ')' : '');
	}
	$out .= '<ol>' . $menu . '</ol>' if $menu;
}
return $out;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my $this = shift;

#̾
my $name = 'data:' . $this->{'id'};

#ǥե
$this->print_field_info_form($name);

print '<fieldset>';
print '<legend></legend>';
print '<table class="field-table">';
if (!$default::static) {
	print '<tbody>';
	print '<tr>';
	print '<td class="field-name"><span class="datatitle">եɽ</span></td>';
	print '<td class="field" colspan="3">';
	print '<label><select name="' . $name . '_formauthority">';
	print '<option value=""></option>';
	foreach (sort {$setting::security_name{$a} cmp $setting::security_name{$b}} keys %setting::security_name) {
		print '<option value="' . $_ . '"' . ((defined $this->{'formauthority'} && $this->{'formauthority'} eq $_) ? ' selected="selected"' : '') . '>' . $setting::security_name{$_} . '</option>';
	}
	print '</select> ¤硢ѹեɽ</label>';
	print '</td>';
	print '</tr>';
	print '<tr class="tbody-end">';
	print '<td class="field-name"><span class="datatitle"></span></td>';
	print '<td class="field" colspan="3">';
	print '<label><input type="checkbox" name="' . $name . '_mTime" value="1"' . (($this->{'mTime'}) ? ' checked="checked"' : '') . ' /> ѹ˹ǡ١򹹿</label>';
	print '</td>';
	print '</tr>';
	print '</tbody>';
}
print '<tbody>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">ɽ</span></td>';
print '<td class="q-field"><label><input type="checkbox" name="' . $name . '_pricehidden" value="1"' . ((defined $this->{'pricehidden'} && $this->{'pricehidden'}) ? ' checked="checked"' : '') . ' /> ɽ</label></td>';
print '<td class="field-name"><label for="' . $name . '_monetaryunit">ñ</label></td>';
print '<td class="q-field">';
print $this->mk_select_menu(
	$name . '_monetaryunit','','',$this->{'monetaryunit'},
	''		=>		'',
	'&yen;'		=>		'&yen;'
);
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><span class="datatitle">ʷٹ</span></td>';
print '<td class="field" colspan="3"><label>ʤ <input type="text" name="' . $name . '_pricelimit" value="' . $this->escape($this->{'pricelimit'}) . '" size="10" /> ̤λٹ𤹤</label></td>';
print '</tr>';
print '</tbody>';
print '<tbody class="physical-item">';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_stockunit">ȯñ</label></td>';
print '<td class="field" colspan="3"><input type="text" size="8" name="' . $name . '_stockunit" value="' . $this->escape($this->{'stockunit'}) . '" /></td>';
print '</tr>';
print '</tbody>';
#print '<tbody>';
#print '<tr class="tbody-end">';
#print '<td class="field-name"><span class="datatitle">ݥɽ</span></td>';
#print '<td class="q-field"><label><input type="checkbox" name="' . $name . '_pointhidden" value="1"' . ((defined $this->{'pointhidden'} && $this->{'pointhidden'}) ? ' checked="checked"' : '') . ' /> ɽ</label></td>';
#print '<td class="field-name"><label for="' . $name . '_pointunit">ݥñ</label></td>';
#print '<td class="q-field"><input type="text" size="8" name="' . $name . '_pointunit" id="' . $name . '_pointunit" value="' . $this->escape($this->{'pointunit'}) . '" /></td>';
#print '</tr>';
#print '<tr>';
#print '<td class="field-name"><span class="datatitle">ݥȷٹ</span></td>';
#print '<td class="field" colspan="3"><label>ݥΨ <input type="text" name="' . $name . '_pointlimit" value="' . $this->escape($this->{'pointlimit'}) . '" size="4" /> % 礭ٹ𤹤</label></td>';
#print '</tr>';
#print '</tbody>';
print '<tbody class="physical-item">';
print '<tr class="tbody-end">';
print '<td class="field-name"><span class="datatitle"></span></td>';
print '<td class="field" colspan="3"><label><input type="checkbox" name="' . $name . '_weightenabled" id="' . $name . '_weightenabled" value="1"' . ((defined $this->{'weightenabled'} && $this->{'weightenabled'}) ? ' checked="checked"' : '') . ' /> Ѥ(ɬ)</label></td>';
print '</tr>';
print '</tbody>';
#print '<tbody>';
#print '<tr>';
#print '<td class="field-name"><span class="datatitle">Ŀ</span></td>';
#print '<td class="field" colspan="3"><label><input type="checkbox" name="' . $name . '_quantityenabled" id="' . $name . '_quantityenabled" value="1"' . ((defined $this->{'quantityenabled'} && $this->{'quantityenabled'}) ? ' checked="checked"' : '') . ' /> Ѥ</label></td>';
#print '</tr>';
#print '</tbody>';
print '<tbody class="physical-item">';
print '<tr>';
print '<td class="field-name"><span class="datatitle">߸ɽ</span></td>';
print '<td class="field" colspan="3"><label><input type="checkbox" name="' . $name . '_stockhidden" id="' . $name . '_stockhidden" value="1"' . ((defined $this->{'stockhidden'} && $this->{'stockhidden'}) ? ' checked="checked"' : '') . ' /> ɽ</label></td>';
print '</tr>';

if (!$default::static) {
	print '<tr>';
	print '<td class="field-name"><span class="datatitle">߸ɽ</span></td>';
	print '<td class="field" colspan="3">';
	print '<fieldset><legend><label><input type="radio" name="' . $name . '_stockview" value="sync"' . ((defined $this->{'stockview'} && $this->{'stockview'} eq 'sync') ? ' checked="checked"' : '') . '> ߸˿Ϣư</label></legend>';
	require CMONOS::CGI_Lib::Table;
	my $table = Table->new;
	$table->set(
		'tableclass' => 'tooltable',
		'thenabled' => 'true',
		'trclass' => 'odd,even',
		'class0' => 'odd,even',
		'classF' => 'name',
		'style0' => 'text-align: center'
	);
	print $table->table;
	print $table->tr;
	print $table->td('');
	print $table->td('߸');
	print $table->td('ɽ');
	print $table->_tr;
	print $table->tr;
	print $table->td('߸˽');
	print $table->td('<span id="abundant_bounds">' . ((defined $this->{'inStockBounds'} && $this->{'inStockBounds'} ne '') ? $this->{'inStockBounds'} : '&lt;̤&gt;') . '</span>' . ((defined $this->{'stockunit'} && $this->{'stockunit'} ne '') ? $this->{'stockunit'} : '') . '¿');
	print $table->td('<input type="text" size="24" name="' . $name . '_abundantName" value="' . $this->escape($this->{'abundantName'}) . '" /> ');
	print $table->_tr;
	print $table->tr;
	print $table->td('߸̾');
	print $table->td('<input type="text" size="8" name="' . $name . '_inStockBounds" value="' . $this->escape($this->{'inStockBounds'}) . '" onchange="document.getElementById(\'abundant_bounds\').innerHTML = (this.value != \'\' && !isNaN(this.value)) ? this.value : \'&amp;lt;̤&amp;gt;\'; void(0)"  /> ' . ((defined $this->{'stockunit'} && $this->{'stockunit'} ne '') ? $this->{'stockunit'} : '') . 'ʲ');
	print $table->td('<input type="text" size="24" name="' . $name . '_inStockName" value="' . $this->escape($this->{'inStockName'}) . '" /> ');
	print $table->_tr;
	print $table->tr;
	print $table->td('߸˶Ͼ');
	print $table->td('<input type="text" size="8" name="' . $name . '_limitedAvailabilityBounds" value="' . $this->escape($this->{'limitedAvailabilityBounds'}) . '" /> ' . ((defined $this->{'stockunit'} && $this->{'stockunit'} ne '') ? $this->{'stockunit'} : '') . 'ʲ');
	print $table->td('<input type="text" size="24" name="' . $name . '_limitedAvailabilityName" value="' . $this->escape($this->{'limitedAvailabilityName'}) . '" /> ');
	print $table->_tr;
	print $table->tr;
	print $table->td('');
	print $table->td('<input type="text" size="8" name="' . $name . '_outOfStockBounds" value="' . $this->escape($this->{'outOfStockBounds'}) . '" /> ' . ((defined $this->{'stockunit'} && $this->{'stockunit'} ne '') ? $this->{'stockunit'} : '') . 'ʲ');
	print $table->td('<input type="text" size="24" name="' . $name . '_outOfStockName" value="' . $this->escape($this->{'outOfStockName'}) . '" /> ');
	print $table->_tr;
	print $table->_table;
	print '</fieldset><fieldset><legend><label><input type="radio" name="' . $name . '_stockview" value="menu"' . ((defined $this->{'stockview'} && $this->{'stockview'} eq 'menu') ? ' checked="checked"' : '') . '> ߸˾˥塼</label></legend>';
} else {
	print '<tr>';
	print '<td class="field-name"><label for="' . $name . '_stockmenu">߸˾˥塼</label></td>';
	print '<td class="field" colspan="3">';
}

print '<textarea name="' . $name . '_stockmenu" cols="56" rows="10" wrap="soft" title="߸˾˥塼ꤷޤ">' . $this->escape($this->{'stockmenu'}) . '</textarea>';
print '<div class="note">ܤȤ˲</div>';
print '<div class="note">Ƭ * = оݹ</div>';
print '</fieldset>' if !defined $default::static || !$default::static;
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><span class="datatitle">ץ</span></td>';
print '<td class="field" colspan="3"><ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_optionenabled" value="1"' . ((defined $this->{'optionenabled'} && $this->{'optionenabled'}) ? ' checked="checked"' : '') . ' /> ץ˥塼ǽˤ</label></li>';
print '</ol></td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';


print '<fieldset>';
print '<legend>ǥ륳ƥ</legend>';

if (!$env::subdirectory_disabled && !$env::user_site_template_dir) {
	my $digital_content_directory = $this->get_digital_content_directory_path;
	my $ftp_url = $this->get_digital_content_directory_ftp_url;
	print '<fieldset>';
	print '<legend><label><input type="checkbox" name="' . $name . '_digitalContentMenuEnabled" value="1"' . ((defined $this->{'digitalContentMenuEnabled'} && $this->{'digitalContentMenuEnabled'}) ? ' checked="checked"' : '') . ' /> ǥ륳ƥĥ˥塼</label></legend>';
	print '<p>ǥ륳ƥĤե򤷤ޤ</p>';

	print '<table class="field-table">';
	print '<tbody>';

	if ($this->set_dir($digital_content_directory)) {
		my $dir = $digital_content_directory;
		$dir =~ s!^(?:\.\./)+!~/!;
		print '<tr>';
		print '<td class="field-name"><span class="datatitle">ǥ륳ƥĥǥ쥯ȥΥѥ</span></td>';
		print '<td class="field">' . $dir . $this->ftp_url_fix . '</td>';
		print '</tr>';
		print '<tr>';
		print '<td class="field-name"><span class="datatitle">ǥ륳ƥĥǥ쥯ȥFTPɥ쥹(ư)</span></td>';
		print '<td class="field"><a href="' . $ftp_url . '">' . $ftp_url . '</a>' . $this->ftp_url_fix . '</td>';
		print '</tr>';
		print '<tr>';
		print '<td class="field-name"><label for="' . $name . '_ftpurl">ǥ륳ƥĥǥ쥯ȥFTPɥ쥹()</label></td>';
		print '<td class="field">ftp://<input type="text" name="' . $name . '_ftpurl" id="' . $name . '_ftpurl" value="' . $this->escape($this->{'ftpurl'}) . '" size="30" title="ư URL ְäƤ硢ǥե¸Ƥǥ쥯ȥURLꤷޤ" />' . $this->ftp_url_fix . '</td>';
		print '</tr>';
	}

	print '<tr>';
	print '<td class="field-name"><label for="' . $name . '_maxitem">ɽե</label></td>';
	print '<td class="field"> <input type="text" name="' . $name . '_maxitem" id="' . $name . '_maxitem" value="' . $this->escape($this->{'maxitem'}) . '" size="3" title="ǥե˥塼ɽեξ¤ꤷޤ" /> ĤΥե˥塼˴ޤ롣</td>';
	print '</tr>';

	print '</tbody></table>';
	print '</fieldset>';
}

print '<fieldset>';
print '<legend><label><input type="checkbox" name="' . $name . '_digitalContentUploadEnabled" value="1"' . ((defined $this->{'digitalContentUploadEnabled'} && $this->{'digitalContentUploadEnabled'}) ? ' checked="checked"' : '') . ' /> ǥ륳ƥĥåץ</label></legend>';
print '<p>ǥ륳ƥĤե륢åץɥեफ饢åץɤޤ</p>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label><input type="checkbox" name="' . $name . '_digitalContentRequired" value="1"' . ((defined $this->{'digitalContentRequired'} && $this->{'digitalContentRequired'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'tbody.physical-item\').disappear(this.checked);" /> ǥ륳ƥɬ</label></legend>';
print '<p>ǥ륳ƥĤ¸ߤʤ祫Ȥɽޤ</p>';
print '</fieldset>';
print $this->javascript('cmonos.element.item(\'tbody.physical-item\').disappear(true);') if $this->{'digitalContentRequired'};

print '<fieldset>';
print '<legend><label for="' . $name . '_mimetype">Ͽǽʥǥ륳ƥĤ MIME-TYPE</label></legend>';
print '<textarea name="' . $name . '_mimetype" id="' . $name . '_mimetype" cols="50" rows="6">' . $this->escape($this->{'mimetype'}) . '</textarea>';
print '<div class="note">MIME-TYPE:ĥ:եμ[]</div>';
print '<div class="example">image/jpeg:jpg:JPEG</div>';
print '<div class="hints">꤬ʤƤΥեϿޤ</div>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label for="' . $name . '_withdrawnLabel">ߡץ٥</label></legend>';
print '<input type="text" name="' . $name . '_withdrawnLabel" id="' . $name . '_withdrawnLabel" value="' . $this->escape($this->{'withdrawnLabel'}) . '" size="50" title="ߡץ٥ꤷޤ" />';
print '</fieldset>';

print '</fieldset>';


print '<fieldset>';
print '<legend>ܥ</legend>';
print '<fieldset>';
print '<legend>ȥ</legend>';
print $cgi::Deco->button_menu(
	$name . '_button',
	'cart',
	120,
	$this->{'button'},
);
print '</fieldset>';
if (!$default::static) {
	print '<fieldset>';
	print '<legend>ܥ</legend>';
	print $cgi::Deco->button_menu(
		$name . '_submitButton',
		'submit',
		120,
		$this->{'submitButton'},
	);
	print '</fieldset>';
}
print '</fieldset>';

print '<fieldset>';
print '<legend><label for="' . $name . '_template">ƥץ졼</label></legend>';
print '<textarea name="' . $name . '_template" id="' . $name . '_template" cols="72" rows="10" wrap="off" class="content-editor-area">' . $this->escape($this->{'template'}) . '</textarea>';
print '<div class="toolbox">';
print '<label class="auto-fit" title="⤵Ƥ˹碌"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'', $name, '_template\').setAutoFit(this.checked);" />եå</label> ';
print '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'' . $name . '_template\').quotationByMenu(this)" title="Υϡ񤭽ФбƥǡѴޤ">';
print '<option value="">åԥ󥰥ȥ</option>';
print '<option value="&lt;!--icon--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/icon--&gt;">ǥ륳ƥĥ &lt;!--icon--&gt;&lt;!--/icon--&gt;</option>';
print '<option value="&lt;!--price--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/price--&gt;"> &lt;!--price--&gt;&lt;!--/price--&gt;</option>';
#print '<option value="&lt;!--point--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/point--&gt;">ݥ &lt;!--point--&gt;&lt;!--/point--&gt;</option>';
print '<option value="&lt;!--stock--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/stock--&gt;">߸ &lt;!--stock--&gt;&lt;!--/stock--&gt;</option>';
print '<option value="&lt;!--condition--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/condition--&gt;"> &lt;!--condition--&gt;&lt;!--/condition--&gt;</option>';
print '<option value=""></option>';
print '<option value="&lt;!--quantity--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/quantity--&gt;">ȯ &lt;!--quantity--&gt;&lt;!--/quantity--&gt;</option>';
print '<option value="&lt;!--option--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/option--&gt;">ץ˥塼 &lt;!--option--&gt;&lt;!--/option--&gt;</option>';
print '<option value="&lt;!--button--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/button--&gt;">Ȥ ܥ &lt;!--button--&gt;&lt;!--/button--&gt;</option>';
print '</select>';

require CMONOS::CGI_Lib::HTMLHelper;
print HTMLHelper->new->html_helper_menu($name . '_template');

print '</div>';
print '</fieldset>';

print '<fieldset>';
print '<legend>ǥե</legend>';

print $this->input_form($name . '_default','default',$this,1);

print '</fieldset>';

$this->print_font_setting_form($name);
$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my $is_valid = $this->is_valid_font_setting;
if (defined $main::data{$this->{'id'} . '_pricelimit'} && $main::data{$this->{'id'} . '_pricelimit'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_pricelimit'})) {
	push(@{$cgi::action->{'dialog'}},'ʷٹоͤǤϤޤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_pricelimit'};
	$is_valid = 0;
}
#if (defined $main::data{$this->{'id'} . '_pointlimit'} && $main::data{$this->{'id'} . '_pointlimit'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_pointlimit'})) {
#	push(@{$cgi::action->{'dialog'}},'ݥȷٹоͤǤϤޤȾѿˤƤ') if ref $cgi::action;
#	delete $main::data{$this->{'id'} . '_pointlimit'};
#	$is_valid = 0;
#}
if (!defined $default::static ||  !$default::static) {
	if (defined $main::data{$this->{'id'} . '_inStockBounds'} && $main::data{$this->{'id'} . '_inStockBounds'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_inStockBounds'})) {
		push(@{$cgi::action->{'dialog'}},'߸̾Ȥʤ߸˾򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
		delete $main::data{$this->{'id'} . '_inStockBounds'};
		$is_valid = 0;
	}
	if (defined $main::data{$this->{'id'} . '_limitedAvailabilityBounds'} && $main::data{$this->{'id'} . '_limitedAvailabilityBounds'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_limitedAvailabilityBounds'})) {
		push(@{$cgi::action->{'dialog'}},'߸˶ϾȤʤ߸˾򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
		delete $main::data{$this->{'id'} . '_limitedAvailabilityBounds'};
		$is_valid = 0;
	}
	if (defined $main::data{$this->{'id'} . '_outOfStockBounds'} && $main::data{$this->{'id'} . '_outOfStockBounds'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_outOfStockBounds'})) {
		push(@{$cgi::action->{'dialog'}},'ߤȤʤ߸˾򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
		delete $main::data{$this->{'id'} . '_outOfStockBounds'};
		$is_valid = 0;
	}
	if (!defined $main::data{$this->{'id'} . '_inStockBounds'} || $main::data{$this->{'id'} . '_inStockBounds'} eq '' || !defined $main::data{$this->{'id'} . '_limitedAvailabilityBounds'} || $main::data{$this->{'id'} . '_limitedAvailabilityBounds'} eq '' || !defined $main::data{$this->{'id'} . '_outOfStockBounds'} || $main::data{$this->{'id'} . '_outOfStockBounds'} eq '') {
		push(@{$cgi::action->{'dialog'}},'߸˾򹹿ǤޤǤ٤Ƥκ߸˾ˤĤơ߸˾ꤷƤ') if ref $cgi::action;
		$main::data{$this->{'id'} . '_stockview'} = '';
		$is_valid = 0;
	} elsif ($main::data{$this->{'id'} . '_inStockBounds'} <= $main::data{$this->{'id'} . '_limitedAvailabilityBounds'} || $main::data{$this->{'id'} . '_limitedAvailabilityBounds'} <= $main::data{$this->{'id'} . '_outOfStockBounds'} || $main::data{$this->{'id'} . '_inStockBounds'} <= $main::data{$this->{'id'} . '_outOfStockBounds'}) {
		push(@{$cgi::action->{'dialog'}},'߸˾򹹿ǤޤǤ߸˾̷⤬ޤ') if ref $cgi::action;
		delete $main::data{$this->{'id'} . '_inStockBounds'};
		delete $main::data{$this->{'id'} . '_limitedAvailabilityBounds'};
		delete $main::data{$this->{'id'} . '_outOfStockBounds'};
		$is_valid = 0;
	}
	$this->tag_fix(\$main::data{$this->{'id'} . '_abundantName'}) if defined $main::data{$this->{'id'} . '_abundantName'} && $main::data{$this->{'id'} . '_abundantName'};
	$this->tag_fix(\$main::data{$this->{'id'} . '_inStockName'}) if defined $main::data{$this->{'id'} . '_inStockName'} && $main::data{$this->{'id'} . '_inStockName'};
	$this->tag_fix(\$main::data{$this->{'id'} . '_limitedAvailabilityName'}) if defined $main::data{$this->{'id'} . '_limitedAvailabilityName'} && $main::data{$this->{'id'} . '_limitedAvailabilityName'};
	$this->tag_fix(\$main::data{$this->{'id'} . '_outOfStockName'}) if defined $main::data{$this->{'id'} . '_outOfStockName'} && $main::data{$this->{'id'} . '_outOfStockName'};
}
if (defined $main::data{$this->{'id'} . '_defaultprice'} && $main::data{$this->{'id'} . '_defaultprice'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_defaultprice'})) {
	push(@{$cgi::action->{'dialog'}},'ʤΥǥեȤǤϤޤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_defaultprice'};
	$is_valid = 0;
}
if (defined $main::data{$this->{'id'} . '_defaultstock'} && $main::data{$this->{'id'} . '_defaultstock'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_defaultstock'})) {
	push(@{$cgi::action->{'dialog'}},'߸˿ΥǥեȤǤϤޤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_defaultstock'};
	$is_valid = 0;
}
$main::data{$this->{'id'} . '_mTime'} = '' if !defined $main::data{$this->{'id'} . '_mTime'} || !$main::data{$this->{'id'} . '_mTime'};
$main::data{$this->{'id'} . '_pricehidden'} = '' if !defined $main::data{$this->{'id'} . '_pricehidden'} || !$main::data{$this->{'id'} . '_pricehidden'};
$main::data{$this->{'id'} . '_stockhidden'} = '' if !defined $main::data{$this->{'id'} . '_stockhidden'} || !$main::data{$this->{'id'} . '_stockhidden'};
#$main::data{$this->{'id'} . '_pointhidden'} = '' if !defined $main::data{$this->{'id'} . '_pointhidden'} || !$main::data{$this->{'id'} . '_pointhidden'};
$main::data{$this->{'id'} . '_weightenabled'} = '' if !defined $main::data{$this->{'id'} . '_weightenabled'} || !$main::data{$this->{'id'} . '_weightenabled'};
#$main::data{$this->{'id'} . '_quantityenabled'} = '' if !defined $main::data{$this->{'id'} . '_quantityenabled'} || !$main::data{$this->{'id'} . '_quantityenabled'};
$main::data{$this->{'id'} . '_optionenabled'} = '' if !defined $main::data{$this->{'id'} . '_optionenabled'} || !$main::data{$this->{'id'} . '_optionenabled'};
$main::data{$this->{'id'} . '_defaultconditionfixed'} = '' if !defined $main::data{$this->{'id'} . '_defaultconditionfixed'} || !$main::data{$this->{'id'} . '_defaultconditionfixed'};

$main::data{$this->{'id'} . '_ftpurl'} = $this->z_to_h($main::data{$this->{'id'} . '_ftpurl'},'euc') if defined $main::data{$this->{'id'} . '_ftpurl'} && $main::data{$this->{'id'} . '_ftpurl'};
$main::data{$this->{'id'} . '_digitalContentMenuEnabled'} = '' if !defined $main::data{$this->{'id'} . '_digitalContentMenuEnabled'} || !$main::data{$this->{'id'} . '_digitalContentMenuEnabled'};
$main::data{$this->{'id'} . '_digitalContentUploadEnabled'} = '' if !defined $main::data{$this->{'id'} . '_digitalContentUploadEnabled'} || !$main::data{$this->{'id'} . '_digitalContentUploadEnabled'};
$main::data{$this->{'id'} . '_digitalContentRequired'} = '' if !defined $main::data{$this->{'id'} . '_digitalContentRequired'} || !$main::data{$this->{'id'} . '_digitalContentRequired'};
if (defined $main::data{$this->{'id'} . '_maxitem'} && $main::data{$this->{'id'} . '_maxitem'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_maxitem'})) {
	push(@{$cgi::action->{'dialog'}},'ɽե򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_maxitem'};
	$is_valid = 0;
}
if (!$main::data{$this->{'id'} . '_digitalContentMenuEnabled'} && !$main::data{$this->{'id'} . '_digitalContentUploadEnabled'} && $main::data{$this->{'id'} . '_digitalContentRequired'}) {
	push(@{$cgi::action->{'dialog'}},'ǥ륳ƥĤɬܤȤˤϡ֥ǥ륳ƥĥ˥塼פޤϡ֥ǥ륳ƥĥåץɡפͭǤɬפޤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_digitalContentRequired'};
	$is_valid = 0;
}
$this->detag(\$main::data{$this->{'id'} . '_mimetype'}) if defined $main::data{$this->{'id'} . '_mimetype'} && $main::data{$this->{'id'} . '_mimetype'};

$main::data{$this->{'id'} . '_defaultmultiple'} = '' if !defined $main::data{$this->{'id'} . '_defaultmultiple'} || !$main::data{$this->{'id'} . '_defaultmultiple'};
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
$this->tag_fix(\$main::data{$this->{'id'} . '_stockunit'}) if defined $main::data{$this->{'id'} . '_stockunit'} && $main::data{$this->{'id'} . '_stockunit'};
#$this->tag_fix(\$main::data{$this->{'id'} . '_pointunit'}) if defined $main::data{$this->{'id'} . '_pointunit'} && $main::data{$this->{'id'} . '_pointunit'};
return $is_valid;
}

######################################################################
sub search_form_enabled ($) {
my $this = shift;
return ($this->{'pricehidden'} && $this->{'stockhidden'}) ? 0 : 1;
}

#	(6) obj->search_form;
sub search_form ($) {
my $this = shift;
#return '' if $this->{'pricehidden'} && $this->{'pointhidden'} && $this->{'stockhidden'};
return '' if $this->{'pricehidden'} && $this->{'stockhidden'};
my($form);
$form = '<tr><td class="field-name"><span class="datatitle">' . $this->{'name'} . '</span></td><td class="field"><table class="sub-field-table">';
if (!$this->{'pricehidden'}) {
	$form .= '<tr><td class="sub-field-name">';
	$form .= (($default::english) ? '<span class="datatitle">Price</span> ' : '<span class="datatitle"></span> ');
	$form .= '</td><td class="sub-field">';
	$form .= $this->search_form_for_price($this);
	$form .= '</td></tr>';
}
#if (!defined $this->{'pointhidden'} ||  !$this->{'pointhidden'}) {
#	$form .= '<tr><td class="sub-field-name">';
#	$form .= (($default::english) ? '<span class="datatitle">Point</span> ' : '<span class="datatitle">ݥ</span> ');
#	$form .= '</td><td class="sub-field">';
#	$form .= $this->search_form_for_point($this);
#	$form .= '</td></tr>';
#}
if (!$this->{'stockhidden'}) {
	$form .= '<tr><td class="sub-field-name">';
	$form .= (($default::english) ? '<span class="datatitle">Stock</span> ' : '<span class="datatitle">߸˾</span> ');
	$form .= '</td><td class="sub-field">';
	$form .= $this->search_form_for_stock($this);
	$form .= '</td></tr>';
}
$form .= '</tbody></table></td></tr>';
return $form;
}

sub search_form_for_price ($$) {
my($this,$obj) = @_;
my($form);
$form .= '<label>';
$form .= '<span class="unit">From</span> ' if defined $default::english && $default::english;
$form .= '<span class="unit">' . $this->{'monetaryunit'} . '</span> ' if !defined $this->{'monetaryunit'} && $this->{'monetaryunit'} !~ /[\x80-\xff]/;
$form .= '<input type="text" size="10" name="search:' . $obj->{'id'} . ':f" value="' . $this->escape($main::search{$obj->{'id'}}{'f'}) . '" />';
$form .= ' <span class="unit">' . $this->{'monetaryunit'} . '</span>' if defined $this->{'monetaryunit'} && $this->{'monetaryunit'} =~ /[\x80-\xff]/;
$form .= ' <span class="unit">ʾ</span> ' if !defined $default::english || !$default::english;
$form .= '</label>';
$form .= '<label>';
$form .= ' <span class="unit">To</span> ' if defined $default::english && $default::english;
$form .= '<span class="unit">' . $this->{'monetaryunit'} . '</span> ' if !defined $this->{'monetaryunit'} && $this->{'monetaryunit'} !~ /[\x80-\xff]/;
$form .= '<input type="text" size="10" name="search:' . $obj->{'id'} . ':t" value="' . $this->escape($main::search{$obj->{'id'}}{'t'}) . '" />';
$form .= ' <span class="unit">' . $this->{'monetaryunit'} . '</span>' if defined $this->{'monetaryunit'} && $this->{'monetaryunit'} =~ /[\x80-\xff]/;
$form .= ' <span class="unit">ʲ</span>' if !defined $default::english || !$default::english;
$form .= '</label>';
return $form;
}

#sub search_form_for_point ($$) {
#my($this,$obj) = @_;
#my($form);
#$form .= '<label>';
#$form .= '<span class="unit">From</span> ' if defined $default::english && $default::english;
#$form .= '<input type="text" size="3" name="search:' . $obj->{'id'} . ':pf" value="' . $this->escape($main::search{$obj->{'id'}}{'pf'}) . '" />';
#$form .= ' <span class="unit">%</span>';
#$form .= ' <span class="unit">ʾ</span> ' if !defined $default::english || !$default::english;
#$form .= '</label>';
#$form .= '<label>';
#$form .= ' <span class="unit">To</span> ' if defined $default::english && $default::english;
#$form .= '<input type="text" size="3" name="search:' . $obj->{'id'} . ':pt" value="' . $this->escape($main::search{$obj->{'id'}}{'pt'}) . '" />';
#$form .= ' <span class="unit">%</span>';
#$form .= ' <span class="unit">ʲ</span>' if !defined $default::english || !$default::english;
#$form .= '</label>';
#return $form;
#}

sub search_form_for_stock ($$) {
my($this,$obj) = @_;
return $this->stock_availability_menu('search:' . $obj->{'id'} . ':stock',$main::search{$obj->{'id'}}{'stock'},1);
}

######################################################################
#sub import {
BEGIN {
#no warnings qw(once);
if ($env::checkout && -e $env::checkout && !$setting::field_for_mail && (!defined $default::type || $default::type eq '')) {
	$setting::deco_dir{'cart'} = '900:Ȥ ܥ';
	$setting::deco_type{'cart'} = 'button';
#	$setting::deco_dir{'login'} = '901:ܥ';
#	$setting::deco_type{'login'} = 'button';
#	$setting::deco_dir{'logout'} = '902:ȥܥ';
#	$setting::deco_type{'logout'} = 'button';
	$setting::deco_dir{'check'} = '903:Ȥ򸫤 ܥ';
	$setting::deco_type{'check'} = 'button';
	$setting::deco_dir{'submit'} = ' ܥ';
	$setting::deco_type{'submit'} = 'button';
	push(@field::redundancy_forbidden,'ysc_cart');
}
}

1;
