package ShoppingCartForDB;
require CMONOS::CGI_Lib::Field::ShoppingCartBase;
@ISA = qw(ShoppingCartBase);
use strict;
######################################################################
# ե⥸塼DBCGIѥåԥ󥰥ȡ
# ShoppingCartForDB.pm 1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-05-07
######################################################################
#	(11) obj->update;
sub update_enabled ($) {
my $this = shift;
return ($defalut::static) ? 0 : 1;
}

sub is_short_parameters ($) {
return 0;
}

sub is_secure_user_for_update ($) {
my $this = shift;
return ($defalut::static || $this->is_short_parameters || !defined $this->{'formauthority'} || $this->{'formauthority'} eq '' || !$this->is_secure($this->{'formauthority'})) ? 0 : 1;
}

sub update ($;$) {
my($this,$is_ajax) = @_;
return ($is_ajax) ? {
	'status'			=>	'error',
	'error_fields'		=>	$this->get_invalid_field_list('data:' . $this->{'id'}),
	'message'			=>	$this->get_message_string,
	'authorized_level'	=>	$this->get_authorized_level
} : 0 if !$this->is_valid_data; 
my(%db,$db,$n,$done,$msg);
$msg = '';
$db = $this->get_db_directory;
$n = $main::n;
$env::dbm_file = 'AnyDBM_File' if !defined $env::dbm_file ||  $env::dbm_file eq '';
$env::dbm_mode = 0666 if !defined $env::dbm_mode ||  $env::dbm_mode eq '';
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
tie(%db, $env::dbm_file, $db . '/showcase', O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %db) {
	my %data = $this->elements($db{$n});
	if ($data{'digitalcontent'} || (!$data{'digitalContentRequired'} && !$this->{'digitalContentRequired'})) {
		foreach my $k ('condition','availability','multiple','option','foldertype','digitalcontent','digitalContentRequired') {
			if (defined $data{$k}) {
				$data{$k} =~ s/\x0A/\&#10;/sg;
				$main::data{$this->{'id'}}{'str'} .= $k . ':' . $data{$k} . "\x0A";
			}
		}
		$db{$n} = $main::data{$this->{'id'}}{'str'};
		$done = 1;
	} else {
		$msg = 'ǥ륳ƥĤ¸ߤޤ';
	}
	undef %{$main::data{$this->{'id'}}};
	undef %main::data;
} else {
	$msg = 'ǡ١³ǤޤǤ';
}
untie %db;
if ($done) {
	$this->post_update;
	return ($is_ajax) ? {
		'status'			=>	'success',
		'reset_disabled'	=>	1,
		'authorized_level'	=>	$this->get_authorized_level
	} : 1;
} else {
	return ($is_ajax) ? {
		'status'			=>	'error',
		'message'			=>	$this->name(1) . ' ι˼Ԥޤ' . $msg,
		'authorized_level'	=>	$this->get_authorized_level
	} : 0;
}
}

sub editor_enabled ($) {
my $this = shift;
return 0;
}

sub is_secure_user_for_edit ($) {
my $this = shift;
return 0;
}

######################################################################
#	CMONOS::CGI_Lib::UserGeneratedField Υԡ
sub get_db_directory ($) {
my $this = shift;
return '.';
}

sub get_invalid_field_list ($$) {
my($this,$prefix) = @_;
my @invalid_fields = map {$prefix . ':' . $_} keys %{$this->{'is_invalid_field'}};
delete $this->{'is_invalid_field'};
return (@invalid_fields) ? join(';',@invalid_fields) : '';
}

sub get_message_string ($) {
my $this = shift;
if (ref $cgi::action) {
	my @message = $cgi::action->dialog;
	if (@message) {
		map {
			$_ =~ s/\\n//g;
			$_ =~ s/;//g;
		} @message;
		return join(';',@message);
	}
}
return '';
}

sub get_viewer_url ($;$$) {
my $this = shift;
return $this->my_url;
}

sub get_authorized_level ($) {
my $this = shift;
if ($this->is_master) {
	return 4;
} elsif ($this->is_owner) {
	return 3;
} elsif ($this->is_one_of_owners) {
	return 2;
} elsif ($this->is_registered_user) {
	return 1;
} else {
	return 0;
}
}

######################################################################
sub get_digital_content_directory_path ($) {
my $this = shift;
return $default::db . '/digital-content';
}



1;
