package UserGeneratedComment;
require CMONOS::CGI_Lib::Field::UserGeneratedField;
@ISA = qw(UserGeneratedField);
use strict;
use Fcntl qw(:flock);
######################################################################
# ե⥸塼ʥȡ
# UserGeneratedComment.pm 1.0.12
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
#support@cmonos.jp
#http://cmonos.jp/
#  ǽ2010-02-05
######################################################################
sub __set ($$) {
my($this,$setting) = @_;
if (!ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
$this->{'elements'} = 1;
if (!ref $cgi::Image) {
	require CMONOS::CGI_Lib::Image;
	$cgi::Image = Image->new;
}
if (!ref $cgi::UserAgent) {
	require CMONOS::CGI_Lib::UserAgent;
	$cgi::UserAgent = UserAgent->new;
}
$this->{'nameFieldName'} = (($default::english) ? 'Name' : '̾') if !defined $this->{'nameFieldName'} || $this->{'nameFieldName'} eq '';
$this->{'commentFieldName'} = (($default::english) ? 'Comment' : '') if !defined $this->{'commentFieldName'} || $this->{'commentFieldName'} eq '';
$this->{'titleFieldName'} = (($default::english) ? 'Title' : 'ȥ') if !defined $this->{'titleFieldName'} || $this->{'titleFieldName'} eq '';
$this->{'emailFieldName'} = (($default::english) ? 'E-Mail' : '᡼륢ɥ쥹') if !defined $this->{'emailFieldName'} || $this->{'emailFieldName'} eq '';
$this->{'urlFieldName'} = (($default::english) ? 'URL' : 'ۡڡ') if !defined $this->{'urlFieldName'} || $this->{'urlFieldName'} eq '';
$this->{'iconSelectorName'} = (($default::english) ? 'Icon' : '') if !defined $this->{'iconSelectorName'} || $this->{'iconSelectorName'} eq '';
$this->{'hiddenCheckboxName'} = (($default::english) ? 'Hide.' : '') if !defined $this->{'hiddenCheckboxName'} || $this->{'hiddenCheckboxName'} eq '';
$this->{'submitButtonName'} = (($default::english) ? 'Send' : '') if !defined $this->{'submitButtonName'} || $this->{'submitButtonName'} eq '';
$this->{'rememberCheckboxName'} = (($default::english) ? 'Remember Me' : '򵭲') if !defined $this->{'rememberCheckboxName'} || $this->{'rememberCheckboxName'} eq '';
$this->{'datetype'} = (($setting::general{'datetype'}) ? $setting::general{'datetype'} : '') if !$this->{'datetype'};
$this->{'size'} = 30 if !$this->{'size'};
$this->{'cols'} = 40 if !$this->{'cols'};
$this->{'rows'} = 3 if !$this->{'rows'};
$this->{'generatableUser'} = 'nocheck' if !$this->{'generatableUser'};
$this->{'fieldTable'} = 'dl' if !$this->{'fieldTable'};
$this->set_ownerpower;
$this->set_external_file_status;
return;
}

sub get_rss_name ($) {
my $this = shift;
return '';
}

sub get_comment_template ($;$) {
my($this,$frame_flag) = @_;
if (defined $this->{'template'} && $this->{'template'}) {
	my $template = $this->{'template'};
	if ($template =~ /<!--_tate(?!\w)[^>]*-->/) {
		require CMONOS::CGI_Lib::Taketori;
		$template = Taketori->new->tategaki_to_text($template);
	}
	if ($frame_flag && $template =~ /<!--frame(?!\w)[^>]*-->/ && ref $frame::obj{'frame'}) {
		require CMONOS::CGI_Lib::Frame;
		$template = Frame->new->text_to_frame($template,'no',$frame::obj{'frame'});
	}
	return $template;
} else {
return <<'TEMPLATE';
<div class="user-generated-comment">
<!--icon--><!--head--><div class="user-generated-comment-icon"><!--/head--><!--foot--></div><!--/foot--><!--/icon-->
<!--title--><!--head--><h4 class="user-generated-comment-head"><!--/head--><!--foot--></h4><!--/foot--><!--/title-->
<div class="user-generated-comment-body">
<!--comment--><!--head--><!--/head--><!--foot--><!--/foot--><!--/comment-->
</div>
<div class="user-generated-comment-info">
<strong><!--name--><!--/name--></strong>
<!--email--><!--head--> <!--/head--><!--foot--><!--/foot--><!--/email-->
<!--url--><!--head--> <!--/head--><!--foot--><!--/foot--><!--/url-->
<!--ctime--><!--head--> (<!--/head--><!--foot-->)<!--/foot--><!--/ctime-->
</div>
</div>
TEMPLATE
}
}

######################################################################
sub get_user_generated_field_data ($$$$;$$$) {
my($this,$memory,$data_ref,$path,$c,$n,$content_only) = @_;
my($dt,$_dt,$dd,$_dd,$submit_start,$submit_end);
my $approval_required = ($data_ref->{'approvalRequired'}) ? 1 : 0;
my $id = $this->mk_user_generated_field_id($c,$n);
my $template = $this->get_comment_template(1);
my $comment_count = 0;
my $memory_count = 0;
my $comment_content = '';
$memory = $this->{'masterMemory'} if $this->{'masterMemory'} && (!defined $memory || $memory eq '' || $memory > $this->{'masterMemory'});
$this->use_deco($this->get_output_path);
local(*DAT);
if (open(DAT, $path . '/' . $this->{'id'} . '.dat')) {
	binmode DAT;
	flock(DAT, LOCK_SH);
	my($head,$foot) = ('','');
	($head,$template,$foot) = ($1,$this->join_header_and_footer($2,$3),$4) if $template =~ /^(.*)<!--article(?!\w)([^>]*)-->(.*)<!--\/article-->(.*)$/s;
	while (my $line = <DAT>) {
		chomp $line;
		$memory_count++;
		$comment_content .= $this->replace_comment($template,$approval_required,[$this->svsplit("\x09",$line)],0,\$comment_count);
		last if $memory && $comment_count >= $memory;
	}
	close(DAT);
	$comment_content = $head . $comment_content . $foot if $comment_content;
}
if ($content_only) {
	$cgi::Deco->restore_output;
	return $comment_content;
}
my $comment = '<div id="' . $id . '" class="user-generated-comments">' . $comment_content . '</div>';
$comment .= '<p id="' . $id . '-info" class="user-generated-comments-info">';
$comment .= '<a href="javascript:void(0)" onclick="cmonos.element.item(\'' . $id . '\',\'' . $id . '-form\').toggle()">' . $this->name(1) . '<span id="' . $id . '-count">(' . $comment_count . ')</span>' . '</a>';
$comment .= $this->field_editor_link((($default::english) ? '[EDIT]' : '[Խ]'),$id . '-editor-link','display: none',$c,$n);
$comment .= '</p>';

my $external_file_disabled = (!$default::static && $this->{'update_is_failed'}) ? 1 : $this->{'externalFileDisabled'};
if ((!$external_file_disabled || $this->is_as_secure_as($this->{'generatableUser'})) && (!defined $memory || $memory eq '' || $memory_count < $memory)) {
	my $is_updated_record = ($external_file_disabled) ? $this->is_updated_record($c,$n) : 0;
	my $title_enabled = ($template =~ /<!--title(?!\w)[^>]*-->.*?<!--\/title-->/) ? 1 : 0;
	my $email_enabled = ($template =~ /<!--email(?!\w)[^>]*-->.*?<!--\/email-->/) ? 1 : 0;
	my $url_enabled = ($template =~ /<!--url(?!\w)[^>]*-->.*?<!--\/url-->/) ? 1 : 0;
	my $icon_enabled = ($this->{'dir'} && $template =~ /<!--icon(?!\w)[^>]*-->.*?<!--\/icon-->/) ? 1 : 0;
	$comment .= $this->form_start(
		'key'		=>	(($external_file_disabled && $setting::security_key) ? $setting::security_key : ''),
		'id'		=>	$id . '-form',
		'name'		=>	$id . '-form',
		'method'	=> 'post',
		'class'		=> 'user-generated-comment-form',
		'onsubmit'	=>	'return cmonos.form.item(this).submit(\'' . $id . '\',[\'comment:name\'' . (($email_enabled) ? ',\'comment:email\',\'comment:hidden\'' : '') . (($url_enabled) ? ',\'comment:url\'' : '') . (($icon_enabled) ? ',\'comment:icon\'' : '') . '],\'COMMENT\',\'' . $this->to_host($ENV{'SERVER_NAME'}) . '\',\'' . (($env::cookie_path) ? $env::cookie_path : $this->home_directory) . '\');',
		'required'	=>	$this->get_query_keys
	);
	$comment .= $this->add_query_for_form($c,$n);
	$comment .= $this->add_query('post',{'id' => $this->{'id'}});

	#ߡ
	$comment .= '<fieldset class="user-generated-content-input-form">';
	$comment .= 'Your Name : <input type="text" name="name" size="30" /><br />';
	$comment .= 'Your E-Mail : <input type="text" name="emailaddress" size="30" /><br />';
	$comment .= 'Your Url : <input type="text" name="url" size="30" /><br />';
	$comment .= 'Your Comment : <textarea name="comment" rows="3" cols="30"></textarea>';
	$comment .= '</fieldset>';

	$this->read_cookie('COMMENT') if $external_file_disabled && (!defined $main::comment{'name'} || $main::comment{'name'} eq '');

	if ($this->{'fieldTable'} && $this->{'fieldTable'} eq 'dl') {
		$comment .= '<dl class="field-dl">';
		$dt = '<dt>';
		$_dt = '</dt>';
		$dd = '<dd>';
		$_dd = '</dd>';
		$submit_start = '</dl><div class="user-generated-comment-submit">';
		$submit_end = '</div>';
	} else {
		$comment .= '<table class="field-table"><tbody>';
		$dt = '<tr><td class="field-name">';
		$_dt = '</td>';
		$dd = '<td class="field">';
		$_dd = '</td></tr>';
		$submit_start = '</tbody><tbody><tr><td class="submit-box" colspan="2">';
		$submit_end = '</td></tr></tbody></table>';
	}
	if ($title_enabled) {
		$comment .= $dt . '<label for="' . $id . '-title">' . $this->{'titleFieldName'} . '</label>' . $_dt;
		$comment .= $dd . '<input type="text" size="' . $this->{'size'} . '" id="' . $id . '-title" name="comment:title" value="' . (($is_updated_record) ? $this->escape($main::comment{'title'}) : '') . '"' . (($is_updated_record && $this->{'is_invalid_field'}{'title'}) ? ' class="invalid-field"' : '') . ' onchange="cmonos.validate.field(this).bailOut()" />' . $_dd;
	}
	$comment .= $dt . '<strong><label for="' . $id . '-name">' . $this->{'nameFieldName'} . '</label></strong>' . $_dt;
	$comment .= $dd . '<input type="text" size="' . $this->{'size'} . '" id="' . $id . '-name" name="comment:name" value="' . (($external_file_disabled) ? $this->escape($main::comment{'name'}) : '') . '" maxlength="' . $this->{'size'} . '"' . (($external_file_disabled && $this->{'is_invalid_field'}{'name'}) ? ' class="invalid-field"' : '') . ' onchange="cmonos.validate.field(this).asNotEmpty()" />' . $_dd;
	if ($email_enabled) {
		$comment .= $dt . '<label for="' . $id . '-email">' . $this->{'emailFieldName'} . '</label>' . $_dt;
		$comment .= $dd . '<input type="text" size="' . $this->{'size'} . '" id="' . $id . '-email" name="comment:email" value="' . (($external_file_disabled) ? $this->escape($main::comment{'email'}) : '') . '" onchange="cmonos.validate.field(this).asEMailAddress()"' . (($external_file_disabled && $this->{'is_invalid_field'}{'email'}) ? ' class="invalid-field"' : '') . ' />';
		$comment .= ' <label><input type="checkbox" name="comment:hidden" value="1"' . (($external_file_disabled && $main::comment{'hidden'}) ? ' checked="checked"' : '') . ' />' . $this->{'hiddenCheckboxName'} . ' </label>' . $_dd;
	}
	if ($url_enabled) {
		$comment .= $dt . '<label for="' . $id . '-url">' . $this->{'urlFieldName'} . '</label>' . $_dt;
		$comment .= $dd . '<input type="text" size="' . $this->{'size'} . '" id="' . $id . '-url" name="comment:url" value="' . (($external_file_disabled) ? $this->escape($main::comment{'url'}) : '') . '" onchange="cmonos.validate.field(this).asUrl()"' . (($external_file_disabled && $this->{'is_invalid_field'}{'url'}) ? ' class="invalid-field"' : '') . ' />' . $_dd;
	}
	if ($icon_enabled) {
		my $sample_id = $id . '-icon-sample';
		$comment .= $dt . '<label for="' . $id . '-icon">' . $this->{'iconSelectorName'} . '</label>' . $_dt;
		$comment .= $dd;
		$comment .= '<div class="user-generated-comment-icon-sample"><img id="' . $sample_id . '" name="' . $sample_id . '" src="' . (($external_file_disabled && defined $main::comment{'icon'} && $main::comment{'icon'} ne '') ? $main::comment{'icon'} : $this->path_change($env::spacer,$ENV{'SCRIPT_NAME'},'abs')) . '" alt="" /></div>';
		$comment .= $this->get_image_menu(
			'comment:icon',
			$id . '-icon',
			(($external_file_disabled) ? $main::comment{'icon'} : ''),
			$sample_id,
			(($external_file_disabled && $this->{'is_invalid_field'}{'icon'}) ? 1 : 0)
		);
		$comment .= $_dd;
	}
	$comment .= $dt . '<strong><label for="' . $id . '-comment">' . $this->{'commentFieldName'} . '</label></strong>' . $_dt;
	$comment .= $dd . '<textarea name="comment:comment" id="' . $id . '-comment" cols="' . $this->{'cols'} . '" rows="' . $this->{'rows'} . '"' . (($is_updated_record && $this->{'is_invalid_field'}{'comment'}) ? ' class="invalid-field"' : '') . ' onchange="cmonos.validate.field(this).asNotEmpty()">' . (($is_updated_record) ? $this->escape($main::comment{'comment'}) : '') . '</textarea>';
	$comment .= $this->textarea_tool('comment:comment','',$id . '-comment');
	$comment .= $_dd;
	$comment .= $submit_start;
	$comment .= '<label><input type="checkbox" name="set_cookie" value="1"' . (($external_file_disabled && ($cookie::read{'COMMENT'} || $main::set_cookie)) ? ' checked="checked"' : '') . ' />' . $this->{'rememberCheckboxName'} . '</label> ';
	$comment .= $cgi::Deco->submit_button('comment',$this->{'button'},$this->{'submitButtonName'},{'id' => $id . '-submit'},'','abs');
	$comment .= $submit_end;
	$comment .= '</form>';
	$comment .= $this->javascript('cmonos.form.item("' . $id . '-form").setDefaultValue("COMMENT-UTF8","' . $id . '-editor-link");' . (($this->{'hiddenComment'}) ? 'cmonos.element.item(\'' . $id . '\',\'' . $id . '-form\').toggle();' : ''));
} else {
	$comment .= '<form id="' . $id . '-form"></form>';
	$comment .= $this->javascript('cmonos.element.item(\'' . $id . '\').toggle();') if $this->{'hiddenComment'};
}
$cgi::Deco->restore_output;
return (wantarray) ? ($comment,$comment_content) : $comment;
}

sub replace_comment ($$$$;$$) {
my($this,$template,$approval_required,$data,$file_flag,$count) = @_;
my($id,$ctime,$approved,$comment,$name,$title,$email,$hidden,$url,$icon,$icon_width,$icon_height,$ip,$agent) = @$data;
return '' if !$file_flag && (!defined $comment || ($this->{'pendingEnabled'} && $approval_required && !$approved));
$$count++ if ref $count;
$email = ($hidden || !$email) ? '' : $cgi::Deco->button(
	'email',
	$this->{'emailButton'},
	$this->address_protector($email,$this->{'addressProtector'}),
	(($this->{'addressProtector'}) ? (($default::english || !$this->{'emailButton'}) ? 'E-Mail' : '᡼륽եȤ򳫤ޤ') : $this->address_camouflage($email)),
	'',
	'',
	'abs'
);
$url = (!$url) ? '' : $cgi::Deco->button(
	'jump',
	$this->{'urlButton'},
	$url,
	$url,
	'_blank',
	(($this->{'nofollow'}) ? {'rel' => 'nofollow'} : ''),
	'abs'
);
$icon = (!$icon) ? '' : $cgi::Image->image_tag(
	$this->path_change($icon,$ENV{'SCRIPT_NAME'},'abs'),
	$icon_width,
	$icon_height,
	$this->{'border'},
	$this->get_image_name($icon),
	'',
	$this->{'maxwidth'},
	$this->{'maxheight'}
);
$agent = $this->get_user_agent_info($agent);
$this->text_conv(\$title) if $title;
$this->text_conv(\$comment);
$this->text_fix(\$comment,$this->{'csv'});
$template =~ s/<\!--name(?!\w)([^>]*)-->(.*?)<\!--\/name(?!\w)[^>]*-->/$this->item_tag_replace('name',$1,$2,$name,$file_flag)/ges;
$template =~ s/<\!--email(?!\w)([^>]*)-->(.*?)<\!--\/email(?!\w)[^>]*-->/$this->item_tag_replace('email',$1,$2,$email,$file_flag)/ges;
$template =~ s/<\!--title(?!\w)([^>]*)-->(.*?)<\!--\/title(?!\w)[^>]*-->/$this->item_tag_replace('title',$1,$2,$title,$file_flag)/ges;
$template =~ s/<\!--url(?!\w)([^>]*)-->(.*?)<\!--\/url(?!\w)[^>]*-->/$this->item_tag_replace('url',$1,$2,$url,$file_flag)/ges;
$template =~ s/<\!--icon(?!\w)([^>]*)-->(.*?)<\!--\/icon(?!\w)[^>]*-->/$this->item_tag_replace('icon',$1,$2,$icon,$file_flag)/ges;
$template =~ s/<\!--ip(?!\w)([^>]*)-->(.*?)<\!--\/ip(?!\w)[^>]*-->/$this->item_tag_replace('ip',$1,$2,$ip,$file_flag)/ges;
$template =~ s/<\!--agent(?!\w)([^>]*)-->(.*?)<\!--\/agent(?!\w)[^>]*-->/$this->item_tag_replace('agent',$1,$2,$agent,$file_flag)/ges;
$template =~ s/<\!--ctime(?!\w)([^>]*)-->(.*?)<\!--\/ctime(?!\w)[^>]*-->/$this->datetime_tag_replace('ctime',$1,$2,$ctime,(($this->{'externalFileDisabled'}) ? $this->{'datelimit'} : 0),'gmt' . $this->{'datetype'},'',$file_flag)/ges;
$template =~ s/<\!--comment(?!\w)([^>]*)-->(.*?)<\!--\/comment(?!\w)[^>]*-->/$this->item_tag_replace('comment',$1,$2,$comment,$file_flag)/ges;
if ($template =~ /<!--tate(?!\w)[^>]*-->/) {
	require CMONOS::CGI_Lib::Taketori;
	$template = Taketori->new->text_to_tategaki($template,$file_flag);
}
return $template;
}

sub get_image_name ($$) {
my($this,$data) = @_;
$this->set_image_info_hash;
my $img = ($data =~ /([^\/]+)$/) ? $1 : '';
return ($this->{'image'}{$img}{'name'}) ? $this->{'image'}{$img}{'name'} : $img
}

#ե
sub get_image_menu ($$$;$$$) {
my($this,$name,$id,$default,$sample_id,$is_invalid_field) = @_;
return '' if !defined $this->{'dir'} || $this->{'dir'} eq '';
my($form,$dir,$file,%image);
local(*DIR,*NAME);
$dir = $env::image_dir . '/imagemenu/' . $this->{'dir'};
return '' unless opendir(DIR,$dir);
$dir .= '/';
while ($file = readdir(DIR)) {
	if ($file =~ /\.(gif|jpg|png)$/i && $file !~ /^\./ && -f $dir . $file) {
		$image{$file} = 1;
	}
}
closedir(DIR);
$form = '<select name="' . $name . '" id="' . (($id ne '') ? $id : $name) . '"' . (($is_invalid_field) ? ' class="invalid-field"' : '') . ((!$sample_id) ? ' multiple="multiple" onchange="cmonos.validate.field(this).bailOut()"' : ' onchange="cmonos.element.item(\'' . $sample_id . '\').setSrc(this.options[this.selectedIndex].value);cmonos.validate.field(this).bailOut()"') . '>';
$form .= '<option value="' . $this->path_change($env::spacer,$ENV{'SCRIPT_NAME'},'abs') . '"></option>' if $sample_id;
if (open(NAME,$dir . 'name.txt')) {
	my $line;
	while ($line = <NAME>) {
		chomp $line;
		next if $line !~ /:/;
		my($img,$name,$reserved) = split(/:/,$line,3);
		next if !defined $image{$img} || !$image{$img};
		delete $image{$img};
		my $path = $this->path_change($dir . $img,$ENV{'SCRIPT_NAME'},'abs');
		if ($reserved) {
			if ($this->{'externalFileDisabled'} && $this->is_one_of_owners) {
				$name = '*' . $name;
			} else {
				next;
			}
		}
		$form .= '<option value="' . $path . '"' . ((($default && !ref $default && $default eq $path) || (ref $default eq 'ARRAY' && grep($_ eq $path,@$default))) ? ' selected="selected"' : '') . '>' . $name . '</option>';
	}
	close(NAME);
}
foreach my $img (sort keys %image) {
	my $path = $this->path_change($dir . $img,$ENV{'SCRIPT_NAME'},'abs');
	$form .= '<option value="' . $path . '"' . ((ref $default eq 'ARRAY' && grep($_ eq $path,@$default)) ? ' selected="selected"' : '') . '>' . $img . '</option>';
}
$form .= '</select>';
return $form;
}

sub set_image_info_hash ($) {
my $this = shift;
return if ref $this->{'image'} || !defined $this->{'dir'} || $this->{'dir'} eq '';
local(*NAME);
if (open(NAME,$env::image_dir . '/imagemenu/' . $this->{'dir'} . '/' . 'name.txt')) {
	my($line);
	while ($line = <NAME>) {
		next if $line !~ /:/;
		chomp $line;
		my($img,$name,$reserved) = split(/:/,$line,3);
		if (defined $img && $img ne '') {
			$this->{'image'}{$img}{'name'} = $name;
			$this->{'image'}{$img}{'reserved'} = $reserved;
		}
	}
	close(NAME);
}
}

sub get_user_agent_info ($;$$) {
my($this,$user_agent,$rmtag) = @_;
my @info = $cgi::UserAgent->get_user_agent_info($user_agent);
$info[2] .= $info[3];
splice(@info,3,1);
shift @info;
@info = grep(defined $_ && $_ ne '',@info);
map($_ = $this->escape($_),@info);
return join('/',@info);
}

sub get_user_generated_field_data_for_text ($$$$) {
my($this,$memory,$data_ref,$path) = @_;
my $approval_required = ($data_ref->{'approvalRequired'}) ? 1 : 0;
my $out = '';
my $template = $this->get_comment_template(1);
my $title_enabled = ($template =~ /<!--title(?!\w)[^>]*-->.*?<!--\/title-->/) ? 1 : 0;
my $email_enabled = ($template =~ /<!--email(?!\w)[^>]*-->.*?<!--\/email-->/) ? 1 : 0;
my $url_enabled = ($template =~ /<!--url(?!\w)[^>]*-->.*?<!--\/url-->/) ? 1 : 0;
my $icon_enabled = ($this->{'dir'} && $template =~ /<!--icon(?!\w)[^>]*-->.*?<!--\/icon-->/) ? 1 : 0;
$memory = $this->{'masterMemory'} if $this->{'masterMemory'} && (!defined $memory || $memory eq '' || $memory > $this->{'masterMemory'});
local(*DAT);
if (open(DAT, $path . '/' . $this->{'id'} . '.dat')) {
	binmode DAT;
	flock(DAT, LOCK_SH);
	my $count;
	while (my $line = <DAT>) {
		chomp $line;
		my($id,$ctime,$approved,$comment,$name,$title,$email,$hidden,$url,$icon,$icon_width,$icon_height,$ip,$agent) = $this->svsplit("\x09",$line);
		if (!$this->{'pendingEnabled'} || !$approval_required || $approved) {
			$this->text_conv(\$title) if $title;
			$this->text_conv(\$comment);
			$out .= $this->detag($this->{'titleFieldName'}) . ' > ' . $title . "\x0A" if defined $title && $title ne '';
			$out .= $this->detag($this->{'nameFieldName'}) . ' > ' . $name . "\x0A";
			$out .= $this->detag($this->{'emailFieldName'}) . ' > ' . $email . "\x0A" if !$hidden && defined $email && $email;
			$out .= $this->detag($this->{'urlFieldName'}) . ' > ' . $url . "\x0A" if defined $url && $url;
			$out .= $this->detag($this->{'commentFieldName'}) . ' >' . "\x0A";
			$out .= $this->detag($comment) . "\x0A(" . $this->date($ctime,0,'gmt' . $this->{'datetype'}) . ")\x0A\x0A";
			$count++;
		}
		last if $memory && $count >= $memory;
	}
	close(DAT);
}
return ($out) ? $out : 'ޤ';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my $this = shift;

#̾
my $name = 'data:' . $this->{'id'};

$this->print_field_info_form($name);

print '<fieldset>';
print '<legend><label for="' . $name . '_template">ƥץ졼</label></legend>';
print '<textarea name="' . $name . '_template" id="' . $name . '_template" cols="72" rows="10" wrap="off" class="content-editor-area">' . $this->escape($this->{'template'}) . '</textarea>';
print '<div class="toolbox">';
print '<label class="auto-fit" title="⤵Ƥ˹碌"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'', $name, '_template\').setAutoFit(this.checked);" />եå</label> ';
print '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'' . $name . '_template\').quotationByMenu(this)" title="Υϡ񤭽ФбƥǡѴޤ">';
print '<option value="">ƥǡ</option>';
print '<option value="&lt;!--article--&gt;&lt;!--/article--&gt;">֤ϰ &lt;!--article--&gt;&lt;!--/article--&gt;</option>';
print '<option value="&lt;!--name--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/name--&gt;">̾ &lt;!--name--&gt;&lt;!--/name--&gt;</option>';
print '<option value="&lt;!--comment--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/comment--&gt;"> &lt;!--comment--&gt;&lt;!--/comment--&gt;</option>';
print '<option value="&lt;!--title--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/title--&gt;">ȥ &lt;!--title--&gt;&lt;!--/title--&gt;</option>';
print '<option value="&lt;!--email--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/email--&gt;">᡼륢ɥ쥹 &lt;!--email--&gt;&lt;!--/email--&gt;</option>';
print '<option value="&lt;!--url--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/url--&gt;">URL &lt;!--url--&gt;&lt;!--/url--&gt;</option>';
print '<option value="&lt;!--icon--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/icon--&gt;"> &lt;!--icon--&gt;&lt;!--/icon--&gt;</option>';
print '<option value="&lt;!--ip--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/ip--&gt;">Ƽ IP &lt;!--ip--&gt;&lt;!--/ip--&gt;</option>';
print '<option value="&lt;!--agent--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/agent--&gt;">ƼԴĶ &lt;!--agent--&gt;&lt;!--/agent--&gt;</option>';
print '<option value="&lt;!--ctime--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/ctime--&gt;"> &lt;!--ctime--&gt;&lt;!--/ctime--&gt;</option>';
print '<option value=""></option>';
print '<option value="' . $this->jsquot(
	'<div class="user-generated-comment">\n'
	. '<!--icon--><!--head--><div class="user-generated-comment-icon"><!--/head--><!--foot--></div><!--/foot--><!--/icon-->\n'
	. '<!--title--><!--head--><h4 class="user-generated-comment-head"><!--/head--><!--foot--></h4><!--/foot--><!--/title-->\n'
	. '<div class="user-generated-comment-body">\n'
	. '<!--comment--><!--/comment-->\n'
	. '</div>\n'
	. '<div class="user-generated-comment-info">\n'
	. '<strong><!--name--><!--/name--></strong>\n'
	. '<!--email--><!--head--> <!--/head--><!--foot--><!--/foot--><!--/email-->\n'
	. '<!--url--><!--head--> <!--/head--><!--foot--><!--/foot--><!--/url-->\n'
	. '<!--ctime--><!--head--> (<!--/head--><!--foot-->)<!--/foot--><!--/ctime-->\n'
	. '</div>\n'
	. '</div>\n'
) . '">ƥץ졼</option>';
print '<option value="' . $this->jsquot(
	'<dl class="log">\n'
	. '<!--article--><dt>\n'
	. '<!--icon--><!--head--><span class="icon"><!--/head--><!--foot--></span><!--/foot--><!--/icon-->\n'
	. '<span class="name"><!--name--><!--/name--></span>\n'
	. '<span class="date"><!--ctime--><!--/ctime--></span>\n'
	. '<!--email--><!--head--><span class="email"><!--/head--><!--foot--></span><!--/foot--><!--/email-->\n'
	. '<!--url--><!--head--><span class="url"><!--/head--><!--foot--></span><!--/foot--><!--/url-->\n'
	. '</dt>\n'
	. '<dd>\n'
	. '<!--comment--><!--/comment-->\n'
	. '</dd><!--/article-->\n'
	. '</dl>\n'
) . '">Vicuna CMS ߴƥץ졼</option>';
print '</select>';

require CMONOS::CGI_Lib::HTMLHelper;
print HTMLHelper->new->html_helper_menu($name . '_template');

if (ref $frame::obj{'frame'}) {
	my $sample = '';
	print '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'', $name, '_template\').quotationByMenu(this)" title="Υϡ񤭽Фбե졼Ѵޤ">';
	print '<option value="">ե졼ॿ</option>';
	foreach my $frid (sort {$a <=> $b} keys %{$frame::obj{'frame'}}) {
		$sample = $frid;
		print '<option value="&lt;!--frame id=&quot;', $frid, '&quot;--&gt;&lt;!--titlebar--&gt;&lt;!--/titlebar--&gt;&lt;!--contents--&gt;&lt;!--/contents--&gt;&lt;!--/frame--&gt;">ID : ', $frid, '</option>';
	}
	print '</select>';
	print '<div id="frame-tips"><label title="åȥե졼ॵץɽޤ"><input type="checkbox" onclick="cmonos.element.item(\'framesample\').disappear(!this.checked);" /> ե졼ॵץɽ</label> <div id="framesample" style="display: none">';
	print $cgi::Deco->frame_menu('','frame','','','ID');
	print '</div>';
	print '<label title="åȥե졼ॿνɽޤ"><input type="checkbox" onclick="cmonos.element.item(\'frametagsample\').disappear(!this.checked);" /> ե졼ॿνɽ</label> <table id="frametagsample" style="display: none"><tbody><tr><td id="sample-frame">';
	my($contents,$title) = ('<strong>ƥ</strong>','<strong>ȥ</strong>');
	print $cgi::Deco->frame('frame',$sample,\$contents,\$title,'no','',0,'type','frame','titlenowrap',1,'contentsnowrap',1);
	print '</td><td id="sample-tag">';
	print '&lt;!--frame id=&quot;<strong>ID</strong>&quot;--&gt;<br />&lt;!--titlebar--&gt;<strong>ȥ</strong>&lt;!--/titlebar--&gt;<br />&lt;!--contents--&gt;<strong>ƥ</strong>&lt;!--/contents--&gt;<br />&lt;!--/frame--&gt;';
	print '</td></tr></tbody></table>';
	print '</div>';
}

print '</div>';
print '</fieldset>';

print '<fieldset>';
print '<legend>̾/ܥ</legend>';
my $table = Table->new;
$table->set(
	'tableclass' => 'tooltable',
	'thenabled' => 'true',
	'trclass' => 'odd,even',
	'class0' => 'odd,even',
	'classF' => 'name',
	'style0' => 'text-align: center'
);
print $table->table;
print $table->tr;
print $table->td('');
print $table->td('̾');
print $table->td('/ܥ');
print $table->_tr;
print $table->tr;
print $table->td('̾');
print $table->td('<input type="text" size="24" name="' . $name . '_nameFieldName" value="' . $this->escape($this->{'nameFieldName'}) . '" />');
print $table->td('<input type="text" size="3" name="' . $name . '_size" value="' . $this->escape($this->{'size'}) . '" /> ʸ()');
print $table->_tr;
print $table->tr;
print $table->td('ȥ');
print $table->td('<input type="text" size="24" name="' . $name . '_titleFieldName" value="' . $this->escape($this->{'titleFieldName'}) . '" />');
print $table->td();
print $table->_tr;
print $table->tr;
print $table->td('᡼륢ɥ쥹');
print $table->td('<input type="text" size="24" name="' . $name . '_emailFieldName" value="' . $this->escape($this->{'emailFieldName'}) . '" />');
print $table->td(
	$cgi::Deco->button_menu(
		$name . '_emailButton',
		'email',
		120,
		$this->{'emailButton'}
	)
);
print $table->_tr;
print $table->tr;
print $table->td('ۡڡ');
print $table->td('<input type="text" size="24" name="' . $name . '_urlFieldName" value="' . $this->escape($this->{'urlFieldName'}) . '" />');
print $table->td(
	$cgi::Deco->button_menu(
		$name . '_urlButton',
		'jump',
		120,
		$this->{'urlButton'}
	)
);
print $table->_tr;
print $table->tr;
print $table->td('');
print $table->td('<input type="text" size="24" name="' . $name . '_iconSelectorName" value="' . $this->escape($this->{'iconSelectorName'}) . '" />');
print $table->td($this->icon_setting($name));
print $table->_tr;
print $table->tr;
print $table->td('');
print $table->td('<input type="text" size="24" name="' . $name . '_commentFieldName" value="' . $this->escape($this->{'commentFieldName'}) . '" />');
print $table->td(' <input type="text" size="3" name="' . $name . '_cols" value="' . $this->escape($this->{'cols'}) . '" /> ʸ  ⤵ <input type="text" size="3" name="' . $name . '_rows" value="' . $this->escape($this->{'rows'}) . '" /> ʸ');
print $table->_tr;
print $table->tr;
print $table->td('᡼륢ɥ쥹ɽ');
print $table->td('<input type="text" size="24" name="' . $name . '_hiddenCheckboxName" value="' . $this->escape($this->{'hiddenCheckboxName'}) . '" />');
print $table->td();
print $table->_tr;
print $table->tr;
print $table->td('ܥ');
print $table->td('<input type="text" size="24" name="' . $name . '_submitButtonName" value="' . $this->escape($this->{'submitButtonName'}) . '" />');
print $table->td(
	$cgi::Deco->button_menu(
		$name . '_button',
		'comment',
		120,
		$this->{'button'}
	)
);
print $table->_tr;
print $table->tr;
print $table->td('򵭲');
print $table->td('<input type="text" size="24" name="' . $name . '_rememberCheckboxName" value="' . $this->escape($this->{'rememberCheckboxName'}) . '" />');
print $table->td();
print $table->_tr;
print $table->_table;
print '</fieldset>';

print '<fieldset>';
print '<legend></legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_fieldTable">ɽ</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_fieldTable','ɽ','',$this->{'fieldTable'},
	'table'	=> 'ơ֥',
	'dl'	=> 'ꥹ'
);
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_masterMemory">Ⱥ¸</label></td>';
print '<td class="field"><input type="text" name="' . $name . '_masterMemory" id="' . $name . '_masterMemory" value="' . $this->escape($this->{'masterMemory'}) . '" size="3" title="Ƶͥ褹¸ꤷޤ" /> <span class="unit"></span></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_maxlength">Ⱥʸ</label></td>';
print '<td class="field"><input type="text" name="' . $name . '_maxlength" id="' . $name . '_maxlength" value="' . $this->escape($this->{'maxlength'}) . '" size="3" title="Ȥʸ¤ޤ" /> <span class="unit">ʸȾѡ</span></td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><span class="datatitle">ϥå</span></td>';
print '<td class="field"><label><input type="checkbox" name="' . $name . '_type" id="' . $name . '_type" value="j"' . (($this->{'type'} && $this->{'type'} eq 'j') ? ' checked="checked"' : '') . ' /> ܸʸɬ</label></td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_rule">Ϣ³</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_rule','Ϣ³','',$this->{'rule'},
	'0'	=> '¤ʤ',
	'1'	=> 'Ʊ IP Ϣ³Ƥ',
	'2'	=> ' IP Ϣ³Ƥ'
);
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_cancelLimit">´</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_cancelLimit','´','',$this->{'cancelLimit'},
	'0'			=> '̵',
	'86400'		=> '1',
	'259200'	=> '3',
	'604800'	=> '7',
	'1209600'	=> '14',
	'2592000'	=> '30',
	'5184000'	=> '60',
	'7776000'	=> '90'
);
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_generatableUser">ѥ</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_generatableUser','','',$this->{'generatableUser'},
	'master'	=>		'ޥ',
	'owner'		=>		'',
	'owners'	=>		'Ʊʡ',
	'member'	=>		'ϿС',
	'nocheck'	=>		'åʤ'
);
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">ɽΥߥ</span></td>';
print '<td class="field"><label><input type="checkbox" name="' . $name . '_pendingEnabled" id="' . $name . '_pendingEnabled" value="1"' . ((defined $this->{'pendingEnabled'} && $this->{'pendingEnabled'}) ? ' checked="checked"' : '') . ' /> ǧޤɽʤȤǽˤ</label></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><span class="datatitle"></span></td>';
print '<td class="field"><label><input type="checkbox" name="' . $name . '_hiddenComment" id="' . $name . '_hiddenComment" value="1"' . ((defined $this->{'hiddenComment'} && $this->{'hiddenComment'}) ? ' checked="checked"' : '') . ' /> ֤ǥȿΤɽ(ȿåǥȤɽ)</label></td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><span class="datatitle"></span></td>';
print '<td class="field"><ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_externalFileDisabled" id="' . $name . '_externalFileDisabled" value="1"' . ((defined $this->{'externalFileDisabled'} && $this->{'externalFileDisabled'}) ? ' checked="checked"' : '') . ' /> JavaScript ˤߤǤϤʤ褹 ( JavaScript եʤ)</label></li>' if !$default::static;
print '<li><label><input type="checkbox" name="' . $name . '_mTime" id="' . $name . '_mTime" value="1"' . ((defined $this->{'mTime'} && $this->{'mTime'}) ? ' checked="checked"' : '') . ' /> ƻ˹ǡ١򹹿</label></li>' if !$default::static;
print '<li><label><input type="checkbox" name="' . $name . '_nameCheck" id="' . $name . '_nameCheck" value="1"' . ((defined $this->{'nameCheck'} && $this->{'nameCheck'}) ? ' checked="checked"' : '') . ' /> ̾ʣåǡ١ϿϿѤߤ̾ȽʣƤʤå</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_nameRegister" id="' . $name . '_nameRegister" value="1"' . ((defined $this->{'nameRegister'} && $this->{'nameRegister'}) ? ' checked="checked"' : '') . ' /> ̾桼̾ǡ١Ͽ¾ CGI ѡ</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_rssEnabled" id="' . $name . '_rssEnabled" value="1"' . ((defined $this->{'rssEnabled'} && $this->{'rssEnabled'}) ? ' checked="checked"' : '') . ' />  RSS 򹹿</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_naviEnabled" id="' . $name . '_naviEnabled" value="1"' . ((defined $this->{'naviEnabled'} && $this->{'naviEnabled'}) ? ' checked="checked"' : '') . ' /> ǿȰ򹹿</label></li>';
print '</ol>';
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
if (!$default::static) {
	print '<tr>';
	print '<td class="field-name"><span class="datatitle">ɽ</span></td>';
	print '<td class="field"><label for="' . $name . '_datelimit"><input type="text" size="3" maxlength="3" name="' . $name . '_datelimit" id="' . $name . '_datelimit" value="' . $this->escape($this->{'datelimit'}) . '" /> ʤɽʤ礦/Τ/</label></td>';
	print '</tr>';
}
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_datetype">ɽ</label></td>';
print '<td class="field">';
$this->print_date_type_menu($name . '_',$this->{'datetype'});
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_mailtoMaster"></label></td>';
print '<td class="field">';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_mailtoMaster" id="' . $name . '_mailtoMaster" value="1"' . ((defined $this->{'mailtoMaster'} && $this->{'mailtoMaster'}) ? ' checked="checked"' : '') . ' />ͥɥ쥹</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_mailtoOwners" value="1"' . ((defined $this->{'mailtoOwners'} && $this->{'mailtoOwners'}) ? ' checked="checked"' : '') . ' />Ʊʡɥ쥹</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_mailToUser" value="1"' . ((defined $this->{'mailToUser'} && $this->{'mailToUser'}) ? ' checked="checked"' : '') . ' />桼ꥢɥ쥹</label></li>';
print '</ol>';
print '</td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

print '<fieldset>';
print '<legend></legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_taboowords">ػʸ</label></td>';
print '<td class="field"><textarea name="' . $name . '_taboowords" id="' . $name . '_taboowords" cols="56" rows="4" wrap="off">' . $this->escape($this->{'taboowords'}) . '</textarea>';
print '<div class="extra-field"><label><input type="checkbox" name="' . $name . '_tabooregexp" value="1"' . ((defined $this->{'tabooregexp'} && $this->{'tabooregexp'}) ? ' checked="checked"' : '') . ' /> ɽѤ</label></div>';
print '<div class="note">ػʸ󤴤Ȥ˲</div>';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_convtable">ʸѴɽ</label></td>';
print '<td class="field"><textarea name="' . $name . '_convtable" id="' . $name . '_convtable" cols="56" rows="4" wrap="off" title="񼰤˽äʸѴɽꤷޤ">' . $this->escape($this->{'convtable'}) . '</textarea>';
print '<div class="extra-field"><label><input type="checkbox" name="' . $name . '_convregexp" value="1"' . ((defined $this->{'convregexp'} && $this->{'convregexp'}) ? ' checked="checked"' : '') . ' /> ɽѤ</label></div>';
print '<div class="note">񼰡Ѵоʸ=&gt;Ѵʸ[]</div>';
print '<div class="example">ˡ=>ʶ/SPAM=>spamʸ</div>';
print '</td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

$this->print_html_tag_setting_form($name,'()');
$this->print_table_setting_form($name,'(ơ֥)');

print '<fieldset>';
print '<legend>Ͽ桼ˤ</legend>';
print '<label><input type="checkbox" name="' . $name . '_deletable" value="1"' . ((defined $this->{'deletable'} && $this->{'deletable'}) ? ' checked="checked"' : '') . ' /> Ͽ桼ˤ륳ȤκĤ</label>';
print '</fieldset>';

$this->print_setting_save_button;
}

sub icon_setting ($$) {
my($this,$name) = @_;
my $form = '<select name="' . $name . '_dir" id="' . $name . '_dir" title="ǥ쥯ȥ򤷤Ƥ">';
local(*DIR,*NAME);
if (opendir(DIR,$env::image_dir . '/imagemenu')) {
	my @dir = grep($_ !~ /^\./ && -d $env::image_dir . '/imagemenu/' . $_,readdir(DIR));
	closedir(DIR);
	my($dir_name);
	foreach $dir_name (@dir) {
		my($name);
		if (open(NAME,$env::image_dir . '/imagemenu/' . $dir_name . '/' . 'name.txt')) {
			$name = <NAME>;
			close(NAME);
			chomp $name;
		}
		$name = $dir_name if $name eq '' || $name =~ /:/;
		$form .= '<option value="' . $dir_name . '"' . ((defined $this->{'dir'} && $dir_name eq $this->{'dir'}) ? ' selected="selected"' : '') . '>' . $name . '</option>';
	}
}
$form .= '</select>';
return $form;
}

######################################################################
#	(6) obj->is_valid_setting;
sub _is_valid_sub_setting ($) {
my $this = shift;
my $is_valid = 1;
$this->tag_fix(\$main::data{$this->{'id'} . '_nameFieldName'}) if defined $main::data{$this->{'id'} . '_nameFieldName'} && $main::data{$this->{'id'} . '_nameFieldName'};
if (defined $main::data{$this->{'id'} . '_size'} && $main::data{$this->{'id'} . '_size'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_size'})) {
	push(@{$cgi::action->{'dialog'}},'󥵥򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_size'};
	$is_valid = 0;
}
$this->tag_fix(\$main::data{$this->{'id'} . '_titleFieldName'}) if defined $main::data{$this->{'id'} . '_titleFieldName'} && $main::data{$this->{'id'} . '_titleFieldName'};
$this->tag_fix(\$main::data{$this->{'id'} . '_emailFieldName'}) if defined $main::data{$this->{'id'} . '_emailFieldName'} && $main::data{$this->{'id'} . '_emailFieldName'};
$this->tag_fix(\$main::data{$this->{'id'} . '_urlFieldName'}) if defined $main::data{$this->{'id'} . '_urlFieldName'} && $main::data{$this->{'id'} . '_urlFieldName'};
$this->tag_fix(\$main::data{$this->{'id'} . '_iconSelectorName'}) if defined $main::data{$this->{'id'} . '_iconSelectorName'} && $main::data{$this->{'id'} . '_iconSelectorName'};
$this->tag_fix(\$main::data{$this->{'id'} . '_hiddenCheckboxName'}) if defined $main::data{$this->{'id'} . '_hiddenCheckboxName'} && $main::data{$this->{'id'} . '_hiddenCheckboxName'};
$this->escape(\$main::data{$this->{'id'} . '_submitButtonName'}) if defined $main::data{$this->{'id'} . '_submitButtonName'} && $main::data{$this->{'id'} . '_submitButtonName'};
$this->tag_fix(\$main::data{$this->{'id'} . '_rememberCheckboxName'}) if defined $main::data{$this->{'id'} . '_rememberCheckboxName'} && $main::data{$this->{'id'} . '_rememberCheckboxName'};

#åܥå
$main::data{$this->{'id'} . '_hiddenComment'} = '' if !defined $main::data{$this->{'id'} . '_hiddenComment'} || !$main::data{$this->{'id'} . '_hiddenComment'};
$main::data{$this->{'id'} . '_nameCheck'} = '' if !defined $main::data{$this->{'id'} . '_nameCheck'} || $main::data{$this->{'id'} . '_nameCheck'} eq '';
$main::data{$this->{'id'} . '_nameRegister'} = '' if !defined $main::data{$this->{'id'} . '_nameRegister'} || $main::data{$this->{'id'} . '_nameRegister'} eq '';
$main::data{$this->{'id'} . '_rssEnabled'} = '' if !defined $main::data{$this->{'id'} . '_rssEnabled'} || $main::data{$this->{'id'} . '_rssEnabled'} eq '';
$main::data{$this->{'id'} . '_naviEnabled'} = '' if !defined $main::data{$this->{'id'} . '_naviEnabled'} || $main::data{$this->{'id'} . '_naviEnabled'} eq '';
$main::data{$this->{'id'} . '_deletable'} = '' if !defined $main::data{$this->{'id'} . '_deletable'} || $main::data{$this->{'id'} . '_deletable'} eq '';

return $is_valid;
}

######################################################################
#	(11) obj->update;
sub update ($;$) {
my($this,$is_ajax) = @_;
my($input_is_valid);
$this->save_update_target;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};

#ϤΥå
$input_is_valid = 1;
$this->detag(\$main::comment{'name'},\$main::comment{'title'});

#ȾѴ
$main::comment{'email'} = $this->z_to_h($main::comment{'email'});
$main::comment{'url'} = $this->z_to_h($main::comment{'url'});

if ($main::name || !defined $main::comment{'name'} || $main::comment{'name'} eq '') {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please input your name.' : $this->{'nameFieldName'} . ' ϤƤޤ')) if ref $cgi::action;
	$this->{'is_invalid_field'}{'name'} = 1;
	$input_is_valid = 0;
} elsif ($this->{'nameCheck'} && $this->use_register) {
	if ($cgi::Register->is_available_name($main::pswd,$main::email,$main::comment{'name'},$security::registered,$is_ajax)) {
		push(@{$cgi::action->{'dialog'}},$cgi::Register->success_dialog) if ref $cgi::action;
	} else {
		push(@{$cgi::action->{'dialog'}},$cgi::Register->error_dialog) if ref $cgi::action;
		$this->{'is_invalid_field'}{'name'} = 1;
		$input_is_valid = 0;
	}
}
if ($main::emailaddress || (defined $main::comment{'email'} && $main::comment{'email'} ne '' && $this->is_invalid_email_address($main::comment{'email'}))) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please input your e-mail address correctly.' : $this->{'emailFieldName'} . ' ޤ')) if ref $cgi::action;
	$this->{'is_invalid_field'}{'email'} = 1;
	$input_is_valid = 0;
} elsif ($this->{'emailCheck'} && !$main::comment{'email'}) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please input your e-mail address.' : $this->{'emailFieldName'} . ' ϤƤޤ')) if ref $cgi::action;
	$this->{'is_invalid_field'}{'email'} = 1;
	$input_is_valid = 0;
}
if ($main::url || (defined $main::comment{'url'} && $main::comment{'url'} ne '' && $this->is_invalid_url($main::comment{'url'}))) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please input your home page url correctly.' : $this->{'urlFieldName'} . ' ޤ')) if ref $cgi::action;
	$this->{'is_invalid_field'}{'url'} = 1;
	$input_is_valid = 0;
}
if ($main::comment || !defined $main::comment{'comment'} || $main::comment{'comment'} eq '') {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please input your comment.' : $this->{'commentFieldName'} . ' ϤƤޤ')) if ref $cgi::action;
	$this->{'is_invalid_field'}{'comment'} = 1;
	$input_is_valid = 0;
} elsif ($this->{'type'} && $this->{'type'} eq 'j' && $this->is_not_japanese($main::comment{'comment'})) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please input your comment.' : $this->{'commentFieldName'} . ' ܸǤϤʤǽޤܸʸϤ䤷Ƥ')) if ref $cgi::action;
	$this->{'is_invalid_field'}{'comment'} = 1;
	$input_is_valid = 0;
} elsif ($this->is_taboo_string($main::comment{'comment'},$this->{'taboowords'},$this->{'tabooregexp'})) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please input your comment.' : $this->{'commentFieldName'} . ' ˶ػߤ줿礬¸ߤޤ')) if ref $cgi::action;
	$this->{'is_invalid_field'}{'comment'} = 1;
	$input_is_valid = 0;
} elsif ($this->{'maxlength'} && $this->{'maxlength'} < (length($main::comment{'comment'}) + (($main::comment{'title'}) ? length($main::comment{'title'}) : 0) + (($main::comment{'name'}) ? length($main::comment{'name'}) : 0))) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Your comment is too long.' : $this->{'commentFieldName'} . ' Ĺ᤮ޤ')) if ref $cgi::action;
	$this->{'is_invalid_field'}{'comment'} = 1;
	$input_is_valid = 0;
}

#ϥ顼
if (!$input_is_valid) {
	$this->{'update_is_failed'} = 1 if !$default::static && !$is_ajax;
	return ($is_ajax) ? {
		'status'			=>	'error',
		'error_fields'		=>	$this->get_invalid_field_list('comment'),
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level
	} : 0;
}

#Ǽɤ߹
my $setting = $this->get_field_data;
my $file_dir = $this->get_file_directory;
my $dat_path = $file_dir . '/' . $this->{'id'} . '.dat';

#Ǽĺ
if (!ref $setting || (defined $setting->{'memory'} && $setting->{'memory'} eq '0')) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! This bbs was closed.' : $this->name(1) . ' ĺƤޤ')) if ref $cgi::action;
	return ($is_ajax) ? {
		'status'			=>	'error',
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level
	} : 0;
}

#󥵥
my $icon_width = '';
my $icon_height = '';
my $icon_ext = '';
my $icon_size = '';
if ($main::comment{'icon'}) {
	my $icon_path = $this->path_change($main::comment{'icon'},$ENV{'SCRIPT_NAME'},'rel');
	if ($icon_path ne $env::spacer && -f $icon_path) {
		$icon_size = -s $icon_path;
		($icon_width,$icon_height,$icon_ext) = $cgi::Image->info($icon_path);
	}
	delete $main::comment{'icon'} if !$icon_width || !$icon_height;
}

#Υ
my $memory_count = 0;
my $last_comment_ip = '';
my $last_comment_ctime = 0;
my $last_id = 0;
my $approval_required = ($this->{'pendingEnabled'} && $setting->{'approvalRequired'}) ? 1 : 0;
local(*DAT);
if (open(DAT, $dat_path)) {
	binmode DAT;
	flock(DAT, LOCK_SH);
	my $last_comment = '';
	while (my $line = <DAT>) {
		chomp $line;
		if ($line) {
			$memory_count++;
			$last_comment = $line;
		}
	}
	close(DAT);
	if ($last_comment) {
		my @comment = $this->svsplit("\x09",$last_comment);
		$last_comment_ip = $comment[12] if $comment[12];
		$last_comment_ctime = $comment[1] if $comment[1];
		$last_id = $comment[0] if $comment[0];
	}
}

#ƽ
$last_comment_ip =~ s/\d+/\\d+/g if $last_comment_ip && $last_comment_ip =~ /\d/ && $last_comment_ip =~ /[^\.\d]/ && $this->{'rule'} && $this->{'rule'} == 2;
if ($this->{'rule'} == 0 || $last_comment_ip eq '' || $this->client_ip_is_matched($last_comment_ip) == 0 || ($this->{'cancelLimit'} > 0 && time - $last_comment_ctime > $this->{'cancelLimit'})) {
	my $memory = ($this->{'masterMemory'} && (!defined $setting->{'memory'} || $setting->{'memory'} eq '' || $setting->{'memory'} > $this->{'masterMemory'})) ? $this->{'masterMemory'} : $setting->{'memory'};
	$memory_count++;

	#Ǽĺ
	if (defined $memory && $memory ne '' && $memory_count > $memory) {
		push(@{$cgi::action->{'dialog'}},(($default::english) ? 'This bbs was closed.' : '¸ãΤǡʾ񤭹ळȤޤ')) if ref $cgi::action;
		return ($is_ajax) ? {
			'status'			=>	'error',
			'hide_form'			=>	'1',
			'message'			=>	$this->get_message_string,
			'authorized_level'	=>	$this->get_authorized_level
		} : 0;
	}

	#̾Ͽ
	$cgi::Register->user_name_register($main::pswd,$main::email,$main::comment{'name'},$security::registered) if $this->{'nameRegister'} && $this->use_register;

	#å
	if ($main::set_cookie) {
		$cookie::enabled = 1;
		$cookie::name = 'COMMENT';
		%cookie::data = (
			'comment:email' => ((defined $main::comment{'email'}) ? $main::comment{'email'} : ''),
			'comment:name' => ((defined $main::comment{'name'}) ? $main::comment{'name'} : ''),
			'comment:url' => ((defined $main::comment{'url'}) ? $main::comment{'url'} : ''),
			'comment:icon' => ((defined $main::comment{'icon'}) ? $main::comment{'icon'} : ''),
		);
		$cookie::enabled = 1 if $cookie::name && %cookie::data;		
	}

	my $viewer_url = $this->get_viewer_url($main::c,$main::n);
	my $editor_url = $this->get_user_generated_field_editor_url(1);
	my @new_comment = ();
	my $content = '';
	local(*DAT);
	if (open(DAT, ">>$dat_path")) {
		binmode DAT;
		flock(DAT, LOCK_EX);
		@new_comment = (
			($last_id + 1),
			time,
			(($approval_required) ? 0 : 1),
			$main::comment{'comment'},
			$main::comment{'name'},
			((defined $main::comment{'title'}) ? $main::comment{'title'} : ''),
			((defined $main::comment{'email'}) ? $main::comment{'email'} : ''),
			(($main::comment{'hidden'}) ? 1 : 0),
			((defined $main::comment{'url'}) ? $main::comment{'url'} : ''),
			((defined $main::comment{'icon'}) ? $main::comment{'icon'} : ''),
			$icon_width,
			$icon_height,
			$this->to_host($ENV{'REMOTE_ADDR'}),
			$ENV{'HTTP_USER_AGENT'}
		);
		print DAT $this->svjoin("\x09",@new_comment),"\x0A";
		close(DAT);
		chmod((($env::ownerpower) ? 0600 : $env::file_mode), $dat_path);
	} else {
		push(@{$cgi::action->{'dialog'}},'Ȥ¸˼Ԥޤ') if ref $cgi::action;
		$this->{'update_is_failed'} = 1 if !$default::static && !$is_ajax;
		return ($is_ajax) ? {
			'status'			=>	'error',
			'message'			=>	$this->get_message_string,
			'authorized_level'	=>	$this->get_authorized_level
		} : 0;
	}

	#Υ᡼
	if ($this->{'mailtoMaster'} || $this->{'mailtoOwners'} || ($this->{'mailToUser'} && $setting->{'mailto'} && $setting->{'mailto'} ne '')) {
		my $bcc = (($this->{'mailToUser'} && $setting->{'mailto'} && $setting->{'mailto'} ne '') ? $this->get_mail_field_data($setting->{'mailto'}) : '');
		$bcc .= (($bcc) ? ',' : '') . $setting::general{'master'} if defined $this->{'mailtoMaster'} && $this->{'mailtoMaster'} && $setting::general{'master'};
		$bcc .= (($bcc) ? ',' : '') . $setting::general{'owners'} if defined $this->{'mailtoOwners'} && $this->{'mailtoOwners'} && $setting::general{'owners'};
		if ($bcc) {
			unless (ref $cgi::SendMail) {
				require CMONOS::CGI_Lib::SendMail;
				$cgi::SendMail = SendMail->new(
					((defined $env::sendmail) ? $env::sendmail : ''),
					((defined $env::master_email) ? $env::master_email : ''),
					'',
					((ref $cgi::input) ? $cgi::input : ''),
					1
				);
			}
			my $msg = $this->name . '˿Ƥޤ' . "\x0A";
			$msg .= 'Ƥڡ : ' . $viewer_url . "\x0A";
			$msg .= 'Խġ : ' . $editor_url . "\x0A" if $approval_required;
			$msg .= "\x0A";
			$msg .= $this->detag($this->{'titleFieldName'}) . ' : ' . $main::comment{'title'} . "\x0A" if defined $main::comment{'title'} && $main::comment{'title'} ne '';
			$msg .= $this->detag($this->{'nameFieldName'}) . ' : ' . $main::comment{'name'} . "\x0A" if defined $main::comment{'name'} && $main::comment{'name'} ne '';
			$msg .= $this->detag($this->{'emailFieldName'}) . ' : ' . $main::comment{'email'} . "\x0A" if !$main::comment{'hidden'} && defined $main::comment{'email'} && $main::comment{'email'} ne '';
			$msg .= $this->detag($this->{'urlFieldName'}) . ' : ' . $main::comment{'url'} . "\x0A" if defined $main::comment{'url'} && $main::comment{'url'} ne '';
			$msg .= $this->detag($this->{'commentFieldName'}) . ' : ' . "\x0A" . $main::comment{'comment'} . "\x0A\x0A" if defined $main::comment{'comment'} && $main::comment{'comment'} ne '';
			$cgi::SendMail->send_mail(
				'Bcc'		=>  $bcc,
				'From'		=>  $env::master_email,
				'Subject'	=>  $this->{'name'} . '˿Ƥޤ',
				'message'	=>  $msg,
				'info'		=>	1
			);
			push(@{$this->{'dialog'}},$cgi::SendMail->dialog);
		}
	}
	if ($approval_required) {
		$this->save_pending_db($editor_url,$this->get_title_field_data);
		push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Thank you for your comment.' : $this->name(1) . ' ꤬Ȥޤ ' . $this->name(1) . ' Ƥǧ줿塢ɽޤ')) if ref $cgi::action;
		$memory_count = '';
	} else {
		$content = $this->set_embed_files($memory,$setting,$file_dir,$main::c,$main::n,1);
		my $comment = $main::comment{'comment'};
		my $title = $main::comment{'title'};
		$this->text_conv(\$title) if $title;
		$this->text_conv(\$comment);
		$this->text_fix(\$comment);
		$this->feed_field_rss(
			'comment',
			{
				'title'				=>	((defined $title) ? $title : ''),
				'link'				=>	$viewer_url,
				'content:encoded'	=>	$comment,
				'category'			=>	(($default::subdivided && defined $main::c && $main::c ne '' && $setting::general{'cginame'}) ? $setting::general{'cginame'} : ''),
				'enclosure'			=>	(($main::comment{'icon'}) ? {
											'url'		=>	$this->full_path($main::comment{'icon'}),
											'length'	=>	$icon_size,
											'type'		=>	(($Common::mime_type{$icon_ext}) ? $Common::mime_type{$icon_ext} : 'application/octet-stream')
										} : ''),
			}
		) if $this->{'rssEnabled'};
		$this->navi_update(\@new_comment,$viewer_url) if $this->{'naviEnabled'};
		$this->post_update;
		$main::comment{'comment'} = $main::comment{'title'} = '';
		push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Thank you for your comment.' : $this->name(1) . ' ꤬Ȥޤ')) if ref $cgi::action;
	}
	return ($is_ajax) ? {
		'status'			=>	'success',
		'content'			=>	(($approval_required) ? '' : $content),
		#'new_content'		=>	(($approval_required) ? '' : $this->replace_comment($this->get_comment_template(1),$setting->{'approvalRequired'},\@new_comment)),
		'new_count'			=>	$memory_count,
		'hide_form'			=>	(($memory && $memory_count && $memory_count >= $memory) ? '1' : ''),
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level
	} : 1;

} else {
	push(@{$cgi::action->{'dialog'}},'Ϣ³ƤϤθ') if ref $cgi::action;
	$this->{'update_is_failed'} = 1 if !$default::static && !$is_ajax;
	return ($is_ajax) ? {
		'status'			=>	'error',
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level
	} : 0;
}
}

sub get_navi_info ($) {
my $this = shift;
return('recentcomments','recentcomments.ssi','recentCommentsTemplate');
}

sub mk_recent_items_article ($$$;$) {
my($this,$comment_array,$template,$url) = @_;
if ($url) {
	$url = $this->escape($url);
	my @comment_data = @$comment_array;
	my $title = $this->get_title_field_data;
	$title = $this->escape($setting::general{'cginame'} . (($setting::general{'cginame'} && $title) ? ' > ' : '') . $title); 
	$title = ' title="' . $title . '"' if $title; 
	if ($template =~ /<!--title(?!\w)[^>]*-->.*?<!--\/title-->/s) {
		if (defined $comment_data[5] && $comment_data[5] ne '') {
			$comment_data[5] = '<a href="' . $url . '"' . $title . '>' . $this->detag_text($comment_data[5]) . '</a>';
		} elsif ($template =~ /<!--comment(?!\w)[^>]*-->.*?<!--\/comment-->/) {
			$comment_data[3] = '<a href="' . $url . '"' . $title . '>' . $this->detag_text($comment_data[3]) . '</a>';
		} else {
			$comment_data[5] = '<a href="' . $url . '"' . $title . '>' . $this->detag_text($comment_data[3]) . '</a>';
		}
	} else {
		$comment_data[3] = '<a href="' . $url . '"' . $title . '>' . $this->detag_text($comment_data[3]) . '</a>';
	}
	return $this->replace_comment($template,0,\@comment_data,1);
} else {
	return $this->replace_comment($template,0,$comment_array,1);
}
}

sub get_array_from_template ($$) {
my($this,$template) = @_;
my $comment = $this->get_hash_from_template($template);
if ($comment->{'icon'} && $comment->{'icon'} =~ /<img(?!\w)([^>]+)>/) {
	my $icon_info = $1;
	$comment->{'icon'} = ($icon_info =~ /\s+src="(.*?)"/) ? $1 : '';
	$comment->{'icon_width'} = ($icon_info =~ /\s+width="(.*?)"/) ? $1 : '';
	$comment->{'icon_height'} = ($icon_info =~ /\s+height="(.*?)"/) ? $1 : '';
}
return [
	'',
	((defined $comment->{'ctime'} && !ref $comment->{'ctime'}) ? $comment->{'ctime'} : ''),
	1,
	((defined $comment->{'comment'} && !ref $comment->{'comment'}) ? $comment->{'comment'} : ''),
	((defined $comment->{'name'} && !ref $comment->{'name'}) ? $comment->{'name'} : ''),
	((defined $comment->{'title'} && !ref $comment->{'title'}) ? $comment->{'title'} : ''),
	((defined $comment->{'email'} && !ref $comment->{'email'}) ? $comment->{'email'} : ''),
	'',
	((defined $comment->{'url'} && !ref $comment->{'url'}) ? $comment->{'url'} : ''),
	((defined $comment->{'icon'} && !ref $comment->{'icon'}) ? $comment->{'icon'} : ''),
	((defined $comment->{'icon_width'} && !ref $comment->{'icon_width'}) ? $comment->{'icon_width'} : ''),
	((defined $comment->{'icon_height'} && !ref $comment->{'icon_height'}) ? $comment->{'icon_height'} : ''),
	((defined $comment->{'ip'} && !ref $comment->{'ip'}) ? $comment->{'ip'} : ''),
	((defined $comment->{'agent'} && !ref $comment->{'agent'}) ? $comment->{'agent'} : '')
];
}

######################################################################
sub set_user_generated_field_editor_page_settings ($) {
my $this = shift;
	$setting::page{'ugfieldeditor'}{'title'} = $this->detag($this->get_title_field_data);
#	$setting::page{'ugfieldeditor'}{'text'} = '#000000'; 
#	$setting::page{'ugfieldeditor'}{'link'} = '#0000ff';
#	$setting::page{'ugfieldeditor'}{'alink'} = '#99ffff';
#	$setting::page{'ugfieldeditor'}{'vlink'} = '#000099';
#	$setting::page{'ugfieldeditor'}{'hover'} = '#00ffff';
#	$setting::page{'ugfieldeditor'}{'nodeco'} = 'no';
#	$setting::page{'ugfieldeditor'}{'bgcolor'} = '#ffffff';
	$setting::page{'ugfieldeditor'}{'bodyId'} = 'comment-editor';
	$setting::page{'ugfieldeditor'}{'cssFileName'} = 'comment-editor.css';
# 	$setting::page{'ugfieldeditor'}{'CSS'} = 'h1 { font-size: large; font-weight: bold; text-indent: 1em; font-family: "ҥ饮γѥ Pro W3",Osaka,"ͣ Хå",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'h2 { font-size: medium; font-weight: bold; font-family: "ҥ饮γѥ Pro W3",Osaka,"ͣ Хå",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'hr { border-width: 1 0 0 0; }';
# 	$setting::page{'ugfieldeditor'}{'background'} = '';
# 	$setting::page{'ugfieldeditor'}{'bgproperties'} = '';
# 	$setting::page{'ugfieldeditor'}{'topmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'leftmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'javascript'} = '';
# 	$setting::page{'ugfieldeditor'}{'header'} = '';
# 	$setting::page{'ugfieldeditor'}{'headerFileName'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImageAlign'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImage'} = '';
# 	$setting::page{'ugfieldeditor'}{'align'} = '';
# 	$setting::page{'ugfieldeditor'}{'width'} = '';
# 	$setting::page{'ugfieldeditor'}{'deco'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleText'} = '';
return 1;
}

sub user_generated_field_edit ($) {
my $this = shift;
return 0 if !$this->is_editable;
local(*DAT,*TEMP);
my $done = 0;
my $last_deleted_id = '';
my $last_id = '';
my @last_approved_comment;
my $delete_list = '';
my $temp_path = $this->{'file_directory'} . '/' . $this->{'id'} . '.temp.dat';
if (open(TEMP, ">>$temp_path")) {
	binmode TEMP;
	flock(TEMP, LOCK_EX);
	truncate(TEMP, 0);
	seek(TEMP, 0, 0);
	if (open(DAT, $this->{'dat_path'})) {
		binmode DAT;
		flock(DAT, LOCK_SH);
		my $line;
		while ($line = <DAT>) {
			chomp $line;
			my @data = $this->svsplit("\x09",$line);
			$last_id = $data[0] if !$this->{'pendingEnabled'} || !$this->{'field_data'}->{'approvalRequired'} || $data[2];
			if ($main::data{$data[0]} && (!$this->{'delete_only'} || ($main::data{$data[0]} eq 'delete' && $data[6] && $main::email && $data[6] eq $main::email))) {
				if ($main::data{$data[0]} eq 'delete') {
					$last_deleted_id = $data[0];
					next;
				} elsif ($this->{'pendingEnabled'} && $this->{'field_data'}->{'approvalRequired'}) {
					if ($main::data{$data[0]} eq 'approve') {
						@last_approved_comment = @data if !$data[2];
						$data[2] = 1; 
					} else {
						$last_deleted_id = $data[0] if $data[2];
						$data[2] = 0; 
					}
				} else {
					$data[2] = 1;
				}
				print TEMP $this->svjoin("\x09",@data),"\x0A";
			} else {
				print TEMP $line,"\x0A";
			}
		}
		close(DAT);
		$done = 1;
	}
	close(TEMP);
}
if ($done) {
	rename($temp_path,$this->{'dat_path'});
	chmod((($env::ownerpower) ? 0600 : $env::file_mode), $this->{'dat_path'});
}
if (@last_approved_comment || $last_deleted_id) {
	my $viewer_url = $this->get_viewer_url($main::c,$main::n);
	$this->set_embed_files($this->{'field_data'}->{'memory'},$this->{'field_data'},$this->{'file_directory'},$main::c,$main::n);
	if (@last_approved_comment) {
		my $icon_ext = '';
		my $icon_size = '';
		if ($last_approved_comment[9]) {
			my $icon_path = $this->path_change($last_approved_comment[9],$ENV{'SCRIPT_NAME'},'rel');
			$icon_size = -s $icon_path if $icon_path ne $env::spacer && -f $icon_path;
			$icon_ext = $1 if $last_approved_comment[9] =~ /\.(\w+)$/;
		}
		my $comment = $last_approved_comment[3];
		my $title = $last_approved_comment[5];
		$this->text_conv(\$title) if $title;
		$this->text_conv(\$comment);
		$this->text_fix(\$comment);
		$this->feed_field_rss(
			'comment',
			{
				'title'				=>	(($title ne '') ? $title : ''),
				'link'				=>	$viewer_url,
				'content:encoded'	=>	$comment,
				'category'			=>	(($default::subdivided && defined $main::c && $main::c ne '' && $setting::general{'cginame'}) ? $setting::general{'cginame'} : ''),
				'enclosure'			=>	(($last_approved_comment[9]) ? {
											'url'		=>	$this->full_path($last_approved_comment[9]),
											'length'	=>	$icon_size,
											'type'		=>	(($Common::mime_type{$icon_ext}) ? $Common::mime_type{$icon_ext} : 'application/octet-stream')
										} : '')
			}
		) if $this->{'rssEnabled'};
		$this->navi_update(\@last_approved_comment,$viewer_url) if $this->{'naviEnabled'};
		$this->post_update;
	} elsif ($last_id eq $last_deleted_id) {
		$this->navi_update('','',1) if $this->{'naviEnabled'};
		$this->delete_field_rss_item('comment',$viewer_url);
		$this->post_update(1);
	} else {
		$this->post_update(1);
	}
}
return 1;
}

sub print_user_generated_field_editor ($) {
my $this = shift;
$this->mk_settings_for_editor;
my $javascript = <<'SCRIPT';
function classChange (target_id,class_name,flag) {
	if (flag) document.getElementById(target_id).className = class_name;
}
SCRIPT
$cgi::action->set_javascript($javascript);
undef $javascript;
$cgi::action->print_page_header('ugfieldeditor','','',0,'',$this->name . 'Խ');
print $this->form_start(
	'key'	=>	'ugfieldeditor',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=>	'return cmonos.form.item(this).isNotSubmitted()'
);
print $this->get_query_for_user_generated_field_editor(1);
print '<input type="hidden" name="action" value="edit" />';
local(*DAT);
if (open(DAT, $this->{'dat_path'})) {
	binmode DAT;
	flock(DAT, LOCK_SH);
	while (my $line = <DAT>) {
		chomp $line;
		my($id,$ctime,$approved,$comment,$name,$title,$email,$hidden,$url,$icon,$icon_width,$icon_height,$ip,$agent) = $this->svsplit("\x09",$line);
		if (!$this->{'delete_only'} || ($email && $main::email && $email eq $main::email)) {
			print '<div class="' . (($this->{'pendingEnabled'} && $this->{'field_data'}->{'approvalRequired'} && !$approved) ? 'pending-comment' : 'approved-comment') . '" id="comment-' . $id . '">';
			print '<div class="controller">';
			print '<label><input type="radio" name="data:' . $id . '" value="' . (($approved) ? '' : 'approve') . '"' . ((!$this->{'pendingEnabled'} || !$this->{'field_data'}->{'approvalRequired'} || $approved) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'comment-' . $id . '\').changeClassName(\'approved-comment\',this.checked);" />ǧ</label>' if !$this->{'delete_only'} || !$this->{'pendingEnabled'} || !$this->{'field_data'}->{'approvalRequired'} || $approved;
			print ' <label><input type="radio" name="data:' . $id . '" value="' . ((!$approved) ? '' : 'pending') . '"' . ((!$approved) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'comment-' . $id . '\').changeClassName(\'pending-comment\',this.checked);" />α</label>' if $this->{'pendingEnabled'} && $this->{'field_data'}->{'approvalRequired'} && (!$this->{'delete_only'} || !$approved);
			print ' <label><input type="radio" name="data:' . $id . '" value="delete" onclick="cmonos.element.item(\'comment-' . $id . '\').changeClassName(\'delete-comment\',this.checked);" /></label>';
			print '</div>';
			$icon = (!$icon) ? '' : $cgi::Image->image_tag(
				$icon,
				$icon_width,
				$icon_height,
				$this->{'border'},
				$this->get_image_name($icon),
				'',
				$this->{'maxwidth'},
				$this->{'maxheight'}
			);
			$this->text_conv(\$title) if $title;
			$this->text_conv(\$comment);
			$this->text_fix(\$comment,$this->{'csv'});
			print '<div class="comment">';
			print '<div class="comment-icon">' . $icon . '</div>' if $icon ne '';
			print '<h1>' . $title . '(' . $id . ')</h1>';
			print '<div class="comment-author">' . $name . (($email) ? ' &lt;' . $email . '&gt;' . (($hidden) ? '[ɽ]' : '') : '') . (($url) ? ' (' . $url . ')' : '') . '</div>';
			print '<div class="comment-agent">' . $this->get_user_agent_info($agent) . '/' . $ip . '</div>' if $agent && $ip;
			print $comment;
			print '<div class="comment-ctime">' . $this->date($ctime,$this->{'datelimit'},'gmt' . $this->{'datetype'}) . '</div>';
			print '</div>';
			print '</div>';
		}
	}
	close(DAT);
}
print '<input type="submit" value="" class="submit" />';
print '</form>';
$cgi::action->print_page_footer('ugfieldeditor');
$this->rm_settings_for_editor;
return 1;
}

######################################################################
#sub import {
BEGIN {
if (!$setting::field_for_mail && (!defined $default::type || $default::type eq '')) {
	$setting::deco_dir{'comment'} = 'Ȥ ܥ';
	$setting::deco_type{'comment'} = 'button';
	$setting::deco_dir{'jump'} = 'ץܥ';
	$setting::deco_type{'jump'} = 'button';
	$setting::deco_dir{'email'} = 'E᡼ܥ';
	$setting::deco_type{'email'} = 'button';
}
}

1;
