package VoteBase;
require CMONOS::CGI_Lib::Field::UserGeneratedBarGraph;
@ISA = qw(UserGeneratedBarGraph);
use strict;
######################################################################
# ե⥸塼ʺ
# Grader.pm 1.1.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
#support@cmonos.jp
#http://cmonos.jp/
# 
######################################################################
#	(0)-5 ǡǤμ
sub elements ($;$) {
my($this,$str) = @_;
my(%data);
($data{'access'},$data{'latest_ip'},$data{'atime'},$data{'status'}) = split(/\x0A/,$str) if defined $str;
$this->dfill(\$data{'access'});
$this->fill(\$data{'latest_ip'},\$data{'atime'},\$data{'status'});
return %data;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
sub get_graph_info ($$) {
my($this,$data) = @_;
return (($data->{'access'}) ? $data->{'access'} : 0) . (($default::english) ? ' votes' : 'ɼ');
}

sub get_bar_value ($$) {
my($this,$data) = @_;
return ($data->{'access'}) ? $data->{'access'} : 0;
}

sub get_bar_max_value ($) {
my $this = shift;
return ($this->{'max'}) ? $this->{'max'} : 150;
}

sub get_additional_vote_form ($$) {
my($this,$data) = @_;
return '';
}

######################################################################
sub print_sub_setting_form($$) {
my($this,$name) = @_;
print '<fieldset>';
print '<legend><label for="' . $name . '_max">դκ</label></legend>';
print '<input type="text" name="' . $name . '_max" value="' . $this->escape($this->{'max'}) . '" size="6" /> ɼ';
print '</fieldset>';
}

sub is_valid_bargraph_setting ($) {
my $this = shift;
if (defined $main::data{$this->{'id'} . '_max'} && $main::data{$this->{'id'} . '_max'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_max'})) {
	push(@{$cgi::action->{'dialog'}},'պͤ򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_max'};
	return 0;
}
return 1;
}

######################################################################
#	(11) obj->update;
sub update_bargraph ($$) {
my($this,$data) = @_;
$data->{'access'}++;
if (defined $cgi::client_host && $cgi::client_host) {
	$data->{'latest_ip'} = $cgi::client_host;
} else {
	$data->{'latest_ip'} = $this->to_ip($ENV{'REMOTE_ADDR'});
	$data->{'latest_ip'} = $this->to_host($data->{'latest_ip'});
}
$data->{'atime'} = time;
$data->{'status'} = 'enabled' if !$data->{'status'};
return $this->get_bargraph_data($data);
}

sub get_bargraph_data ($$) {
my($this,$data) = @_;
return ((defined $data->{'access'}) ? $data->{'access'} : 0) . "\x0A" . ((defined $data->{'latest_ip'}) ? $data->{'latest_ip'} : '') . "\x0A" . ((defined $data->{'atime'}) ? $data->{'atime'} : '') . "\x0A" . ((defined $data->{'status'}) ? $data->{'status'} : 'enabled');
}

1;
