package MapLib;
require CMONOS::CGI_Lib::Tools::ImageLib;
@ISA = qw(ImageLib);
use strict;
######################################################################
# Ͽޥ饤֥Խ⥸塼
# MapLib.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2008-12-02
######################################################################
# 
sub erase ($) {
my $this = shift;
unlink("$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif") ||
unlink("$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.jpg") ||
unlink("$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.png");
$this->replace_image_css($main::dir . '-' . $main::id);
}

######################################################################
sub make_image_css ($$$;$$) {
my($this,$image_dir,$dir,$is_image_lib,$setting) = @_;
my @files = $this->get_image_file_list($image_dir,$dir);
my $css = '';
foreach my $name (@files) {
	if ($name =~ /^(\w+)\.(gif|png|jpg)$/) {
		my $id = $1;
		$css .= "\x0A\x0A" . $this->mk_image_css_for_map(
			$dir . '-' . $id,
			$dir,
			$id,
			$is_image_lib,
			$this->{'deco_obj'}->image_info($dir,$id,$is_image_lib)
		);
	}
}
return $css;
}

sub mk_image_css_for_map ($$$$$$$$) {
my($this,$class_name,$dir,$id,$is_image_lib,$width,$height,$name) = @_;
my $image_path = (($is_image_lib) ? '.' : $this->base_change($this->{'deco_obj'}->{'image_dir'} . '/' . $dir,$this->{'image_css'})) . '/' . $name;
my $css = '/* ' . $class_name . ' start */' . "\x0A";
$css .= 'div.imap-canvas div.' . $class_name . ' {' . "\x0A";
$css .= '  width: ' . $width . 'px;' . "\x0A";
$css .= '  height: ' . $height . 'px;' . "\x0A";
$css .= '  margin: 0 !important;' . "\x0A";
$css .= '  padding: 0 !important;' . "\x0A";
$css .= '  position: absolute;' . "\x0A";
$css .= '  background-image: url("' . $image_path . '");' . "\x0A";
$css .= '  cursor: move;' . "\x0A";
$css .= '}' . "\x0A";
#$css .= 'div.imap-canvas div.' . $class_name . ' img {' . "\x0A";
#$css .= '  display: none;' . "\x0A";
#$css .= '}' . "\x0A";
$css .= '/* ' . $class_name . ' end */' . "\x0A";
return $css;
}

######################################################################
# ե
sub print_setting_form ($) {
my $this = shift;
print '<fieldset><legend><label for="setting:alt">Ͽ޲̾</label></legend>';
print '<input type="text" name="setting:alt" id="setting:alt" value="' . $cgi::action->escape($this->{'deco_obj'}{'setting'}{$main::dir}{$main::id}{'alt'}) . '" size="20" />';
print ' <input type="submit" value="¸" />' if defined $main::id && $main::id ne '';
print '</fieldset>';
}

######################################################################
# Ͽ
sub set_image ($) {
my $this = shift;
my $class_name = $main::dir . '-' . $main::id;
$this->replace_image_css(
	$class_name,
	$this->mk_image_css_for_map(
		$class_name,
		$main::dir,
		$main::id,
		0,
		$this->{'deco_obj'}->image_info($main::dir,$main::id)
	)
);
$this->set_deco($main::dir,$main::id,{'alt' => $main::setting{'alt'}}) if defined $main::setting{'alt'};
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#饹Ͽ
	$ImageLib::modules{'map'} = 'MapLib' if !defined $ImageLib::modules{'map'};
}


1;