package TableSetting;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ơ֥⥸塼
# TableSetting.pm ver1.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ¹
sub run ($) {
my $this = shift;


#񤭹
if ($this->is_master && defined $main::id && defined $main::data{'name'} && $main::id ne '' && $main::data{'name'} ne '') {
	my($delete,%new);
	if (defined $main::delete && $main::delete) {
		$delete = $main::id;
		$main::id = 'new';
	} else {
		$main::data{'setting'} = $this->z_to_h($main::data{'setting'}) if $main::data{'setting'} =~ /\W/;
		$this->detag(\$main::data{'name'});
		$main::data{'name'} = 'ơ֥ ' . $main::id if !defined $main::data{'name'} || !$main::data{'name'};
		$main::data{'name'} =~ s/[\r\n]//sg;
	
		#ID
		$main::id = $this->new_number(\%table::obj,0) if $main::id eq 'new';
	
		my($k,$v);
		while (($k,$v) = each %main::data) {
			$new{$main::id . '_' . $k} = $v;
		}
	}

	undef %main::data;
	$this->write_db($env::preference_dir . '/table',\%new,'',$delete,\%setting::table,1);
	undef %new;

#ɤ߹
} else {
	$this->import_db($env::preference_dir . '/table',\%setting::table,1);
	push(@{$this->{'dialog'}},'̾ϤƲ') if defined $main::id && defined $main::data{'setting'} && $main::id ne '' && $main::data{'setting'} ne '';

}

#ڡإå
$this->jump_menu('tools');

if (!$this->is_master) {
	push(@{$this->{'dialog'}},'ޤ');
	$this->print_page_header('tools');
	$this->print_page_footer('tools');
	return;
}

$this->print_page_header('tools');

#IDʤΤȤ
$main::id = 'new' if !defined $main::id || $main::id eq '';

#
print '<fieldset class="toolbox" id="toolnavi">';
print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'tableselector',
	'required'	=>	\@setting::form
);
print '<select name="id" onchange="submit();">';

my($prev,$next);
foreach (sort {$a <=> $b} keys %setting::table) {
	next if $_ eq '';
	$prev = $_ if $main::id ne 'new' && $_ < $main::id;
	$next = $_ if $main::id ne 'new' && !$next && $_ > $main::id;
	print '<option value="' . $_ . '"' . (($main::id eq $_) ? ' selected="selected"' : '') . '>' . $setting::table{$_}{'name'} . '</option>';
	$prev = $_ if $main::id eq 'new';
}
print '<option value="new"' . (($main::id eq 'new') ? ' selected="selected"' : '') . '></option>';

print '</select><input type="submit" value="" />';
print '</form>';

if (defined $prev && $prev ne '') {
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'prevtable',
		'required'	=>	\@setting::form
	);
	print '<input type="submit" name="id=' . $prev . '" value="Υơ֥" />';
	print '</form>';
}
if (defined $next && $next) {
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'nexttable',
		'required'	=>	\@setting::form
	);
	print '<input type="submit" name="id=' . $next . '" value="Υơ֥" />';
	print '</form>';
}
print '</fieldset>';
undef $prev;
undef $next;

#̾ʤ
%{$setting::table{$main::id}} = %main::data if $main::id ne '' && defined $main::data{'setting'} && $main::data{'setting'} ne '';

print '<h1>ơ֥' . ((!defined $setting::table{$main::id}{'name'} || !$setting::table{$main::id}{'name'}) ? '' : '') . '</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="id" value="' . $this->escape($main::id) . '" />';

$this->escape(\$setting::table{$main::id}{'name'});
print '<fieldset><legend><label for="data:name">̾</label></legend>';
print '<input type="text" size="80" maxlength="80" name="data:name" id="data:name" value="' . $setting::table{$main::id}{'name'} . '" />';
print '</fieldset>';

if (!defined $setting::table{$main::id}{'setting'} || $setting::table{$main::id}{'setting'} eq '') {
$setting::table{$main::id}{'setting'} = <<SETTING;
tableclass="datatable"
trclass="odd,even"
class0="odd,even"
thenabled="true"
SETTING
}

print '<fieldset><legend><label for="data:setting"></label></legend>';
print '<textarea name="data:setting" id="data:setting" cols="80" rows="15" wrap="off" class="content-editor-area" ondblclick="cmonos.tool.colorPalette.open(\'data:setting+\',\'dom\')">' . $this->escape($setting::table{$main::id}{'setting'}) . '</textarea>';

print '<div class="toolbox"><select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:setting\').quotationByMenu(this)">';
print '<option value=""></option>';
print '<option value="' . $this->jsquot('\nsummary=&quot;&quot;') . '">/summary=""</option>';
print '<option value="' . $this->jsquot('\ncaption=&quot;&quot;') . '">ץ/caption=""</option>';
print '<option value="' . $this->jsquot('\ntableclass=&quot;&quot;') . '">ơ֥Υ륯饹/tableclass=""</option>';
print '<option value=""></option>';
print '<option value="' . $this->jsquot('\ntrclass=&quot;&quot;') . '">tr륯饹/trclass="r1,r2"</option>';
print '<option value=""></option>';
print '<option value="' . $this->jsquot('\nthenabled=&quot;true&quot;') . '">thtrue=ɬȤ/false=лȤʤ/auto=ɬפʤȤΤ߻Ȥ</option>';
print '<option value="' . $this->jsquot('\nclassH=&quot;&quot;') . '">td륯饹/classH="tdStyle1,tdStyle2"</option>';
print '<option value="' . $this->jsquot('\nclassF=&quot;&quot;') . '">td륯饹/classF="tdStyle1,tdStyle2"</option>';
print '<option value="' . $this->jsquot('\nclass0=&quot;&quot;') . '">ntd륯饹ʤn=1/class0="tdStyle1,tdStyle2"</option>';
print '<option value=""></option>';
print '<option value="">侩</option>';
print '<option value="' . $this->jsquot('\ncellpadding=&quot;&quot;') . '">;/cellpadding=""</option>';
print '<option value="' . $this->jsquot('\ncellspacing=&quot;&quot;') . '">/cellspacing=""</option>';
print '<option value="' . $this->jsquot('\nborder=&quot;&quot;') . '">/border=""</option>';
print '<option value="' . $this->jsquot('\nbordercolor=&quot;&quot;') . '">/bordercolor=""</option>';
print '<option value="' . $this->jsquot('\nbackground=&quot;&quot;') . '">طʲѥ/background=""</option>';
print '<option value="' . $this->jsquot('\ntablealign=&quot;&quot;') . '">ɽΤΰ·/tablealign=""</option>';
print '<option value="' . $this->jsquot('\ntablewidth=&quot;&quot;') . '">ɽ/tablewidth=""</option>';
print '<option value="' . $this->jsquot('\ntableheight=&quot;&quot;') . '">ɽ⤵/tableheight=""</option>';
print '<option value="' . $this->jsquot('\ntablehspace=&quot;&quot;') . '">ɽʿ;/tablehspace=""</option>';
print '<option value="' . $this->jsquot('\ntablevspace=&quot;&quot;') . '">ɽľ;/tablevspace=""</option>';
print '<option value="' . $this->jsquot('\ntableoption=&quot;&quot;') . '">嵭ʳɽץ/tableoption=""</option>';
print '<option value=""></option>';
print '<option value="' . $this->jsquot('\nwidth=&quot;&quot;') . '">/width="50,50,50"</option>';
print '<option value="' . $this->jsquot('\nheight=&quot;&quot;') . '">/height="30,30,30"</option>';
print '<option value="' . $this->jsquot('\nalign0=&quot;&quot;') . '">ʿ·/align0="center,left,right"</option>';
print '<option value="' . $this->jsquot('\nvalign0=&quot;&quot;') . '">ľ·/valign0="bottom,top,middle"</option>';
print '<option value=""></option>';
print '<option value="' . $this->jsquot('\nbgcolorH=&quot;&quot;') . '">tdطʿ/bgcolorH="#000000,#333333"</option>';
print '<option value="' . $this->jsquot('\nbgcolorF=&quot;&quot;') . '">tdطʿ/bgcolorF="#ffffff,#cccccc"</option>';
print '<option value=""></option>';
print '<option value="' . $this->jsquot('\nbgcolor0=&quot;&quot;') . '">ntdطʿʤn=1/bgcolor0="#ffffff,#cccccc"</option>';
print '<option value="' . $this->jsquot('\nbackground0=&quot;&quot;') . '">ntdطʲʤn=1/background0="bg.gif"</option>';
print '<option value=""></option>';
print '<option value="' . $this->jsquot('\nstyleH=&quot;&quot;') . '">td륷/styleH="font-size: 9pt;,font-size: 10pt;"</option>';
print '<option value="' . $this->jsquot('\nstyleF=&quot;&quot;') . '">td륷/styleF="font-size: 10pt;,font-size: 9pt;"</option>';
print '<option value="' . $this->jsquot('\nstyle0=&quot;&quot;') . '">ntd륷ȡʤn=1/style0="font-size: 10pt;,font-size: 9pt;"</option>';
print '<option value=""></option>';
print '<option value="' . $this->jsquot('\nfontcolorH=&quot;&quot;') . '">tdʸ/fontcolorH="#ffffff,#cccccc"</option>';
print '<option value="' . $this->jsquot('\nfontcolorF=&quot;&quot;') . '">tdʸ/fontcolorF="#000000,#333333"</option>';
print '<option value="' . $this->jsquot('\nfontcolor0=&quot;&quot;') . '">ntdʸʤn=1/fontcolor0="#000000,#333333"</option>';
print '<option value=""></option>';
print '<option value="' . $this->jsquot('\nfontsizeH=&quot;&quot;') . '">tdʸ/fontsizeH="4,3,4"</option>';
print '<option value="' . $this->jsquot('\nfontsizeF=&quot;&quot;') . '">tdʸ/fontsizeF="5,7,1"</option>';
print '<option value="' . $this->jsquot('\nfontsize0=&quot;&quot;') . '">ntdʸʤn=1/fontsize0="3,2"</option>';
print '<option value=""></option>';
print '<option value="' . $this->jsquot('\nnowrapH=&quot;&quot;') . '">td̵Ի/nowrapH="1,0,0"</option>';
print '<option value="' . $this->jsquot('\nnowrapF=&quot;&quot;') . '">td̵Ի/nowrapF="1,0,0"</option>';
print '<option value="' . $this->jsquot('\nnowrap0=&quot;&quot;') . '">ntd̵Իʤn=1/nowrap0="1,0,0"</option>';
print '<option value=""></option>';
print '<option value="' . $this->jsquot('\nfixed=&quot;1&quot;') . '">ɤ߹Ȥɽ/fixed="1"</option>';
print '<option value="' . $this->jsquot('\nbg=&quot;1&quot;') . '">ơ֥̤ȿǤ/bg="1"</option>';
print '</select> ';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:setting+\')" ondblclick="cmonos.tool.colorPalette.open(\'data:setting+\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a></div>';

print '</fieldset>';

print '<fieldset class="submit"><input type="submit" value="¸" class="save" /></fieldset>';

print '<fieldset class="sample"><legend>ߤ</legend>';

require CMONOS::CGI_Lib::Table;
my($table,$r);
$table = Table->new($setting::table{$main::id}{'setting'});
print $table->table;
foreach $r (0..5) {
	my($c);
	print $table->tr;
	foreach $c ('A','B','C','D','E','F') {
		print $table->td($c . '-' . $r);
	}
	print $table->_tr;
}
print $table->_table;
print '</fieldset>';

if ($main::id ne 'new') {
	print '<fieldset class="delete"><input type="submit" name="delete=1" value="" onclick="return confirm(\'ϼäޤ˺ޤ\');" /></fieldset>';
}

print '</form>';

#ڡեå
$this->print_page_footer('tools');

}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);
unless (defined $default::subdivided && defined $main::c && $default::subdivided && $main::c ne '') {

	$setting::table = 1;

	#饹Ͽ
	Common::class_register('0130','TableSetting');

	#˥塼Ͽ
	$setting::jump_menu{'0130'} = 'ơ֥()';
	$setting::master_check_option{'0130'} = 1;
}
}

1;
