package Inviter;
require CMONOS::Calendar::Field::CalUserGeneratedField;
require CMONOS::CGI_Lib::Field::UserGeneratedField;
@ISA = qw(CalUserGeneratedField UserGeneratedField);
use strict;
######################################################################
# ե⥸塼ʾԥեɡ
# Inviter.pm 1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-06-14
######################################################################
sub __set ($$) {
my $this = shift;
if (!ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
$this->{'datetype'} = (($setting::general{'datetype'}) ? $setting::general{'datetype'} : '') if !$this->{'datetype'};
$this->scalar_to_array(\$this->{'mailto'});
$this->{'elements'} = 1;
return;
}

######################################################################
#	(0)-3 եDB
sub db ($) {
my $this = shift;
return 'guest';
}

sub elements ($$) {
my($this,$str) = @_;
return ('str' => $str);
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
return 0
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
return 1;
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status,$original,$path) = @_;
my $form = $this->inviter_form($this->get_latest_data($main::n),$main::c,$main::n,1);
return ($form) ? $this->field_header . $form . $this->field_footer : '';
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
my $this = shift;
if ($main::data{$this->{'id'}}{'new'} ne '' && $this->is_invalid_email_address_header($main::data{$this->{'id'}}{'new'})) {
	push(@{$cgi::action->{'dialog'}},'ֿȡפǧƤ᡼륢ɥ쥹ϤƲ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'new'} = 1;
	return 0;
}
my(@addr);
if (ref $this->{'field_for'}{'mail_address'}) {
	foreach my $id (@{$this->{'field_for'}{'mail_address'}}) {
		while (my($k,$v) = each %{$main::data{$id}}) {
			push(@addr,$this->get_address($v));
		}
	}
}
@{$this->{'organizer'}} = (@addr) ? $this->get_address(@addr) : ();
return 1;
}

sub input_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=ɽǡ/path=ե¸ǥ쥯ȥ
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
return $this->inviter_form($str,$c,$n);
}

sub has_content {
my($this,$str) = @_;
my($organizer,$guest_can,$guest,$guest_list) = $this->get_guest_info_from_data($str);
if ($this->is_authorized(@$organizer)
	|| ($main::guest{'email'} && $main::guest{'key'} && ref $guest->{$main::guest{'email'}} && $guest->{$main::guest{'email'}}->{'key'} eq $main::guest{'key'})
	|| $this->is_authorized(@$guest_list)) {
	return 1;
} else {
	return 0;
}
}

sub inviter_form ($$;$$$) {
my($this,$data,$c,$n,$is_form) = @_;
my $is_organizer;
my $form = '';
my($organizer,$guest_can,$guest,$guest_list) = $this->get_guest_info_from_data($data);
if ($is_form || $this->is_authorized(@$organizer)) {
	$is_organizer = 1;
} elsif ($main::guest{'email'} && $main::guest{'key'} && ref $guest->{$main::guest{'email'}} && $guest->{$main::guest{'email'}}->{'key'} eq $main::guest{'key'}) {
	$is_organizer = 0;
} elsif ($this->is_authorized(@$guest_list)) {
	$is_organizer = 0;
	undef %main::guest;
} else {
	return '';
}
my $id = $this->mk_user_generated_field_id($c,$n);
if (!$is_form) {
	my @required = grep($_ ne 'n' && $_ ne 'c' && $_ ne 'id',@setting::form);
	$form = $this->form_start(
		'key'		=>	(($setting::security_key) ? $setting::security_key : ''),
		'id'		=>	(($id) ? $id . '-form' : ''),
		'name'		=>	(($id) ? $id . '-form' : ''),
		'method'	=> 'post',
		'onsubmit'	=>	'return cmonos.form.item(this).submit(\'' . $id . '\');',
		'required'	=>	\@required
	);
	$form .= '<input type="hidden" name="id" value="' . $this->{'id'} . '" />';
	$form .= '<input type="hidden" name="n" value="' . $n . '" />';
	$form .= '<input type="hidden" name="c" value="' . $c . '" />';
	$form .= '<input type="hidden" name="guest:email" value="' . $main::guest{'email'} . '" />' if $main::guest{'email'};
	$form .= '<input type="hidden" name="guest:key" value="' . $main::guest{'key'} . '" />' if $main::guest{'key'};
}
if ($is_organizer || $guest_can) {
	$form .= '<div id="' . $id . '">' . ((ref $guest_list && @$guest_list) ? $this->guests_table($id,$guest_list,$guest,$is_organizer,$guest_can) : '') . '</div>';
	if ($is_organizer) {
		$main::data{$this->{'id'}}{'guestcan'} = $guest_can if !defined $main::data{$this->{'id'}}{'guestcan'};
		$form .= '<fieldset class="guest-can"><legend>Ȥθ</legend>';
		$form .= '<ol class="checkbox">';
		$form .= '<li><label><input type="radio" name="data:' . $this->{'id'} . ':guestcan" value="none"' . ((!$main::data{$this->{'id'}}{'guestcan'} || $main::data{$this->{'id'}}{'guestcan'} eq 'none') ? ' checked="checked"' : '') . ' /> Τ</label></li>';
		$form .= '<li><label><input type="radio" name="data:' . $this->{'id'} . ':guestcan" value="see"' . (($main::data{$this->{'id'}}{'guestcan'} eq 'see') ? ' checked="checked"' : '') . ' /> Ȥΰɽ</label></li>';
		$form .= '<li><label><input type="radio" name="data:' . $this->{'id'} . ':guestcan" value="invite"' . (($main::data{$this->{'id'}}{'guestcan'} eq 'invite') ? ' checked="checked"' : '') . ' /> ¾Υ桼ξ</label></li>';
		$form .= '</ol>';
		$form .= '</fieldset>';
	}
	if ($is_organizer || $guest_can eq 'invite') {
		$form .= '<fieldset class="guest-can"><legend><label for="data:' . $this->{'id'} . ':new">(᡼륢ɥ쥹)</label></legend>';
		$form .= '<textarea name="data:' . $this->{'id'} . ':new" id="data:' . $this->{'id'} . ':new" cols="40" rows="8"' . (($this->{'is_invalid_field'}{'new'}) ? $this->set_invalid_class : '') . '>' . $this->escape($main::data{$this->{'id'}}{'new'}) . '</textarea>';
		$form .= '<div class="note">᡼륢ɥ쥹Ȥ˲Ԥޤ</div></fieldset>';
		$form .= '<div class="guest-submit-box">' . $cgi::Deco->submit_button('submit',$this->{'button'},(($default::english) ? 'Submit' : ''),{'id' => $id . '-submit'}) . '</div>' if !$is_form;
	}
} else {
	my $email = ($main::guest{'email'}) ? $main::guest{'email'} : $main::email;
	my %user_name = $cgi::Register->get_name_hash_from_emails($email);
	$form .= '<fieldset class="guest-can"><legend>' . (($user_name{$email}) ? $user_name{$email} . ' ' : (defined $guest->{$email}->{'name'} && $guest->{$email}->{'name'} ne '') ? $guest->{$email}->{'name'} . ' ' : $email) . '</legend>';
	$form .= $this->mk_select_menu(
		'data:' . $this->{'id'} . ':answer','','',$guest->{$email}->{'answer'},
		'pending'		=>		'α',
		'attendance'	=>		'',
		'absence'		=>		'Ի',
	);
	$form .= '<input type="text" size="30" name="data:' . $this->{'id'} . ':comment" title="Ȥޤ(Ǥ)" value="' . $guest->{$email}->{'comment'} . '" /><input type="hidden" name="data:' . $this->{'id'} . ':guest" value="' . $this->escape($email) . '" />' . $cgi::Deco->submit_button('submit',$this->{'button'},(($default::english) ? 'Submit' : ''),{'id' => $id . '-submit'}) if !$is_form;
	$form .= '</fieldset>';
}
$form .= '</form>' if !$is_form;
return $form;
}

sub guests_table ($$$$;$$$) {
my($this,$id,$guest_list,$guest,$is_organizer,$guest_can,$empty_msg) = @_;
return (($empty_msg) ? $empty_msg : '') if !$guest_list || !@$guest_list;
my %user_name = $cgi::Register->get_name_hash_from_emails(@$guest_list);
my $form = $this->{'Table'}->table;
$form .= $this->{'Table'}->tr;
$form .= $this->{'Table'}->th('') if $is_organizer;
$form .= $this->{'Table'}->th(($default::english) ? 'Guests' : '');
$form .= $this->{'Table'}->th(($default::english) ? 'Ans' : '');
$form .= $this->{'Table'}->th(($default::english) ? 'Comment' : '');
$form .= $this->{'Table'}->th(($default::english) ? 'Date' : '');
$form .= $this->{'Table'}->_tr;
foreach my $email (@$guest_list) {
	$form .= $this->{'Table'}->tr;
	if ($is_organizer) {
		$this->scalar_to_array(\$main::data{$this->{'id'}}{'target'}) if defined $main::data{$this->{'id'}}{'target'} && !ref $main::data{$this->{'id'}}{'target'};
		$form .= $this->{'Table'}->td('<input type="checkbox" name="data:' . $this->{'id'} . ':target" value="' . $this->escape($email) . '"' . (($main::data{$this->{'id'}}{'target'} && grep($_ eq $email,@{$main::data{$this->{'id'}}{'target'}})) ? ' checked="checked"' : '') . ' />');
	}
	$form .= $this->{'Table'}->td('<a href="mailto:' . $email . '" title="' . $email . '">' . (($user_name{$email}) ? $user_name{$email} : (defined $guest->{$email}->{'name'} && $guest->{$email}->{'name'} ne '') ? $guest->{$email}->{'name'} : $email) . '</a>');
	if (!$is_organizer && $guest_can && (($main::guest{'email'} && $email eq $main::guest{'email'}) || ($main::email && $email eq $main::email))) {
		$form .= $this->{'Table'}->td(
			$this->mk_select_menu(
				'data:' . $this->{'id'} . ':answer','','',$guest->{$email}->{'answer'},
				'pending'		=>		'α',
				'attendance'	=>		'',
				'absence'		=>		'Ի',
			)
		);
		$form .= $this->{'Table'}->td('<input type="text" size="30" name="data:' . $this->{'id'} . ':comment" title="Ȥޤ(Ǥ)" value="' . $this->escape($guest->{$email}->{'comment'}) . '" /><input type="hidden" name="data:' . $this->{'id'} . ':guest" value="' . $this->escape($email) . '" />' . (($guest_can eq 'see') ? $cgi::Deco->submit_button('submit',$this->{'button'},(($default::english) ? 'Submit' : ''),{'id' => $id . '-submit'}) : ''));
	} else {
		$form .= $this->{'Table'}->td((!$guest->{$email}->{'answer'}) ? '̤' : ($default::english) ? $guest->{$email}->{'answer'} : ($guest->{$email}->{'answer'} eq 'attendance') ? '' : ($guest->{$email}->{'answer'} eq 'absence') ? 'Ի' : ($guest->{$email}->{'answer'} eq 'pending') ? 'α' : '̤');
		$form .= $this->{'Table'}->td($guest->{$email}->{'comment'});
	}
	$form .= $this->{'Table'}->td(($guest->{$email}->{'time'}) ? $this->date($guest->{$email}->{'time'},$this->{'datelimit'},'gmt' . $this->{'datetype'}) : '');
	$form .= $this->{'Table'}->_tr;
}
$form .= $this->{'Table'}->_table;
if ($is_organizer) {
	$form .= '<label>åȤ';
	$form .= $this->mk_select_menu(
		'data:' . $this->{'id'} . ':do','','',$main::data{$this->{'id'}}{'do'},
		'pending'		=>		'αפˤ',
		'attendance'	=>		'ֻáפˤ',
		'absence'		=>		'Իáפˤ',
		''				=>		'',
		'delete'		=>		'',
	);
	$form .= '</label>';
}
return $form;
}

sub get_guest_info_from_data ($$) {
my($this,$data) = @_;
return([],'',{},[]) if !$data;
my $guest_list = [];
my $guest = {};
my($organizer,$guest_can) = ($data =~ s/^organizer=(.*?);guest_can=(\w*?);$//m) ? ((($1) ? [split(/,/,$1)] : []),$2) : ([],'');
while ($data =~ /^(.*?)$/mg) {
	my $line = $1;
	chomp $line;
	my($email,$key,$name,$answer,$comment,$time) = split(/\x09/,$line);
	next if !$email;
	$guest->{$email}->{'key'} = $key;
	$guest->{$email}->{'name'} = (defined $name) ? $name : '';
	$guest->{$email}->{'answer'} = (defined $answer) ? $answer : '';
	$guest->{$email}->{'comment'} = (defined $comment) ? $comment : '';
	$guest->{$email}->{'time'} = (defined $time) ? $time : '';
	push(@$guest_list,$email);
}
$guest_can = '' if !$guest_can;
return($organizer,$guest_can,$guest,$guest_list);
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
my $this = shift;
return 0;
}

sub format_for_mail {
my($this,$str) = @_;
return '';
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text_enabled ($) {
my $this = shift;
return 0;
}

sub format_for_text {
my($this,$str) = @_;
return '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$) {
my($this,$str) = @_;
return '' if !$main::data{$this->{'id'}}{'target'} && !$main::data{$this->{'id'}}{'guestcan'} && !$main::data{$this->{'id'}}{'new'};
$this->scalar_to_array(\$main::data{$this->{'id'}}{'target'});
my $html = '';
my @new_guests = $this->get_address($main::data{$this->{'id'}}{'new'});
my %user_name = $cgi::Register->get_name_hash_from_emails(@{$main::data{$this->{'id'}}{'target'}},@new_guests);
if ($main::data{$this->{'id'}}{'guestcan'}) {
	$html .= '<li>Ȥθ¤' . (($main::data{$this->{'id'}}{'guestcan'} eq 'invite') ? '¾Υ桼ξ' : ($main::data{$this->{'id'}}{'guestcan'} eq 'see') ? 'Ȥΰɽ' : 'Τ') . 'פˤ</li>';
}
if ($main::data{$this->{'id'}}{'do'} && @{$main::data{$this->{'id'}}{'target'}}) {
	my(%db,$data);
	use Fcntl qw(:DEFAULT);
	eval 'use ' . $env::dbm_file . ';';
	tie(%db, $env::dbm_file, $default::db . '/guest', O_RDONLY, $env::dbm_mode);
	if (ref tied %db) {
		$data = $db{$main::n};
	}
	untie %db;
	my($organizer,$guest_can,$guest,$guest_list) = $this->get_guest_info_from_data($data);
	$html .= '<li>Ȥ' . (($main::data{$this->{'id'}}{'do'} eq 'attendance') ? 'ֻáפ' : ($main::data{$this->{'id'}}{'do'} eq 'absence') ? 'Իáפ' : ($main::data{$this->{'id'}}{'do'} eq 'pending') ? 'αפ' : ($main::data{$this->{'id'}}{'do'} eq 'delete') ? '' : '') . '';
	$html .= '<ol>';
	foreach my $email (@{$main::data{$this->{'id'}}{'target'}}) {
		next if !ref $guest->{$email};
		$html .= '<li>' . $this->escape(($user_name{$email}) ? $user_name{$email} . ' <' . $email . '>' : (defined $guest->{$email}->{'name'} && $guest->{$email}->{'name'} ne '') ? $guest->{$email}->{'name'} . ' <' . $email . '>' : $email) . '</li>';
	}
	$html .= '</ol></li>';
}
if (@new_guests) {
	while ($main::data{$this->{'id'}}{'new'} =~ /\s*([^<>,]+)\s*<([^<>]+)>\s*,?\s*/g) {
		my($name,$addr) = ($1,$2);
		$name =~ s/\s+$//;
		$user_name{$addr} = $name if !defined $user_name{$addr};
	}
	if (@new_guests) {
		$html .= '<li>Ȥɲä';
		$html .= '<ol>';
		foreach my $email (@new_guests) {
			$html .= '<li>' . $this->escape(($user_name{$email}) ? $user_name{$email} . ' <' . $email . '>' : $email) . '</li>';
		}
		$html .= '</ol></li>';
	}
}
return ($html) ? '<ul>' . $html . '</ul>' : '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my $this = shift;
my($name,$id,$n);
$n = 0;

#̾
$name = 'data:' . $this->{'id'};

$this->print_field_info_form($name);

print '<fieldset>';
print '<legend>Ծ</legend>';
print '<table class="field-table"><tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_subject">ȥ</label></td>';
print '<td class="field"><input type="text" name="' . $name . '_subject" id="' . $name . '_subject" size="80" value="' . $this->escape($this->{'subject'}) . '" /></div>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_msg"></label></td>';
print '<td class="field"><textarea name="' . $name . '_msg" id="' . $name . '_msg" cols="80" rows="10">' . $this->escape($this->{'msg'}) . '</textarea>';
print '<div class="toolbox">';
print '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'' . $name . '_msg\').quotationByMenu(this)" title="Υϥ᡼бͤѴޤ">';
print '<option value=""></option>';
print '<option value="&lt;guest&gt;">&lt;guest&gt;[Ȥ̾ޤϥɥ쥹]</option>';
print '<option value="&lt;name&gt;">&lt;name&gt;[̾ե' . (($field::for{'name'} && ref $field::obj{$field::for{'name'}}) ? '' . $field::obj{$field::for{'name'}}->name . '' : '') . ']</option>';
print '<option value="&lt;title&gt;">&lt;title&gt;[ȥե' . (($field::for{'title'} && ref $field::obj{$field::for{'title'}}) ? '' . $field::obj{$field::for{'title'}}->name . '' : '') . ']</option>';
print '<option value="&lt;title&gt;">&lt;title&gt;[ե' . (($field::for{'location'} && ref $field::obj{$field::for{'location'}}) ? '' . $field::obj{$field::for{'location'}}->name . '' : '') . ']</option>';
print '<option value="&lt;url&gt;">&lt;url&gt;[ܺ٥ڡURL]</option>';
print '<option value="&lt;register&gt;">&lt;register&gt;[ɥ쥹ϿURL]</option>';
print '<option value="&lt;data&gt;">&lt;data&gt;[ǡΰ]</option>';
print '</select>';
print '</div>';
print '</td>';
print '</tr>';
print '</tbody><tbody>';
print '<tr>';
print '<td class="field-name">Υ᡼</td>';
print '<td class="field">';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_mailToMaster" value="1"' . (($this->{'mailToMaster'}) ? ' checked="checked"' : '') . ' /> ͤӶƱʡ˥᡼Τ</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_mailToOrganizer" value="1"' . (($this->{'mailToOrganizer'}) ? ' checked="checked"' : '') . ' /> żԤ˥᡼Τ(᡼륢ɥ쥹եɤɬ)</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_mailToGuests" value="1"' . (($this->{'mailToGuests'}) ? ' checked="checked"' : '') . ' /> ˥᡼Τ(Ȥ˥Ȱɽ¤ɬ)</label></li>';
print '</ol>';
print '</td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

print '<fieldset>';
print '<legend>ν</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_mTime" id="' . $name . '_mTime" value="1" ' . ((defined $this->{'mTime'} && $this->{'mTime'}) ? ' checked="checked"' : '') . ' /> ˹ǡ١򹹿롣</label></li>';
print '</ol>';
print '</fieldset>';

print '<fieldset>';
print '<legend></legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_datetype">ɽ</label></td>';
print '<td class="field">';
$this->print_date_type_menu($name . '_',$this->{'datetype'});
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">ɽ</span></td>';
print '<td class="field"><label><input type="text" size="3" maxlength="3" name="' . $name . '_datelimit" id="' . $name . '_datelimit" value="' . $this->escape($this->{'datelimit'}) . '" /> ʤɽʤ礦/Τ/</label></td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

print '<fieldset>';
print '<legend>Ȱ</legend>';
$this->print_table_setting_form($name,'','none');
print '<fieldset>';
print '<legend>ܥ</legend>';
print $cgi::Deco->button_menu(
	$name . '_button',
	'submit',
	120,
	$this->{'button'}
);
print '</fieldset>';
print '</fieldset>';

$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my $is_valid = 1;

#Ĵ
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};

#åܥå
$main::data{$this->{'id'} . '_mTime'} = 0 if !defined $main::data{$this->{'id'} . '_mTime'} || !$main::data{$this->{'id'} . '_mTime'};
$main::data{$this->{'id'} . '_mailToMaster'} = 0 if !defined $main::data{$this->{'id'} . '_mailToMaster'} || !$main::data{$this->{'id'} . '_mailToMaster'};
$main::data{$this->{'id'} . '_mailToOrganizer'} = 0 if !defined $main::data{$this->{'id'} . '_mailToOrganizer'} || !$main::data{$this->{'id'} . '_mailToOrganizer'};
$main::data{$this->{'id'} . '_mailToGuests'} = 0 if !defined $main::data{$this->{'id'} . '_mailToGuests'} || !$main::data{$this->{'id'} . '_mailToGuests'};

#å
if (defined $main::data{$this->{'id'} . '_datelimit'} && $main::data{$this->{'id'} . '_datelimit'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_datelimit'})) {
	push(@{$cgi::action->{'dialog'}},'򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_datelimit'};
	$is_valid = 0;
}
return $is_valid;
}

######################################################################
#	(6) obj->search_form;
sub search_form_enabled ($) {
my $this = shift;
return 0;
}

sub search_form ($) {
my $this = shift;
return '';
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(11) obj->update;
sub update_enabled ($) {
my $this = shift;
return 1;
}

sub is_secure_user_for_edit ($) {
my $this = shift;
return 0;
}

sub _update_error ($$) {
my($this,$is_ajax) = @_;
return ($is_ajax) ? {
	'status'			=>	'error',
	'message'			=>	$this->get_message_string,
	'authorized_level'	=>	$this->get_authorized_level
} : 0;
}

sub get_latest_data ($$) {
my($this,$n) = @_;
my $data = '';
if (defined $n && $n ne '') {
	my %db;
	use Fcntl qw(:DEFAULT);
	eval 'use ' . $env::dbm_file . ';';
	tie(%db, $env::dbm_file, $default::db . '/guest', O_RDONLY, $env::dbm_mode);
	if (ref tied %db) {
		$data = $db{$n};
	}
	untie %db;
}
return $data;
}

sub update ($;$$) {
#no warnings qw(untie);
my($this,$is_ajax,$is_editor) = @_;
$this->save_update_target;

my($c,$n,%db,$data,$table_modified,$send_mail,$is_organizer);
$is_organizer = ($is_editor) ? 1 : 0;
$c = $main::c;
$n = $main::n;

my($organizer,$guest_can,$guest,$guest_list) = $this->get_guest_info_from_data($this->get_latest_data($n));

#żԥɥ쥹
@$organizer = @{$this->{'organizer'}} if $is_organizer && ref $this->{'organizer'} && @{$this->{'organizer'}};

if ($is_organizer || $this->is_authorized(@$organizer)) {
	$is_organizer = 1;
	$guest_can = ($main::data{$this->{'id'}}{'guestcan'} ne 'invite' && $main::data{$this->{'id'}}{'guestcan'} ne 'see') ? '' : $main::data{$this->{'id'}}{'guestcan'} if $main::data{$this->{'id'}}{'guestcan'};
} elsif ($main::guest{'email'} && $main::guest{'key'} && $guest->{$main::guest{'email'}}->{'key'} eq $main::guest{'key'}) {
	$is_organizer = 0;
} elsif ($this->is_authorized(@$guest_list)) {
	$is_organizer = 0;
	undef %main::guest;
} else {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ծ') . '򹹿ǤޤǤ¤ޤ');
	return $this->_update_error($is_ajax);
}
undef $main::data{$this->{'id'}}{'guestcan'};
if ($is_organizer) {
	if ($main::data{$this->{'id'}}{'target'} && $main::data{$this->{'id'}}{'do'}) {
		$this->scalar_to_array(\$main::data{$this->{'id'}}{'target'});
		my $time = time;
		foreach my $email (@{$main::data{$this->{'id'}}{'target'}}) {
			if (ref $guest->{$email}) {
				if ($main::data{$this->{'id'}}{'do'} eq 'pending') {
					$guest->{$email}->{'answer'} = 'pending';
					$guest->{$email}->{'time'} = $time;
				} elsif ($main::data{$this->{'id'}}{'do'} eq 'attendance') {
					$guest->{$email}->{'answer'} = 'attendance';
					$guest->{$email}->{'time'} = $time;
				} elsif ($main::data{$this->{'id'}}{'do'} eq 'absence') {
					$guest->{$email}->{'answer'} = 'absence';
					$guest->{$email}->{'time'} = $time;
				} elsif ($main::data{$this->{'id'}}{'do'} eq 'delete') {
					delete $guest->{$email};
					@$guest_list = grep($_ ne $email,@$guest_list);
				}
				$table_modified = 1;
			}
		}
		$send_mail = 1 if $table_modified;
	}
	undef $main::data{$this->{'id'}}{'target'};
	undef $main::data{$this->{'id'}}{'do'};
} elsif ($main::data{$this->{'id'}}{'guest'} && ref $guest->{$main::data{$this->{'id'}}{'guest'}}) {
	$main::data{$this->{'id'}}{'comment'} = $this->escape($main::data{$this->{'id'}}{'comment'});
	$main::data{$this->{'id'}}{'comment'} =~ s/[\x0A\x0D\x09]//g;
	$main::data{$this->{'id'}}{'answer'} = 'pending' if !$main::data{$this->{'id'}}{'answer'};
	if (!$guest->{$main::data{$this->{'id'}}{'guest'}}->{'answer'} || $main::data{$this->{'id'}}{'answer'} ne $guest->{$main::data{$this->{'id'}}{'guest'}}->{'answer'}) {
		$guest->{$main::data{$this->{'id'}}{'guest'}}->{'time'} = time;
		$table_modified = 1;
	}
	$guest->{$main::data{$this->{'id'}}{'guest'}}->{'answer'} = $main::data{$this->{'id'}}{'answer'};
	$guest->{$main::data{$this->{'id'}}{'guest'}}->{'comment'} = $main::data{$this->{'id'}}{'comment'};
	$send_mail = 1;
	undef $main::data{$this->{'id'}}{'answer'};
	undef $main::data{$this->{'id'}}{'comment'};
	undef $main::data{$this->{'id'}}{'guest'};
}
if ($main::data{$this->{'id'}}{'new'} && ($is_organizer || $guest_can eq 'invite')) {
	my @new_guests = $this->get_address($main::data{$this->{'id'}}{'new'});
	if (@new_guests) {
		my($mail_subject,$mail_msg,$detail_url,$file_dir);
		$file_dir = "$default::file/$n";
		$detail_url = $this->my_url . '?m=DetailViewer&k=detail&c=' . $c . '&n=' . $n;
		$mail_subject = ($this->{'subject'}) ? $this->{'subject'} : '<title> ؤξ';
		$mail_msg = ($this->{'msg'}) ? $this->{'msg'} : '<title> ˾ԤƤޤ' . "\x0A" . 'URL˥ƻáԻä򤴲' . "\x0A\x0A" . '<url>' . "\x0A\x0A";
		if ($mail_subject =~ /<name>/i || $mail_msg =~ /<name>/i) {
			my $name = ($default::english) ? 'organizer' : 'ż';
			if (defined $field::for{'name'} && $field::for{'name'} && ref $field::obj{$field::for{'name'}} && $field::obj{$field::for{'name'}}->format_for_text_enabled) {
				my $temp = '';
				if ($is_editor) {
					$temp = $field::obj{$field::for{'name'}}->format_for_text($main::data{$field::for{'name'}}{'str'},$file_dir,$c,$n) if defined $main::data{$field::for{'name'}}{'str'} && $main::data{$field::for{'name'}}{'str'} ne '';
				} else {
					my(%name);
					tie(%name, $env::dbm_file, $default::db . '/' . $field::obj{$field::for{'name'}}->db, O_RDONLY, $env::dbm_mode);
					$name = $field::obj{$field::for{'name'}}->format_for_text($name{$n},$file_dir,$c,$n) if defined $name{$n} && $name{$n} ne '';
					untie(%name);
				}
				$name = $temp if $temp ne '';
			}
			$mail_subject =~ s/<name>/$name/igs;
			$mail_msg =~ s/<name>/$name/igs;
		}
		if ($mail_subject =~ /<title>/i || $mail_msg =~ /<title>/i) {
			my $title = ($default::english) ? 'this event' : '٥';
			if (defined $field::for{'title'} && $field::for{'title'} && ref $field::obj{$field::for{'title'}} && $field::obj{$field::for{'title'}}->format_for_text_enabled) {
				my $temp = '';
				if ($is_editor) {
					$temp = $field::obj{$field::for{'title'}}->format_for_text($main::data{$field::for{'title'}}{'str'},$file_dir,$c,$n) if defined $main::data{$field::for{'title'}}{'str'} && $main::data{$field::for{'title'}}{'str'} ne '';
				} else {
					my(%title);
					tie(%title, $env::dbm_file, $default::db . '/' . $field::obj{$field::for{'title'}}->db, O_RDONLY, $env::dbm_mode);
					$title = $field::obj{$field::for{'title'}}->format_for_text($title{$n},$file_dir,$c,$n) if defined $title{$n} && $title{$n} ne '';
					untie(%title);
				}
				$title = $temp if $temp ne '';
			}
			$mail_subject =~ s/<title>/$title/igs;
			$mail_msg =~ s/<title>/$title/igs;
		}
		if ($mail_subject =~ /<location>/i || $mail_msg =~ /<location>/i) {
			my $location = ($default::english) ? 'this event' : '٥';
			if (defined $field::for{'location'} && $field::for{'location'} && ref $field::obj{$field::for{'location'}} && $field::obj{$field::for{'location'}}->format_for_text_enabled) {
				my $temp = '';
				if ($is_editor) {
					$temp = $field::obj{$field::for{'location'}}->format_for_text($main::data{$field::for{'location'}}{'str'},$file_dir,$c,$n) if defined $main::data{$field::for{'location'}}{'str'} && $main::data{$field::for{'location'}}{'str'} ne '';
				} else {
					my(%location);
					tie(%location, $env::dbm_file, $default::db . '/' . $field::obj{$field::for{'location'}}->db, O_RDONLY, $env::dbm_mode);
					$location = $field::obj{$field::for{'location'}}->format_for_text($location{$n},$file_dir,$c,$n) if defined $location{$n} && $location{$n} ne '';
					untie(%location);
				}
				$location = $temp if $temp ne '';
			}
			$mail_subject =~ s/<location>/$location/igs;
			$mail_msg =~ s/<location>/$location/igs;
		}
		if ($mail_msg =~ /<data>/i) {
			my $list = '';
			foreach (sort {$a <=> $b} keys %field::ORDER) {
				my $id = $field::ORDER{$_};
				next if !$field::obj{$id}->format_for_mail_enabled;
				if ($is_editor) {
					$list .= $field::obj{$id}->format_for_mail($main::data{$id}{'str'},$file_dir,$c,$n);
				} else {
					my(%data);
					tie(%data, $env::dbm_file, $default::db . '/' . $field::obj{$id}->db, O_RDONLY, $env::dbm_mode);
					$list .= $field::obj{$id}->format_for_mail($data{$n},$file_dir,$c,$n);
					untie(%data);
				}
			}
			$mail_msg =~ s/<data>/$list/igs;
		}
		unless (ref $cgi::SendMail) {
			require CMONOS::CGI_Lib::SendMail;
			$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
		}
		my %user_name = $cgi::Register->get_name_hash_from_emails(@new_guests);
		while ($main::data{$this->{'id'}}{'new'} =~ /\s*([^<>,]+)\s*<([^<>]+)>\s*,?\s*/g) {
			my($name,$addr) = ($1,$2);
			$name =~ s/\s+$//;
			$user_name{$addr} = $name if !defined $user_name{$addr};
		}
		my $time = time;
		foreach my $email (@new_guests) {
			if (!ref $guest->{$email}) {
				my($subject,$msg,$name,$bcc,$user_name,$script_name,$url,$input,$register_url);
				$table_modified = 1;
				push(@$guest_list,$email);
				$guest->{$email}->{'key'} = $cgi::Register->rand_char;
	
				$subject = $mail_subject;
				$msg = $mail_msg;
	
				$guest->{$email}->{'name'} = ($user_name{$email}) ? $user_name{$email} : '';
				$user_name = ($user_name{$email}) ? $user_name{$email} : $email;
				$subject =~ s/<guest>/$user_name/igs;
				$msg =~ s/<guest>/$user_name/igs;
		
				$script_name = $this->my_url;
				$url = $detail_url . $this->add_query('url',{'guest:email' => $email,'guest:key' => $guest->{$email}->{'key'}});
				$msg =~ s/<url>/$url/igs;
	
				$register_url = $this->http_my_domain . $this->path_change($env::register_cgi,$ENV{'SCRIPT_NAME'},'abs');
				$msg =~ s/<register>/$register_url/igs;
				$cgi::SendMail->send_mail(
					'To'		=>  (($user_name{$email}) ? $user_name{$email} . ' <' . $email . '>' : $email),
					'From'		=>  (($setting::general{'master'}) ? (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}) : $env::master_email),
					'Subject'	=>  $subject,
					'message'	=>  $msg . "\x0A\x0A",
					'info'		=>  0
				);
			}
		}
		$send_mail = 1;
		undef $main::data{$this->{'id'}}{'new'};
	}
} elsif ($main::data{$this->{'id'}}{'new'}) {
	push(@{$cgi::action->{'dialog'}},'ȤɲäǤޤǤɲø¤ޤ');
}
$this->send_notice_mail($organizer,$guest_can,$guest,$guest_list) if !$is_editor && $send_mail;

#żԡȸ¾Ⱦ
$data = 'organizer=' . join(",",@$organizer) . ';guest_can=' . $guest_can . ';' . "\x0A";
if (@$guest_list) {
	foreach my $email (@$guest_list) {
		$data .= $this->svjoin("\x09",
			$email,
			$guest->{$email}->{'key'},
			((defined $guest->{$email}->{'name'}) ? $guest->{$email}->{'name'} : ''),
			((defined $guest->{$email}->{'answer'}) ? $guest->{$email}->{'answer'} : ''),
			((defined $guest->{$email}->{'comment'}) ? $guest->{$email}->{'comment'} : ''),
			((defined $guest->{$email}->{'time'}) ? $guest->{$email}->{'time'} : '')
		) . "\x0A";
	}
}

tie(%db, $env::dbm_file, $default::db . '/guest', O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %db) {
	$db{$n} = $data;
} else {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ծ') . '򹹿ǤޤǤǡ١³ǤޤǤ');
	return $this->_update_error($is_ajax);
}
untie %db;

$this->post_update;
if ($is_ajax) {
	return {
		'status'			=>	'success',
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level,
		'reset_disabled'	=>	1,
		(($table_modified) ? (
			'content'		=>	$this->guests_table($this->mk_user_generated_field_id($c,$n),$guest_list,$guest,$is_organizer,$guest_can,'ߥȤϾԤƤޤ'),
			'reset_fields'	=>	'data:' . $this->{'id'} . ':new'
		) : ()),
	};
} else {
	return 1;
}
}

sub send_notice_mail ($$$$$) {
my($this,$organizer,$guest_can,$guest,$guest_list) = @_;
my(@addr);
if ($this->{'mailToMaster'}) {
	push(@addr,$env::master_email) if $env::master_email;
	push(@addr,$setting::general{'master'}) if $setting::general{'master'};
	push(@addr,$setting::general{'owners'}) if $setting::general{'owners'};
}
push(@addr,$organizer->[0]) if $this->{'mailToOrganizer'} && @$organizer;
push(@addr,@$guest_list) if $this->{'mailToGuests'} && $guest_can && @$guest_list;
@addr = $this->get_address(@addr);
if (@addr) {
	unless (ref $cgi::SendMail) {
		require CMONOS::CGI_Lib::SendMail;
		$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
	}
	$cgi::SendMail->send_mail(
		'Bcc'		=>  join(',',@addr),
		'From'		=>  (($setting::general{'master'}) ? (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}) : $env::master_email),
		'Subject'	=>  'ڤΤ餻ۻüԾ󤬹ޤ',
		'message'	=>  'ͽλüԾ󤬹ޤ' . "\x0A\x0A" . $this->my_url . '?m=DetailViewer&k=detail&c=' . $main::c . '&n=' . $main::n . "\x0A\x0A",
	);
}
}

sub editor_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('xcal_inviter','Inviter','Ȥ');
	$setting::deco_dir{'submit'} = ' ܥ';
	$setting::deco_type{'submit'} = 'button';
	push(@field::redundancy_forbidden,'xcal_inviter');
}

1;
