package EventSweeper;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ٥⥸塼
# EventSweeper.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ¹
sub run ($) {
my $this = shift;
my($error,@folder,%year);

use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

#
if (defined $main::delete && $main::delete && !$this->is_nan($main::mday) && !$this->is_nan($main::mon) && !$this->is_nan($main::year) && $main::year > 1900 && $main::year < 2100 && !$this->is_impossible_mday($main::year,$main::mon,$main::mday)) {
	
	#ɬפʥ⥸塼
	use File::Path;

	my($limit,%date,@delete_event,$delete_count);
	$limit = $main::year . sprintf("%.2d", $main::mon) . sprintf("%.2d", $main::mday);
	$delete_count = 0;

	#եɤ߹
	$this->use_field('field',$default::field_pref_dir . '/inputfield',2,2,'no');

	tie(%date, $env::dbm_file, $default::db . '/date', O_RDWR, $env::dbm_mode);
	if (ref tied %date) {
		my(@delete_date);
		while (my($date,$events) = each %date) {
			if (!$events) {
				push(@delete_date,$date);
			} elsif ($date !~ /\D/ && $date > 19000000 && $date < $limit) {
				push(@delete_event,split(/,/,$events));
				push(@delete_date,$date);
			}
		}
		foreach my $date (@delete_date) {
			delete $date{$date};
		}
	}
	untie(%date);
	if (@delete_event) {
		my(%delete_event,%dt,%db,@db);
		foreach my $n (@delete_event) {
			$n =~ s/^\d+<//;
			$n =~ s/>\d+$//;
			$delete_event{$n}++;
		}
		tie(%dt, $env::dbm_file, $default::db . '/dt', O_RDWR, $env::dbm_mode);
		tie(%{$db{'ctime'}}, $env::dbm_file, $default::db . '/ctime', O_RDWR, $env::dbm_mode);
		tie(%{$db{'mtime'}}, $env::dbm_file, $default::db . '/mtime', O_RDWR, $env::dbm_mode);
		tie(%{$db{'agent'}}, $env::dbm_file, $default::db . '/agent', O_RDWR, $env::dbm_mode);
		tie(%{$db{'ip'}}, $env::dbm_file, $default::db . '/ip', O_RDWR, $env::dbm_mode);
		tie(%{$db{'category'}}, $env::dbm_file, $default::db . '/category', O_RDWR, $env::dbm_mode);
		while (my($id,$field) = each %field::obj) {
			my $db_name = $field->db;
			if ($db_name && !ref $db{$db_name}) {
				tie(%{$db{$db_name}}, $env::dbm_file, $default::db . '/' . $db_name, O_RDWR, $env::dbm_mode);
			}
		}
		@db = values %db;
		foreach my $n (keys %delete_event) {
			next if !defined $n || !$n;
			my $last = ($dt{$n} && $dt{$n} =~ /(\d{8})$/) ? $1 : 0;
			if ($last && $last < $limit) {
				delete $dt{$n};
				foreach my $db (@db) {
					delete $db->{$n};
				}
				rmtree "$default::file/$n" if defined $default::file && $default::file ne '';
				$delete_count++;
			}
		}
		foreach my $db (@db) {
			untie(%$db);
		}
		undef %db;
		untie(%dt);
	}
	push(@{$this->{'dialog'}},$delete_count . 'ͽޤ');
} elsif ($main::delete) {
	push(@{$this->{'dialog'}},'դλ꤬ޤ');
}

#ǯ
my @localtime = localtime(time);
my $year = $localtime[5] + 1900;

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1 title="ͽΰԤޤ">Ťͽΰ</h1>';

if (!defined $main::year || !$main::year) {
	($main::mday,$main::mon,$main::year) = @localtime[3..5];
	$main::year += 1899;
	$main::mon++;
}

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=> 'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);
print '<fieldset class="delete">';
print '<label><select name="year">';
for (my $y = $year - 10; $y <= $year; $y++) {
	print '<option value="', $y, '"';
	print (($main::year && $main::year == $y) ? ' selected="selected"' : '');
	print '>', $y, '</option>';
}
print '</select>ǯ</label> ';

print '<label><select name="mon">';
foreach (1..12) {
	print '<option value="', $_, '"';
	print (($main::mon && $main::mon == $_) ? ' selected="selected"' : '');
	print '>', $_, '</option>';
}
print '</select></label> ';

print '<label><select name="mday">';
foreach (1..31) {
	print '<option value="', $_, '"';
	print (($main::mday && $main::mday == $_) ? ' selected="selected"' : '');
	print '>', $_, '</option>';
}
print '</select></label> ';

print ' Ťͽ <input type="submit" name="delete=1" value="" onclick="return confirm(\'ϼäޤ˺ޤ\');" />';
print '</fieldset></form>';

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);
if (!$default::subdivided || ($default::subdivided && defined $main::c && $main::c ne '')) {

	#饹Ͽ
	Common::class_register('xxas','EventSweeper');

	#˥塼Ͽ
	$setting::jump_menu{'xxas'} = 'Ťͽΰ';

}
}



1;
