package ArticleSweeper;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use Fcntl qw(:flock);
######################################################################
# ⥸塼
# ArticleSweeper.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ¹
sub run ($) {
my $this = shift;
my($error,@folder,%year);

#ɬפʥ⥸塼
use File::Path;

#֥롼פΥۡǥ쥯ȥ
if (defined $default::subdivided && $default::subdivided) {
	$default::home = '.' if !defined $default::home || $default::home eq '';
	if (defined $main::c && $main::c ne '' && -d "$default::home/$main::c") {
		$default::home .= '/' . $main::c;
	} else {
		push(@{$this->{'dialog'}},'ꤵ줿եߤĤޤǤ');
		$error++;
	}
}
$error++ if !defined $default::date || !$default::date;

#ꥹ
if (opendir(DIR, $default::home)) {
	@folder = grep(-d "$default::home/$_" && $_ !~ /\D/,readdir(DIR));
	closedir(DIR);
} else {
	push(@{$this->{'dialog'}},'ۡǥ쥯ȥǧƤ');
	$error++;
}

#
if (defined $main::delete && $main::delete) {
	my(@delete,$delerror,@temp,$oldest);
	foreach (sort {$a <=> $b} @folder) {
		if ($_ =~ /^([0-9]{4})[0-9]{6}$/) {
			if ($1 <= $main::delete) {
				push(@delete,$_);
			} else {
				$oldest = $_ if !defined $oldest ||  !$oldest;
				push(@temp,$_);
			}
		}
	}
	@folder = @temp;

	#
	foreach (@delete) {
		$delerror++ unless rmtree "$default::home/$_";
	}

	#嵭Υ󥯤
	$this->rm_link($default::home . '/' . $oldest,'prev');

	#ȥκ
	if (defined $default::date && $default::date) {

		#κ
		$this->remove("$default::home/history",$main::delete,'','prevpage');

		#κ
		$this->remove("$default::home/calendar",$main::delete-1,$main::delete);

	}

	if (defined $delerror && $delerror) {
		push(@{$this->{'dialog'}},'κ˼Ԥޤ' . $delerror . 'ˡ');
	} else {
		push(@{$this->{'dialog'}},'ꤵ줿ޤ');
	}
}

#ǯ
foreach (@folder) {
	$year{substr($_,0,4)}++;
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

if (defined $error && $error) {
	print '顼';
	$this->print_page_footer('tools');
	exit;
}

print '<h1></h1><p>ꤵ줿ǯεޤϺޤǥåΥ󥯤Ϻޤ</p>';

if (%year) {
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'method'	=>	'post',
		'required'	=>	\@setting::form
	);
	print '<fieldset class="delete">';
	print '<select name="delete" title="뵭ꤷޤʡˤϺоݤȤʤ뵭Ǥ"><option value="">ϰϤ</option>';
	
	my($count);
	foreach (sort {$a <=> $b} keys %year) {
		$count += $year{$_};
		print '<option value="' . $_ . '">' . $_ . ' ǯε ' . $count. ' </option>';
	}
	
	print '</select>  <input type="submit" value="" onclick="return confirm(\'ϼäޤ˺ޤ\');" />';
	print '</fieldset></form>';
} else {
	print '<p>Ĥޤ</p>';
}

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# /κ
sub remove ($$$;$$) {
my($this,$dir,$delete,$del,$link) = @_;
my($oldest,@folder);
if (opendir(DIR, $dir)) {
	#no warnings qw(numeric);
	@folder = sort {$a <=> $b} grep(-f "$dir/$_" && $_ =~ /^[0-9]{6}/,readdir(DIR));
	closedir(DIR);
} else {
	return;
}

#
foreach (@folder) {
	if ($_ =~ /^([0-9]{4})[0-9]{2,4}\./) {
		if ($1 <= $delete) {
			unlink "$dir/$_";
		} elsif ($del && $1 <= $del) {
			unlink "$dir/$_";
			if (open(OUT, ">>$dir/$_")) {
				flock(OUT, LOCK_EX);
				truncate(OUT, 0);
				seek(OUT, 0, 0);
				print OUT '';
				close(OUT);
			}
		} elsif (!defined $oldest || $oldest eq '') {
			$oldest = $_;
		} else {
			last;
		}
	}
}

#󥯤
$this->_rm_link($dir . '/' . $oldest,$link) if defined $link && $link;
}

######################################################################
# 󥯤κ
sub rm_link ($$$) {
my($this,$dir,$link) = @_;
my(@folder);
if (opendir(DIR, $dir)) {
	@folder = grep(-f "$dir/$_" && $_ =~ /^[0-9]+/,readdir(DIR));
	closedir(DIR);
} else {
	return;
}

#
foreach (@folder) {
	$this->_rm_link("$dir/$_",$link);
}
}

sub _rm_link ($$) {
my($this,$path,$link) = @_;
my($data);
local(*FILE);
local(*OUT);

if (open(FILE, $path)) {
	binmode FILE;
	flock(FILE, LOCK_EX);
	$data = join('',<FILE>);
	close(FILE);
} else {
	return 0;
}

$data =~ s/<\!--$link(?!\w)[^>]*-->.*?<\!--\/$link-->//sg;

return if !defined $data || $data eq '';
if (open(OUT, ">>$path")) {
	flock(OUT, LOCK_EX);
	truncate(OUT, 0);
	seek(OUT, 0, 0);
	print OUT $data;
	close(OUT);
	return 1;
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);
if ($default::date && (!$default::subdivided || ($default::subdivided && defined $main::c && $main::c ne ''))) {

	#饹Ͽ
	Common::class_register('H200','ArticleSweeper');

	#˥塼Ͽ
	$setting::jump_menu{'H200'} = '' if !defined $setting::jump_menu{'H200'};

}
}



1;
