package DataEditor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use Fcntl qw(:flock);
######################################################################
# 񤭽Ф⥸塼
# DataEditor.pm ver1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-05-20
######################################################################
# ¹
sub run ($) {
#no warnings qw(numeric);
my $this = shift;
my($file_name,@datafiles);
@main::target = ($main::target) if !@main::target && $main::target;
$main::a = '' if !defined $main::a;
$main::code = ($ENV{'HTTP_USER_AGENT'} && $ENV{'HTTP_USER_AGENT'} =~ /Win|Mac/i) ? 'sjis' : 'euc' if !defined $main::code;
$main::rcode = ($ENV{'HTTP_USER_AGENT'} && $ENV{'HTTP_USER_AGENT'} =~ /Win/i) ? 'crlf' : ($ENV{'HTTP_USER_AGENT'} =~ /Mac/i) ? 'cr' : 'lf' if !defined $main::rcode;

#ư
if (defined $main::remote && $main::remote && !@main::target) {
	local(*DATA);
	opendir(DATA, $default::data);
	@datafiles = readdir(DATA);
	closedir(DATA);
	foreach (@datafiles) {
		if ($_ =~ /(\d+)\.tsv$/) {
			if ($main::a eq 'delete') {
				push(@main::target,$1) if -d $default::data . '/' . $1 . '.checked';
			} elsif ($main::a eq 'v') {
				push(@main::target,$1) if !-d $default::data . '/' . $1 . '.checked';
			}
		}
	}
}

#ǡɽ
if ($main::a eq 'v' && @main::target) {
	my($file_no);
	@main::target = sort {$a <=> $b || $a cmp $b} @main::target;
	if ($main::for_excel) {
		$this->print_http_header('application/vnd.ms-excel');
	} elsif (defined $main::type && $main::type eq 'csv') {
#		$this->print_http_header('text/comma-separated-values');
		$this->print_http_header('application/csv');
	} else {
#		$this->print_http_header('text/tab-separated-values');
		$this->print_http_header('application/tab-separated-values');
	}
	foreach $file_no (@main::target) {
		next if $file_no !~ /^\d{14}$/;
		local(*DATA);
		if (open(DATA,$default::data . '/' . $file_no . '.tsv')) {
			binmode DATA;
			flock(DATA, LOCK_EX);
			my($data);
			while ($data = <DATA>) {
				$this->jcode_convert(\$data,$main::code,'euc') if $main::code eq 'sjis' || $main::code eq 'jis';
				if (defined $main::type && $main::type eq 'csv') {
					chomp $data;
					my @data = split(/\x09/,$data);
					map{
						$_ =~ s/\x0B/\x0A/g;
						$_ = '"' . $_ . '"' if $_ =~ /[,"\x0A]/;
					} @data;
					$data = join(',',@data) . "\x0A";
				}
				if ($main::rcode eq 'crlf') {
					$data =~ s/\x0A/\x0D\x0A/g;
				} elsif ($main::rcode eq 'cr') {
					$data =~ s/\x0A/\x0D/g;
				}
				print $data;
			}
			close (DATA);
			if (!-d $default::data . '/' . $file_no . '.checked') {
				mkdir($default::data . '/' . $file_no . '.checked',0700);
			}
		}
	}
	exit;
} elsif ($main::a eq 'v') {
	push(@{$this->{'dialog'}},'եꤷƤ');
}

#ǡ
if ($main::a eq 'delete' && @main::target) {
	my($file_no,$del_count,$error_count);
	foreach $file_no (@main::target) {
		my($check_dir);
		$check_dir = $default::data . '/' . $file_no . '.checked';
		if (!-d $check_dir) {
			push(@{$this->{'dialog'}},'̤ɺǿǡϺǤޤ');
			next;
		}
		if (unlink($default::data . '/' . $file_no . '.tsv') && rmdir $check_dir) {
			$del_count++;
		} else {
			$error_count++;
		}
	}
	push(@{$this->{'dialog'}},$del_count . 'ĤΥեޤ') if defined $del_count && $del_count;
	push(@{$this->{'dialog'}},$error_count . 'ĤΥեǤޤǤ') if defined $error_count && $error_count;
	undef @main::target;
} elsif ($main::a eq 'delete') {
	push(@{$this->{'dialog'}},'եꤷƤ');
}

#ư
if (defined $main::remote && $main::remote) {
	$this->print_http_header('text/plain');
	my($msg,$r);
	$main::code = 'sjis' if !defined $main::code || !$main::code;
	if ($main::rcode eq 'lf') {
		$r = "\x0A";
	} elsif ($main::rcode eq 'cr') {
		$r = "\x0D";
	} else {
		$r = "\x0D\x0A";
	}
	foreach $msg (@{$this->{'dialog'}}) {
		$this->jcode_convert(\$msg,$main::code,'euc') if $main::code eq 'sjis' || $main::code eq 'jis';
		print $msg;
		print $r;
	}
	exit;
}

#ǡԽ
local(*DATA);
opendir(DATA, $default::data);
@datafiles = sort {$b <=> $a || $b cmp $a} grep($_ =~ /\d+\.tsv$/ && -f $default::data . '/' . $_,readdir(DATA));
closedir(DATA);

my $downloadname = $default::id || 'exported';
$downloadname =~ s/^_//;
$downloadname .= '_data';
my $javascript = <<JAVASCRIPT;
cmonos.tool.questionnaireDataExporter = function (delete_data) {
	if (document.getElementById('target') && document.getElementById('target').selectedIndex == -1) {
		alert('ե򤷤Ƥ');
		return false;
	}
	if (delete_data) {
		cmonos.form.name('input').appendDownloadPath()
	} else {
		cmonos.form.name('input').field(\'type\').appendDownloadPathByValue({'csv':'$downloadname.csv','tsv':'$downloadname.tsv'});
	}
	return true;
}
JAVASCRIPT
$this->set_javascript($javascript);

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>ǡ񤭽Ф/</h1>';

if (!@datafiles) {
	print '<fieldset>ǡե뤬ߤĤޤ</fieldset>';
	$this->print_page_footer('tools');
	exit;
}

#ե೫
$this->fill(\$main::code);
print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'id'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);
print '<fieldset><table class="field-table"><tbody>';
print '<tr>';
print '<td class="field-name"><label for="type"></label></td>';
print '<td class="field"><select name="type" id="type">';
print '<option value="tsv">ֶڤƥ</option>';
print '<option value="csv"' . ((defined $main::type && $main::type eq 'csv') ? ' selected="selected"' : '') . '>޶ڤƥȡcsv</option>';
print '</select>';
print '<label><input type="checkbox" name="for_excel" value="1"' . (($main::for_excel) ? ' checked="checked"' : '') . ' /> Excel եȤƽ񤭽Ф</label>';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="code">ʸ</label></td>';
print '<td class="field"><select name="code" id="code">';
print '<option value="sjis"' . (($main::code eq 'sjis') ? ' selected="selected"' : '') . '>ShiftJIS</option>';
print '<option value="euc"' . (($main::code eq 'euc') ? ' selected="selected"' : '') . '>EUC</option>';
print '<option value="jis"' . (($main::code eq 'jis') ? ' selected="selected"' : '') . '>JIS</option>';
print '</select>';
print '<select name="rcode">';
print '<option value="crlf"' . (($main::rcode eq 'crlf') ? ' selected="selected"' : '') . '>CR+LF(Windows)</option>';
print '<option value="cr"' . (($main::rcode eq 'cr') ? ' selected="selected"' : '') . '>CR(Mac)</option>';
print '<option value="lf"' . (($main::rcode eq 'lf') ? ' selected="selected"' : '') . '>LF(UNIX)</option>';
print '</select>';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="target">ե</label></td>';
print '<td class="field"><select name="target" id="target" multiple="multiple" size="' . scalar(@datafiles) . '">';
foreach $file_name (@datafiles) {
	my($file_no,$mtime);
	$file_no = $1 if $file_name =~ /^(\d+)\.tsv$/;
	$mtime = (stat($default::data . '/' . $file_name))[9];
	print '<option value="' . $file_no . '">';
	print $this->date($file_no,0,'/24');
	print '-';
	print $this->date($mtime,0,'gmt/24');
	print 'ںѡ' if -d $default::data . '/' . $file_no . '.checked';
	print '</option>';
}
print '</select>';
print '</td>';
print '</tr>';
print '</tbody></table></fieldset>';
print '<fieldset class="submit">';
print '<input type="submit" name="a=delete" value="" onclick="return cmonos.tool.questionnaireDataExporter(true) && confirm(\'ϼäޤ˺ޤ\') &amp;&amp; cmonos.form.item(this.form).isNotSubmitted();" class="delete"/>';
print '<input type="submit" name="a=v" value="񤭽Ф" class="export" onclick="return cmonos.tool.questionnaireDataExporter()" />';
print '</fieldset></form>';

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('q200','DataEditor');

	#˥塼Ͽ
	$setting::jump_menu{'q200'} = 'ǡ񤭽Ф/';

}



1;
