package CartSetting;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use strict;
use Fcntl qw(:flock);
######################################################################
# ǡȾѹ⥸塼
# CartSetting.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ¹
sub run ($) {
my $this = shift;
my($valid_flag,$error_flag,$tax_rate,$tax_included,$tax_frac,$point_lifetime,$checkout_window_type,$checkout_window_width,$checkout_window_height,$checkout_window_top,$checkout_window_left,$cart_js_changed);
$this->get_setup_env;

#ϥå
if (defined $main::tax_rate && $main::tax_rate ne '') {
	if ($this->is_nan($main::tax_rate)) {
		push(@{$this->{'dialog'}},'ΨȾѿꤷƤ');
		$error_flag = 1;
	} else {
		$tax_rate = abs(int($main::tax_rate)) / 100;
		if ($tax_rate == $env::tax_rate) {
			undef $main::tax_rate;
			undef $tax_rate;
		} else {
			$valid_flag = 1;
		}
	}
}
if (defined $main::tax_frac && $main::tax_frac =~ /^(ceil|round|floor)$/) {
	if ($main::tax_frac eq $env::tax_frac) {
		undef $main::tax_frac;
	} else {
		$tax_frac = $main::tax_frac;
		$valid_flag = 1;
	}
}
if (defined $main::tax_included && $main::tax_included ne '') {
	if ($main::tax_included eq $env::tax_included) {
		undef $main::tax_included;
	} else {
		$tax_included = ($main::tax_included) ? 1 : 0;
		$valid_flag = 1;
	}
}
#if (defined $main::point_lifetime && $main::point_lifetime ne '') {
#	if ($this->is_nan($main::point_lifetime)) {
#		push(@{$this->{'dialog'}},'ݥͭ¤ȾѿꤷƤ');
#		$error_flag = 1;
#	} else {
#		$point_lifetime = $main::point_lifetime;
#		$valid_flag = 1;
#	}
#}
if (defined $main::checkout_window_type && ($main::checkout_window_type eq 'self' || $main::checkout_window_type eq 'iframe' || $main::checkout_window_type eq 'new')) {
	if ($main::checkout_window_type eq $env::checkout_window_type) {
		undef $main::checkout_window_type;
	} else {
		$checkout_window_type = $main::checkout_window_type;
		$cart_js_changed = $valid_flag = 1;
	}
}
if (defined $main::checkout_window_width && $main::checkout_window_width ne '') {
	if ($main::checkout_window_width eq $env::checkout_window_width) {
		undef $main::checkout_window_width;
	} elsif ($this->is_nan($main::checkout_window_width)) {
		push(@{$this->{'dialog'}},'åȥɥȾѿꤷƤ');
		$error_flag = 1;
	} else {
		$cart_js_changed = $valid_flag = 1;
		$checkout_window_width = int($main::checkout_window_width);
	}
}
if (defined $main::checkout_window_height && $main::checkout_window_height ne '') {
	if ($main::checkout_window_height eq $env::checkout_window_height) {
		undef $main::checkout_window_height;
	} elsif ($this->is_nan($main::checkout_window_height)) {
		push(@{$this->{'dialog'}},'åȥɥ⤵ȾѿꤷƤ');
		$error_flag = 1;
	} else {
		$cart_js_changed = $valid_flag = 1;
		$checkout_window_height = int($main::checkout_window_height);
	}
}
if (defined $main::checkout_window_top && $main::checkout_window_top ne '') {
	if ($main::checkout_window_top eq $env::checkout_window_top) {
		undef $main::checkout_window_top;
	} elsif ($this->is_nan($main::checkout_window_top)) {
		push(@{$this->{'dialog'}},'åȥե졼ľ֤ȾѿꤷƤ');
		$error_flag = 1;
	} else {
		$cart_js_changed = $valid_flag = 1;
		$checkout_window_top = int($main::checkout_window_top);
	}
}
if (defined $main::checkout_window_left && $main::checkout_window_left ne '') {
	if ($main::checkout_window_left eq $env::checkout_window_left) {
		undef $main::checkout_window_left;
	} elsif ($this->is_nan($main::checkout_window_left)) {
		push(@{$this->{'dialog'}},'åȥե졼ʿ֤ȾѿꤷƤ');
		$error_flag = 1;
	} else {
		$cart_js_changed = $valid_flag = 1;
		$checkout_window_left = int($main::checkout_window_left);
	}
}

#env.pl񤭴
if ($valid_flag && !$error_flag) {
	local(*FILE);
	my($data,$env_path);
	$env_path = $default::cgi_data . '/lib/env.pl';
	$data = $this->read_file($env_path);
	$data =~ s/^[\x20\x09]*\$tax_rate[\x20\x09]*=[^;]*;/\$tax_rate = $tax_rate;/gm if defined $tax_rate && $tax_rate ne '';
	$data =~ s/^[\x20\x09]*\$tax_frac[\x20\x09]*=[^;]*;/\$tax_frac = '$tax_frac';/gm if defined $tax_frac && $tax_frac ne '';
	$data =~ s/^[\x20\x09]*\$tax_included[\x20\x09]*=[^;]*;/\$tax_included = $tax_included;/gm if defined $tax_included && $tax_included ne '';
	$data =~ s/^[\x20\x09]*\$point_lifetime[\x20\x09]*=[^;]*;/\$point_lifetime = $point_lifetime;/gm if defined $point_lifetime && $point_lifetime ne '';
	$data =~ s/^[\x20\x09]*\$checkout_window_type[\x20\x09]*=[^;]*;/\$checkout_window_type = '$checkout_window_type';/gm if defined $checkout_window_type && $checkout_window_type ne '';
	$data =~ s/^[\x20\x09]*\$checkout_window_width[\x20\x09]*=[^;]*;/\$checkout_window_width = $checkout_window_width;/gm if defined $checkout_window_width && $checkout_window_width ne '';
	$data =~ s/^[\x20\x09]*\$checkout_window_height[\x20\x09]*=[^;]*;/\$checkout_window_height = $checkout_window_height;/gm if defined $checkout_window_height && $checkout_window_height ne '';
	$data =~ s/^[\x20\x09]*\$checkout_window_top[\x20\x09]*=[^;]*;/\$checkout_window_top = $checkout_window_top;/gm if defined $checkout_window_top && $checkout_window_top ne '';
	$data =~ s/^[\x20\x09]*\$checkout_window_left[\x20\x09]*=[^;]*;/\$checkout_window_left = $checkout_window_left;/gm if defined $checkout_window_left && $checkout_window_left ne '';
	if (open (FILE, ">>$env_path")) {
		binmode FILE;
		flock(FILE, LOCK_EX);
		truncate(FILE, 0);
		seek(FILE, 0, 0);
		print FILE $data;
		close(FILE);
		push(@{$this->{'dialog'}},'ǡȾ򹹿ޤ');
		$env::tax_rate = $tax_rate if defined $tax_rate && $tax_rate ne '';
		$env::tax_frac = $tax_frac if defined $tax_frac && $tax_frac ne '';
		$env::tax_included = $tax_included if defined $tax_included && $tax_included ne '';
		$env::point_lifetime = $point_lifetime if defined $point_lifetime && $point_lifetime ne '';
		$env::checkout_window_type = $checkout_window_type if defined $checkout_window_type && $checkout_window_type ne '';
		$env::checkout_window_width = $checkout_window_width if defined $checkout_window_width && $checkout_window_width ne '';
		$env::checkout_window_height = $checkout_window_height if defined $checkout_window_height && $checkout_window_height ne '';
		$env::checkout_window_top = $checkout_window_top if defined $checkout_window_top && $checkout_window_top ne '';
		$env::checkout_window_left = $checkout_window_left if defined $checkout_window_left && $checkout_window_left ne '';
		undef $main::tax_rate;
		undef $main::tax_frac;
		undef $main::tax_included;
		undef $main::point_lifetime;
		undef $main::checkout_window_type;
		undef $main::checkout_window_width;
		undef $main::checkout_window_height;
		undef $main::checkout_window_top;
		undef $main::checkout_window_left;
		$this->mk_cart_js if $cart_js_changed;
	} else {
		push(@{$this->{'dialog'}},'ǡȾι˼Ԥޤ');
	}
} elsif (defined $error_flag && $error_flag) {
	push(@{$this->{'dialog'}},'ǡȾι˼Ԥޤ');
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>ǡȾѹ</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=>	'return confirm(\'ϼäޤѹޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="1" />';
print '<fieldset><table class="field-table"><tbody>';
print '<tr>';
print '<td class="field-name"><label for="tax_rate">Ψ</label></td>';
print '<td class="field"><input type="text" name="tax_rate" id="tax_rate" size="4" value="' . ((defined $main::tax_rate) ? $main::tax_rate : (defined $env::tax_rate) ? $env::tax_rate * 100 : '') . '" /> %';
print '<div class="hints">0 %ꤹȾǤη׻򤷤ޤ</div>';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="tax_frac">ü</label></td>';
print '<td class="field"><select name="tax_frac" id="tax_frac">';
print '<option value="ceil"' . (((defined $main::tax_frac && $main::tax_frac eq 'ceil') || (!defined $main::tax_frac && $env::tax_frac eq 'ceil')) ? ' selected="selected"' : '') . '>ڤ夲</option>';
print '<option value="round"' . (((defined $main::tax_frac && $main::tax_frac eq 'round') || (!defined $main::tax_frac && $env::tax_frac eq 'round')) ? ' selected="selected"' : '') . '>ͼθ</option>';
print '<option value="floor"' . (((defined $main::tax_frac && $main::tax_frac eq 'floor') || (!defined $main::tax_frac && $env::tax_frac eq 'floor')) ? ' selected="selected"' : '') . '>ڤΤ</option>';
print '</select>';
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="tax_included">ɽ</label></td>';
print '<td class="field"><select name="tax_included" id="tax_included">';
print '<option value="1"' . (((defined $main::tax_included && $main::tax_included eq '1') || (!defined $main::tax_included && $env::tax_included eq '1')) ? ' selected="selected"' : '') . '></option>';
print '<option value="0"' . (((defined $main::tax_included && $main::tax_included eq '0') || (!defined $main::tax_included && $env::tax_included eq '0')) ? ' selected="selected"' : '') . '></option>';
print '</select>';
print '</td>';
print '</tbody><tbody>';
#print '<tr class="tbody-end">';
#print '<td class="field-name"><label for="point_lifetime">ݥͭ</label></td>';
#print '<td class="field">';
#print '<input type="text" name="point_lifetime" id="point_lifetime" size="4" value="' . $this->escape((defined $main::point_lifetime) ? $main::point_lifetime : $env::point_lifetime) . '" /> ͭ';
#print '(üݥȤ' . (($env::tax_frac eq 'floor') ? 'ڤ夲' : (($env::tax_frac eq 'round') ? 'ͼθ' : 'ڤ겼')) . ')';
#print '<div class="hints">ߤ=' . $env::point_lifetime . '</div>';
#print '<div class="hints">̵ξѹޤ</div>';
#print '</td>';
#print '</tr>';
#print '</tbody><tbody>';
print '<tr>';
print '<td class="field-name"><label for="checkout_window_type">åȥġ</label></td><td class="field"><select name="checkout_window_type" id="checkout_window_type">';
print '<option value="new"' . (((defined $main::checkout_window_type && $main::checkout_window_type eq 'new') || (!defined $main::checkout_window_type && $env::checkout_window_type eq 'new')) ? ' selected="selected"' : '') . '>̤Υɥǳ</option>';
print '<option value="iframe"' . (((defined $main::checkout_window_type && $main::checkout_window_type eq 'iframe') || (!defined $main::checkout_window_type && $env::checkout_window_type eq 'iframe')) ? ' selected="selected"' : '') . '>饤ե졼ǳ</option>';
print '<option value="self"' . (((defined $main::checkout_window_type && $main::checkout_window_type eq 'self') || (!defined $main::checkout_window_type && $env::checkout_window_type eq 'self')) ? ' selected="selected"' : '') . '>Ʊɥǳ</option>';
print '</select>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="tax_rate">å' . (($env::checkout_window_type && $env::checkout_window_type eq 'iframe') ? 'ե졼' : 'ɥ') . '</label></td>';
print '<td class="field"><input type="text" name="checkout_window_width" id="checkout_window_width" size="4" value="' . $this->escape((defined $main::checkout_window_width) ? $main::checkout_window_width : $env::checkout_window_width) . '" /> px';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="tax_rate">å' . (($env::checkout_window_type && $env::checkout_window_type eq 'iframe') ? 'ե졼' : 'ɥ') . '⤵</label></td>';
print '<td class="field"><input type="text" name="checkout_window_height" id="checkout_window_height" size="4" value="' . $this->escape((defined $main::checkout_window_height) ? $main::checkout_window_height : $env::checkout_window_height) . '" /> px';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="tax_rate">åȥե졼ľɽ</label></td>';
print '<td class="field"><input type="text" name="checkout_window_top" id="checkout_window_top" size="4" value="' . $this->escape((defined $main::checkout_window_top) ? $main::checkout_window_top : $env::checkout_window_top) . '" /> px';
print '<div class="hints">ޥʥͤꤹȥڡüεΥȤʤޤ</div>';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="tax_rate">åȥե졼ʿɽ</label></td>';
print '<td class="field"><input type="text" name="checkout_window_left" id="checkout_window_left" size="4" value="' . $this->escape((defined $main::checkout_window_left) ? $main::checkout_window_left : $env::checkout_window_left) . '" /> px';
print '<div class="hints">ޥʥͤꤹȥڡüεΥȤʤޤ</div>';
print '</td>';
print '</tr>';
print '</tbody></table></fieldset>';
print '<fieldset class="submit"><input type="submit" value="ѹ" class="save" /></fieldset></form>';

#ڡեå
$this->print_page_footer('tools');
}

sub mk_cart_js ($) {
my $this = shift;
my $cart_js = $this->read_file($env::javascript . '/cart.js',1);
return 0 if !$cart_js;
$cart_js =~ s/(\s+)type : .*?,/${1}type : "$env::checkout_window_type",/mg if defined $env::checkout_window_type && $env::checkout_window_type ne '';
$cart_js =~ s/(\s+)margin_top : .*?,/${1}margin_top : $env::checkout_window_top,/mg if defined $env::checkout_window_top && $env::checkout_window_top ne '';
$cart_js =~ s/(\s+)margin_left : .*?,/${1}margin_left : $env::checkout_window_left,/mg if defined $env::checkout_window_left && $env::checkout_window_left ne '';
$cart_js =~ s/(\s+)target_width : .*?,/${1}target_width : $env::checkout_window_width,/mg if defined $env::checkout_window_width && $env::checkout_window_width ne '';
$cart_js =~ s/(\s+)target_height : .*?,/${1}target_height : $env::checkout_window_height,/mg if defined $env::checkout_window_height && $env::checkout_window_height ne '';
return $this->write_file($env::javascript . '/cart.js',\$cart_js,1);
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
if (defined $env::checkout && $env::checkout) {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('00s1','CartSetting');

	#˥塼Ͽ
	$setting::jump_menu{'00s1'} = 'ǡȾѹ';

}
}



1;
