package JavaScriptUpdater;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use strict;
use Fcntl qw(:flock);
######################################################################
# JavaScriptåץǡ⥸塼
# JavaScriptUpdater.pm ver1.0.5
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-07-02
######################################################################
# ¹
sub run ($) {
my $this = shift;
$this->get_setup_env;
my $updater_enabled = (-d $env::template_dir . '/site/default/htdocs/lib/javascript') ? 1 : 0;

#åץǡ
$this->update if $updater_enabled && $main::update;


#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>JavaScript åץǡ</h1>';
print '<p>"' . $this->get_path_for_log($env::template_dir) . '/site/default/htdocs/lib/javascript" ʲΥեƤΥȥƥץ졼ȤƤΥ֥ǥ쥯ȥ javascript ե˾񤭥ԡޤ</p>';
if (!$updater_enabled) {
	print '<fieldset>åץǡȤɬפʥƥץ졼ȤߤĤޤ</fieldset>';
} else {
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'method'	=>	'post',
		'onsubmit'	=>	'return confirm(\'ϼäޤѹޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
		'required'	=>	\@setting::form
	);
	if ($this->{'update_log'}) {
		print '<fieldset><legend>JavaScript åץǡȥ</legend><ol>';
		print $this->{'update_log'};
		print '</ol></fieldset>';
	}
	print '<fieldset class="submit"><input type="submit" name="update=1" value="JavaScript 򥢥åץǡȤ" /></fieldset></form>';
}

#ڡեå
$this->print_page_footer('tools');
}

sub get_path_for_log ($$) {
my($this,$path) = @_;
$path =~ s/^(?:\.\.\/)+/~\//;
return $path;
}

sub update ($) {
my $this = shift;
my($dir);
local(*TEMP);
foreach $dir ('',$this->sub_directory_scan($default::cgi_data_root)) {
	$this->javascript_update($dir);
}
if (opendir(TEMP,$env::template_dir . '/site')) {
	my @template = grep($_ ne 'default' && $_ !~ /\./ && -d $env::template_dir . '/site/' . $_,readdir(TEMP));
	closedir(TEMP);
	foreach $dir (@template) {
		$this->javascript_update($dir,1);
	}
}
return $this;
}

sub update_log ($) {
my $this = shift;
return $this->{'update_log'};
}

sub javascript_update ($$;$$) {
my($this,$home_dir,$is_template,$home_rel) = @_;
$home_dir =~ s!^/!!;
$home_rel = '../../' . $home_dir if !$home_rel;
my $new_version = $env::template_dir . '/site/default/htdocs/lib/javascript';
my $javascript_dir;
my $cart_enabled = (-f (($is_template) ? $env::template_dir . '/site/' . $home_dir . '/htdocs/cgi/order/start.cgi' : (!$home_dir) ? ($env::checkout) ? $env::checkout : '../order/start.cgi' : $home_rel . '/cgi/order/start.cgi')) ? 1 : 0;
my(@files,@directories,$entry,$f,$env_javascript,$env_home_dir_id,$env_checkout_window_type,$env_checkout_window_width,$env_checkout_window_height,$env_checkout_window_top,$env_checkout_window_left);
local(*SUBDIR);
return 0 unless opendir(SUBDIR,$new_version);
while ($entry = readdir(SUBDIR)) {
	next if $entry =~ /^\./;
	my $path = $new_version . '/' . $entry;
	if (-f $path) {
		push(@files,$entry);
	} elsif (-d $path) {
		push(@directories,$entry);
	}
}
closedir(SUBDIR);
if ($is_template) {
	$javascript_dir = $env::template_dir . '/site/' . $home_dir . '/htdocs/lib/javascript';
	return 0 if !-d $javascript_dir;
	$env_home_dir_id = '';
	$env_javascript = $this->get_path_for_log($env::template_dir) . '/site/' . $home_dir . '/htdocs/lib/javascript';
	$this->{'update_log'} .= '<li>' . $env_javascript . '</li>';
	my $env_data = $this->read_file($env::template_dir . '/site/' . $home_dir . '/env.bak');
	if ($env_data) {
		if ($env_data =~ /^checkout_window_type\x09([0-9a-zA-Z_]+)$/m) {
			$env_checkout_window_type = $1;
		}
		if ($env_data =~ /^checkout_window_width\x09(\-?[0-9]+)$/m) {
			$env_checkout_window_width = $1;
		}
		if ($env_data =~ /^checkout_window_height\x09(\-?[0-9]+)$/m) {
			$env_checkout_window_height = $1;
		}
		if ($env_data =~ /^checkout_window_top\x09(\-?[0-9]+)$/m) {
			$env_checkout_window_top = $1;
		}
		if ($env_data =~ /^checkout_window_left\x09(\-?[0-9]+)$/m) {
			$env_checkout_window_left = $1;
		}
	}
} else {
	my $multi_domain;
	if ($home_dir && -f $default::cgi_data_root . '/' . $home_dir . '/lib/env.pl') {
		my $env_data = $this->read_file($default::cgi_data_root . '/' . $home_dir . '/lib/env.pl');
		if ($env_data) {
			if ($env_data =~ /^[\x20\x09]*\$home_dir_id[\x20\x09]*=[\x20\x09]*["'](.*?)["'][\x20\x09]*;/m) {
				$env_home_dir_id = $1;
			}
			if ($env_data =~ /^[\x20\x09]*\$multi_domain[\x20\x09]*=[\x09\x0A\x0C\x0D\x20]*["']?([^'"]+)["']?;/m) {
				$multi_domain = 1;
			}
			if ($env_data =~ /^[\x20\x09]*\$checkout_window_type[\x20\x09]*=[\x20\x09]*["']([0-9a-zA-Z_]+)["'][\x20\x09]*;/m) {
				$env_checkout_window_type = $1;
			}
			if ($env_data =~ /^[\x20\x09]*\$checkout_window_width[\x20\x09]*=[\x20\x09]*(-?[0-9]+)[\x20\x09]*;/m) {
				$env_checkout_window_width = $1;
			}
			if ($env_data =~ /^[\x20\x09]*\$checkout_window_height[\x20\x09]*=[\x20\x09]*(-?[0-9]+)[\x20\x09]*;/m) {
				$env_checkout_window_height = $1;
			}
			if ($env_data =~ /^[\x20\x09]*\$checkout_window_top[\x20\x09]*=[\x20\x09]*(-?[0-9]+)[\x20\x09]*;/m) {
				$env_checkout_window_top = $1;
			}
			if ($env_data =~ /^[\x20\x09]*\$checkout_window_left[\x20\x09]*=[\x20\x09]*(-?[0-9]+)[\x20\x09]*;/m) {
				$env_checkout_window_left = $1;
			}
		}
		$javascript_dir = $home_rel . '/lib/javascript';
	} else {
		$env_home_dir_id = '';
		$javascript_dir = $env::javascript;
		$env_checkout_window_type = $env::checkout_window_type;
		$env_checkout_window_width = $env::checkout_window_width;
		$env_checkout_window_height = $env::checkout_window_height;
		$env_checkout_window_top = $env::checkout_window_top;
		$env_checkout_window_left = $env::checkout_window_left;
	}
	$env_javascript = $this->path_change($javascript_dir,$ENV{'SCRIPT_NAME'},'abs');
	$this->{'update_log'} .= '<li>' . $env_javascript . '</li>';
	$env_javascript =~ s!^/[^/]+!! if $multi_domain;
}
foreach $f (@files) {
	if ($f eq 'cmonos.js') {
		my $old = $this->read_file($javascript_dir . '/cmonos.js',1);
		my $new = $this->read_file($new_version . '/cmonos.js',1);
		my $sync_buttons = ($old =~ /var sync_button_classes = new Array\(([^\)]*)\);/) ? $1 : '';
		$new =~ s/(var sync_button_classes = new Array\()[^\)]*(\);)/$1$sync_buttons$2/si;
		if (!$is_template) {
			$new =~ s!(\.\./\.\./|/)lib/javascript!$env_javascript!g;
			$new =~ s/parent\.main/parent\.${env_home_dir_id}main/g;
			$new =~ s/parent\.navi/parent\.${env_home_dir_id}navi/g;
		}
		$new =~ s!^//(cmonos\.init\.loadCartJs\(\);)!$1!m if $cart_enabled;
		$this->write_file($javascript_dir . '/cmonos.js',\$new,1);
	} elsif ($f eq 'cart.js') {
		my $cart_js = $this->read_file($new_version . '/cart.js',1);
		$cart_js =~ s/([\x09\x0A\x0C\x0D\x20]+)type : .*?,/${1}type : "$env_checkout_window_type",/mg if defined $env_checkout_window_type && $env_checkout_window_type ne '';
		$cart_js =~ s/([\x09\x0A\x0C\x0D\x20]+)margin_top : .*?,/${1}margin_top : $env_checkout_window_top,/mg if defined $env_checkout_window_top && $env_checkout_window_top ne '';
		$cart_js =~ s/([\x09\x0A\x0C\x0D\x20]+)margin_left : .*?,/${1}margin_left : $env_checkout_window_left,/mg if defined $env_checkout_window_left && $env_checkout_window_left ne '';
		$cart_js =~ s/([\x09\x0A\x0C\x0D\x20]+)target_width : .*?,/${1}target_width : $env_checkout_window_width,/mg if defined $env_checkout_window_width && $env_checkout_window_width ne '';
		$cart_js =~ s/([\x09\x0A\x0C\x0D\x20]+)target_height : .*?,/${1}target_height : $env_checkout_window_height,/mg if defined $env_checkout_window_height && $env_checkout_window_height ne '';
		$this->write_file($javascript_dir . '/cart.js',\$cart_js,1);
	} else {
		$this->file_copy($new_version . '/' . $f,$javascript_dir . '/' . $f);
	}
}
if (@directories) {
	my $d;
	foreach $d (@directories) {
		$this->directory_copy($new_version . '/' . $d,$javascript_dir . '/' . $d,1);
	}
}
return 1;
}

#ѹʥåץǡȤɬפʾѡ
sub text_replace ($$$$;$$) {
my($this,$path,$old,$new,$quote,$log_ref) = @_;
my $data = $this->read_file($path,1);
$old = quotemeta $old if $quote;
if ($data =~ s/$old/$new/sg) {
	$this->write_file($path,\$data,1);
	$log_ref->{$path} = 1 if ref $log_ref;
}
}

sub sub_directory_scan ($$) {
my($this,$dir,$home_dir) = @_;
my(@directories,@sub_directories,$entry,$d);
@directories = @sub_directories = ();
local(*DIR);
return unless opendir(DIR,$dir);
$home_dir = '' if !defined $home_dir;
while ($entry = readdir(DIR)) {
	next if $entry =~ /^\./;
	my $path = $dir . '/' . $entry;
	push(@directories,$entry) if -d $dir . '/' . $entry && -f $dir . '/' . $entry . '/lib/env.pl';
}
closedir(DIR);
foreach $d (@directories) {
	push(@sub_directories,$home_dir . '/' . $d,$this->sub_directory_scan($dir . '/' . $d,$home_dir . '/' . $d));
}
return @sub_directories;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('s303','JavaScriptUpdater');

	#˥塼Ͽ
	$setting::jump_menu{'s303'} = 'JavaScript åץǡ';

}



1;
