package MobileRedirect;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ӥ쥯ȥ⥸塼
# FTPAccess.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-03-06
######################################################################
# ¹
sub run ($) {
my $this = shift;
my $htaccess = $this->read_file('../../.htaccess',1);
my $redirect_ready = ($htaccess =~ /# For Mobile - start -.*?# For Mobile - end -/s) ? 1 : 0;
if ($main::toggle) {
	if ($redirect_ready) {
		$htaccess =~ s/\s?# For Mobile - start -.*?# For Mobile - end -\s?//s;
		$redirect_ready = 0;
		push(@{$this->{'dialog'}},'ӥ쥯Ȥޤ');
	} else {
		my $this_dir = $this->path_change('../../',$ENV{'SCRIPT_NAME'},'abs');
		$this_dir .= '/' if $this_dir !~ m!/$!;
my $redirect_rule = <<REDIRECT;

# For Mobile - start -
<IfModule mod_rewrite.c>
RewriteEngine On
RewriteCond \%{HTTP_USER_AGENT} (DoCoMo|J-PHONE|Vodafone|SoftBank|KDDI|UP\\.Browser) [NC]
RewriteCond \%{HTTP_USER_AGENT} !MCONV
RewriteCond \%{REQUEST_URI} !/m\\.cgi
RewriteCond \%{REQUEST_URI} (/|\\.html|\\.htm|\\.shtml)\$
RewriteRule ^(.*)\$ ${this_dir}m.cgi/\$1 [L,R]
</IfModule>
# For Mobile - end -
REDIRECT
		$htaccess .= $redirect_rule unless $htaccess =~ s/\s?# For Mobile - start -.*?# For Mobile - end -\s?/$redirect_rule/s;
		$redirect_ready = 1;
		push(@{$this->{'dialog'}},'ӥ쥯Ȥꤷޤ');
	}
	$this->write_file('../../.htaccess',\$htaccess,1);
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>ӥ쥯</h1>';
print '<p class="warning">Υǥ쥯ȥʲ˵켰ӥ֥饦饢äȤ켰ӥ֥饦ɽѴ URL ˥쥯Ȥ뤫ɤꤷޤ mod_rewrite ѤǤĶǤΤͭǤʤmod_rewrite бĶǥ쥯ԤƤΥ顼Ȥʤ礬ޤΤǤդ顼ˤĤƤϥޥ˥奢</p>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);
print '<fieldset class="submit"><input type="submit" name="toggle=1" value="' . (($redirect_ready) ? 'ӥ쥯Ȥ' : 'ӥ쥯Ȥꤹ') . '" /></fieldset></form>';

require CMONOS::CGI_Lib::HTTP_Client;
my $mobile_url = $this->full_path('../../m.cgi/');
my $res = HTTP_Client->new->request(
	'GET' => 'http://chart.apis.google.com/chart?chs=160x160&cht=qr&chl=' . $this->url_encode($mobile_url),
	{},'','','',
	'../../qr.png'
);
if ($res->is_success && -f '../../qr.png') {
	my $img = '<img src="' . $this->full_path('../../qr.png') . '" width="160" height="160" border="0" alt="' . $this->escape($mobile_url) . '" title="' . $this->escape($mobile_url) . '" />';
	print '<form action="\#"><fieldset><legend>QR  (by <a href="http://code.google.com/intl/ja-JP/apis/chart/" target="_blank">Google Chart Tools</a>)</legend><p>' . $img . '</p><textarea rows="2" cols="90" />' . $this->escape($img) . '</textarea></fieldset></form>';
}
$res = HTTP_Client->new->request(
	'GET' => 'http://chart.apis.google.com/chart?chs=100x100&cht=qr&chl=' . $this->url_encode($mobile_url),
	{},'','','',
	'../../qr_mini.png'
);
if ($res->is_success && -f '../../qr_mini.png') {
	my $img = '<img src="' . $this->full_path('../../qr_mini.png') . '" width="100" height="100" border="0" alt="' . $this->escape($mobile_url) . '" title="' . $this->escape($mobile_url) . '" />';
	print '<form action="\#"><fieldset><legend>QR  (by <a href="http://code.google.com/intl/ja-JP/apis/chart/" target="_blank">Google Chart Tools</a>)</legend><p>' . $img . '</p><textarea rows="2" cols="90" />' . $this->escape($img) . '</textarea></fieldset></form>';
}

#ڡեå
$this->print_page_footer('tools');

}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
if ($env::ownerpower) {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('00s3','MobileRedirect');

	#˥塼Ͽ
	$setting::jump_menu{'00s3'} = 'ӥ쥯';

}
}



1;
