package SiteTemplateImporter;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use strict;
######################################################################
# ȥƥץ졼ɤ߹ߥ⥸塼
# SiteTemplateImporter.pm ver1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-04-18
######################################################################
# ¹
sub run ($) {
my $this = shift;
$this->get_setup_env;
unless (eval 'use Archive::Tar;Archive::Tar->has_zlib_support;') {
	$this->jump_menu('tools');
	$this->print_page_header('tools');
	print '<h1>ȥƥץ졼ɤ߹</h1>';
	print '<p>Archive::Tar ⥸塼뤬ߤĤʤᡢεǽѤǤޤ󡣤Υޥ˥奢<a href="http://cmonos.jp/manual/setup_assistant/how/site_template_install.html" target="_blank">ȥƥץ졼ȤƳ</a>פ</p>';
	$this->print_page_footer('tools');
	return 1;
}
use File::Path;
require CMONOS::CGI_Lib::HTTP_Client;

#ȥե
my $temp_dir = $env::clipboard . '/site_template_importer' . ($env::home_dir_id || '');
my $status_file = $temp_dir . '/status';
my $pending_time = (!-f $status_file) ? 0 : time - (stat($status_file))[9];
if (-d $temp_dir && $pending_time > 600) {
	push(@{$this->{'dialog'}},'󥵥ȥƥץ졼Ȥɤ߹ߤޤϲ˼Ԥǽޤȥեޤ');
	rmtree $temp_dir;
}
my $status = $this->read_file($status_file,1) || 0;

#ɤ߹߽
if ($main::a) {
	my $tgz_file = '';
	my $temp_name = '';
	if ($main::file) {
		if ($main::file =~ /^(\w+)\.(?:tar\.gz|tgz)$/i) {
			$temp_name = $1;
			$this->set_dir($temp_dir);
			$this->write_file($status_file,1,1);
			$cgi::input->save_file('file','<client>','','',$temp_dir);
			$tgz_file = $temp_dir . '/' . $main::file;
		} else {
			push(@{$this->{'dialog'}},'ȥƥץ졼ȤɲäǤޤǤtar-gzip ǰ̤줿ե򥢥åץɤƤĥҤϡ.tar.gzפޤϡ.tgzפǤե̾ȾѱѿˤƤ');
		}
		$cgi::input->clear_clipboard;
	} elsif ($main::filename) {
		if ($main::filename !~ /^\w+\.(?:tar\.gz|tgz)$/) {
			push(@{$this->{'dialog'}},'ȥƥץ졼ȤɲäǤޤǤꤵ줿ȥƥץ졼Ȥ¸ߤޤ');
		} else {
			$this->set_dir($temp_dir);
			$this->write_file($status_file,1,1);
			HTTP_Client->new->request('GET' => 'http://cmonos.jp/download/site_templates/' . $main::filename,{},'','','',$temp_dir . '/' . $main::filename);
			$tgz_file = $temp_dir . '/' . $main::filename;
		}
	} else {
		push(@{$this->{'dialog'}},'ȥƥץ졼ȤɲäǤޤǤȥƥץ졼ȤꤵƤޤ');
	}
	if ($tgz_file && -f $tgz_file) {
		$this->write_file($status_file,2,1);
		my $tar = Archive::Tar->new();
		$tar->setcwd($temp_dir);
		$tar->read($tgz_file,1);
		$tar->extract();
		$this->write_file($status_file,3,1);
		my $new_template = $temp_dir . '/' . $temp_name;
		if (-f $temp_dir . '/env.bak') {
			local(*DIR);
			if (opendir(DIR,$temp_dir)) {
				my @files = grep($_ ne 'status' && $_ ne $main::file && $_ !~ /^\./,readdir(DIR));
				closedir(DIR);
				$this->set_dir($new_template);
				foreach my $f (@files) {
					rename($temp_dir . '/' . $f,$new_template . '/' . $f);
				}
			}
		} else {
			$new_template = $this->fileglob($temp_dir,'^[a-zA-Z][a-zA-Z0-9]{0,32}$','d');
		}
		my $site_template_dir = $env::user_site_template_dir || $env::template_dir . '/site';
		if (!$new_template) {
			push(@{$this->{'dialog'}},'ȥƥץ졼ȤɲäǤޤǤȥƥץ졼ȥե̾ȾѱѻǻϤޤ32ʸȾѱѿˤƤ');
		} elsif (!-f $new_template . '/env.bak') {
			push(@{$this->{'dialog'}},'ȥƥץ졼ȤɲäǤޤǤꤵ줿եϥȥƥץ졼ȤǤϤޤ');
		} elsif (!$this->set_dir($site_template_dir)) {
			push(@{$this->{'dialog'}},'ȥƥץ졼ȤɲäǤޤǤȥƥץ졼¸ǥ쥯ȥǤޤǤ');
		} else {
			my $new_name;
			if ($new_template =~ /\/([a-zA-Z0-9]+)$/) {
				$new_name = $1;
			} elsif ($temp_name) {
				$new_name = $temp_name;
			} else {
				$new_name = 'NewSiteTemplate';
				undef $main::replace;
			}
			my $suffix = (!$env::user_site_template_dir && $main::closed) ? $this->directory_suffix : '';
			if (-d $site_template_dir . '/' . $new_name . $suffix) {
				if ($main::replace) {
					rmtree $site_template_dir . '/' . $new_name . $suffix;
				} else {
					my $n = ($new_name =~ s/(\d+)$//) ? $1 : 2;
					while (-d $site_template_dir . '/' . $new_name . $n . $suffix) {
						$n++;
					}
					$new_name .= $n;
				}
			}
			if (rename($new_template,$site_template_dir . '/' . $new_name . $suffix)) {
				my $temp_label = $new_name . (($main::closed) ? ($default::home_dir) ? '@~' . $this->escape($default::home_dir) : '@~/' : '');
				my($title) = split(/\x09/,$this->read_file($site_template_dir . '/' . $new_name . $suffix . '/name.txt'));
				push(@{$this->{'dialog'}},'ȥƥץ졼ȡ' . $this->site_template_title($title,$temp_label) . 'פɲäޤ');
			} else {
				push(@{$this->{'dialog'}},'ȥƥץ졼ȤɲäǤޤǤȥƥץ졼ȥե˥ԡǤޤǤ');
			}
		}
	}
	rmtree $temp_dir if -d $temp_dir;
	$status = 0;
}

my $res = HTTP_Client->new->request('GET' => 'http://cmonos.jp/download/site_templates/list.txt');
my $site_templates_list = ($res->is_success) ? $res->content('euc') : '';

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>ȥƥץ졼ɤ߹</h1>';

if ($status) {
	print '<p>';
	if ($status == 1) {
		print 'ȥƥץ졼ȥեɤ߹Ǥޤ... (ɤ߹ߤ˼ԤƤ硢' . (($pending_time) ? 10 - int($pending_time/60) : 10) . 'ʬ˺ȥեޤ)';
	} elsif ($status == 2) {
		print 'ȥƥץ졼ȥեषƤޤ... (̤˼ԤƤ硢' . (($pending_time) ? 10 - int($pending_time/60) : 10) . 'ʬ˺ȥեޤ)';
	} elsif ($status == 3) {
		print 'ȥƥץ졼ȥեŬڤʰ֤˰ưƤޤ...';
	} else {
		print '...';
	}
	print '</p>';
} else {
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'multi'	=>	1,
		'method'	=>	'post',
		'onsubmit'	=>	'return cmonos.form.item(this).isNotSubmitted();',
		'required'	=>	\@setting::form
	);
	print '<input type="hidden" name="a" value="1" />';
	if ($site_templates_list) {
		print '<fieldset><legend><a href="http://cmonos.jp/download/" target="_blank">CMONOS.JP</a> 饵ȥƥץ졼Ȥɤ߹</legend><ol class="checkbox">';
		while ($site_templates_list =~ /^(.*?)$/mg) {
			my $line  = $1;
			chomp $line;
			my($file,$name,$summary) = split(/\x09/,$line);
			print '<li><label><input type="radio" name="filename" value="' . $file . '"' . (($main::filename && $main::filename eq $file) ? ' checked="checked"' : '') . ' />' . $name . ' : ' . $summary . '</label></li>';
		}
		print '</ol></fieldset>';
	}
	print '<fieldset><legend><label for="file">ȥƥץ졼ȥե(tar-gzip)򥢥åץɤ</label></legend><input type="file" name="file" id="file" /></fieldset>';
	print '<fieldset><legend>Ʊ̾Υȥƥץ졼ȥե¸ߤ</legend><ol class="checkbox">';
	print '<li><label><input type="radio" name="replace" value="0" ' . ((!$main::replace) ? ' checked="checked"' : '') . '/> ȥƥץ졼ȥե̾˿ɲä</label></li>';
	print '<li><label><input type="radio" name="replace" value="1" ' . (($main::replace) ? ' checked="checked"' : '') . '/> ȥƥץ졼ȥեƱ̾Υȥƥץ졼ȥե񤭤</label></li>';
	print '</ol></fieldset>';
	if (!$env::user_site_template_dir) {
		print '<fieldset>';
		print '<legend></legend>';
		print '<label><input type="checkbox" name="closed" id="closed" value="1"' . (($main::closed) ? ' checked="checked"' : '') . ' /> ̥ǥ쥯ȥ꤫餳Υȥƥץ졼Ȥ򱣤</label>';
		print '</fieldset>';
	}
	print '<fieldset class="submit"><input type="submit" value="ȥƥץ졼Ȥɤ߹" /></fieldset>';
}

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('s701','SiteTemplateImporter');

	#˥塼Ͽ
	$setting::jump_menu{'s701'} = 'ȥƥץ졼ɤ߹';

}



1;
