package SCOrderPaymentMethod;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# ʧˡ⥸塼
# SCOrderPaymentMethod.pm 1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-02-13
######################################################################
#	(0)-3 եDB
sub db ($) {
my $this = shift;
return 'payment';
}

# --------------------------------------------------------------------
sub __set ($$) {
my $this = shift;
my $i = 0;
$this->{'payment_methods'} = [];
$this->import_db($default::preference_dir . '/terms',\%setting::payment,1) if !%setting::payment;
$this->{'field_for'}{'payment_method'} = $this->{'id'};
if ($setting::payment{'bankenabled'}) {
	my $n;
	foreach $n (sort {$a <=> $b || $a cmp $b} keys %{$setting::payment{'bank'}}) {
		$this->{'payment_methods'}[$i++] = {'id' => 'bank:' . $n,'name' => $setting::payment{'bank'}{$n}{'bank'}};
	}
}
$this->{'payment_methods'}[$i++] = {'id' => 'yubin','name' => '椦(͹ؿ)'} if $setting::payment{'yubinenabled'};
$this->{'payment_methods'}[$i++] = {'id' => 'paypal','name' => 'PayPal'} if $setting::payment{'paypalenabled'};
$this->{'payment_methods'}[$i++] = {'id' => 'cod','name' => ''} if $setting::payment{'codenabled'};
$this->{'payment_methods'}[$i++] = {'id' => 'moneyorder','name' => '۾'} if $setting::payment{'moneyorderenabled'};
if ($setting::payment{'otherenabled'}) {
	my $n;
	foreach $n (sort {$a <=> $b || $a cmp $b} keys %{$setting::payment{'other'}}) {
		$this->{'payment_methods'}[$i++] = {'id' => 'other:' . $n,'name' => $setting::payment{'other'}{$n}{'name'}};
	}
}
$setting::payment{'cod'}{'fee3'} = $setting::payment{'cod'}{'fee4'} = '' if !defined $setting::payment{'cod'}{'fee3'} || $setting::payment{'cod'}{'fee3'} eq '';
$setting::payment{'cod'}{'fee2'} = $setting::payment{'cod'}{'fee3'} = $setting::payment{'cod'}{'fee4'} = '' if !defined $setting::payment{'cod'}{'fee2'} || $setting::payment{'cod'}{'fee2'} eq '';
$setting::payment{'cod'}{'fee1'} = $setting::payment{'cod'}{'fee2'} = $setting::payment{'cod'}{'fee3'} = $setting::payment{'cod'}{'fee4'} = '' if !defined $setting::payment{'cod'}{'fee1'} || $setting::payment{'cod'}{'fee1'} eq '';

return;
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
return 0 if !@{$this->{'payment_methods'}};
$this->scalar_to_array(\$main::search{$this->{'id'}}{'str'});
return (ref $main::search{$this->{'id'}}{'str'} && @{$main::search{$this->{'id'}}{'str'}}) ? 1 : 0;
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
return (!$this->match_enabled || grep($_ eq $$str,@{$main::search{$this->{'id'}}{'str'}})) ? 1 : 0;
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status,$original,$path) = @_;
my($form);
my($estimated_sum) = $this->get_order_info;
$form = $this->field_header;
if (!$estimated_sum) {
	$form .= '-';
} elsif (defined $status && $status ne '' && $main::data{$this->{'id'}}{'str'} eq 'paypal') {
	$form .= 'PayPal';
} else {
	$form .= $this->payment_method_menu('data:' . $this->{'id'} . ':str',[$main::data{$this->{'id'}}{'str'}],$this->{'is_invalid_field'},0,(((!defined $status || $status eq '') && $setting::payment{'paypalenabled'}) ? 1 : 0));
	$form .= $this->payment_method_info_link;
}
$form .= $this->field_footer;
return $form;
}

sub payment_method_menu ($$$;$$$) {
my($this,$name,$data,$is_invalid,$is_multiple,$paypal_enabled) = @_;
my $form = '';
if (@{$this->{'payment_methods'}} <= 1) {
	$form = (!$is_multiple && ref $this->{'payment_methods'}[0]) ? $this->escape($this->{'payment_methods'}[0]->{'name'}) . '<input type="hidden" name="' . $name . '" value="' . $this->{'payment_methods'}[0]->{'id'} . '" />' : '';
} else {
	my($payment_method);
	$form .= '<select name="' . $name . '" id="' . $name . '"' . (($is_multiple) ? ' multiple="multiple"' : '') . (($is_invalid) ? ' class="invalid-field" onchange="cmonos.validate.field(this).bailOut()' . (($paypal_enabled) ? ';cmonos.form.togglePaymentMethod();"' : '') . '"' : (($paypal_enabled) ? ' onchange="cmonos.form.togglePaymentMethod()"' : '')) . '>';
	foreach $payment_method (@{$this->{'payment_methods'}}) {
		my $limit = '';
		if ($payment_method->{'id'} eq 'cod') {
			next if $cgi::action->{'digital_content_only'};
			$limit = '(' . $this->max_cod_price . 'ޤ)';
		} elsif (!$paypal_enabled && $payment_method->{'id'} eq 'paypal') {
			next;
		}
		$form .= '<option value="' . $payment_method->{'id'} . '"' . ((ref $data && grep(defined $_ && $_ eq $payment_method->{'id'},@$data)) ? ' selected="selected"' : '') . '>' . $this->escape($payment_method->{'name'}) . $limit . '</option>';
	}
	$form .= '</select>';
}
return $form;
}

sub max_cod_price ($) {
my $this = shift;
return	($setting::payment{'cod'}{'fee4'} ne '') ? '30' : 
		($setting::payment{'cod'}{'fee3'} ne '') ? '10' : 
		($setting::payment{'cod'}{'fee2'} ne '') ? '3' : 
		($setting::payment{'cod'}{'fee1'} ne '') ? '1' : 
		'0';
}

sub max_cod ($) {
my $this = shift;
return	($setting::payment{'cod'}{'fee4'} ne '') ? 300000 : 
		($setting::payment{'cod'}{'fee3'} ne '') ? 100000 : 
		($setting::payment{'cod'}{'fee2'} ne '') ? 30000 : 
		($setting::payment{'cod'}{'fee1'} ne '') ? 10000 : 
		0;
}

sub payment_method_info_link ($) {
my $this = shift;
return '<a href="' . $default::file . '/payment_info.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html') . '" class="payment-info-link" target="_blank">[' . (($default::english) ? 'About payment methods' : 'ܺ') . ']</a>';
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
my $this = shift;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
my($estimated_sum,$digital_content_only) = $this->get_order_info;
my $is_valid = 1;
if (!$estimated_sum) {
	if ($main::data{$this->{'id'}}{'str'} && $main::data{$this->{'id'}}{'str'} ne 'none') {
		push(@{$this->{'dialog'}},'ʧۤ0ߤΤᡢͤ򤷤' . $this->name(1) . '̵ޤ');
	}
	$main::data{$this->{'id'}}{'str'} = 'none';
} elsif (@{$this->{'payment_methods'}} <= 1) {
	$main::data{$this->{'id'}}{'str'} = (ref $this->{'payment_methods'}[0]) ? $this->{'payment_methods'}[0]->{'id'} : '';
} else {
	my($payment_method);
	$main::data{$this->{'id'}}{'str'} = '' if $main::data{$this->{'id'}}{'str'} && $main::data{$this->{'id'}}{'str'} eq 'none';
	$is_valid = 0;
	$cgi::action->{'cod_disabled'} = 1 if ($estimated_sum && !$this->is_nan($estimated_sum) && $estimated_sum > $this->max_cod) || $digital_content_only;
	foreach $payment_method (@{$this->{'payment_methods'}}) {
		if ($main::data{$this->{'id'}}{'str'} && $main::data{$this->{'id'}}{'str'} eq $payment_method->{'id'}) {
			if ($cgi::action->{'cod_disabled'} && $payment_method->{'id'} eq 'cod') {
				if ($digital_content_only) {
					push(@{$cgi::action->{'dialog'}},'ǥ륳ƥĤΤϤѤˤʤޤ') if ref $cgi::action;
				} else {
					push(@{$cgi::action->{'dialog'}},'ʧۤ' . $this->max_cod_price . 'ĶᡢѤˤʤޤ' . $this->name(1) . 'ѹ뤫Ĥʸ򥭥󥻥뤷Ƥ') if ref $cgi::action;
				}
				$is_valid = 0;
			} else {
				$is_valid = 1;
			}
			last;
		}
	}
}
$is_valid = 0 if !$this->is_not_empty('str');
if ($is_valid) {
	$cookie::data{'data:' . $this->{'id'} . ':str'} = $main::data{$this->{'id'}}{'str'} if $this->{'cookie'} && $main::set_cookie && defined $main::data{$this->{'id'}}{'str'};
} else {
	$this->{'is_invalid_field'} = 1;
}
return $is_valid;
}

sub get_order_info ($) {
my $this = shift;
if (ref $cgi::action && defined $cgi::action->{'estimated_sum'} && defined $cgi::action->{'digital_content_only'}) {
	return($cgi::action->{'estimated_sum'},$cgi::action->{'digital_content_only'});
} elsif (!$cgi::action->{'new_data'} && defined $main::n && defined $main::c && $main::n ne '' && $main::c ne '') {
	my(%db,$data);
	use Fcntl qw(:DEFAULT);
	eval 'use ' . $env::dbm_file . ';';
	tie(%db, $env::dbm_file, "$default::db/$main::c/order", O_RDONLY, $env::dbm_mode);
	if (ref tied %db && $db{$main::n} && $db{$main::n} =~ /^(.*?)$/m) {
		$data = $1;
	}
	untie %db;
	my($total,$tax,$fee,$carriage,$carriage_total,$download_key,$ptime,$transaction_id,$status,$dc_only) = split(/\x09/,$data);
	return($total,$dc_only);
}
return(0,0);
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=ɽǡ/path=ե¸ǥ쥯ȥ
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
my($out,$service,$number,$time,$comment);
$str = $$str{'str'} if ref $str eq 'HASH';
return ($str) ? $this->style(
	$this->payment_method_info($str),
	$this->{'style'},
	$this->{'fontsize'},
	$this->{'fontcolor'},
	$this->{'fontface'}
) : '';
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
my($this,$str) = @_;
return '' if !defined $str || $str eq '';
$str = $$str{'str'} if ref $str eq 'HASH';
$str = '[' . $this->name . "]\x0A" . $this->payment_method_info($str,1,1);
$str =~ s/[\x0A]*\Z/\x0A\x0A/s;
return $str;
}

#---------------------------------------------------------------------
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail {
my($this,$str,$path,$c,$n) = @_;
my($out,$service,$number,$time,$comment);
$str = $$str{'str'} if ref $str eq 'HASH';
return ($str) ? $this->style(
	$this->payment_method_info($str,0,1),
	$this->{'style'},
	$this->{'fontsize'},
	$this->{'fontcolor'},
	$this->{'fontface'}
) : '';
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
my($this,$str) = @_;
return '' if !defined $str || $str eq '';
$str = $$str{'str'} if ref $str eq 'HASH';
return $this->payment_method_info($str,1);
}

sub payment_method_info ($$;$$) {
my($this,$str,$for_text,$for_user) = @_;
return '-' if $str eq 'none';
my $info = '';
my($method,$n) = ($str =~ /^(\w+):(\d+)$/) ? ($1,$2) : ($str,'');
if (!$for_text && !ref $this->{'Table'}) {
	require CMONOS::CGI_Lib::Table;
	$this->{'Table'} = Table->new;
}
if ($method eq 'bank' && $setting::payment{'bankenabled'}) {
	if ($for_text) {
		$info .= $setting::payment{'bank'}{$n}{'bank'} . "\x0A";
		if ($for_user || $setting::payment{'bankinfo'}) {
			$info .= $setting::payment{'bank'}{$n}{'office'} . "\x0A";
			if ($for_user || $setting::payment{'bankinfo'} >= 2) {
				$info .= ((defined $setting::payment{'bank'}{$n}{'deposit'} && $setting::payment{'bank'}{$n}{'deposit'} eq 'current') ? '() ' : '() ') . $setting::payment{'bank'}{$n}{'number'} . "\x0A";
				if ($for_user || $setting::payment{'bankinfo'} >= 3) {
					$info .= $setting::payment{'bank'}{$n}{'name'} . "\x0A";
					$info .= $setting::payment{'bank'}{$n}{'kana'} . "\x0A";
				}
			}
		}
		$info .= '(' . $setting::payment{'banknote'} . ")\x0A" if $setting::payment{'banknote'};
		$info .= "\x0A";
	} else {
		$info .= $this->{'Table'}->table('id' => 'bank-info-table');
		$info .= $this->{'Table'}->tr;
		$info .= $this->{'Table'}->th('');
		$info .= $this->{'Table'}->td($this->escape($setting::payment{'bank'}{$n}{'bank'}));
		$info .= $this->{'Table'}->_tr;
		if ($for_user || $setting::payment{'bankinfo'}) {
			$info .= $this->{'Table'}->tr;
			$info .= $this->{'Table'}->th('Ź');
			$info .= $this->{'Table'}->td($this->escape($setting::payment{'bank'}{$n}{'office'}));
			$info .= $this->{'Table'}->_tr;
			if ($for_user || $setting::payment{'bankinfo'} >= 2) {
				$info .= $this->{'Table'}->tr;
				$info .= $this->{'Table'}->th('');
				$info .= $this->{'Table'}->td(((defined $setting::payment{'bank'}{$n}{'deposit'} && $setting::payment{'bank'}{$n}{'deposit'} eq 'current') ? '() ' : '() ') . $setting::payment{'bank'}{$n}{'number'});
				$info .= $this->{'Table'}->_tr;
				if ($for_user || $setting::payment{'bankinfo'} >= 3) {
					$info .= $this->{'Table'}->tr;
					$info .= $this->{'Table'}->th('̾');
					$info .= $this->{'Table'}->td($this->escape($setting::payment{'bank'}{$n}{'name'}));
					$info .= $this->{'Table'}->_tr;
					$info .= $this->{'Table'}->tr;
					$info .= $this->{'Table'}->th('ɽ');
					$info .= $this->{'Table'}->td($setting::payment{'bank'}{$n}{'kana'});
					$info .= $this->{'Table'}->_tr;
				}
			}
		}
		if ($setting::payment{'banknote'}) {
			$info .= $this->{'Table'}->tr;
			$info .= $this->{'Table'}->th('ջ');
			$info .= $this->{'Table'}->td($setting::payment{'banknote'});
			$info .= $this->{'Table'}->_tr;
		}
		$info .= $this->{'Table'}->_table;
	}
} elsif ($method eq 'yubin' && $setting::payment{'yubinenabled'}) {
	if ($for_text) {
		$info .= '椦(͹ؿ)' . "\x0A";
		if ($for_user || $setting::payment{'yubininfo'}) {
			$info .= $setting::payment{'yubin'}{'office'} . (($setting::payment{'yubin'}{'bankname'}) ? '(' . $setting::payment{'yubin'}{'bankname'} . ')' : '') . "\x0A";
			if ($for_user || $setting::payment{'yubininfo'} >= 2) {
				$info .= ((defined $setting::payment{'yubin'}{'mark'} && $setting::payment{'yubin'}{'mark'} ne '') ? $setting::payment{'yubin'}{'mark'} . '-' : '') . ((defined $setting::payment{'yubin'}{'digit'} && $setting::payment{'yubin'}{'digit'} ne '') ? $setting::payment{'yubin'}{'digit'} . '-' : ' -') . $setting::payment{'yubin'}{'number'} . "\x0A";
				if ($for_user || $setting::payment{'yubininfo'} >= 3) {
					$info .= $setting::payment{'yubin'}{'name'} . (($setting::payment{'yubin'}{'kana'}) ? '(' . $setting::payment{'yubin'}{'kana'} . ')' : '') . "\x0A";
				}
			}
		}
		$info .= '(' . $setting::payment{'yubinnote'} . ")\x0A" if $setting::payment{'yubinnote'};
		$info .= "\x0A";
	} else {
		$info .= $this->{'Table'}->table('id' => 'yuubin-info-table');
		if ($for_user || $setting::payment{'yubininfo'}) {
			$info .= $this->{'Table'}->tr;
			$info .= $this->{'Table'}->th('͹ض');
			$info .= $this->{'Table'}->td($this->escape($setting::payment{'yubin'}{'office'}));
			$info .= $this->{'Table'}->_tr;
			if ($setting::payment{'yubin'}{'bankname'}) {
				$info .= $this->{'Table'}->tr;
				$info .= $this->{'Table'}->th('Ź̾');
				$info .= $this->{'Table'}->td($this->escape($setting::payment{'yubin'}{'bankname'}));
				$info .= $this->{'Table'}->_tr;
			}
			if ($for_user || $setting::payment{'yubininfo'} >= 2) {
				$info .= $this->{'Table'}->tr;
				$info .= $this->{'Table'}->th('ֹ');
				$info .= $this->{'Table'}->td(((defined $setting::payment{'yubin'}{'mark'} && $setting::payment{'yubin'}{'mark'} ne '') ? $setting::payment{'yubin'}{'mark'} . '-' : '') . ((defined $setting::payment{'yubin'}{'digit'} && $setting::payment{'yubin'}{'digit'} ne '') ? $setting::payment{'yubin'}{'digit'} . '-' : ' -') . $setting::payment{'yubin'}{'number'});
				$info .= $this->{'Table'}->_tr;
				if ($for_user || $setting::payment{'yubininfo'} >= 3) {
					$info .= $this->{'Table'}->tr;
					$info .= $this->{'Table'}->th('̾');
					$info .= $this->{'Table'}->td($this->escape($setting::payment{'yubin'}{'name'}));
					$info .= $this->{'Table'}->_tr;
					if ($setting::payment{'yubin'}{'kana'}) {
						$info .= $this->{'Table'}->tr;
						$info .= $this->{'Table'}->th('ɽ');
						$info .= $this->{'Table'}->td($this->escape($setting::payment{'yubin'}{'kana'}));
						$info .= $this->{'Table'}->_tr;
					}
				}
			}
		} else {
			$info .= $this->{'Table'}->tr;
			$info .= $this->{'Table'}->th('椦');
			$info .= $this->{'Table'}->td('졦͹ؿ');
			$info .= $this->{'Table'}->_tr;
		}
		if ($setting::payment{'yubinnote'}) {
			$info .= $this->{'Table'}->tr;
			$info .= $this->{'Table'}->th('ջ');
			$info .= $this->{'Table'}->td($setting::payment{'yubinnote'});
			$info .= $this->{'Table'}->_tr;
		}
		$info .= $this->{'Table'}->_table;
	}
} elsif ($method eq 'cod' && $setting::payment{'codenabled'}) {
	if ($for_text) {
		$info .= '' . "\x0A";
		$info .= '(' . $setting::payment{'codnote'} . ")\x0A" if $setting::payment{'codnote'};
		$info .= "\x0A";
	} else {
		$info .= '' . $this->payment_method_info_link;
		$info .= '<div class="note">' . $setting::payment{'codnote'} . '</div>' if $setting::payment{'codnote'};
	}
} elsif ($method eq 'moneyorder' && $setting::payment{'moneyorderenabled'}) {
	if ($for_text) {
		$info .= '۾' . "\x0A";
		$info .= '(' . $setting::payment{'moneyordernote'} . ")\x0A" if $setting::payment{'moneyordernote'};
		$info .= "\x0A";
	} else {
		$info .= '<a href="http://www.jp-bank.japanpost.jp/kojin/tukau/sokin/hikoza/kj_tk_sk_hkz_kogawase.html" target="_blank">۾</a>';
		$info .= '<div class="note">' . $setting::payment{'moneyordernote'} . '</div>' if $setting::payment{'moneyordernote'};
	}
} elsif ($method eq 'paypal' && $setting::payment{'paypalenabled'}) {
	if ($for_text) {
		$info .= 'PayPal' . "\x0A";
		$info .= '(' . $setting::payment{'paypalnote'} . ")\x0A" if $setting::payment{'paypalnote'};
		$info .= "\x0A";
	} else {
		if ($setting::payment{'paypal'}{'banner'}) {
			$info .= $setting::payment{'paypal'}{'banner'};
		} else {
			$info .= '<a href="#" onclick="javascript:window.open(\'https://www.paypal.com/jp/cgi-bin/webscr?cmd=xpt/Marketing/popup/OLCWhatIsPayPal-outside\',\'olcwhatispaypal\',\'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes, width=400, height=350\');"><img src="https://www.paypal.com/ja_JP/JP/i/bnr/horizontal_solution_4_jcb.gif" border="0" alt="PayPalΥ塼" /></a>';
		}
		$info .= '<div class="note">' . $setting::payment{'paypalnote'} . '</div>' if $setting::payment{'paypalnote'};
	}
} elsif ($method eq 'other' && $setting::payment{'otherenabled'}) {
	if ($for_text) {
		$info .= $setting::payment{'other'}{$n}{'name'} . "\x0A";
		$info .= '(' . $setting::payment{'other'}{$n}{'note'} . ")\x0A" if $setting::payment{'other'}{$n}{'note'};
		$info .= "\x0A";
	} else {
		$info .= $setting::payment{'other'}{$n}{'name'};
		$info .= '<div class="note">' . $setting::payment{'other'}{$n}{'note'} . '</div>' if $setting::payment{'other'}{$n}{'note'};
	}
}
return $info;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my $this = shift;
my $name = 'data:' . $this->{'id'};
$this->print_field_info_form($name);
$this->print_font_setting_form($name);
$this->print_table_setting_form($name,'(Ըʧˡɽ˻Ѥޤ)','none');
$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
return $this->is_valid_font_setting;
}

######################################################################
#	(6) obj->search_form;
sub search_form_enabled ($) {
my $this = shift;
return (@{$this->{'payment_methods'}} > 1) ? 1 : 0;
}

sub search_form ($) {
my $this = shift;
my($form);
$form = '<tr class="tbody-end"><td class="field-name"><span class="datatitle">' . $this->{'name'} . '</span></td><td class="field">';
$form .= $this->payment_method_menu('search:' . $this->{'id'} . ':str',[$main::search{$this->{'id'}}{'str'}],0,1);
$form .= '</td></tr>';
return $form;
}

######################################################################
#sub import {
BEGIN {
#no warnings qw(once);
if (defined $default::type && $default::type eq 'order' && defined $env::checkout && $env::checkout && !$setting::field_for_mail) {
	Field::class_register('yorder_payment','SCOrderPaymentMethod','ʧˡ');
	push(@field::redundancy_forbidden,'yorder_payment');
}
}

1;
