package Inquiry;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# 䤤碌⥸塼
# Inquiry.pm ver1.1.5
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-03-16
######################################################################
# ᥤ
sub run ($) {
my $this = shift;

#---------------------------------------------------------------------
#׵å
unless (defined $main::c && $main::c ne '' && $main::c !~ /\W/ && defined $main::n && $main::n ne '' && $main::n !~ /\W/ && -d "$default::db/$main::c" && ref $field::obj{$main::mf}) {
	$this->print_dialog('inq','顼 : ǡޤ(101)');
}

#᡼եɥ֥ɤ߹
$cgi::confirmation_disabled = $cgi::enctype_multipart = 0;
$setting::field_for_mail = 1;
$this->use_field('inquiry',$default::field_pref_dir . '/inquiryfield',2,2,'no');


#---------------------------------------------------------------------
#եɥå
my(%db,$user,$name,$key,$title,$name_db,$key_db,$title_db,%setting,$mailsetting,$mailto);
eval 'use ' . $env::dbm_file . ';';
use Fcntl qw(:DEFAULT);
tie(%db, $env::dbm_file, "$default::db/$main::c/$main::mf", O_RDONLY, $env::dbm_mode);
$mailsetting = $db{$main::n} if ref tied %db;
untie %db;
while ($mailsetting =~ s/^(\w+)\:([^\x0A\x0D]*)\x0A//s) {
	$setting{$1} = $2;
	$setting{$1} =~ s/&#10;/\x0A/sig;
}

#᡼Υå
unless (
	$field::obj{$main::mf}->{'mailtoMaster'} || $field::obj{$main::mf}->{'mailtoOwners'} ||
	($field::obj{$main::mf}->{'mailtoUser'} && $setting{'mailto'})
) {
	$this->print_dialog('inq','顼 : ǡޤ');
}

#̾ե
$name_db = $field::obj{$field::for{'name'}}->db if $field::for{'name'} && ref $field::obj{$field::for{'name'}};
if (defined $name_db && $name_db) {
	my %name;
	tie(%name, $env::dbm_file, "$default::db/$main::c/$name_db", O_RDONLY, $env::dbm_mode);
	if (ref tied %name) {
		$name = $field::obj{$field::for{'name'}}->format_for_text($name{$main::n});
	}
	untie %name;
}

#ե
$key_db = $field::obj{$field::for{'key'}}->db if $field::for{'key'} && ref $field::obj{$field::for{'key'}};
if (defined $key_db && $key_db) {
	my %key;
	tie(%key, $env::dbm_file, "$default::db/$main::c/$key_db", O_RDONLY, $env::dbm_mode);
	if (ref tied %key) {
		$key = $field::obj{$field::for{'key'}}->format_for_text($key{$main::n});
	}
	untie %key;
}

#ȥե
$title_db = $field::obj{$field::for{'title'}}->db if $field::for{'title'} && ref $field::obj{$field::for{'title'}};
if (defined $title_db && $title_db) {
	my %title;
	tie(%title, $env::dbm_file, "$default::db/$main::c/$title_db", O_RDONLY, $env::dbm_mode);
	if (ref tied %title) {
		$title = $field::obj{$field::for{'title'}}->format_for_text($title{$main::n});
	}
	untie %title;
}

#᡼ե
if (defined $setting{'mailto'} && $setting{'mailto'} !~ /\D/) {
	my %mail;
	tie(%mail, $env::dbm_file, "$default::db/$main::c/$setting{'mailto'}", O_RDONLY, $env::dbm_mode);
	if (ref tied %mail) {
		$mailto = $mail{$main::n};
		$user = $mailto if !$field::obj{$setting{'mailto'}}->{'Hidden'};
	}
	untie %mail;
}
$mailto .= ',' if $mailto;
$mailto .= $setting::general{'master'} || $env::master_email if $field::obj{$main::mf}->{'mailtoMaster'};
$mailto .= ',' if $mailto;
$mailto .= $setting::general{'owners'} if $field::obj{$main::mf}->{'mailtoOwners'};
$this->print_dialog('inq','顼 : ǡޤ(103)') if !$mailto;


#---------------------------------------------------------------------
#󥯸
if (!defined $cgi::path || $cgi::path eq '') {
	$cgi::path = $ENV{'SCRIPT_NAME'};
	$cgi::path = $env::cgi_server . $cgi::path if defined $env::cgi_server && $env::cgi_server;
}
my $referer_url = $cgi::path . '?m=' . ((defined $main::mod) ? $main::mod : '') . ((defined $main::c) ? '&c=' . $main::c : '') . ((defined $main::n) ? '&n=' . $main::n : '') . $this->set_query('url+',['s','w','f','u','uni','and','search','q','fv']);


#---------------------------------------------------------------------
#᡼

#ϤΥå
my($input_is_valid,$msg,$from_name);
if (defined $main::a && $main::a eq 'm') {
	$input_is_valid = 1;
	foreach my $fid (sort {$a <=> $b} keys %inquiry::ORDER) {
		$input_is_valid = 0 unless ref $inquiry::obj{$inquiry::ORDER{$fid}} && $inquiry::obj{$inquiry::ORDER{$fid}}->is_valid_data;
	}

	#Ϣ³å
	if (defined $field::obj{$main::mf}->{'ipStopper'} && $field::obj{$main::mf}->{'ipStopper'} && $setting::general{'latestmail'}) {
		my($mtime,$ip) = split(/:/,$setting::general{'latestmail'});
		if ($ip && $mtime && $ip eq $this->to_host($ENV{'REMOTE_ADDR'}) && time - $mtime <= $field::obj{$main::mf}->{'ipStopper'}) {
			push(@{$this->{'dialog'}},'Ϣ³¤ƤޤФ餯ƤʤƤ');
			$input_is_valid = 0;
		}
	}

	#᡼
	if ($input_is_valid && !$main::cancel) {
		if ($cgi::confirmation_disabled || $main::ok) {

			#Υ᡼
			my($subject,$from,$url);
			$url = $this->my_url . '?m=DetailViewer&k=detail&c=' . $main::c . '&n=' . $main::n;
			$subject = $inquiry::obj{$inquiry::for{'subject'}}->format_for_text($main::data{$inquiry::for{'subject'}}{'str'}) if defined $inquiry::for{'subject'} && ref $inquiry::obj{$inquiry::for{'subject'}};
			$subject = $field::obj{$main::mf}->{'subject'} if !defined $subject || $subject eq '';
			$this->detag(\$subject);
	
			$from = $main::data{$inquiry::for{'from'}}{'str'} if defined $main::data{$inquiry::for{'from'}}{'str'} && $main::data{$inquiry::for{'from'}}{'str'};
			$from_name = $main::data{$inquiry::for{'name'}}{'str'} if defined $from && $from ne '';
			$this->detag(\$from_name) if defined $from_name && $from_name ne '';
			$from = $from_name . ' <' . $from . '>' if defined $from && $from ne '';
	
			$msg = $this->notice_mail(
				$subject,
				'ȯ쥳:' . $url . (($key) ? ' (' . $key . ')' : ($title) ? ' (' . $title . ')' :  ($name) ? ' (' . $name . ')' : ''),
				\%inquiry::obj,
				\%main::data,
				$from,
				$mailto
			);
			
			#ưֿ᡼
			if ($from && $field::obj{$main::mf}->{'resmsg'} || ($field::obj{$main::mf}->{'autores'} && $setting{'resmsg'})) {
				my($res_subject,$res_msg);
				$res_msg = (($setting{'resmsg'}) ? $setting{'resmsg'} : $field::obj{$main::mf}->{'resmsg'});
				$res_subject = (($setting{'ressubject'}) ? $setting{'ressubject'} : $field::obj{$main::mf}->{'ressubject'});

				$res_subject =~ s/<name>/$from_name/sig;
				$res_msg =~ s/<name>/$from_name/sig;
				$res_msg =~ s/<msg>/$msg/sig;
				$res_msg =~ s/<url>/$url/sig;
		
				$cgi::SendMail->send_mail(
					'To'		=>  $from,
					'From'		=>  (($user) ? $user : (($setting::general{'master'}) ? (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}) : $env::master_email)),
					'Subject'	=>  $res_subject,
					'message'	=>  $res_msg . "\x0A\x0A"
				);
			}

			#
			foreach my $fid (sort {$a <=> $b} keys %inquiry::ORDER) {
				$inquiry::obj{$inquiry::ORDER{$fid}}->settle_up if ref $inquiry::obj{$inquiry::ORDER{$fid}};
			}
			$cgi::input->clear_parameters_trash;
			$cgi::input->clear_clipboard;

			#̾󹹿
			my(%general);
			tie(%general, $env::dbm_file, $default::preference_dir . '/general', O_RDWR | O_CREAT, $env::dbm_mode);
			if (ref tied %general) {
				$general{'latestmail'} = time . ':' . $this->to_host($ENV{'REMOTE_ADDR'});
			}
			untie %general;

			#񤭹ߤ
			my($thanks,$thankstitle);
	
			#桼
			if ($field::obj{$main::mf}->{'usrthanks'} && $setting{'thanks'}) {
				$thanks = $setting{'thanks'};
				$thankstitle = ($setting{'thankstitle'}) ? $setting{'thankstitle'} : ($field::obj{$main::mf}->{'thankstitle'}) ? $field::obj{$main::mf}->{'thankstitle'} : '';		
		
			} elsif (defined $field::obj{$main::mf}->{'thanks'} && $field::obj{$main::mf}->{'thanks'}) {
				$thanks = $field::obj{$main::mf}->{'thanks'};
				$thankstitle = $field::obj{$main::mf}->{'thankstitle'} if defined $field::obj{$main::mf}->{'thankstitle'} && $field::obj{$main::mf}->{'thankstitle'};		
			}
			if (defined $thankstitle && $thankstitle) {
				$thankstitle =~ s/<name>/$from_name/sig;
				$this->escape(\$thankstitle);
				$this->push_window_title($thankstitle);
			}
	
			#ڡإå
			$this->print_page_header('inq');
			
			#桼
			if (defined $thanks && $thanks) {
				$this->escape(\$from_name);
				$this->escape(\$msg);
				#$from_name =~ s/(\x0A|\x0D|\x0D\x0A)/<br \/>/sg;
				#$msg =~ s/(\x0A|\x0D|\x0D\x0A)/<br \/>/sg;
				$thanks =~ s/<name>/$from_name/sig;
				$thanks =~ s/<msg>/$msg/sig;
				$thanks =~ s/<url>/$url/sig;
				print $this->tag_fix($thanks,2,0,0,1);
		
			#Ѹɽ
			} elsif (defined $default::english && $default::english) {
				print '<p id="tm-thanks">Thank you for your e-mail.</p>';
			
			#ܸ
			} else {
				print '<p id="tm-thanks">ޤ</p>';
			}
	
		#ϳǧ
		} else {
			$this->print_page_header('inq');
			$this->print_inquiry_message($name,$key,$title);
			print $this->form_start(
				'key'	=>	'inq',
				'name'	=>	'input',
				'method'	=> 'post',
				'onsubmit'	=>	'return cmonos.form.item(this).isNotSubmitted()',
				'required'	=>	\@setting::form
			);
			print '<input type="hidden" name="a" value="m" />';
			print '<p id="tm-confirmation">' . (($default::english) ? 'Confirmation.' : 'Ƥ꤬ʤСץܥ򲡤Ƥ') . '</p>';
			print '<table class="field-table"><tbody>';
			foreach (sort {$a <=> $b} keys %inquiry::ORDER) {
				my $id = $inquiry::ORDER{$_};
				next unless ref $inquiry::obj{$id} && $inquiry::obj{$id}->format_for_mail_enabled;
				$inquiry::obj{$id}->print_confirmation_form_table_row('',$main::c,$main::n);
			}
			print '</tbody><tbody>';
			print '<tr class="tbody-start"><td class="submit-box" colspan="2"><input type="submit" name="cancel=1" value="' . (($default::english) ? 'Cancel' : '󥻥');
			print '" class="cancel" /><input type="submit" name="ok=1" value="' . (($default::english) ? 'OK' : '') . '" class="save" /></td></tr>';
			print '</tbody></table></form>';
		}
		$this->print_close_button($referer_url);

		#ڡեå
		$this->print_page_footer('inq');
		return;

	}
}

#---------------------------------------------------------------------
#񤭽Ф
my($template,$temp,%temp,$path);

#ե
my($formcheck);

$this->print_page_header('inq');
$this->print_inquiry_message($name,$key,$title);
print $this->form_start(
	'key'	=>	'inq',
	'name'	=>	'input',
	'multi'	=> $cgi::enctype_multipart,
	'method'	=> 'post',
	'onsubmit'	=>	'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="m" />';

#եǼǥ쥯ȥ
$path = "$default::file/$main::c/$main::n";
$key = (defined $default::english && $default::english) ? 'This' : '' if !defined $key || $key eq '';
$title = (defined $default::english && $default::english) ? 'This' : '' if !defined $title || $title eq '';
$name = (defined $default::english && $default::english) ? 'You' : 'ʤ' if !defined $name || $name eq '';

print '<table class="field-table"><tbody>';
foreach (sort {$a <=> $b} keys %inquiry::ORDER) {
	next unless ref $inquiry::obj{$inquiry::ORDER{$_}} && $inquiry::obj{$inquiry::ORDER{$_}}->format_for_mail_enabled;
	if (defined $inquiry::obj{$inquiry::ORDER{$_}}->{'default'}) {
		$inquiry::obj{$inquiry::ORDER{$_}}->{'default'} =~ s/<name>/$name/sgi;
		$inquiry::obj{$inquiry::ORDER{$_}}->{'default'} =~ s/<key>/$key/sgi;
		$inquiry::obj{$inquiry::ORDER{$_}}->{'default'} =~ s/<title>/$title/sgi;
	}
	print $inquiry::obj{$inquiry::ORDER{$_}}->form('','',$path);
	$formcheck = 1;
}

if (defined $formcheck && $formcheck) {
	print '</tbody><tbody>';
	print '<tr class="tbody-start"><td class="submit-box" colspan="2">';
	if (defined $cookie::enabled && $cookie::enabled) {
		print '<label><input type="checkbox" name="set_cookie" value="1"' . (($cookie::read{$cookie::name} || $main::set_cookie) ? ' checked="checked"' : '') . ' />' . ((defined $default::english && $default::english) ? 'Remember Me' : '򵭲') . '</label> ';
	}
	print '<input type="submit" value="' . ((defined $default::english && $default::english) ? 'Send' : '') . '" /></td></tr>';
}

print '</tbody></table></form>';
$this->print_close_button($referer_url);

#ڡեå
$this->print_page_footer('inq');
}

sub print_close_button ($;$) {
my($this,$referer_url) = @_;
print '<div id="close-button">';
print $this->close_button($referer_url,$setting::page{'closeButton'},$setting::page{'backButton'});
print '</div>';
}

sub print_inquiry_message ($$$$) {
my($this,$name,$key,$title) = @_;
return if !defined $setting::page{'inq'}{'template'} || $setting::page{'inq'}{'template'} eq '';
$key = (defined $default::english && $default::english) ? 'This' : '' if !defined $key || $key eq '';
$title = (defined $default::english && $default::english) ? 'This' : '' if !defined $title || $title eq '';
$name = (defined $default::english && $default::english) ? 'You' : 'ʤ' if !defined $name || $name eq '';
my $template = $setting::page{'inq'}{'template'};
$template =~ s/<name>/$name/sig;
$template =~ s/<key>/$key/sig;
$template =~ s/<title>/$title/sig;
print $this->tag_fix($template,2,0,0,1);
}

sub set_rss_link ($;$) {
my($this,$output) = @_;
#$this->import_db($default::preference_dir . '/category',\%setting::category,1) if !%setting::category;
#$this->_set_rss_link($default::file . '/' . $main::c,((ref $setting::category{$main::c} && defined $setting::category{$main::c}{'name'} && $setting::category{$main::c}{'name'} ne '') ? $setting::category{$main::c}{'name'} : ''));
$this->_set_rss_link($default::file,((defined $setting::general{'cginame'} && $setting::general{'cginame'} ne '') ? $setting::general{'cginame'} : ''),$output);
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;					#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 1;						#ơ֥ɤ߹
	$setting::page = 1;						#ڡɤ߹

	$setting::field_db_name = 'inputfield';	#եDB
	$setting::field = 2;						#եɤ߹ߡ2=ꥸʥɤ߹
	$setting::field_style_disabled = 2;			#2=եꥹ̵/1=եΤ̵
	$setting::field_tag_enabled = 'no';				#tag=Τ/all=Ƥ/no=Ĥʤ
	$setting::field_for_mail = 1;

	#省
	$setting::security_key = 'inq';		#ǥեȥƥ
	$setting::key = 'inq';					#ڡꥭ

	#å
	$cookie::id_enabled = 1;							#ID󥯥åɤ߹
	$cookie::default_enabled = 1;					#桼Ͼ󥯥åɤ߹
	$cookie::name = 'INQ';
	$cookie::path = $ENV{'SCRIPT_NAME'};

	#ǥեȥ
	$main::k = 'inq' if !defined $main::k || !$main::k;

	#ɬܥե
	@setting::form = ('m','k','c','n','mf','mod','s','w','f','u','uni','and','search','q','fv');
	if ($ENV{'QUERY_STRING'} || ($ENV{'REQUEST_METHOD'} eq 'POST' && !$cgi::input->referer_is_me)) {
		undef $main::a;
	}

	#᡼CSS
	$setting::image_css = 'order-image.css' if $default::type && $default::type eq 'order';

	#饹Ͽ
	Common::class_register('inq','Inquiry');
}

1;
