package TMCommon;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
use strict;
######################################################################
# ơ֥᡼̥⥸塼
# TMCommon.pm ver1.0.9
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-08-12
######################################################################
# إå
sub print_viewer_header ($) {
my $this = shift;
$this->use_deco;
$this->replace_category_list;
$this->set_category_name;
$this->push_title($this->{'favorites_field_name'},1) if $this->{'has_favorites'};
$this->push_title((($default::english) ? 'Search Results' : ''),1) if $this->{'is_searched'};
$this->push_title($this->{'record_title'}) if $this->{'record_title'};
$this->set_favorites_control_js;
$this->set_delete_this_js if $this->{'revForm'};
$this->set_style_sheet_link("$env::css/tablemaker-common.css");
$this->print_page_header($setting::key);
}

sub set_category_name ($) {
my $this = shift;
if (defined $setting::page{'categoryname'} && $setting::page{'categoryname'}) {
	my($sub_title);
	my $category_count = keys %{$setting::category{'ORDER'}};
	if ($category_count && $category_count > 1) {
		my $count = 0;
		my %done;
		foreach my $catlist (@main::c) {
			foreach my $cat (split(/,/,$catlist)) {
				if (!$done{$cat}++ && defined $setting::category{$cat}{'name'} && $setting::category{$cat}{'name'} ne '') {
					$sub_title .= ', ' if defined $sub_title && $sub_title ne '';
					#$sub_title .= ($setting::category{$cat}{'name'} =~ /([^\/]+)$/) ? $1 : $setting::category{$cat}{'name'};
					$sub_title .= $setting::category{$cat}{'name'};
					$count++;
				}
			}
		}
		$sub_title = ($default::english) ? 'All' : 'ǡ' if $count == $category_count;
		$this->push_title($sub_title);
	}
}
}

sub push_title ($$;$) {
my($this,$title,$search_flag) = @_;
return if !defined $title || $title eq '';
$this->push_window_title($title);
if (defined $setting::page{$setting::key}{'titleText'} && $setting::page{$setting::key}{'titleText'} ne '') {
	my $tag = ($setting::page{$setting::key}{'titleText'} =~ s/((<\/[^>]+>)+)$//) ? $1 : '';
	if (defined $search_flag && $search_flag) {
		$setting::page{$setting::key}{'titleText'} .= ' (' . $title . ')' . $tag;
	} else {
		$setting::page{$setting::key}{'titleText'} .= ' &gt; ' . $title . $tag;
	}
}
}

sub set_favorites_control_js ($) {
my $this = shift;
return if !$this->favorites_enabled;
my $js = <<'JAVASCRIPT';
cmonos.tool.favorites = {
	list : cmonos.value.deleteFromArray(cmonos.document.getCookie('favorites').split(/,/),""),

	set : function (this_record,add_record) {
		if (!this.list) this.list = new Array();
		var updated = false;
		if (add_record) {
			if (!cmonos.value.isIncluded(this.list,this_record)) {
				this.list.push(this_record);
				updated = true;
			}
		} else {
			if (cmonos.value.isIncluded(this.list,this_record)) {
				this.list = cmonos.value.deleteFromArray(this.list,this_record);
				updated = true;
			}
		}
		if (updated) {
			if (this.list.length > 0) {
				cmonos.document.setCookie('favorites',this.list.join(","));
			} else {
				cmonos.document.deleteCookie('favorites');
			}
			this.toggle();
		}
	},

	toggle : function () {
		var display = (this.list && this.list.length > 0) ? "" : "none";
		if (document.getElementById('show-favorites-top')) document.getElementById('show-favorites-top').style.display = display;
		if (document.getElementById('show-favorites-bottom')) document.getElementById('show-favorites-bottom').style.display = display;
	},

	checkbox : function (this_id,title) {
		document.write('<form action="#"><input type="checkbox" onclick="cmonos.tool.favorites.set(\''+this_id+'\',this.checked);" title="'+title+'"'+((cmonos.value.isIncluded(this.list,this_id)) ? ' checked="checked"' : '')+' /></form>');
	},

	reset : function () {
		this.list = new Array();
		cmonos.document.deleteCookie('favorites');
	}
}
JAVASCRIPT
$this->set_javascript($js);
$this->set_onload((($this->{'reset_favorites'}) ? 'cmonos.tool.favorites.reset();' : '') . 'cmonos.tool.favorites.toggle();');
return;
}

sub set_delete_this_js ($) {
my $this = shift;
return;
}

sub favorites_enabled ($) {
my $this = shift;
return $this->{'favorites_enabled'} if defined $this->{'favorites_enabled'};
$this->{'favorites_enabled'} = 0;
foreach my $field (values %field::obj) {
	if ($field->{'class'} eq 'xtm_favorites' && !$field->{'Hidden'} && ($field->{'Open'} || $this->is_secure('secret'))) {
		$this->{'favorites_enabled'} = 1;
		$this->{'favorites_field_name'} = $field->name;
		last;
	}
}
return $this->{'favorites_enabled'};
}

######################################################################
# եå
sub print_viewer_footer ($) {
my $this = shift;
$this->print_page_footer($setting::key);
}

######################################################################
# 
sub has_to_satisfy_queries ($) {
my $this = shift;
if ($field::for{'coordinates'} && ref $main::search{$field::for{'coordinates'}}) {
	delete $main::search{$field::for{'coordinates'}}{'sw'};
	delete $main::search{$field::for{'coordinates'}}{'ne'};
}
return ();
}

sub sort_and_search ($;$) {
my($this,$target_no) = @_;
$this->{'match'} = {};
$this->{'sort'} = {};
$this->{'mcount'} = 0;
my @target_c = @main::c;

#
undef $main::fv if !grep($main::m eq $_,'TableViewer','TileViewer','KMLViewer','GMapViewer','DetailViewer');
my %favorites;
if ($main::fv && $this->favorites_enabled) {
	my @favorites;
	if ($main::fav) {
		@favorites = grep($_ ne '' && $_ !~ /\D/,split(/,/,$main::fav));
		push(@setting::form,'fav');
	} else {
		@favorites = grep($_ ne '' && $_ !~ /\D/,split(/,/,$this->read_cookie_direct('favorites')));
	}
	if (@favorites) {
		my $order = 1;
		foreach my $no (@favorites) {
			my $c = int($no / 1000000);
			my $n = $no - ($c * 1000000);
			$favorites{$c}{$n} = $order++;
		}
		@target_c = keys %favorites;
		$this->{'has_favorites'} = 1;
	}
}

#ɸ
my(@q,@num);
@q = (defined $main::q && $main::q ne '') ? split(/\s+|\xa1\xa1/,$main::q) : ();
map($_ = quotemeta($_),@q);
@num = grep($_ =~ /^\\=\d+$/,@q);
map($_ =~ s/^\\=//,@num) if @num;

#
my $sort_db = 'mtime';
$main::s = ($field::for{'sort'}) ? $field::for{'sort'} : ($field::for{'key'}) ? $field::for{'key'} : ($field::for{'title'}) ? $field::for{'title'} : '' if !defined $main::s || $main::s eq '';
if (ref $field::obj{$main::s} && $field::obj{$main::s}->sort_enabled && $field::obj{$main::s}->{'sortEnabled'} && !$field::obj{$main::s}->{'Hidden'} && ($field::obj{$main::s}->{'Open'} || $this->is_secure('secret'))) {
	$sort_db = $field::obj{$main::s}->db;
	$sort_db = 'mtime' if !$sort_db;
}

#
my @required = $this->has_to_satisfy_queries;
my @fields = keys %field::obj;
my $count = 0;
my %done;
MCATEGORY:
foreach my $ct (@target_c) {
	CATEGORY:
	foreach my $c (split(/,/,$ct)) {
		next CATEGORY if $done{$c}++ || $c =~ /\D/;
		my($dir,$records_ref);
		$dir = "$default::db/$c/";
		unless (ref tied %{$this->{'DB'}{$c}{'mtime'}}) {
			tie(%{$this->{'DB'}{$c}{'mtime'}}, $env::dbm_file, "$dir/mtime", O_RDONLY, $env::dbm_mode);
		}
		if (%favorites) {
			$records_ref = $favorites{$c};
		} elsif (ref tied %{$this->{'DB'}{$c}{'mtime'}}) {
			$records_ref = $this->{'DB'}{$c}{'mtime'};
		}
		if (ref $records_ref) {
			RECORD:
			while (my($n) = each %$records_ref) {
				next RECORD if (%favorites && !defined $this->{'DB'}{$c}{'mtime'}{$n}) || $this->is_pending_record($c,$n,$target_no);
				$count++;
				my $matched = 0;
				my $q_matched = 0;
				my $satisfied = 1;
				my $text = '';
				SEARCH:
				foreach my $id (@fields) {
					next SEARCH if !ref $field::obj{$id}
						|| (!$field::obj{$id}->match_enabled && ((!@q && !@num) || $field::obj{$id}->{'class'} !~ /^(?:text|num|addr_|select_(?!image)|ysc_)/))
						|| (!$this->{'search_enabled'} && ($field::obj{$id}->{'Hidden'} || (!$field::obj{$id}->{'Open'} && !$this->is_secure('secret'))));
					my $db = $field::obj{$id}->db;
					next SEARCH if !defined $db || $db eq '';
					$this->{'is_searched'} = 1;
					unless (ref tied %{$this->{'DB'}{$c}{$db}}) {
						tie(%{$this->{'DB'}{$c}{$db}}, $env::dbm_file, "$dir/$db", O_RDONLY, $env::dbm_mode);
					}
					my $dat = $this->{'DB'}{$c}{$db}{$n};
					if ($field::obj{$id}->match_enabled) {
						my $required;
						if (@required && grep($_ eq $id,@required)) {
							$required = 1;
						} else {
							$this->{'is_searched_full'} = 1;
						}
						if ($field::obj{$id}->match(\$dat)) {
							$matched++ if !$required;
						} elsif ($main::and || $required) {
							$matched = $q_matched = $satisfied = 0;
							last SEARCH;
						}
					}
					if (@q && $field::obj{$id}->{'class'} =~ /^(?:text|num|addr_|select_(?!image)|ysc_)/) {
						$text .= (($text) ? "\x0A" : '') . $dat;
					}
				}
				if ($text) {
					my $euc = (length $text < 200) ? 1 : 0;
					foreach my $pat (@q) {
						if ($this->jmatch(\$text,$pat,'i',1,$euc)) {
							$q_matched++;
						} else {
							$q_matched = 0;
							last;
						}
					}
				}
				if (@num) {
					foreach my $tn (@num) {
						$q_matched++ if int($tn / 1000000) == $c && $tn - ($c * 1000000) == $n;
					}
				}
				if ($satisfied && (!$this->{'is_searched_full'} || $matched) && ((!@q && !@num) || $q_matched)) {
					my $no = $c * 1000000 + $n;
					$this->{'match'}{$no} += $matched + $q_matched if $this->{'is_searched'};
					if (%favorites) {
						$this->{'sort'}{$no} = $favorites{$c}{$n};
					} else {
						unless (ref tied %{$this->{'DB'}{$c}{$sort_db}}) {
							tie(%{$this->{'DB'}{$c}{$sort_db}}, $env::dbm_file, "$dir/$sort_db", O_RDONLY, $env::dbm_mode);
						}
						$this->{'sort'}{$no} = $this->{'DB'}{$c}{$sort_db}{$n};
					}
					$this->{'mcount'}++;
				}
			}
		}
	}
}
if (%favorites && !$count) {
	$this->{'reset_favorites'} = 1;
}

#̵+ֹ
if (!$this->{'is_searched'} && @main::c == 1 && defined $main::n && $main::pickup) {
	my $c = $main::c[0];
	my $kdb = ($field::for{'name'}) ? $field::for{'name'} : ($field::for{'key'}) ? $field::for{'key'} : $sort_db;
	unless (ref tied %{$this->{'DB'}{$c}{$kdb}}) {
		tie(%{$this->{'DB'}{$c}{$kdb}}, $env::dbm_file, "$default::db/$c/$kdb", O_RDONLY, $env::dbm_mode);
	}
	if (defined $this->{'DB'}{$c}{$kdb}{$main::n}) {
		if (!$this->is_pending_record($c,$main::n,$target_no)) {
			$this->{'record_title'} = $this->{'sort'}{$c * 1000000 + $main::n} = $this->{'DB'}{$c}{$kdb}{$main::n};
			$this->{'mcount'} = 1;
		}
	}
	$this->{'match'} = {};
}
}

sub is_pending_record ($$$$) {
my($this,$c,$n,$target_no) = @_;
return 0 if !$field::for{'pending'};
my($is_pending,$is_expired);
if (!ref $this->{'DB'}{$c}{'pending'} || !ref tied %{$this->{'DB'}{$c}{'pending'}}) {
	tie(%{$this->{'DB'}{$c}{'pending'}}, $env::dbm_file, "$default::db/$c/pending", O_RDWR | O_CREAT, $env::dbm_mode);
}
if (ref tied %{$this->{'DB'}{$c}{'pending'}}) {
	my($was_pending,$start,$end) = (defined $this->{'DB'}{$c}{'pending'}{$n}) ? split(/-/,$this->{'DB'}{$c}{'pending'}{$n}) : (0,'','');
	if (!$start && !$end) {
		$is_pending = $was_pending;
	} else {
		$was_pending = 0 if !$was_pending;
		my $time = time;
		$is_pending = ((!$start || $start < $time) && (!$end || $time < $end)) ? 0 : 1;
		if ($was_pending ne $is_pending) {
			unless (ref tied %{$this->{'DB'}{'pref'}{'category'}}) {
				tie(%{$this->{'DB'}{'pref'}{'category'}}, $env::dbm_file, $default::preference_dir . '/category', O_RDWR | O_CREAT, $env::dbm_mode);
			}
			if (ref tied %{$this->{'DB'}{'pref'}{'category'}}) {
				if ($is_pending) {
					$this->{'DB'}{'pref'}{'category'}{$c . '_count'}--;
				} else {
					$this->{'DB'}{'pref'}{'category'}{$c . '_count'}++;
				}
			}
			if ($end && $field::obj{$field::for{'pending'}}->{'margin'} && $time > $end) {
				if ($field::obj{$field::for{'pending'}}->{'margin'} == 1) {
					$this->{'expired_record'} = {} if !ref $this->{'expired_record'};
					$this->{'expired_record'}{$c} = [] if !ref $this->{'expired_record'}{$c};
					push(@{$this->{'expired_record'}{$c}},$n);
					$is_expired = 1;
				} else {
					unless (ref tied %{$this->{'DB'}{$c}{'expire'}}) {
						tie(%{$this->{'DB'}{$c}{'expire'}}, $env::dbm_file, "$default::db/$c/expire", O_RDWR | O_CREAT, $env::dbm_mode);
					}
					if (ref tied %{$this->{'DB'}{$c}{'expire'}}) {
						$this->{'DB'}{$c}{'expire'}{$n} = $time + $field::obj{$field::for{'pending'}}->{'margin'};
						$this->{'DB'}{$c}{'pending'}{$n} = $is_pending . '-' . $start . '-' . $end . '-' . $this->{'DB'}{$c}{'expire'}{$n};
					}
				}
			} else {
				$this->{'DB'}{$c}{'pending'}{$n} = $is_pending . '-' . $start . '-' . $end;
			}
			if (!$is_expired && ($is_pending || $field::obj{$field::for{'pending'}}->{'mTime'})) {
				$this->{'modified_record'} = {} if !ref $this->{'modified_record'};
				$this->{'modified_record'}{$c} = {} if !ref $this->{'modified_record'}{$c};
				$this->{'modified_record'}{$c}{$n} = $is_pending;
			}
			$field::obj{$field::for{'pending'}}->pending_notice($field::obj{$field::for{'pending'}}->_pending_status($is_pending,$start,$end,0,1,1),$c,$n);
		}
	}
}
return ($is_expired || (
	$is_pending
	&& $setting::pending_check
	&& !$this->is_secure('pending')
	&& (!defined $target_no || $target_no ne ($c * 1000000 + $n))
)) ? 1 : 0;
}

sub rss_refresh ($$$$) {
my($this,$c,$n,$is_pending) = @_;
if ($is_pending) {
	$this->index_sweeper($c,$n);
} else {
	my %data = ();
	foreach my $type ('title','key','content','media') {
		if ($field::for{$type}) {
			my $id = $field::for{$type};
			if (ref $field::obj{$id} && $field::obj{$id}->db) {
				my $db = $field::obj{$id}->db;
				my %db;
				tie(%db, $env::dbm_file, "$default::db/$c/$db", O_RDONLY, $env::dbm_mode);
				$data{$id}{'str'} = $db{$n} if ref tied %db && defined $db{$n};
				untie(%db);
			}
		}
	}
	$this->feed_db_rss($c,$n,\%data);
}
}

sub untie_all_dbm ($) {
my $this = shift;
if (ref $this->{'modified_record'}) {
	while (my($c,$modified_records) = each %{$this->{'modified_record'}}) {
		while (my($n,$is_pending) = each %$modified_records) {
			if ($is_pending) {
				$this->index_sweeper($c,$n);
			} else {
				my %data = ();
				foreach my $type ('title','key','content','media') {
					if ($field::for{$type}) {
						my $id = $field::for{$type};
						if (ref $field::obj{$id} && $field::obj{$id}->db) {
							my $db = $field::obj{$id}->db;
							unless (ref tied %{$this->{'DB'}{$c}{$db}}) {
								tie(%{$this->{'DB'}{$c}{$db}}, $env::dbm_file, "$default::db/$c/$db", O_RDONLY, $env::dbm_mode);
							}
							$data{$id}{'str'} = $this->{'DB'}{$c}{$db}{$n} if ref tied %{$this->{'DB'}{$c}{$db}} && defined $this->{'DB'}{$c}{$db}{$n};
						}
					}
				}
				$this->feed_db_rss($c,$n,\%data);
			}
		}
	}
}
while (my($c) = each %{$this->{'DB'}}) {
	while (my($db_id) = each %{$this->{'DB'}{$c}}) {
		untie(%{$this->{'DB'}{$c}{$db_id}});
		delete $this->{'DB'}{$c}{$db_id};
	}
	delete $this->{'DB'}{$c};
}
delete $this->{'DB'};
if (ref $this->{'modified_record'}) {
	if ($field::obj{$field::for{'pending'}}->{'mTime'}) {
		my $time = time;
		while (my($c,$modified_records) = each %{$this->{'modified_record'}}) {
			my(%mtime);
			tie(%mtime, $env::dbm_file, "$default::db/$c/mtime", O_RDWR | O_CREAT, $env::dbm_mode);
			if (ref tied %mtime) {
				while (my($n,$is_pending) = each %$modified_records) {
					$mtime{$n} = $time;
				}
			}
			untie %mtime;
		}
		my %general;
		tie(%general, $env::dbm_file, $default::preference_dir . '/general', O_RDWR | O_CREAT, $env::dbm_mode);
		if (ref tied %general) {
			$general{'mtime'} = $time;
		}
		untie %general;
		$setting::general{'mtime'} = $time;
	}
	delete $this->{'modified_record'};
}
if (ref $this->{'expired_record'}) {
	use File::Path;
	while (my($c,$expired_records) = each %{$this->{'expired_record'}}) {
		foreach my $n (@$expired_records) {
			$this->delete_all_data("$default::db/$c",$n);
			rmtree "$default::file/$c/$n";
			$this->index_sweeper($c,$n);
		}
		delete $this->{'expired_record'}{$c};
	}
	delete $this->{'expired_record'};
}
}

######################################################################
# ġܥ
sub tm_tool_button ($$;$$$$$$$$) {
my($this,$view,$title,$url,$query,$li_class,$onclick,$target,$is_selected,$li_id) = @_;
if (!ref $this->{'icon_obj'}) {
	require CMONOS::CGI_Lib::Deco;
	$this->{'icon_obj'} = Deco->new(
		$env::image_dir . '/tablemaker',
		$env::image_lib . '/tablemaker'
	);
}
my $button = '<li' . ((defined $li_class && $li_class ne '') ? ' class="' . $li_class . '"' : '') . ((defined $li_id && $li_id ne '') ? ' id="' . $li_id . '"' : '') . '>';
if (defined $url && $url ne '') {
	$url .= $this->amp_escape($this->add_query('url',$query)) if ref $query;
	$button .= $this->{'icon_obj'}->button(
		$view,
		(($setting::page{$view}) ? $setting::page{$view} : '') . (($is_selected && $is_selected == 2) ? '-active' : ($is_selected) ? '-selected' : ''),
		$url,
		$title,
		$target,
		(($onclick) ? {'onclick' => $onclick} : '')
	);
} else {
	if ($target) {
		if ($onclick =~ /^return/) {
			$onclick =~ s/;$/ \&\& /;
			$onclick .= '(this.form.target=\'' . $target . '\');';
		} else {
			$onclick .= ';' if $onclick;
			$onclick .= 'this.form.target=\'' . $target . '\';';
		}
	}		
	$button .= $this->{'icon_obj'}->submit_button(
		$view,
		(($setting::page{$view}) ? $setting::page{$view} : '') . (($is_selected && $is_selected == 2) ? '-active' : ($is_selected) ? '-selected' : ''),
		$title,
		(($onclick) ? {'onclick' => $onclick} : ''),
		$query
	);
}
$button .= '</li>';
return $button;
}

sub amp_escape ($$) {
my($this,$url) = @_;
return '' if !defined $url;
$url =~ s/\&/\&amp;/g;
return $url;
}

sub gmap_view_enabled ($) {
my $this = shift;
return ((!$ENV{'HTTP_USER_AGENT'} || $ENV{'HTTP_USER_AGENT'} !~ /MCONV/) && defined $field::for{'coordinates'} && ref $field::obj{$field::for{'coordinates'}} && $field::obj{$field::for{'coordinates'}}->{'class'} && $field::obj{$field::for{'coordinates'}}->{'class'} eq 'webapi_gmap') ? 1 : 0;
}

######################################################################
# ġܥå
sub print_toolbox ($$) {
my($this,$suffix) = @_;

my @form = grep($_ ne 'm' && $_ ne 'k' && $_ ne 'fv',@setting::form);
@form = grep($_ ne 'c',@form) if defined $setting::page{'categoryselector'} && $setting::page{'categoryselector'};
@form = grep($_ ne 'q',@form) if defined $setting::page{'searchbox'} && $setting::page{'searchbox'};
@form = grep($_ ne 'w' && $_ ne 's',@form) if defined $setting::page{'sortmenu'} && $setting::page{'sortmenu'};

print $this->form_start(
	'key'		=>	$setting::security_key,
	'name'		=>	'tm-toolbox-' . $suffix,
	'id' 		=>	'tm-toolbox-' . $suffix,
	'class'		=>	'panel',
	'required'	=>	\@form
);
print '<ul class="tools">';

if (defined $setting::page{'categoryselector'} && $setting::page{'categoryselector'}) {
	my @categories = sort {$setting::category{$a}{'ORDER'} <=> $setting::category{$b}{'ORDER'} || $a <=> $b} grep(defined $_ && $_ !~ /\D/,keys %setting::category);
	if (@categories > 1) {
		push(@main::c,$main::c) if !@main::c && defined $main::c && $main::c;
		push(@main::c,((ref $setting::category{'DEFAULT'}) ? @{$setting::category{'DEFAULT'}} : $setting::category{'DEFAULT'})) if !@main::c && defined $setting::category{'DEFAULT'};
		my $size = 0;
		my $selector = $this->mk_category_selector(\%setting::category,\@categories,\@main::c,\$size);
		print '<li><select name="c"';
		if (defined $setting::category{'MULTIPLE'} && $setting::category{'MULTIPLE'}) {
			$size = 5 if $size > 5;
			$size = 1 if $size < 1;
			print ' size="' . $size. '" multiple="multiple"';
		} else {
			print ' onchange="this.name=\'m=' . $main::m . '&amp;k=' . $main::k . (($this->{'has_favorites'}) ? '&amp;fv=1' : '') . '&amp;c=\'+this.value;';
			if ($setting::page{'searchbox'}) {
				print 'var q=self.cmonos.element.form(this.form).fieldname(\'q\').shift();if(self.cmonos.element.item(q).hasClassName(\'placeholder\')){q.value=\'\';}';
			}
			print 'submit();"';
		}
		print '>';
		print $selector;
		print '</select></li>';
	}
}
if (defined $setting::page{'searchbox'} && $setting::page{'searchbox'}) {
	print '<li><input type="search" placeholder="' . (($this->{'is_searched_full'}) ? ($default::english) ? 'Further Search' : 'ʤ߸' : ($default::english) ? 'Search' : '') . '" results="5" autosave="' . (($default::id) ? $default::id : 'tablemaker') . '" name="q" size="16" value="' . $this->escape($main::q) . '" title="' . (($this->{'is_searched_full'}) ? ($default::english) ? 'Search' : 'ɤǤ˹ʤߤޤ' : ($default::english) ? 'Search' : '') . '" onkeypress="if((event.keyCode || event.charCode)==13){this.name=\'m=' . $main::m . '&amp;k=' . $main::k . (($this->{'has_favorites'}) ? '&amp;fv=1' : '') . '&amp;q=\'+this.value;submit();return false}" /></li>';
}
if (defined $setting::page{'sortmenu'} && $setting::page{'sortmenu'}) {
	print '<li><select name="s" title="' . (($default::english) ? 'Sort field' : '(¤ؤ)') . '">';
	$main::s = ($field::for{'sort'}) ? $field::for{'sort'} : ($field::for{'key'}) ? $field::for{'key'} : ($field::for{'title'}) ? $field::for{'title'} : '' if !defined $main::s || $main::s eq '';
	foreach (sort {$a <=> $b} keys %field::ORDER) {
		my $id = $field::ORDER{$_};
		next unless ref $field::obj{$id} && !$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret')) && $field::obj{$id}->sort_enabled && $field::obj{$id}->{'sortEnabled'};
		print '<option value="' . $id . '"' . (($main::s eq $id) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$id}->name,32,'I',1) . '</option>';
	}
	print '</select></li>';
	$main::w = $field::SORTORDER if $main::w eq '' && $field::SORTORDER;
	$main::w = 'ascend' if !defined $main::w ||  $main::w eq '';
	print '<li><select name="w" title="' . (($default::english) ? 'Sort' : '(¤ؤ)ˡ') . '">';
	print '<option value="ascend"' . ((defined $main::w && $main::w eq 'ascend') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Ascending' : '') . '</option>';
	print '<option value="descend"' . ((defined $main::w && $main::w eq 'descend') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Descending' : '߽') . '</option>';
	print '</select></li>';
}

# ɽ
print $this->tm_tool_button(
	'tableview',
	(($default::english) ? 'Table' : 'ơ֥ɽ'),
	'',
	{'m'=>'TableViewer','k'=>'viewer',(($this->{'has_favorites'}) ? ('fv' => 1) : ())},
	'',
	'',
	'',
	(($main::m && $main::m eq 'TableViewer') ? 1 : 0)
);
if ($this->gmap_view_enabled) {
	print $this->tm_tool_button(
		'gmapview',
		(($default::english) ? 'GoogleMaps' : 'Googleޥåɽ'),
		'',
		{'m'=>'GMapViewer','k'=>'gmap',(($this->{'has_favorites'}) ? ('fv' => 1) : ())},
		'',
		'',
		'',
		(($main::m && $main::m eq 'GMapViewer') ? 1 : 0)
	);
}	
print $this->tm_tool_button(
	'tileview',
	(($default::english) ? 'Tile' : 'ɽ'),
	'',
	{'m'=>'TileViewer','k'=>'tile',(($this->{'has_favorites'}) ? ('fv' => 1) : ())},
	'',
	'',
	'',
	(($main::m && $main::m eq 'TileViewer') ? 1 : 0)
);

# ɽ
if ($this->favorites_enabled) {
	print $this->tm_tool_button(
		'tmfavorites',
		(($this->{'has_favorites'}) ? (($default::english) ? 'Back.' : '̾ɽ᤹') : (($default::english) ? 'Show ' . $this->{'favorites_field_name'} . '.' : $this->{'favorites_field_name'} . ' ɽ')),
		'',
		{'m'=>$main::m,'k'=>$main::k,(($this->{'has_favorites'}) ? () : ('fv' => 1))},
		'group-start',
		'',
		'',
		(($this->{'has_favorites'}) ? 2 : 0),
		'show-favorites-' . $suffix
	);
}

# ᡼ۿեؤ³
if ($this->{'mcount'} && $this->is_secure('mail') && $this->email_field_enabled) {
	print $this->tm_tool_button(
		'tmmailer',
		(($default::english) ? 'Send mail by this list.' : '᡼ۿե򳫤'),
		'',
		{'m'=>'Mailer','k'=>'mail',(($this->{'has_favorites'}) ? ('fv' => 1) : ())},
		'group-start',
	);
}

# եå
if ($this->{'is_searched'}) {
	print $this->tm_tool_button(
		'tmreset',
		(($default::english) ? 'Refresh.' : 'ꥻå'),
		$cgi::path . $this->set_query('url',[grep($_ ne 'q' && $_ ne 'search' && $_ ne 'and',@setting::form)]),
		'',
		'group-start'
	);
}

# ڡ
print $this->tm_tool_button(
	'tmsearch',
	(($default::english) ? 'Search.' : ''),
	'',
	{'m'=>'Index','k'=>'index'},
	'group-start',
);

# ǡեؤ³
if ($this->email_field_enabled && $this->is_secure('revise')) {
	$setting::page{'reviseButton'} = ($default::english) ? 'Revise Data' : 'ǡ' if !defined $setting::page{'reviseButton'} || $setting::page{'reviseButton'} eq '';
	print $this->tm_tool_button(
		'tmlist',
		$setting::page{'reviseButton'},
		'',
		{'m'=>'Gate','k'=>'gate'},
		'group-start',
	);
}
if ($this->is_secure('input')) {
	$setting::page{'newDataButton'} = ($default::english) ? 'New Data' : 'ǡ' if !defined $setting::page{'newDataButton'} || $setting::page{'newDataButton'} eq '';
	print $this->tm_tool_button(
		'tminput',
		$setting::page{'newDataButton'},
		'',
		{'m'=>'Input','k'=>'input'},
		'group-start',
		"cmonos.window.open('detailViewer',640,480)",
		'detailViewer',
	);
}

if ($this->is_secure('tools')) {
	print $this->tm_tool_button(
		'tmtool',
		(($default::english) ? 'Control Panel.' : 'Ķ򳫤'),
		$cgi::path . '?m=Tools',
		'',
		'group-start'
	);
}

# ѥ
if (defined $setting::page{'pswdIcon'} && $setting::page{'pswdIcon'}) {
	print $this->tm_tool_button(
		'tmlogin',
		(($default::english) ? 'Log in.' : ''),
		$env::register_cgi . '?k=pswd&amp;m=Password',
		'',
		'group-start',
		"cmonos.window.open('LoginWindow',450,300)",
		'LoginWindow',
	);
}

print '</ul>';
print '</form>';
}

sub print_mini_toolbox ($$;$) {
my($this,$suffix,$another_gate) = @_;
return if (!$this->email_field_enabled || (!$another_gate && !$this->is_secure('revise'))) && !$this->is_secure('input') && !$this->is_secure('tools') && !$setting::page{'pswdIcon'};

print $this->form_start(
	'key'		=>	$setting::security_key,
	'name'		=>	'tm-toolbox-' . $suffix,
	'id' 		=>	'tm-toolbox-' . $suffix,
	'required'	=>	['mod']
);
print '<ul class="tools panel">';

# 
if ($this->email_field_enabled && ($another_gate || $this->is_secure('revise'))) {
	$setting::page{'reviseButton'} = ($default::english) ? 'Revise Data' : 'ǡ' if !defined $setting::page{'reviseButton'} || $setting::page{'reviseButton'} eq '';
	print $this->tm_tool_button(
		'tmlist',
		(($another_gate) ? ($default::english) ? 'Another e-mail address' : '̤Υɥ쥹Ǹ' : $setting::page{'reviseButton'}),
		'',
		{'m'=>'Gate','k'=>'gate',(($another_gate) ? ('id_disabled'=>'1') : ())},
	);
}

# ǡ
if ($this->is_secure('input')) {
	$setting::page{'newDataButton'} = ($default::english) ? 'New Data' : 'ǡ' if !defined $setting::page{'newDataButton'} || $setting::page{'newDataButton'} eq '';
	print $this->tm_tool_button(
		'tminput',
		$setting::page{'newDataButton'},
		'',
		{'m'=>'Input','k'=>'input'},
		'group-start',
		"cmonos.window.open('detailViewer',640,480)",
		'detailViewer',
	);
}

# 򳫤
if ($this->is_secure('tools')) {
	print $this->tm_tool_button(
		'tmtool',
		(($default::english) ? 'Control Panel.' : 'Ķ򳫤'),
		$cgi::path . '?m=Tools',
		'',
		'group-start'
	);
}

# ѥ
if (defined $setting::page{'pswdIcon'} && $setting::page{'pswdIcon'}) {
	print $this->tm_tool_button(
		'tmlogin',
		(($default::english) ? 'Log in.' : ''),
		$env::register_cgi . '?k=pswd&amp;m=Password',
		'',
		'group-start',
		"cmonos.window.open('LoginWindow',450,300)",
		'LoginWindow',
	);
}

print '</ul>';
print '</form>';
}

sub print_toolbox_top ($) {
my $this = shift;
$setting::page{$setting::key}{'toolboxTop'} = 1 if !defined $setting::page{$setting::key}{'toolboxTop'} && !defined $setting::page{$setting::key}{'toolboxBottom'};
$this->print_toolbox('top') if defined $setting::page{$setting::key}{'toolboxTop'} && $setting::page{$setting::key}{'toolboxTop'};
}

sub print_toolbox_bottom ($) {
my $this = shift;
$this->print_toolbox('bottom') if defined $setting::page{$setting::key}{'toolboxBottom'} && $setting::page{$setting::key}{'toolboxBottom'};
}

######################################################################
sub email_field_enabled ($) {
my $this = shift;
return (ref $field::for{'mail_address'} && @{$field::for{'mail_address'}}) ? 1 : 0;
}

######################################################################
sub get_rev_buttons ($$$$$$;$) {
my($this,$c,$n,$rid,$edit_button,$delete_button,$setting_key) = @_;
my $delete_disabled = (!$this->is_secure('delete',0,'revise') || ($default::type && $default::type eq 'order' && !$this->is_secure('tools'))) ? 1 : 0;
my $is_detail = ($setting_key && $setting_key eq 'detail') ? 1 : 0;
if (!ref $this->{'icon_obj'}) {
	require CMONOS::CGI_Lib::Deco;
	$this->{'icon_obj'} = Deco->new(
		$env::image_dir . '/tablemaker',
		$env::image_lib . '/tablemaker'
	);
}
my $button = $this->form_start(
	'key'		=>	'editor',
	'target'	=>	'detailViewer',
	'method'	=>	'post',
	'id'		=>	'record-editor' . (($is_detail) ? '' : '-n' . $rid),
	'required'	=>	['mod','s','w','f','u','uni','and','search','q','fv']
);
$button .= '<input type="hidden" name="m" value="Input" />';
$button .= '<input type="hidden" name="k" value="input" />';
$button .= '<input type="hidden" name="c" value="' . $c . '" />';
if (@main::ct) {
	foreach my $ct (@main::ct) {
		$button .= '<input type="hidden" name="ct" value="' . $ct . '" />';
	}
} elsif (@main::c) {
	foreach my $ct (@main::c) {
		$button .= '<input type="hidden" name="ct" value="' . $ct . '" />';
	}
}
$button .= '<input type="hidden" name="n" value="' . $n . '" />';
if (!$env::session_enabled && defined $main::pswd && !ref $main::pswd && $main::pswd ne '' && !$cookie::read{$this->login_cookie_name}) {
	$button .= '<input type="hidden" name="email" value="' . $this->escape($main::email) . '" />' if defined $main::email && $main::email;
	$button .= '<input type="hidden" name="pswd" value="' . $this->escape($main::pswd) . '" />' if defined $main::pswd && $main::pswd;
}
if (!$delete_disabled) {
	$button .= '<ul class="tools">';
	$button .= '<li>';
}
$button .= $this->{'icon_obj'}->submit_button(
	$edit_button,
	(($setting_key) ? $setting::page{$setting_key}{$edit_button} : $setting::page{$edit_button}),
	(($default::english) ? 'Edit.' : ''),
	{'onclick' => 'return window.opener || cmonos.window.open(\'detailViewer\',640,480)'}
);
if (!$delete_disabled) {
	$button .= '</li>';
	$button .= '<li>';
	$button .= $this->{'icon_obj'}->submit_button(
		$delete_button,
		(($setting_key) ? $setting::page{$setting_key}{$delete_button} : $setting::page{$delete_button}),
		(($default::english) ? 'Delete.' : ''),
		(($is_detail)
			?	{'onclick' => 'return confirm(\'ϼäޤ˺ޤ\') && (window.opener || cmonos.window.open(\'detailViewer\',640,480))'}
			:	{'onclick' => 'return confirm(\'ϼäޤ˺ޤ\') && cmonos.form.item(this.form).field(this).deleteRecord(\'' . $rid . '\')'}
		),
		{'delete'=>'1'}
	);
	$button .= '</li>';
	$button .= '</ul>';
}
$button .= '</form>';
return $button;
}

######################################################################
sub print_category_selector ($$$$;$$) {
my($this,$tableheader,$header,$footer,$multiple) = @_;

#ƥ꡼ɤ߹
$this->import_db($default::preference_dir . '/category',\%setting::category,1) if !%setting::category;

my @categories = sort {$setting::category{$a}{'ORDER'} <=> $setting::category{$b}{'ORDER'} || $a <=> $b} grep(defined $_ && $_ !~ /\D/,keys %setting::category);
if (@categories && @categories > 1) {
	push(@main::c,$main::c) if !@main::c && defined $main::c && $main::c;
	push(@main::c,((ref $setting::category{'DEFAULT'}) ? @{$setting::category{'DEFAULT'}} : $setting::category{'DEFAULT'})) if !@main::c && defined $setting::category{'DEFAULT'};
	my $size = 0;
	my $selector = $this->mk_category_selector(\%setting::category,\@categories,\@main::c,\$size);
	print $tableheader if $tableheader;
	print $header if $header;
	print '<select name="c" id="c"' . (($multiple || $setting::category{'MULTIPLE'}) ? ' size="' . (($size) ? $size : '1') . '" multiple="multiple"' : '') . '>';
	print $selector;
	print '</select>';
	print $footer if $footer;
} elsif (@categories) {
	print '<input type="hidden" name="c" value="' . $categories[0] . '" />';
	print $tableheader if $tableheader;
} else {
	print '<input type="hidden" name="c" value="1" />';
	print $tableheader if $tableheader;
}
}

sub mk_category_selector ($$$;$$$$$) {
my($this,$category,$list,$selected,$size,$key,$indent,$done) = @_;
return '' if !ref $list;
$key = '' if !defined $key;
$indent = '' if !defined $indent;
my($sub_key,@sub_list,$selector,$c);
$done = {} if !ref $done;
$sub_key = $selector = '';
foreach $c (@$list) {
	next if !defined $c;
	$sub_key = $1 if $sub_key eq '' && $category->{$c}->{'name'} && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
	if ($sub_key ne '' && $sub_key ne $key && $category->{$c}->{'name'} =~ /^$sub_key/ && ($sub_key =~ m!/$! || $category->{$c}->{'name'} eq $sub_key)) {
		push(@sub_list,$c);
	} else {
		if ($sub_key ne '' && $sub_key ne $key) {
			my $my_indent = $indent;
			my $indent2 = '';
			if ($key ne '') {
				$my_indent .= '';
				$indent2 = '';
			}
			$selector .= $this->_mk_category_selector($category,\@sub_list,$selected,$size,$sub_key,$my_indent,$done);
			$selector .= $this->mk_category_selector($category,\@sub_list,$selected,$size,$sub_key,$indent . $indent2,$done) if @sub_list && $key ne $sub_key;
		}
		$sub_key = $1 if $category->{$c}->{'name'} && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
		undef @sub_list;
		push(@sub_list,$c);
	}
}
if ($sub_key ne '' && $sub_key ne $key) {
	my $my_indent = $indent;
	my $indent2 = '';
	if ($key ne '') {
		$my_indent .= '';
		$indent2 = '';
	}
	$selector .= $this->_mk_category_selector($category,\@sub_list,$selected,$size,$sub_key,$my_indent,$done);
	$selector .= $this->mk_category_selector($category,\@sub_list,$selected,$size,$sub_key,$indent . $indent2,$done) if @sub_list && $key ne $sub_key;
}
return $selector;
}

sub _mk_category_selector ($$$$$$$$) {
my($this,$category,$sub_list,$selected,$size,$sub_key,$my_indent,$done) = @_;
my $record_count = 0;
my $record_total = 0;
foreach my $c (@$sub_list) {
	if (ref $category->{$c}) {
		$record_count += $category->{$c}->{'count'} if $category->{$c}->{'count'};
		$record_total += $category->{$c}->{'total'} if $this->is_secure('pending') && $category->{$c}->{'total'};
	}
}
my $value = join(',',@$sub_list);
my $selector .= '<option value="' . $value . '"' . ((!$done->{$value}++ && grep($_ eq $value,@$selected)) ? ' selected="selected"' : '') . '>';
$selector .= $my_indent;
$selector .= $1 if $sub_key =~ m!([^/]+)/?$!;
$selector .= ' (' . $record_count . (($this->is_secure('pending')) ? '/' . $record_total : '') . ')</option>';
$$size++ if ref $size;
return $selector;
}

sub replace_category_list ($) {
my $this = shift;
$this->import_db($default::preference_dir . '/category',\%setting::category,1) if !%setting::category;
my @categories = sort {$setting::category{$a}{'ORDER'} <=> $setting::category{$b}{'ORDER'} || $a <=> $b} grep(defined $_ && $_ !~ /\D/,keys %setting::category);
if (@categories > 1) {
	push(@main::c,$main::c) if !@main::c && defined $main::c && $main::c;
	push(@main::c,((ref $setting::category{'DEFAULT'}) ? @{$setting::category{'DEFAULT'}} : $setting::category{'DEFAULT'})) if !@main::c && defined $setting::category{'DEFAULT'};
	my @required = grep($_ ne 'm' && $_ ne 'k' && $_ ne 'c' && $_ ne 'n',@setting::form);
	my $query = $this->set_query('url',\@required,1);
	my $categorylist = $this->mk_category_list($query,\%setting::category,\@categories,\@main::c,'',{},'tm-categories');
	$setting::page{$setting::key}{'header'} =~ s/<\!--categorylist(?!\w)([^>]*)-->(.*?)<\!--\/categorylist(?!\w)[^>]*-->/$this->item_tag_replace('categorylist',$1,$2,$categorylist,0,1)/gies if $setting::page{$setting::key}{'header'};
	$setting::page{$setting::key}{'headText'} =~ s/<\!--categorylist(?!\w)([^>]*)-->(.*?)<\!--\/categorylist(?!\w)[^>]*-->/$this->item_tag_replace('categorylist',$1,$2,$categorylist,0,1)/gies if $setting::page{$setting::key}{'headText'};
	$setting::page{$setting::key}{'footer'} =~ s/<\!--categorylist(?!\w)([^>]*)-->(.*?)<\!--\/categorylist(?!\w)[^>]*-->/$this->item_tag_replace('categorylist',$1,$2,$categorylist,0,1)/gies if $setting::page{$setting::key}{'footer'};
	$setting::page{$setting::key}{'template'} =~ s/<\!--categorylist(?!\w)([^>]*)-->(.*?)<\!--\/categorylist(?!\w)[^>]*-->/$this->item_tag_replace('categorylist',$1,$2,$categorylist,0,1)/gies if $setting::page{$setting::key}{'template'};
} else {
	$setting::page{$setting::key}{'header'} =~ s/<\!--categorylist(?!\w)[^>]*-->.*?<\!--\/categorylist(?!\w)[^>]*-->//gis if $setting::page{$setting::key}{'header'};
	$setting::page{$setting::key}{'headText'} =~ s/<\!--categorylist(?!\w)[^>]*-->.*?<\!--\/categorylist(?!\w)[^>]*-->//gis if $setting::page{$setting::key}{'headText'};
	$setting::page{$setting::key}{'footer'} =~ s/<\!--categorylist(?!\w)[^>]*-->.*?<\!--\/categorylist(?!\w)[^>]*-->//gis if $setting::page{$setting::key}{'footer'};
	$setting::page{$setting::key}{'template'} =~ s/<\!--categorylist(?!\w)[^>]*-->.*?<\!--\/categorylist(?!\w)[^>]*-->//gis if $setting::page{$setting::key}{'template'};
}
}

sub mk_category_list ($$$$;$$$$$) {
my($this,$query,$category,$category_list,$selected,$key,$done,$class,$m) = @_;
$key = '' if !defined $key;
my($sub_key,@sub_list,$list,$c);
$done = {} if !ref $done;
$sub_key = $list = '';
foreach $c (@$category_list) {
	next if !defined $c;
	$sub_key = $1 if $sub_key eq '' && $category->{$c}->{'name'} && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
	if ($sub_key ne '' && $sub_key ne $key && $category->{$c}->{'name'} =~ /^$sub_key/ && ($sub_key =~ m!/$! || $category->{$c}->{'name'} eq $sub_key)) {
		push(@sub_list,$c);
	} else {
		if ($sub_key ne '' && $sub_key ne $key) {
			$list .= '<li>' . $this->_mk_category_list($query,$category,\@sub_list,$selected,$sub_key,$done,$m);
			$list .= $this->mk_category_list($query,$category,\@sub_list,$selected,$sub_key,$done,'',$m) if @sub_list && $key ne $sub_key;
			$list .= '</li>';
		}
		$sub_key = $1 if $category->{$c}->{'name'} && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
		undef @sub_list;
		push(@sub_list,$c);
	}
}
if ($sub_key ne '' && $sub_key ne $key) {
	$list .= '<li>' . $this->_mk_category_list($query,$category,\@sub_list,$selected,$sub_key,$done,$m);
	$list .= $this->mk_category_list($query,$category,\@sub_list,$selected,$sub_key,$done,'',$m) if @sub_list && $key ne $sub_key;
	$list .= '</li>';
}
return ($list) ? '<ul' . (($class) ? ' class="' . $class . '"' : '') . '>' . $list . '</ul>' : '';
}

sub _mk_category_list ($$$$$$$;$) {
my($this,$query,$category,$sub_list,$selected,$sub_key,$done,$m) = @_;
my $record_count = 0;
foreach my $c (@$sub_list) {
	$record_count += $category->{$c}->{'count'} if ref $category->{$c} && $category->{$c}->{'count'};
}
my $value = join(',',@$sub_list);
my $is_here = (!$done->{$value}++ && ref $selected && @$selected && grep($_ eq $value,@$selected)) ? 1 : 0;
return (($is_here) ? '<strong>' : '') . '<a href="' . $cgi::path . '?m=' . (($m) ? $m : ($main::m && ($main::m eq 'TableViewer' || $main::m eq 'TileViewer' || $main::m eq 'GMapViewer')) ? $main::m : ($main::mod && ($main::mod eq 'TableViewer' || $main::mod eq 'TileViewer' || $main::mod eq 'GMapViewer')) ? $main::mod : ($setting::page{'defaultView'}) ? $setting::page{'defaultView'} : 'TileViewer') . '&amp;c=' . $value . $this->escape($query) . '">'
	. (($sub_key =~ m!([^/]+)/?$!) ? $1 : '')
	. '</a>' . (($is_here) ? '</strong>' : '') . ' <span>(' . $record_count . ')</span>';
}

sub write_category_list ($) {
my $this = shift;
return 1 if $default::type && $default::type eq 'order';
$this->import_db($default::preference_dir . '/page',\%setting::page,1,$setting::key) if !%setting::page || !$setting::page{'defaultView'};
$this->import_db($default::preference_dir . '/category',\%setting::category,1) if !%setting::category;
my @categories = sort {$setting::category{$a}{'ORDER'} <=> $setting::category{$b}{'ORDER'} || $a <=> $b} grep(defined $_ && $_ !~ /\D/,keys %setting::category);
$this->write_file(
	$default::file . '/category_list.ssi',
	$this->mk_category_list('',\%setting::category,\@categories,[],'',{},'tm-categories',($setting::page{'defaultView'} || 'TileViewer')),
	1
);
$this->mk_external_javascript($default::file . '/category_list.ssi');
return 1;
}

sub gc_download_directory ($) {
my $this = shift;
my $gc_dat = $default::file . '/download/gc.dat';
return 1 if -f $gc_dat && (-M $gc_dat) < 3;
local(*DIR);
if (opendir(DIR,$default::file . '/download')) {
	my @expired = ();
	while (my $key = readdir(DIR)) {
		if ($key !~ /^\./ && -d $default::file . '/download/' . $key) {
			my $dat = $default::file . '/download/' . $key . '/checkout.dat';
			if (
					(!-s $dat && (-M $dat) > (($setting::general{'dcPendingTimeout'}) ? $setting::general{'dcPendingTimeout'} : 30))
				||	(-s $dat && (-M $dat) > (($setting::general{'dcLifetime'}) ? $setting::general{'dcLifetime'} : 30))
			) {
				push(@expired,$default::file . '/download/' . $key);
			}
		}
	}
	closedir(DIR);
	if (@expired) {
		use File::Path;
		foreach my $dir (@expired) {
			rmtree $dir;
		}
	}
	$this->write_file($default::file . '/download/index.html',"<html><head><title>404 Not Found</title></head><body><h1>Not Found</h1> The requested object does not exist on this server.</body></html>\x0A",1);
	$this->write_file($gc_dat,time,1);
	return 1;
}
return 0;
}

######################################################################
#RSS
sub feed_db_rss ($$$$) {
my($this,$c,$n,$data) = @_;
local $main::c = $c;
if ((!$default::type || $default::type ne 'order') && defined $c && $c ne '' && defined $n && $n ne '' && ($setting::general{'RSSEnabled'} || $setting::general{'masterRSSEnabled'} || $setting::general{'siteRSSEnabled'})) {
	$this->import_db($default::preference_dir . '/category',\%setting::category,1) if !%setting::category;
	my $my_url = $this->my_url;
	my $guid = $my_url . '?m=DetailViewer&c=' . $c . '&n=' . $n;
	if ($setting::security{'browse'}{'passwordCheck'} eq 'nocheck' && $setting::security{'detail'}{'passwordCheck'} eq 'nocheck') {
		$this->feed_rss(
			{
				'title'				=>	(($field::for{'title'} && ref $field::obj{$field::for{'title'}} && $field::obj{$field::for{'title'}}->{'Open'} && !$field::obj{$field::for{'title'}}->{'Hidden'} && $data->{$field::for{'title'}}{'str'}) ? $field::obj{$field::for{'title'}}->format_for_text($data->{$field::for{'title'}}{'str'},$default::file . '/' . $c . '/' . $n,$c,$n) : ($field::for{'key'} && ref $field::obj{$field::for{'key'}} && $field::obj{$field::for{'key'}}->{'Open'} && !$field::obj{$field::for{'key'}}->{'Hidden'} && $data->{$field::for{'key'}}{'str'}) ? $field::obj{$field::for{'key'}}->format_for_text($data->{$field::for{'key'}}{'str'},$default::file . '/' . $c . '/' . $n,$c,$n) : '쥳ɤϤޤ'),
				'link'				=>	$guid,
				'content:encoded'	=>	(($field::for{'content'} && ref $field::obj{$field::for{'content'}} && $field::obj{$field::for{'content'}}->{'Open'} && !$field::obj{$field::for{'content'}}->{'Hidden'} && $data->{$field::for{'content'}}{'str'}) ? $field::obj{$field::for{'content'}}->format_for_detail($data->{$field::for{'content'}}{'str'},$default::file . '/' . $c . '/' . $n,$c,$n) : '쥳ɤϤޤ'),
				'category'			=>	((ref $setting::category{$c} && defined $setting::category{$c}{'name'}) ? $setting::category{$c}{'name'} : ''),
				'enclosure'			=>	(($field::for{'media'} && ref $field::obj{$field::for{'media'}} && $field::obj{$field::for{'media'}}->{'Open'} && !$field::obj{$field::for{'media'}}->{'Hidden'} && $data->{$field::for{'media'}}{'str'}) ? {$field::obj{$field::for{'media'}}->get_enclosure_attributes($data->{$field::for{'media'}}{'str'},$default::file . '/' . $c . '/' . $n,$c,$n)} : ''),
				'guid'				=>	$guid,
				(($env::checkout && $field::for{'showcase'} && ref $field::obj{$field::for{'showcase'}} && $field::obj{$field::for{'showcase'}}->{'Open'} && !$field::obj{$field::for{'media'}}->{'Hidden'}) ? 
					$field::obj{$field::for{'showcase'}}->get_gdata($guid,$data->{$field::for{'showcase'}})
				: ())
			},
			$default::file . '/' . $c,
			$my_url,
			$default::file,
			$my_url
		);
	} else {
		$this->feed_rss(
			{
				'title'				=>	'쥳ɤϤޤ',
				'link'				=>	$guid,
				'content:encoded'	=>	'쥳ɤϤޤ',
				'guid'				=>	$guid
			},
			$default::file . '/' . $c,
			$my_url,
			$default::file,
			$my_url
		);
	}
}
}

sub index_sweeper ($$$) {
my($this,$c,$n) = @_;
require CMONOS::CGI_Lib::IndexSweeper;
IndexSweeper->new(
	'index_files'	=>	[
							$env::externalfiles . '/recentcomments.ssi',
							$env::externalfiles . '/recenttrackbacks.ssi',
							$default::file . '/recentcomments.ssi',
							$default::file . '/recenttrackbacks.ssi',
							$default::file . '/' . $c . '/recentcomments.ssi',
							$default::file . '/' . $c . '/recenttrackbacks.ssi',
						],
	'rss_files'		=>	[
							'../../index.xml',
							'../../comment.xml',
							'../../trackback.xml',
							'../../podcast.xml',
							$default::file . '/index.xml',
							$default::file . '/comment.xml',
							$default::file . '/trackback.xml',
							$default::file . '/podcast.xml',
							$default::file . '/' . $c . '/index.xml',
							$default::file . '/' . $c . '/comment.xml',
							$default::file . '/' . $c . '/trackback.xml',
							$default::file . '/' . $c . '/podcast.xml',
						]
)->sweep(
	[$this->my_url . '?m=DetailViewer&c=' . $c . '&n=' . $n],
	{
		$default::id => [$c . '-' . $n]
	}
);
}

1;
