package SearchDBEditor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ɥǡ١⥸塼
# MkZipCodeDB.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ¹
sub run ($) {
my $this = shift;
my $mtime;

use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
$this->jump_menu('tools');

#ǡ١
if ($main::words || $main::num) {
	my(%words,@delete,@words);
	$main::mode = "and" if !$main::mode;
	if (defined $main::words && $main::words ne '') {
		@words = grep($_ ne '',split(/\s+|\xa1\xa1/,$main::words));
		map($_ = quotemeta($_),@words);
	}
	tie(%words, $env::dbm_file, $default::db . '/words', O_RDWR, $env::dbm_mode);
	if (ref tied %words) {
		while (my($k,$v) = each %words) {
			next if $k eq 'MAX VALUE';
			my $is_target = 0;
			if ($main::words) {
				if ($main::mode eq 'eq') {
					$is_target = 1 if grep($k eq $_,@words);
				} elsif ($main::mode eq 'or') {
					$is_target = 1 if grep($k =~ /$_/,@words);
				} else {
					$is_target = 1 if !grep($k !~ /$_/,@words);
				}
			} else {
				$is_target = 1;
			}
			if ($is_target && $main::num) {
				my($t,$n) = split(/\t/,$v);
				push(@delete,$k) if $n < $main::num;
			}
		}
		if (@delete) {
			my $count = @delete;
			foreach my $w (@delete) {
				delete $words{$w};
				push(@{$this->{'dialog'}},'' . $this->escape($w) . 'פޤ') if $count < 10;
			}
			push(@{$this->{'dialog'}},$count . ' θɤޤ');			
		} else {
			push(@{$this->{'dialog'}},'˳븡ɤϤߤĤޤǤ');			
		}
	} else {
		push(@{$this->{'dialog'}},'ɥǡ١³ǤޤǤ');			
	}
	untie %words;
} elsif ($main::a) {
	push(@{$this->{'dialog'}},'ϤƤ');			
}

#ڡإå
$this->print_page_header('tools');

print '<h1 title="ɥǡ١ޤ">ɥǡ١</h1>';

#ե೫
print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method' =>	'post',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="1" />';
print '<fieldset class="delete">';
print '<label>줿<input type="text" size="3" name="num" title="ɬܹܤǤ" />ʲ</label> ';
print '<label>ɤ<input type="text" size="20" name="words" title="ξ˰פƤθɤޤ" /></label>';
print $this->mk_select_menu(
	'mode','','','',
	'eq'	=>		'Ǥ',
	'and'	=>		'٤Ƥ˰פ',
	'or'	=>		'줫˰פ',
);
print 'ɤ<input type="submit" value="" onclick="return confirm(\'ϼäޤ˹ޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();" />';
print '</fieldset>';

print '</form>';

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('xxde','SearchDBEditor');

	#˥塼Ͽ
	$setting::jump_menu{'xxde'} = 'ɥǡ١';

}



1;
